/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/cancellation","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/hash","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(Y){for(var e=[],D=0,n=Y.length;D<n;D++)e[D]=ne[Y[D]];return e};define(ne[99],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function D(n,L){if(!n)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D}),define(ne[48],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(T){return T?T.replace(/\$\((.*?)\)/g,(R,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(R,b,E){this.id=R,this.definition=b,this.description=E,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function L(T,R){const b=["codicon","codicon-"+T];return R&&b.push("codicon-modifier-"+R),b}e.getClassNamesArray=L;var A;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function b(C){if(C instanceof n)return["codicon","codicon-"+C.id];const f=R.exec(C.id);if(!f)return b(n.error);let[,y,h]=f;const v=["codicon","codicon-"+y];return h&&v.push("codicon-modifier-"+h.substr(1)),v}T.asClassNameArray=b;function E(C){return b(C).join(" ")}T.asClassName=E;function I(C){return"."+b(C).join(".")}T.asCSSSelector=I})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ne[67],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const D=Object.prototype.hasOwnProperty;function n(I){const C=[];for(let f in I)D.call(I,f)&&C.push(I[f]);return C}e.values=n;function L(I,C){for(let f in I)if(D.call(I,f)&&C({key:f,value:I[f]},function(){delete I[f]})===!1)return}e.forEach=L;function A(I,C){const f=Object.create(null);for(const y of I){const h=C(y);let v=f[h];v||(v=f[h]=[]),v.push(y)}return f}e.groupBy=A;function T(I){const C=Object.create(null);return I&&I.forEach((f,y)=>{C[y]=f}),C}e.fromMap=T;function R(I,C){const f=[],y=[];for(let h of I)C.has(h)||f.push(h);for(let h of C)I.has(h)||y.push(h);return{removed:f,added:y}}e.diffSets=R;function b(I,C){const f=[],y=[];for(let[h,v]of I)C.has(h)||f.push(v);for(let[h,v]of C)I.has(h)||y.push(v);return{removed:f,added:y}}e.diffMaps=b;class E{constructor(){this.map=new Map}add(C,f){let y=this.map.get(C);y||(y=new Set,this.map.set(C,y)),y.add(f)}delete(C,f){const y=this.map.get(C);!y||(y.delete(f),y.size===0&&this.map.delete(C))}forEach(C,f){const y=this.map.get(C);!y||y.forEach(f)}}e.SetMap=E}),define(ne[54],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(T){return(R,b,E)=>{let I=null,C=null;if(typeof E.value=="function"?(I="value",C=E.value):typeof E.get=="function"&&(I="get",C=E.get),!C)throw new Error("not supported");E[I]=T(C,b)}}e.createDecorator=D;function n(T,R,b){let E=null,I=null;if(typeof b.value=="function"?(E="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(E="get",I=b.get),!I)throw new Error("not supported");const C=`$memoize$${R}`;b[E]=function(...f){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[C]}}e.memoize=n;function L(T,R,b){return D((E,I)=>{const C=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...y){this[f]||(this[f]=b?b():void 0),clearTimeout(this[C]),R&&(this[f]=R(this[f],...y),y=[this[f]]),this[C]=setTimeout(()=>{E.apply(this,y),this[f]=b?b():void 0},T)}})}e.debounce=L;function A(T,R,b){return D((E,I)=>{const C=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,y=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...v){if(this[f]||(this[f]=b?b():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...v)),this[h])return;const d=this[y]+T;d<=Date.now()?(this[y]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0):(this[h]=!0,this[C]=setTimeout(()=>{this[h]=!1,this[y]=Date.now(),E.apply(this,[this[f]]),this[f]=b?b():void 0},d-Date.now()))}})}e.throttle=A}),define(ne[9],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=D,e.errorHandler=new D;function n(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=n;function L(l){b(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=L;function A(l){b(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=A;function T(l){if(l instanceof Error){let{name:r,message:a}=l;const i=l.stacktrace||l.stack;return{$isError:!0,name:r,message:a,stack:i}}return l}e.transformErrorForSerialization=T;const R="Canceled";function b(l){return l instanceof E?!0:l instanceof Error&&l.name===R&&l.message===R}e.isCancellationError=b;class E extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=E;function I(){const l=new Error(R);return l.name=l.message,l}e.canceled=I;function C(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=C;function f(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=f;function y(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function h(l){const r=new Error(`${l} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function v(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=v;class d extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=d;class g extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=g;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function m(l){const r=l;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=m;function S(l,r=Object.create(null)){const a=new Error(l);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=S}),define(ne[16],ie([0,1,9]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function n(W,N=0){return W[W.length-(1+N)]}e.tail=n;function L(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=L;function A(W,N,V=(z,B)=>z===B){if(W===N)return!0;if(!W||!N||W.length!==N.length)return!1;for(let z=0,B=W.length;z<B;z++)if(!V(W[z],N[z]))return!1;return!0}e.equals=A;function T(W,N,V){let z=0,B=W.length-1;for(;z<=B;){const te=(z+B)/2|0,se=V(W[te],N);if(se<0)z=te+1;else if(se>0)B=te-1;else return te}return-(z+1)}e.binarySearch=T;function R(W,N){let V=0,z=W.length;if(z===0)return 0;for(;V<z;){const B=Math.floor((V+z)/2);N(W[B])?z=B:V=B+1}return V}e.findFirstInSorted=R;function b(W,N,V){if(W=W|0,W>=N.length)throw new TypeError("invalid index");let z=N[Math.floor(N.length*Math.random())],B=[],te=[],se=[];for(let ce of N){const he=V(ce,z);he<0?B.push(ce):he>0?te.push(ce):se.push(ce)}return W<B.length?b(W,B,V):W<B.length+se.length?se[0]:b(W-(B.length+se.length),te,V)}e.quickSelect=b;function E(W,N){const V=[];let z;for(const B of W.slice(0).sort(N))!z||N(z[0],B)!==0?(z=[B],V.push(z)):z.push(B);return V}e.groupBy=E;function I(W,N,V){const z=[];function B(ce,he,ve){if(he===0&&ve.length===0)return;const pe=z[z.length-1];pe&&pe.start+pe.deleteCount===ce?(pe.deleteCount+=he,pe.toInsert.push(...ve)):z.push({start:ce,deleteCount:he,toInsert:ve})}let te=0,se=0;for(;;){if(te===W.length){B(te,0,N.slice(se));break}if(se===N.length){B(te,W.length-te,[]);break}const ce=W[te],he=N[se],ve=V(ce,he);ve===0?(te+=1,se+=1):ve<0?(B(te,1,[]),te+=1):ve>0&&(B(te,0,[he]),se+=1)}return z}e.sortedDiff=I;function C(W,N,V){const z=I(W,N,V),B=[],te=[];for(const se of z)B.push(...W.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:B,added:te}}e.delta=C;function f(W,N,V){if(V===0)return[];const z=W.slice(0,V).sort(N);return h(W,N,z,V,W.length),z}e.top=f;function y(W,N,V,z,B){return V===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=W.length,he=W.slice(0,V).sort(N);for(let ve=V,pe=Math.min(V+z,ce);ve<ce;ve=pe,pe=Math.min(pe+z,ce)){if(ve>V&&await new Promise(Ee=>setTimeout(Ee)),B&&B.isCancellationRequested)throw(0,D.canceled)();h(W,N,he,ve,pe)}return he})().then(te,se)})}e.topAsync=y;function h(W,N,V,z,B){for(const te=V.length;z<B;z++){const se=W[z];if(N(se,V[te-1])<0){V.pop();const ce=R(V,he=>N(se,he)<0);V.splice(ce,0,se)}}}function v(W){return W.filter(N=>!!N)}e.coalesce=v;function d(W){let N=0;for(let V=0;V<W.length;V++)W[V]&&(W[N]=W[V],N+=1);W.length=N}e.coalesceInPlace=d;function g(W,N,V){W.splice(V,0,W.splice(N,1)[0])}e.move=g;function w(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=w;function m(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=m;function S(W,N=V=>V){const V=new Set;return W.filter(z=>{const B=N(z);return V.has(B)?!1:(V.add(B),!0)})}e.distinct=S;function l(W){const N=new Set;return V=>{const z=W(V);return N.has(z)?!1:(N.add(z),!0)}}e.uniqueFilter=l;function r(W,N){const V=a(W,N);if(V!==-1)return W[V]}e.findLast=r;function a(W,N){for(let V=W.length-1;V>=0;V--){const z=W[V];if(N(z))return V}return-1}e.lastIndex=a;function i(W,N){return W.length>0?W[0]:N}e.firstOrDefault=i;function t(W,N,V=(z,B)=>z===B){let z=0;for(let B=0,te=Math.min(W.length,N.length);B<te&&V(W[B],N[B]);B++)z++;return z}e.commonPrefixLength=t;function o(W){return[].concat(...W)}e.flatten=o;function s(W,N){let V=typeof N=="number"?W:0;typeof N=="number"?V=W:(V=0,N=W);const z=[];if(V<=N)for(let B=V;B<N;B++)z.push(B);else for(let B=V;B>N;B--)z.push(B);return z}e.range=s;function c(W,N,V){return W.reduce((z,B)=>(z[N(B)]=V?V(B):B,z),Object.create(null))}e.index=c;function u(W,N){return W.push(N),()=>p(W,N)}e.insert=u;function p(W,N){const V=W.indexOf(N);if(V>-1)return W.splice(V,1),N}e.remove=p;function P(W,N,V){const z=W.slice(0,N),B=W.slice(N);return z.concat(V,B)}e.arrayInsert=P;function _(W,N){let V;if(typeof N=="number"){let z=N;V=()=>{const B=Math.sin(z++)*179426549;return B-Math.floor(B)}}else V=Math.random;for(let z=W.length-1;z>0;z-=1){const B=Math.floor(V()*(z+1)),te=W[z];W[z]=W[B],W[B]=te}}e.shuffle=_;function O(W,N){const V=W.indexOf(N);V>-1&&(W.splice(V,1),W.unshift(N))}e.pushToStart=O;function F(W,N){const V=W.indexOf(N);V>-1&&(W.splice(V,1),W.push(N))}e.pushToEnd=F;function $(W,N){return Array.isArray(W)?W.map(N):N(W)}e.mapArrayOrNot=$;function k(W){return Array.isArray(W)?W:[W]}e.asArray=k;function M(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=M;function j(W,N){for(const V of W){const z=N(V);if(z!==void 0)return z}}e.mapFind=j;function U(W,N,V){const z=K(W,N),B=W.length,te=V.length;W.length=B+te;for(let se=B-1;se>=z;se--)W[se+te]=W[se];for(let se=0;se<te;se++)W[se+z]=V[se]}e.insertInto=U;function G(W,N,V,z){const B=K(W,N),te=W.splice(B,V);return U(W,B,z),te}e.splice=G;function K(W,N){return N<0?Math.max(N+W.length,0):Math.min(N,W.length)}function x(W,N){return(V,z)=>N(W(V),W(z))}e.compareBy=x;const q=(W,N)=>W-N;e.numberComparator=q;function X(W,N){if(W.length===0)return;let V=W[0];for(let z=1;z<W.length;z++){const B=W[z];N(B,V)>0&&(V=B)}return V}e.findMaxBy=X;function H(W,N){if(W.length===0)return;let V=W[0];for(let z=1;z<W.length;z++){const B=W[z];N(B,V)>=0&&(V=B)}return V}e.findLastMaxBy=H;function Z(W,N){return X(W,(V,z)=>-N(V,z))}e.findMinBy=Z;class ee{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let V=this.firstIdx;for(;V<this.items.length&&N(this.items[V]);)V++;const z=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,z}takeFromEndWhile(N){let V=this.lastIdx;for(;V>=0&&N(this.items[V]);)V--;const z=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,z}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const V=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,V}}e.ArrayQueue=ee}),define(ne[68],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const L=this;let A=!1,T;return function(){return A||(A=!0,T=n.apply(L,arguments)),T}}e.once=D}),define(ne[55],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function L(l){return l&&typeof l=="object"&&typeof l[Symbol.iterator]=="function"}n.is=L;const A=Object.freeze([]);function T(){return A}n.empty=T;function*R(l){yield l}n.single=R;function b(l){return l||A}n.from=b;function E(l){return!l||l[Symbol.iterator]().next().done===!0}n.isEmpty=E;function I(l){return l[Symbol.iterator]().next().value}n.first=I;function C(l,r){for(const a of l)if(r(a))return!0;return!1}n.some=C;function f(l,r){for(const a of l)if(r(a))return a}n.find=f;function*y(l,r){for(const a of l)r(a)&&(yield a)}n.filter=y;function*h(l,r){let a=0;for(const i of l)yield r(i,a++)}n.map=h;function*v(...l){for(const r of l)for(const a of r)yield a}n.concat=v;function*d(l){for(const r of l)for(const a of r)yield a}n.concatNested=d;function g(l,r,a){let i=a;for(const t of l)i=r(i,t);return i}n.reduce=g;function*w(l,r,a=l.length){for(r<0&&(r+=l.length),a<0?a+=l.length:a>l.length&&(a=l.length);r<a;r++)yield l[r]}n.slice=w;function m(l,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,l];const i=l[Symbol.iterator]();for(let t=0;t<r;t++){const o=i.next();if(o.done)return[a,n.empty()];a.push(o.value)}return[a,{[Symbol.iterator](){return i}}]}n.consume=m;function S(l,r,a=(i,t)=>i===t){const i=l[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const o=i.next(),s=t.next();if(o.done!==s.done)return!1;if(o.done)return!0;if(!a(o.value,s.value))return!1}}n.equals=S})(D=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(r){r.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function T(r,a=!1){let i=0,t=r.length,o="",s=0,c=16,u=0;function p(M){let j=0,U=0;for(;j<M;){const G=r.charCodeAt(i);if(G>=48&&G<=57)U=U*16+G-48;else if(G>=65&&G<=70)U=U*16+G-65+10;else if(G>=97&&G<=102)U=U*16+G-97+10;else break;i++,j++}return j<M&&(U=-1),U}function P(M){i=M,o="",s=0,c=16,u=0}function _(){const M=i;if(r.charCodeAt(i)===48)i++;else for(i++;i<r.length&&E(r.charCodeAt(i));)i++;if(i<r.length&&r.charCodeAt(i)===46)if(i++,i<r.length&&E(r.charCodeAt(i)))for(i++;i<r.length&&E(r.charCodeAt(i));)i++;else return u=3,r.substring(M,i);let j=i;if(i<r.length&&(r.charCodeAt(i)===69||r.charCodeAt(i)===101))if(i++,(i<r.length&&r.charCodeAt(i)===43||r.charCodeAt(i)===45)&&i++,i<r.length&&E(r.charCodeAt(i))){for(i++;i<r.length&&E(r.charCodeAt(i));)i++;j=i}else u=3;return r.substring(M,j)}function O(){let M="",j=i;for(;;){if(i>=t){M+=r.substring(j,i),u=2;break}const U=r.charCodeAt(i);if(U===34){M+=r.substring(j,i),i++;break}if(U===92){if(M+=r.substring(j,i),i++,i>=t){u=2;break}switch(r.charCodeAt(i++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const K=p(4);K>=0?M+=String.fromCharCode(K):u=4;break}default:u=5}j=i;continue}if(U>=0&&U<=31)if(b(U)){M+=r.substring(j,i),u=2;break}else u=6;i++}return M}function F(){if(o="",u=0,s=i,i>=t)return s=t,c=17;let M=r.charCodeAt(i);if(R(M)){do i++,o+=String.fromCharCode(M),M=r.charCodeAt(i);while(R(M));return c=15}if(b(M))return i++,o+=String.fromCharCode(M),M===13&&r.charCodeAt(i)===10&&(i++,o+=`
`),c=14;switch(M){case 123:return i++,c=1;case 125:return i++,c=2;case 91:return i++,c=3;case 93:return i++,c=4;case 58:return i++,c=6;case 44:return i++,c=5;case 34:return i++,o=O(),c=10;case 47:{const j=i-1;if(r.charCodeAt(i+1)===47){for(i+=2;i<t&&!b(r.charCodeAt(i));)i++;return o=r.substring(j,i),c=12}if(r.charCodeAt(i+1)===42){i+=2;const U=t-1;let G=!1;for(;i<U;){if(r.charCodeAt(i)===42&&r.charCodeAt(i+1)===47){i+=2,G=!0;break}i++}return G||(i++,u=1),o=r.substring(j,i),c=13}return o+=String.fromCharCode(M),i++,c=16}case 45:if(o+=String.fromCharCode(M),i++,i===t||!E(r.charCodeAt(i)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),c=11;default:for(;i<t&&$(M);)i++,M=r.charCodeAt(i);if(s!==i){switch(o=r.substring(s,i),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(M),i++,c=16}}function $(M){if(R(M)||b(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function k(){let M;do M=F();while(M>=12&&M<=15);return M}return{setPosition:P,getPosition:()=>i,scan:a?k:F,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>s,getTokenLength:()=>i-s,getTokenError:()=>u}}e.createScanner=T;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function E(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function C(r,a){const i=[],t=new Object;let o;const s={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(p,P,_,O){s.value=p,s.offset=P,s.length=_,s.type=O,s.colonOffset=void 0,o=s}try{m(r,{onObjectBegin:(p,P)=>{if(a<=p)throw t;o=void 0,c=a>p,i.push("")},onObjectProperty:(p,P,_)=>{if(a<P||(u(p,P,_,"property"),i[i.length-1]=p,a<=P+_))throw t},onObjectEnd:(p,P)=>{if(a<=p)throw t;o=void 0,i.pop()},onArrayBegin:(p,P)=>{if(a<=p)throw t;o=void 0,i.push(0)},onArrayEnd:(p,P)=>{if(a<=p)throw t;o=void 0,i.pop()},onLiteralValue:(p,P,_)=>{if(a<P||(u(p,P,_,l(p)),a<=P+_))throw t},onSeparator:(p,P,_)=>{if(a<=P)throw t;if(p===":"&&o&&o.type==="property")o.colonOffset=P,c=!1,o=void 0;else if(p===","){const O=i[i.length-1];typeof O=="number"?i[i.length-1]=O+1:(c=!0,i[i.length-1]=""),o=void 0}}})}catch(p){if(p!==t)throw p}return{path:i,previousNode:o,isAtPropertyKey:c,matches:p=>{let P=0;for(let _=0;P<p.length&&_<i.length;_++)if(p[P]===i[_]||p[P]==="*")P++;else if(p[P]!=="**")return!1;return P===p.length}}}e.getLocation=C;function f(r,a=[],i=A.DEFAULT){let t=null,o=[];const s=[];function c(p){Array.isArray(o)?o.push(p):t!==null&&(o[t]=p)}return m(r,{onObjectBegin:()=>{const p={};c(p),s.push(o),o=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const p=[];c(p),s.push(o),o=p,t=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:c,onError:(p,P,_)=>{a.push({error:p,offset:P,length:_})}},i),o[0]}e.parse=f;function y(r,a=[],i=A.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(p){t.type==="property"&&(t.length=p-t.offset,t=t.parent)}function s(p){return t.children.push(p),p}m(r,{onObjectBegin:p=>{t=s({type:"object",offset:p,length:-1,parent:t,children:[]})},onObjectProperty:(p,P,_)=>{t=s({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:p,offset:P,length:_,parent:t})},onObjectEnd:(p,P)=>{t.length=p+P-t.offset,t=t.parent,o(p+P)},onArrayBegin:(p,P)=>{t=s({type:"array",offset:p,length:-1,parent:t,children:[]})},onArrayEnd:(p,P)=>{t.length=p+P-t.offset,t=t.parent,o(p+P)},onLiteralValue:(p,P,_)=>{s({type:l(p),offset:P,length:_,parent:t,value:p}),o(P+_)},onSeparator:(p,P,_)=>{t.type==="property"&&(p===":"?t.colonOffset=P:p===","&&o(P))},onError:(p,P,_)=>{a.push({error:p,offset:P,length:_})}},i);const u=t.children[0];return u&&delete u.parent,u}e.parseTree=y;function h(r,a){if(!r)return;let i=r;for(let t of a)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const s of i.children)if(Array.isArray(s.children)&&s.children[0].value===t){i=s.children[1],o=!0;break}if(!o)return}else{const o=t;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=h;function v(r){if(!r.parent||!r.parent.children)return[];const a=v(r.parent);if(r.parent.type==="property"){const i=r.parent.children[0].value;a.push(i)}else if(r.parent.type==="array"){const i=r.parent.children.indexOf(r);i!==-1&&a.push(i)}return a}e.getNodePath=v;function d(r){switch(r.type){case"array":return r.children.map(d);case"object":{const a=Object.create(null);for(let i of r.children){const t=i.children[1];t&&(a[i.children[0].value]=d(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=d;function g(r,a,i=!1){return a>=r.offset&&a<r.offset+r.length||i&&a===r.offset+r.length}e.contains=g;function w(r,a,i=!1){if(g(r,a,i)){const t=r.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=a;o++){const s=w(t[o],a,i);if(s)return s}return r}}e.findNodeAtOffset=w;function m(r,a,i=A.DEFAULT){const t=T(r,!1);function o(ee){return ee?()=>ee(t.getTokenOffset(),t.getTokenLength()):()=>!0}function s(ee){return ee?W=>ee(W,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=o(a.onObjectBegin),u=s(a.onObjectProperty),p=o(a.onObjectEnd),P=o(a.onArrayBegin),_=o(a.onArrayEnd),O=s(a.onLiteralValue),F=s(a.onSeparator),$=o(a.onComment),k=s(a.onError),M=i&&i.disallowComments,j=i&&i.allowTrailingComma;function U(){for(;;){const ee=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:M||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(ee){case 12:case 13:M?G(10):$();break;case 16:G(1);break;case 15:case 14:break;default:return ee}}}function G(ee,W=[],N=[]){if(k(ee),W.length+N.length>0){let V=t.getToken();for(;V!==17;){if(W.indexOf(V)!==-1){U();break}else if(N.indexOf(V)!==-1)break;V=U()}}}function K(ee){const W=t.getTokenValue();return ee?O(W):u(W),U(),!0}function x(){switch(t.getToken()){case 11:{let ee=0;try{ee=JSON.parse(t.getTokenValue()),typeof ee!="number"&&(G(2),ee=0)}catch{G(2)}O(ee);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return U(),!0}function q(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(K(!1),t.getToken()===6?(F(":"),U(),Z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function X(){c(),U();let ee=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),F(","),U(),t.getToken()===2&&j)break}else ee&&G(6,[],[]);q()||G(4,[],[2,5]),ee=!0}return p(),t.getToken()!==2?G(7,[2],[]):U(),!0}function H(){P(),U();let ee=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ee||G(4,[],[]),F(","),U(),t.getToken()===4&&j)break}else ee&&G(6,[],[]);Z()||G(4,[],[4,5]),ee=!0}return _(),t.getToken()!==4?G(8,[4],[]):U(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return X();case 10:return K(!0);default:return x()}}return U(),t.getToken()===17?i.allowEmptyContent?!0:(G(4,[],[]),!1):Z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=m;function S(r,a){let i=T(r),t=[],o,s=0,c;do switch(c=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:s!==c&&t.push(r.substring(s,c)),a!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,a)),s=i.getPosition();break}while(o!==17);return t.join("")}e.stripComments=S;function l(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(ne[49],ie([0,1,35]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(E,I,C){let f,y,h,v,d;if(I){for(v=I.offset,d=v+I.length,h=v;h>0&&!b(E,h-1);)h--;let c=d;for(;c<E.length&&!b(E,c);)c++;y=E.substring(h,c),f=T(y,C)}else y=E,f=0,h=0,v=0,d=E.length;const g=R(C,E);let w=!1,m=0,S;C.insertSpaces?S=A(" ",C.tabSize||4):S="	";const l=(0,D.createScanner)(y,!1);let r=!1;function a(){return g+A(S,f+m)}function i(){let c=l.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=l.scan();return r=c===16||l.getTokenError()!==0,c}const t=[];function o(c,u,p){!r&&u<d&&p>v&&E.substring(u,p)!==c&&t.push({offset:u,length:p-u,content:c})}let s=i();if(s!==17){const c=l.getTokenOffset()+h,u=A(S,f);o(u,h,c)}for(;s!==17;){let c=l.getTokenOffset()+l.getTokenLength()+h,u=i(),p="";for(;!w&&(u===12||u===13);){const _=l.getTokenOffset()+h;o(" ",c,_),c=l.getTokenOffset()+l.getTokenLength()+h,p=u===12?a():"",u=i()}if(u===2)s!==1&&(m--,p=a());else if(u===4)s!==3&&(m--,p=a());else{switch(s){case 3:case 1:m++,p=a();break;case 5:case 12:p=a();break;case 13:w?p=a():p=" ";break;case 6:p=" ";break;case 10:if(u===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?p=" ":u!==5&&u!==17&&(r=!0);break;case 16:r=!0;break}w&&(u===12||u===13)&&(p=a())}const P=l.getTokenOffset()+h;o(p,c,P),s=u}return t}e.format=n;function L(E,I){const C=JSON.stringify(E,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?C.replace(/\r\n|\r|\n/g,I.eol):C}e.toFormattedString=L;function A(E,I){let C="";for(let f=0;f<I;f++)C+=E;return C}function T(E,I){let C=0,f=0;const y=I.tabSize||4;for(;C<E.length;){const h=E.charAt(C);if(h===" ")f++;else if(h==="	")f+=y;else break;C++}return Math.floor(f/y)}function R(E,I){for(let C=0;C<I.length;C++){const f=I.charAt(C);if(f==="\r")return C+1<I.length&&I.charAt(C+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=R;function b(E,I){return`\r
`.indexOf(E.charAt(I))!==-1}e.isEOL=b}),define(ne[69],ie([0,1,35,49]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(E,I,C){return A(E,I,void 0,C)}e.removeProperty=L;function A(E,I,C,f,y){const h=I.slice(),v=[],d=(0,D.parseTree)(E,v);let g,w;for(;h.length>0&&(w=h.pop(),g=(0,D.findNodeAtLocation)(d,h),g===void 0&&C!==void 0);)typeof w=="string"?C={[w]:C}:C=[C];if(g)if(g.type==="object"&&typeof w=="string"&&Array.isArray(g.children)){const m=(0,D.findNodeAtLocation)(g,[w]);if(m!==void 0)if(C===void 0){if(!m.parent)throw new Error("Malformed AST");const S=g.children.indexOf(m.parent);let l,r=m.parent.offset+m.parent.length;if(S>0){const a=g.children[S-1];l=a.offset+a.length}else l=g.offset+1,g.children.length>1&&(r=g.children[1].offset);return T(E,{offset:l,length:r-l,content:""},f)}else return T(E,{offset:m.offset,length:m.length,content:JSON.stringify(C)},f);else{if(C===void 0)return[];const S=`${JSON.stringify(w)}: ${JSON.stringify(C)}`,l=y?y(g.children.map(a=>a.children[0].value)):g.children.length;let r;if(l>0){const a=g.children[l-1];r={offset:a.offset+a.length,length:0,content:","+S}}else g.children.length===0?r={offset:g.offset+1,length:0,content:S}:r={offset:g.offset+1,length:0,content:S+","};return T(E,r,f)}}else if(g.type==="array"&&typeof w=="number"&&Array.isArray(g.children))if(C!==void 0){const m=`${JSON.stringify(C)}`;let S;if(g.children.length===0||w===0)S={offset:g.offset+1,length:0,content:g.children.length===0?m:m+","};else{const l=w===-1||w>g.children.length?g.children.length:w,r=g.children[l-1];S={offset:r.offset+r.length,length:0,content:","+m}}return T(E,S,f)}else{const m=w,S=g.children[m];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===m){const r=g.children[m-1],a=r.offset+r.length,i=g.offset+g.length;l={offset:a,length:i-2-a,content:""}}else l={offset:S.offset,length:g.children[m+1].offset-S.offset,content:""};return T(E,l,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${g.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return T(E,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(C)},f)}}e.setProperty=A;function T(E,I,C){let f=R(E,I),y=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;y>0&&!(0,n.isEOL)(f,y-1);)y--;for(;h<f.length&&!(0,n.isEOL)(f,h);)h++}const v=(0,n.format)(f,{offset:y,length:h-y},C);for(let g=v.length-1;g>=0;g--){const w=v[g];f=R(f,w),y=Math.min(y,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const d=E.length-(f.length-h)-y;return[{offset:y,length:d,content:f.substring(y,h)}]}e.withFormatting=T;function R(E,I){return E.substring(0,I.offset)+I.content+E.substring(I.offset+I.length)}e.applyEdit=R;function b(E,I){let C=I.slice(0).sort((y,h)=>{const v=y.offset-h.offset;return v===0?y.length-h.length:v}),f=E.length;for(let y=C.length-1;y>=0;y--){let h=C[y];if(h.offset+h.length<=f)E=R(E,h);else throw new Error("Overlapping edit");f=h.offset}return E}e.applyEdits=b}),define(ne[100],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(L){this.executor=L,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(L){this._error=L}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(L){return new D(()=>L(this.getValue()))}}e.Lazy=D}),define(ne[2],ie([0,1,68,55]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const L=!1;let A=null;function T(t){A=t}if(e.setDisposableTracker=T,L){const t="__is_disposable_tracked__";T(new class{trackDisposable(o){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[t]||console.log(s)},3e3)}setParent(o,s){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsDisposed(o){if(o&&o!==w.None)try{o[t]=!0}catch{}}markAsSingleton(o){}})}function R(t){return A?.trackDisposable(t),t}function b(t){A?.markAsDisposed(t)}function E(t,o){A?.setParent(t,o)}function I(t,o){if(!!A)for(const s of t)A.setParent(s,o)}function C(t){return A?.markAsSingleton(t),t}e.markAsSingleton=C;class f extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=f;function y(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=y;function h(t){if(n.Iterable.is(t)){let o=[];for(const s of t)if(s)try{s.dispose()}catch(c){o.push(c)}if(o.length===1)throw o[0];if(o.length>1)throw new f(o);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function v(...t){const o=d(()=>h(t));return I(t,o),o}e.combinedDisposable=v;function d(t){const o=R({dispose:(0,D.once)(()=>{b(o),t()})});return o}e.toDisposable=d;class g{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return E(o,this),this._isDisposed?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new g,R(this),E(this._store,this)}dispose(){b(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class m{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&E(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&E(o,null),o}}e.MutableDisposable=m;class S{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=S;class l{constructor(){this.references=new Map}acquire(o,...s){let c=this.references.get(o);c||(c={counter:0,object:this.createReferencedObject(o,...s)},this.references.set(o,c));const{object:u}=c,p=(0,D.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(o,c.object),this.references.delete(o))});return c.counter++,{object:u,dispose:p}}}e.ReferenceCollection=l;class r{constructor(o){this.referenceCollection=o}async acquire(o,...s){const c=this.referenceCollection.acquire(o,...s);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(u){throw c.dispose(),u}}}e.AsyncReferenceCollection=r;class a{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=a;function i(t){const o=new g;try{t(o)}finally{o.dispose()}}e.disposeOnReturn=i}),define(ne[101],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let A=this._first;for(;A!==D.Undefined;){const T=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=T}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,T){const R=new D(A);if(this._first===D.Undefined)this._first=R,this._last=R;else if(T){const E=this._last;this._last=R,R.prev=E,E.next=R}else{const E=this._first;this._first=R,R.next=E,E.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==D.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==D.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const T=A.prev;T.next=A.next,A.next.prev=T}else A.prev===D.Undefined&&A.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):A.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):A.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.LinkedList=n}),function(){function Y(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function T(b){A.push(b,Date.now())}function R(){const b=[];for(let E=0;E<A.length;E+=2)b.push({name:A[E],startTime:A[E+1]});return b}return{mark:T,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const T of performance.getEntriesByType("mark"))A.push({name:T.name,startTime:Math.round(L+T.startTime)});return A}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),define(ne[4],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const D="en";let n=!1,L=!1,A=!1,T=!1,R=!1,b=!1,E=!1,I=!1,C,f=D,y,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let v;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?v=e.globals.vscode.process:typeof process!="undefined"&&(v=process);const d=typeof v?.versions?.electron=="string",g=d&&v?.type==="renderer";if(e.isElectronSandboxed=g&&v?.sandboxed,typeof navigator=="object"&&!g)h=navigator.userAgent,n=h.indexOf("Windows")>=0,L=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,b=!0,C=navigator.language,f=C;else if(typeof v=="object"){n=v.platform==="win32",L=v.platform==="darwin",A=v.platform==="linux",T=A&&!!v.env.SNAP&&!!v.env.SNAP_REVISION,E=d,C=D,f=D;const o=v.env.VSCODE_NLS_CONFIG;if(o)try{const s=JSON.parse(o),c=s.availableLanguages["*"];C=s.locale,f=c||D,y=s._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function m(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=m;let S=0;L?S=1:n?S=3:A&&(S=2),e.isWindows=n,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=T,e.isNative=R,e.isElectron=E,e.isWeb=b,e.isIOS=I,e.platform=S,e.userAgent=h,e.language=f;var l;(function(o){function s(){return e.language}o.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=c;function u(){return e.language==="en"}o.isDefault=u})(l=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let u=0,p=o.length;u<p;u++){const P=o[u];if(P.id===c.data.vscodeScheduleAsyncWork){o.splice(u,1),P.callback();return}}});let s=0;return c=>{const u=++s;o.push({id:u,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:u},"*")}}return o=>setTimeout(o)})();var r;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||I?2:n?1:3;let a=!0,i=!1;function t(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,a=new Uint16Array(o.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(ne[32],ie([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const L=D.globals.vscode.process;n={get platform(){return L.platform},get arch(){return L.arch},get env(){return L.env},cwd(){return L.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[10],ie([0,1,32]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,L=97,A=90,T=122,R=46,b=47,E=92,I=58,C=63;class f extends Error{constructor(S,l,r){let a;typeof l=="string"&&l.indexOf("not ")===0?(a="must not be",l=l.replace(/^not /,"")):a="must be";const i=S.indexOf(".")!==-1?"property":"argument";let t=`The "${S}" ${i} ${a} of type ${l}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function y(m,S){if(typeof m!="string")throw new f(S,"string",m)}function h(m){return m===b||m===E}function v(m){return m===b}function d(m){return m>=n&&m<=A||m>=L&&m<=T}function g(m,S,l,r){let a="",i=0,t=-1,o=0,s=0;for(let c=0;c<=m.length;++c){if(c<m.length)s=m.charCodeAt(c);else{if(r(s))break;s=b}if(r(s)){if(!(t===c-1||o===1))if(o===2){if(a.length<2||i!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const u=a.lastIndexOf(l);u===-1?(a="",i=0):(a=a.slice(0,u),i=a.length-1-a.lastIndexOf(l)),t=c,o=0;continue}else if(a.length!==0){a="",i=0,t=c,o=0;continue}}S&&(a+=a.length>0?`${l}..`:"..",i=2)}else a.length>0?a+=`${l}${m.slice(t+1,c)}`:a=m.slice(t+1,c),i=c-t-1;t=c,o=0}else s===R&&o!==-1?++o:o=-1}return a}function w(m,S){if(S===null||typeof S!="object")throw new f("pathObject","Object",S);const l=S.dir||S.root,r=S.base||`${S.name||""}${S.ext||""}`;return l?l===S.root?`${l}${r}`:`${l}${m}${r}`:r}e.win32={resolve(...m){let S="",l="",r=!1;for(let a=m.length-1;a>=-1;a--){let i;if(a>=0){if(i=m[a],y(i,"path"),i.length===0)continue}else S.length===0?i=D.cwd():(i=D.env[`=${S}`]||D.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==S.toLowerCase()&&i.charCodeAt(2)===E)&&(i=`${S}\\`));const t=i.length;let o=0,s="",c=!1;const u=i.charCodeAt(0);if(t===1)h(u)&&(o=1,c=!0);else if(h(u))if(c=!0,h(i.charCodeAt(1))){let p=2,P=p;for(;p<t&&!h(i.charCodeAt(p));)p++;if(p<t&&p!==P){const _=i.slice(P,p);for(P=p;p<t&&h(i.charCodeAt(p));)p++;if(p<t&&p!==P){for(P=p;p<t&&!h(i.charCodeAt(p));)p++;(p===t||p!==P)&&(s=`\\\\${_}\\${i.slice(P,p)}`,o=p)}}}else o=1;else d(u)&&i.charCodeAt(1)===I&&(s=i.slice(0,2),o=2,t>2&&h(i.charCodeAt(2))&&(c=!0,o=3));if(s.length>0)if(S.length>0){if(s.toLowerCase()!==S.toLowerCase())continue}else S=s;if(r){if(S.length>0)break}else if(l=`${i.slice(o)}\\${l}`,r=c,c&&S.length>0)break}return l=g(l,!r,"\\",h),r?`${S}\\${l}`:`${S}${l}`||"."},normalize(m){y(m,"path");const S=m.length;if(S===0)return".";let l=0,r,a=!1;const i=m.charCodeAt(0);if(S===1)return v(i)?"\\":m;if(h(i))if(a=!0,h(m.charCodeAt(1))){let o=2,s=o;for(;o<S&&!h(m.charCodeAt(o));)o++;if(o<S&&o!==s){const c=m.slice(s,o);for(s=o;o<S&&h(m.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!h(m.charCodeAt(o));)o++;if(o===S)return`\\\\${c}\\${m.slice(s)}\\`;o!==s&&(r=`\\\\${c}\\${m.slice(s,o)}`,l=o)}}}else l=1;else d(i)&&m.charCodeAt(1)===I&&(r=m.slice(0,2),l=2,S>2&&h(m.charCodeAt(2))&&(a=!0,l=3));let t=l<S?g(m.slice(l),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(m.charCodeAt(S-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(m){y(m,"path");const S=m.length;if(S===0)return!1;const l=m.charCodeAt(0);return h(l)||S>2&&d(l)&&m.charCodeAt(1)===I&&h(m.charCodeAt(2))},join(...m){if(m.length===0)return".";let S,l;for(let i=0;i<m.length;++i){const t=m[i];y(t,"path"),t.length>0&&(S===void 0?S=l=t:S+=`\\${t}`)}if(S===void 0)return".";let r=!0,a=0;if(typeof l=="string"&&h(l.charCodeAt(0))){++a;const i=l.length;i>1&&h(l.charCodeAt(1))&&(++a,i>2&&(h(l.charCodeAt(2))?++a:r=!1))}if(r){for(;a<S.length&&h(S.charCodeAt(a));)a++;a>=2&&(S=`\\${S.slice(a)}`)}return e.win32.normalize(S)},relative(m,S){if(y(m,"from"),y(S,"to"),m===S)return"";const l=e.win32.resolve(m),r=e.win32.resolve(S);if(l===r||(m=l.toLowerCase(),S=r.toLowerCase(),m===S))return"";let a=0;for(;a<m.length&&m.charCodeAt(a)===E;)a++;let i=m.length;for(;i-1>a&&m.charCodeAt(i-1)===E;)i--;const t=i-a;let o=0;for(;o<S.length&&S.charCodeAt(o)===E;)o++;let s=S.length;for(;s-1>o&&S.charCodeAt(s-1)===E;)s--;const c=s-o,u=t<c?t:c;let p=-1,P=0;for(;P<u;P++){const O=m.charCodeAt(a+P);if(O!==S.charCodeAt(o+P))break;O===E&&(p=P)}if(P!==u){if(p===-1)return r}else{if(c>u){if(S.charCodeAt(o+P)===E)return r.slice(o+P+1);if(P===2)return r.slice(o+P)}t>u&&(m.charCodeAt(a+P)===E?p=P:P===2&&(p=3)),p===-1&&(p=0)}let _="";for(P=a+p+1;P<=i;++P)(P===i||m.charCodeAt(P)===E)&&(_+=_.length===0?"..":"\\..");return o+=p,_.length>0?`${_}${r.slice(o,s)}`:(r.charCodeAt(o)===E&&++o,r.slice(o,s))},toNamespacedPath(m){if(typeof m!="string")return m;if(m.length===0)return"";const S=e.win32.resolve(m);if(S.length<=2)return m;if(S.charCodeAt(0)===E){if(S.charCodeAt(1)===E){const l=S.charCodeAt(2);if(l!==C&&l!==R)return`\\\\?\\UNC\\${S.slice(2)}`}}else if(d(S.charCodeAt(0))&&S.charCodeAt(1)===I&&S.charCodeAt(2)===E)return`\\\\?\\${S}`;return m},dirname(m){y(m,"path");const S=m.length;if(S===0)return".";let l=-1,r=0;const a=m.charCodeAt(0);if(S===1)return h(a)?m:".";if(h(a)){if(l=r=1,h(m.charCodeAt(1))){let o=2,s=o;for(;o<S&&!h(m.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&h(m.charCodeAt(o));)o++;if(o<S&&o!==s){for(s=o;o<S&&!h(m.charCodeAt(o));)o++;if(o===S)return m;o!==s&&(l=r=o+1)}}}}else d(a)&&m.charCodeAt(1)===I&&(l=S>2&&h(m.charCodeAt(2))?3:2,r=l);let i=-1,t=!0;for(let o=S-1;o>=r;--o)if(h(m.charCodeAt(o))){if(!t){i=o;break}}else t=!1;if(i===-1){if(l===-1)return".";i=l}return m.slice(0,i)},basename(m,S){S!==void 0&&y(S,"ext"),y(m,"path");let l=0,r=-1,a=!0,i;if(m.length>=2&&d(m.charCodeAt(0))&&m.charCodeAt(1)===I&&(l=2),S!==void 0&&S.length>0&&S.length<=m.length){if(S===m)return"";let t=S.length-1,o=-1;for(i=m.length-1;i>=l;--i){const s=m.charCodeAt(i);if(h(s)){if(!a){l=i+1;break}}else o===-1&&(a=!1,o=i+1),t>=0&&(s===S.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=m.length),m.slice(l,r)}for(i=m.length-1;i>=l;--i)if(h(m.charCodeAt(i))){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":m.slice(l,r)},extname(m){y(m,"path");let S=0,l=-1,r=0,a=-1,i=!0,t=0;m.length>=2&&m.charCodeAt(1)===I&&d(m.charCodeAt(0))&&(S=r=2);for(let o=m.length-1;o>=S;--o){const s=m.charCodeAt(o);if(h(s)){if(!i){r=o+1;break}continue}a===-1&&(i=!1,a=o+1),s===R?l===-1?l=o:t!==1&&(t=1):l!==-1&&(t=-1)}return l===-1||a===-1||t===0||t===1&&l===a-1&&l===r+1?"":m.slice(l,a)},format:w.bind(null,"\\"),parse(m){y(m,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return S;const l=m.length;let r=0,a=m.charCodeAt(0);if(l===1)return h(a)?(S.root=S.dir=m,S):(S.base=S.name=m,S);if(h(a)){if(r=1,h(m.charCodeAt(1))){let p=2,P=p;for(;p<l&&!h(m.charCodeAt(p));)p++;if(p<l&&p!==P){for(P=p;p<l&&h(m.charCodeAt(p));)p++;if(p<l&&p!==P){for(P=p;p<l&&!h(m.charCodeAt(p));)p++;p===l?r=p:p!==P&&(r=p+1)}}}}else if(d(a)&&m.charCodeAt(1)===I){if(l<=2)return S.root=S.dir=m,S;if(r=2,h(m.charCodeAt(2))){if(l===3)return S.root=S.dir=m,S;r=3}}r>0&&(S.root=m.slice(0,r));let i=-1,t=r,o=-1,s=!0,c=m.length-1,u=0;for(;c>=r;--c){if(a=m.charCodeAt(c),h(a)){if(!s){t=c+1;break}continue}o===-1&&(s=!1,o=c+1),a===R?i===-1?i=c:u!==1&&(u=1):i!==-1&&(u=-1)}return o!==-1&&(i===-1||u===0||u===1&&i===o-1&&i===t+1?S.base=S.name=m.slice(t,o):(S.name=m.slice(t,i),S.base=m.slice(t,o),S.ext=m.slice(i,o))),t>0&&t!==r?S.dir=m.slice(0,t-1):S.dir=S.root,S},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...m){let S="",l=!1;for(let r=m.length-1;r>=-1&&!l;r--){const a=r>=0?m[r]:D.cwd();y(a,"path"),a.length!==0&&(S=`${a}/${S}`,l=a.charCodeAt(0)===b)}return S=g(S,!l,"/",v),l?`/${S}`:S.length>0?S:"."},normalize(m){if(y(m,"path"),m.length===0)return".";const S=m.charCodeAt(0)===b,l=m.charCodeAt(m.length-1)===b;return m=g(m,!S,"/",v),m.length===0?S?"/":l?"./":".":(l&&(m+="/"),S?`/${m}`:m)},isAbsolute(m){return y(m,"path"),m.length>0&&m.charCodeAt(0)===b},join(...m){if(m.length===0)return".";let S;for(let l=0;l<m.length;++l){const r=m[l];y(r,"path"),r.length>0&&(S===void 0?S=r:S+=`/${r}`)}return S===void 0?".":e.posix.normalize(S)},relative(m,S){if(y(m,"from"),y(S,"to"),m===S||(m=e.posix.resolve(m),S=e.posix.resolve(S),m===S))return"";const l=1,r=m.length,a=r-l,i=1,t=S.length-i,o=a<t?a:t;let s=-1,c=0;for(;c<o;c++){const p=m.charCodeAt(l+c);if(p!==S.charCodeAt(i+c))break;p===b&&(s=c)}if(c===o)if(t>o){if(S.charCodeAt(i+c)===b)return S.slice(i+c+1);if(c===0)return S.slice(i+c)}else a>o&&(m.charCodeAt(l+c)===b?s=c:c===0&&(s=0));let u="";for(c=l+s+1;c<=r;++c)(c===r||m.charCodeAt(c)===b)&&(u+=u.length===0?"..":"/..");return`${u}${S.slice(i+s)}`},toNamespacedPath(m){return m},dirname(m){if(y(m,"path"),m.length===0)return".";const S=m.charCodeAt(0)===b;let l=-1,r=!0;for(let a=m.length-1;a>=1;--a)if(m.charCodeAt(a)===b){if(!r){l=a;break}}else r=!1;return l===-1?S?"/":".":S&&l===1?"//":m.slice(0,l)},basename(m,S){S!==void 0&&y(S,"ext"),y(m,"path");let l=0,r=-1,a=!0,i;if(S!==void 0&&S.length>0&&S.length<=m.length){if(S===m)return"";let t=S.length-1,o=-1;for(i=m.length-1;i>=0;--i){const s=m.charCodeAt(i);if(s===b){if(!a){l=i+1;break}}else o===-1&&(a=!1,o=i+1),t>=0&&(s===S.charCodeAt(t)?--t==-1&&(r=i):(t=-1,r=o))}return l===r?r=o:r===-1&&(r=m.length),m.slice(l,r)}for(i=m.length-1;i>=0;--i)if(m.charCodeAt(i)===b){if(!a){l=i+1;break}}else r===-1&&(a=!1,r=i+1);return r===-1?"":m.slice(l,r)},extname(m){y(m,"path");let S=-1,l=0,r=-1,a=!0,i=0;for(let t=m.length-1;t>=0;--t){const o=m.charCodeAt(t);if(o===b){if(!a){l=t+1;break}continue}r===-1&&(a=!1,r=t+1),o===R?S===-1?S=t:i!==1&&(i=1):S!==-1&&(i=-1)}return S===-1||r===-1||i===0||i===1&&S===r-1&&S===l+1?"":m.slice(S,r)},format:w.bind(null,"/"),parse(m){y(m,"path");const S={root:"",dir:"",base:"",ext:"",name:""};if(m.length===0)return S;const l=m.charCodeAt(0)===b;let r;l?(S.root="/",r=1):r=0;let a=-1,i=0,t=-1,o=!0,s=m.length-1,c=0;for(;s>=r;--s){const u=m.charCodeAt(s);if(u===b){if(!o){i=s+1;break}continue}t===-1&&(o=!1,t=s+1),u===R?a===-1?a=s:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const u=i===0&&l?1:i;a===-1||c===0||c===1&&a===t-1&&a===i+1?S.base=S.name=m.slice(u,t):(S.name=m.slice(u,a),S.base=m.slice(u,t),S.ext=m.slice(a,t))}return i>0?S.dir=m.slice(0,i-1):l&&(S.dir="/"),S},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[102],ie([0,1,10]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var n;(function(C){C.text="text/plain",C.binary="application/octet-stream",C.unknown="application/unknown",C.markdown="text/markdown",C.latex="text/latex"})(n=e.Mimes||(e.Mimes={}));const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(C){const f=(0,D.extname)(C),y=L[f.toLowerCase()];return y!==void 0?y:R(C)}e.getMediaOrTextMime=T;function R(C){const f=(0,D.extname)(C);return A[f.toLowerCase()]}e.getMediaMime=R;function b(C){for(const f in A)if(A[f]===C)return f}e.getExtensionForMimeType=b;const E=/^(.+)\/(.+?)(;.+)?$/;function I(C,f){const y=E.exec(C);return y?`${y[1].toLowerCase()}/${y[2].toLowerCase()}${y[3]??""}`:f?void 0:C}e.normalizeMimeType=I}),define(ne[103],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var D;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(D=e.Source||(e.Source={}));var n;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(n=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(A,...T){const R=T.reduce((I,C)=>(I[C]=!0,I),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(I=>!R[I]).forEach(I=>{for(let C=0;C<b.length;C++)if(I.search(b[C])!==-1){delete A[I];break}})}e.sanitizeProcessEnvironment=L}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:Y)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(Y){var e={};function D(n){if(e[n])return e[n].exports;var L=e[n]={i:n,l:!1,exports:{}};return Y[n].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=Y,D.c=e,D.d=function(n,L,A){D.o(n,L)||Object.defineProperty(n,L,{enumerable:!0,get:A})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,L){if(1&L&&(n=D(n)),8&L||4&L&&typeof n=="object"&&n&&n.__esModule)return n;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:n}),2&L&&typeof n!="string")for(var T in n)D.d(A,T,function(R){return n[R]}.bind(null,T));return A},D.n=function(n){var L=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(L,"a",L),L},D.o=function(n,L){return Object.prototype.hasOwnProperty.call(n,L)},D.p="",D(D.s=0)}([function(Y,e,D){(function(n){var L;e=Y.exports=N,L=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],E=0,I=E++;b[I]="0|[1-9]\\d*";var C=E++;b[C]="[0-9]+";var f=E++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=E++;b[y]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var h=E++;b[h]="("+b[C]+")\\.("+b[C]+")\\.("+b[C]+")";var v=E++;b[v]="(?:"+b[I]+"|"+b[f]+")";var d=E++;b[d]="(?:"+b[C]+"|"+b[f]+")";var g=E++;b[g]="(?:-("+b[v]+"(?:\\."+b[v]+")*))";var w=E++;b[w]="(?:-?("+b[d]+"(?:\\."+b[d]+")*))";var m=E++;b[m]="[0-9A-Za-z-]+";var S=E++;b[S]="(?:\\+("+b[m]+"(?:\\."+b[m]+")*))";var l=E++,r="v?"+b[y]+b[g]+"?"+b[S]+"?";b[l]="^"+r+"$";var a="[v=\\s]*"+b[h]+b[w]+"?"+b[S]+"?",i=E++;b[i]="^"+a+"$";var t=E++;b[t]="((?:<|>)?=?)";var o=E++;b[o]=b[C]+"|x|X|\\*";var s=E++;b[s]=b[I]+"|x|X|\\*";var c=E++;b[c]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[g]+")?"+b[S]+"?)?)?";var u=E++;b[u]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[w]+")?"+b[S]+"?)?)?";var p=E++;b[p]="^"+b[t]+"\\s*"+b[c]+"$";var P=E++;b[P]="^"+b[t]+"\\s*"+b[u]+"$";var _=E++;b[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=E++;b[O]="(?:~>?)";var F=E++;b[F]="(\\s*)"+b[O]+"\\s+",R[F]=new RegExp(b[F],"g");var $=E++;b[$]="^"+b[O]+b[c]+"$";var k=E++;b[k]="^"+b[O]+b[u]+"$";var M=E++;b[M]="(?:\\^)";var j=E++;b[j]="(\\s*)"+b[M]+"\\s+",R[j]=new RegExp(b[j],"g");var U=E++;b[U]="^"+b[M]+b[c]+"$";var G=E++;b[G]="^"+b[M]+b[u]+"$";var K=E++;b[K]="^"+b[t]+"\\s*("+a+")$|^$";var x=E++;b[x]="^"+b[t]+"\\s*("+r+")$|^$";var q=E++;b[q]="(\\s*)"+b[t]+"\\s*("+a+"|"+b[c]+")",R[q]=new RegExp(b[q],"g");var X=E++;b[X]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var H=E++;b[H]="^\\s*("+b[u]+")\\s+-\\s+("+b[u]+")\\s*$";var Z=E++;b[Z]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)L(ee,b[ee]),R[ee]||(R[ee]=new RegExp(b[ee]));function W(re,ae){if(re instanceof N)return re;if(typeof re!="string"||re.length>A||!(ae?R[i]:R[l]).test(re))return null;try{return new N(re,ae)}catch{return null}}function N(re,ae){if(re instanceof N){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof N))return new N(re,ae);L("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?R[i]:R[l]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Pe=+ye;if(Pe>=0&&Pe<T)return Pe}return ye}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=W,e.valid=function(re,ae){var ue=W(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=W(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=N,N.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},N.prototype.toString=function(){return this.version},N.prototype.compare=function(re){return L("SemVer.compare",this.version,this.loose,re),re instanceof N||(re=new N(re,this.loose)),this.compareMain(re)||this.comparePre(re)},N.prototype.compareMain=function(re){return re instanceof N||(re=new N(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},N.prototype.comparePre=function(re){if(re instanceof N||(re=new N(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],ye=re.prerelease[ae];if(L("prerelease compare",ae,ue,ye),ue===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(ue===void 0)return-1;if(ue!==ye)return z(ue,ye)}while(++ae)},N.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,ye){typeof ue=="string"&&(ye=ue,ue=void 0);try{return new N(re,ue).inc(ae,ye).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var ue=W(re),ye=W(ae);if(ue.prerelease.length||ye.prerelease.length){for(var Pe in ue)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ue[Pe]!==ye[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ue)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ue[Pe]!==ye[Pe])return Pe},e.compareIdentifiers=z;var V=/^[0-9]+$/;function z(re,ae){var ue=V.test(re),ye=V.test(ae);return ue&&ye&&(re=+re,ae=+ae),ue&&!ye?-1:ye&&!ue?1:re<ae?-1:re>ae?1:0}function B(re,ae,ue){return new N(re,ue).compare(new N(ae,ue))}function te(re,ae,ue){return B(re,ae,ue)>0}function se(re,ae,ue){return B(re,ae,ue)<0}function ce(re,ae,ue){return B(re,ae,ue)===0}function he(re,ae,ue){return B(re,ae,ue)!==0}function ve(re,ae,ue){return B(re,ae,ue)>=0}function pe(re,ae,ue){return B(re,ae,ue)<=0}function Ee(re,ae,ue,ye){var Pe;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Pe=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Pe=re!==ue;break;case"":case"=":case"==":Pe=ce(re,ue,ye);break;case"!=":Pe=he(re,ue,ye);break;case">":Pe=te(re,ue,ye);break;case">=":Pe=ve(re,ue,ye);break;case"<":Pe=se(re,ue,ye);break;case"<=":Pe=pe(re,ue,ye);break;default:throw new TypeError("Invalid operator: "+ae)}return Pe}function Ce(re,ae){if(re instanceof Ce){if(re.loose===ae)return re;re=re.value}if(!(this instanceof Ce))return new Ce(re,ae);L("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===we?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new N(re,ae).major},e.minor=function(re,ae){return new N(re,ae).minor},e.patch=function(re,ae){return new N(re,ae).patch},e.compare=B,e.compareLoose=function(re,ae){return B(re,ae,!0)},e.rcompare=function(re,ae,ue){return B(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,ye){return e.compare(ue,ye,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,ye){return e.rcompare(ue,ye,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=ve,e.lte=pe,e.cmp=Ee,e.Comparator=Ce;var we={};function be(re,ae){if(re instanceof be)return re.loose===ae?re:new be(re.raw,ae);if(re instanceof Ce)return new be(re.value,ae);if(!(this instanceof be))return new be(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function Re(re){return!re||re.toLowerCase()==="x"||re==="*"}function Fe(re,ae,ue,ye,Pe,Ne,Te,Oe,_e,Q,oe,le,fe){return((ae=Re(ue)?"":Re(ye)?">="+ue+".0.0":Re(Pe)?">="+ue+"."+ye+".0":">="+ae)+" "+(Oe=Re(_e)?"":Re(Q)?"<"+(+_e+1)+".0.0":Re(oe)?"<"+_e+"."+(+Q+1)+".0":le?"<="+_e+"."+Q+"."+oe+"-"+le:"<="+Oe)).trim()}function Ue(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(L(re[ue].semver),re[ue].semver!==we&&re[ue].semver.prerelease.length>0){var ye=re[ue].semver;if(ye.major===ae.major&&ye.minor===ae.minor&&ye.patch===ae.patch)return!0}return!1}return!0}function qe(re,ae,ue){try{ae=new be(ae,ue)}catch{return!1}return ae.test(re)}function Be(re,ae,ue,ye){var Pe,Ne,Te,Oe,_e;switch(re=new N(re,ye),ae=new be(ae,ye),ue){case">":Pe=te,Ne=pe,Te=se,Oe=">",_e=">=";break;case"<":Pe=se,Ne=ve,Te=te,Oe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(qe(re,ae,ye))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(ge){ge.semver===we&&(ge=new Ce(">=0.0.0")),le=le||ge,fe=fe||ge,Pe(ge.semver,le.semver,ye)?le=ge:Te(ge.semver,fe.semver,ye)&&(fe=ge)}),le.operator===Oe||le.operator===_e||(!fe.operator||fe.operator===Oe)&&Ne(re,fe.semver)||fe.operator===_e&&Te(re,fe.semver))return!1}return!0}Ce.prototype.parse=function(re){var ae=this.loose?R[K]:R[x],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new N(ue[2],this.loose):this.semver=we},Ce.prototype.toString=function(){return this.value},Ce.prototype.test=function(re){return L("Comparator.test",re,this.loose),this.semver===we||(typeof re=="string"&&(re=new N(re,this.loose)),Ee(re,this.operator,this.semver,this.loose))},Ce.prototype.intersects=function(re,ae){if(!(re instanceof Ce))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new be(re.value,ae),qe(this.value,ue,ae);if(re.operator==="")return ue=new be(this.value,ae),qe(re.semver,ue,ae);var ye=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Ne=this.semver.version===re.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Oe=Ee(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),_e=Ee(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return ye||Pe||Ne&&Te||Oe||_e},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),L("range",re,ae);var ue=ae?R[H]:R[X];re=re.replace(ue,Fe),L("hyphen replace",re),re=re.replace(R[q],"$1$2$3"),L("comparator trim",re,R[q]),re=(re=(re=re.replace(R[F],"$1~")).replace(R[j],"$1^")).split(/\s+/).join(" ");var ye=ae?R[K]:R[x],Pe=re.split(" ").map(function(Ne){return function(Te,Oe){return L("comp",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){L("caret",le,fe);var ge=fe?R[G]:R[U];return le.replace(ge,function(Le,Se,De,ke,Ie){var Ae;return L("caret",le,Le,Se,De,ke,Ie),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=Se==="0"?">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+".0 <"+(+Se+1)+".0.0":Ie?(L("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+Ie+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+Ie+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+Ie+" <"+(+Se+1)+".0.0"):(L("no pr"),Ae=Se==="0"?De==="0"?">="+Se+"."+De+"."+ke+" <"+Se+"."+De+"."+(+ke+1):">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0":">="+Se+"."+De+"."+ke+" <"+(+Se+1)+".0.0"),L("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("caret",Te),Te=function(_e,Q){return _e.trim().split(/\s+/).map(function(oe){return function(le,fe){var ge=fe?R[k]:R[$];return le.replace(ge,function(Le,Se,De,ke,Ie){var Ae;return L("tilde",le,Le,Se,De,ke,Ie),Re(Se)?Ae="":Re(De)?Ae=">="+Se+".0.0 <"+(+Se+1)+".0.0":Re(ke)?Ae=">="+Se+"."+De+".0 <"+Se+"."+(+De+1)+".0":Ie?(L("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+Se+"."+De+"."+ke+Ie+" <"+Se+"."+(+De+1)+".0"):Ae=">="+Se+"."+De+"."+ke+" <"+Se+"."+(+De+1)+".0",L("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Te,Oe),L("tildes",Te),Te=function(_e,Q){return L("replaceXRanges",_e,Q),_e.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var ge=fe?R[P]:R[p];return le.replace(ge,function(Le,Se,De,ke,Ie,Ae){L("xRange",le,Le,Se,De,ke,Ie,Ae);var $e=Re(De),je=$e||Re(ke),xe=je||Re(Ie);return Se==="="&&xe&&(Se=""),$e?Le=Se===">"||Se==="<"?"<0.0.0":"*":Se&&xe?(je&&(ke=0),xe&&(Ie=0),Se===">"?(Se=">=",je?(De=+De+1,ke=0,Ie=0):xe&&(ke=+ke+1,Ie=0)):Se==="<="&&(Se="<",je?De=+De+1:ke=+ke+1),Le=Se+De+"."+ke+"."+Ie):je?Le=">="+De+".0.0 <"+(+De+1)+".0.0":xe&&(Le=">="+De+"."+ke+".0 <"+De+"."+(+ke+1)+".0"),L("xRange return",Le),Le})}(oe,Q)}).join(" ")}(Te,Oe),L("xrange",Te),Te=function(_e,Q){return L("replaceStars",_e,Q),_e.trim().replace(R[Z],"")}(Te,Oe),L("stars",Te),Te}(Ne,ae)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ne){return!!Ne.match(ye)})),Pe=Pe.map(function(Ne){return new Ce(Ne,ae)})},be.prototype.intersects=function(re,ae){if(!(re instanceof be))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(ye){return re.set.some(function(Pe){return Pe.every(function(Ne){return ye.intersects(Ne,ae)})})})})},e.toComparators=function(re,ae){return new be(re,ae).set.map(function(ue){return ue.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},be.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new N(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ue(this.set[ae],re))return!0;return!1},e.satisfies=qe,e.maxSatisfying=function(re,ae,ue){var ye=null,Pe=null;try{var Ne=new be(ae,ue)}catch{return null}return re.forEach(function(Te){Ne.test(Te)&&(ye&&Pe.compare(Te)!==-1||(Pe=new N(ye=Te,ue)))}),ye},e.minSatisfying=function(re,ae,ue){var ye=null,Pe=null;try{var Ne=new be(ae,ue)}catch{return null}return re.forEach(function(Te){Ne.test(Te)&&(ye&&Pe.compare(Te)!==1||(Pe=new N(ye=Te,ue)))}),ye},e.validRange=function(re,ae){try{return new be(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return Be(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return Be(re,ae,">",ue)},e.outside=Be,e.prerelease=function(re,ae){var ue=W(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new be(re,ue),ae=new be(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof N)return re;if(typeof re!="string")return null;var ae=re.match(R[_]);return ae==null?null:W((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function(Y,e){var D,n,L=Y.exports={};function A(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function R(d){if(D===setTimeout)return setTimeout(d,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{n=typeof clearTimeout=="function"?clearTimeout:T}catch{n=T}})();var b,E=[],I=!1,C=-1;function f(){I&&b&&(I=!1,b.length?E=b.concat(E):C=-1,E.length&&y())}function y(){if(!I){var d=R(f);I=!0;for(var g=E.length;g;){for(b=E,E=[];++C<g;)b&&b[C].run();C=-1,g=E.length}b=null,I=!1,function(w){if(n===clearTimeout)return clearTimeout(w);if((n===T||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(w);try{n(w)}catch{try{return n.call(null,w)}catch{return n.call(this,w)}}}(d)}}function h(d,g){this.fun=d,this.array=g}function v(){}L.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)g[w-1]=arguments[w];E.push(new h(d,g)),E.length!==1||I||R(y)},h.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=v,L.addListener=v,L.once=v,L.off=v,L.removeListener=v,L.removeAllListeners=v,L.emit=v,L.prependListener=v,L.prependOnceListener=v,L.listeners=function(d){return[]},L.binding=function(d){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(d){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ne[104],ie([0,1]),function(Y,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(R,b,E){this.level=R,this.key=b,this.value=E,this.forward=[]}}const L=void 0;class A{constructor(R,b=2**16){this.comparator=R,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new n(this._maxLevel,L,L)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,L,L)}has(R){return Boolean(A._search(this,R,this.comparator))}get(R){return A._search(this,R,this.comparator)?.value}set(R,b){return A._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=A._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let E=this._header.forward[0];for(;E;)R.call(b,E.value,E.key,this),E=E.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,E){let I=R._header;for(let C=R._level-1;C>=0;C--)for(;I.forward[C]&&E(I.forward[C].key,b)<0;)I=I.forward[C];if(I=I.forward[0],I&&E(I.key,b)===0)return I}static _insert(R,b,E,I){let C=[],f=R._header;for(let y=R._level-1;y>=0;y--){for(;f.forward[y]&&I(f.forward[y].key,b)<0;)f=f.forward[y];C[y]=f}if(f=f.forward[0],f&&I(f.key,b)===0)return f.value=E,!1;{let y=A._randomLevel(R);if(y>R._level){for(let h=R._level;h<y;h++)C[h]=R._header;R._level=y}f=new n(y,b,E);for(let h=0;h<y;h++)f.forward[h]=C[h].forward[h],C[h].forward[h]=f;return!0}}static _randomLevel(R,b=.5){let E=1;for(;Math.random()<b&&E<R._maxLevel;)E+=1;return E}static _delete(R,b,E){let I=[],C=R._header;for(let f=R._level-1;f>=0;f--){for(;C.forward[f]&&E(C.forward[f].key,b)<0;)C=C.forward[f];I[f]=C}if(C=C.forward[0],!C||E(C.key,b)!==0)return!1;for(let f=0;f<R._level&&I[f].forward[f]===C;f++)I[f].forward[f]=C.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===L;)R._level-=1;return!0}}e.SkipList=A}),define(ne[105],ie([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class L{constructor(T){this._highResolution=n&&T,this._startTime=this._now(),this._stopTime=-1}static create(T=!0){return new L(T)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=L}),define(ne[3],ie([0,1,9,68,2,101,105]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(S){S.None=()=>L.Disposable.None;function l(K){return(x,q=null,X)=>{let H=!1,Z;return Z=K(ee=>{if(!H)return Z?Z.dispose():H=!0,x.call(q,ee)},null,X),H&&Z.dispose(),Z}}S.once=l;function r(K,x){return c((q,X=null,H)=>K(Z=>q.call(X,x(Z)),null,H))}S.map=r;function a(K,x){return c((q,X=null,H)=>K(Z=>{x(Z),q.call(X,Z)},null,H))}S.forEach=a;function i(K,x){return c((q,X=null,H)=>K(Z=>x(Z)&&q.call(X,Z),null,H))}S.filter=i;function t(K){return K}S.signal=t;function o(...K){return(x,q=null,X)=>(0,L.combinedDisposable)(...K.map(H=>H(Z=>x.call(q,Z),null,X)))}S.any=o;function s(K,x,q){let X=q;return r(K,H=>(X=x(X,H),X))}S.reduce=s;function c(K){let x;const q=new f({onFirstListenerAdd(){x=K(q.fire,q)},onLastListenerRemove(){x.dispose()}});return q.event}function u(K,x,q,X=100,H=!1){let Z,ee,W=0;return K(N=>{W++,Z=q(Z,N),H&&!ee&&(x(Z),Z=void 0),clearTimeout(ee),ee=setTimeout(()=>{const V=Z;Z=void 0,ee=void 0,(!H||W>1)&&x(V),W=0},X)})}S.debouncedListener=u;function p(K,x,q=100,X=!1,H){let Z,ee,W,N=0;const V=new f({leakWarningThreshold:H,onFirstListenerAdd(){Z=K(z=>{N++,ee=x(ee,z),X&&!W&&(V.fire(ee),ee=void 0),clearTimeout(W),W=setTimeout(()=>{const B=ee;ee=void 0,W=void 0,(!X||N>1)&&V.fire(B),N=0},q)})},onLastListenerRemove(){Z.dispose()}});return V.event}S.debounce=p;function P(K,x=(q,X)=>q===X){let q=!0,X;return i(K,H=>{const Z=q||!x(H,X);return q=!1,X=H,Z})}S.latch=P;function _(K,x){return[S.filter(K,x),S.filter(K,q=>!x(q))]}S.split=_;function O(K,x=!1,q=[]){let X=q.slice(),H=K(W=>{X?X.push(W):ee.fire(W)});const Z=()=>{X&&X.forEach(W=>ee.fire(W)),X=null},ee=new f({onFirstListenerAdd(){H||(H=K(W=>ee.fire(W)))},onFirstListenerDidAdd(){X&&(x?setTimeout(Z):Z())},onLastListenerRemove(){H&&H.dispose(),H=null}});return ee.event}S.buffer=O;class F{constructor(x){this.event=x}map(x){return new F(r(this.event,x))}forEach(x){return new F(a(this.event,x))}filter(x){return new F(i(this.event,x))}reduce(x,q){return new F(s(this.event,x,q))}latch(){return new F(P(this.event))}debounce(x,q=100,X=!1,H){return new F(p(this.event,x,q,X,H))}on(x,q,X){return this.event(x,q,X)}once(x,q,X){return l(this.event)(x,q,X)}}function $(K){return new F(K)}S.chain=$;function k(K,x,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>K.on(x,X),Z=()=>K.removeListener(x,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}S.fromNodeEventEmitter=k;function M(K,x,q=X=>X){const X=(...W)=>ee.fire(q(...W)),H=()=>K.addEventListener(x,X),Z=()=>K.removeEventListener(x,X),ee=new f({onFirstListenerAdd:H,onLastListenerRemove:Z});return ee.event}S.fromDOMEventEmitter=M;function j(K){return new Promise(x=>l(K)(x))}S.toPromise=j;function U(K,x){return x(void 0),K(q=>x(q))}S.runAndSubscribe=U;function G(K,x){let q=null;function X(Z){q?.dispose(),q=new L.DisposableStore,x(Z,q)}X(void 0);const H=K(Z=>X(Z));return(0,L.toDisposable)(()=>{H.dispose(),q?.dispose()})}S.runAndSubscribeWithStore=G})(R=e.Event||(e.Event={}));class b{constructor(l){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${l}_${b._idPool++}`}start(l){this._stopWatch=new T.StopWatch(!0),this._listenerCount=l}stop(){if(this._stopWatch){const l=this._stopWatch.elapsed();this._elapsedOverall+=l,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${l.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let E=-1;function I(S){const l=E;return E=S,{dispose(){E=l}}}e.setGlobalLeakWarningThreshold=I;class C{constructor(l,r=Math.random().toString(18).slice(2,5)){this.customThreshold=l,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(l){let r=E;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||l<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),i=this._stacks.get(a)||0;if(this._stacks.set(a,i+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,o=0;for(const[s,c]of this._stacks)(!t||o<c)&&(t=s,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${o}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(l){this._disposed=!1,this._options=l,this._leakageMon=E>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(l,r,a)=>{this._listeners||(this._listeners=new A.LinkedList);const i=this._listeners.isEmpty();i&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[l,r]:l);i&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,l,r);const o=this._leakageMon?.check(this._listeners.size),s=(0,L.toDisposable)(()=>{o&&o(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof L.DisposableStore?a.add(s):Array.isArray(a)&&a.push(s),s}),this._event}fire(l){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,l]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(i){(0,D.onUnexpectedError)(i)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class y extends f{async fireAsync(l,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const i of this._listeners)this._asyncDeliveryQueue.push([i,l]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[i,t]=this._asyncDeliveryQueue.shift(),o=[],s={...t,token:r,waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof i=="function"?i:i[0])),o.push(c)}};try{typeof i=="function"?i.call(void 0,s):i[0].call(i[1],s)}catch(c){(0,D.onUnexpectedError)(c);continue}Object.freeze(o),await Promise.allSettled(o).then(c=>{for(const u of c)u.status==="rejected"&&(0,D.onUnexpectedError)(u.reason)})}}}}e.AsyncEmitter=y;class h extends f{constructor(l){super(l);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=l?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const l=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(l))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(l){this._listeners&&(this._isPaused!==0?this._eventQueue.push(l):super.fire(l))}}e.PauseableEmitter=h;class v extends h{constructor(l){super(l);this._delay=l.delay??100}fire(l){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(l)}}e.DebounceEmitter=v;class d extends f{constructor(l){super(l);this._queuedEvents=[],this._mergeFn=l?.merge}fire(l){this._queuedEvents.push(l),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=d;class g{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(l){const r={event:l,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const i=this.events.indexOf(r);this.events.splice(i,1)};return(0,L.toDisposable)((0,n.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(l=>this.hook(l))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(l=>this.unhook(l))}hook(l){l.listener=l.event(r=>this.emitter.fire(r))}unhook(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=g;class w{constructor(){this.buffers=[]}wrapEvent(l){return(r,a,i)=>l(t=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>r.call(a,t)):r.call(a,t)},void 0,i)}bufferEvents(l){const r=[];this.buffers.push(r);const a=l();return this.buffers.pop(),r.forEach(i=>i()),a}}e.EventBufferer=w;class m{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=L.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(l){this.inputEvent=l,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=l(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=m}),define(ne[23],ie([0,1,3]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(R,b){const E=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(E)}}});var L;(function(R){function b(E){return E===R.None||E===R.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(L=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class T{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=L.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=T}),define(ne[106],ie([0,1,23]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class n{constructor(T){this.task=T,this.result=null}get(){if(this.result)return this.result;const T=new D.CancellationTokenSource,R=this.task(T.token);return this.result={promise:R,dispose:()=>{this.result=null,T.cancel(),T.dispose()}},this.result}}e.Cache=n;class L{constructor(T){this.computeFn=T,this.lastCache=void 0,this.lastArgKey=void 0}get(T){const R=JSON.stringify(T);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(T)),this.lastCache}}e.LRUCachedComputed=L}),define(ne[40],ie([0,1,9,2]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(m){const S=m;return S?[S.on,S.pause,S.resume,S.destroy].every(l=>typeof l=="function"):!1}e.isReadableStream=L;function A(m){const S=m;return S?L(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.isReadableBufferedStream=A;function T(m,S){return new R(m,S)}e.newWriteableStream=T;class R{constructor(S,l){this.reducer=S,this.options=l,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(S){if(!this.state.destroyed){if(this.state.flowing)this.emitData(S);else if(this.buffer.data.push(S),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(l=>this.pendingWritePromises.push(l))}}error(S){this.state.destroyed||(this.state.flowing?this.emitError(S):this.buffer.error.push(S))}end(S){this.state.destroyed||(typeof S!="undefined"&&this.write(S),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(S){this.listeners.data.slice(0).forEach(l=>l(S))}emitError(S){this.listeners.error.length===0?(0,D.onUnexpectedError)(S):this.listeners.error.slice(0).forEach(l=>l(S))}emitEnd(){this.listeners.end.slice(0).forEach(S=>S())}on(S,l){if(!this.state.destroyed)switch(S){case"data":this.listeners.data.push(l),this.resume();break;case"end":this.listeners.end.push(l),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(l),this.state.flowing&&this.flowErrors();break}}removeListener(S,l){if(this.state.destroyed)return;let r;switch(S){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(l);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const S=this.reducer(this.buffer.data);this.emitData(S),this.buffer.data.length=0;const l=[...this.pendingWritePromises];this.pendingWritePromises.length=0,l.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const S of this.buffer.error)this.emitError(S);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(m,S){const l=[];let r;for(;(r=m.read())!==null;)l.push(r);return S(l)}e.consumeReadable=b;function E(m,S,l){const r=[];let a;for(;(a=m.read())!==null&&r.length<l;)r.push(a);return a===null&&r.length>0?S(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const i=a;return a=void 0,i}return m.read()}}}e.peekReadable=E;function I(m,S){return new Promise((l,r)=>{const a=[];C(m,{onData:i=>{S&&a.push(i)},onError:i=>{S?r(i):l(void 0)},onEnd:()=>{l(S?S(a):void 0)}})})}e.consumeStream=I;function C(m,S){let l=!1;return m.on("error",r=>{l||S.onError(r)}),m.on("end",()=>{l||S.onEnd()}),m.on("data",r=>{l||S.onData(r)}),(0,n.toDisposable)(()=>l=!0)}e.listenStream=C;function f(m,S){return new Promise((l,r)=>{const a=new n.DisposableStore,i=[],t=c=>{if(i.push(c),i.length>S)return a.dispose(),m.pause(),l({stream:m,buffer:i,ended:!1})},o=c=>r(c),s=()=>l({stream:m,buffer:i,ended:!0});a.add((0,n.toDisposable)(()=>m.removeListener("error",o))),m.on("error",o),a.add((0,n.toDisposable)(()=>m.removeListener("end",s))),m.on("end",s),a.add((0,n.toDisposable)(()=>m.removeListener("data",t))),m.on("data",t)})}e.peekStream=f;function y(m,S){const l=T(S);return l.end(m),l}e.toStream=y;function h(){const m=T(()=>{throw new Error("not supported")});return m.end(),m}e.emptyStream=h;function v(m){let S=!1;return{read:()=>S?null:(S=!0,m)}}e.toReadable=v;function d(m,S,l){const r=T(l);return C(m,{onData:a=>r.write(S.data(a)),onError:a=>r.error(S.error?S.error(a):a),onEnd:()=>r.end()}),r}e.transform=d;function g(m,S,l){let r=!1;return{read:()=>{const a=S.read();return r?a:(r=!0,a!==null?l([m,a]):m)}}}e.prefixedReadable=g;function w(m,S,l){let r=!1;const a=T(l);return C(S,{onData:i=>r?a.write(i):(r=!0,a.write(l([m,i]))),onError:i=>a.error(i),onEnd:()=>{r||(r=!0,a.write(m)),a.end()}}),a}e.prefixedStream=w}),define(ne[17],ie([0,1,40]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let L,A;class T{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return n?new T(Buffer.allocUnsafe(u)):new T(new Uint8Array(u))}static wrap(u){return n&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new T(u)}static fromString(u,p){return!(p?.dontUseNodeBuffer||!1)&&n?new T(Buffer.from(u)):(L||(L=new TextEncoder),new T(L.encode(u)))}static fromByteArray(u){const p=T.alloc(u.length);for(let P=0,_=u.length;P<_;P++)p.buffer[P]=u[P];return p}static concat(u,p){if(typeof p=="undefined"){p=0;for(let O=0,F=u.length;O<F;O++)p+=u[O].byteLength}const P=T.alloc(p);let _=0;for(let O=0,F=u.length;O<F;O++){const $=u[O];P.set($,_),_+=$.byteLength}return P}clone(){const u=T.alloc(this.byteLength);return u.set(this),u}toString(){return n?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(u,p){return new T(this.buffer.subarray(u,p))}set(u,p){if(u instanceof T)this.buffer.set(u.buffer,p);else if(u instanceof Uint8Array)this.buffer.set(u,p);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),p);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),p);else throw new Error("Unkown argument 'array'")}readUInt32BE(u){return E(this.buffer,u)}writeUInt32BE(u,p){I(this.buffer,u,p)}readUInt32LE(u){return C(this.buffer,u)}writeUInt32LE(u,p){f(this.buffer,u,p)}readUInt8(u){return y(this.buffer,u)}writeUInt8(u,p){h(this.buffer,u,p)}}e.VSBuffer=T;function R(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=R;function b(c,u,p){c[p+0]=u&255,u=u>>>8,c[p+1]=u&255}e.writeUInt16LE=b;function E(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=E;function I(c,u,p){c[p+3]=u,u=u>>>8,c[p+2]=u,u=u>>>8,c[p+1]=u,u=u>>>8,c[p]=u}e.writeUInt32BE=I;function C(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=C;function f(c,u,p){c[p+0]=u&255,u=u>>>8,c[p+1]=u&255,u=u>>>8,c[p+2]=u&255,u=u>>>8,c[p+3]=u&255}e.writeUInt32LE=f;function y(c,u){return c[u]}e.readUInt8=y;function h(c,u,p){c[p]=u}e.writeUInt8=h;function v(c){return D.consumeReadable(c,u=>T.concat(u))}e.readableToBuffer=v;function d(c){return D.toReadable(c)}e.bufferToReadable=d;function g(c){return D.consumeStream(c,u=>T.concat(u))}e.streamToBuffer=g;async function w(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await g(c.stream)])}e.bufferedStreamToBuffer=w;function m(c){return D.toStream(c,u=>T.concat(u))}e.bufferToStream=m;function S(c){return D.transform(c,{data:u=>typeof u=="string"?T.fromString(u):T.wrap(u)},u=>T.concat(u))}e.streamToBufferReadableStream=S;function l(c){return D.newWriteableStream(u=>T.concat(u),c)}e.newWriteableBufferStream=l;function r(c,u){return D.prefixedReadable(c,u,p=>T.concat(p))}e.prefixedBufferReadable=r;function a(c,u){return D.prefixedStream(c,u,p=>T.concat(p))}e.prefixedBufferStream=a;function i(c){let u=0,p=0,P=0;const _=new Uint8Array(Math.floor(c.length/4*3)),O=$=>{switch(p){case 3:_[P++]=u|$,p=0;break;case 2:_[P++]=u|$>>>2,u=$<<6,p=3;break;case 1:_[P++]=u|$>>>4,u=$<<4,p=2;break;default:u=$<<2,p=1}};for(let $=0;$<c.length;$++){const k=c.charCodeAt($);if(k>=65&&k<=90)O(k-65);else if(k>=97&&k<=122)O(k-97+26);else if(k>=48&&k<=57)O(k-48+52);else if(k===43||k===45)O(62);else if(k===47||k===95)O(63);else{if(k===61)break;throw new SyntaxError(`Unexpected base64 character ${c[$]}`)}}const F=P;for(;p>0;)O(0);return T.wrap(_).slice(0,F)}e.decodeBase64=i;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function s({buffer:c},u=!0,p=!1){const P=p?o:t;let _="";const O=c.byteLength%3;let F=0;for(;F<c.byteLength-O;F+=3){const $=c[F+0],k=c[F+1],M=c[F+2];_+=P[$>>>2],_+=P[($<<4|k>>>4)&63],_+=P[(k<<2|M>>>6)&63],_+=P[M&63]}if(O===1){const $=c[F+0];_+=P[$>>>2],_+=P[$<<4&63],u&&(_+="==")}else if(O===2){const $=c[F+0],k=c[F+1];_+=P[$>>>2],_+=P[($<<4|k>>>4)&63],_+=P[k<<2&63],u&&(_+="=")}return _}e.encodeBase64=s}),define(ne[26],ie([0,1,106,100]),function(Y,e,D,n){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function A(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=A;const T=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(T,function(le,fe){const ge=parseInt(fe,10);return isNaN(ge)||ge<0||ge>=oe.length?le:oe[ge]})}e.format=R;const b=/{([^}]+)}/g;function E(Q,oe){return Q.replace(b,(le,fe)=>oe[fe]??le)}e.format2=E;function I(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=I;function C(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function f(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let ge=Q.length-1;ge>=0;ge--)Q.charCodeAt(ge)===fe&&le++;return le}e.count=f;function y(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=y;function h(Q,oe=" "){const le=v(Q,oe);return d(le,oe)}e.trim=h;function v(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=v;function d(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let ge=fe,Le=-1;for(;Le=Q.lastIndexOf(oe,ge-1),!(Le===-1||Le+le!==ge);){if(Le===0)return"";ge=Le}return Q.substring(0,ge)}e.rtrim=d;function g(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function m(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=C(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=m;function S(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function l(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function i(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=i;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const ge=Q.charCodeAt(fe);if(ge!==32&&ge!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function o(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=o;function s(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=s;function c(Q,oe,le=0,fe=Q.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(ge);if(ke<Ie)return-1;if(ke>Ie)return 1}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstring=c;function u(Q,oe){return p(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=u;function p(Q,oe,le=0,fe=Q.length,ge=0,Le=oe.length){for(;le<fe&&ge<Le;le++,ge++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(ge);if(ke===Ie)continue;if(ke>=128||Ie>=128)return c(Q.toLowerCase(),oe.toLowerCase(),le,fe,ge,Le);P(ke)&&(ke-=32),P(Ie)&&(Ie-=32);const Ae=ke-Ie;if(Ae!==0)return Ae}const Se=fe-le,De=Le-ge;return Se<De?-1:Se>De?1:0}e.compareSubstringIgnoreCase=p;function P(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=P;function _(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=_;function O(Q,oe){return Q.length===oe.length&&p(Q,oe)===0}e.equalsIgnoreCase=O;function F(Q,oe){const le=oe.length;return oe.length>Q.length?!1:p(Q,oe,0,le)===0}e.startsWithIgnoreCase=F;function $(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=$;function k(Q,oe){let le,fe=Math.min(Q.length,oe.length);const ge=Q.length-1,Le=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(ge-le)!==oe.charCodeAt(Le-le))return le;return fe}e.commonSuffixLength=k;function M(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=M;function j(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=j;function U(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=U;function G(Q,oe,le){const fe=Q.charCodeAt(le);if(M(fe)&&le+1<oe){const ge=Q.charCodeAt(le+1);if(j(ge))return U(fe,ge)}return fe}e.getNextCodePoint=G;function K(Q,oe){const le=Q.charCodeAt(oe-1);if(j(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(M(fe))return U(fe,le)}return le}class x{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=K(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=G(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=x;class q{constructor(oe,le=0){this._iterator=new x(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Le=le.offset,Se=oe.getGraphemeBreakType(le.nextCodePoint());if(Be(ge,Se)){le.setOffset(Le);break}ge=Se}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let ge=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Le=le.offset,Se=oe.getGraphemeBreakType(le.prevCodePoint());if(Be(Se,ge)){le.setOffset(Le);break}ge=Se}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function X(Q,oe){return new q(Q,oe).nextGraphemeLength()}e.nextCharLength=X;function H(Q,oe){return new q(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&j(Q.charCodeAt(oe))&&oe--;const le=oe+X(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(Q){return ee.test(Q)}e.containsRTL=W;const N=/^[\t\n\r\x20-\x7E]*$/;function V(Q){return N.test(Q)}e.isBasicASCII=V,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=z;function B(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=B;function te(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=te;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function pe(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(ve,"")),Q}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ee(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ee;function Ce(Q){return Ee(Q)?Q.substr(1):Q}e.stripUTF8BOM=Ce;function we(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let ge=0,Le=-1;for(;ge<le;){const Se=fe.indexOf(oe[ge],Le+1);if(Se<0)return!1;Le=Se,ge++}return!0}e.fuzzyContains=we;function be(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=be;function Re(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=Re;function Fe(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=Fe;function Ue(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Ue;function qe(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=qe;function Be(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let ge=1;for(;ge<=fe;)if(oe<le[3*ge])ge=2*ge;else if(oe>le[3*ge+1])ge=2*ge+1;else return le[3*ge+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ye(Q,oe){if(Q===0)return 0;const le=Pe(Q,oe);if(le!==void 0)return le;const fe=new x(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=ye;function Pe(Q,oe){const le=new x(oe,Q);let fe=le.prevCodePoint();for(;Ne(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!te(fe))return;let ge=le.offset;return ge>0&&le.prevCodePoint()===8205&&(ge=le.offset),ge}function Ne(Q){return 127995<=Q&&Q<=127999}var Te;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.noBreakWhitespace="\xA0";class Oe{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Oe.cache.get(Array.from(oe))}static getLocales(){return Oe._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Oe,L=Oe,Oe.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.cache=new D.LRUCachedComputed(Q=>{function oe(Ie){const Ae=new Map;for(let $e=0;$e<Ie.length;$e+=2)Ae.set(Ie[$e],Ie[$e+1]);return Ae}function le(Ie,Ae){const $e=new Map(Ie);for(const[je,xe]of Ae)$e.set(je,xe);return $e}function fe(Ie,Ae){if(!Ie)return Ae;const $e=new Map;for(const[je,xe]of Ie)Ae.has(je)&&$e.set(je,xe);return $e}const ge=L.ambiguousCharacterData.getValue();let Le=Q.filter(Ie=>!Ie.startsWith("_")&&Ie in ge);Le.length===0&&(Le=["_default"]);let Se;for(const Ie of Le){const Ae=oe(ge[Ie]);Se=fe(Se,Ae)}const De=oe(ge._common),ke=le(De,Se);return new Oe(ke)}),Oe._locales=new n.Lazy(()=>Object.keys(Oe.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class _e{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(_e.getRawData())),this._data}static isInvisibleCharacter(oe){return _e.getData().has(oe)}static get codePoints(){return _e.getData()}}e.InvisibleCharacters=_e,_e._data=void 0}),define(ne[70],ie([0,1,26]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(g){return L(g,0)}e.hash=n;function L(g,w){switch(typeof g){case"object":return g===null?A(349,w):Array.isArray(g)?b(g,w):E(g,w);case"string":return R(g,w);case"boolean":return T(g,w);case"number":return A(g,w);case"undefined":return A(937,w);default:return A(617,w)}}e.doHash=L;function A(g,w){return(w<<5)-w+g|0}e.numberHash=A;function T(g,w){return A(g?433:863,w)}function R(g,w){w=A(149417,w);for(let m=0,S=g.length;m<S;m++)w=A(g.charCodeAt(m),w);return w}e.stringHash=R;function b(g,w){return w=A(104579,w),g.reduce((m,S)=>L(S,m),w)}function E(g,w){return w=A(181387,w),Object.keys(g).sort().reduce((m,S)=>(m=R(S,m),L(g[S],m)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=L(w,this._value),this._value}}e.Hasher=I;var C;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function f(g,w,m=32){const S=m-w,l=~((1<<S)-1);return(g<<w|(l&g)>>>S)>>>0}function y(g,w=0,m=g.byteLength,S=0){for(let l=0;l<m;l++)g[w+l]=S}function h(g,w,m="0"){for(;g.length<w;)g=m+g;return g}function v(g,w=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(m=>m.toString(16).padStart(2,"0")).join(""):h((g>>>0).toString(16),w/4)}e.toHexString=v;class d{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const m=w.length;if(m===0)return;const S=this._buff;let l=this._buffLen,r=this._leftoverHighSurrogate,a,i;for(r!==0?(a=r,i=-1,r=0):(a=w.charCodeAt(0),i=0);;){let t=a;if(D.isHighSurrogate(a))if(i+1<m){const o=w.charCodeAt(i+1);D.isLowSurrogate(o)?(i++,t=D.computeCodePoint(a,o)):t=65533}else{r=a;break}else D.isLowSurrogate(a)&&(t=65533);if(l=this._push(S,l,t),i++,i<m)a=w.charCodeAt(i);else break}this._buffLen=l,this._leftoverHighSurrogate=r}_push(w,m,S){return S<128?w[m++]=S:S<2048?(w[m++]=192|(S&1984)>>>6,w[m++]=128|(S&63)>>>0):S<65536?(w[m++]=224|(S&61440)>>>12,w[m++]=128|(S&4032)>>>6,w[m++]=128|(S&63)>>>0):(w[m++]=240|(S&1835008)>>>18,w[m++]=128|(S&258048)>>>12,w[m++]=128|(S&4032)>>>6,w[m++]=128|(S&63)>>>0),m>=64&&(this._step(),m-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),m}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),v(this._h0)+v(this._h1)+v(this._h2)+v(this._h3)+v(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=d._bigBlock32,m=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,m.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,f(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let S=this._h0,l=this._h1,r=this._h2,a=this._h3,i=this._h4,t,o,s;for(let c=0;c<80;c++)c<20?(t=l&r|~l&a,o=1518500249):c<40?(t=l^r^a,o=1859775393):c<60?(t=l&r|l&a|r&a,o=2400959708):(t=l^r^a,o=3395469782),s=f(S,5)+t+i+o+w.getUint32(c*4,!1)&4294967295,i=a,a=r,r=f(l,30),l=S,S=s;this._h0=this._h0+S&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+i&4294967295}}e.StringSHA1=d,d._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(Y,e,D,n,L){if(n==="m")throw new TypeError("Private method is not writable");if(n==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Y!==e||!L:!e.has(Y))throw new TypeError("Cannot write private member to an object whose class did not declare it");return n==="a"?L.call(Y,D):L?L.value=D:e.set(Y,D),D},Ke=this&&this.__classPrivateFieldGet||function(Y,e,D,n){if(D==="a"&&!n)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Y!==e||!n:!e.has(Y))throw new TypeError("Cannot read private member from an object whose class did not declare it");return D==="m"?n:D==="a"?n.call(Y):n?n.value:e.get(Y)};define(ne[39],ie([0,1,16,26]),function(Y,e,D,n){"use strict";var L,A,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(i,t,o){let s=i.get(t);return s===void 0&&(s=o,i.set(t,s)),s}e.getOrSet=R;function b(i){const t=[];return i.forEach((o,s)=>{t.push(`${s} => ${o}`)}),`Map(${i.size}) {${t.join(", ")}}`}e.mapToString=b;function E(i){const t=[];return i.forEach(o=>{t.push(o)}),`Set(${i.size}) {${t.join(", ")}}`}e.setToString=E;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const o=t.charCodeAt(0),s=this._value.charCodeAt(this._pos);return o-s}value(){return this._value[this._pos]}}e.StringIterator=I;class C{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class f{constructor(t=!0,o=!0){this._splitOnBackslash=t,this._caseSensitive=o}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let o=t.length-1;o>=0;o--,this._valueLen--){const s=this._value.charCodeAt(o);if(!(s===47||this._splitOnBackslash&&s===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,n.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var y;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(y||(y={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,n.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(i){i[i.Left=-1]="Left",i[i.Mid=0]="Mid",i[i.Right=1]="Right"})(d||(d={}));class g{constructor(t){this._iter=t}static forUris(t=()=>!1){return new g(new h(t))}static forPaths(t=!1){return new g(new f(void 0,!t))}static forStrings(){return new g(new I)}static forConfigKeys(){return new g(new C)}clear(){this._root=void 0}fill(t,o){if(o){const s=o.slice(0);(0,D.shuffle)(s);for(let c of s)this.set(c,t)}else{const s=t.slice(0);(0,D.shuffle)(s);for(let c of s)this.set(c[0],c[1])}}set(t,o){const s=this._iter.reset(t);let c;this._root||(this._root=new v,this._root.segment=s.value());const u=[];for(c=this._root;;){const P=s.cmp(c.segment);if(P>0)c.left||(c.left=new v,c.left.segment=s.value()),u.push([-1,c]),c=c.left;else if(P<0)c.right||(c.right=new v,c.right.segment=s.value()),u.push([1,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new v,c.mid.segment=s.value()),u.push([0,c]),c=c.mid;else break}const p=c.value;c.value=o,c.key=t;for(let P=u.length-1;P>=0;P--){const _=u[P][1];_.updateHeight();const O=_.balanceFactor();if(O<-1||O>1){const F=u[P][0],$=u[P+1][0];if(F===1&&$===1)u[P][1]=_.rotateLeft();else if(F===-1&&$===-1)u[P][1]=_.rotateRight();else if(F===1&&$===-1)_.right=u[P+1][1]=u[P+1][1].rotateRight(),u[P][1]=_.rotateLeft();else if(F===-1&&$===1)_.left=u[P+1][1]=u[P+1][1].rotateLeft(),u[P][1]=_.rotateRight();else throw new Error;if(P>0)switch(u[P-1][0]){case-1:u[P-1][1].left=u[P][1];break;case 1:u[P-1][1].right=u[P][1];break;case 0:u[P-1][1].mid=u[P][1];break}else this._root=u[0][1]}}return p}get(t){return this._getNode(t)?.value}_getNode(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const c=o.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else break}return s}has(t){const o=this._getNode(t);return!(o?.value===void 0&&o?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,o){const s=this._iter.reset(t),c=[];let u=this._root;for(;u;){const p=s.cmp(u.segment);if(p>0)c.push([-1,u]),u=u.left;else if(p<0)c.push([1,u]),u=u.right;else if(s.hasNext())s.next(),c.push([0,u]),u=u.mid;else break}if(!!u){if(o?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const p=this._min(u.right),{key:P,value:_,segment:O}=p;this._delete(p.key,!1),u.key=P,u.value=_,u.segment=O}else{const p=u.left??u.right;if(c.length>0){const[P,_]=c[c.length-1];switch(P){case-1:_.left=p;break;case 0:_.mid=p;break;case 1:_.right=p;break}}else this._root=p}for(let p=c.length-1;p>=0;p--){const P=c[p][1];P.updateHeight();const _=P.balanceFactor();if(_>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),c[p][1]=P.rotateLeft()):_<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),c[p][1]=P.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const o=this._iter.reset(t);let s=this._root,c;for(;s;){const u=o.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(o.hasNext())o.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(t){const o=this._iter.reset(t);let s=this._root;for(;s;){const c=o.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(o.hasNext())o.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(t){for(const[o,s]of this)t(s,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=o=>{if(!o)return!0;const s=o.balanceFactor();return s<-1||s>1?!1:t(o.left)&&t(o.right)};return t(this._root)}}e.TernarySearchTree=g;class w{constructor(t,o){this.uri=t,this.value=o}}class m{constructor(t,o){this[L]="ResourceMap",t instanceof m?(this.map=new Map(t.map),this.toKey=o??m.defaultToKey):(this.map=new Map,this.toKey=t??m.defaultToKey)}set(t,o){return this.map.set(this.toKey(t),new w(t,o)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,o){typeof o!="undefined"&&(t=t.bind(o));for(let[s,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=m,m.defaultToKey=i=>i.toString();var S;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class l{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,o=0){const s=this._map.get(t);if(!!s)return o!==0&&this.touch(s,o),s.value}set(t,o,s=0){let c=this._map.get(t);if(c)c.value=o,s!==0&&this.touch(c,s);else{switch(c={key:t,value:o,next:void 0,previous:void 0},s){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this._map.get(t);if(!!o)return this._map.delete(t),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,o){const s=this._state;let c=this._head;for(;c;){if(o?t.bind(o)(c.value,c.key,this):t(c.value,c.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.key,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return c}values(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:s.value,done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return c}entries(){const t=this,o=this._state;let s=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==o)throw new Error("LinkedMap got modified during iteration.");if(s){const u={value:[s.key,s.value],done:!1};return s=s.next,u}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this._head,s=this.size;for(;o&&s>t;)this._map.delete(o.key),o=o.next,s--;this._head=o,this._size=s,o&&(o.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const o=t.next,s=t.previous;if(!o||!s)throw new Error("Invalid list");o.previous=s,s.next=o}t.next=void 0,t.previous=void 0,this._state++}touch(t,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this._head)return;const s=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(s.previous=c,c.next=s),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(o===2){if(t===this._tail)return;const s=t.next,c=t.previous;t===this._head?(s.previous=void 0,this._head=s):(s.previous=c,c.next=s),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((o,s)=>{t.push([s,o])}),t}fromJSON(t){this.clear();for(const[o,s]of t)this.set(o,s)}}e.LinkedMap=l;class r extends l{constructor(t,o=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){T.set(this,void 0),Pt(this,T,t,"f")}get size(){return Ke(this,T,"f").size}forEach(t,o){Ke(this,T,"f").forEach(t,o)}get(t){return Ke(this,T,"f").get(t)}has(t){return Ke(this,T,"f").has(t)}entries(){return Ke(this,T,"f").entries()}keys(){return Ke(this,T,"f").keys()}values(){return Ke(this,T,"f").values()}[(T=new WeakMap,Symbol.iterator)](){return Ke(this,T,"f").entries()}}e.ReadonlyMapView=a}),define(ne[71],ie([0,1,39]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function L(E){return b(E,"NFC",n)}e.normalizeNFC=L;const A=new D.LRUCache(1e4);function T(E){return b(E,"NFD",A)}e.normalizeNFD=T;const R=/[^\u0000-\u0080]/;function b(E,I,C){if(!E)return E;const f=C.get(E);if(f)return f;let y;return R.test(E)?y=E.normalize(I):y=E,C.set(E,y),y}e.removeAccents=function(){const E=/[\u0300-\u036f]/g;return function(I){return T(I).replace(E,"")}}()}),define(ne[14],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function D(u){return Array.isArray(u)}e.isArray=D;function n(u){return typeof u=="string"}e.isString=n;function L(u){return Array.isArray(u)&&u.every(p=>n(p))}e.isStringArray=L;function A(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=A;function T(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=T;function R(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=R;function b(u){return u===!0||u===!1}e.isBoolean=b;function E(u){return typeof u=="undefined"}e.isUndefined=E;function I(u){return!C(u)}e.isDefined=I;function C(u){return E(u)||u===null}e.isUndefinedOrNull=C;function f(u,p){if(!u)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=f;function y(u){if(C(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=y;function h(...u){const p=[];for(let P=0;P<u.length;P++){const _=u[P];if(C(_))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);p.push(_)}return p}e.assertAllDefined=h;const v=Object.prototype.hasOwnProperty;function d(u){if(!A(u))return!1;for(let p in u)if(v.call(u,p))return!1;return!0}e.isEmptyObject=d;function g(u){return typeof u=="function"}e.isFunction=g;function w(...u){return u.length>0&&u.every(g)}e.areFunctions=w;function m(u,p){const P=Math.min(u.length,p.length);for(let _=0;_<P;_++)S(u[_],p[_])}e.validateConstraints=m;function S(u,p){if(n(p)){if(typeof u!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(g(p)){try{if(u instanceof p)return}catch{}if(!C(u)&&u.constructor===p||p.length===1&&p.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function l(u){let p=[],P=Object.getPrototypeOf(u);for(;Object.prototype!==P;)p=p.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return p}e.getAllPropertyNames=l;function r(u){const p=[];for(const P of l(u))typeof u[P]=="function"&&p.push(P);return p}e.getAllMethodNames=r;function a(u,p){const P=O=>function(){const F=Array.prototype.slice.call(arguments,0);return p(O,F)};let _={};for(const O of u)_[O]=P(O);return _}e.createProxyObject=a;function i(u){return u===null?void 0:u}e.withNullAsUndefined=i;function t(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=t;function o(u){return class{constructor(){return new Proxy({},{get(p,P){if(p[P])return p[P];throw new Error(`Not Implemented: ${u}->${String(P)}`)}})}}}e.NotImplementedProxy=o;function s(u,p="Unreachable"){throw new Error(p)}e.assertNever=s;function c(u){return!!u&&typeof u.then=="function"&&typeof u.catch=="function"}e.isPromise=c}),define(ne[41],ie([0,1,10,4,26,14]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function R(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=R;function b(o){return o.indexOf("/")===-1&&(o=R(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=b;function E(o,s=D.posix.sep){if(!o)return"";const c=o.length,u=o.charCodeAt(0);if(T(u)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let P=3;const _=P;for(;P<c&&!T(o.charCodeAt(P));P++);if(_!==P&&!T(o.charCodeAt(P+1))){for(P+=1;P<c;P++)if(T(o.charCodeAt(P)))return o.slice(0,P+1).replace(/[\\/]/g,s)}}return s}else if(g(u)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+s:o.slice(0,2);let p=o.indexOf("://");if(p!==-1){for(p+=3;p<c;p++)if(T(o.charCodeAt(p)))return o.slice(0,p+1)}return""}e.getRoot=E;function I(o){if(!n.isWindows||!o||o.length<5)return!1;let s=o.charCodeAt(0);if(s!==92||(s=o.charCodeAt(1),s!==92))return!1;let c=2;const u=c;for(;c<o.length&&(s=o.charCodeAt(c),s!==92);c++);return!(u===c||(s=o.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=I;const C=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(o,s=n.isWindows){const c=s?C:f;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||s&&y.test(o)||o==="."||o===".."||s&&o[o.length-1]==="."||s&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=h;function v(o,s,c){const u=o===s;return!c||u?u:!o||!s?!1:(0,L.equalsIgnoreCase)(o,s)}e.isEqual=v;function d(o,s,c,u=D.sep){if(o===s)return!0;if(!o||!s||s.length>o.length)return!1;if(c){if(!(0,L.startsWithIgnoreCase)(o,s))return!1;if(s.length===o.length)return!0;let P=s.length;return s.charAt(s.length-1)===u&&P--,o.charAt(P)===u}return s.charAt(s.length-1)!==u&&(s+=u),o.indexOf(s)===0}e.isEqualOrParent=d;function g(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=g;function w(o,s){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(s,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,L.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,L.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=w;function m(o){const s=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:S(s)&&(o.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=m;function S(o,s){return(s!==void 0?s:n.isWindows)?g(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function l(o){return S(o)?o[0]:void 0}e.getDriveLetter=l;function r(o,s,c){return s.length>o.length?-1:o===s?0:(c&&(o=o.toLowerCase(),s=s.toLowerCase()),o.indexOf(s))}e.indexOfPath=r;function a(o){const s=o.split(":");let c,u,p;for(const P of s){const _=Number(P);(0,A.isNumber)(_)?u===void 0?u=_:p===void 0&&(p=_):c=c?[c,P].join(":"):P}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:u!==void 0?u:void 0,column:p!==void 0?p:u!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(o,s,c=8){let u="";for(let P=0;P<c;P++)u+=i.charAt(Math.floor(Math.random()*i.length));let p;return s?p=`${s}-${u}`:p=u,o?(0,D.join)(o,p):p}e.randomPath=t}),define(ne[28],ie([0,1,14]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(v){if(!v||typeof v!="object"||v instanceof RegExp)return v;const d=Array.isArray(v)?[]:{};return Object.keys(v).forEach(g=>{v[g]&&typeof v[g]=="object"?d[g]=n(v[g]):d[g]=v[g]}),d}e.deepClone=n;function L(v){if(!v||typeof v!="object")return v;const d=[v];for(;d.length>0;){const g=d.shift();Object.freeze(g);for(const w in g)if(A.call(g,w)){const m=g[w];typeof m=="object"&&!Object.isFrozen(m)&&d.push(m)}}return v}e.deepFreeze=L;const A=Object.prototype.hasOwnProperty;function T(v,d){return R(v,d,new Set)}e.cloneAndChange=T;function R(v,d,g){if((0,D.isUndefinedOrNull)(v))return v;const w=d(v);if(typeof w!="undefined")return w;if((0,D.isArray)(v)){const m=[];for(const S of v)m.push(R(S,d,g));return m}if((0,D.isObject)(v)){if(g.has(v))throw new Error("Cannot clone recursive data-structure");g.add(v);const m={};for(let S in v)A.call(v,S)&&(m[S]=R(v[S],d,g));return g.delete(v),m}return v}function b(v,d,g=!0){return(0,D.isObject)(v)?((0,D.isObject)(d)&&Object.keys(d).forEach(w=>{w in v?g&&((0,D.isObject)(v[w])&&(0,D.isObject)(d[w])?b(v[w],d[w],g):v[w]=d[w]):v[w]=d[w]}),v):d}e.mixin=b;function E(v,d){if(v===d)return!0;if(v==null||d===null||d===void 0||typeof v!=typeof d||typeof v!="object"||Array.isArray(v)!==Array.isArray(d))return!1;let g,w;if(Array.isArray(v)){if(v.length!==d.length)return!1;for(g=0;g<v.length;g++)if(!E(v[g],d[g]))return!1}else{const m=[];for(w in v)m.push(w);m.sort();const S=[];for(w in d)S.push(w);if(S.sort(),!E(m,S))return!1;for(g=0;g<m.length;g++)if(!E(v[m[g]],d[m[g]]))return!1}return!0}e.equals=E;function I(v){const d=new Set;return JSON.stringify(v,(g,w)=>{if((0,D.isObject)(w)||Array.isArray(w)){if(d.has(w))return"[Circular]";d.add(w)}return w})}e.safeStringify=I;function C(v,d,g){const w=d(v);return typeof w=="undefined"?g:w}e.getOrDefault=C;function f(v,d){const g=Object.create(null);return!v||!d||Object.keys(d).forEach(m=>{const S=v[m],l=d[m];E(S,l)||(g[m]=l)}),g}e.distinct=f;function y(v,d){const g=d.toLowerCase(),w=Object.keys(v).find(m=>m.toLowerCase()===g);return w?v[w]:v[d]}e.getCaseInsensitive=y;function h(v,d){const g=Object.create(null);for(const[w,m]of Object.entries(v))d(w,m)&&(g[w]=m);return g}e.filter=h}),define(ne[7],ie([0,1,10,4]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,T=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,t){return!i&&!t?"file":i}function E(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==C&&(t=C+t):t=C;break}return t}const I="",C="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(t,o,s,c,u,p=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=b(t,p),this.authority=o||I,this.path=E(this.scheme,s||I),this.query=c||I,this.fragment=u||I,R(this,p))}static isUri(t){return t instanceof y?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return m(this,!1)}with(t){if(!t)return this;let{scheme:o,authority:s,path:c,query:u,fragment:p}=t;return o===void 0?o=this.scheme:o===null&&(o=I),s===void 0?s=this.authority:s===null&&(s=I),c===void 0?c=this.path:c===null&&(c=I),u===void 0?u=this.query:u===null&&(u=I),p===void 0?p=this.fragment:p===null&&(p=I),o===this.scheme&&s===this.authority&&c===this.path&&u===this.query&&p===this.fragment?this:new v(o,s,c,u,p)}static parse(t,o=!1){const s=f.exec(t);return s?new v(s[2]||I,a(s[4]||I),a(s[5]||I),a(s[7]||I),a(s[9]||I),o):new v(I,I,I,I,I)}static file(t){let o=I;if(n.isWindows&&(t=t.replace(/\\/g,C)),t[0]===C&&t[1]===C){const s=t.indexOf(C,2);s===-1?(o=t.substring(2),t=C):(o=t.substring(2,s),t=t.substring(s)||C)}return new v("file",o,t,I,I)}static from(t){const o=new v(t.scheme,t.authority,t.path,t.query,t.fragment);return R(o,!0),o}static joinPath(t,...o){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let s;return n.isWindows&&t.scheme==="file"?s=y.file(D.win32.join(m(t,!0),...o)).path:s=D.posix.join(t.path,...o),t.with({path:s})}toString(t=!1){return S(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof y)return t;{const o=new v(t);return o._formatted=t.external,o._fsPath=t._sep===h?t.fsPath:null,o}}else return t}}e.URI=y;const h=n.isWindows?1:void 0;class v extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(t=!1){return t?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,t){let o,s=-1;for(let c=0;c<i.length;c++){const u=i.charCodeAt(c);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47)s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o!==void 0&&(o+=i.charAt(c));else{o===void 0&&(o=i.substr(0,c));const p=d[u];p!==void 0?(s!==-1&&(o+=encodeURIComponent(i.substring(s,c)),s=-1),o+=p):s===-1&&(s=c)}}return s!==-1&&(o+=encodeURIComponent(i.substring(s))),o!==void 0?o:i}function w(i){let t;for(let o=0;o<i.length;o++){const s=i.charCodeAt(o);s===35||s===63?(t===void 0&&(t=i.substr(0,o)),t+=d[s]):t!==void 0&&(t+=i[o])}return t!==void 0?t:i}function m(i,t){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=m;function S(i,t){const o=t?w:g;let s="",{scheme:c,authority:u,path:p,query:P,fragment:_}=i;if(c&&(s+=c,s+=":"),(u||c==="file")&&(s+=C,s+=C),u){let O=u.indexOf("@");if(O!==-1){const F=u.substr(0,O);u=u.substr(O+1),O=F.indexOf(":"),O===-1?s+=o(F,!1):(s+=o(F.substr(0,O),!1),s+=":",s+=o(F.substr(O+1),!1)),s+="@"}u=u.toLowerCase(),O=u.indexOf(":"),O===-1?s+=o(u,!1):(s+=o(u.substr(0,O),!1),s+=u.substr(O))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const O=p.charCodeAt(1);O>=65&&O<=90&&(p=`/${String.fromCharCode(O+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const O=p.charCodeAt(0);O>=65&&O<=90&&(p=`${String.fromCharCode(O+32)}:${p.substr(2)}`)}s+=o(p,!0)}return P&&(s+="?",s+=o(P,!1)),_&&(s+="#",s+=t?_:g(_,!1)),s}function l(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+l(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(r)?i.replace(r,t=>l(t)):i}}),define(ne[107],ie([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(E){const I=E;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=n;function L(E){const I=[];let C;try{const f=JSON.parse(E.arguments),y=f[f.length-1];y&&y.__$stack&&(f.pop(),C=y.__$stack),I.push(...f)}catch{I.push("Unable to log remote console arguments",E.arguments)}return{args:I,stack:C}}e.parse=L;function A(E){if(typeof E!="string")return A(L(E).stack);const I=E;if(I){const C=T(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(f&&f.length===4)return{uri:D.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=A;function T(E){if(!E)return E;const I=E.indexOf(`
`);return I===-1?E:E.substring(0,I)}function R(E,I){const{args:C,stack:f}=L(E),y=typeof C[0]=="string"&&C.length===1;let h=T(f);h&&(h=`(${h.trim()})`);let v=[];if(typeof C[0]=="string"?h&&y?v=[`%c[${I}] %c${C[0]} %c${h}`,b("blue"),b(""),b("grey")]:v=[`%c[${I}] %c${C[0]}`,b("blue"),b(""),...C.slice(1)]:v=[`%c[${I}]%`,b("blue"),...C],h&&!y&&v.push(h),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,v)}e.log=R;function b(E){return`color: ${E}`}}),define(ne[108],ie([0,1,17,26,7]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(I){return JSON.stringify(I,b)}e.stringify=A;function T(I){let C=JSON.parse(I);return C=E(C),C}e.parse=T;var R;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext",I[I.Date=14]="Date"})(R=e.MarshalledId||(e.MarshalledId={}));function b(I,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,n.regExpFlags)(C)}:C}function E(I,C=0){if(!I||C>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return L.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let f=0;f<I.length;++f)I[f]=E(I[f],C+1);else for(const f in I)Object.hasOwnProperty.call(I,f)&&(I[f]=E(I[f],C+1))}return I}e.revive=E}),define(ne[18],ie([0,1,4,7]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(L=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,E,I){this._hosts[b]=E,this._ports[b]=I}setConnectionToken(b,E){this._connectionTokens[b]=E}rewrite(b){if(this._delegate)return this._delegate(b);const E=b.authority;let I=this._hosts[E];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const C=this._ports[E],f=this._connectionTokens[E];let y=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(y+=`&tkn=${encodeURIComponent(f)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${I}:${C}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new A;class T{asBrowserUri(b,E){const I=this.toUri(b,E);return I.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===L.file&&(D.isNative||typeof D.globals.importScripts=="function"&&D.globals.origin===`${L.vscodeFileResource}://${T.FALLBACK_AUTHORITY}`)?I.with({scheme:L.vscodeFileResource,authority:I.authority||T.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(b,E){const I=this.toUri(b,E);return I.scheme===L.vscodeFileResource?I.with({scheme:L.file,authority:I.authority!==T.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(b,E){return n.URI.isUri(b)?b:n.URI.parse(E.toUrl(b))}}T.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new T}),define(ne[19],ie([0,1,41,18,10,4,26,7]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(y){return(0,R.uriToFsPath)(y,!0)}e.originalFSPath=b;class E{constructor(h){this._ignorePathCasing=h}compare(h,v,d=!1){return h===v?0:(0,T.compare)(this.getComparisonKey(h,d),this.getComparisonKey(v,d))}isEqual(h,v,d=!1){return h===v?!0:!h||!v?!1:this.getComparisonKey(h,d)===this.getComparisonKey(v,d)}getComparisonKey(h,v=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,v,d=!1){if(h.scheme===v.scheme){if(h.scheme===n.Schemas.file)return D.isEqualOrParent(b(h),b(v),this._ignorePathCasing(h))&&h.query===v.query&&(d||h.fragment===v.fragment);if((0,e.isEqualAuthority)(h.authority,v.authority))return D.isEqualOrParent(h.path,v.path,this._ignorePathCasing(h),"/")&&h.query===v.query&&(d||h.fragment===v.fragment)}return!1}joinPath(h,...v){return R.URI.joinPath(h,...v)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return L.posix.basename(h.path)}extname(h){return L.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let v;return h.scheme===n.Schemas.file?v=R.URI.file(L.dirname(b(h))).path:(v=L.posix.dirname(h.path),h.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),v="/")),h.with({path:v})}normalizePath(h){if(!h.path.length)return h;let v;return h.scheme===n.Schemas.file?v=R.URI.file(L.normalize(b(h))).path:v=L.posix.normalize(h.path),h.with({path:v})}relativePath(h,v){if(h.scheme!==v.scheme||!(0,e.isEqualAuthority)(h.authority,v.authority))return;if(h.scheme===n.Schemas.file){const w=L.relative(b(h),b(v));return A.isWindows?D.toSlashes(w):w}let d=h.path||"/",g=v.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const m=Math.min(d.length,g.length);w<m&&!(d.charCodeAt(w)!==g.charCodeAt(w)&&d.charAt(w).toLowerCase()!==g.charAt(w).toLowerCase());w++);d=g.substr(0,w)+d.substr(w)}return L.posix.relative(d,g)}resolvePath(h,v){if(h.scheme===n.Schemas.file){const d=R.URI.file(L.resolve(b(h),v));return h.with({authority:d.authority,path:d.path})}return v=D.toPosixPath(v),h.with({path:L.posix.resolve(h.path,v)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,v){return h===v||h!==void 0&&v!==void 0&&(0,T.equalsIgnoreCase)(h,v)}hasTrailingPathSeparator(h,v=L.sep){if(h.scheme===n.Schemas.file){const d=b(h);return d.length>D.getRoot(d).length&&d[d.length-1]===v}else{const d=h.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,v=L.sep){return(0,e.hasTrailingPathSeparator)(h,v)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,v=L.sep){let d=!1;if(h.scheme===n.Schemas.file){const g=b(h);d=g!==void 0&&g.length===D.getRoot(g).length&&g[g.length-1]===v}else{v="/";const g=h.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(h,v)?h.with({path:h.path+"/"}):h}}e.ExtUri=E,e.extUri=new E(()=>!1),e.extUriBiasedIgnorePathCase=new E(y=>y.scheme===n.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new E(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(y,h){const v=[];for(let d=0;d<y.length;d++){const g=h(y[d]);y.some((w,m)=>m===d?!1:(0,e.isEqualOrParent)(g,h(w)))||v.push(y[d])}return v}e.distinctParents=I;var C;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function h(v){const d=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(m=>{const[S,l]=m.split(":");S&&l&&d.set(S,l)});const w=v.path.substring(0,v.path.indexOf(";"));return w&&d.set(y.META_DATA_MIME,w),d}y.parseMetaData=h})(C=e.DataUri||(e.DataUri={}));function f(y,h,v){if(h){let d=y.path;return d&&d[0]!==L.posix.sep&&(d=L.posix.sep+d),y.with({scheme:v,authority:h,path:d})}return y.with({scheme:v})}e.toLocalResource=f}),define(ne[5],ie([0,1,23,9,3,2,19,4]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(W){return!!W&&typeof W.then=="function"}e.isThenable=b;function E(W){const N=new D.CancellationTokenSource,V=W(N.token),z=new Promise((B,te)=>{const se=N.token.onCancellationRequested(()=>{se.dispose(),N.dispose(),te(new n.CancellationError)});Promise.resolve(V).then(ce=>{se.dispose(),N.dispose(),B(ce)},ce=>{se.dispose(),N.dispose(),te(ce)})});return new class{cancel(){N.cancel()}then(B,te){return z.then(B,te)}catch(B){return this.then(void 0,B)}finally(B){return z.finally(B)}}}e.createCancelablePromise=E;function I(W,N,V){return new Promise((z,B)=>{const te=N.onCancellationRequested(()=>{te.dispose(),z(V)});W.then(z,B).finally(()=>te.dispose())})}e.raceCancellation=I;function C(W,N){return new Promise((V,z)=>{const B=N.onCancellationRequested(()=>{B.dispose(),z(new n.CancellationError)});W.then(V,z).finally(()=>B.dispose())})}e.raceCancellationError=C;async function f(W){let N=-1;const V=W.map((B,te)=>B.then(se=>(N=te,se))),z=await Promise.race(V);return W.forEach((B,te)=>{te!==N&&B.cancel()}),z}e.raceCancellablePromises=f;function y(W,N,V){let z;const B=setTimeout(()=>{z?.(void 0),V?.()},N);return Promise.race([W.finally(()=>clearTimeout(B)),new Promise(te=>z=te)])}e.raceTimeout=y;function h(W){return new Promise((N,V)=>{const z=W();b(z)?z.then(N,V):N(z)})}e.asPromise=h;class v{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const V=()=>{this.queuedPromise=null;const z=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,z};this.queuedPromise=new Promise(z=>{this.activePromise.then(V,V).then(z)})}return new Promise((V,z)=>{this.queuedPromise.then(V,z)})}return this.activePromise=N(),new Promise((V,z)=>{this.activePromise.then(B=>{this.activePromise=null,V(B)},B=>{this.activePromise=null,z(B)})})}}e.Throttler=v;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class g{constructor(){this.promiseMap=new Map}queue(N,V){const B=(this.promiseMap.get(N)??Promise.resolve()).catch(()=>{}).then(V).finally(()=>{this.promiseMap.get(N)===B&&this.promiseMap.delete(N)});return this.promiseMap.set(N,B),B}}e.SequencerByKey=g;const w=(W,N)=>{let V=!0;const z=setTimeout(()=>{V=!1,N()},W);return{isTriggered:()=>V,dispose:()=>{clearTimeout(z),V=!1}}},m=W=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,W())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class S{constructor(N){this.defaultDelay=N,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,V=this.defaultDelay){this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,te)=>{this.doResolve=B,this.doReject=te}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}}));const z=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=V===e.MicrotaskDelay?m(z):w(V,z),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=S;class l{constructor(N){this.delayer=new S(N),this.throttler=new v}trigger(N,V){return this.delayer.trigger(()=>this.throttler.queue(N),V)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class r{constructor(){this._isOpen=!1,this._promise=new Promise((N,V)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=r;class a extends r{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function i(W,N){return N?new Promise((V,z)=>{const B=setTimeout(()=>{te.dispose(),V()},W),te=N.onCancellationRequested(()=>{clearTimeout(B),te.dispose(),z(new n.CancellationError)})}):E(V=>i(W,V))}e.timeout=i;function t(W,N=0){const V=setTimeout(W,N);return(0,A.toDisposable)(()=>clearTimeout(V))}e.disposableTimeout=t;function o(W){const N=[];let V=0;const z=W.length;function B(){return V<z?W[V++]():null}function te(se){se!=null&&N.push(se);const ce=B();return ce?ce.then(te):Promise.resolve(N)}return Promise.resolve(null).then(te)}e.sequence=o;function s(W,N=z=>!!z,V=null){let z=0;const B=W.length,te=()=>{if(z>=B)return Promise.resolve(V);const se=W[z++];return Promise.resolve(se()).then(he=>N(he)?Promise.resolve(he):te())};return te()}e.first=s;function c(W,N=z=>!!z,V=null){if(W.length===0)return Promise.resolve(V);let z=W.length;const B=()=>{z=-1;for(const te of W)te.cancel?.()};return new Promise((te,se)=>{for(const ce of W)ce.then(he=>{--z>=0&&N(he)?(B(),te(he)):z===0&&te(V)}).catch(he=>{--z>=0&&(B(),se(he))})})}e.firstParallel=c;class u{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((V,z)=>{this.outstandingPromises.push({factory:N,c:V,e:z}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const V=N.factory();V.then(N.c,N.e),V.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class p extends u{constructor(){super(1)}}e.Queue=p;class P{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const N=new x;return this.drainers.add(N),N.p}isDrained(){for(const[,N]of this.queues)if(N.size>0)return!1;return!0}queueFor(N,V=T.extUri){const z=V.getComparisonKey(N);let B=this.queues.get(z);return B||(B=new p,L.Event.once(B.onFinished)(()=>{B?.dispose(),this.queues.delete(z),this.onDidQueueFinish()}),this.queues.set(z,B)),B}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const N of this.drainers)N.complete();this.drainers.clear()}dispose(){for(const[,N]of this.queues)N.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=P;class _{constructor(N,V){this._token=-1,typeof N=="function"&&typeof V=="number"&&this.setIfNotSet(N,V)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,V){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},V)}setIfNotSet(N,V){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},V))}}e.TimeoutTimer=_;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,V){this.cancel(),this._token=setInterval(()=>{N()},V)}}e.IntervalTimer=O;class F{constructor(N,V){this.timeoutToken=-1,this.runner=N,this.timeout=V,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class ${constructor(N,V){V%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.runner=N,this.timeout=V,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(N=this.timeout){N%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(N/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=$;class k extends F{constructor(N,V){super(N,V);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=k;class M extends A.Disposable{constructor(N,V){super();this.options=N,this.handler=V,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(N){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+N.length>this.options.maxBufferedWork)return!1}else if(this.pending+N.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...N),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=M,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if(N)return;const V=Date.now()+15;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,V-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(W,N)=>{const V=requestIdleCallback(W,typeof N=="number"?{timeout:N}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(V))}}}}();class j{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(V){this._error=V}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=j;async function U(W,N,V){let z;for(let B=0;B<V;B++)try{return await W()}catch(te){z=te,await i(N)}throw z}e.retry=U;class G{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(N,V,z){return this._pending={taskId:N,cancel:()=>z?.(),promise:V},V.then(()=>this.donePending(N),()=>this.donePending(N)),V}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let V,z;const B=new Promise((te,se)=>{V=te,z=se});this._next={run:N,promise:B,promiseResolve:V,promiseReject:z}}return this._next.promise}}e.TaskSequentializer=G;class K{constructor(N,V=()=>Date.now()){this.interval=N,this.nowFn=V,this.lastIncrementTime=0,this.value=0}increment(){const N=this.nowFn();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=K;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,V)=>{this.completeCallback=N,this.errorCallback=V})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(V=>{this.completeCallback(N),this.resolved=!0,V()})}error(N){return new Promise(V=>{this.errorCallback(N),this.rejected=!0,V()})}cancel(){new Promise(N=>{this.errorCallback(new n.CancellationError),this.rejected=!0,N()})}}e.DeferredPromise=x;var q;(function(W){async function N(z){let B;const te=await Promise.all(z.map(se=>se.then(ce=>ce,ce=>{B||(B=ce)})));if(typeof B!="undefined")throw B;return te}W.settled=N;function V(z){return new Promise(async(B,te)=>{try{await z(B,te)}catch(se){te(se)}})}W.withAsyncBody=V})(q=e.Promises||(e.Promises={}));var X;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(X||(X={}));class H{constructor(N){this._state=0,this._results=[],this._error=null,this._onStateChanged=new L.Emitter,queueMicrotask(async()=>{const V={emitOne:z=>this.emitOne(z),emitMany:z=>this.emitMany(z),reject:z=>this.reject(z)};try{await Promise.resolve(N(V)),this.resolve()}catch(z){this.reject(z)}finally{V.emitOne=void 0,V.emitMany=void 0,V.reject=void 0}})}static fromArray(N){return new H(V=>{V.emitMany(N)})}static fromPromise(N){return new H(async V=>{V.emitMany(await N)})}static fromPromises(N){return new H(async V=>{await Promise.all(N.map(async z=>V.emitOne(await z)))})}static merge(N){return new H(async V=>{await Promise.all(N.map(async z=>{for await(const B of z)V.emitOne(B)}))})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(N<this._results.length)return{done:!1,value:this._results[N++]};if(this._state===1)return{done:!0,value:void 0};await L.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(N,V){return new H(async z=>{for await(const B of N)z.emitOne(V(B))})}map(N){return H.map(this,N)}static filter(N,V){return new H(async z=>{for await(const B of N)V(B)&&z.emitOne(B)})}filter(N){return H.filter(this,N)}static coalesce(N){return H.filter(N,V=>!!V)}coalesce(){return H.coalesce(this)}static async toPromise(N){const V=[];for await(const z of N)V.push(z);return V}toPromise(){return H.toPromise(this)}emitOne(N){this._state===0&&(this._results.push(N),this._onStateChanged.fire())}emitMany(N){this._state===0&&(this._results=this._results.concat(N),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(N){this._state===0&&(this._state=2,this._error=N,this._onStateChanged.fire())}}e.AsyncIterableObject=H,H.EMPTY=H.fromArray([]);class Z extends H{constructor(N,V){super(V);this._source=N}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=Z;function ee(W){const N=new D.CancellationTokenSource,V=W(N.token);return new Z(N,async z=>{const B=N.token.onCancellationRequested(()=>{B.dispose(),N.dispose(),z.reject(new n.CancellationError)});try{for await(const te of V){if(N.token.isCancellationRequested)return;z.emitOne(te)}B.dispose(),N.dispose()}catch(te){B.dispose(),N.dispose(),z.reject(te)}})}e.createCancelableAsyncIterable=ee}),define(ne[109],ie([0,1,5,41,39,10,26]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const b="[/\\\\]",E="[^/\\\\]",I=/\//g;function C(K){switch(K){case 0:return"";case 1:return`${E}*?`;default:return`(?:${b}|${E}+${b}|${b}${E}+)*?`}}function f(K,x){if(!K)return[];const q=[];let X=!1,H=!1,Z="";for(const ee of K){switch(ee){case x:if(!X&&!H){q.push(Z),Z="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":H=!0;break;case"]":H=!1;break}Z+=ee}return Z&&q.push(Z),q}e.splitGlobAware=f;function y(K){if(!K)return"";let x="";const q=f(K,e.GLOB_SPLIT);if(q.every(X=>X===e.GLOBSTAR))x=".*";else{let X=!1;q.forEach((H,Z)=>{if(H===e.GLOBSTAR){X||(x+=C(2),X=!0);return}let ee=!1,W="",N=!1,V="";for(const z of H){if(z!=="}"&&ee){W+=z;continue}if(N&&(z!=="]"||!V)){let B;z==="-"?B=z:(z==="^"||z==="!")&&!V?B="^":z===e.GLOB_SPLIT?B="":B=T.escapeRegExpCharacters(z),V+=B;continue}switch(z){case"{":ee=!0;continue;case"[":N=!0;continue;case"}":{x+=`(?:${f(W,",").map(se=>y(se)).join("|")})`,ee=!1,W="";break}case"]":x+="["+V+"]",N=!1,V="";break;case"?":x+=E;continue;case"*":x+=C(1);continue;default:x+=T.escapeRegExpCharacters(z)}}Z<q.length-1&&(q[Z+1]!==e.GLOBSTAR||Z+2<q.length)&&(x+=b),X=!1})}return x}const h=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,S=new L.LRUCache(1e4),l=function(){return!1},r=function(){return null};function a(K,x){if(!K)return r;let q;typeof K!="string"?q=K.pattern:q=K,q=q.trim();const X=`${q}_${!!x.trimForExclusions}`;let H=S.get(X);if(H)return i(H,K);let Z;if(h.test(q)){const ee=q.substr(4);H=function(W,N){return typeof W=="string"&&W.endsWith(ee)?q:null}}else(Z=v.exec(t(q,x)))?H=o(Z[1],q):(x.trimForExclusions?g:d).test(q)?H=s(q,x):(Z=w.exec(t(q,x)))?H=c(Z[1].substr(1),q,!0):(Z=m.exec(t(q,x)))?H=c(Z[1],q,!1):H=u(q);return S.set(X,H),i(H,K)}function i(K,x){return typeof x=="string"?K:function(q,X){return n.isEqualOrParent(q,x.base)?K(A.relative(x.base,q),X):null}}function t(K,x){return x.trimForExclusions&&K.endsWith("/**")?K.substr(0,K.length-2):K}function o(K,x){const q=`/${K}`,X=`\\${K}`,H=function(ee,W){return typeof ee!="string"?null:W?W===K?x:null:ee===K||ee.endsWith(q)||ee.endsWith(X)?x:null},Z=[K];return H.basenames=Z,H.patterns=[x],H.allBasenames=Z,H}function s(K,x){const q=G(K.slice(1,-1).split(",").map(W=>a(W,x)).filter(W=>W!==r),K),X=q.length;if(!X)return r;if(X===1)return q[0];const H=function(W,N){for(let V=0,z=q.length;V<z;V++)if(q[V](W,N))return K;return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function c(K,x,q){const X=A.sep===A.posix.sep,H=X?K:K.replace(I,A.sep),Z=A.sep+H,ee=A.posix.sep+K,W=q?function(N,V){return typeof N=="string"&&(N===H||N.endsWith(Z)||!X&&(N===K||N.endsWith(ee)))?x:null}:function(N,V){return typeof N=="string"&&(N===H||!X&&N===K)?x:null};return W.allPaths=[(q?"*/":"./")+K],W}function u(K){try{const x=new RegExp(`^${y(K)}$`);return function(q){return x.lastIndex=0,typeof q=="string"&&x.test(q)?K:null}}catch{return r}}function p(K,x,q){return!K||typeof x!="string"?!1:P(K)(x,void 0,q)}e.match=p;function P(K,x={}){if(!K)return l;if(typeof K=="string"||$(K)){const q=a(K,x);if(q===r)return l;const X=function(H,Z){return!!q(H,Z)};return q.allBasenames&&(X.allBasenames=q.allBasenames),q.allPaths&&(X.allPaths=q.allPaths),X}return j(K,x)}e.parse=P;function _(K){if(!K)return;let x;return q=>(x||(x=(K()||Promise.resolve([])).then(X=>X?F(X):{})),x.then(X=>!!X[q]))}e.hasSiblingPromiseFn=_;function O(K){if(!K)return;let x;return q=>{if(!x){const X=K();x=X?F(X):{}}return!!x[q]}}e.hasSiblingFn=O;function F(K){const x={};for(const q of K)x[q]=!0;return x}function $(K){const x=K;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.isRelativePattern=$;function k(K){return K.allBasenames||[]}e.getBasenameTerms=k;function M(K){return K.allPaths||[]}e.getPathTerms=M;function j(K,x){const q=G(Object.getOwnPropertyNames(K).map(W=>U(W,K[W],x)).filter(W=>W!==r)),X=q.length;if(!X)return r;if(!q.some(W=>!!W.requiresSiblings)){if(X===1)return q[0];const W=function(z,B){for(let te=0,se=q.length;te<se;te++){const ce=q[te](z,B);if(ce)return ce}return null},N=q.find(z=>!!z.allBasenames);N&&(W.allBasenames=N.allBasenames);const V=q.reduce((z,B)=>B.allPaths?z.concat(B.allPaths):z,[]);return V.length&&(W.allPaths=V),W}const H=function(W,N,V){let z;for(let B=0,te=q.length;B<te;B++){const se=q[B];se.requiresSiblings&&V&&(N||(N=A.basename(W)),z||(z=N.substr(0,N.length-A.extname(W).length)));const ce=se(W,N,z,V);if(ce)return ce}return null},Z=q.find(W=>!!W.allBasenames);Z&&(H.allBasenames=Z.allBasenames);const ee=q.reduce((W,N)=>N.allPaths?W.concat(N.allPaths):W,[]);return ee.length&&(H.allPaths=ee),H}function U(K,x,q){if(x===!1)return r;const X=a(K,q);if(X===r)return r;if(typeof x=="boolean")return X;if(x){const H=x.when;if(typeof H=="string"){const Z=(ee,W,N,V)=>{if(!V||!X(ee,W))return null;const z=H.replace("$(basename)",N),B=V(z);return(0,D.isThenable)(B)?B.then(te=>te?K:null):B?K:null};return Z.requiresSiblings=!0,Z}}return X}function G(K,x){const q=K.filter(W=>!!W.basenames);if(q.length<2)return K;const X=q.reduce((W,N)=>{const V=N.basenames;return V?W.concat(V):W},[]);let H;if(x){H=[];for(let W=0,N=X.length;W<N;W++)H.push(x)}else H=q.reduce((W,N)=>{const V=N.patterns;return V?W.concat(V):W},[]);const Z=function(W,N){if(typeof W!="string")return null;if(!N){let z;for(z=W.length;z>0;z--){const B=W.charCodeAt(z-1);if(B===47||B===92)break}N=W.substr(z)}const V=X.indexOf(N);return V!==-1?H[V]:null};Z.basenames=X,Z.patterns=H,Z.allBasenames=X;const ee=K.filter(W=>!W.basenames);return ee.push(Z),ee}}),define(ne[110],ie([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(I){return I.toJSON()}class L{constructor(C){this._uriTransformer=C}transformIncoming(C){const f=this._uriTransformer.transformIncoming(C);return f===C?C:n(D.URI.from(f))}transformOutgoing(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:n(D.URI.from(f))}transformOutgoingURI(C){const f=this._uriTransformer.transformOutgoing(C);return f===C?C:D.URI.from(f)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,C,f){if(!I||f>200)return null;if(typeof I=="object"){if(I instanceof D.URI)return C.transformOutgoing(I);for(let y in I)if(Object.hasOwnProperty.call(I,y)){const h=A(I[y],C,f+1);h!==null&&(I[y]=h)}}return null}function T(I,C){const f=A(I,C,0);return f===null?I:f}e.transformOutgoingURIs=T;function R(I,C,f,y){if(!I||y>200)return null;if(typeof I=="object"){if(I.$mid===1)return f?D.URI.revive(C.transformIncoming(I)):C.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const v=R(I[h],C,f,y+1);v!==null&&(I[h]=v)}}return null}function b(I,C){const f=R(I,C,!1,0);return f===null?I:f}e.transformIncomingURIs=b;function E(I,C){const f=R(I,C,!0,0);return f===null?I:f}e.transformAndReviveIncomingURIs=E}),define(ne[29],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(b){return D.test(b)}e.isUUID=n;const L=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));let T;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?T=crypto.getRandomValues.bind(crypto):T=function(b){for(let E=0;E<b.length;E++)b[E]=Math.floor(Math.random()*256);return b};function R(){T(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let b=0,E="";return E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+="-",E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E+=A[L[b++]],E}e.generateUuid=R}),define(ne[111],ie([0,1,249]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(A="utf8"){this.stringDecoder=new D.StringDecoder(A),this.remaining=null}write(A){const T=[],R=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(R.length<1)return T;let b=0,E,I=b;for(;I<R.length;)if(E=R.charCodeAt(I),E===13||E===10){if(T.push(R.substring(b,I)),I++,I<R.length){const C=E;E=R.charCodeAt(I),(C===13&&E===10||C===10&&E===13)&&I++}b=I}else I++;return this.remaining=b<R.length?R.substr(b):null,T}end(){return this.remaining}}e.LineDecoder=n}),define(ne[112],ie([0,1,33]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(T){const R=T.replace(/\-/g,":").toLowerCase();return!n.has(R)}function A(){const T=(0,D.networkInterfaces)();for(let R in T){const b=T[R];if(b){for(const{mac:E}of b)if(L(E))return E}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=A}),define(ne[113],ie([0,1,33,9,39,29,112]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=L.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,C=0;const f=(0,D.networkInterfaces)();for(let y in f){const h=f[y];if(h)for(const{mac:v,internal:d}of h)d||(C+=1,this._isVirtualMachineMacAddress(v.toUpperCase())&&(I+=1))}this._value=C>0?I/C:0}return this._value}};let R;async function b(){return R||(R=(async()=>await E()||A.generateUuid())()),R}e.getMachineId=b;async function E(){try{const I=await new Promise((f,y)=>{Y(["crypto"],f,y)}),C=(0,T.getMac)();return I.createHash("sha256").update(C,"utf8").digest("hex")}catch(I){n.onUnexpectedError(I);return}}}),define(ne[22],ie([0,1,50,33,250,5,41,71,10,4,19,7]),function(Y,e,D,n,L,A,T,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var f;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(f=e.RimRafMode||(e.RimRafMode={}));async function y(M,j=f.UNLINK){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return j===f.UNLINK?v(M):h(M)}async function h(M){try{const j=(0,T.randomPath)((0,n.tmpdir)());try{await D.promises.rename(M,j)}catch{return v(M)}v(j).catch(U=>{})}catch(j){if(j.code!=="ENOENT")throw j}}async function v(M){return(0,L.promisify)(D.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function d(M){if((0,T.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function g(M,j){return S(await(j?w(M):(0,L.promisify)(D.readdir)(M)))}async function w(M){try{return await(0,L.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(G){console.warn("[node.js fs] readdir with filetypes failed with error: ",G)}const j=[],U=await g(M);for(const G of U){let K=!1,x=!1,q=!1;try{const X=await e.Promises.lstat((0,b.join)(M,G));K=X.isFile(),x=X.isDirectory(),q=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}j.push({name:G,isFile:()=>K,isDirectory:()=>x,isSymbolicLink:()=>q})}return j}function m(M){return S(D.readdirSync(M))}e.readdirSync=m;function S(M){return M.map(j=>typeof j=="string"?E.isMacintosh?(0,R.normalizeNFC)(j):j:(j.name=E.isMacintosh?(0,R.normalizeNFC)(j.name):j.name,j))}async function l(M){const j=await g(M),U=[];for(const G of j)await a.existsDirectory((0,b.join)(M,G))&&U.push(G);return U}function r(M,j=1e3){return new Promise(U=>{let G=!1;const K=setInterval(()=>{G||(G=!0,D.access(M,x=>{G=!1,x&&(clearInterval(K),U(void 0))}))},j)})}e.whenDeleted=r;var a;(function(M){async function j(K){let x;try{if(x=await e.Promises.lstat(K),!x.isSymbolicLink())return{stat:x}}catch{}try{return{stat:await e.Promises.stat(K),symbolicLink:x?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};if(E.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(K)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&x)return{stat:x,symbolicLink:{dangling:!0}};throw X}throw q}}M.stat=j;async function U(K){try{const{stat:x,symbolicLink:q}=await M.stat(K);return x.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=U;async function G(K){try{const{stat:x,symbolicLink:q}=await M.stat(K);return x.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=G})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new A.ResourceQueue;function t(M,j,U){return i.queueFor(C.URI.file(M),I.extUriBiasedIgnorePathCase).queue(()=>{const G=u(U);return new Promise((K,x)=>s(M,j,G,q=>q?x(q):K()))})}let o=!0;function s(M,j,U,G){if(!o)return D.writeFile(M,j,{mode:U.mode,flag:U.flag},G);D.open(M,U.flag,U.mode,(K,x)=>{if(K)return G(K);D.writeFile(x,j,q=>{if(q)return D.close(x,()=>G(q));D.fdatasync(x,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),o=!1),D.close(x,H=>G(H))))})})}function c(M,j,U){const G=u(U);if(!o)return D.writeFileSync(M,j,{mode:G.mode,flag:G.flag});const K=D.openSync(M,G.flag,G.mode);try{D.writeFileSync(K,j);try{D.fdatasyncSync(K)}catch(x){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",x),o=!1}}finally{D.closeSync(K)}}e.writeFileSync=c;function u(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function p(M,j){if(M===j)return;async function U(G){try{const K=await e.Promises.lstat(G);if(K.isDirectory()||K.isSymbolicLink())return;await e.Promises.utimes(G,K.atime,new Date)}catch{}}try{await e.Promises.rename(M,j),await U(j)}catch(G){if(M.toLowerCase()!==j.toLowerCase()&&G.code==="EXDEV"||M.endsWith("."))await P(M,j,{preserveSymlinks:!1}),await y(M,f.MOVE),await U(j);else throw G}}async function P(M,j,U){return O(M,j,{root:{source:M,target:j},options:U,handledSourcePaths:new Set})}const _=511;async function O(M,j,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:G,symbolicLink:K}=await a.stat(M);if(K){if(U.options.preserveSymlinks)try{return await k(M,j,U)}catch(x){console.warn("[node.js fs] copy of symlink failed: ",x)}if(K.dangling)return}return G.isDirectory()?F(M,j,G.mode&_,U):$(M,j,G.mode&_)}async function F(M,j,U,G){await e.Promises.mkdir(j,{recursive:!0,mode:U});const K=await g(M);for(const x of K)await O((0,b.join)(M,x),(0,b.join)(j,x),G)}async function $(M,j,U){await e.Promises.copyFile(M,j),await e.Promises.chmod(j,U)}async function k(M,j,U){let G=await e.Promises.readlink(M);(0,T.isEqualOrParent)(G,U.root.source,!E.isLinux)&&(G=(0,b.join)(U.root.target,G.substr(U.root.source.length+1))),await e.Promises.symlink(G,j)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(M,j,U,G,K)=>new Promise((x,q)=>{D.read(M,j,U,G,K,(X,H,Z)=>X?q(X):x({bytesRead:H,buffer:Z}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(M,j,U,G,K)=>new Promise((x,q)=>{D.write(M,j,U,G,K,(X,H,Z)=>X?q(X):x({bytesWritten:H,buffer:Z}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get rename(){return(0,L.promisify)(D.rename)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return t}get rm(){return y}get move(){return p}get copy(){return P}}}),define(ne[114],ie([0,1,50,10,4,26,22]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(f){if(L.isLinux)return f;const y=(0,n.dirname)(f);if(f===y)return f;const h=((0,n.basename)(f)||f).toLowerCase();try{const d=(0,T.readdirSync)(y).filter(g=>g.toLowerCase()===h);if(d.length===1){const g=R(y);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(h);if(g>=0){const w=R(y);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcaseSync=R;async function b(f){if(L.isLinux)return f;const y=(0,n.dirname)(f);if(f===y)return f;const h=((0,n.basename)(f)||f).toLowerCase();try{const d=(await T.Promises.readdir(y)).filter(g=>g.toLowerCase()===h);if(d.length===1){const g=await b(y);if(g)return(0,n.join)(g,d[0])}else if(d.length>1){const g=d.indexOf(h);if(g>=0){const w=await b(y);if(w)return(0,n.join)(w,d[g])}}}catch{}return null}e.realcase=b;async function E(f){try{return await T.Promises.realpath(f)}catch{const h=C(f);return await T.Promises.access(h,D.constants.R_OK),h}}e.realpath=E;function I(f){try{return D.realpathSync(f)}catch{const h=C(f);return D.accessSync(h,D.constants.R_OK),h}}e.realpathSync=I;function C(f){return(0,A.rtrim)((0,n.normalize)(f),n.sep)}}),define(ne[115],ie([0,1,56]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(R,b,E,I=1){let C=!1;return new Promise(f=>{const y=setTimeout(()=>{if(!C)return C=!0,f(0)},E);L(R,b,I,h=>{if(!C)return C=!0,clearTimeout(y),f(h)})})}e.findFreePort=n;function L(R,b,E,I){if(b===0)return I(0);const C=new D.Socket;C.once("connect",()=>(T(C),L(R+E,b-1,E,I))),C.once("data",()=>{}),C.once("error",f=>(T(C),f.code!=="ECONNREFUSED"?L(R+E,b-1,E,I):I(R))),C.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,b,E){let I=!1,C,f=1;const y=D.createServer({pauseOnConnect:!0});function h(v,d){I||(I=!0,y.removeAllListeners(),y.close(),C&&clearTimeout(C),d(v))}return new Promise(v=>{C=setTimeout(()=>{h(0,v)},E),y.on("listening",()=>{h(R,v)}),y.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&f<b?(R++,f++,y.listen(R,"127.0.0.1")):h(0,v)}),y.on("close",()=>{h(0,v)}),y.listen(R,"127.0.0.1")})}e.findFreePortFaster=A;function T(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(ne[72],ie([0,1,33,10,22]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,T=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(b||(b={}));let E;switch(process.arch){case"ia32":case"x32":E=1;break;case"arm":case"arm64":E=2;break;default:E=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class C{constructor(l,r,a){this.exePath=l,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await L.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:S=!1}={}){return S?E===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:S=!1,findPreview:l=!1}={}){const r=f({useAlternateBitness:S});if(!r)return null;const a=n.join(r,"PowerShell");if(!await L.SymlinkSupport.existsDirectory(a))return null;let i=-1,t=null;for(const c of await L.Promises.readdir(a)){let u=-1;if(l){const P=c.indexOf("-");if(P<0)continue;const _=c.substring(0,P);if(!A.test(_)||c.substring(P+1)!=="preview")continue;u=parseInt(_,10)}else{if(!A.test(c))continue;u=parseInt(c,10)}if(u<=i)continue;const p=n.join(a,c,"pwsh.exe");!await L.SymlinkSupport.existsFile(p)||(t=p,i=u)}if(!t)return null;const o=r.includes("x86")?" (x86)":"",s=l?" Preview":"";return new C(t,`PowerShell${s}${o}`,!0)}async function h({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const l=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await L.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=S?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const i of await L.Promises.readdir(l))if(r.test(i)){const t=n.join(l,i,"pwsh.exe");return new C(t,a)}return null}function v(){const S=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new C(S,".NET Core PowerShell Global Tool")}function d(){const S=n.join(process.env.windir,E===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(S,"Windows PowerShell",!0)}async function*g(){let S=await y();S&&(yield S),S=await y({useAlternateBitness:!0}),S&&(yield S),S=await h(),S&&(yield S),S=v(),S&&(yield S),S=await y({findPreview:!0}),S&&(yield S),S=await h({findPreview:!0}),S&&(yield S),S=await y({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=d(),S&&(yield S)}async function*w(){for await(const S of g())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=w;async function m(){for await(const S of w())return S;return null}e.getFirstAvailablePowerShellInstallation=m}),define(ne[116],ie([0,1,45,18]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(T){return new Promise((R,b)=>{let E;const I=new Map;function C(y,h,v,d,g){const w=I.get(h);if(y===T||w){const m={name:f(v),cmd:v,pid:y,ppid:h,load:d,mem:g};I.set(y,m),y===T&&(E=m),w&&(w.children||(w.children=[]),w.children.push(m),w.children.length>1&&(w.children=w.children.sort((S,l)=>S.pid-l.pid)))}}function f(y){const h=/--vscode-window-kind=shared-process/,v=/--vscode-window-kind=issue-reporter/,d=/--vscode-window-kind=process-explorer/,g=/--utility-sub-type=network/,w=/--crashes-directory/,m=/\\pipe\\winpty-control/,S=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(w.exec(y))return"electron-crash-reporter";if(m.exec(y))return"winpty-process";if(S.exec(y))return"console-window-host (Windows internal process)";let r=l.exec(y);if(r&&r.length===2)return r[1]==="renderer"?h.exec(y)?"shared-process":v.exec(y)?"issue-reporter":d.exec(y)?"process-explorer":"window":r[1]==="utility"&&g.exec(y)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let i="";do r=a.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,v)=>{Y(["windows-process-tree"],h,v)}).then(h=>{h.getProcessList(T,v=>{h.getProcessCpuUsage(v,d=>{const g=new Map;d.forEach(w=>{const m=y(w.commandLine||"");g.set(w.pid,{name:f(m),cmd:m,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),E=g.get(T),E?(g.forEach(w=>{const m=g.get(w.ppid);m&&(m.children||(m.children=[]),m.children.push(w))}),g.forEach(w=>{w.children&&(w.children=w.children.sort((m,S)=>m.pid-S.pid))}),R(E)):b(new Error(`Root process ${T} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let y=function(){let h=[E];const v=[];for(;h.length;){const g=h.shift();g&&(v.push(g.pid),g.children&&(h=h.concat(g.children)))}let d=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Y).fsPath);d+=" "+v.join(" "),(0,D.exec)(d,{},(g,w,m)=>{if(g||m)b(g||new Error(m.toString()));else{const S=w.toString().split(`
`);for(let l=0;l<v.length;l++){const r=I.get(v[l]);r.load=parseFloat(S[l])}if(!E){b(new Error(`Root process ${T} not found`));return}R(E)}})};(0,D.exec)("which ps",{},(h,v,d)=>{if(h||d)if(process.platform!=="linux")b(h||new Error(d.toString()));else{const g=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",Y).fsPath);(0,D.exec)(g,{},(w,m,S)=>{w||S?b(w||new Error(S.toString())):(A(m,C),y())})}else{const g=v.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${g} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,S,l)=>{m||l&&!l.includes("screen size is bogus")?b(m||new Error(l.toString())):(A(S,C),process.platform==="linux"?y():E?R(E):b(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=L;function A(T,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,E=T.toString().split(`
`);for(const I of E){const C=b.exec(I.trim());C&&C.length===6&&R(parseInt(C[1]),parseInt(C[2]),C[5],parseFloat(C[3]),parseFloat(C[4]))}}});var de=this&&this.__decorate||function(Y,e,D,n){var L=arguments.length,A=L<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(Y,e,D,n);else for(var R=Y.length-1;R>=0;R--)(T=Y[R])&&(A=(L<3?T(A):L>3?T(e,D,A):T(e,D))||A);return L>3&&A&&Object.defineProperty(e,D,A),A};define(ne[36],ie([0,1,16,5,17,23,54,9,3,2,108,26,14]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function h(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(v=e.ResponseType||(e.ResponseType={}));function d(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(g||(g={}));class w{constructor(q){this.buffer=q,this.pos=0}read(q){const X=this.buffer.slice(this.pos,this.pos+q);return this.pos+=X.byteLength,X}}class m{constructor(){this.buffers=[]}get buffer(){return L.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var S;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object"})(S||(S={}));function l(x){const q=L.VSBuffer.alloc(4);return q.writeUInt32BE(x,0),q}function r(x){return x.read(4).readUInt32BE(0)}function a(x){const q=L.VSBuffer.alloc(1);return q.writeUInt8(x,0),q}const i={Undefined:a(S.Undefined),String:a(S.String),Buffer:a(S.Buffer),VSBuffer:a(S.VSBuffer),Array:a(S.Array),Object:a(S.Object)},t=typeof Buffer!="undefined";function o(x,q){if(typeof q=="undefined")x.write(i.Undefined);else if(typeof q=="string"){const X=L.VSBuffer.fromString(q);x.write(i.String),x.write(l(X.byteLength)),x.write(X)}else if(t&&Buffer.isBuffer(q)){const X=L.VSBuffer.wrap(q);x.write(i.Buffer),x.write(l(X.byteLength)),x.write(X)}else if(q instanceof L.VSBuffer)x.write(i.VSBuffer),x.write(l(q.byteLength)),x.write(q);else if(Array.isArray(q)){x.write(i.Array),x.write(l(q.length));for(const X of q)o(x,X)}else{const X=L.VSBuffer.fromString(JSON.stringify(q));x.write(i.Object),x.write(l(X.byteLength)),x.write(X)}}function s(x){switch(x.read(1).readUInt8(0)){case S.Undefined:return;case S.String:return x.read(r(x)).toString();case S.Buffer:return x.read(r(x)).buffer;case S.VSBuffer:return x.read(r(x));case S.Array:{const X=r(x),H=[];for(let Z=0;Z<X;Z++)H.push(s(x));return H}case S.Object:return JSON.parse(x.read(r(x)).toString())}}class c{constructor(q,X,H=null,Z=1e3){this.protocol=q,this.ctx=X,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(ee=>this.onRawMessage(ee)),this.sendResponse({type:200})}registerChannel(q,X){this.channels.set(q,X),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const X=this.send([q.type]);this.logger&&this.logger.logOutgoing(X,0,1,d(q.type));return}case 201:case 202:case 204:case 203:{const X=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(X,q.id,1,d(q.type),q.data);return}}}send(q,X=void 0){const H=new m;return o(H,q),o(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const X=new w(q),H=s(X),Z=s(X),ee=H[0];switch(ee){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:ee,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(ee)}`),this.disposeActiveRequest({type:ee,id:H[1]})}}onPromise(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=new A.CancellationTokenSource;let Z;try{Z=X.call(this.ctx,q.name,q.arg,H.token)}catch(N){Z=Promise.reject(N)}const ee=q.id;Z.then(N=>{this.sendResponse({id:ee,data:N,type:201}),this.activeRequests.delete(q.id)},N=>{N instanceof Error?this.sendResponse({id:ee,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:ee,data:N,type:203}),this.activeRequests.delete(q.id)});const W=(0,E.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,W)}onEventListen(q){const X=this.channels.get(q.channelName);if(!X){this.collectPendingRequest(q);return}const H=q.id,ee=X.listen(this.ctx,q.name,q.arg)(W=>this.sendResponse({id:H,data:W,type:204}));this.activeRequests.set(q.id,ee)}disposeActiveRequest(q){const X=this.activeRequests.get(q.id);X&&(X.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let X=this.pendingRequests.get(q.channelName);X||(X=[],this.pendingRequests.set(q.channelName,X));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const X=this.pendingRequests.get(q);if(X){for(const H of X)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var u;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(u=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(q,X=null){this.protocol=q,this.isDisposed=!1,this.state=g.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=X}getChannel(q){const X=this;return{call(H,Z,ee){return X.isDisposed?Promise.reject(R.canceled()):X.requestPromise(q,H,Z,ee)},listen(H,Z){return X.isDisposed?Promise.reject(R.canceled()):X.requestEvent(q,H,Z)}}}requestPromise(q,X,H,Z=A.CancellationToken.None){const ee=this.lastRequestId++,N={id:ee,type:100,channelName:q,name:X,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let V;return new Promise((B,te)=>{if(Z.isCancellationRequested)return te(R.canceled());const se=()=>{const pe=Ee=>{switch(Ee.type){case 201:this.handlers.delete(ee),B(Ee.data);break;case 202:{this.handlers.delete(ee);const Ce=new Error(Ee.data.message);Ce.stack=Ee.data.stack,Ce.name=Ee.data.name,te(Ce);break}case 203:this.handlers.delete(ee),te(Ee.data);break}};this.handlers.set(ee,pe),this.sendRequest(N)};let ce=null;this.state===g.Idle?se():(ce=(0,n.createCancelablePromise)(pe=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:ee,type:101}),te(R.canceled())},ve=Z.onCancellationRequested(he);V=(0,E.combinedDisposable)((0,E.toDisposable)(he),ve),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(q,X,H){const Z=this.lastRequestId++,W={id:Z,type:102,channelName:q,name:X,arg:H};let N=null;const V=new b.Emitter({onFirstListenerAdd:()=>{N=(0,n.createCancelablePromise)(B=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(V),this.sendRequest(W)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(V),this.sendRequest({id:Z,type:103}))}}),z=B=>V.fire(B.data);return this.handlers.set(Z,z),V.event}sendRequest(q){switch(q.type){case 100:case 102:{const X=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(X,q.id,0,`${h(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const X=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(X,q.id,0,h(q.type));return}}}send(q,X=void 0){const H=new m;return o(H,q),o(H,X),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const X=new w(q),H=s(X),Z=s(X),ee=H[0];switch(ee){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,d(ee)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,d(ee),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=g.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(q.id);X&&X(q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([T.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class P{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:X,onDidClientDisconnect:H})=>{b.Event.once(X.onMessage)(ee=>{const W=new w(ee),N=s(W),V=new c(X,N),z=new p(X);this.channels.forEach((te,se)=>V.registerChannel(se,te));const B={channelServer:V,channelClient:z,ctx:N};this._connections.add(B),this._onDidAddConnection.fire(B),H(()=>{V.dispose(),z.dispose(),this._connections.delete(B),this._onDidRemoveConnection.fire(B)})})})}get connections(){const q=[];return this._connections.forEach(X=>q.push(X)),q}getChannel(q,X){const H=this;return{call(Z,ee,W){let N;if((0,f.isFunction)(X)){let z=(0,D.getRandomElement)(H.connections.filter(X));N=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(H.onDidAddConnection,X))}else N=X.routeCall(H,Z,ee);const V=N.then(z=>z.channelClient.getChannel(q));return O(V).call(Z,ee,W)},listen(Z,ee){if((0,f.isFunction)(X))return H.getMulticastEvent(q,X,Z,ee);const W=X.routeEvent(H,Z,ee).then(N=>N.channelClient.getChannel(q));return O(W).listen(Z,ee)}}}getMulticastEvent(q,X,H,Z){const ee=this;let W=new E.DisposableStore;const N=new b.Emitter({onFirstListenerAdd:()=>{W=new E.DisposableStore;const V=new b.EventMultiplexer,z=new Map,B=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),ve=V.add(he);z.set(se,ve)},te=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};ee.connections.filter(X).forEach(B),b.Event.filter(ee.onDidAddConnection,X)(B,void 0,W),ee.onDidRemoveConnection(te,void 0,W),V.event(N.fire,N,W),W.add(V)},onLastListenerRemove:()=>{W.dispose()}});return N.event}registerChannel(q,X){this.channels.set(q,X),this._connections.forEach(H=>{H.channelServer.registerChannel(q,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class _{constructor(q,X,H=null){const Z=new m;o(Z,X),q.send(Z.buffer),this.channelClient=new p(q,H),this.channelServer=new c(q,X,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,X){this.channelServer.registerChannel(q,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=_;function O(x){return{call(q,X,H){return x.then(Z=>Z.call(q,X,H))},listen(q,X){const H=new b.Relay;return x.then(Z=>H.input=Z.listen(q,X)),H.event}}}e.getDelayedChannel=O;function F(x){let q=!1;return{call(X,H,Z){return q?x.call(X,H,Z):(0,n.timeout)(0).then(()=>q=!0).then(()=>x.call(X,H,Z))},listen(X,H){if(q)return x.listen(X,H);const Z=new b.Relay;return(0,n.timeout)(0).then(()=>q=!0).then(()=>Z.input=x.listen(X,H)),Z.event}}}e.getNextTickChannel=F;class ${constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const X of q.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await b.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=$;var k;(function(x){function q(ee,W){const N=ee,V=W&&W.disableMarshalling,z=new Map;for(const B in N)H(B)&&z.set(B,b.Event.buffer(N[B],!0));return new class{listen(B,te,se){const ce=z.get(te);if(ce)return ce;if(Z(te)){const he=N[te];if(typeof he=="function")return he.call(N,se)}throw new Error(`Event not found: ${te}`)}call(B,te,se){const ce=N[te];if(typeof ce=="function"){if(!V&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,I.revive)(se[he]);return ce.apply(N,se)}throw new Error(`Method not found: ${te}`)}}}x.fromService=q;function X(ee,W){const N=W&&W.disableMarshalling;return new Proxy({},{get(V,z){if(typeof z=="string")return W?.properties?.has(z)?W.properties.get(z):Z(z)?function(B){return ee.listen(z,B)}:H(z)?ee.listen(z):async function(...B){let te;W&&!(0,f.isUndefinedOrNull)(W.context)?te=[W.context,...B]:te=B;const se=await ee.call(z,te);return N?se:(0,I.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}x.toService=X;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&C.isUpperAsciiLetter(ee.charCodeAt(2))}function Z(ee){return/^onDynamic/.test(ee)&&C.isUpperAsciiLetter(ee.charCodeAt(9))}})(k=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){let q=x.toString();if(q!=="[object Object]")return q}return x}function U(x){return Array.isArray(x)?x.map(j):j(x)}function G(x,q,X,H,Z,ee,W){W=U(W);const N=M[Z],V=N[H%N.length];let z=[`%c[${x}]%c[${String(q).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(ee)?(z=z.concat(W),z.push(")")):z.push(W),console.log.apply(console,z)}e.logWithColors=G;class K{constructor(q,X){this._outgoingPrefix=q,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,X,H,Z,ee){this._totalOutgoing+=q,G(this._outgoingPrefix,this._totalOutgoing,q,X,H,Z,ee)}logIncoming(q,X,H,Z,ee){this._totalIncoming+=q,G(this._incomingPrefix,this._totalIncoming,q,X,H,Z,ee)}}e.IPCLogger=K}),define(ne[117],ie([0,1,17,3,36]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(b){this.port=b,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",E=>D.VSBuffer.wrap(E.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class T extends L.IPCClient{constructor(b,E){const I=new A(b);super(I,E);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=T}),define(ne[73],ie([0,1,17,3,2,36]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var T;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(T=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let s=0;function c(p,P){if(!o.has(p)){const _=String(++s);o.set(p,_)}return o.get(p)}function u(p,P,_,O){if(!t.enableDiagnostics)return;const F=c(p,P);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const $=D.VSBuffer.alloc(O.byteLength);$.set(O),t.records.push({timestamp:Date.now(),id:F,label:P,type:_,buff:$})}else t.records.push({timestamp:Date.now(),id:F,label:P,type:_,data:O})}t.traceSocketEvent=u})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let E=null;function I(){return E||(E=D.VSBuffer.alloc(0)),E}class C{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,s){if(o===0)return I();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const P=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=o),P}if(this._chunks[0].byteLength>o){const P=this._chunks[0].slice(0,o);return s&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),P}let c=D.VSBuffer.alloc(o),u=0,p=0;for(;o>0;){const P=this._chunks[p];if(P.byteLength>o){const _=P.slice(0,o);c.set(_,u),u+=o,s&&(this._chunks[p]=P.slice(o),this._totalLength-=o),o-=o}else c.set(P,u),u+=P.byteLength,s?(this._chunks.shift(),this._totalLength-=P.byteLength):p++,o-=P.byteLength}return c}}e.ChunkStream=C;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function y(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class v{constructor(o,s,c,u){this.type=o,this.id=s,this.ack=c,this.data=u,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new C,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,u=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",s),this._onMessage.fire(new v(c,u,p,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(o.type,0),s.writeUInt32BE(o.id,1),s.writeUInt32BE(o.ack,5),s.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(s,o.data)}_bufferAdd(o,s){const c=this._totalLength===0;return this._data.push(o,s),this._totalLength+=o.byteLength+s.byteLength,c}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,s){this._bufferAdd(o,s)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class w extends L.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new v(1,0,0,o))}}e.Protocol=w;class m extends A.IPCClient{constructor(o,s,c=null){super(o,s,c);this.protocol=o}static fromSocket(o,s){return new m(new w(o),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=m;class S{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=S;class l{constructor(o){this.data=o,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],s=0,c=this._first;for(;c;)o[s++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const s=new l(o);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class a{constructor(){this.lastRuns=[];const o=Date.now();for(let s=0;s<a._HISTORY_LENGTH;s++)this.lastRuns[s]=o-1e3*s;setInterval(()=>{for(let s=a._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const o=Date.now(),s=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let u=0;u<a._HISTORY_LENGTH;u++)o-this.lastRuns[u]<=s&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class i{constructor(o,s=null,c=a.getInstance()){this._onControlMessage=new S,this.onControlMessage=this._onControlMessage.event,this._onMessage=new S,this.onMessage=this._onMessage.event,this._onDidDispose=new S,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new S,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new S,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(u=>this._onSocketClose.fire(u))),s&&this._socketReader.acceptChunk(s)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new v(5,0,0,I());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new v(7,0,0,I());this._socketWriter.write(o)}sendResume(){const o=new v(8,0,0,I());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,s){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,I());this._socketWriter.write(o);const s=this._outgoingUnackMsg.toArray();for(let c=0,u=s.length;c<u;c++)this._socketWriter.write(s[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new v(6,0,0,I())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const s=this._outgoingUnackMsg.toArray();for(let c=0,u=s.length;c<u;c++)this._socketWriter.write(s[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new v(1,s,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const s=new v(2,0,0,o);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),s=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,u=Date.now()-this._lastSocketTimeoutTime;if(s>=2e4&&c>=2e4&&u>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const p=Math.max(2e4-s,2e4-c,2e4-u,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new v(3,0,this._incomingAckId,I());this._socketWriter.write(o)}}e.PersistentProtocol=i}),define(ne[118],ie([0,1,74,3,36,117]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class T extends L.IPCServer{static getOnDidClientConnect(){const b=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(E,I)=>I);return n.Event.map(b,E=>{const{port1:I,port2:C}=new MessageChannel,y={protocol:new A.Protocol(I),onDidClientDisconnect:n.Event.fromDOMEventEmitter(I,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",E,[C]),y})}constructor(){super(T.getOnDidClientConnect())}}e.Server=T}),define(ne[119],ie([0,1,17,9]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((I,C)=>{E.open(R.type||"GET",R.url||"",!0,R.user,R.password),A(E,R),E.responseType="arraybuffer",E.onerror=f=>C(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=f=>{I({res:{statusCode:E.status,headers:T(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=f=>C(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(E.timeout=R.timeout),E.send(R.data),b.onCancellationRequested(()=>{E.abort(),C((0,n.canceled)())})})}e.request=L;function A(R,b){if(b.headers){e:for(let E in b.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(E,b.headers[E])}}}function T(R){const b=Object.create(null);for(const E of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const I=E.indexOf(":");b[E.substr(0,I).trim().toLowerCase()]=E.substr(I+1).trim()}return b}}),define(ne[75],ie([0,1,5,3,2,14]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(T=e.StorageHint||(e.StorageHint={}));function R(C){const f=C;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(b||(b={}));class E extends L.Disposable{constructor(f,y=Object.create(null)){super();this.database=f,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(E.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((y,h)=>this.accept(h,y)),f.deleted?.forEach(y=>this.accept(y,void 0))}accept(f,y){if(this.state===b.Closed)return;let h=!1;(0,A.isUndefinedOrNull)(y)?h=this.cache.delete(f):this.cache.get(f)!==y&&(this.cache.set(f,y),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,y){const h=this.cache.get(f);return(0,A.isUndefinedOrNull)(h)?y:h}getBoolean(f,y){const h=this.get(f);return(0,A.isUndefinedOrNull)(h)?y:h==="true"}getNumber(f,y){const h=this.get(f);return(0,A.isUndefinedOrNull)(h)?y:parseInt(h,10)}async set(f,y){if(this.state===b.Closed)return;if((0,A.isUndefinedOrNull)(y))return this.delete(f);const h=String(y);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=E,E.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((y,h)=>this.items.set(h,y)),f.delete&&f.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=I}),define(ne[120],ie([11,12]),function(Y,e){return Y.create("vs/base/common/date",e)}),define(ne[57],ie([0,1,120]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,L=n*60,A=L*24,T=A*7,R=A*30,b=A*365;function E(C,f,y){typeof C!="number"&&(C=C.getTime());const h=Math.round((new Date().getTime()-C)/1e3);if(h<-30)return(0,D.localize)(0,null,E(new Date().getTime()+h*1e3,!1));if(h<30)return(0,D.localize)(1,null);let v;return h<n?(v=h,f?v===1?y?(0,D.localize)(2,null,v):(0,D.localize)(3,null,v):y?(0,D.localize)(4,null,v):(0,D.localize)(5,null,v):v===1?y?(0,D.localize)(6,null,v):(0,D.localize)(7,null,v):y?(0,D.localize)(8,null,v):(0,D.localize)(9,null,v)):h<L?(v=Math.floor(h/n),f?v===1?y?(0,D.localize)(10,null,v):(0,D.localize)(11,null,v):y?(0,D.localize)(12,null,v):(0,D.localize)(13,null,v):v===1?y?(0,D.localize)(14,null,v):(0,D.localize)(15,null,v):y?(0,D.localize)(16,null,v):(0,D.localize)(17,null,v)):h<A?(v=Math.floor(h/L),f?v===1?y?(0,D.localize)(18,null,v):(0,D.localize)(19,null,v):y?(0,D.localize)(20,null,v):(0,D.localize)(21,null,v):v===1?y?(0,D.localize)(22,null,v):(0,D.localize)(23,null,v):y?(0,D.localize)(24,null,v):(0,D.localize)(25,null,v)):h<T?(v=Math.floor(h/A),f?v===1?(0,D.localize)(26,null,v):(0,D.localize)(27,null,v):v===1?(0,D.localize)(28,null,v):(0,D.localize)(29,null,v)):h<R?(v=Math.floor(h/T),f?v===1?y?(0,D.localize)(30,null,v):(0,D.localize)(31,null,v):y?(0,D.localize)(32,null,v):(0,D.localize)(33,null,v):v===1?y?(0,D.localize)(34,null,v):(0,D.localize)(35,null,v):y?(0,D.localize)(36,null,v):(0,D.localize)(37,null,v)):h<b?(v=Math.floor(h/R),f?v===1?y?(0,D.localize)(38,null,v):(0,D.localize)(39,null,v):y?(0,D.localize)(40,null,v):(0,D.localize)(41,null,v):v===1?y?(0,D.localize)(42,null,v):(0,D.localize)(43,null,v):y?(0,D.localize)(44,null,v):(0,D.localize)(45,null,v)):(v=Math.floor(h/b),f?v===1?y?(0,D.localize)(46,null,v):(0,D.localize)(47,null,v):y?(0,D.localize)(48,null,v):(0,D.localize)(49,null,v):v===1?y?(0,D.localize)(50,null,v):(0,D.localize)(51,null,v):y?(0,D.localize)(52,null,v):(0,D.localize)(53,null,v))}e.fromNow=E;function I(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(ne[121],ie([11,12]),function(Y,e){return Y.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,14,121]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(E,I){return I&&(E.stack||E.stacktrace)?L.localize(0,null,R(E),T(E.stack)||T(E.stacktrace)):R(E)}function T(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?L.localize(1,null,E.message):E.message||L.localize(2,null)}function b(E=null,I=!1){if(!E)return L.localize(3,null);if(Array.isArray(E)){const C=D.coalesce(E),f=b(C[0],I);return C.length>1?L.localize(4,null,f,C.length):f}if(n.isString(E))return E;if(E.detail){const C=E.detail;if(C.error)return A(C.error,I);if(C.exception)return A(C.exception,I)}return E.stack?A(E,I):E.message?E.message:L.localize(5,null)}e.toErrorMessage=b}),define(ne[122],ie([11,12]),function(Y,e){return Y.create("vs/base/node/processes",e)}),define(ne[76],ie([0,1,45,41,18,28,10,4,32,103,14,111,22,122]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return E.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return E.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function v(r,a){if(R.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};a&&(i.cwd=a);const t=D.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(o=>{t.once("error",s=>{o({success:!1,error:s})}),t.once("exit",(s,c)=>{o(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?h(i.status):1})}else if(R.isLinux||R.isMacintosh)try{const i=L.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Y).fsPath;return new Promise(t=>{D.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(o,s,c)=>{t(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function d(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=d;function g(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=g;class w{constructor(a,i,t,o){if(i!==void 0&&t!==void 0&&o!==void 0)this.cmd=a,this.args=i,this.shell=t,this.options=o;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(b.env).forEach(c=>{s[c]=b.env[c]}),Object.keys(this.options.env).forEach(c=>{s[c]=this.options.env[c]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const i=a.lastIndexOf(T.sep);return i!==-1&&(a=a.substring(i+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(b.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(i=>{let t,o;const s=new Promise((c,u)=>{t=c,o=u});if(i){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=D.exec(c,this.options,(u,p,P)=>{this.childProcess=null;const _=u;_&&_.killed?o({killed:this.terminateRequested,stdout:p.toString(),stderr:P.toString()}):this.handleExec(t,a,u,p,P)})}else{let c=null;const u=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,a,o);const P={terminated:this.terminateRequested};I.isNumber(p)&&(P.cmdCode=p),t(P)};if(this.shell&&R.isWindows){const p=A.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let P=!1,_=!1;const O=[];let F=this.ensureQuotes(this.cmd);O.push(F.value),P=F.quoted,this.args&&this.args.forEach(k=>{F=this.ensureQuotes(k),O.push(F.value),_=_&&F.quoted});const $=["/s","/c"];P?_?$.push('"'+O.join(" ")+'"'):O.length>1?$.push('"'+O[0]+'" '+O.slice(1).join(" ")):$.push('"'+O[0]+'"'):$.push(O.join(" ")),c=D.spawn(g(),$,p)}else this.cmd&&(c=D.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(I.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",p=>{this.childProcess=null,o({terminated:this.terminateRequested,error:p})}),c.pid&&(this.childProcess.on("close",u),this.handleSpawn(c,t,a,o,!0)))}return s})}handleClose(a,i,t,o){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,v(a,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const i=D.spawn(g(),["/s","/c"]);i.on("error",t=>a(!0)),i.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class m extends w{constructor(a,i,t,o){super(a,i,t,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,i,t,o,s){[o,s].forEach((c,u)=>{const p=new C.LineDecoder;p.write(c).forEach(O=>{i({line:O,source:u===0?0:1})});const _=p.end();_&&i({line:_,source:u===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,i,t,o,s){const c=new C.LineDecoder,u=new C.LineDecoder;a.stdout.on("data",p=>{c.write(p).forEach(_=>t({line:_,source:0}))}),a.stderr.on("data",p=>{u.write(p).forEach(_=>t({line:_,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=u}handleClose(a,i,t,o){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&t({line:s,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=m;function S(r){let a=[],i=!1;const t=function(o){if(i){a.push(o);return}(!r.send(o,c=>{if(c&&console.error(c),i=!1,a.length>0){const u=a.slice(0);a=[],u.forEach(p=>t(p))}})||R.isWindows)&&(i=!0)};return{send:t}}e.createQueuedSender=S;var l;(function(r){async function a(i,t,o){if(T.isAbsolute(i))return i;if(t===void 0&&(t=b.cwd()),T.dirname(i)!=="."||(o===void 0&&I.isString(b.env.PATH)&&(o=b.env.PATH.split(T.delimiter)),o===void 0||o.length===0))return T.join(t,i);async function c(u){if(await f.Promises.exists(u)){let p;try{p=await f.Promises.stat(u)}catch(P){P.message.startsWith("EACCES")&&(p=await f.Promises.lstat(u))}return p?!p.isDirectory():!1}return!1}for(let u of o){let p;if(T.isAbsolute(u)?p=T.join(u,i):p=T.join(t,u,i),await c(p))return p;let P=p+".com";if(await c(P)||(P=p+".exe",await c(P)))return P}return T.join(t,i)}r.findExecutable=a})(l=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,33,4,72,76]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function T(y,h){return y===1?n.isWindows?C():A.getWindowsShell(h):E(y,h)}e.getSystemShell=T;function R(y,h){return y===1?n.isWindows?f(h):A.getWindowsShell(h):E(y,h)}e.getSystemShellSync=R;let b=null;function E(y,h){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!b){let v;if(n.isWindows)v="/bin/bash";else{if(v=h.SHELL,!v)try{v=(0,D.userInfo)().shell}catch{}v||(v="sh"),v==="/bin/false"&&(v="/bin/bash")}b=v}return b}let I=null;async function C(){return I||(I=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),I}function f(y){if(I)return I;const h=n.isWindows&&parseFloat((0,D.release)())>=10,v=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${y.windir}\\${v?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?d:A.getWindowsShell(y)}}),define(ne[58],ie([0,1,45,5,17,23,107,9,3,2,28,76,36]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends f.ChannelServer{constructor(d){super({send:g=>{try{process.send&&process.send(g.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",g=>L.VSBuffer.wrap(Buffer.from(g,"base64")))},d);process.once("disconnect",()=>this.dispose())}}e.Server=y;class h{constructor(d,g){this.modulePath=d,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(w),this.child=null,this._client=null}getChannel(d){const g=this;return{call(w,m,S){return g.requestPromise(d,w,m,S)},listen(w,m){return g.requestEvent(d,w,m)}}}requestPromise(d,g,w,m=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const S=this.getCachedChannel(d),l=(0,n.createCancelablePromise)(i=>S.call(g,w,i)),r=m.onCancellationRequested(()=>l.cancel()),a=(0,E.toDisposable)(()=>l.cancel());return this.activeRequests.add(a),l.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),l}requestEvent(d,g,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let m;const S=new b.Emitter({onFirstListenerAdd:()=>{m=this.getCachedChannel(d).listen(g,w)(S.fire,S),this.activeRequests.add(m)},onLastListenerRemove:()=>{this.activeRequests.delete(m),m.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return S.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,C.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,d,g);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,T.isRemoteConsoleLog)(t)){(0,T.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(L.VSBuffer.wrap(Buffer.from(t,"base64")))});const S=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,l=t=>this.child&&this.child.connected&&S.send(t.buffer.toString("base64")),r=w.event,a={send:l,onMessage:r};this._client=new f.ChannelClient(a);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,o)=>{process.removeListener("exit",i),this.activeRequests.forEach(s=>(0,E.dispose)(s)),this.activeRequests.clear(),t!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:o})})}return this._client}getCachedChannel(d){let g=this.channels.get(d);return g||(g=this.client.getChannel(d),this.channels.set(d,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ne[124],ie([11,12]),function(Y,e){return Y.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(Y,e){return Y.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(Y,e){return Y.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(Y,e){return Y.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(Y,e){return Y.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(Y,e){return Y.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(Y,e){return Y.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(Y,e){return Y.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(Y,e){return Y.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var n;(function(T){T.Team="team",T.Internal="internal",T.Insiders="insider",T.Public="public"})(n=e.TargetPopulation||(e.TargetPopulation={}));var L;(function(T){T.Market="X-MSEdge-Market",T.CorpNet="X-FD-Corpnet",T.ApplicationVersion="X-VSCode-AppVersion",T.Build="X-VSCode-Build",T.ClientId="X-MSEdge-ClientId",T.ExtensionName="X-VSCode-ExtensionName",T.Language="X-VSCode-Language",T.TargetPopulation="X-VSCode-TargetPopulation"})(L=e.Filters||(e.Filters={}));class A{constructor(R,b,E,I){this.version=R,this.appName=b,this.machineId=E,this.targetPopulation=I}getFilterValue(R){switch(R){case L.ApplicationVersion:return this.version;case L.Build:return this.appName;case L.ClientId:return this.machineId;case L.Language:return D.language;case L.ExtensionName:return"vscode-core";case L.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(L);for(let E of b)R.set(E,this.getFilterValue(E));return R}}e.AssignmentFilterProvider=A}),define(ne[77],ie([0,1,57,54,18,10,32,19,7]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class E{constructor(v,d,g){this._args=v,this.paths=d,this.productService=g}get appRoot(){return(0,A.dirname)(L.FileAccess.asFileUri("",Y).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const v=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",v)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const v=T.env.VSCODE_PORTABLE;return v?b.URI.file((0,A.join)(v,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const v=this.args["builtin-extensions-dir"];return v?(0,A.resolve)(v):(0,A.normalize)((0,A.join)(L.FileAccess.asFileUri("",Y).fsPath,"..","extensions"))}get extensionsDownloadPath(){const v=this.args["extensions-download-dir"];return v?(0,A.resolve)(v):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const v=this.args["extensions-dir"];if(v)return(0,A.resolve)(v);const d=T.env.VSCODE_EXTENSIONS;if(d)return d;const g=T.env.VSCODE_PORTABLE;return g?(0,A.join)(g,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const v=this.args.extensionDevelopmentPath;if(Array.isArray(v))return v.map(d=>/^[^:/?#]+?:\/\//.test(d)?b.URI.parse(d):b.URI.file((0,A.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(v=>v==="ui"||v==="workspace"||v==="web"?v:"workspace")}get extensionTestsLocationURI(){const v=this.args.extensionTestsPath;if(v)return/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,A.normalize)(v))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const v=this.args["disable-extension"];if(v){if(typeof v=="string")return[v];if(Array.isArray(v)&&v.length>0)return v}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([n.memoize],E.prototype,"appRoot",null),de([n.memoize],E.prototype,"userHome",null),de([n.memoize],E.prototype,"userDataPath",null),de([n.memoize],E.prototype,"appSettingsHome",null),de([n.memoize],E.prototype,"tmpDir",null),de([n.memoize],E.prototype,"cacheHome",null),de([n.memoize],E.prototype,"userRoamingDataHome",null),de([n.memoize],E.prototype,"settingsResource",null),de([n.memoize],E.prototype,"userDataSyncHome",null),de([n.memoize],E.prototype,"userDataSyncLogResource",null),de([n.memoize],E.prototype,"sync",null),de([n.memoize],E.prototype,"machineSettingsResource",null),de([n.memoize],E.prototype,"globalStorageHome",null),de([n.memoize],E.prototype,"workspaceStorageHome",null),de([n.memoize],E.prototype,"keybindingsResource",null),de([n.memoize],E.prototype,"keyboardLayoutResource",null),de([n.memoize],E.prototype,"argvResource",null),de([n.memoize],E.prototype,"snippetsHome",null),de([n.memoize],E.prototype,"isExtensionDevelopment",null),de([n.memoize],E.prototype,"untitledWorkspacesHome",null),de([n.memoize],E.prototype,"installSourcePath",null),de([n.memoize],E.prototype,"builtinExtensionsPath",null),de([n.memoize],E.prototype,"extensionsPath",null),de([n.memoize],E.prototype,"extensionDevelopmentLocationURI",null),de([n.memoize],E.prototype,"extensionDevelopmentKind",null),de([n.memoize],E.prototype,"extensionTestsLocationURI",null),de([n.memoize],E.prototype,"debugExtensionHost",null),de([n.memoize],E.prototype,"serviceMachineIdResource",null),de([n.memoize],E.prototype,"telemetryLogResource",null),de([n.memoize],E.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=E;function I(h,v){return y(h["inspect-extensions"],h["inspect-brk-extensions"],5870,v,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function C(h,v){return y(h["inspect-search"],h["inspect-brk-search"],5876,v,h.extensionEnvironment)}e.parseSearchPort=C;function f(h,v){return y(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,v,h.extensionEnvironment)}e.parsePtyHostPort=f;function y(h,v,d,g,w,m){const l=Number(v||h)||(g?null:d),r=l?Boolean(!!v):!1;let a;if(m)try{a=JSON.parse(m)}catch{}return{port:l,break:r,debugId:w,env:a}}}),define(ne[150],ie([0,1,251,4,126]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const A={o:(0,L.localize)(0,null),e:(0,L.localize)(1,null),t:(0,L.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,L.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,L.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,L.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,L.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,L.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,L.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,L.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,L.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,L.localize)(11,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,L.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,L.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,L.localize)(14,null)},category:{type:"string",cat:"e",description:(0,L.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,L.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,L.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,L.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,L.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,L.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,L.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,L.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,L.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,L.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,L.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,L.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,L.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,L.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,L.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,L.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,L.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:["debugSearch"]},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"]},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,v,d=T){const g={},w=[],m=[];for(let a in v){const i=v[a];i.alias&&(g[a]=i.alias),i.type==="string"||i.type==="string[]"?(w.push(a),i.deprecates&&w.push(...i.deprecates)):i.type==="boolean"&&(m.push(a),i.deprecates&&m.push(...i.deprecates))}const S=D(h,{string:w,boolean:m,alias:g}),l={},r=S;l._=S._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in v){const i=v[a];i.alias&&delete r[i.alias];let t=r[a];if(i.deprecates)for(const o of i.deprecates)r.hasOwnProperty(o)&&(t||(t=r[o],t&&d.onDeprecatedOption(o,i.deprecationMessage||(0,L.localize)(33,null))),delete r[o]);typeof t!="undefined"&&(i.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):i.type==="string"&&Array.isArray(t)&&(t=t.pop(),d.onMultipleValues(a,t)),l[a]=t,i.deprecationMessage&&d.onDeprecatedOption(a,i.deprecationMessage)),delete r[a]}for(let a in r)d.onUnknownOption(a);return l}e.parseArgs=R;function b(h,v){let d="";return v.args&&(Array.isArray(v.args)?d=` <${v.args.join("> <")}>`:d=` <${v.args}>`),v.alias?`-${v.alias} --${h}${d}`:`--${h}${d}`}function E(h,v){let d=0,g=[];for(const l in h){const r=h[l],a=b(l,r);d=Math.max(d,a.length),g.push([a,r.description])}let w=d+2+1;if(v-w<25)return g.reduce((l,r)=>l.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let m=v-w-1,S=[];for(const l of g){let r=l[0],a=C(l[1],m),i=I(w-r.length-2);S.push("  "+r+i+a[0]);for(let t=1;t<a.length;t++)S.push(I(w)+a[t])}return S}e.formatOptions=E;function I(h){return" ".repeat(h)}function C(h,v){let d=[];for(;h.length;){let g=h.length<v?h.length:h.lastIndexOf(" ",v),w=h.slice(0,g).trim();h=h.slice(g),d.push(w)}return d}function f(h,v,d,g,w){const m=process.stdout.isTTY&&process.stdout.columns||80,S=w?.noInputFiles!==!0?`[${(0,L.localize)(34,null)}...]`:"",l=[`${h} ${d}`];l.push(""),l.push(`${(0,L.localize)(35,null)}: ${v} [${(0,L.localize)(36,null)}]${S}`),l.push(""),w?.noPipe!==!0&&(n.isWindows?l.push((0,L.localize)(37,null,v)):l.push((0,L.localize)(38,null,v)),l.push(""));const r={};for(const a in g){const i=g[a];if(i.description&&i.cat){let t=r[i.cat];t||(r[i.cat]=t={}),t[a]=i}}for(let a in r){const i=a;let t=r[i];t&&(l.push(A[i]),l.push(...E(t,m)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=f;function y(h,v){return`${h||(0,L.localize)(39,null)}
${v||(0,L.localize)(40,null)}
${process.arch}`}e.buildVersionMessage=y}),function(){"use strict";function Y(e,D,n,L){function A(R){const b=T(R),E=[b];return e.isAbsolute(b)||E.unshift(L),e.resolve(...E)}function T(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let E=process.env.VSCODE_APPDATA;if(E)return e.join(E,n);const I=R["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(E=process.env.APPDATA,!E){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");E=e.join(C,"AppData","Roaming")}break;case"darwin":E=e.join(D.homedir(),"Library","Application Support");break;case"linux":E=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(E,n)}return{getUserDataPath:A}}if(typeof define=="function")define(ne[151],ie([0,252,33,18,19,32]),function(e,D,n,L,A,T){const R=A.dirname(L.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(A.joinPath(R,"package.json").fsPath);return Y(D,n,b.name,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=Y(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[152],ie([0,1,33,77,151]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends n.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=A}),define(ne[153],ie([0,1,7]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,T=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function E(d){const g=d.match(T);return g?g[1]:null}function I(d){if(d.indexOf("://")===-1){const g=d.match(n);return g?E(g[2]):null}try{const g=D.URI.parse(d);if(g.authority)return E(g.authority)}catch{}return null}function C(d,g){const w=new Set;let m;for(;m=R.exec(d);){const l=I(m[1]);l&&w.add(l)}const S=new Set(g);return Array.from(w).map(l=>S.has(l)?l:l.replace(b,"a"))}e.getDomainsOfRemotes=C;function f(d){const g=d.match(A);return g?g[2]:null}function y(d,g,w){return d&&g?(w&&g.endsWith(".git")&&(g=g.substr(0,g.length-4)),g.indexOf("/")===0?`${d}${g}`:`${d}/${g}`):null}function h(d,g){if(d.indexOf("://")===-1){const w=d.match(L);if(w)return y(w[2],w[3],g)}try{const w=D.URI.parse(d);if(w.authority)return y(f(w.authority),w.path,g)}catch{}return null}function v(d,g=!1){const w=[];let m;for(;m=R.exec(d);){const S=h(m[1],g);S&&w.push(S)}return w}e.getRemotes=v}),define(ne[154],ie([0,1,28]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const n=/^%([\w\d.-]+)%$/i;function L(A,T){const R=b=>{if(typeof b!="string")return;const E=n.exec(b);if(!E)return;const I=T[E[1]]??b;return typeof I=="string"?I:typeof I.message=="string"?I.message:b};return(0,D.cloneAndChange)(A,R)}e.localizeManifest=L}),define(ne[155],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,T,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[A,T,R,b])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(A){this.service=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,R){switch(T){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[78],ie([0,1,135]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const n=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function A(f){return f=f.trim(),f==="*"||n.test(f)}e.isValidVersionStr=A;function T(f){if(!A(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=f.match(n);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=T;function R(f){if(!f)return null;let y=f.majorBase,h=f.majorMustEqual,v=f.minorBase,d=f.minorMustEqual,g=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(y===0||(d=!1),w=!1);let m=0;if(f.preRelease){const S=L.exec(f.preRelease);if(S){const[,l,r,a]=S;m=Date.UTC(Number(l),Number(r)-1,Number(a))}}return{majorBase:y,majorMustEqual:h,minorBase:v,minorMustEqual:d,patchBase:g,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:m}}e.normalizeVersion=R;function b(f,y,h){let v;typeof f=="string"?v=R(T(f)):v=f;let d;y instanceof Date?d=y.getTime():typeof y=="string"&&(d=new Date(y).getTime());let g;if(typeof h=="string"?g=R(T(h)):g=h,!v||!g)return!1;let w=v.majorBase,m=v.minorBase,S=v.patchBase,l=g.majorBase,r=g.minorBase,a=g.patchBase,i=g.notBefore,t=g.majorMustEqual,o=g.minorMustEqual,s=g.patchMustEqual;return g.isMinimum?w>l?!0:w<l?!1:m>r?!0:m<r||d&&d<i?!1:S>=a:(w===1&&l===0&&(!t||!o||!s)&&(l=1,r=0,a=0,t=!0,o=!1,s=!1),w<l?!1:w>l?!t:m<r?!1:m>r?!o:S<a?!1:S>a?!s:!(d&&d<i))}e.isValidVersion=b;function E(f,y,h,v){return h.isBuiltin||typeof h.main=="undefined"?!0:C(f,y,h.engines.vscode,v)}e.isValidExtensionVersion=E;function I(f,y,h){return f==="*"||C(y,h,f)}e.isEngineValid=I;function C(f,y,h,v=[]){let d=R(T(h));if(!d)return v.push(D.localize(0,null,h)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return v.push(D.localize(1,null,h)),!1}else if(!d.majorMustEqual)return v.push(D.localize(2,null,h)),!1;return b(f,y,d)?!0:(v.push(D.localize(3,null,f,h)),!1)}}),define(ne[51],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(L,A=[],T=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=D}),define(ne[79],ie([0,1,51]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function L(T,R,b){R instanceof D.SyncDescriptor||(R=new D.SyncDescriptor(R,[],b)),n.push([T,R])}e.registerSingleton=L;function A(){return n}e.getSingletonServiceDescriptors=A}),define(ne[156],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=D;class n{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let T of this._nodes.values())T.outgoing.size===0&&A.push(T);return A}insertEdge(A,T){const R=this.lookupOrInsertNode(A),b=this.lookupOrInsertNode(T);R.outgoing.set(this._hashFn(T),b),b.incoming.set(this._hashFn(A),R)}removeNode(A){const T=this._hashFn(A);this._nodes.delete(T);for(let R of this._nodes.values())R.outgoing.delete(T),R.incoming.delete(T)}lookupOrInsertNode(A){const T=this._hashFn(A);let R=this._nodes.get(T);return R||(R=new D(A),this._nodes.set(T,R)),R}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[T,R]of this._nodes)A.push(`${T}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,T]of this._nodes){const R=new Set([A]),b=this._findCycle(T,R);if(b)return b}}_findCycle(A,T){for(let[R,b]of A.outgoing){if(T.has(R))return[...T,R].join(" -> ");T.add(R);const E=this._findCycle(b,T);if(E)return E;T.delete(R)}}}e.Graph=n}),define(ne[6],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=R})(D=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function n(T,R,b,E){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:T,index:b,optional:E}):(R[D.DI_DEPENDENCIES]=[{id:T,index:b,optional:E}],R[D.DI_TARGET]=R)}function L(T){if(D.serviceIds.has(T))return D.serviceIds.get(T);const R=function(b,E,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(R,b,I,!1)};return R.toString=()=>T,D.serviceIds.set(T,R),R}e.createDecorator=L;function A(T){return T}e.refineServiceDecorator=A}),define(ne[157],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(ne[20],ie([0,1,14,7,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,L.createDecorator)("configurationService");function A(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationOverrides=A;function T(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||D.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=T;var R;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function E(d,g){const w=Object.create(null);for(let m in d)I(w,m,d[m],g);return w}e.toValuesTree=E;function I(d,g,w,m){const S=g.split("."),l=S.pop();let r=d;for(let a=0;a<S.length;a++){let i=S[a],t=r[i];switch(typeof t){case"undefined":t=r[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${g} as ${S.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[l]=w}catch{m(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function C(d,g){const w=g.split(".");f(d,w)}e.removeFromValueTree=C;function f(d,g){const w=g.shift();if(g.length===0){delete d[w];return}if(Object.keys(d).indexOf(w)!==-1){const m=d[w];typeof m=="object"&&!Array.isArray(m)&&(f(m,g),Object.keys(m).length===0&&delete d[w])}}function y(d,g,w){function m(r,a){let i=r;for(const t of a){if(typeof i!="object"||i===null)return;i=i[t]}return i}const S=g.split("."),l=m(d,S);return typeof l=="undefined"?w:l}e.getConfigurationValue=y;function h(d,g,w){Object.keys(g).forEach(m=>{m!=="__proto__"&&(m in d?D.isObject(d[m])&&D.isObject(g[m])?h(d[m],g[m],w):w&&(d[m]=g[m]):d[m]=g[m])})}e.merge=h;function v(d,g,w){const m=d.inspect(g),S=d.inspect(w);return typeof m.userValue!="undefined"||typeof m.workspaceValue!="undefined"||typeof m.workspaceFolderValue!="undefined"?m.value:typeof S.userValue!="undefined"||typeof S.workspaceValue!="undefined"||typeof S.workspaceFolderValue!="undefined"?S.value:m.defaultValue}e.getMigratedSettingValue=v}),define(ne[158],ie([0,1,4,26,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=D.userAgent||"";const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",D.isMacintosh),T.set("isLinux",D.isLinux),T.set("isWindows",D.isWindows),T.set("isWeb",D.isWeb),T.set("isMacNative",D.isMacintosh&&!D.isWeb),T.set("isEdge",A.indexOf("Edg/")>=0),T.set("isFirefox",A.indexOf("Firefox")>=0),T.set("isChrome",A.indexOf("Chrome")>=0),T.set("isSafari",A.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var b;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return f.INSTANCE}static true(){return y.INSTANCE}static has(k){return h.create(k)}static equals(k,M){return v.create(k,M)}static notEquals(k,M){return w.create(k,M)}static regex(k,M){return t.create(k,M)}static in(k,M){return d.create(k,M)}static not(k){return m.create(k)}static and(...k){return c.create(k,null)}static or(...k){return u.create(k,null,!0)}static greater(k,M){return l.create(k,M)}static greaterEquals(k,M){return r.create(k,M)}static smaller(k,M){return a.create(k,M)}static smallerEquals(k,M){return i.create(k,M)}static deserialize(k,M=!1){if(!!k)return this._deserializeOrExpression(k,M)}static _deserializeOrExpression(k,M){let j=k.split("||");return u.create(j.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(k,M){let j=k.split("&&");return c.create(j.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(k,M){if(k=k.trim(),k.indexOf("!=")>=0){let j=k.split("!=");return w.create(j[0].trim(),this._deserializeValue(j[1],M))}if(k.indexOf("==")>=0){let j=k.split("==");return v.create(j[0].trim(),this._deserializeValue(j[1],M))}if(k.indexOf("=~")>=0){let j=k.split("=~");return t.create(j[0].trim(),this._deserializeRegexValue(j[1],M))}if(k.indexOf(" in ")>=0){let j=k.split(" in ");return d.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(k)){const j=k.split(">=");return r.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(k)){const j=k.split(">");return l.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(k)){const j=k.split("<=");return i.create(j[0].trim(),j[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(k)){const j=k.split("<");return a.create(j[0].trim(),j[1].trim())}return/^\!\s*/.test(k)?m.create(k.substr(1).trim()):h.create(k)}static _deserializeValue(k,M){if(k=k.trim(),k==="true")return!0;if(k==="false")return!1;let j=/^'([^']*)'$/.exec(k);return j?j[1].trim():k}static _deserializeRegexValue(k,M){if((0,n.isFalsyOrWhitespace)(k)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let j=k.indexOf("/"),U=k.lastIndexOf("/");if(j===U||j<0){if(M)throw new Error(`bad regexp-value '${k}', missing /-enclosure`);return console.warn(`bad regexp-value '${k}', missing /-enclosure`),null}let G=k.slice(j+1,U),K=k[U+1]==="i"?"i":"";try{return new RegExp(G,K)}catch(x){if(M)throw new Error(`bad regexp-value '${k}', parse error: ${x}`);return console.warn(`bad regexp-value '${k}', parse error: ${x}`),null}}}e.ContextKeyExpr=E;function I($,k){const M=$?$.substituteConstants():void 0,j=k?k.substituteConstants():void 0;return!M&&!j?!0:!M||!j?!1:M.equals(j)}e.expressionsAreEqualWithConstantSubstitution=I;function C($,k){return $.cmp(k)}class f{constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return y.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class y{constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=y,y.INSTANCE=new y;class h{constructor(k,M){this.key=k,this.negated=M,this.type=2}static create(k,M=null){const j=T.get(k);return typeof j=="boolean"?j?y.INSTANCE:f.INSTANCE:new h(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?y.INSTANCE:f.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.negated||(this.negated=m.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class v{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=4}static create(k,M,j=null){if(typeof M=="boolean")return M?h.create(k,j):m.create(k,j);const U=T.get(k);return typeof U=="boolean"?M===(U?"true":"false")?y.INSTANCE:f.INSTANCE:new v(k,M,j)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?y.INSTANCE:f.INSTANCE}return this}evaluate(k){return k.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(k){return k.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=v;class d{constructor(k,M){this.key=k,this.valueKey=M,this.type=10,this.negated=null}static create(k,M){return new d(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.valueKey,k.key,k.valueKey)}equals(k){return k.type===this.type?this.key===k.key&&this.valueKey===k.valueKey:!1}substituteConstants(){return this}evaluate(k){const M=k.getValue(this.valueKey),j=k.getValue(this.key);return Array.isArray(M)?M.indexOf(j)>=0:typeof j=="string"&&typeof M=="object"&&M!==null?R.call(M,j):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(k){return k.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=g.create(this)),this.negated}}e.ContextKeyInExpr=d;class g{constructor(k){this._actual=k,this.type=11}static create(k){return new g(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new g(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class w{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=5}static create(k,M,j=null){if(typeof M=="boolean")return M?m.create(k,j):h.create(k,j);const U=T.get(k);return typeof U=="boolean"?M===(U?"true":"false")?f.INSTANCE:y.INSTANCE:new w(k,M,j)}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){const k=T.get(this.key);if(typeof k=="boolean"){const M=k?"true":"false";return this.value===M?f.INSTANCE:y.INSTANCE}return this}evaluate(k){return k.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(k){return k.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=v.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class m{constructor(k,M){this.key=k,this.negated=M,this.type=3}static create(k,M=null){const j=T.get(k);return typeof j=="boolean"?j?f.INSTANCE:y.INSTANCE:new m(k,M)}cmp(k){return k.type!==this.type?this.type-k.type:P(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=T.get(this.key);return typeof k=="boolean"?k?f.INSTANCE:y.INSTANCE:this}evaluate(k){return!k.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(k){return k.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=m;function S($,k){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?k($):f.INSTANCE}class l{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=12}static create(k,M,j=null){return S(M,U=>new l(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=i.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class r{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=13}static create(k,M,j=null){return S(M,U=>new r(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(k){return k.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=14}static create(k,M,j=null){return S(M,U=>new a(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class i{constructor(k,M,j){this.key=k,this.value=M,this.negated=j,this.type=15}static create(k,M,j=null){return S(M,U=>new i(k,U,j))}cmp(k){return k.type!==this.type?this.type-k.type:_(this.key,this.value,k.key,k.value)}equals(k){return k.type===this.type?this.key===k.key&&this.value===k.value:!1}substituteConstants(){return this}evaluate(k){return typeof this.value=="string"?!1:parseFloat(k.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(k){return k.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=i;class t{constructor(k,M){this.key=k,this.regexp=M,this.type=7,this.negated=null}static create(k,M){return new t(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.key<k.key)return-1;if(this.key>k.key)return 1;const M=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return M<j?-1:M>j?1:0}equals(k){if(k.type===this.type){const M=this.regexp?this.regexp.source:"",j=k.regexp?k.regexp.source:"";return this.key===k.key&&M===j}return!1}substituteConstants(){return this}evaluate(k){let M=k.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const k=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${k}`}keys(){return[this.key]}map(k){return k.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=o.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class o{constructor(k){this._actual=k,this.type=8}static create(k){return new o(k)}cmp(k){return k.type!==this.type?this.type-k.type:this._actual.cmp(k._actual)}equals(k){return k.type===this.type?this._actual.equals(k._actual):!1}substituteConstants(){return this}evaluate(k){return!this._actual.evaluate(k)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(k){return new o(this._actual.map(k))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=o;function s($){let k=null;for(let M=0,j=$.length;M<j;M++){const U=$[M].substituteConstants();if($[M]!==U&&k===null){k=[];for(let G=0;G<M;G++)k[G]=$[G]}k!==null&&(k[M]=U)}return k===null?$:k}class c{constructor(k,M){this.expr=k,this.negated=M,this.type=6}static create(k,M){return c._normalizeArr(k,M)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,j=this.expr.length;M<j;M++){const U=C(this.expr[M],k.expr[M]);if(U!==0)return U}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,j=this.expr.length;M<j;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:c.create(k,this.negated)}evaluate(k){for(let M=0,j=this.expr.length;M<j;M++)if(!this.expr[M].evaluate(k))return!1;return!0}static _normalizeArr(k,M){const j=[];let U=!1;for(const G of k)if(!!G){if(G.type===1){U=!0;continue}if(G.type===0)return f.INSTANCE;if(G.type===6){j.push(...G.expr);continue}j.push(G)}if(j.length===0&&U)return y.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(C);for(let G=1;G<j.length;G++)j[G-1].equals(j[G])&&(j.splice(G,1),G--);if(j.length===1)return j[0];for(;j.length>1;){const G=j[j.length-1];if(G.type!==9)break;j.pop();const K=j.pop(),x=j.length===0,q=u.create(G.expr.map(X=>c.create([X,K],null)),null,x);q&&(j.push(q),j.sort(C))}return j.length===1?j[0]:new c(j,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new c(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){const k=[];for(let M of this.expr)k.push(M.negate());this.negated=u.create(k,this,!0)}return this.negated}}class u{constructor(k,M){this.expr=k,this.negated=M,this.type=9}static create(k,M,j){return u._normalizeArr(k,M,j)}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let M=0,j=this.expr.length;M<j;M++){const U=C(this.expr[M],k.expr[M]);if(U!==0)return U}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let M=0,j=this.expr.length;M<j;M++)if(!this.expr[M].equals(k.expr[M]))return!1;return!0}return!1}substituteConstants(){const k=s(this.expr);return k===this.expr?this:u.create(k,this.negated,!1)}evaluate(k){for(let M=0,j=this.expr.length;M<j;M++)if(this.expr[M].evaluate(k))return!0;return!1}static _normalizeArr(k,M,j){let U=[],G=!1;if(k){for(let K=0,x=k.length;K<x;K++){const q=k[K];if(!!q){if(q.type===0){G=!0;continue}if(q.type===1)return y.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&G)return f.INSTANCE;U.sort(C)}if(U.length!==0){if(U.length===1)return U[0];for(let K=1;K<U.length;K++)U[K-1].equals(U[K])&&(U.splice(K,1),K--);if(U.length===1)return U[0];if(j){for(let K=0;K<U.length;K++)for(let x=K+1;x<U.length;x++)O(U[K],U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0]}return new u(U,M)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(let M of this.expr)k.push(...M.keys());return k}map(k){return new u(this.expr.map(M=>M.map(k)),null)}negate(){if(!this.negated){let k=[];for(let M of this.expr)k.push(M.negate());for(;k.length>1;){const M=k.shift(),j=k.shift(),U=[];for(const K of F(M))for(const x of F(j))U.push(c.create([K,x],null));const G=k.length===0;k.unshift(u.create(U,null,G))}this.negated=k[0]}return this.negated}}class p extends h{constructor(k,M,j){super(k,null);this._defaultValue=M,typeof j=="object"?p._info.push({...j,key:k}):j!==!0&&p._info.push({key:k,description:j,type:M!=null?typeof M:void 0})}static all(){return p._info.values()}bindTo(k){return k.createKey(this.key,this._defaultValue)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return v.create(this.key,k)}notEqualsTo(k){return w.create(this.key,k)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P($,k){return $<k?-1:$>k?1:0}function _($,k,M,j){return $<M?-1:$>M?1:k<j?-1:k>j?1:0}function O($,k){if(k.type===6&&$.type!==9&&$.type!==6){for(const U of k.expr)if($.equals(U))return!0}const M=$.negate(),j=F(M).concat(F(k));j.sort(C);for(let U=0;U<j.length;U++){const K=j[U].negate();for(let x=U+1;x<j.length;x++){const q=j[x];if(K.equals(q))return!0}}return!1}e.implies=O;function F($){return $.type===9?$.expr:[$]}}),define(ne[80],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n}),define(ne[81],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(ne[15],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[30],ie([0,1,18,130,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var A;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));function T(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=T;function R(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function b(m,S){switch(m){case 3:return S==="x64"?"win32-x64":S==="ia32"?"win32-ia32":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function E(m,S){return S==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=E;function I(m,S,l){return E(S,l)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===l?!0:C(l).includes(m)}e.isTargetPlatformCompatible=I;function C(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=C;function f(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=f;var y;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var h;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var v;(function(m){m.Install="install",m.Uninstall="uninstall"})(v=e.StatisticType||(e.StatisticType={}));var d;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var g;(function(m){m.Unsupported="Unsupported",m.UnsupportedPreRelease="UnsupportedPreRelease",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(g=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(S,l){super(S);this.code=l,this.name=l}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",Y).toString(!0),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,n.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(ne[159],ie([0,1,3,2,28,7,110,30]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(v,d){return A.URI.revive(d?d.transformIncoming(v):v)}function E(v,d){return d?d.transformOutgoingURI(v):v}function I(v,d){d=d||T.DefaultURITransformer;const g=v.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...v,manifest:void 0},d),manifest:g}}function C(v,d){return d?(0,L.cloneAndChange)(v,g=>g instanceof A.URI?d.transformOutgoingURI(g):void 0):v}class f{constructor(d,g){this.service=d,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(d.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(d.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(d.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(d.onDidUninstallExtension,!0)}listen(d,g){const w=this.getUriTransformer(d);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,m=>m.map(S=>({...S,local:S.local?C(S.local,w):S.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(d,g,w){const m=this.getUriTransformer(d);switch(g){case"zip":return this.service.zip(I(w[0],m)).then(S=>E(S,m));case"unzip":return this.service.unzip(b(w[0],m));case"install":return this.service.install(b(w[0],m),w[1]);case"getManifest":return this.service.getManifest(b(w[0],m));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(I(w[0],m),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(w[0],m));case"getInstalled":return this.service.getInstalled(w[0]).then(S=>S.map(l=>C(l,m)));case"updateMetadata":return this.service.updateMetadata(I(w[0],m),w[1]).then(S=>C(S,m));case"updateExtensionScope":return this.service.updateExtensionScope(I(w[0],m),w[1]).then(S=>C(S,m));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class y extends n.Disposable{constructor(d){super();this.channel=d,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(w=>({...w,local:w.local?I(w.local,null):w.local,source:this.isUriComponents(w.source)?A.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire(g))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire(g)))}isUriComponents(d){return d?typeof d.path=="string"&&typeof d.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(d){const g=await this.getTargetPlatform();return d.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,d.allTargetPlatforms,g))}zip(d){return Promise.resolve(this.channel.call("zip",[d]).then(g=>A.URI.revive(g)))}unzip(d){return Promise.resolve(this.channel.call("unzip",[d]))}install(d,g){return Promise.resolve(this.channel.call("install",[d,g])).then(w=>I(w,null))}getManifest(d){return Promise.resolve(this.channel.call("getManifest",[d]))}installFromGallery(d,g){return Promise.resolve(this.channel.call("installFromGallery",[d,g])).then(w=>I(w,null))}uninstall(d,g){return Promise.resolve(this.channel.call("uninstall",[d,g]))}reinstallFromGallery(d){return Promise.resolve(this.channel.call("reinstallFromGallery",[d]))}getInstalled(d=null){return Promise.resolve(this.channel.call("getInstalled",[d])).then(g=>g.map(w=>I(w,null)))}updateMetadata(d,g){return Promise.resolve(this.channel.call("updateMetadata",[d,g])).then(w=>I(w,null))}updateExtensionScope(d,g){return Promise.resolve(this.channel.call("updateExtensionScope",[d,g])).then(w=>I(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=y;class h{constructor(d){this.service=d}listen(d,g){throw new Error("Invalid listen")}call(d,g,w){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(ne[82],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function L(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var A;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],ie([0,1,39,10,26,14,7,137,6]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function E(U){return U.create===!0}e.isFileOpenForWriteOptions=E;var I;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var C;(function(U){U[U.Readonly=1]="Readonly"})(C=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=y;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function v(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;function g(U){return y(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(G,K){super(G);this.code=K}}e.FileSystemProviderError=m;function S(U,G){const K=new m(U.toString(),G);return r(K,G),K}e.createFileSystemProviderError=S;function l(U){return U||S((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function r(U,G){return U.name=G?`${G} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function a(U){if(!U)return w.Unknown;if(U instanceof m)return U.code;const G=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!G)return w.Unknown;switch(G[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function i(U){if(U instanceof p)return U.fileOperationResult;switch(a(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class o{constructor(G,K,x){this.resource=G,this.operation=K,this.target=x}isOperation(G){return this.operation===G}}e.FileOperationEvent=o;var s;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class c{constructor(G,K){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=G;const x=new Map;for(const q of G){const X=x.get(q.type);switch(X?X.push([q.resource,q]):x.set(q.type,[[q.resource,q]]),q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}}for(const[q,X]of x)switch(q){case 1:this.added=D.TernarySearchTree.forUris(()=>K),this.added.fill(X);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>K),this.updated.fill(X);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>K),this.deleted.fill(X);break}}contains(G,...K){return this.doContains(G,{includeChildren:!1},...K)}affects(G,...K){return this.doContains(G,{includeChildren:!0},...K)}doContains(G,K,...x){if(!G)return!1;const q=x.length>0;return!!((!q||x.includes(1))&&(this.added?.get(G)||K.includeChildren&&this.added?.findSuperstr(G))||(!q||x.includes(0))&&(this.updated?.get(G)||K.includeChildren&&this.updated?.findSuperstr(G))||(!q||x.includes(2))&&(this.deleted?.findSubstr(G)||K.includeChildren&&this.deleted?.findSuperstr(G)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function u(U,G,K){return!U||!G||U===G||G.length>U.length?!1:(G.charAt(G.length-1)!==n.sep&&(G+=n.sep),K?(0,L.startsWithIgnoreCase)(U,G):U.indexOf(G)===0)}e.isParent=u;class p extends Error{constructor(G,K,x){super(G);this.fileOperationResult=K,this.options=x}}e.FileOperationError=p;class P extends p{constructor(G,K,x){super(G,2,x);this.stat=K}}e.NotModifiedSinceFileOperationError=P;var _;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(_=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=F;async function $(U,G){if(!G.hasProvider(T.URI.from({scheme:U.scheme})))return new Promise(K=>{const x=G.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(x.dispose(),K())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class k{static formatSize(G){return(0,A.isNumber)(G)||(G=0),G<k.KB?(0,R.localize)(1,null,G.toFixed(0)):G<k.MB?(0,R.localize)(2,null,(G/k.KB).toFixed(2)):G<k.GB?(0,R.localize)(3,null,(G/k.MB).toFixed(2)):G<k.TB?(0,R.localize)(4,null,(G/k.GB).toFixed(2)):(0,R.localize)(5,null,(G/k.TB).toFixed(2))}}e.ByteSize=k,k.KB=1024,k.MB=k.KB*k.KB,k.GB=k.MB*k.KB,k.TB=k.GB*k.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function j(U){return{maxFileSize:U===0?300*k.MB:16*k.GB,maxHeapSize:U===0?700*k.MB:2*700*k.MB}}e.getPlatformLimits=j});var J=this&&this.__param||function(Y,e){return function(D,n){e(D,n,Y)}};define(ne[160],ie([0,1,83,40,13]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((E,I)=>{const C=(0,D.createHash)("md5");(0,n.listenStream)(b,{onData:f=>C.update(f.buffer),onError:f=>I(f),onEnd:()=>E(C.digest("base64").replace(/=+$/,""))})})}};A=de([J(0,L.IFileService)],A),e.ChecksumService=A}),define(ne[161],ie([0,1,253,127,150,13]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function T(f,y){const h={onUnknownOption:d=>{console.warn((0,n.localize)(0,null,d))},onMultipleValues:(d,g)=>{console.warn((0,n.localize)(1,null,d,g))},onDeprecatedOption:(d,g)=>{console.warn((0,n.localize)(2,null,d,g))}},v=(0,L.parseArgs)(f,L.OPTIONS,y?h:void 0);return v.goto&&v._.forEach(d=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,n.localize)(3,null))),v["max-memory"]&&D(parseInt(v["max-memory"])>=A.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${A.MIN_MAX_MEMORY_SIZE_MB} MB.`),v}function R(f){const y=f.findIndex(h=>!/^-/.test(h));if(y>-1)return[...f.slice(0,y),...f.slice(y+1)]}function b(f){let[,...y]=f;process.env.VSCODE_DEV&&(y=R(y)||[]);const h=!C(process.env);return T(y,h)}e.parseMainProcessArgv=b;function E(f){const[,,...y]=f;return T(y,!0)}e.parseCLIProcessArgv=E;function I(f,...y){const h=f.indexOf("--");return h===-1?f.push(...y):f.splice(h,0,...y),f}e.addArg=I;function C(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=C}),define(ne[162],ie([0,1,45,10,128,23,37,9,4,29,123,161,5]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let h;async function v(g,w,m){return w["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(m)&&!w["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(m)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(S,l)=>{const r=new A.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),l(new Error((0,L.localize)(0,null)))},y);try{S(await d(g,r.token))}catch(i){!(0,R.isCancellationError)(i)&&!r.token.isCancellationRequested?l(new Error((0,L.localize)(1,null,(0,T.toErrorMessage)(i)))):S({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=v;async function d(g,w){const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const l=(0,E.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(l+"(.*)"+l),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};g.trace("getUnixShellEnvironment#env",a);const i=await(0,I.getSystemShell)(b.OS,a);return g.trace("getUnixShellEnvironment#shell",i),new Promise((t,o)=>{if(w.isCancellationRequested)return o((0,R.canceled)());const s=(0,n.basename)(i);let c,u;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(s)?(c=`& '${process.execPath}' ${p} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,u=["-Login","-Command"]):(c=`'${process.execPath}' ${p} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,s==="tcsh"?u=["-ic"]:u=["-ilc"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(u),c);const P=(0,D.spawn)(i,[...u,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(P.kill(),o((0,R.canceled)()))),P.on("error",F=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(F)),o(F)});const _=[];P.stdout.on("data",F=>_.push(F));const O=[];P.stderr.on("data",F=>O.push(F)),P.on("close",(F,$)=>{const k=Buffer.concat(_).toString("utf8");g.trace("getUnixShellEnvironment#raw",k);const M=Buffer.concat(O).toString("utf8");if(M.trim()&&g.trace("getUnixShellEnvironment#stderr",M),F||$)return o(new Error((0,L.localize)(2,null,F,$)));const j=r.exec(k),U=j?j[1]:"{}";try{const G=JSON.parse(U);m?G.ELECTRON_RUN_AS_NODE=m:delete G.ELECTRON_RUN_AS_NODE,S?G.ELECTRON_NO_ATTACH_CONSOLE=S:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){g.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(G)),o(G)}})})}}),define(ne[163],ie([0,1,17,37,9,3,2,40,7,29,13]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class C extends T.Disposable{constructor(y,h){super();this.channel=y,this.extraCapabilities=h,this.onDidChangeCapabilities=A.Event.None,this._onDidChange=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,E.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,h){const{buffer:v}=await this.channel.call("readFile",[y,h]);return v}readFileStream(y,h,v){const d=(0,R.newWriteableStream)(w=>D.VSBuffer.concat(w.map(m=>D.VSBuffer.wrap(m))).buffer),g=this.channel.listen("readFileStream",[y,h])(w=>{if(w instanceof D.VSBuffer)d.write(w.buffer);else{if(w==="end")d.end();else{let m=w;m instanceof Error||(m=(0,I.createFileSystemProviderError)((0,n.toErrorMessage)(m),I.FileSystemProviderErrorCode.Unknown)),d.error(m),d.end()}g.dispose()}});return v.onCancellationRequested(()=>{d.error((0,L.canceled)()),d.end(),g.dispose()}),d}writeFile(y,h,v){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(h),v])}open(y,h){return this.channel.call("open",[y,h])}close(y){return this.channel.call("close",[y])}async read(y,h,v,d,g){const[w,m]=await this.channel.call("read",[y,h,g]);return v.set(w.buffer.slice(0,m),d),m}write(y,h,v,d,g){return this.channel.call("write",[y,h,D.VSBuffer.wrap(v),d,g])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,h){return this.channel.call("delete",[y,h])}rename(y,h,v){return this.channel.call("rename",[y,h,v])}copy(y,h,v){return this.channel.call("copy",[y,h,v])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const h=y;this._onDidChange.fire(h.map(v=>({resource:b.URI.revive(v.resource),type:v.type})))}else{const h=y;this._onDidWatchError.fire(h)}}))}watch(y,h){const v=(0,E.generateUuid)();return this.channel.call("watch",[this.sessionId,v,y,h]),(0,T.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,v]))}}e.DiskFileSystemProviderClient=C}),define(ne[84],ie([0,1,17,9,138,13]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(I,C,f,y,h,v){let d;try{await R(I,C,f,y,h,v)}catch(g){d=g}finally{d&&h.errorTransformer&&(d=h.errorTransformer(d)),typeof d!="undefined"&&f.error(d),f.end()}}e.readFileIntoStream=T;async function R(I,C,f,y,h,v){b(v);const d=await I.open(C,{create:!1});try{b(v);let g=0,w=0,m=h&&typeof h.length=="number"?h.length:void 0,S=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),l=h&&typeof h.position=="number"?h.position:0,r=0;do w=await I.read(d,l,S.buffer,r,S.byteLength-r),l+=w,r+=w,g+=w,typeof m=="number"&&(m-=w),r===S.byteLength&&(await f.write(y(S)),S=D.VSBuffer.alloc(Math.min(h.bufferSize,typeof m=="number"?m:h.bufferSize)),r=0);while(w>0&&(typeof m!="number"||m>0)&&b(v)&&E(g,h));if(r>0){let a=r;typeof m=="number"&&(a=Math.min(r,m)),f.write(y(S.slice(0,a)))}}catch(g){throw(0,A.ensureFileSystemProviderError)(g)}finally{await I.close(d)}}function b(I){if(I.isCancellationRequested)throw(0,n.canceled)();return!0}function E(I,C){if(C?.limits){if(typeof C.limits.memory=="number"&&I>C.limits.memory)throw(0,A.createFileSystemProviderError)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&I>C.limits.size)throw(0,A.createFileSystemProviderError)((0,L.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[52],ie([0,1,2,4,7,13]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function T(y){return y.recursive===!0}e.isRecursiveWatchRequest=T;class R extends D.Disposable{constructor(h,v,d,g){super();this.onFileChanges=h,this.onLogMessage=v,this.verboseLogging=d,this.options=g,this.watcherDisposables=this._register(new D.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const h=new D.DisposableStore;this.watcherDisposables.value=h,this.watcher=this.createWatcher(h),this.watcher.setVerboseLogging(this.verboseLogging),h.add(this.watcher.onDidChangeFile(v=>this.onFileChanges(v))),h.add(this.watcher.onDidLogMessage(v=>this.onLogMessage(v))),h.add(this.watcher.onDidError(v=>this.onError(v)))}onError(h){this.options.restartOnError?this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${h}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${h}`):this.error(h)}restart(h){this.restartCounter++,this.init(),this.watch(h)}async watch(h){this.requests=h,await this.watcher?.watch(h)}async setVerboseLogging(h){this.verboseLogging=h,await this.watcher?.setVerboseLogging(h)}error(h){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${h}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=R,R.MAX_RESTARTS=5;class b extends R{constructor(h,v,d){super(h,v,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=b;class E extends R{constructor(h,v,d){super(h,v,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=E;function I(y){return y.map(h=>({type:h.type,resource:L.URI.file(h.path)}))}e.toFileChanges=I;function C(y){const h=new f;for(const v of y)h.processEvent(v);return h.coalesce()}e.coalesceEvents=C;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(h){return n.isLinux?h.path:h.path.toLowerCase()}processEvent(h){const v=this.mapPathToChange.get(this.toKey(h));let d=!1;if(v){const g=v.type,w=h.type;v.path!==h.path&&(h.type===2||h.type===1)?d=!0:g===1&&w===2?(this.mapPathToChange.delete(this.toKey(h)),this.coalesced.delete(v)):g===2&&w===1?v.type=0:g===1&&w===0||(v.type=w)}else d=!0;d&&(this.coalesced.add(h),this.mapPathToChange.set(this.toKey(h),h))}coalesce(){const h=[],v=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(h.push(d),!1):!0).sort((d,g)=>d.path.length-g.path.length).filter(d=>v.some(g=>(0,A.isParent)(d.path,g,!n.isLinux))?!1:(v.push(d.path),!0)).concat(h)}}}),define(ne[164],ie([0,1,50,5,23,41,109,2,71,10,4,114,22,52]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class h extends R.Disposable{constructor(g,w,m,S){super();this.request=g,this.onDidFilesChange=w,this.onLogMessage=m,this.verboseLogging=S,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},l=>this.onDidFilesChange(l)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(l=>(0,T.parse)(l)),this.cts=new L.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const g=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const w=await f.Promises.stat(g);this._register(await this.doWatch(g,w.isDirectory()))}catch(g){g.code!=="ENOENT"?this.error(g):this.trace(g)}}async normalizePath(g){let w=g.path;try{w=await f.Promises.realpath(g.path),g.path===w&&(w=await(0,C.realcase)(g.path)??g.path),g.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${g.path}, real: ${w})`)}catch{}return w}async doWatch(g,w){if(I.isMacintosh&&(0,A.isEqualOrParent)(g,"/Volumes/"))return this.error(`Refusing to watch ${g} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const m=new L.CancellationTokenSource(this.cts.token);let S=new R.DisposableStore;try{const l=(0,E.basename)(g),r=(0,D.watch)(g);S.add((0,R.toDisposable)(()=>{r.removeAllListeners(),r.close()})),this.trace(`Started watching: '${g}'`);const a=new Set;if(w)try{for(const t of await f.Promises.readdir(g))a.add(t)}catch(t){this.error(t)}const i=new Map;S.add((0,R.toDisposable)(()=>{for(const[,t]of i)t.dispose();i.clear()})),r.on("error",(t,o)=>{this.error(`Failed to watch ${g} for changes using fs.watch() (${t}, ${o})`),this.dispose()}),r.on("change",(t,o)=>{if(m.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${o}`);let s="";if(o&&(s=o.toString(),I.isMacintosh&&(s=(0,b.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(w)if(t==="rename"){i.get(s)?.dispose();const c=setTimeout(async()=>{if(i.delete(s),s===l&&!await f.Promises.exists(g)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.existsChildStrictCase((0,E.join)(g,s));if(m.token.isCancellationRequested)return;let p;u?a.has(s)?p=0:(p=1,a.add(s)):(a.delete(s),p=2),this.onFileChange({path:(0,E.join)(this.request.path,s),type:p})},h.FILE_DELETE_HANDLER_DELAY);i.set(s,(0,R.toDisposable)(()=>clearTimeout(c)))}else{let c;a.has(s)?c=0:(c=1,a.add(s)),this.onFileChange({path:(0,E.join)(this.request.path,s),type:c})}else if(t==="rename"||s!==l){const c=setTimeout(async()=>{const u=await f.Promises.exists(g);m.token.isCancellationRequested||(u?(this.onFileChange({path:this.request.path,type:0},!0),S.add(await this.doWatch(g,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},h.FILE_DELETE_HANDLER_DELAY);S.clear(),S.add((0,R.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(l){await f.Promises.exists(g)&&!m.token.isCancellationRequested&&this.error(`Failed to watch ${g} for changes using fs.watch() (${l.toString()})`)}return(0,R.toDisposable)(()=>{m.dispose(!0),S.dispose()})}async onFileChange(g,w=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),!w&&this.excludes.some(m=>m(g.path))?this.verboseLogging&&this.trace(` >> ignored ${g.path}`):this.fileChangesBuffer.push(g);try{await this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,y.coalesceEvents)(m);if(S.length>0){if(this.verboseLogging)for(const r of S)this.trace(`>> normalized ${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`);this.throttledFileChangesWorker.work(S)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(g){if(I.isLinux)return f.Promises.exists(g);try{const w=(0,E.basename)(g);return(await f.Promises.readdir((0,E.dirname)(g))).some(S=>S===w)}catch(w){return this.trace(w),!1}}setVerboseLogging(g){this.verboseLogging=g}error(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${g}`})}warn(g){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${g}`})}trace(g){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=h,h.FILE_DELETE_HANDLER_DELAY=100,h.FILE_CHANGES_HANDLER_DELAY=50;async function v(d,g,w,m,S=512){const l=await f.Promises.open(d,"r"),r=Buffer.allocUnsafe(S),a=new L.CancellationTokenSource(m);let i,t=!1;const o={path:d,excludes:[],recursive:!1},s=new h(o,c=>{(async()=>{for(const{type:u}of c)if(u===0){if(t)return;t=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:p}=await f.Promises.read(l,r,0,S,null);if(!p||a.token.isCancellationRequested)break;g(r.slice(0,p))}}catch(p){i=new Error(p),a.dispose(!0)}finally{t=!1}}})()});return await s.ready,w(),new Promise((c,u)=>{a.token.onCancellationRequested(async()=>{s.dispose();try{await f.Promises.close(l)}catch(p){i=new Error(p)}i?u(i):c()})})}e.watchFileContents=v}),define(ne[165],ie([0,1,16,3,2,4,164]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class R extends L.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new n.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=n.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(E){const I=this.normalizeRequests(E),C=I.filter(y=>{const h=this.watchers.get(y.path);return h?!(0,D.equals)(h.request.excludes,y.excludes):!0}),f=Array.from(this.watchers.values()).filter(({request:y})=>!I.find(h=>h.path===y.path&&(0,D.equals)(h.excludes,y.excludes))).map(({request:y})=>y.path);C.length&&this.trace(`Request to start watching: ${C.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"})`).join(",")}`),f.length&&this.trace(`Request to stop watching: ${f.join(",")}`);for(const y of f)this.stopWatching(y);for(const y of C)this.startWatching(y)}startWatching(E){const I=new T.NodeJSFileWatcherLibrary(E,f=>this._onDidChangeFile.fire(f),f=>this._onDidLogMessage.fire(f),this.verboseLogging),C={request:E,instance:I};this.watchers.set(E.path,C)}async stop(){for(const[E]of this.watchers)this.stopWatching(E);this.watchers.clear()}stopWatching(E){const I=this.watchers.get(E);I&&(this.watchers.delete(E),I.instance.dispose())}normalizeRequests(E){const I=new Map;for(const C of E){const f=A.isLinux?C.path:C.path.toLowerCase();I.set(f,C)}return Array.from(I.values())}async setVerboseLogging(E){this.verboseLogging=E;for(const[,I]of this.watchers)I.instance.setVerboseLogging(E)}trace(E){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(E)})}toMessage(E,I){return I?`[File Watcher (node.js)] ${E} (path: ${I.request.path})`:`[File Watcher (node.js)] ${E}`}}e.NodeJSWatcher=R}),define(ne[166],ie([0,1,52,165]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class L extends D.AbstractNonRecursiveWatcherClient{constructor(T,R,b){super(T,R,b);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=L}),define(ne[167],ie([0,1,18,36,58,52]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends A.AbstractUniversalWatcherClient{constructor(b,E,I){super(b,E,I);this.init()}createWatcher(b){const E=b.add(new L.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(E.onDidProcessExit(({code:I,signal:C})=>this.onError(`terminated by itself with code ${I}, signal: ${C}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(E.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(ne[85],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...L){this._entries=new Map;for(let[A,T]of L)this.set(A,T)}set(L,A){const T=this._entries.get(L);return this._entries.set(L,A),T}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=D}),define(ne[168],ie([0,1,5,9,51,156,6,85]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const b=!1;class E extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new R.ServiceCollection,v=!1,d){this._activeInstantiations=new Set,this._services=h,this._strict=v,this._parent=d,this._services.set(T.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...v){let d=f.traceInvocation(h),g=!1;try{return h({get:m=>{if(g)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(m,d);if(!S)throw new Error(`[invokeFunction] unknown service '${m}'`);return S}},...v)}finally{g=!0,d.stop()}}createInstance(h,...v){let d,g;return h instanceof L.SyncDescriptor?(d=f.traceCreation(h.ctor),g=this._createInstance(h.ctor,h.staticArguments.concat(v),d)):(d=f.traceCreation(h),g=this._createInstance(h,v,d)),d.stop(),g}_createInstance(h,v=[],d){let g=T._util.getServiceDependencies(h).sort((S,l)=>S.index-l.index),w=[];for(const S of g){let l=this._getOrCreateServiceInstance(S.id,d);if(!l&&this._strict&&!S.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${S.id}.`);w.push(l)}let m=g.length>0?g[0].index:v.length;if(v.length!==m){console.warn(`[createInstance] First service dependency of ${h.name} at position ${m+1} conflicts with ${v.length} static arguments`);let S=m-v.length;S>0?v=v.concat(new Array(S)):v=v.slice(0,m)}return new h(...[...v,...w])}_setServiceInstance(h,v){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,v);else if(this._parent)this._parent._setServiceInstance(h,v);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let v=this._services.get(h);return!v&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):v}_getOrCreateServiceInstance(h,v){let d=this._getServiceInstanceOrDescriptor(h);return d instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,d,v.branch(h,!0)):(v.branch(h,!1),d)}_safeCreateAndCacheServiceInstance(h,v,d){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,v,d)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,v,d){const g=new A.Graph(S=>S.id.toString());let w=0;const m=[{id:h,desc:v,_trace:d}];for(;m.length;){const S=m.pop();if(g.lookupOrInsertNode(S),w++>1e3)throw new E(g);for(let l of T._util.getServiceDependencies(S.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(l.id);if(!r&&!l.optional&&console.warn(`[createInstance] ${h} depends on ${l.id} which is NOT registered.`),r instanceof L.SyncDescriptor){const a={id:l.id,desc:r,_trace:S._trace.branch(l.id,!0)};g.insertEdge(S,a),m.push(a)}}}for(;;){const S=g.roots();if(S.length===0){if(!g.isEmpty())throw new E(g);break}for(const{data:l}of S){if(this._getServiceInstanceOrDescriptor(l.id)instanceof L.SyncDescriptor){const a=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,a)}g.removeNode(l)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,v,d=[],g,w){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(v,d,g,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,v,d,g,w);throw new Error(`illegalState - creating UNKNOWN service instance ${v.name}`)}_createServiceInstance(h,v=[],d,g){if(d){const w=new D.IdleValue(()=>this._createInstance(h,v,g));return new Proxy(Object.create(null),{get(m,S){if(S in m)return m[S];let l=w.value,r=l[S];return typeof r!="function"||(r=r.bind(l),m[S]=r),r},set(m,S,l){return w.value[S]=l,!0}})}else return this._createInstance(h,v,g)}}e.InstantiationService=I;var C;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(C||(C={}));class f{constructor(h,v){this.type=h,this.name=v,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return b?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return b?new f(0,h.name):f._None}branch(h,v){let d=new f(2,h.toString());return this._dep.push([h,v,d]),d}stop(){let h=Date.now()-this._start;f._totals+=h;let v=!1;function d(w,m){let S=[],l=new Array(w+1).join("	");for(const[r,a,i]of m._dep)if(a&&i){v=!0,S.push(`${l}CREATES -> ${r}`);let t=d(w+1,i);t&&S.push(t)}else S.push(`${l}uses -> ${r}`);return S.join(`
`)}let g=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||v)&&console.log(g.join(`
`))}}e.Trace=f,f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(ne[169],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(L,A){this.server=L,this.router=A}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,A){this.server.registerChannel(L,A)}}e.MessagePortMainProcessService=D}),define(ne[170],ie([0,1,36,51,79,6]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class T{constructor(y,h,v){const d=v.getChannel(y);return R(h)?new h.channelClientCtor(d):D.ProxyChannel.toService(d,h?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,A.createDecorator)("mainProcessService");let b=class extends T{constructor(y,h,v){super(y,h,v)}};b=de([J(2,e.IMainProcessService)],b);function E(f,y,h){(0,L.registerSingleton)(f,new n.SyncDescriptor(b,[y,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=E,e.ISharedProcessService=(0,A.createDecorator)("sharedProcessService");let I=class extends T{constructor(y,h,v){super(y,h,v)}};I=de([J(2,e.ISharedProcessService)],I);function C(f,y,h){(0,L.registerSingleton)(f,new n.SyncDescriptor(I,[y,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=C}),define(ne[59],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,D.createDecorator)("localizationsService");function n(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const A of L.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=n}),define(ne[171],ie([0,1,2,59]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends D.Disposable{constructor(T){super();this.localizationsService=T,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([J(0,n.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(ne[8],ie([0,1,37,3,2,4,6]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,T.createDecorator)("logService"),e.ILoggerService=(0,T.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function E(a,i,t){switch(i){case b.Trace:a.trace(t);break;case b.Debug:a.debug(t);break;case b.Info:a.info(t);break;case b.Warning:a.warn(t);break;case b.Error:a.error(t);break;case b.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=E;function I(a){let i="";for(let t=0;t<a.length;t++){let o=a[t];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}i+=(t>0?" ":"")+o}return i}e.format=I;class C extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class f extends C{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,I([i,...t]))}debug(i,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,I([i,...t]))}info(i,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,I([i,...t]))}warn(i,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,I([i,...t]))}error(i,...t){if(this.checkLogLevel(b.Error))if(i instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=i.stack,this.log(b.Error,I(o))}else this.log(b.Error,I([i,...t]))}critical(i,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,I([i,...t]))}flush(){}}e.AbstractMessageLogger=f;class y extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}debug(i,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}info(i,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,i,...t):console.log(`[main ${R()}]`,i,...t))}warn(i,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,i,...t):console.warn(`[main ${R()}]`,i,...t))}error(i,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}critical(i,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,i,...t):console.error(`[main ${R()}]`,i,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class h extends C{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",i,...t)}debug(i,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...t)}info(i,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",i,...t)}warn(i,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",i,...t)}error(i,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",i,...t)}critical(i,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class v extends C{constructor(i,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(t)}trace(i,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(i),...t])}debug(i,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(i),...t])}info(i,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(i),...t])}warn(i,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(i),...t])}error(i,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(i),...t])}critical(i,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(i),...t])}extractMessage(i){return typeof i=="string"?i:(0,D.toErrorMessage)(i,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=v;class d extends C{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const t of this.logServices)t.setLevel(i);super.setLevel(i)}trace(i,...t){for(const o of this.logServices)o.trace(i,...t)}debug(i,...t){for(const o of this.logServices)o.debug(i,...t)}info(i,...t){for(const o of this.logServices)o.info(i,...t)}warn(i,...t){for(const o of this.logServices)o.warn(i,...t)}error(i,...t){for(const o of this.logServices)o.error(i,...t)}critical(i,...t){for(const o of this.logServices)o.critical(i,...t)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=d;class g extends L.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...t){this.logger.trace(i,...t)}debug(i,...t){this.logger.debug(i,...t)}info(i,...t){this.logger.info(i,...t)}warn(i,...t){this.logger.warn(i,...t)}error(i,...t){this.logger.error(i,...t)}critical(i,...t){this.logger.critical(i,...t)}flush(){this.logger.flush()}}e.LogService=g;class w extends L.Disposable{constructor(i,t){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(o))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,t){let o=this.loggers.get(i.toString());return o||(o=this.doCreateLogger(i,t?.always?b.Trace:this.logLevel,t),this.loggers.set(i.toString(),o),t?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class m{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(i){}getLevel(){return b.Info}trace(i,...t){}debug(i,...t){}info(i,...t){}warn(i,...t){}error(i,...t){}critical(i,...t){}dispose(){}flush(){}}e.NullLogService=m;function S(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const i=l(a.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function l(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=l;function r(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(ne[172],ie([0,1,5,9,2,10,22,15,8]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let E=class extends L.Disposable{constructor(C,f){super();this.environmentService=C,this.logService=f,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const C=(0,A.basename)(this.environmentService.logsPath),f=(0,A.dirname)(this.environmentService.logsPath),v=(await T.Promises.readdir(f)).filter(g=>/^\d{8}T\d{6}$/.test(g)).sort().filter(g=>g!==C),d=v.slice(0,Math.max(0,v.length-9));d.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${d.join(", ")}'`),await Promise.all(d.map(g=>T.Promises.rm((0,A.join)(f,g)))))}catch(C){(0,n.onUnexpectedError)(C)}}};E=de([J(0,R.IEnvironmentService),J(1,b.ILogService)],E),e.LogsDataCleaner=E}),define(ne[173],ie([0,1,5,9,2,10,22,15,8]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let E=class gt extends L.Disposable{constructor(C,f,y){super();this.backupWorkspacesPath=C,this.environmentService=f,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const C=await T.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(C).emptyWorkspaceInfos.map(v=>v.backupFolder),h=await T.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async v=>{v.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||v===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(v)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${v}.`),await T.Promises.rm((0,A.join)(this.environmentService.workspaceStorageHome.fsPath,v)))}))}catch(C){(0,n.onUnexpectedError)(C)}}};E.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,E.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",E=de([J(1,R.INativeEnvironmentService),J(2,b.ILogService)],E),e.StorageDataCleaner=E}),define(ne[174],ie([0,1,45,5,37,3,2,18,10,22,15,8]),function(Y,e,D,n,L,A,T,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends T.Disposable{constructor(h,v){super();this.environmentService=h,this.logService=v,this.processesLimiter=new n.Limiter(5)}async postUninstall(h){const v=this.parseScript(h,"uninstall");return v&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(v.script,"uninstall",v.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${d}`)))),E.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(h,v){const d=`vscode:${v}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[d]=="string"){const g=h.manifest.scripts[d].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${d} should be a node script`),null):{script:(0,b.join)(h.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}runLifecycleHook(h,v,d,g,w){return new Promise((m,S)=>{const l=this.start(h,v,d,w);let r;const a=i=>{r&&(clearTimeout(r),r=null),i?S(i):m(void 0)};l.on("error",i=>{a((0,L.toErrorMessage)(i)||"Unknown")}),l.on("exit",(i,t)=>{a(i?`post-${v} process exited with code ${i}`:void 0)}),g&&(r=setTimeout(()=>{r=null,l.kill(),S("timed out")},5e3))})}start(h,v,d,g){const w={silent:!0,execArgv:void 0},m=(0,D.fork)(h,[`--type=extension-post-${v}`,...d],w);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const S=A.Event.fromNodeEventEmitter(m.stdout,"data"),l=A.Event.fromNodeEventEmitter(m.stderr,"data");S(i=>this.logService.info(g.identifier.id,g.manifest.version,`post-${v}`,i)),l(i=>this.logService.error(g.identifier.id,g.manifest.version,`post-${v}`,i));const r=A.Event.any(A.Event.map(S,i=>({data:`%c${i}`,format:[""]})),A.Event.map(l,i=>({data:`%c${i}`,format:["color: red"]})));return A.Event.debounce(r,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100)(i=>{console.group(g.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),m}getExtensionStoragePath(h){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=de([J(0,I.IEnvironmentService),J(1,C.ILogService)],f),e.ExtensionsLifecycle=f}),define(ne[175],ie([0,1,16,5,9,3,2,10,52,8]),function(Y,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends T.Disposable{constructor(f,y){super();this.logService=f,this.options=y,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(f,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(f,y):this.watchNonRecursive(f,y)}watchUniversal(f,y){const h={path:this.toFilePath(f),excludes:y.excludes,recursive:y.recursive},v=(0,D.insert)(this.universalPathsToWatch,h);return this.refreshUniversalWatchers(),(0,T.toDisposable)(()=>{v(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,b.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)})));const f=this.options?.watcher?.recursive?.usePolling;if(f===!0)for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(f))for(const y of this.universalPathsToWatch)(0,b.isRecursiveWatchRequest)(y)&&f.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(f,y){const h={path:this.toFilePath(f),excludes:y.excludes,recursive:!1},v=(0,D.insert)(this.nonRecursivePathsToWatch,h);return this.refreshNonRecursiveWatchers(),(0,T.toDisposable)(()=>{v(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(f=>(0,L.onUnexpectedError)(f))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===E.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===E.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(ne[176],ie([0,1,16,5,17,23,3,70,55,2,39,18,177,19,40,136,13,84,8]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let m=class extends E.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new T.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new T.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new T.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(l,r){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,f.mark)(`code/registerFilesystem/${l}`);const a=new E.DisposableStore;return this.provider.set(l,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:r}),a.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new d.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),typeof r.onDidWatchError=="function"&&a.add(r.onDidWatchError(i=>this._onDidWatchError.fire(new Error(i)))),a.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:l}))),(0,E.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:r}),this.provider.delete(l),(0,E.dispose)(a)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(a){r.push(a)}}),!this.provider.has(l)&&await n.Promises.settled(r)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,r){const a=this.provider.get(l.scheme);return!!(a&&a.capabilities&r)}listCapabilities(){return b.Iterable.map(this.provider,([l,r])=>({scheme:l,capabilities:r.capabilities}))}async withProvider(l){if(!(0,y.isAbsolutePath)(l))throw new d.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const r=this.provider.get(l.scheme);if(!r){const a=new Error;throw a.name="ENOPRO",a.message=(0,v.localize)(1,null,l.toString()),a}return r}async withReadProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r)||(0,d.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const r=await this.withProvider(l);if((0,d.hasOpenReadWriteCloseCapability)(r)||(0,d.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,r){try{return await this.doResolveFile(l,r)}catch(a){throw(0,d.toFileSystemProviderErrorCode)(a)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,d.ensureFileSystemProviderError)(a)}}async doResolveFile(l,r){const a=await this.withProvider(l),i=this.isPathCaseSensitive(a),t=r?.resolveTo,o=r?.resolveSingleChildDescendants,s=r?.resolveMetadata,c=await a.stat(l);let u;return this.toFileStat(a,l,c,void 0,!!s,(p,P)=>(u||(u=I.TernarySearchTree.forUris(()=>!i),u.set(l,!0),t&&u.fill(!0,t)),u.get(p.resource)||u.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&o?P===1:!1))}async toFileStat(l,r,a,i,t,o){const{providerExtUri:s}=this.getExtUri(l),c={resource:r,name:s.basename(r),isFile:(a.type&d.FileType.File)!=0,isDirectory:(a.type&d.FileType.Directory)!=0,isSymbolicLink:(a.type&d.FileType.SymbolicLink)!=0,mtime:a.mtime,ctime:a.ctime,size:a.size,readonly:Boolean((a.permissions??0)&d.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,d.etag)({mtime:a.mtime,size:a.size})};if(c.isDirectory&&o(c,i)){try{const u=await l.readdir(r),p=await n.Promises.settled(u.map(async([P,_])=>{try{const O=s.joinPath(r,P),F=t?await l.stat(O):{type:_};return await this.toFileStat(l,O,F,u.length,t,o)}catch(O){return this.logService.trace(O),null}}));c.children=(0,D.coalesce)(p)}catch(u){this.logService.trace(u),c.children=[]}return c}return c}async resolveAll(l){return n.Promises.settled(l.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(a){return this.logService.trace(a),{stat:void 0,success:!1}}}))}async exists(l){const r=await this.withProvider(l);try{return!!await r.stat(l)}catch{return!1}}async canCreateFile(l,r){try{await this.doValidateCreateFile(l,r)}catch(a){return a}return!0}async doValidateCreateFile(l,r){if(!r?.overwrite&&await this.exists(l))throw new d.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,r)}async createFile(l,r=L.VSBuffer.fromString(""),a){await this.doValidateCreateFile(l,a);const i=await this.writeFile(l,r);return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,i)),i}async writeFile(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:t}=this.getExtUri(i);try{await this.validateWriteFile(i,l,a)||await this.mkdirp(i,t.dirname(l));let s;if((0,d.hasReadWriteCapability)(i)&&!(r instanceof L.VSBuffer))if((0,h.isReadableStream)(r)){const c=await(0,h.peekStream)(r,3);c.ended?s=L.VSBuffer.concat(c.buffer):s=c}else s=(0,h.peekReadable)(r,c=>L.VSBuffer.concat(c),3);else s=r;!(0,d.hasOpenReadWriteCloseCapability)(i)||(0,d.hasReadWriteCapability)(i)&&s instanceof L.VSBuffer?await this.doWriteUnbuffered(i,l,a,s):await this.doWriteBuffered(i,l,a,s instanceof L.VSBuffer?(0,L.bufferToReadable)(s):s)}catch(o){throw new d.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),a)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,r,a){if(!!a?.unlock&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(r)));let t;try{t=await l.stat(r)}catch{return}if((t.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,v.localize)(6,null,this.resourceForError(r)),0,a);if(this.throwIfFileIsReadonly(r,t),typeof a?.mtime=="number"&&typeof a.etag=="string"&&a.etag!==d.ETAG_DISABLED&&typeof t.mtime=="number"&&typeof t.size=="number"&&a.mtime<t.mtime&&a.etag!==(0,d.etag)({mtime:a.mtime,size:t.size}))throw new d.FileOperationError((0,v.localize)(7,null),3,a);return t}async readFile(l,r,a){const i=await this.withReadProvider(l);return r?.atomic?this.doReadFileAtomic(i,l,r,a):this.doReadFile(i,l,r,a)}async doReadFileAtomic(l,r,a,i){return new Promise((t,o)=>{this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,r,a,i);t(s)}catch(s){o(s)}})})}async doReadFile(l,r,a,i){const t=await this.doReadFileStream(l,r,{...a,preferUnbuffered:!0},i);return{...t,value:await(0,L.streamToBuffer)(t.value)}}async readFileStream(l,r,a){const i=await this.withReadProvider(l);return this.doReadFileStream(i,l,r,a)}async doReadFileStream(l,r,a,i){const t=new A.CancellationTokenSource(i),o=this.validateReadFile(r,a).then(c=>c,c=>{throw t.cancel(),c});let s;try{return typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&await o,a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)||!((0,d.hasOpenReadWriteCloseCapability)(l)||(0,d.hasFileReadStreamCapability)(l))||(0,d.hasReadWriteCapability)(l)&&a?.preferUnbuffered?s=this.readFileUnbuffered(l,r,a):(0,d.hasFileReadStreamCapability)(l)?s=this.readFileStreamed(l,r,t.token,a):s=this.readFileBuffered(l,r,t.token,a),{...await o,value:s}}catch(c){s&&await(0,h.consumeStream)(s);const u=(0,v.localize)(8,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(c).toString());throw c instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(u,c.stat,a):new d.FileOperationError(u,(0,d.toFileOperationResult)(c),a)}}readFileStreamed(l,r,a,i=Object.create(null)){const t=l.readFileStream(r,i,a);return(0,h.transform)(t,{data:o=>o instanceof L.VSBuffer?o:L.VSBuffer.wrap(o),error:o=>new d.FileOperationError((0,v.localize)(9,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},o=>L.VSBuffer.concat(o))}readFileBuffered(l,r,a,i=Object.create(null)){const t=(0,L.newWriteableBufferStream)();return(0,g.readFileIntoStream)(l,r,t,o=>o,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new d.FileOperationError((0,v.localize)(10,null,this.resourceForError(r),(0,d.ensureFileSystemProviderError)(o).toString()),(0,d.toFileOperationResult)(o),i)},a),t}readFileUnbuffered(l,r,a){const i=(0,h.newWriteableStream)(t=>L.VSBuffer.concat(t));return(async()=>{try{let t;a?.atomic&&(0,d.hasFileAtomicReadCapability)(l)?t=await l.readFile(r,{atomic:!0}):t=await l.readFile(r),typeof a?.position=="number"&&(t=t.slice(a.position)),typeof a?.length=="number"&&(t=t.slice(0,a.length)),this.validateReadFileLimits(r,t.byteLength,a),i.end(L.VSBuffer.wrap(t))}catch(t){i.error(t),i.end()}})(),i}async validateReadFile(l,r){const a=await this.resolve(l,{resolveMetadata:!0});if(a.isDirectory)throw new d.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,r);if(typeof r?.etag=="string"&&r.etag!==d.ETAG_DISABLED&&r.etag===a.etag)throw new d.NotModifiedSinceFileOperationError((0,v.localize)(12,null),a,r);return this.validateReadFileLimits(l,a.size,r),a}validateReadFileLimits(l,r,a){if(a?.limits){let i;if(typeof a.limits.memory=="number"&&r>a.limits.memory&&(i=9),typeof a.limits.size=="number"&&r>a.limits.size&&(i=7),typeof i=="number")throw new d.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,r,a){return this.doCanMoveCopy(l,r,"move",a)}async canCopy(l,r,a){return this.doCanMoveCopy(l,r,"copy",a)}async doCanMoveCopy(l,r,a,i){if(l.toString()!==r.toString())try{const t=a==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(t,l,o,r,a,i)}catch(t){return t}return!0}async move(l,r,a){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"move",!!a),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="move"?2:3,s)),s}async copy(l,r,a){const i=await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),o=await this.doMoveCopy(i,l,t,r,"copy",!!a),s=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,o==="copy"?3:2,s)),s}async doMoveCopy(l,r,a,i,t,o){if(r.toString()===i.toString())return t;const{exists:s,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,r,a,i,t,o);if(s&&!c&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(a,this.getExtUri(a).providerExtUri.dirname(i)),t==="copy"){if(l===a&&(0,d.hasFileFolderCopyCapability)(l))await l.copy(r,i,{overwrite:o});else{const u=await this.resolve(r);u.isDirectory?await this.doCopyFolder(l,u,a,i):await this.doCopyFile(l,r,a,i)}return t}else return l===a?(await l.rename(r,i,{overwrite:o}),t):(await this.doMoveCopy(l,r,a,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(l,r,a,i){if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeBuffered(l,r,a,i);if((0,d.hasOpenReadWriteCloseCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeBufferedToUnbuffered(l,r,a,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasOpenReadWriteCloseCapability)(a))return this.doPipeUnbufferedToBuffered(l,r,a,i);if((0,d.hasReadWriteCapability)(l)&&(0,d.hasReadWriteCapability)(a))return this.doPipeUnbuffered(l,r,a,i)}async doCopyFolder(l,r,a,i){await a.mkdir(i),Array.isArray(r.children)&&await n.Promises.settled(r.children.map(async t=>{const o=this.getExtUri(a).providerExtUri.joinPath(i,t.name);return t.isDirectory?this.doCopyFolder(l,await this.resolve(t.resource),a,o):this.doCopyFile(l,t.resource,a,o)}))}async doValidateMoveCopy(l,r,a,i,t,o){let s=!1;if(l===a){const{providerExtUri:u,isPathCaseSensitive:p}=this.getExtUri(l);if(p||(s=u.isEqual(r,i)),s&&t==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!s&&u.isEqualOrParent(i,r))throw new Error((0,v.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const c=await this.exists(i);if(c&&!s){if(!o)throw new d.FileOperationError((0,v.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(l===a){const{providerExtUri:u}=this.getExtUri(l);if(u.isEqualOrParent(r,i))throw new Error((0,v.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:c,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const r=this.isPathCaseSensitive(l);return{providerExtUri:r?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(r,l);const a=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(l,0,a)),a}async mkdirp(l,r){const a=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(r,i.dirname(r));)try{if(((await l.stat(r)).type&d.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(r)));break}catch(t){if((0,d.toFileSystemProviderErrorCode)(t)!==d.FileSystemProviderErrorCode.FileNotFound)throw t;a.push(i.basename(r)),r=i.dirname(r)}for(let t=a.length-1;t>=0;t--){r=i.joinPath(r,a[t]);try{await l.mkdir(r)}catch(o){if((0,d.toFileSystemProviderErrorCode)(o)!==d.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,r){try{await this.doValidateDelete(l,r)}catch(a){return a}return!0}async doValidateDelete(l,r){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!r?.useTrash&&!(a.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));let t;try{t=await a.stat(l)}catch{}if(t)this.throwIfFileIsReadonly(l,t);else throw new d.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!r?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return a}async del(l,r){const a=await this.doValidateDelete(l,r),i=!!r?.useTrash,t=!!r?.recursive;await a.delete(l,{recursive:t,useTrash:i}),this._onDidRunOperation.fire(new d.FileOperationEvent(l,1))}watch(l,r={recursive:!1,excludes:[]}){const a=new E.DisposableStore;let i=!1,t=()=>{i=!0};return a.add((0,E.toDisposable)(()=>t())),(async()=>{try{const o=await this.doWatch(l,r);i?(0,E.dispose)(o):t=()=>(0,E.dispose)(o)}catch(o){this.logService.error(o)}})(),a}async doWatch(l,r){const a=await this.withProvider(l),i=(0,R.hash)([this.getExtUri(a).providerExtUri.getComparisonKey(l),r]);let t=this.activeWatchers.get(i);return t||(t={count:0,disposable:a.watch(l,r)},this.activeWatchers.set(i,t)),t.count+=1,(0,E.toDisposable)(()=>{t&&(t.count--,t.count===0&&((0,E.dispose)(t.disposable),this.activeWatchers.delete(i)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,E.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(async()=>{const t=await l.open(r,{create:!0,unlock:a?.unlock??!1});try{(0,h.isReadableStream)(i)||(0,h.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,t,i):await this.doWriteReadableBufferedQueued(l,t,i)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await l.close(t)}})}async doWriteStreamBufferedQueued(l,r,a){let i=0,t;if((0,h.isReadableBufferedStream)(a)){if(a.buffer.length>0){const o=L.VSBuffer.concat(a.buffer);await this.doWriteBuffer(l,r,o,o.byteLength,i,0),i+=o.byteLength}if(a.ended)return;t=a.stream}else t=a;return new Promise((o,s)=>{(0,h.listenStream)(t,{onData:async c=>{t.pause();try{await this.doWriteBuffer(l,r,c,c.byteLength,i,0)}catch(u){return s(u)}i+=c.byteLength,setTimeout(()=>t.resume())},onError:c=>s(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,r,a){let i=0,t;for(;(t=a.read())!==null;)await this.doWriteBuffer(l,r,t,t.byteLength,i,0),i+=t.byteLength}async doWriteBuffer(l,r,a,i,t,o){let s=0;for(;s<i;)s+=await l.write(r,t+s,a.buffer,o+s,i-s)}async doWriteUnbuffered(l,r,a,i){return this.writeQueue.queueFor(r,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,r,a,i))}async doWriteUnbufferedQueued(l,r,a,i){let t;i instanceof L.VSBuffer?t=i:(0,h.isReadableStream)(i)?t=await(0,L.streamToBuffer)(i):(0,h.isReadableBufferedStream)(i)?t=await(0,L.bufferedStreamToBuffer)(i):t=(0,L.readableToBuffer)(i),await l.writeFile(r,t.buffer,{create:!0,overwrite:!0,unlock:a?.unlock??!1})}async doPipeBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,r,a,i))}async doPipeBufferedQueued(l,r,a,i){let t,o;try{t=await l.open(r,{create:!1}),o=await a.open(i,{create:!0,unlock:!1});const s=L.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,u=0,p=0;do p=await l.read(t,c,s.buffer,u,s.byteLength-u),await this.doWriteBuffer(a,o,s,p,c,u),c+=p,u+=p,u===s.byteLength&&(u=0);while(p>0)}catch(s){throw(0,d.ensureFileSystemProviderError)(s)}finally{await n.Promises.settled([typeof t=="number"?l.close(t):Promise.resolve(),typeof o=="number"?a.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,r,a,i))}async doPipeUnbufferedQueued(l,r,a,i){return a.writeFile(i,await l.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,r,a,i){return this.writeQueue.queueFor(i,this.getExtUri(a).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,r,a,i))}async doPipeUnbufferedToBufferedQueued(l,r,a,i){const t=await a.open(i,{create:!0,unlock:!1});try{const o=await l.readFile(r);await this.doWriteBuffer(a,t,L.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,d.ensureFileSystemProviderError)(o)}finally{await a.close(t)}}async doPipeBufferedToUnbuffered(l,r,a,i){const t=await(0,L.streamToBuffer)(this.readFileBuffered(l,r,A.CancellationToken.None));await this.doWriteUnbuffered(a,i,void 0,t)}throwIfFileSystemIsReadonly(l,r){if(l.capabilities&2048)throw new d.FileOperationError((0,v.localize)(22,null,this.resourceForError(r)),6);return l}throwIfFileIsReadonly(l,r){if((r.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,v.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===C.Schemas.file?l.fsPath:l.toString(!0)}};m=de([J(0,w.ILogService)],m),e.FileService=m}),define(ne[178],ie([0,1,50,254,5,39,17,3,41,2,10,4,19,40,22,139,13,84,175,37,167,166]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(a){console.error(`Error enabling graceful-fs: ${(0,m.toErrorMessage)(a)}`)}})();class r extends w.AbstractDiskFileSystemProvider{constructor(i,t){super(i,t);this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new A.ResourceMap(o=>f.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:t,symbolicLink:o}=await h.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(i){try{const t=await h.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async s=>{try{let c;s.isSymbolicLink()?c=(await this.stat((0,f.joinPath)(i,s.name))).type:c=this.toType(s),o.push([s.name,c])}catch(c){this.logService.trace(c)}})),o}catch(t){throw this.toFileSystemProviderError(t)}}toType(i,t){let o;return t?.dangling?o=d.FileType.Unknown:i.isFile()?o=d.FileType.File:i.isDirectory()?o=d.FileType.Directory:o=d.FileType.Unknown,t&&(o|=d.FileType.SymbolicLink),o}async createResourceLock(i){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(i)})`);let t;for(;t=this.resourceLocks.get(i);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(i)})`),await t.wait();const o=new L.Barrier;return this.resourceLocks.set(i,o),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(i)})`),(0,E.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(i)})`),this.resourceLocks.delete(i),o.open()})}async readFile(i,t){let o;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(i)})`),o=await this.createResourceLock(i));const s=this.toFilePath(i);return await h.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}finally{o?.dispose()}}readFileStream(i,t,o){const s=(0,y.newWriteableStream)(c=>T.VSBuffer.concat(c.map(u=>T.VSBuffer.wrap(u))).buffer);return(0,g.readFileIntoStream)(this,i,s,c=>c.buffer,{...t,bufferSize:256*1024},o),s}async writeFile(i,t,o){let s;try{const c=this.toFilePath(i);if(!o.create||!o.overwrite){if(await h.Promises.exists(c)){if(!o.overwrite)throw(0,d.createFileSystemProviderError)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,d.createFileSystemProviderError)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}s=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(s,0,t,0,t.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(i,c)}finally{typeof s=="number"&&await this.close(s)}}async open(i,t){let o;(0,d.isFileOpenForWriteOptions)(t)&&(o=await this.createResourceLock(i));let s;try{const c=this.toFilePath(i);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:p}=await h.SymlinkSupport.stat(c);p.mode&128||await h.Promises.chmod(c,p.mode|128)}catch(p){this.logService.trace(p)}let u;if((0,d.isFileOpenForWriteOptions)(t)){if(C.isWindows)try{await h.Promises.truncate(c,0),u="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}u||(u="w")}else u="r";s=await h.Promises.open(c,u)}catch(c){throw o?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(i,c):this.toFileSystemProviderError(c)}return this.mapHandleToPos.set(s,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(s,i),o&&this.mapHandleToLock.set(s,o),s}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await h.Promises.fdatasync(i)}catch(t){this.canFlush=!1,this.logService.error(t)}return await h.Promises.close(i)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(i);t&&(this.mapHandleToLock.delete(i),t.dispose())}}async read(i,t,o,s,c){const u=this.normalizePos(i,t);let p=null;try{const{bytesRead:P}=await h.Promises.read(i,o,s,c,u);return P}catch(P){throw this.toFileSystemProviderError(P)}finally{this.updatePos(i,u,p)}}normalizePos(i,t){return t===this.mapHandleToPos.get(i)?null:t}updatePos(i,t,o){const s=this.mapHandleToPos.get(i);typeof s=="number"&&(typeof t=="number"||(typeof o=="number"?this.mapHandleToPos.set(i,s+o):this.mapHandleToPos.delete(i)))}async write(i,t,o,s,c){return(0,L.retry)(()=>this.doWrite(i,t,o,s,c),100,3)}async doWrite(i,t,o,s,c){const u=this.normalizePos(i,t);let p=null;try{const{bytesWritten:P}=await h.Promises.write(i,o,s,c,u);return P}catch(P){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),P)}finally{this.updatePos(i,u,p)}}async mkdir(i){try{await h.Promises.mkdir(this.toFilePath(i))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(i,t){try{const o=this.toFilePath(i);t.recursive?await h.Promises.rm(o,h.RimRafMode.MOVE):await h.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(i,t,o){const s=this.toFilePath(i),c=this.toFilePath(t);if(s!==c)try{await this.validateTargetDeleted(i,t,"move",o.overwrite),await h.Promises.move(s,c)}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,v.localize)(2,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async copy(i,t,o){const s=this.toFilePath(i),c=this.toFilePath(t);if(s!==c)try{await this.validateTargetDeleted(i,t,"copy",o.overwrite),await h.Promises.copy(s,c,{preserveSymlinks:!0})}catch(u){throw(u.code==="EINVAL"||u.code==="EBUSY"||u.code==="ENAMETOOLONG")&&(u=new Error((0,v.localize)(3,null,(0,I.basename)(s),(0,I.basename)((0,I.dirname)(c)),u.toString()))),this.toFileSystemProviderError(u)}}async validateTargetDeleted(i,t,o,s){const c=this.toFilePath(i),u=this.toFilePath(t);let p=!1;if(!!(this.capabilities&1024)||(p=(0,b.isEqual)(c,u,!0)),p&&o==="copy")throw(0,d.createFileSystemProviderError)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!p&&await h.Promises.exists(u)){if(!s)throw(0,d.createFileSystemProviderError)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createUniversalWatcher(i,t,o){return new S.UniversalWatcherClient(s=>i(s),s=>t(s),o)}createNonRecursiveWatcher(i,t,o){return new l.NodeJSWatcherClient(s=>i(s),s=>t(s),o)}toFileSystemProviderError(i){if(i instanceof d.FileSystemProviderError)return i;let t;switch(i.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(i,t)}async toFileSystemProviderWriteError(i,t){let o=this.toFileSystemProviderError(t);if(i&&o.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:s}=await h.SymlinkSupport.stat(this.toFilePath(i));s.mode&128||(o=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(s){this.logService.trace(s)}return o}}e.DiskFileSystemProvider=r}),define(ne[86],ie([0,1,3,7,8]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(f){this.service=f,this.onDidChangeLogLevel=D.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(f,y,h){switch(y){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=A;class T{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){T.setLevel(this.channel,f)}static setLevel(f,y){return f.call("setLevel",y)}}e.LogLevelChannelClient=T;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,y){throw new Error(`Event not found: ${y}`)}async call(f,y,h){switch(y){case"createLogger":this.createLogger(n.URI.revive(h[0]),h[1]);return;case"log":return this.log(n.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${y}`)}createLogger(f,y){this.loggers.set(f.toString(),this.loggerService.createLogger(f,y))}consoleLog(f,y){let h=console.log;switch(f){case L.LogLevel.Error:h=console.error;break;case L.LogLevel.Warning:h=console.warn;break;case L.LogLevel.Info:h=console.info;break}h.call(console,...y)}log(f,y){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[v,d]of y)(0,L.log)(h,v,d)}}e.LoggerChannel=R;class b extends L.AbstractLoggerService{constructor(f,y,h){super(f,y);this.channel=h}createConsoleMainLogger(){return new L.AdapterLogger({log:(f,y)=>{this.channel.call("consoleLog",[f,y])}})}doCreateLogger(f,y,h){return new E(this.channel,f,y,h)}}e.LoggerChannelClient=b;class E extends L.AbstractMessageLogger{constructor(f,y,h,v){super(v?.always);this.channel=f,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[y,v]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,y){const h=[[f,y]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class I extends L.LogService{constructor(f,y){super(y);this.parent=f,this._register(f.onDidChangeLogLevel(h=>y.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=I}),define(ne[60],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(ne[87],ie([0,1,18,4,32,19]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let T;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const R=n.globals.vscode.context.configuration();if(R)T=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Y?.__$__nodeRequire=="function"){const R=(0,A.dirname)(D.FileAccess.asFileUri("",Y));T=Y.__$__nodeRequire((0,A.joinPath)(R,"product.json").fsPath);const b=Y.__$__nodeRequire((0,A.joinPath)(R,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(T,{nameShort:`${T.nameShort} Dev`,nameLong:`${T.nameLong} Dev`,dataFolderName:`${T.dataFolderName}-dev`}),Object.assign(T,{version:b.version})}else T={},Object.keys(T).length===0&&Object.assign(T,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=T}),define(ne[27],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[179],ie([0,1,5,9,2,10,22,8,27]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let E=class extends L.Disposable{constructor(C,f,y){super();this.productService=f,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,C&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(C)},30*1e3)).schedule()}async cleanUpCodeCaches(C){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),y=(0,A.dirname)(C),h=(0,A.basename)(C),v=await T.Promises.readdir(y);await Promise.all(v.map(async d=>{if(d===h)return;const g=(0,A.join)(y,d),w=await T.Promises.stat(g);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${d}.`),T.Promises.rm(g)}))}catch(f){(0,n.onUnexpectedError)(f)}}};E=de([J(1,b.IProductService),J(2,R.ILogService)],E),e.CodeCacheCleaner=E}),define(ne[180],ie([0,1,5,9,2,10,22,15,8,27]),function(Y,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends L.Disposable{constructor(f,y,h){super();this.environmentService=f,this.logService=y,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),y=JSON.parse(await T.Promises.readFile((0,A.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(y)){const m=y[w];f[`${m.hash}.${w}`]=!0}const h=(0,A.join)(this.environmentService.userDataPath,"clp");if(!await T.Promises.exists(h))return;const d=await T.Promises.readdir(h);for(const w of d){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await T.Promises.rm((0,A.join)(h,w))}const g=Date.now();for(const w of Object.keys(f)){const m=(0,A.join)(h,w),S=await T.Promises.readdir(m);for(const l of S){if(l==="tcf.json")continue;const r=(0,A.join)(m,l),a=await T.Promises.stat(r);a.isDirectory()&&g-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.join)(w,l)}`),await T.Promises.rm(r))}}}catch(f){(0,n.onUnexpectedError)(f)}}};I=de([J(0,R.INativeEnvironmentService),J(1,b.ILogService),J(2,E.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(ne[181],ie([0,1,10,6]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var L;(function(A){function T(R,b="noAbsolutePaths"){for(const E of R.nodes)E.callFrame&&E.callFrame.url&&((0,D.isAbsolute)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(E.callFrame.url))&&(E.callFrame.url=(0,D.join)(b,(0,D.basename)(E.callFrame.url)));return R}A.rewriteAbsolutePaths=T})(L=e.Utils||(e.Utils={}))}),define(ne[182],ie([0,1,29]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(A){const R=await(await new Promise((E,I)=>{Y(["v8-inspect-profiler"],E,I)})).startProfiling({port:A.port,checkForPaused:!0}),b=(0,D.generateUuid)();return this._sessions.set(b,R),b}async stopProfiling(A){const T=this._sessions.get(A);if(!T)throw new Error(`UNKNOWN session '${A}'`);const R=await T.stop();return this._sessions.delete(A),R.profile}}e.InspectProfilingService=n}),define(ne[38],ie([0,1,99,14]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(T,R){D.ok(n.isString(T)),D.ok(n.isObject(R)),D.ok(!this.data.has(T),"There is already an extension with this id"),this.data.set(T,R)}knows(T){return this.data.has(T)}as(T){return this.data.get(T)||null}}e.Registry=new L}),define(ne[88],ie([0,1,3,38]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,E){this.schemasById[L(b)]=E,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const T=new A;n.Registry.add(e.Extensions.JSONContribution,T)}),define(ne[42],ie([0,1,16,3,14,125,88,38]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(S){S.Multiline="multilineText",S.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=R.Registry.as(T.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(l,r=!0){this.registerConfigurations([l],r)}registerConfigurations(l,r=!0){const a=this.doRegisterConfigurations(l,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(l){const r=this.doDeregisterConfigurations(l);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:l,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(l,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(a)})}registerDefaultConfigurations(l){const r=[],a=[];for(const{overrides:i,source:t}of l)for(const o in i)if(r.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const s={...this.configurationDefaultsOverrides.get(o)?.value||{},...i[o]};this.configurationDefaultsOverrides.set(o,{source:t,value:s});const c={type:"object",default:s,description:A.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:s,source:L.isString(t)?void 0:t};a.push(...h(o)),this.configurationProperties[o]=c,this.defaultLanguageConfigurationOverridesNode.properties[o]=c}else{this.configurationDefaultsOverrides.set(o,{value:i[o],source:t});const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(l){const r=[];for(const{overrides:a,source:i}of l)for(const t in a){const o=this.configurationDefaultsOverrides.get(t),s=L.isString(i)?i:i?.id,c=L.isString(o?.source)?o?.source:o?.source?.id;if(s===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const u=this.configurationProperties[t];u&&(this.updatePropertyDefaultValue(t,u),this.updateSchema(t,u))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...l){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(l){for(const r of l)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(l,r){const a=[];return l.forEach(i=>{a.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),a}doDeregisterConfigurations(l){const r=[],a=i=>{if(i.properties)for(const t in i.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,i.properties[t]);i.allOf&&i.allOf.forEach(t=>a(t))};for(const i of l){a(i);const t=this.configurationContributors.indexOf(i);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(l,r=!0,a,i,t=3){t=L.isUndefinedOrNull(l.scope)?t:l.scope;let o=[],s=l.properties;if(s)for(let u in s){if(r&&w(u)){delete s[u];continue}const p=s[u];if(p.source=a,p.defaultDefaultValue=s[u].default,this.updatePropertyDefaultValue(u,p),e.OVERRIDE_PROPERTY_REGEX.test(u)?p.scope=void 0:(p.scope=L.isUndefinedOrNull(p.scope)?t:p.scope,p.restricted=L.isUndefinedOrNull(p.restricted)?!!i?.includes(u):p.restricted),s[u].hasOwnProperty("included")&&!s[u].included){this.excludedConfigurationProperties[u]=s[u],delete s[u];continue}else this.configurationProperties[u]=s[u];!s[u].deprecationMessage&&s[u].markdownDeprecationMessage&&(s[u].deprecationMessage=s[u].markdownDeprecationMessage),o.push(u)}let c=l.allOf;if(c)for(let u of c)o.push(...this.validateAndRegisterProperties(u,r,a,i,t));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(l){const r=a=>{let i=a.properties;if(i)for(const o in i)this.updateSchema(o,i[o]);let t=a.allOf;t&&t.forEach(r)};r(l)}updateSchema(l,r){switch(e.allSettings.properties[l]=r,r.scope){case 1:e.applicationSettings.properties[l]=r;break;case 2:e.machineSettings.properties[l]=r;break;case 6:e.machineOverridableSettings.properties[l]=r;break;case 3:e.windowSettings.properties[l]=r;break;case 4:e.resourceSettings.properties[l]=r;break;case 5:e.resourceSettings.properties[l]=r,this.resourceLanguageSettingsSchema.properties[l]=r;break}}removeFromSchema(l,r){switch(delete e.allSettings.properties[l],r.scope){case 1:delete e.applicationSettings.properties[l];break;case 2:delete e.machineSettings.properties[l];break;case 6:delete e.machineOverridableSettings.properties[l];break;case 3:delete e.windowSettings.properties[l];break;case 4:case 5:delete e.resourceSettings.properties[l],delete this.resourceLanguageSettingsSchema.properties[l];break}}updateOverridePropertyPatternKey(){for(const l of this.overrideIdentifiers.values()){const r=`[${l}]`,a={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const l={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=l,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(l,r){const a=this.configurationDefaultsOverrides.get(l);let i=a?.value,t=a?.source;L.isUndefined(i)&&(i=r.defaultDefaultValue,t=void 0),L.isUndefined(i)&&(i=d(r.type)),r.default=i,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(S){const l=[];if(e.OVERRIDE_PROPERTY_REGEX.test(S)){let r=y.exec(S);for(;r?.length;){const a=r[1].trim();a&&l.push(a),r=y.exec(S)}}return(0,D.distinct)(l)}e.overrideIdentifiersFromKey=h;function v(S){return S.reduce((l,r)=>`${l}[${r}]`,"")}e.keyFromOverrideIdentifiers=v;function d(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new C;R.Registry.add(e.Extensions.Configuration,g);function w(S){return S.trim()?e.OVERRIDE_PROPERTY_REGEX.test(S)?A.localize(7,null,S):g.getConfigurationProperties()[S]!==void 0?A.localize(8,null,S):null:A.localize(6,null)}e.validateProperty=w;function m(){const S=[],l=g.getConfigurationProperties();for(const r of Object.keys(l))S.push([r,l[r].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=m}),define(ne[89],ie([0,1,16,3,35,2,39,28,14,7,20,42,38]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(i={},t=[],o=[]){this._contents=i,this._keys=t,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,I.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,t){const o=this.getContentsForOverrideIdentifer(t);return o?i?(0,I.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const o of this.overrides)o.identifiers.includes(i)&&t.push(...o.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return D.distinct(i)}override(i){let t=this.overrideConfigurations.get(i);return t||(t=this.createOverrideConfigurationModel(i),this.overrideConfigurations.set(i,t)),t}merge(...i){const t=R.deepClone(this.contents),o=R.deepClone(this.overrides),s=[...this.keys];for(const c of i){this.mergeContents(t,c.contents);for(const u of c.overrides){const[p]=o.filter(P=>D.equals(P.identifiers,u.identifiers));p?(this.mergeContents(p.contents,u.contents),p.keys.push(...u.keys),p.keys=D.distinct(p.keys)):o.push(R.deepClone(u))}for(const u of c.keys)s.indexOf(u)===-1&&s.push(u)}return new y(t,s,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(i){const t=this.getContentsForOverrideIdentifer(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let o={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[s],u=t[s];u&&(typeof c=="object"&&typeof u=="object"?(c=R.deepClone(c),this.mergeContents(c,u)):c=u),o[s]=c}return new y(o,this.keys,this.overrides)}mergeContents(i,t){for(const o of Object.keys(t)){if(o in i&&b.isObject(i[o])&&b.isObject(t[o])){this.mergeContents(i[o],t[o]);continue}i[o]=R.deepClone(t[o])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?R.deepFreeze(i):i}getContentsForOverrideIdentifer(i){let t=null,o=null;const s=c=>{c&&(o?this.mergeContents(o,c):o=R.deepClone(c))};for(const c of this.overrides)D.equals(c.identifiers,[i])?t=c.contents:c.identifiers.includes(i)&&s(c.contents);return s(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,t){this.addKey(i),(0,I.addToValueTree)(this.contents,i,t,o=>{throw new Error(o)})}removeValue(i){this.removeKey(i)&&(0,I.removeFromValueTree)(this.contents,i)}addKey(i){let t=this.keys.length;for(let o=0;o<t;o++)i.indexOf(this.keys[o])===0&&(t=o);this.keys.splice(t,1,i)}removeKey(i){let t=this.keys.indexOf(i);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class h extends y{constructor(i={}){const t=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(t),s=Object.create(null),c=[];for(const u in t){const p=i[u],P=p!==void 0?p:t[u].default;(0,I.addToValueTree)(s,u,P,_=>console.error(`Conflict in default settings: ${_}`))}for(const u of Object.keys(s))C.OVERRIDE_PROPERTY_REGEX.test(u)&&c.push({identifiers:(0,C.overrideIdentifiersFromKey)(u),keys:Object.keys(s[u]),contents:(0,I.toValuesTree)(s[u],p=>console.error(`Conflict in default settings file: ${p}`))});super(s,o,c)}}e.DefaultConfigurationModel=h;class v{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,t){if(!b.isUndefinedOrNull(i)){const o=this.doParseContent(i);this.parseRaw(o,t)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,t){this._raw=i;const{contents:o,keys:s,overrides:c,restricted:u}=this.doParseRaw(i,t);this._configurationModel=new y(o,s,c),this._restrictedConfigurations=u||[]}doParseContent(i){let t={},o=null,s=[],c=[],u=[];function p(_){Array.isArray(s)?s.push(_):o!==null&&(s[o]=_)}let P={onObjectBegin:()=>{let _={};p(_),c.push(s),s=_,o=null},onObjectProperty:_=>{o=_},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{let _=[];p(_),c.push(s),s=_,o=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:p,onError:(_,O,F)=>{u.push({error:_,offset:O,length:F})}};if(i)try{L.visit(i,P),t=s[0]||{}}catch(_){console.error(`Error while parsing settings file ${this._name}: ${_}`),this._parseErrors=[_]}return t}doParseRaw(i,t){const o=f.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),s=this.filter(i,o,!0,t);i=s.raw;const c=(0,I.toValuesTree)(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),u=Object.keys(i),p=this.toOverrides(i,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:c,keys:u,overrides:p,restricted:s.restricted}}filter(i,t,o,s){if(!s?.scopes&&!s?.skipRestricted)return{raw:i,restricted:[]};const c={},u=[];for(let p in i)if(C.OVERRIDE_PROPERTY_REGEX.test(p)&&o){const P=this.filter(i[p],t,!1,s);c[p]=P.raw,u.push(...P.restricted)}else{const P=t[p],_=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&u.push(p),(_===void 0||s.scopes===void 0||s.scopes.includes(_))&&(s.skipRestricted&&P?.restricted||(c[p]=i[p]))}return{raw:c,restricted:u}}toOverrides(i,t){const o=[];for(const s of Object.keys(i))if(C.OVERRIDE_PROPERTY_REGEX.test(s)){const c={};for(const u in i[s])c[u]=i[s][u];o.push({identifiers:(0,C.overrideIdentifiersFromKey)(s),keys:Object.keys(c),contents:(0,I.toValuesTree)(c,t)})}return o}}e.ConfigurationModelParser=v;class d extends A.Disposable{constructor(i,t,o,s){super();this.userSettingsResource=i,this.scopes=t,this.fileService=s,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new v(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=d;class g{constructor(i,t,o=new y,s=new y,c=new T.ResourceMap,u=new y,p=new T.ResourceMap,P=!0){this._defaultConfiguration=i,this._localUserConfiguration=t,this._remoteUserConfiguration=o,this._workspaceConfiguration=s,this._folderConfigurations=c,this._memoryConfiguration=u,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(i,t,o){return this.getConsolidateConfigurationModel(t,o).getValue(i)}updateValue(i,t,o={}){let s;o.resource?(s=this._memoryConfigurationByResource.get(o.resource),s||(s=new y,this._memoryConfigurationByResource.set(o.resource,s))):s=this._memoryConfiguration,t===void 0?s.removeValue(i):s.setValue(i,t),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,t,o){const s=this.getConsolidateConfigurationModel(t,o),c=this.getFolderConfigurationModelForResource(t.resource,o),u=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,p=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),P=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),_=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),O=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),F=o?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,$=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(i):c.freeze().getValue(i):void 0,k=t.overrideIdentifier?u.override(t.overrideIdentifier).getValue(i):u.getValue(i),M=s.getValue(i),j=D.distinct(D.flatten(s.overrides.map(U=>U.identifiers))).filter(U=>s.getOverrideValue(i,U)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:_,userRemoteValue:O,workspaceValue:F,workspaceFolderValue:$,memoryValue:k,value:M,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userLocal:_!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,userRemote:O!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:c?.freeze().getValue(i),override:t.overrideIdentifier?c?.freeze().getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,memory:k!==void 0?{value:u.getValue(i),override:t.overrideIdentifier?u.getOverrideValue(i,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(i){const t=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,t){this._folderConfigurations.set(i,t),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const o=[];if(!t){const{added:s,updated:c,removed:u}=l(this._defaultConfiguration,i);t=[...s,...c,...u]}for(const s of t)for(const c of(0,C.overrideIdentifiersFromKey)(s)){const u=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=i.getKeysForOverrideIdentifier(c),P=[...p.filter(_=>u.indexOf(_)===-1),...u.filter(_=>p.indexOf(_)===-1),...u.filter(_=>!R.equals(this._defaultConfiguration.override(c).getValue(_),i.override(c).getValue(_)))];o.push([c,P])}return this.updateDefaultConfiguration(i),{keys:t,overrides:o}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:c}=l(this.localUserConfiguration,i),u=[...t,...o,...s];return u.length&&this.updateLocalUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:o,removed:s,overrides:c}=l(this.remoteUserConfiguration,i);let u=[...t,...o,...s];return u.length&&this.updateRemoteUserConfiguration(i),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:o,removed:s,overrides:c}=l(this.workspaceConfiguration,i);let u=[...t,...o,...s];return u.length&&this.updateWorkspaceConfiguration(i),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(i,t){const o=this.folderConfigurations.get(i),{added:s,updated:c,removed:u,overrides:p}=l(o,t);let P=[...s,...c,...u];return(P.length||!o)&&this.updateFolderConfiguration(i,t),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:s,removed:c,overrides:u}=l(t,void 0);return{keys:[...o,...s,...c],overrides:u}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,t){let o=this.getConsolidatedConfigurationModelForResource(i,t);return i.overrideIdentifier?o.override(i.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:i},t){let o=this.getWorkspaceConsolidatedConfiguration();if(t&&i){const s=t.getFolder(i);s&&(o=this.getFolderConsolidatedConfiguration(s.uri)||o);const c=this._memoryConfigurationByResource.get(i);c&&(o=o.merge(c))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let t=this._foldersConsolidatedConfigurations.get(i);if(!t){const o=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(i);s?(t=o.merge(s),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(i,t)):t=o}return t}getFolderConfigurationModelForResource(i,t){if(t&&i){const o=t.getFolder(i);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,t)=>{const{contents:o,overrides:s,keys:c}=this._folderConfigurations.get(t);return i.push([t,{contents:o,overrides:s,keys:c}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>i.add(t)),this.userConfiguration.freeze().keys.forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(o=>i.add(o))),[...i.values()]}allOverrideIdentifiers(){const i=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>i.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s))),[...t.values()]}static parse(i){const t=this.parseConfigurationModel(i.defaults),o=this.parseConfigurationModel(i.user),s=this.parseConfigurationModel(i.workspace),c=i.folders.reduce((u,p)=>(u.set(E.URI.revive(p[0]),this.parseConfigurationModel(p[1])),u),new T.ResourceMap);return new g(t,o,new y,s,c,new y,new T.ResourceMap,!1)}static parseConfigurationModel(i){return new y(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=g;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,t=new Map;for(const s of a)s.keys.forEach(c=>i.add(c)),s.overrides.forEach(([c,u])=>{const p=(0,T.getOrSet)(t,c,new Set);u.forEach(P=>p.add(P))});const o=[];return t.forEach((s,c)=>o.push([c,[...s.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=w;class m{constructor(i,t,o,s){this.change=i,this.previous=t,this.currentConfiguraiton=o,this.currentWorkspace=s,this._previousConfiguration=void 0;const c=new Set;i.keys.forEach(p=>c.add(p)),i.overrides.forEach(([,p])=>p.forEach(P=>c.add(P))),this.affectedKeys=[...c.values()];const u=new y;this.affectedKeys.forEach(p=>u.setValue(p,{})),this.affectedKeysTree=u.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=g.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(t){const o=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.previous?.workspace):void 0,s=this.currentConfiguraiton.getValue(i,t,this.currentWorkspace);return!R.equals(o,s)}return!0}return!1}doesAffectedKeysTreeContains(i,t){let o=(0,I.toValuesTree)({[t]:!0},()=>{}),s;for(;typeof o=="object"&&(s=Object.keys(o)[0]);){if(i=i[s],!i)return!1;o=o[s]}return!0}}e.ConfigurationChangeEvent=m;class S extends m{constructor(i,t,o,s){super({keys:i.allKeys(),overrides:[]},void 0,i,t);this.source=o,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=S;function l(a,i){const{added:t,removed:o,updated:s}=r(i,a),c=[],u=a?.getAllOverrideIdentifiers()||[],p=i?.getAllOverrideIdentifiers()||[];if(i){const P=p.filter(_=>!u.includes(_));for(const _ of P)c.push([_,i.getKeysForOverrideIdentifier(_)])}if(a){const P=u.filter(_=>!p.includes(_));for(const _ of P)c.push([_,a.getKeysForOverrideIdentifier(_)])}if(i&&a){for(const P of u)if(p.includes(P)){const _=r({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:i.getOverrideValue(void 0,P)||{},keys:i.getKeysForOverrideIdentifier(P)});c.push([P,[..._.added,..._.removed,..._.updated]])}}return{added:t,removed:o,updated:s,overrides:c}}function r(a,i){const t=a?i?a.keys.filter(c=>i.keys.indexOf(c)===-1):[...a.keys]:[],o=i?a?i.keys.filter(c=>a.keys.indexOf(c)===-1):[...i.keys]:[],s=[];if(a&&i){for(const c of i.keys)if(a.keys.indexOf(c)!==-1){const u=(0,I.getConfigurationValue)(i.contents,c),p=(0,I.getConfigurationValue)(a.contents,c);R.equals(u,p)||s.push(c)}}return{added:t,removed:o,updated:s}}}),define(ne[183],ie([0,1,5,3,2,19,20,89,42,38]),function(Y,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends L.Disposable{constructor(f,y){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,y)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,y){const h=typeof f=="string"?f:void 0,v=(0,T.isConfigurationOverrides)(f)?f:(0,T.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(h,v,void 0)}updateValue(f,y,h,v){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,y,1)}onDidDefaultConfigurationChange(f){const y=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(h,y,6)}trigger(f,y,h){const v=new R.ConfigurationChangeEvent(f,{data:y},this.configuration);v.source=h,v.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(v)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(ne[184],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,D.createDecorator)("remoteAuthorityResolverService");var n;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(n=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends Error{constructor(T,R=n.Unknown,b){super(T);this._message=T,this._code=R,this._detail=b,this.isHandled=R===n.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(T){return T instanceof L&&T._code===n.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof L&&T._code===n.NoResolverFound}static isHandled(T){return T instanceof L&&T.isHandled}}e.RemoteAuthorityResolverError=L}),define(ne[185],ie([0,1,5,17,23,9,3,2,29,73,184]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const C=30*1e3;var f;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function y(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(H){const Z=new L.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function v(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return L.CancellationToken.Cancelled;const ee=new L.CancellationTokenSource;return H.onCancellationRequested(()=>ee.cancel()),Z.onCancellationRequested(()=>ee.cancel()),ee.token}class d{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((ee,W)=>{this._resolvePromise=ee,this._rejectPromise=W}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function g(H,Z){const ee=new d(Z);return ee.registerDisposable(H.onControlMessage(W=>{const N=JSON.parse(W.toString()),V=G(N);V?ee.reject(V):ee.resolve(N)})),ee.promise}function w(H,Z,ee,W,N,V,z){const B=new d(z);return Z.connect(ee,W,N,V,(te,se)=>{B.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?B.reject(te):B.resolve(se)}),B.promise}function m(H,Z){const ee=new d(Z);return H.then(W=>{ee.didTimeout||ee.resolve(W)},W=>{ee.didTimeout||ee.reject(W)}),ee.promise}async function S(H,Z,ee,W){const N=q(H,Z);H.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${y(Z)}-${H.reconnectionToken}`,W)}catch(ce){throw H.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let z,B;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(V,null),z=H.reconnectionProtocol,B=!1):(z=new E.PersistentProtocol(V,null),B=!0),H.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const te=await m(H.signService.createNewMessage((0,b.generateUuid)()),W),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await g(z,v(W,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(H.logService.trace(`${N} 4/6. received SignRequest control message.`),!await m(H.signService.validate(te,ce.signedData),W)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const ve=await m(H.signService.sign(ce.data),W),pe={type:"connectionType",commit:H.commit,signedData:ve,desiredConnectionType:Z};return ee&&(pe.args=ee),H.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:z,ownsProtocol:B}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${N} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${N} received error control message when negotiating connection. Error:`),H.logService.error(ce)),B&&U(z),ce}}async function l(H,Z,ee,W){const N=Date.now(),V=q(H,Z),{protocol:z,ownsProtocol:B}=await S(H,Z,ee,W),te=new d(W);return te.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=G(ce);he?(H.logService.error(`${V} received error control message when negotiating connection. Error:`),H.logService.error(he),B&&U(z),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${X(N)}!`),te.resolve({protocol:z,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:ee}=await l(H,1,void 0,Z);return{protocol:ee}}async function a(H,Z,ee){const{protocol:W,firstMessage:N}=await l(H,2,Z,ee),V=N&&N.debugPort;return{protocol:W,debugPort:V}}async function i(H,Z,ee){const W=Date.now(),N=q(H,3),{protocol:V}=await S(H,3,Z,ee);return H.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${X(W)}!`),V}async function t(H,Z,ee){const{host:W,port:N,connectionToken:V}=await H.addressProvider.getAddress();return{commit:H.commit,host:W,port:N,connectionToken:V,reconnectionToken:Z,reconnectionProtocol:ee,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function o(H,Z,ee){try{const W=(0,b.generateUuid)(),N=await t(H,W,null),{protocol:V}=await r(N,L.CancellationToken.None);return new M(H,Z,ee,W,V)}catch(W){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(W),k.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentManagement=o;async function s(H,Z){try{const ee=(0,b.generateUuid)(),W=await t(H,ee,null),{protocol:N,debugPort:V}=await a(W,Z,L.CancellationToken.None);return new j(H,Z,ee,N,V)}catch(ee){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(ee),k.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(ee)),ee}}e.connectRemoteAgentExtensionHost=s;async function c(H,Z,ee){const W=await t(H,(0,b.generateUuid)(),null);return await i(W,{host:Z,port:ee},L.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function u(H){return(0,D.createCancelablePromise)(Z=>new Promise((ee,W)=>{const N=setTimeout(ee,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(N),ee()})}))}var p;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(p=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class P{constructor(Z,ee){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.type=0}}e.ConnectionLostEvent=P;class _{constructor(Z,ee,W,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.durationSeconds=W,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=_;class O{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=O;class F{constructor(Z,ee,W){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.type=4}}e.ConnectionGainEvent=F;class ${constructor(Z,ee,W,N){this.reconnectionToken=Z,this.millisSinceLastIncomingData=ee,this.attempt=W,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class k extends R.Disposable{constructor(Z,ee,W,N){super();this._connectionType=Z,this._onDidStateChange=this._register(new T.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=ee,this.reconnectionToken=W,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new F(this.reconnectionToken,0,0)),this._register(N.onSocketClose(V=>{const z=x(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const V=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),k._instances.push(this),k._permanentFailure&&this._gotoPermanentFailure(k._permanentFailureMillisSinceLastIncomingData,k._permanentFailureAttempt,k._permanentFailureHandled)}static triggerPermanentFailure(Z,ee,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=ee,this._permanentFailureHandled=W,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(k._permanentFailure)return;const Z=x(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ee=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const N=W<ee.length?ee[W]:ee[ee.length-1];try{if(N>0){const z=u(N);this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,z)),this._options.logService.info(`${Z} waiting for ${N} seconds before reconnecting...`);try{await z}catch{}}if(k._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${Z} resolving connection...`);const V=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,h(C)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,A.isCancellationError)(V)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,I.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),k.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!k._permanentFailure)}_gotoPermanentFailure(Z,ee,W){this._onDidStateChange.fire(new $(this.reconnectionToken,Z,ee,W)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=k,k._permanentFailure=!1,k._permanentFailureMillisSinceLastIncomingData=0,k._permanentFailureAttempt=0,k._permanentFailureHandled=!1,k._instances=[];class M extends k{constructor(Z,ee,W,N,V){super(1,Z,N,V);this.client=this._register(new E.Client(V,{remoteAuthority:ee,clientId:W},Z.ipcLogger))}async _reconnect(Z,ee){await r(Z,ee)}}e.ManagementPersistentConnection=M;class j extends k{constructor(Z,ee,W,N,V){super(2,Z,W,N);this._startArguments=ee,this.debugPort=V}async _reconnect(Z,ee){await a(Z,this._startArguments,ee)}}e.ExtensionHostPersistentConnection=j;function U(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,A.onUnexpectedError)(Z)}}function G(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function K(H,Z){for(;H.length<Z;)H+=" ";return H}function x(H,Z,ee){return`[remote-connection][${K(y(H),13)}][${Z.substr(0,5)}\u2026][${ee?"reconnect":"initial"}]`}function q(H,Z){return`${x(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function X(H){return`${Date.now()-H} ms`}}),define(ne[186],ie([0,1,18]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function n(E){return E.scheme===D.Schemas.vscodeRemote?E.authority:void 0}e.getRemoteAuthority=n;function L(E){if(!E)return;const I=E.indexOf("+");return I<0?E:E.substr(0,I)}e.getRemoteName=L;function A(E){return E.scheme!==D.Schemas.file&&E.scheme!==D.Schemas.vscodeRemote}e.isVirtualResource=A;function T(E){if(E.folders.length)return E.folders.every(I=>A(I.uri))?E.folders[0].uri:void 0;if(E.configuration&&A(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=T;function R(E){return T(E)?.scheme}e.getVirtualWorkspaceScheme=R;function b(E){return T(E)!==void 0}e.isVirtualWorkspace=b}),define(ne[90],ie([0,1,26,6,186]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=A;function T(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,h){if(typeof y=="undefined"||y===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof y=="string"||typeof h=="string"){let v=typeof y=="string"?y:y.value,d=typeof h=="string"?h:h.value;return D.equalsIgnoreCase(v,d)}return y._lower===h._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=b;function E(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function I(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function C(f,y){if(y){const h=`onResolveRemoteAuthority:${(0,L.getRemoteName)(y)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=C,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[31],ie([0,1,26,90]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(h,v){return h.uuid&&v.uuid?h.uuid===v.uuid:h.id===v.id?!0:(0,D.compareIgnoreCase)(h.id,v.id)===0}e.areSameExtensions=L;class A{constructor(v,d){this.version=d,this.id=v.id,this.uuid=v.uuid}key(){return`${this.id}-${this.version}`}equals(v){return v instanceof A?L(this,v)&&this.version===v.version:!1}}e.ExtensionIdentifierWithVersion=A;function T(h,v){return`${h}.${v}`}e.getExtensionId=T;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(h,v){return R(T(h,v))}e.getGalleryExtensionId=b;function E(h,v){const d=[],g=w=>{for(const m of d)if(m.some(S=>L(v(S),v(w))))return m;return null};for(const w of h){const m=g(w);m?m.push(w):d.push([w])}return d}e.groupByExtension=E;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function C(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge");function f(h){const v=new Set;if(h.malicious)for(const d of h.malicious)v.add(d.id);return v}e.getMaliciousExtensionsSet=f;function y(h,v){const d=[],g=v.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const w=g.shift();if(w&&d.every(m=>!L(m.identifier,{id:w}))){const m=h.filter(S=>L(S.identifier,{id:w}));m.length===1&&(d.push(m[0]),g.push(...m[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}e.getExtensionDependencies=y}),define(ne[187],ie([0,1,23,31]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function L(A,T,R,b,E){try{const I=await A.getExtensionsControlManifest();if(!I.unsupportedPreReleaseExtensions)return;const C=await A.getInstalled(1);for(const[f,{id:y,migrateStorage:h}]of Object.entries(I.unsupportedPreReleaseExtensions)){const v=C.find(g=>(0,n.areSameExtensions)(g.identifier,{id:f}));if(!v)continue;const d=(await T.getExtensions([{id:y,preRelease:!0}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!d){E.info(`Skipping migrating '${v.identifier.id}' extension because, the comaptible target '${y}' extension is not found`);continue}try{E.info(`Migrating '${v.identifier.id}' extension to '${y}' extension...`);const g=!b.getDisabledExtensions().some(m=>(0,n.areSameExtensions)(m,v.identifier));await A.uninstall(v),E.info(`Uninstalled the unsupported extension '${v.identifier.id}'`);let w=C.find(m=>(0,n.areSameExtensions)(m.identifier,{id:y}));(!w||!w.isPreReleaseVersion&&g)&&(w=await A.installFromGallery(d,{installPreReleaseVersion:!0,isMachineScoped:v.isMachineScoped,operation:4}),E.info(`Installed the pre-release extension '${w.identifier.id}'`),g||(await b.disableExtension(w.identifier),E.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${v.identifier.id}' is disabled`)),h&&(R.addToMigrationList((0,n.getExtensionId)(v.manifest.publisher,v.manifest.name),(0,n.getExtensionId)(w.manifest.publisher,w.manifest.name)),E.info("Added pre-release extension to the storage migration list"))),E.info(`Migrated '${v.identifier.id}' extension to '${y}' extension.`)}catch(g){E.error(g)}}}catch(I){E.error(I)}}e.migrateUnsupportedExtensions=L}),define(ne[188],ie([0,1,5,9,2,4,19,61,7,29,22,15,30,31,13,8]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let g=class extends L.Disposable{constructor(m,S,l,r){super();this.fileService=S,this.extensionGalleryService=l,this.logService=r,this.extensionsDownloadDir=b.URI.file(m.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(m,S){await this.cleanUpPromise;const l=this.getName(m),r=(0,T.joinPath)(this.extensionsDownloadDir,l);if(!await this.fileService.exists(r)){const a=(0,T.joinPath)(this.extensionsDownloadDir,`.${(0,E.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(m,a,S);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(a)}catch{}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",m.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(i)}. Deleted the vsix from downloaded location`,a.path),i}}return r}async delete(m){await this.cleanUpPromise,await this.fileService.del(m)}async rename(m,S,l){try{await I.Promises.rename(m.fsPath,S.fsPath)}catch(r){if(A.isWindows&&r&&r.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${m} to ${S} with 'EPERM' error. Trying again...`),this.rename(m,S,l);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const m=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(m.children){const S=[],l=[];for(const i of m.children){const t=this.parse(i.name);t&&l.push([t,i])}const r=(0,y.groupByExtension)(l,([i])=>i),a=[];for(const i of r)i.sort((t,o)=>R.rcompare(t[0].version,o[0].version)),S.push(...i.slice(1).map(t=>t[1].resource)),a.push(i[0][1]);a.sort((i,t)=>i.mtime-t.mtime),S.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(i=>i.resource)),await D.Promises.settled(S.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(m){this.logService.error(m)}}getName(m){return this.cache?`${new y.ExtensionIdentifierWithVersion(m.identifier,m.version).key().toLowerCase()}${m.properties.targetPlatform!=="undefined"?`-${m.properties.targetPlatform}`:""}`:(0,E.generateUuid)()}parse(m){const S=d.exec(m);return S&&S[1]&&S[2]?new y.ExtensionIdentifierWithVersion({id:S[1]},S[2]):null}};g=de([J(0,C.INativeEnvironmentService),J(1,h.IFileService),J(2,f.IExtensionGalleryService),J(3,v.ILogService)],g),e.ExtensionsDownloader=g}),define(ne[189],ie([0,1,2,10,22,90]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class T extends D.Disposable{constructor(b,E){super();this.environmentService=b,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(E.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(E.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(b){b.some(E=>!!E.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){L.Promises.rm(this.extensionsManifestCache,L.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=T}),define(ne[190],ie([0,1,83,16,5,2,18,10,22,15,30,31,59,8]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends A.Disposable{constructor(g,w,m){super();this.extensionManagementService=g,this.logService=m,this.cache=this._register(new v(w,m)),this.extensionManagementService.registerParticipant({postInstall:async S=>this.postInstallExtension(S),postUninstall:async S=>this.postUninstallExtension(S)})}async getLanguageIds(){const g=await this.cache.getLanguagePacks(),w=["en",...Object.keys(g)];return(0,n.distinct)(w)}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const w=await this.cache.getLanguagePacks();Object.keys(w).some(m=>w[m]&&w[m].extensions.some(S=>(0,C.areSameExtensions)(S.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),m=await this.cache.update(w);return!(0,n.equals)(Object.keys(g),Object.keys(m))}};h=de([J(0,I.IExtensionManagementService),J(1,E.INativeEnvironmentService),J(2,y.ILogService)],h),e.LocalizationsService=h;let v=class extends A.Disposable{constructor(g,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new L.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(w=>{Object.keys(w).forEach(m=>delete w[m]),this.createLanguagePacksFromExtensions(w,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...w){for(const m of w)m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,m);Object.keys(g).forEach(m=>this.updateHash(g[m]))}createLanguagePacksFromExtension(g,w){const m=w.identifier,S=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const l of S)if(w.location.scheme===T.Schemas.file&&(0,f.isValidLocalization)(l)){let r=g[l.languageId];r||(r={hash:"",extensions:[],translations:{}},g[l.languageId]=r);let a=r.extensions.filter(i=>(0,C.areSameExtensions)(i.extensionIdentifier,m))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:m,version:w.manifest.version});for(const i of l.translations)r.translations[i.id]=(0,R.join)(w.location.fsPath,i.path)}}updateHash(g){if(g){const w=(0,D.createHash)("md5");for(const m of g.extensions)w.update(m.extensionIdentifier.uuid||m.extensionIdentifier.id).update(m.version);g.hash=w.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,m=>m.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(m)).then(m=>{try{return JSON.parse(m)}catch{return{}}}).then(m=>(w=g(m),m)).then(m=>{for(const l of Object.keys(m))m[l]||delete m[l];this.languagePacks=m,this.initializedCache=!0;const S=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",S),b.Promises.writeFile(this.languagePacksFilePath,S)}).then(()=>w,m=>this.logService.error(m))})}};v=de([J(0,E.INativeEnvironmentService),J(1,y.ILogService)],v)}),define(ne[191],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,8]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,L.createDecorator)("sharedTunnelsService");var T;(function(h){h.Http="http",h.Https="https"})(T=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function E(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const v=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!v)return{address:v[1],port:+v[2]}}e.extractLocalHostUriMetaDataForPortMapping=E,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function C(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=C;function f(h,v){return v?v!==1&&h<1024:!n.isWindows&&h<1024}e.isPortPrivileged=f;let y=class{constructor(v){this.logService=v,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(v){return this._tunnelProvider=v,v?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(v){this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const v=[],d=Array.from(this._tunnels.values());for(let g of d){const w=Array.from(g.values());for(let m of w){const S=await m.value;S&&v.push(S)}}return v}async dispose(){for(const v of this._tunnels.values()){for(const{value:d}of v.values())await d.then(g=>g?.dispose());v.clear()}this._tunnels.clear()}openTunnel(v,d,g,w,m=!1,S=R.Private,l){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${w}.`),!v)return;d||(d="localhost");const r=this.retainOrCreateTunnel(v,d,g,w,m,S,l);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(v){return{tunnelRemotePort:v.tunnelRemotePort,tunnelRemoteHost:v.tunnelRemoteHost,tunnelLocalPort:v.tunnelLocalPort,localAddress:v.localAddress,privacy:v.privacy,protocol:v.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${v.tunnelRemoteHost}:${v.tunnelRemotePort} `);const d=this._tunnels.get(v.tunnelRemoteHost);if(d){const g=d.get(v.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(v.tunnelRemoteHost,v.tunnelRemotePort,g))}}}}async tryDisposeTunnel(v,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${v}:${d}.`);const w=g.value.then(async m=>{m&&(await m.dispose(!0),this._onTunnelClosed.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this._tunnels.has(v)&&this._tunnels.get(v).delete(d),w}}async closeTunnel(v,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${v}:${d} `);const g=this._tunnels.get(v);if(g&&g.has(d)){const w=g.get(d);w.refcount=0,await this.tryDisposeTunnel(v,d,w)}}addTunnelToMap(v,d,g){this._tunnels.has(v)||this._tunnels.set(v,new Map),this._tunnels.get(v).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(v,d){const g=this._tunnels.get(v);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(v))}getTunnelFromMap(v,d){let g=[v];I(v)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):C(v)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const w=g.map(m=>this._tunnels.get(m));for(const m of w){const S=m?.get(d);if(S)return S}}canTunnel(v){return!!E(v)}createWithProvider(v,d,g,w,m,S,l){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${w}.`);const a={elevationRequired:m?f(w===void 0?g:w):!1},i={remoteAddress:{host:d,port:g},localAddressPort:w,privacy:S,public:S!==R.Private,protocol:l},t=v.forwardPort(i,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,g,t),t}};y=de([J(0,A.ILogService)],y),e.AbstractTunnelService=y}),define(ne[192],ie([0,1,8,62,2,9,5]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends L.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new T.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let b=class Ct extends L.Disposable{constructor(I,C){super();this._tunnelService=I,this._logService=C,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(I,C,f,y,h,v){const d=new R,g=await Promise.resolve(this._tunnelService.openTunnel(I,d,f,y,h,v));if(!g)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${y} (remote).`),d.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(C))throw this._disposedTunnels.delete(C),d.dispose(),await g.dispose(),(0,A.canceled)();return d.setTunnel(g),this._tunnels.set(C,d),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${C}: ${g.localAddress} (local) to ${f}:${y} (remote).`),{tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress}}async setAddress(I,C){const f=this._tunnels.get(I);!f||f.setAddress(C)}async destroyTunnel(I){const C=this._tunnels.get(I);if(C){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await C.dispose();return}this._disposedTunnels.add(I)}};b._lastId=0,b=de([J(0,n.ISharedTunnelsService),J(1,D.ILogService)],b),e.SharedProcessTunnelService=b}),define(ne[193],ie([0,1,119,20,8]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,D.request)(R,b)}async resolveProxy(R){}};A=de([J(0,n.IConfigurationService),J(1,L.ILogService)],A),e.RequestService=A}),define(ne[43],ie([0,1,17,140,42,6,38]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function b(h){return h.res.statusCode===204}async function E(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return b(h)?null:(await(0,D.streamToBuffer)(h.stream)).toString()}e.asText=E;async function I(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(b(h))return null;const d=(await(0,D.streamToBuffer)(h.stream)).toString();try{return JSON.parse(d)}catch(g){throw g.message+=`:
`+d,g}}e.asJson=I;function C(h){y(h)}e.updateProxyConfigurationsScope=C;let f;function y(h){const v=T.Registry.as(L.Extensions.Configuration),d=f;f={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:d?[d]:[]})}y(2)}),define(ne[194],ie([0,1,23,18,13,43]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=class{constructor(b,E){this.requestService=b,this.fileService=E}async download(b,E,I=D.CancellationToken.None){if(b.scheme===n.Schemas.file||b.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(b,E);return}const C={type:"GET",url:b.toString()},f=await this.requestService.request(C,I);if(f.res.statusCode===200)await this.fileService.writeFile(E,f.stream);else{const y=await(0,A.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${y}`)}}};T=de([J(0,A.IRequestService),J(1,L.IFileService)],T),e.DownloadService=T}),define(ne[195],ie([0,1,16,23,67,2,19,153,13,8,27,43]),function(Y,e,D,n,L,A,T,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends A.Disposable{constructor(h,v,d,g){super();this.fileService=h,this.productService=v,this.requestService=d,this.logService=g,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,L.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const v=[];for(const[d,g]of this.allConfigBasedTips)if(!(g.configScheme&&g.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,T.joinPath)(h,d)),m=new Map;(0,L.forEach)(g.recommendations,({key:l,value:r})=>{if((0,D.isNonEmptyArray)(r.remotes))for(const a of r.remotes)m.set(a,{extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else v.push({extensionId:l,extensionName:r.name,configName:g.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const S=(0,R.getDomainsOfRemotes)(w.value.toString(),[...m.keys()]);for(const l of S){const r=m.get(l);r&&v.push(r)}}catch{}return v}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(h.res.statusCode!==200)return[];const v=await(0,C.asJson)(h);return v?v.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=de([J(0,b.IFileService),J(1,I.IProductService),J(2,C.IRequestService),J(3,E.ILogService)],f),e.ExtensionTipsService=f}),define(ne[46],ie([0,1,17,29]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(A,T,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const I=(await T.readFile(A.serviceMachineIdResource)).value.toString();b=(0,n.isUUID)(I)?I:null}catch{b=null}if(!b){b=(0,n.generateUuid)();try{await T.writeFile(A.serviceMachineIdResource,D.VSBuffer.fromString(b))}catch{}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=L}),define(ne[91],ie([0,1,70,6]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function L(A){return(0,D.hash)({moduleId:A.process.moduleId,windowId:A.reply.windowId})}e.hash=L,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[196],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[197],ie([0,1,74,5,23,3,2,18,29,8,91,196]),function(Y,e,D,n,L,A,T,R,b,E,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let f=class{constructor(v){this.logService=v,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(v){const d=`window: ${v.reply.windowId}, moduleId: ${v.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${d})`);const g=(0,I.hash)(v);this.processeDisposables.has(g)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${d})`),this.doDisposeWorker(v));const w=new L.CancellationTokenSource;let m,S,l;this.processeDisposables.set(g,t=>{w.dispose(!0),m?.terminate(v,L.CancellationToken.None),S?.close(),l?.close(),this.processeDisposables.delete(g);const o=this.processResolvers.get(g);o&&(this.processResolvers.delete(g),o({reason:t}))}),m=await this.getOrCreateWebWorker(v);const r=new Promise(t=>{this.processResolvers.set(g,t)});if(w.token.isCancellationRequested)return r;const{port1:a,port2:i}=new MessageChannel;return S=a,l=i,await m.spawn(v,l,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${d})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",v,[S])),r}getOrCreateWebWorker(v){let d=this.workers.get(v.process.moduleId);if(!d){this.logService.trace(`SharedProcess: creating new web worker (${v.process.moduleId})`);const g=new y(v.process.type,this.logService);d=g.init(),g.onDidProcessSelfTerminate(({configuration:w,reason:m})=>{this.doDisposeWorker(w,m)}),this.workers.set(v.process.moduleId,d)}return d}async disposeWorker(v){return this.doDisposeWorker(v)}doDisposeWorker(v,d){const g=this.processeDisposables.get((0,I.hash)(v));g&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${v.reply.windowId}, moduleId: ${v.process.moduleId})`),g(d))}};f=de([J(0,E.ILogService)],f),e.SharedProcessWorkerService=f;class y extends T.Disposable{constructor(v,d){super();this.type=v,this.logService=d,this._onDidProcessSelfTerminate=this._register(new A.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const v=new n.DeferredPromise,d=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return d.onerror=g=>{this.logService.error(`SharedProcess: worker error (${this.type})`,g.message)},d.onmessageerror=g=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,g)},d.onmessage=g=>{const{id:w,message:m,configuration:S,nonce:l}=g.data;switch(w){case C.SharedProcessWorkerMessages.Ready:v.complete(d);break;case C.SharedProcessWorkerMessages.Ack:if(l){const r=this.mapMessageNonceToPendingMessageResolve.get(l);r&&(this.mapMessageNonceToPendingMessageResolve.delete(l),r())}break;case C.SharedProcessWorkerMessages.SelfTerminated:S&&m&&this._onDidProcessSelfTerminate.fire({configuration:S,reason:JSON.parse(m)});break;case C.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,m);break;case C.SharedProcessWorkerMessages.Info:m&&this.logService.info(m);break;case C.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,m);break;case C.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,m);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,g)}},d.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),v.p}async send(v,d,g){const w=await this.workerReady;if(!d.isCancellationRequested)return new Promise(m=>{const S=(0,b.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(S,m);const l={...v,nonce:S};g?w.postMessage(l,[g]):w.postMessage(l),d.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(S)&&m()})})}spawn(v,d,g){const w={id:C.SharedProcessWorkerMessages.Spawn,configuration:v,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",Y).fsPath}};return this.send(w,g,d)}terminate(v,d){const g={id:C.SharedProcessWorkerMessages.Terminate,configuration:v};return this.send(g,d)}}}),define(ne[198],ie([0,1,54,18,152]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class A extends L.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.userData})}}de([D.memoize],A.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=A}),define(ne[92],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[199],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((L,A)=>Y(["vsda"],L,A))}async createNewMessage(L){try{const A=await this.vsda(),T=new A.validator;if(T){const R=String(D._nextId++);return this.validators.set(R,T),{id:R,data:T.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const T=this.validators.get(L.id);if(!T)return!1;this.validators.delete(L.id);try{return T.validate(A)==="ok"}catch{return!1}}async sign(L){try{const A=await this.vsda(),T=new A.signer;if(T)return T.sign(L)}catch{}return L}}e.SignService=D,D._nextId=1}),define(ne[24],ie([0,1,5,3,2,177,14,75,6]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var I;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var C;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(C=e.StorageScope||(e.StorageScope={}));var f;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class y extends L.Disposable{constructor(g={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,A.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,w){w===E?(g===0?this._globalKeyTargets=void 0:g===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:g})):this._onDidChangeValue.fire({scope:g,key:w,target:this.getKeyTargets(g)[w]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,w,m){return this.getStorage(w)?.get(g,m)}getBoolean(g,w,m){return this.getStorage(w)?.getBoolean(g,m)}getNumber(g,w,m){return this.getStorage(w)?.getNumber(g,m)}store(g,w,m,S){if((0,T.isUndefinedOrNull)(w)){this.remove(g,m);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,m,S),this.getStorage(m)?.set(g,w)})}remove(g,w){this.withPausedEmitters(()=>{this.updateKeyTarget(g,w,void 0),this.getStorage(w)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,w){const m=[],S=this.getKeyTargets(g);for(const l of Object.keys(S))S[l]===w&&m.push(l);return m}updateKeyTarget(g,w,m){const S=this.getKeyTargets(w);typeof m=="number"?S[g]!==m&&(S[g]=m,this.getStorage(w)?.set(E,JSON.stringify(S))):typeof S[g]=="number"&&(delete S[g],this.getStorage(w)?.set(E,JSON.stringify(S)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(g){return g===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(g){const w=this.get(E,g);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=I.NONE){this._onWillSaveState.fire({reason:g});const w=this.getStorage(0),m=this.getStorage(1);switch(g){case I.NONE:await D.Promises.settled([w?.whenFlushed()??Promise.resolve(),m?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await D.Promises.settled([w?.flush(0)??Promise.resolve(),m?.flush(0)??Promise.resolve()]);break}}async logStorage(){const g=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return v(g,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends y{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.globalStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g)))}getStorage(g){return g===0?this.globalStorage:this.workspaceStorage}getLogDetails(g){return g===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(g){}}e.InMemoryStorageService=h;async function v(d,g,w,m){const S=s=>{try{return JSON.parse(s)}catch{return s}},l=new Map,r=new Map;d.forEach((s,c)=>{l.set(c,s),r.set(c,S(s))});const a=new Map,i=new Map;g.forEach((s,c)=>{a.set(c,s),i.set(c,S(s))}),console.group(`Storage: Global (path: ${w})`);let t=[];l.forEach((s,c)=>{t.push({key:c,value:s})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${m})`);let o=[];a.forEach((s,c)=>{o.push({key:c,value:s})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=v}),define(ne[200],ie([0,1,3,2,14,30,31,24]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends n.Disposable{constructor(C,f){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new E(C)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(f.onDidInstallExtensions(y=>y.forEach(({local:h,operation:v})=>{h&&v===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(C,f){return this._removeFromDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}async disableExtension(C,f){return this._addToDisabledExtensions(C)?(this._onDidChangeEnablement.fire({extensions:[C],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(C){let f=this.getDisabledExtensions();return f.every(y=>!(0,T.areSameExtensions)(y,C))?(f.push(C),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(C){let f=this.getDisabledExtensions();for(let y=0;y<f.length;y++){const h=f[y];if((0,T.areSameExtensions)(h,C))return f.splice(y,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(C){this._setExtensions(A.DISABLED_EXTENSIONS_STORAGE_PATH,C)}_getExtensions(C){return this.storageManger.get(C,0)}_setExtensions(C,f){this.storageManger.set(C,f,0)}};b=de([J(0,R.IStorageService),J(1,A.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class E extends n.Disposable{constructor(C){super();this.storageService=C,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(C.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(C,f){let y;return f===0?((0,L.isUndefinedOrNull)(this.storage[C])&&(this.storage[C]=this._get(C,f)),y=this.storage[C]):y=this._get(C,f),JSON.parse(y)}set(C,f,y){let h=JSON.stringify(f.map(({id:d,uuid:g})=>({id:d,uuid:g})));this._get(C,y)!==h&&(y===0&&(f.length?this.storage[C]=h:delete this.storage[C]),this._set(C,f.length?h:void 0,y))}onDidStorageChange(C){if(C.scope===0&&!(0,L.isUndefinedOrNull)(this.storage[C.key])&&this._get(C.key,C.scope)!==this.storage[C.key]){const y=this.get(C.key,C.scope);delete this.storage[C.key];const h=this.get(C.key,C.scope),v=y.filter(g=>!h.some(w=>(0,T.areSameExtensions)(g,w))),d=h.filter(g=>!y.some(w=>(0,T.areSameExtensions)(w,g)));(v.length||d.length)&&this._onDidChange.fire([...v,...d])}}_get(C,f){return this.storageService.get(C,f,"[]")}_set(C,f,y){f?this.storageService.store(C,f,y,1):this.storageService.remove(C,y)}}e.StorageManager=E}),define(ne[63],ie([0,1,6,3,2,24,31,27,16,8,14]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let f=class nt extends L.Disposable{constructor(h,v,d){super();this.storageService=h,this.productService=v,this.logService=d,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(g=>this.onDidChangeStorageValue(g)))}static toKey(h){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(h.id)}@${h.version}`}static fromKey(h){const v=C.exec(h);if(v&&v[1])return{id:v[1],version:v[2]}}initialize(){const h=this.storageService.keys(0,1);for(const v of h){const d=nt.fromKey(v);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(h){if(h.scope!==0)return;if(this.extensionsWithKeysForSync.has(h.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const v=nt.fromKey(h.key);if(v){this.extensionsWithKeysForSync.add(v.id.toLowerCase()),this._onDidChangeExtensionStorageToSync.fire();return}}getExtensionId(h){if((0,I.isString)(h))return h;const v=h.manifest?h.manifest.publisher:h.publisher,d=h.manifest?h.manifest.name:h.name;return(0,T.getExtensionId)(v,d)}getExtensionState(h,v){const d=this.getExtensionId(h),g=this.storageService.get(d,v?0:1);if(g)try{return JSON.parse(g)}catch(w){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${v}): ${w}`)}}setExtensionState(h,v,d){const g=this.getExtensionId(h);v===void 0?this.storageService.remove(g,d?0:1):this.storageService.store(g,JSON.stringify(v),d?0:1,1)}setKeysForSync(h,v){this.storageService.store(nt.toKey(h),JSON.stringify(v),0,1)}getKeysForSync(h){const v=this.productService.extensionSyncedKeys?.[h.id.toLowerCase()],d=this.storageService.get(nt.toKey(h),0),g=d?JSON.parse(d):void 0;return g&&v?(0,b.distinct)([...g,...v]):g||v}addToMigrationList(h,v){if(h!==v){const d=this.migrationList.filter(g=>!g.includes(h)&&!g.includes(v));d.push([h,v]),this.migrationList=d}}getSourceExtensionToMigrate(h){const v=this.migrationList.find(([,d])=>h===d);return v?v[0]:void 0}get migrationList(){const h=this.storageService.get("extensionStorage.migrationList",0,"[]");try{const v=JSON.parse(h);if((0,I.isArray)(v))return v}catch{}return[]}set migrationList(h){h.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(h),0,1):this.storageService.remove("extensionStorage.migrationList",0)}};f=de([J(0,A.IStorageService),J(1,R.IProductService),J(2,E.ILogService)],f),e.ExtensionStorageService=f}),define(ne[201],ie([0,1,2,30,63,187,8]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let R=class extends D.Disposable{constructor(E,I,C,f,y){super();E.removeDeprecatedExtensions(),(0,A.migrateUnsupportedExtensions)(E,I,C,f,y)}};R=de([J(0,n.IExtensionManagementService),J(1,n.IExtensionGalleryService),J(2,L.IExtensionStorageService),J(3,n.IGlobalExtensionEnablementService),J(4,T.ILogService)],R),e.ExtensionsCleaner=R}),define(ne[202],ie([0,1,3,2]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends n.Disposable{constructor(E,I){super();this.channel=E,this.workspace=I}async getItems(){const E={workspace:this.workspace},I=await this.channel.call("getItems",E);return new Map(I)}updateItems(E){const I={workspace:this.workspace};return E.insert&&(I.insert=Array.from(E.insert.entries())),E.delete&&(I.delete=Array.from(E.delete.values())),this.channel.call("updateItems",I)}}class A extends L{constructor(E){super(E,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(E=>this.onDidChangeGlobalStorage(E)))}onDidChangeGlobalStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}async close(){this.dispose()}}class T extends L{constructor(E,I){super(E,I);this.onDidChangeItemsExternal=D.Event.None}async close(){const E={workspace:this.workspace};return this.channel.call("close",E)}}class R extends n.Disposable{constructor(E,I){super();this.channel=E,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new T(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[203],ie([0,1,5,2,19,75,24,202]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends T.AbstractStorageService{constructor(I,C,f){super();this.mainProcessService=C,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new n.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),C=new A.Storage(I.globalStorage);return this._register(C.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),C}createWorkspaceStorage(I){const C=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(C.workspaceStorage){const f=new A.Storage(C.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)),this.workspaceStorageId=I?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await D.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,L.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(T.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const C=this.workspaceStorage,f=C?.items??new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[y,h]of f)this.workspaceStorage.set(y,h)}}e.NativeStorageService=b}),define(ne[204],ie([0,1,4,32,7,29]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function T(E){if(D.platform===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}async function R(E,I,C,f,y,h,v,d,g,w){const m=Object.create(null);m["common.machineId"]=v,m.sessionID=(0,A.generateUuid)()+Date.now(),m.commitHash=y,m.version=h,m["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),m["common.platform"]=(0,D.PlatformToString)(D.platform),m["common.nodePlatform"]=n.platform,m["common.nodeArch"]=f,m["common.product"]=w||"desktop";const S=b(d||[]);S&&(m["common.msftInternal"]=S);let l=0;const r=Date.now();Object.defineProperties(m,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),D.isLinuxSnap&&(m["common.snap"]="true");const a=T(C);a&&(m["common.platformDetail"]=a);try{const i=await E.readFile(L.URI.file(g));m["common.source"]=i.value.toString().slice(0,30)}catch{}return m}e.resolveCommonProperties=R;function b(E){const I=n.env.USERDNSDOMAIN;if(!I)return!1;const C=I.toLowerCase();return E.some(f=>C===f)}e.verifyMicrosoftInternalDomain=b}),define(ne[21],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[205],ie([0,1,33,55,5,35,18,10,4,7,113,22,116,80,13,27,21]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function g(r,a){const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const o=D.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:O=>/^[a-z]:\\(my drive|shared drives)\\/.test(O)||O.startsWith(o+"\\my drive\\")},{tag:"dropbox",matcher:O=>O.startsWith(o+"\\dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(o+"\\onedrive")},{tag:"box",matcher:O=>O.startsWith(o+"\\box\\")},{tag:"nextcloud",matcher:O=>O.startsWith(o+"\\nextcloud\\")},{tag:"owncloud",matcher:O=>O.startsWith(o+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:O=>O.startsWith("/volumes/googledrive/")||O.startsWith(o+"/my drive/")},{tag:"dropbox",matcher:O=>O.startsWith(o+"/dropbox")},{tag:"onedrive",matcher:O=>O.startsWith(o+"/onedrive")||O.startsWith(o+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:O=>O.startsWith(o+"/library/mobile documents/")},{tag:"box",matcher:O=>O.startsWith(o+"/box/")},{tag:"nextcloud",matcher:O=>O.startsWith(o+"/nextcloud/")},{tag:"owncloud",matcher:O=>O.startsWith(o+"/owncloud/")}];break}const s=new Map,c=new Map,u=2e4;function p(O,F,$,k){for(const j of t){const U=O.toLowerCase();j.matcher(U)&&c.set(j.tag,1)}const M=F.substring(O.length+1);return L.Promises.withAsyncBody(async j=>{let U;try{U=await C.Promises.readdir(F,{withFileTypes:!0})}catch{j();return}if(k.count>=u){k.count+=U.length,k.maxReached=!0,j();return}let G=U.length;if(G===0){j();return}let K=U;k.count+U.length>u&&(k.maxReached=!0,G=u-k.count,K=U.slice(0,G)),k.count+=U.length;for(const x of K)if(x.isDirectory()){if($.includes(x.name)||await p(O,(0,R.join)(F,x.name),$,k),--G==0){j();return}}else{const q=x.name.lastIndexOf(".");if(q>=0){const X=x.name.substring(q+1);X&&s.set(X,(s.get(X)??0)+1)}for(const X of i)X.relativePathPattern?.test(M)!==!1&&X.filePattern.test(x.name)&&c.set(X.tag,(c.get(X.tag)??0)+1);if(--G==0){j();return}}})}const P={count:0,maxReached:!1};await p(r,r,a,P);const _=await S(r);return{configFiles:w(c),fileTypes:w(s),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:_}}e.collectWorkspaceStats=g;function w(r){return[...n.Iterable.map(r.entries(),([a,i])=>({name:a,count:i}))].sort((a,i)=>i.count-a.count)}function m(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},a=D.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=m;async function S(r){try{const a=new Map,i=(0,R.join)(r,".vscode","launch.json"),t=await C.Promises.readFile(i),o=[],s=(0,A.parse)(t.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,A.getNodeType)(s)==="object"&&s.configurations)for(const c of s.configurations){const u=c.type;u&&(a.has(u)?a.set(u,a.get(u)+1):a.set(u,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=S;let l=class{constructor(a,i){this.telemetryService=a,this.productService=i}formatMachineInfo(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}formatEnvironment(a){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const t=D.cpus();return t&&t.length>0&&i.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||i.push(`Load (avg):       ${D.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[o,s]=t,c=this.formatProcessList(a,o);return i.forEach(u=>{if((0,y.isRemoteDiagnosticError)(u))c+=`
${u.errorMessage}`,s+=`
${u.errorMessage}`;else if(c+=`

Remote: ${u.hostName}`,u.processes&&(c+=`
${this.formatProcessList(a,u.processes)}`),u.workspaceMetadata){s+=`
|  Remote: ${u.hostName}`;for(const p of Object.keys(u.workspaceMetadata)){const P=u.workspaceMetadata[p];let _=`${P.fileCount} files`;P.maxFilesReached&&(_=`more than ${_}`),s+=`|    Folder (${p}): ${_}`,s+=this.formatWorkspaceStats(P)}}}),{processInfo:c,workspaceInfo:s}})}async getSystemInfo(a,i){const{memory:t,vmHint:o,os:s,cpus:c}=m(),u={os:s,memory:t,cpus:c,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return b.isWindows||(u.load=`${D.loadavg().map(p=>Math.round(p)).join(", ")}`),b.isLinux&&(u.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(u)}async getDiagnostics(a,i){const t=[];return(0,f.listProcesses)(a.mainPID).then(async o=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,o)),a.windows.some(s=>s.folderURIs&&s.folderURIs.length>0&&!s.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),i.forEach(s=>{if((0,y.isRemoteDiagnosticError)(s))t.push(`
${s.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${s.hostName}`),t.push(this.formatMachineInfo(s.machineInfo)),s.processes&&t.push(this.formatProcessList(a,s.processes)),s.workspaceMetadata)for(const c of Object.keys(s.workspaceMetadata)){const u=s.workspaceMetadata[c];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),t.push(`Folder (${c}): ${p}`),t.push(this.formatWorkspaceStats(u))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const i=[],t=60;let o=0;const s=(P,_)=>{const O=` ${P}(${_})`;o+O.length>t?(i.push(c),c="|                 ",o=c.length):o+=O.length,c+=O};let c="|      File types:";const u=10;let p=a.fileTypes.length>u?u:a.fileTypes.length;for(let P=0;P<p;P++){const _=a.fileTypes[P];s(_.name,_.count)}if(i.push(c),a.configFiles.length>=0&&(c="|      Conf files:",o=0,a.configFiles.forEach(P=>{s(P.name,P.count)}),i.push(c)),a.launchConfigFiles.length>0){let P="|      Launch Configs:";a.launchConfigFiles.forEach(_=>{P+=_.count>1?` ${_.name}(${_.count})`:` ${_.name}`}),i.push(P)}return i.join(`
`)}expandGPUFeatures(a){const i=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(i-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const i=[],t=[];return a.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(s=>{const c=E.URI.revive(s);if(c.scheme===T.Schemas.file){const u=c.fsPath;t.push(g(u,["node_modules",".git"]).then(p=>{let P=`${p.fileCount} files`;p.maxFilesReached&&(P=`more than ${P}`),i.push(`|    Folder (${(0,R.basename)(u)}): ${P}`),i.push(this.formatWorkspaceStats(p))}).catch(p=>{i.push(`|      Error: Unable to collect workspace stats for folder ${u} (${p.toString()})`)}))}else i.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(a,i){const t=new Map;a.windows.forEach(s=>t.set(s.pid,s.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(a.mainPID,t,o,i,0),o.join(`
`)}formatProcessItem(a,i,t,o,s){const c=s===0;let u;c?u=o.pid===a?`${this.productService.applicationName} main`:"remote agent":(u=`${"  ".repeat(s)} ${o.name}`,o.name==="window"&&(u=`${u} (${i.get(o.pid)})`));const p=process.platform==="win32"?o.mem:D.totalmem()*(o.mem/100);t.push(`${o.load.toFixed(0).padStart(5," ")}	${(p/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${u}`),Array.isArray(o.children)&&o.children.forEach(P=>this.formatProcessItem(a,i,t,P,s+1))}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const t=E.URI.revive(i);if(t.scheme!==T.Schemas.file)continue;const o=t.fsPath;try{const s=await g(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),s.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),s.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),s.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};l=de([J(0,d.ITelemetryService),J(1,v.IProductService)],l),e.DiagnosticsService=l}),define(ne[206],ie([0,1,16,5,23,9,3,2,4,14,7,129,30,31,8,27,21]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends R.Disposable{constructor(a,i,t,o){super();this.galleryService=a,this.telemetryService=i,this.logService=t,this.productService=o,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(s=>s.cancel()),this.uninstallingExtensions.forEach(s=>s.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const i=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,i))}async installFromGallery(a,i={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(C.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,i)}catch(t){throw S(this.telemetryService,"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),m(t)}}async uninstall(a,i={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,i)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const i=await this.findGalleryExtension(a);if(!i)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(i)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,i,t){if(!I.URI.isUri(i)){let p=this.installingExtensions.get(new y.ExtensionIdentifierWithVersion(i.identifier,i.version).key());if(p)return this.logService.info("Extensions is already requested to install",i.identifier.id),p.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const o=[],s=[],c=this.createInstallExtensionTask(a,i,t);I.URI.isUri(i)||this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:i}),this.logService.info("Installing extension:",c.identifier.id),o.push({task:c,manifest:a});let u=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:_,manifest:O}of P)if(u=u||!!O.extensionDependencies?.some(F=>(0,y.areSameExtensions)({id:F},c.identifier)),this.installingExtensions.has(new y.ExtensionIdentifierWithVersion(_.identifier,_.version).key()))this.logService.info("Extension is already requested to install",_.identifier.id);else{const F=this.createInstallExtensionTask(O,_,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new y.ExtensionIdentifierWithVersion(F.identifier,O.version).key(),F),this._onInstallExtension.fire({identifier:F.identifier,source:_}),this.logService.info("Installing extension:",F.identifier.id),o.push({task:F,manifest:O})}}catch(P){if(I.URI.isUri(c.source))(0,D.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,P.message),(0,D.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),P}const p=o.reduce((P,{task:_,manifest:O})=>(P.set(_.identifier.id.toLowerCase(),{task:_,manifest:O}),P),new Map);for(;p.size;){let P;const _=[...p.values()].filter(({manifest:O})=>!O.extensionDependencies?.some(F=>p.has(F.toLowerCase())));_.length?P=p.size===1?_:_.filter(({task:O})=>!(O===c&&!u)):(this.logService.info("Found extensions with circular dependencies",_.map(({task:O})=>O.identifier.id)),P=[...p.values()]),await this.joinAllSettled(P.map(async({task:O})=>{const F=new Date().getTime(),$=(0,E.isUndefined)(t.operation)?O.operation:t.operation;try{const k=await O.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(k,O.source,t,L.CancellationToken.None))),!I.URI.isUri(O.source)&&(S(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,void 0),b.isWeb&&$!==3))try{await this.galleryService.reportStatistic(k.manifest.publisher,k.manifest.name,k.manifest.version,"install")}catch{}s.push({local:k,identifier:O.identifier,operation:$,source:O.source})}catch(k){throw I.URI.isUri(O.source)||S(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,y.getGalleryExtensionTelemetryData)(O.source),new Date().getTime()-F,k),this.logService.error("Error while installing the extension:",O.identifier.id),k}finally{p.delete(O.identifier.id.toLowerCase())}}))}return s.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(s),s.filter(({identifier:P})=>(0,y.areSameExtensions)(P,c.identifier))[0].local}catch(p){if(o.forEach(({task:P})=>P.cancel()),s.length)try{const P=await Promise.allSettled(s.map(({local:_})=>this.createUninstallExtensionTask(_,{versionOnly:!0}).run()));for(let _=0;_<P.length;_++){const O=P[_],{identifier:F}=s[_];O.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",F.id):this.logService.warn("Rollback: Error while uninstalling extension",F.id,(0,A.getErrorMessage)(O.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,A.getErrorMessage)(P),s.map(({identifier:_})=>_.id))}throw this._onDidInstallExtensions.fire(o.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),p}finally{for(const{task:p,manifest:P}of o)if(!I.URI.isUri(p.source)){const _=new y.ExtensionIdentifierWithVersion(p.identifier,P.version).key();this.installingExtensions.delete(_)||this.logService.warn("Installation task is not found in the cache",_)}}}async joinAllSettled(a){const i=[],t=[],o=await Promise.allSettled(a);for(const s of o)s.status==="fulfilled"?i.push(s.value):t.push(s.reason);if(t.length)throw w(t);return i}async getAllDepsAndPackExtensionsToInstall(a,i,t,o){if(!this.galleryService.isEnabled())return[];let s=await this.getInstalled();const c=[a,...s.map(P=>P.identifier)],u=[],p=async(P,_)=>{const O=_.extensionDependencies||[],F=[...O];if(_.extensionPack){const $=t?s.find(k=>(0,y.areSameExtensions)(k.identifier,P)):void 0;for(const k of _.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(M=>(0,y.areSameExtensions)({id:M},{id:k}))||F.every(M=>!(0,y.areSameExtensions)({id:M},{id:k}))&&F.push(k)}if(F.length){const $=[...c,...u.map(M=>M.gallery.identifier)],k=F.filter(M=>$.every(j=>!(0,y.areSameExtensions)(j,{id:M})));if(k.length){const M=await this.galleryService.query({names:k,pageSize:F.length},L.CancellationToken.None);for(const j of M.firstPage){if($.find(K=>(0,y.areSameExtensions)(K,j.identifier)))continue;const U=O.some(K=>(0,y.areSameExtensions)({id:K},j.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(j,!0,o)}catch(K){if(K instanceof f.ExtensionManagementError&&K.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",j.identifier.id);continue}else throw K}u.push({gallery:G.extension,manifest:G.manifest}),await p(G.extension.identifier,_)}}}};return await p(a,i),s=await this.getInstalled(),u.filter(P=>!s.some(_=>(0,y.areSameExtensions)(_.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(a,i,t){const o=await this.getExtensionsControlManifest();if((0,y.getMaliciousExtensionsSet)(o).has(a.identifier.id))throw new f.ExtensionManagementError(C.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!o.unsupportedPreReleaseExtensions&&!!o.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(C.localize(4,null,a.identifier.id,o.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const u=await this.getTargetPlatform();throw new f.ExtensionManagementError(C.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(u)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.getCompatibleVersion(a,i,t);if(s){if(t&&a.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(C.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!t&&a.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([a.identifier],L.CancellationToken.None))[0]?new f.ExtensionManagementError(C.localize(7,null,a.identifier.id),f.ExtensionManagementErrorCode.ReleaseVersionNotFound):new f.ExtensionManagementError(C.localize(8,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",s.identifier.id);const c=await this.galleryService.getManifest(s,L.CancellationToken.None);if(c===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(c.version!==s.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:c}}async getCompatibleVersion(a,i,t){const o=await this.getTargetPlatform();let s=null;return i&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(s=(await this.galleryService.getExtensions([{...a.identifier,preRelease:t}],{targetPlatform:o,compatible:!0},L.CancellationToken.None))[0]||null),!s&&await this.galleryService.isExtensionCompatible(a,t,o)&&(s=a),!s&&i&&(s=await this.galleryService.getCompatibleExtension(a,t,o)),s}async unininstallExtension(a,i){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const o=(p,P)=>{const _=this.createUninstallExtensionTask(p,P);return this.uninstallingExtensions.set(_.extension.identifier.id.toLowerCase(),_),this.logService.info("Uninstalling extension:",p.identifier.id),this._onUninstallExtension.fire(p.identifier),_},s=(p,P)=>{P?this.logService.error("Failed to uninstall extension:",p.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",p.identifier.id),S(this.telemetryService,"extensionGallery:uninstall",(0,y.getLocalExtensionTelemetryData)(p),void 0,P),this._onDidUninstallExtension.fire({identifier:p.identifier,error:P?.code})},c=[],u=[];try{c.push(o(a,{}));const p=await this.getInstalled(1);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(a,p);for(const _ of P)this.uninstallingExtensions.has(_.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",_.identifier.id):c.push(o(_,{}))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(P=>P.extension),p,a),await this.joinAllSettled(c.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(_=>_.postUninstall(P.extension,i,L.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch{}s(P.extension)}catch(_){const O=_ instanceof f.ExtensionManagementError?_:new f.ExtensionManagementError((0,A.getErrorMessage)(_),f.ExtensionManagementErrorCode.Internal);throw s(P.extension,O),O}finally{u.push(P)}}))}catch(p){const P=p instanceof f.ExtensionManagementError?p:new f.ExtensionManagementError((0,A.getErrorMessage)(p),f.ExtensionManagementErrorCode.Internal);for(const _ of c){try{_.cancel()}catch{}u.includes(_)||s(_.extension,P)}throw P}finally{for(const p of c)this.uninstallingExtensions.delete(p.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",p.extension.identifier.id)}}checkForDependents(a,i,t){for(const o of a){const s=this.getDependents(o,i);if(s.length){const c=s.filter(u=>!a.some(p=>(0,y.areSameExtensions)(p.identifier,u.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(o,c,t))}}}getDependentsErrorMessage(a,i,t){return t===a?i.length===1?C.localize(9,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(10,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(11,null,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?C.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?C.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):C.localize(14,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(a,i,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const o=a.manifest.extensionPack?a.manifest.extensionPack:[];if(o.length){const s=i.filter(u=>!u.isBuiltin&&o.some(p=>(0,y.areSameExtensions)({id:p},u.identifier))),c=[];for(const u of s)c.push(...this.getAllPackExtensionsToUninstall(u,i,t));return[...s,...c]}return[]}getDependents(a,i){return i.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(o=>(0,y.areSameExtensions)({id:o},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const i=await this.findGalleryExtensionById(a.identifier.uuid);return i||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},L.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=de([J(0,f.IExtensionGalleryService),J(1,d.ITelemetryService),J(2,h.ILogService),J(3,v.IProductService)],g),e.AbstractExtensionManagementService=g;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((i,t)=>new Error(`${i.message}${i.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function m(r){if(r instanceof f.ExtensionManagementError)return r;const a=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function S(r,a,i,t,o){const s=o?o instanceof f.ExtensionManagementError?o.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...i,success:!o,duration:t,errorcode:s})}e.reportTelemetry=S;class l{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(a=>new Promise((i,t)=>{const o=a.onCancellationRequested(()=>{o.dispose(),t((0,A.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=l}),define(ne[207],ie([0,1,16,5,67,3,10,4,32,7,131,15,30,195,82,13,8,60,27,43,24,21]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let i=class extends y.ExtensionTipsService{constructor(o,s,c,u,p,P,_,O,F,$){super(_,O,F,$);this.environmentService=o,this.telemetryService=s,this.extensionManagementService=c,this.storageService=u,this.nativeHostService=p,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&(0,L.forEach)(O.exeBasedExtensionTips,({key:k,value:M})=>{const j=[],U=[],G=[];(0,L.forEach)(M.recommendations,({key:K,value:x})=>{x.important?M.important?j.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):U.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack}):G.push({extensionId:K,extensionName:x.name,isExtensionPack:!!x.isExtensionPack})}),j.length&&this.highImportanceExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:j}),U.length&&this.mediumImportanceExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:U}),G.length&&this.allOtherExecutableTips.set(k,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:G})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...s]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),s=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(s,c)}groupImportantTipsByExe(o,s){const c=new Map;o.forEach(O=>c.set(O.extensionId.toLowerCase(),O));const{installed:u,uninstalled:p}=this.groupByInstalled([...c.keys()],s);for(const O of u){const F=c.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:F.exeName})}for(const O of p){const F=c.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:F.exeName})}const P=this.getPromptedExecutableTips(),_=new Map;for(const O of p){const F=c.get(O);if(F&&(!P[F.exeName]||!P[F.exeName].includes(F.extensionId))){let $=_.get(F.exeName);$||($=[],_.set(F.exeName,$)),$.push(F)}}return _}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,s]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(s).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(s[0].exeName,s);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const u=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(u(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const u=this._register((0,n.disposableTimeout)(()=>{u.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),s=Date.now()-o,c=7*24*60*60*1e3;if(s<c){const P=this._register((0,n.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},c-s));return}const[u,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(P=>{switch(P){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(u),this.addToRecommendedExecutables(p[0].exeName,p);const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},c));break}case"ignored":this.mediumImportanceTipsByExe.delete(u),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const _=A.Event.once(A.Event.latch(A.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const _=this._register((0,n.disposableTimeout)(()=>{_.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(o){const s=o.map(({extensionId:u})=>u.toLowerCase()),c=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(s,c,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(a,0);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(a,o,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(o,s){const c=this.getPromptedExecutableTips();c[o]=s.map(({extensionId:u})=>u.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(o,s){const c=[],u=[],p=s.reduce((P,_)=>(P.add(_.identifier.id.toLowerCase()),P),new Set);return o.forEach(P=>{p.has(P.toLowerCase())?c.push(P):u.push(P)}),{installed:c,uninstalled:u}}async getValidExecutableBasedExtensionTips(o){const s=[],c=new Map;for(const u of o.keys()){const p=o.get(u);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const P=[];R.isWindows?p.windowsPath&&P.push(p.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(P.push((0,T.join)("/usr/local/bin",u)),P.push((0,T.join)("/usr/bin",u)),P.push((0,T.join)(this.environmentService.userHome.fsPath,u)));for(const _ of P){let O=c.get(_);if(O===void 0&&(O=await this.fileService.exists(E.URI.file(_)),c.set(_,O)),O)for(const{extensionId:F,extensionName:$,isExtensionPack:k}of p.recommendations)s.push({extensionId:F,extensionName:$,isExtensionPack:k,exeName:u,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return s}};i=de([J(0,C.INativeEnvironmentService),J(1,l.ITelemetryService),J(2,f.IExtensionManagementService),J(3,S.IStorageService),J(4,g.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,v.IFileService),J(7,w.IProductService),J(8,m.IRequestService),J(9,d.ILogService)],i),e.ExtensionTipsService=i}),define(ne[93],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(A){this.appenders=A}listen(A,T){throw new Error(`Event not found: ${T}`)}call(A,T,{eventName:R,data:b}){return this.appenders.forEach(E=>E.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(A){this.channel=A}log(A,T){return this.channel.call("log",{eventName:A,data:T}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[44],ie([0,1,28,14,20,21]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(g,w){return Promise.resolve(void 0)}publicLog2(g,w){return this.publicLog(g,w)}publicLogError(g,w){return Promise.resolve(void 0)}publicLogError2(g,w){return this.publicLogError(g,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class R{async publicLog(g,w,m){}async publicLogError(g,w,m){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(d,g){return g.onDidChangeConfiguration(w=>{w.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=b;function E(d,g){return!(g.disableTelemetry||!d.enableTelemetry||g.extensionTestsLocationURI)}e.supportsTelemetry=E;function I(d){const g=d.getValue(A.TELEMETRY_SETTING_ID),w=d.getValue("telemetry.enableCrashReporter");if(d.getValue(A.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(g??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function C(d){const g=Object.create(null),w=Object.create(null),m=Object.create(null);y(d,m);for(let S in m){S=S.length>150?S.substr(S.length-149):S;const l=m[S];typeof l=="number"?w[S]=l:typeof l=="boolean"?w[S]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${l.length}`),g[S]=l.substring(0,8191)):typeof l!="undefined"&&l!==null&&(g[S]=l)}return{properties:g,measurements:w}}e.validateTelemetryData=C;function f(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(m=>{d.indexOf(`${m}+`)===0&&(g=m)}),g}e.cleanRemoteAuthority=f;function y(d,g,w=0,m){if(!!d)for(let S of Object.getOwnPropertyNames(d)){const l=d[S],r=m?m+S:S;Array.isArray(l)?g[r]=(0,D.safeStringify)(l):l instanceof Date?g[r]=l.toISOString():(0,n.isObject)(l)?w<2?y(l,g,w+1,r+"."):g[r]=(0,D.safeStringify)(l):g[r]=l}}function h(d){if(!d)return[];const g=[];return v(g,"",d),g}function v(d,g,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(m=>v(d,g?`${g}.${m}`:m,w[m])):d.push(g)}}),define(ne[208],ie([0,1,44,149]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class L{constructor(){}setSharedProperty(b,E){}postEvent(b,E){}}class A{constructor(b,E,I,C,f){this.getMachineId=b,this.configurationService=E,this.productService=I,this.telemetry=C,this.keyValueStorage=f,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,D.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const y=this.configurationService.getValue("experiments.overrideDelay"),h=typeof y=="number"?y:0;this.overrideInitDelay=new Promise(v=>setTimeout(v,h))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const E=this.configurationService.getValue("experiments.override."+b);if(E!==void 0)return E;if(!this.tasClient||!this.experimentsEnabled)return;let I;const C=await this.tasClient;return this.networkInitialized?I=C.getTreatmentVariable("vscode",b):I=await C.getTreatmentVariableAsync("vscode",b,!0),I=C.getTreatmentVariable("vscode",b),I}async setupTASClient(){const b=this.productService.quality==="stable"?n.TargetPopulation.Public:n.TargetPopulation.Insiders,E=await this.getMachineId(),I=new n.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,E,b),C=this.productService.tasConfig,f=new(await new Promise((y,h)=>{Y(["tas-client-umd"],y,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:n.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:C.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:C.assignmentContextTelemetryPropertyName,telemetryEventName:C.telemetryEventName,endpoint:C.endpoint,refetchInterval:n.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=A;class T extends A{constructor(b,E,I){super(()=>Promise.resolve(b),E,I,new L)}}e.AssignmentService=T}),define(ne[209],ie([0,1,16,23,9,28,4,32,14,7,20,15,30,31,78,13,8,27,43,46,24,21,44]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=T.isWeb?"web":(0,f.getTargetPlatform)(T.platform,R.arch);var i;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function t(...z){return String(z.reduce((B,te)=>B|te,0))}var o;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class P{constructor(B=p){this.state=B}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(B,te=this.state.pageSize){return new P({...this.state,pageNumber:B,pageSize:te})}withFilter(B,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:B,value:ce})):[{filterType:B}]];return new P({...this.state,criteria:se})}withSortBy(B){return new P({...this.state,sortBy:B})}withSortOrder(B){return new P({...this.state,sortOrder:B})}withFlags(...B){return new P({...this.state,flags:B.reduce((te,se)=>te|se,0)})}withAssetTypes(...B){return new P({...this.state,assetTypes:B})}get raw(){const{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:ve,assetTypes:pe}=this.state;return{filters:[{criteria:B,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:pe,flags:ve}}get searchText(){const B=this.state.criteria.filter(te=>te.filterType===o.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(B=>String(B.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function _(z,B){const te=(z||[]).filter(se=>se.statisticName===B)[0];return te?te.value:0}function O(z){const B="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(B)===0).reduce((se,ce)=>{const he=M(z,ce.assetType);return he&&se.push([ce.assetType.substring(B.length),he]),se},[])}function F(z){if(z.properties){const B=z.properties.filter(ce=>ce.key===s.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=B.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return M(z,s.Repository)}function $(z){return{uri:`${z.fallbackAssetUri}/${s.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${s.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function k(z){const B=M(z,s.Icon);if(B)return B;const te=f.DefaultIconPath;return{uri:te,fallbackUri:te}}function M(z,B){return z.files.filter(se=>se.assetType===B)[0]?{uri:`${z.assetUri}/${B}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${B}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function j(z,B){const te=z.properties?z.properties.filter(ce=>ce.key===B):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,y.adoptToGalleryExtensionId)(ce)):[]}function U(z){const B=z.properties?z.properties.filter(te=>te.key===c.Engine):[];return B.length>0&&B[0].value||""}function G(z){const B=z.properties?z.properties.filter(te=>te.key===c.PreRelease):[];return B.length>0&&B[0].value==="true"}function K(z){const B=z.properties?z.properties.filter(se=>se.key===c.LocalizedLanguages):[],te=B.length>0&&B[0].value||"";return te?te.split(","):[]}function x(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,f.toTargetPlatform)(z.targetPlatform):"undefined"}function X(z){const B=(0,D.distinct)(z.versions.map(q)),te=!!z.tags?.includes(f.WEB_EXTENSION_TAG),se=B.indexOf("web");return te?se===-1&&B.push("web"):se!==-1&&B.splice(se,1),B}function H(z,B){const te=(0,f.getFallbackTargetPlarforms)(B);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let he=se;const ve=q(ce);if(ve===B)for(;he>0&&z[he-1].version===ce.version;)he--;else if(te.includes(ve))for(;he>0&&z[he-1].version===ce.version&&q(z[he-1])!==B;)he--;he!==se&&(z.splice(se,1),z.splice(he,0,ce))}}return z}e.sortExtensionVersions=H;function Z(z,B,te){const se=z.versions[0],ce={manifest:M(B,s.Manifest),readme:M(B,s.Details),changelog:M(B,s.Changelog),license:M(B,s.License),repository:F(B),download:$(B),icon:k(B),coreTranslations:O(B)};return{identifier:{id:(0,y.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:B.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:_(z.statistics,"install"),rating:_(z.statistics,"averagerating"),ratingCount:_(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:te,assets:ce,properties:{dependencies:j(B,c.Dependency),extensionPack:j(B,c.ExtensionPack),engine:U(B),localizedLanguages:K(B),targetPlatform:q(B),isPreReleaseVersion:G(B)},hasPreReleaseVersion:G(se),hasReleaseVersion:!0,preview:x(z.flags)}}let ee=class{constructor(B,te,se,ce,he,ve,pe,Ee){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=ve,this.productService=pe,this.configurationService=Ee;const Ce=pe.extensionsGallery;this.extensionsGalleryUrl=Ce&&Ce.serviceUrl,this.extensionsControlUrl=Ce&&Ce.controlUrl,this.commonHeadersPromise=V(pe.version,pe,this.environmentService,this.configurationService,this.fileService,B)}api(B=""){return`${this.extensionsGalleryUrl}${B}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(B,te,se){const ce=n.CancellationToken.isCancellationToken(te)?{targetPlatform:a}:te,he=n.CancellationToken.isCancellationToken(te)?te:se,ve=[],pe=[],Ee=[],Ce=[];for(const Re of B)Re.uuid?pe.push(Re.uuid):ve.push(Re.id),Ee.push({...Re,preRelease:!!Re.preRelease}),Re.version&&Ce.push({...Re,version:Re.version});if(!pe.length&&!ve.length)return[];let we=new P().withPage(1,B.length);pe.length&&(we=we.withFilter(o.ExtensionId,...pe)),ve.length&&(we=we.withFilter(o.ExtensionName,...ve));const{extensions:be}=await this.queryGalleryExtensions(we,{targetPlatform:ce.targetPlatform,preRelease:Ee,versions:Ce,compatible:!!ce.compatible},he);return be}async getCompatibleExtension(B,te,se){if((0,f.isNotWebExtensionInWebTargetPlatform)(B.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(B,te,se))return B;const ce=new P().withFlags(i.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,B.identifier.uuid),{extensions:he}=await this.queryGalleryExtensions(ce,{targetPlatform:se,compatible:!0,preRelease:te},n.CancellationToken.None);return he[0]||null}async isExtensionCompatible(B,te,se){if(!(0,f.isTargetPlatformCompatible)(B.properties.targetPlatform,B.allTargetPlatforms,se)||!te&&B.properties.isPreReleaseVersion)return!1;let ce=B.properties.engine;if(!ce){const he=await this.getManifest(B,n.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isValidVersion(B,te,se,ce,he){if(!(0,f.isTargetPlatformCompatible)(q(B),ce,he)||!te&&G(B))return!1;if(se){const ve=await this.getEngine(B);if(!(0,h.isEngineValid)(ve,this.productService.version,this.productService.date))return!1}return!0}async query(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=B.text||"";const ce=(0,A.getOrDefault)(B,we=>we.pageSize,50);let he=new P().withPage(1,ce);se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Re)=>(he=he.withFilter(o.Category,Re||be),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(we,be,Re)=>(he=he.withFilter(o.Tag,Re||be),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(o.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(o.SearchText,se)),he=he.withSortBy(0)):B.ids?he=he.withFilter(o.ExtensionId,...B.ids):B.names?he=he.withFilter(o.ExtensionName,...B.names):he=he.withSortBy(4),typeof B.sortBy=="number"&&(he=he.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(he=he.withSortOrder(B.sortOrder));const ve=async(we,be)=>{const{extensions:Re,total:Fe}=await this.queryGalleryExtensions(we,{targetPlatform:a,compatible:!1,preRelease:!!B.includePreRelease},be);return Re.forEach((Ue,qe)=>Ue.telemetryData={index:(we.pageNumber-1)*we.pageSize+qe,querySource:B.source}),{extensions:Re,total:Fe}},{extensions:pe,total:Ee}=await ve(he,te),Ce=async(we,be)=>{if(be.isCancellationRequested)throw new L.CancellationError;const{extensions:Re}=await ve(he.withPage(we+1),be);return Re};return{firstPage:pe,total:Ee,pageSize:he.pageSize,getPage:Ce}}async queryGalleryExtensions(B,te,se){const ce=B.flags;!!(B.flags&i.IncludeLatestVersionOnly)&&!!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),te.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:he,total:ve}=await this.queryRawGalleryExtensions(B,se);if(!(B.flags&i.IncludeLatestVersionOnly)){const we=[];for(const be of he){const Re=await this.toGalleryExtensionWithCriteria(be,te,!0);Re&&we.push(Re)}return{extensions:we,total:ve}}const Ee=[],Ce=new Map;for(let we=0;we<he.length;we++){const be=he[we],Re={id:(0,y.getGalleryExtensionId)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Fe=(0,b.isBoolean)(te.preRelease)?te.preRelease:!!te.preRelease.find(qe=>(0,y.areSameExtensions)(qe,Re))?.preRelease;let Ue=await this.toGalleryExtensionWithCriteria(be,te,!1);!Ue||Ue.properties.isPreReleaseVersion&&(!Fe||!Ue.hasReleaseVersion)||!Ue.properties.isPreReleaseVersion&&Ue.properties.targetPlatform!==te.targetPlatform&&Ue.hasPreReleaseVersion?Ce.set(be.extensionId,we):Ee.push([we,Ue])}if(Ce.size){const we=new Date().getTime(),be=new P().withFlags(ce&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Ce.size).withFilter(o.ExtensionId,...Ce.keys()),{extensions:Re}=await this.queryGalleryExtensions(be,te,se);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-we,count:Ce.size});for(const Fe of Re){const Ue=Ce.get(Fe.identifier.uuid);Ee.push([Ue,Fe])}}return{extensions:Ee.sort((we,be)=>we[0]-be[0]).map(([,we])=>we),total:ve}}async toGalleryExtensionWithCriteria(B,te,se){const ce={id:(0,y.getGalleryExtensionId)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},he=te.versions?.find(Ce=>(0,y.areSameExtensions)(Ce,ce))?.version,ve=(0,b.isBoolean)(te.preRelease)?te.preRelease:!!te.preRelease.find(Ce=>(0,y.areSameExtensions)(Ce,ce))?.preRelease,pe=X(B),Ee=H(B.versions,te.targetPlatform);if(te.compatible&&se&&(0,f.isNotWebExtensionInWebTargetPlatform)(pe,te.targetPlatform))return null;for(let Ce=0;Ce<Ee.length;Ce++){const we=Ee[Ce];if(!(he&&we.version!==he)){if(await this.isValidVersion(we,ve,te.compatible,pe,te.targetPlatform))return Z(B,we,pe);if(he&&we.version===he)return null}}return he||te.compatible?null:Z(B,B.versions[0],pe)}async queryRawGalleryExtensions(B,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,t(i.Unpublished));const se=await this.commonHeadersPromise,ce=JSON.stringify(B.raw),he={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ce.length)},ve=new Date().getTime();let pe,Ee,Ce=0;try{if(pe=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:ce,headers:he},te),pe.res.statusCode&&pe.res.statusCode>=400&&pe.res.statusCode<500)return{galleryExtensions:[],total:Ce};const we=await(0,w.asJson)(pe);if(we){const be=we.results[0],Re=be.extensions,Fe=be.resultMetadata&&be.resultMetadata.filter(Ue=>Ue.metadataType==="ResultCount")[0];return Ce=Fe&&Fe.metadataItems.filter(Ue=>Ue.name==="TotalCount")[0].count||0,{galleryExtensions:Re,total:Ce}}return{galleryExtensions:[],total:Ce}}catch(we){throw Ee=we,we}finally{this.telemetryService.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(ce.length),duration:new Date().getTime()-ve,success:!!pe&&(0,w.isSuccess)(pe),responseBodySize:pe?.res.headers["Content-Length"],statusCode:pe?String(pe.res.statusCode):void 0,errorCode:Ee?(0,L.isCancellationError)(Ee)?"canceled":(0,L.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Ce)})}}async reportStatistic(B,te,se,ce){if(!this.isEnabled())return;const he=T.isWeb?this.api(`/itemName/${B}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${B}/extensions/${te}/${se}/stats?statType=${ce}`),ve=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:ve};try{await this.requestService.request({type:"POST",url:he,headers:Ee},n.CancellationToken.None)}catch{}}async download(B,te,se){this.logService.trace("ExtensionGalleryService#download",B.identifier.id);const ce=(0,y.getGalleryExtensionTelemetryData)(B),he=new Date().getTime(),ve=we=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:we}),pe=se===2?"install":se===3?"update":"",Ee=pe?{uri:`${B.assets.download.uri}${E.URI.parse(B.assets.download.uri).query?"&":"?"}${pe}=true`,fallbackUri:`${B.assets.download.fallbackUri}${E.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${pe}=true`}:B.assets.download,Ce=await this.getAsset(Ee);await this.fileService.writeFile(te,Ce.stream),ve(new Date().getTime()-he)}async getReadme(B,te){if(B.assets.readme){const se=await this.getAsset(B.assets.readme,{},te);return await(0,w.asText)(se)||""}return""}async getManifest(B,te){if(B.assets.manifest){const se=await this.getAsset(B.assets.manifest,{},te),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(B,te){const se=M(B,s.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(B,te){const se=B.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(B,te){if(B.assets.changelog){const se=await this.getAsset(B.assets.changelog,{},te);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(B,te,se){let ce=new P().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?ce=ce.withFilter(o.ExtensionId,B.identifier.uuid):ce=ce.withFilter(o.ExtensionName,B.identifier.id);const{galleryExtensions:he}=await this.queryRawGalleryExtensions(ce,n.CancellationToken.None);if(!he.length)return[];const ve=X(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(ve,se))return[];const pe=[];for(const Ee of he[0].versions)try{pe[pe.length-1]?.version!==Ee.version&&await this.isValidVersion(Ee,te,!0,ve,se)&&pe.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:G(Ee)})}catch{}return pe}async getAsset(B,te={},se=n.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},ve={...ce,...te.headers||{}};te={...te,...he,headers:ve};const pe=B.uri,Ee=B.fallbackUri,Ce={...te,url:pe};try{const we=await this.requestService.request(Ce,se);if(we.res.statusCode===200)return we;const be=await(0,w.asText)(we);throw new Error(`Expected 200, got back ${we.res.statusCode} instead.

${be}`)}catch(we){if((0,L.isCancellationError)(we))throw we;const be=(0,L.getErrorMessage)(we);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:pe,message:be});const Re={...te,url:Ee};return this.requestService.request(Re,se)}}async getEngine(B){let te=U(B);if(!te){const se=await this.getManifestFromRawExtensionVersion(B,n.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const B=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,w.asJson)(B),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const ve=te.unsupported[he];(0,b.isBoolean)(ve)||(ce[he.toLowerCase()]=ve.preReleaseExtension)}if(te.migrateToPreRelease)for(const[he,ve]of Object.entries(te.migrateToPreRelease))(!ve.engine||(0,h.isEngineValid)(ve.engine,this.productService.version,this.productService.date))&&(ce[he.toLowerCase()]=ve)}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};ee=de([J(1,w.IRequestService),J(2,d.ILogService),J(3,C.IEnvironmentService),J(4,l.ITelemetryService),J(5,v.IFileService),J(6,g.IProductService),J(7,I.IConfigurationService)],ee);let W=class extends ee{constructor(B,te,se,ce,he,ve,pe,Ee){super(B,te,se,ce,he,ve,pe,Ee)}};W=de([J(0,S.IStorageService),J(1,w.IRequestService),J(2,d.ILogService),J(3,C.IEnvironmentService),J(4,l.ITelemetryService),J(5,v.IFileService),J(6,g.IProductService),J(7,I.IConfigurationService)],W),e.ExtensionGalleryService=W;let N=class extends ee{constructor(B,te,se,ce,he,ve,pe){super(void 0,B,te,se,ce,he,ve,pe)}};N=de([J(0,w.IRequestService),J(1,d.ILogService),J(2,C.IEnvironmentService),J(3,l.ITelemetryService),J(4,v.IFileService),J(5,g.IProductService),J(6,I.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N;async function V(z,B,te,se,ce,he){const ve={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${B.nameShort})`},pe=await(0,m.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(B,te)&&(0,r.getTelemetryLevel)(se)===3&&(ve["X-Market-User-Id"]=pe),ve}e.resolveMarketplaceHeaders=V}),define(ne[94],ie([0,1,2,15,8,44]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let T=class extends D.Disposable{constructor(b,E,I=""){super();this.prefix=I;const C=b.getLogger(E.telemetryLogResource);C?this.logger=this._register(C):(this.logger=this._register(b.createLogger(E.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,E){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,A.validateTelemetryData)(E))}};T=de([J(0,L.ILoggerService),J(1,n.IEnvironmentService)],T),e.TelemetryLogAppender=T}),define(ne[95],ie([0,1,2,28,4,26,141,20,42,87,38,21,44]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const m=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!m})})}setExperimentProperty(d,g){this._experimentProperties[d]=g}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,w=d["common.machineId"],m=d["common.firstSessionDate"],S=d["common.msftInternal"];return{sessionId:g,machineId:w,firstSessionDate:m,msftInternal:S}}dispose(){this._disposables.dispose()}_log(d,g,w,m){return this.telemetryLevel<g?Promise.resolve(void 0):this._commonProperties.then(S=>{w=(0,n.mixin)(w,S),w=(0,n.mixin)(w,this._experimentProperties),w=(0,n.cloneAndChange)(w,l=>{if(typeof l=="string")return this._cleanupInfo(l,m)}),this._appenders.forEach(l=>l.log(d,w))},S=>{console.error(S)})}publicLog(d,g,w){return this._log(d,3,g,w)}publicLog2(d,g,w){return this.publicLog(d,g,w)}publicLogError(d,g){return this.sendErrorTelemetry?this._log(d,2,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_anonymizeFilePaths(d){let g=d;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(d);if(!a)break;w.push([a.index,r.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,S=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const r=S.exec(d);if(!r)break;!m.test(r[0])&&w.every(([a,i])=>r.index<a||r.index>=i)&&(g+=d.substring(l,r.index)+"<REDACTED: user-file-path>",l=S.lastIndex)}return l<d.length&&(g+=d.substr(l)),g}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const g=d.toLowerCase(),w=/@[a-zA-Z0-9-.]+/,m=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,S=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return m.test(g)?"<REDACTED: secret>":w.test(g)?"<REDACTED: email>":S.test(g)?"<REDACTED: token>":d}_cleanupInfo(d,g){let w=d;g&&(w=this._anonymizeFilePaths(w));for(let m of this._cleanupPatterns)w=w.replace(m,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([J(1,R.IConfigurationService)],y),e.TelemetryService=y;function h(){const v=(0,T.localize)(0,null,E.default.nameLong),d=E.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=L.isWeb?"":(0,T.localize)(3,null),w=(0,T.localize)(4,null),m=(0,T.localize)(5,null),S=(0,T.localize)(6,null),l=(0,T.localize)(7,null),r=`
|       | ${w} | ${m} | ${S} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,T.localize)(8,null);return`
${v} ${d} ${g}

&nbsp;

${l}
${r}

&nbsp;

${a}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,T.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,T.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[210],ie([0,1,9,28,44]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(R,b){const E=await new Promise((C,f)=>{Y(["applicationinsights"],C,f)});let I;return E.defaultClient?(I=new E.TelemetryClient(R),I.channel.setUseDiskRetryCaching(!0)):(E.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=E.defaultClient),R.indexOf("AIF-")===0&&(I.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class T{constructor(b,E,I,C,f){this._eventPrefix=b,this._defaultData=E,this.testCollector=C,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(E=>{b(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(b,E){!this._aiClient||(E=(0,n.mixin)(E,this._defaultData),E=(0,L.validateTelemetryData)(E),this.testCollector&&(E.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+b,properties:E.properties,measurements:E.measurements})))}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(E=>{E.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=T}),define(ne[211],ie([0,1,18,58,20,15,8,21,93,94,95]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let C=class{constructor(y,h,v,d){this.configurationService=y,this.telemetryService=h,this.loggerService=v,this.environmentService=d,this.customTelemetryServices=new Map}async getCustomTelemetryService(y){if(!this.customTelemetryServices.has(y.id)){const{machineId:h,sessionId:v}=await this.telemetryService.getTelemetryInfo(),d=Object.create(null);d["common.vscodemachineid"]=h,d["common.vscodesessionid"]=v;const g=[y.id,JSON.stringify(d),y.aiKey],m=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),S=[new b.TelemetryAppenderClient(m),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${y.id}] `)];this.customTelemetryServices.set(y.id,new I.TelemetryService({appenders:S,sendErrorTelemetry:y.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(y.id)}async publicLog(y,h,v){await(await this.getCustomTelemetryService(y)).publicLog(h,v)}async publicLogError(y,h,v){await(await this.getCustomTelemetryService(y)).publicLogError(h,v)}};C=de([J(0,L.IConfigurationService),J(1,R.ITelemetryService),J(2,T.ILoggerService),J(3,A.IEnvironmentService)],C),e.CustomEndpointTelemetryService=C}),define(ne[212],ie([0,1,5,23,3,2,8]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends A.Disposable{constructor(E,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new L.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=E===void 0?15e3:E}createRequest(E){return new Promise((I,C)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,I),this._onCreateRequest.fire({requestId:f,...E});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>C(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,A.toDisposable)(()=>y.cancel())])})}acceptReply(E,I){const C=this._pendingRequests.get(E);C?(this._pendingRequests.delete(E),(0,A.dispose)(this._pendingRequestDisposables.get(E)||[]),this._pendingRequestDisposables.delete(E),C(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${E}`)}};R=de([J(1,T.ILogService)],R),e.RequestStore=R}),define(ne[96],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.EnableShellIntegration="terminal.integrated.enableShellIntegration"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var T;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(T=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var b;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var E;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var C;(function(d){d.TerminalView="view",d.Editor="editor"})(C=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.CwdDetection=0]="CwdDetection",d[d.NaiveCwdDetection=1]="NaiveCwdDetection",d[d.CommandDetection=2]="CommandDetection",d[d.PartialCommandDetection=3]="PartialCommandDetection"})(f=e.TerminalCapability||(e.TerminalCapability={}));var y;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var v;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(v=e.ProfileSource||(e.ProfileSource={}))}),define(ne[213],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(ne[214],ie([0,1,33,28,10,4,32,14,22]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function E(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let f=0;return C&&C.length===4&&(f=parseInt(C[3])),f}e.getWindowsBuildNumber=E;async function I(C,f,y,h=T.env,v=b.Promises.exists){if(L.isAbsolute(C))return await v(C)?C:void 0;if(f===void 0&&(f=T.cwd()),L.dirname(C)!=="."){const m=L.join(f,C);return await v(m)?m:void 0}const g=(0,n.getCaseInsensitive)(h,"PATH");if(y===void 0&&(0,R.isString)(g)&&(y=g.split(L.delimiter)),y===void 0||y.length===0){const m=L.join(f,C);return await v(m)?m:void 0}for(let m of y){let S;if(L.isAbsolute(m)?S=L.join(m,C):S=L.join(f,m,C),await v(S))return S;if(A.isWindows){let l=S+".com";if(await v(l)||(l=S+".exe",await v(l)))return l}}const w=L.join(f,C);return await v(w)?w:void 0}e.findExecutable=I}),define(ne[215],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var D;(function(n){n.DARK="dark",n.LIGHT="light",n.HIGH_CONTRAST="hc"})(D=e.ColorScheme||(e.ColorScheme={}))}),define(ne[97],ie([0,1,48,3,2,6,38,215]),function(Y,e,D,n,L,A,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var b;(function(d){function g(w){return w&&typeof w=="object"&&typeof w.id=="string"}d.isThemeColor=g})(b=e.ThemeColor||(e.ThemeColor={}));function E(d){return{id:d}}e.themeColorFromId=E;var I;(function(d){function g(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||b.isThemeColor(t.color))}d.isThemeIcon=g;const w=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function m(t){const o=w.exec(t);if(!o)return;let[,s]=o;return{id:s}}d.fromString=m;function S(t){return{id:t}}d.fromId=S;function l(t,o){let s=t.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),o&&(s=`${s}~${o}`),{id:s}}d.modify=l;function r(t){const o=t.id.lastIndexOf("~");if(o!==-1)return t.id.substring(o+1)}d.getModifier=r;function a(t,o){return t.id===o.id&&t.color?.id===o.color?.id}d.isEqual=a;function i(t,o){return{id:t.id,color:o?E(o):void 0}}d.asThemeIcon=i,d.asClassNameArray=D.CSSIcon.asClassNameArray,d.asClassName=D.CSSIcon.asClassName,d.asCSSSelector=D.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function C(d){switch(d){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(g){return this.themingParticipants.push(g),this.onThemingParticipantAddedEmitter.fire(g),(0,L.toDisposable)(()=>{const w=this.themingParticipants.indexOf(g);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new f;T.Registry.add(e.Extensions.ThemingContribution,y);function h(d){return y.onColorThemeChange(d)}e.registerThemingParticipant=h;class v extends L.Disposable{constructor(g){super();this.themeService=g,this.theme=g.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(g){this.theme=g,this.updateStyles()}updateStyles(){}getColor(g,w){let m=this.theme.getColor(g);return m&&w&&(m=w(m,this.theme)),m?m.toString():null}}e.Themable=v}),define(ne[216],ie([0,1,48,7,97]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(C,f){const y=C.map(h=>({name:h.profileName,description:T(h)}));return f&&y.push(...f.map(h=>({name:h.title,description:R(h)}))),{values:y.map(h=>h.name),markdownDescriptions:y.map(h=>h.description)}}e.createProfileSchemaEnums=A;function T(C){let f=`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.profileName}
- path: ${C.path}`;return C.args&&(typeof C.args=="string"?f+=`
- args: "${C.args}"`:f+=`
- args: [${C.args.length===0?"":`'${C.args.join("','")}'`}]`),C.overrideName!==void 0&&(f+=`
- overrideName: ${C.overrideName}`),C.color&&(f+=`
- color: ${C.color}`),C.env&&(f+=`
- env: ${JSON.stringify(C.env)}`),f}function R(C){return`$(${L.ThemeIcon.isThemeIcon(C.icon)?C.icon.id:C.icon?C.icon:D.Codicon.terminal.id}) ${C.title}
- extensionIdenfifier: ${C.extensionIdentifier}`}function b(C,f){if(!C&&!f)return!0;if(typeof C=="string"&&typeof f=="string")return C===f;if(Array.isArray(C)&&Array.isArray(f)){if(C.length!==f.length)return!1;for(let y=0;y<C.length;y++)if(C[y]!==f[y])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function E(C,f){if(!C&&!f)return!0;if(!C||!f)return!1;if(L.ThemeIcon.isThemeIcon(C)&&L.ThemeIcon.isThemeIcon(f))return C.id===f.id&&C.color===f.color;if(typeof C=="object"&&C&&"light"in C&&"dark"in C&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const y=C,h=f;if((n.URI.isUri(y.light)||I(y.light))&&(n.URI.isUri(y.dark)||I(y.dark))&&(n.URI.isUri(h.light)||I(h.light))&&(n.URI.isUri(h.dark)||I(h.dark)))return y.light.path===h.light.path&&y.dark.path===h.dark.path}if(n.URI.isUri(C)&&n.URI.isUri(f)||I(C)||I(f)){const y=C,h=f;return y.path===h.path&&y.scheme===h.scheme}return!1}e.terminalIconsEqual=E;function I(C){return C?typeof C.path=="string"&&typeof C.scheme=="string":!1}e.isUriComponents=I}),define(ne[217],ie([0,1,48,142,42,38,216]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),type:"string",enum:Array.from(D.Codicon.getAll(),S=>S.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),S=>`$(${S.id})`)},color:{description:(0,n.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},E={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),C=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),v=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),d={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,n.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,n.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},E],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:C},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:C},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function g(){A.Registry.as(L.Extensions.Configuration).registerConfiguration(d),m()}e.registerTerminalPlatformConfiguration=g;let w;function m(S,l){const r=A.Registry.as(L.Extensions.Configuration);let a;S&&(a=(0,T.createProfileSchemaEnums)(S?.profiles,l));const i=w;w={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?a?.values:void 0,markdownEnumDescriptions:S?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?a?.values:void 0,markdownEnumDescriptions:S?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?a?.values:void 0,markdownEnumDescriptions:S?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=m}),define(ne[218],ie([0,1,45,48,10,4,22,72,214,97]),function(Y,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,C=!0;function f(a,i,t,o,s=process.env,c,u,p,P){return c=c||{existsFile:T.SymlinkSupport.existsFile,readFile:T.Promises.readFile},A.isWindows?y(t,c,s,u,o.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),P,p):S(c,u,t,a&&typeof a=="object"?{...a}:o.getValue(A.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(A.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,p,s)}e.detectAvailableProfiles=f;async function y(a,i,t,o,s,c,u,p,P){const _=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${_?"Sysnative":"System32"}`;let F=!1;(0,b.getWindowsBuildNumber)()>=16299&&(F=!0),await d(p);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),l(c,$);const k=await h($.entries(),u,i,t,o,P);if(a||!a&&s)try{const M=await w(`${O}\\${F?"wsl":"bash"}.exe`,u);for(const j of M)(!c||!(j.profileName in c))&&k.push(j)}catch{C&&(o?.info("WSL is not installed, so could not detect WSL profiles"),C=!1)}return k}async function h(a,i,t,o=process.env,s,c){const u=[];for(const[p,P]of a){if(P===null)continue;let _,O,F;if("source"in P){const M=I?.get(P.source);if(!M)continue;_=M.paths,O=P.args||M.args,P.icon?F=v(P.icon):M.icon&&(F=M.icon)}else _=Array.isArray(P.path)?P.path:[P.path],O=A.isWindows||Array.isArray(P.args)?P.args:void 0,F=v(P.icon);const $=await c?.(_)||_.slice(),k=await r(p,i,$,t,o,O,P.env,P.overrideName,P.isAutoDetected,s);k?(k.isAutoDetected=P.isAutoDetected,k.icon=F,k.color=P.color,u.push(k)):s?.trace("profile not validated",p,_)}return u}function v(a){return typeof a=="string"?{id:a}:a}async function d(a){I&&!a||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:a||await g(),icon:E.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function g(){const a=[];for await(const i of(0,R.enumeratePowerShellInstallations)())a.push(i.exePath);return a}async function w(a,i){const t=[],o=await new Promise((u,p)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,_)=>{if(P)return p("Problem occurred when getting wsl distros");u(_)})});if(!o)return[];const s=new RegExp(/[\r?\n]/),c=o.split(s).filter(u=>u.trim().length>0&&u!=="");for(const u of c){if(u===""||u.startsWith("docker-desktop"))continue;const p=`${u} (WSL)`,P={profileName:p,path:a,args:["-d",`${u}`],isDefault:p===i,icon:m(u),isAutoDetected:!1};t.push(P)}return t}function m(a){return a.includes("Ubuntu")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):a.includes("Debian")?E.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):E.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function S(a,i,t,o,s,c,u,p){const P=new Map;if(t){const _=(await a.readFile("/etc/shells")).toString(),O=c||_.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),F=new Map;for(const $ of O){let k=(0,L.basename)($),M=F.get(k)||0;M++,M>1&&(k=`${k} (${M})`),F.set(k,M),P.set(k,{path:$,isAutoDetected:!0})}}return l(o,P),await h(P.entries(),s,a,p,i,u)}function l(a,i){if(!!a)for(const[t,o]of Object.entries(a))o===null||!("path"in o)&&!("source"in o)?i.delete(t):(o.icon=o.icon||i.get(t)?.icon,i.set(t,o))}async function r(a,i,t,o,s,c,u,p,P,_){if(t.length===0)return Promise.resolve(void 0);const O=t.shift();if(O==="")return r(a,i,t,o,s,c,u,p,P);const F={profileName:a,path:O,args:c,env:u,overrideName:p,isAutoDetected:P,isDefault:a===i};if((0,L.basename)(O)===O){const k=s.PATH?s.PATH.split(L.delimiter):void 0,M=await(0,b.findExecutable)(O,void 0,k,void 0,o.existsFile);return M?(F.path=M,F.isFromPath=!0,F):r(a,i,t,o,s,c)}return await o.existsFile((0,L.normalize)(O))?F:r(a,i,t,o,s,c,u,p,P)}}),define(ne[219],ie([0,1,3,2,18,4,36,58,20,15,77,162,8,86,21,212,96,217,218]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var m;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(m||(m={}));let S=0,l=class extends n.Disposable{constructor(a,i,t,o,s){super();this._reconnectConstants=a,this._configurationService=i,this._environmentService=t,this._logService=o,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,g.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new v.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(A.isWindows)return process.env;try{return await(0,C.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:S,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},i=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);i&&(i.break&&i.port?a.debugBrk=i.port:!i.break&&i.port&&(a.debug=i.port));const t=new R.Client(L.FileAccess.asFileUri("bootstrap-fork",Y).fsPath,a);this._onPtyHostStart.fire(),T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(u=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(u.code),this._isDisposed||(this._restartCount<=m.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))}));const s=t.getChannel(d.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const c=T.ProxyChannel.toService(t.getChannel(d.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(u=>this._onProcessData.fire(u))),this._register(c.onProcessReady(u=>this._onProcessReady.fire(u))),this._register(c.onProcessExit(u=>this._onProcessExit.fire(u))),this._register(c.onDidChangeProperty(u=>this._onDidChangeProperty.fire(u))),this._register(c.onProcessReplay(u=>this._onProcessReplay.fire(u))),this._register(c.onProcessOrphanQuestion(u=>this._onProcessOrphanQuestion.fire(u))),this._register(c.onDidRequestDetach(u=>this._onDidRequestDetach.fire(u))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,i,t,o,s,c,u,p,P,_,O){const F=setTimeout(()=>this._handleUnresponsiveCreateProcess(),d.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,i,t,o,s,c,u,p,P,_,O);return clearTimeout(F),S=Math.max(S,$),$}updateTitle(a,i,t){return this._proxy.updateTitle(a,i,t)}updateIcon(a,i,t){return this._proxy.updateIcon(a,i,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,i){return this._proxy.shutdown(a,i)}input(a,i){return this._proxy.input(a,i)}processBinary(a,i){return this._proxy.processBinary(a,i)}resize(a,i,t){return this._proxy.resize(a,i,t)}acknowledgeDataEvent(a,i){return this._proxy.acknowledgeDataEvent(a,i)}setUnicodeVersion(a,i){return this._proxy.setUnicodeVersion(a,i)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,i){return this._proxy.installAutoReply(a,i)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,i,t,o=!1){const s=await this._shellEnv;return(0,w.detectAvailableProfiles)(i,t,o,this._configurationService,s,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,i){return this._proxy.requestDetachInstance(a,i)}async acceptDetachInstanceReply(a,i){return this._proxy.acceptDetachInstanceReply(a,i)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,i){return this._proxy.reviveTerminalProcesses(a,i)}async refreshProperty(a,i){return this._proxy.refreshProperty(a,i)}async updateProperty(a,i,t){return this._proxy.updateProperty(a,i,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,i){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:i})}async acceptPtyHostResolvedVariables(a,i){this._resolveVariablesRequestStore.acceptReply(a,i)}};l=de([J(1,b.IConfigurationService),J(2,E.IEnvironmentService),J(3,f.ILogService),J(4,h.ITelemetryService)],l),e.PtyHostService=l}),define(ne[34],ie([0,1,6]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(ne[220],ie([0,1,3,2,7,15,31,13,8,34]),function(Y,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends n.Disposable{constructor(f,y,h,v,d){super();this.extensionsManagementService=f,this.logService=v,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(m=>m.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const g=L.URI.file(h.extensionsPath);this._register(y.watch(g)),this._register(D.Event.filter(y.onDidFilesChange,w=>w.rawChanges.some(m=>this.doesChangeAffects(m,g)))(()=>this.onDidChange()))}doesChangeAffects(f,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),y)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const y of f)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(y=>!(0,T.areSameExtensions)(y,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,T.areSameExtensions)(y,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),y=f.filter(v=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,T.areSameExtensions)(d,v.identifier))?!1:v.installedTimestamp&&v.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",v.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",v.identifier.id),!1)),h=this.installedExtensions.filter(v=>this.installingExtensions.some(d=>(0,T.areSameExtensions)(d,v))?!1:f.every(d=>!(0,T.areSameExtensions)(d.identifier,v))?(this.logService.info("Detected extension removed from another source",v.id),!0):!1);this.installedExtensions=f.map(v=>v.identifier),(y.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:h})}}};I=de([J(1,R.IFileService),J(2,A.INativeEnvironmentService),J(3,b.ILogService),J(4,E.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(ne[221],ie([0,1,34,79,13,19,104,3,2]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class E{constructor(f){this.uri=f,this.time=E._clock++}touch(){return this.time=E._clock++,this}}E._clock=0;let I=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const y=new Map,h=v=>{let d=y.get(v.scheme);return d===void 0&&(d=f.hasProvider(v)&&!this._fileService.hasCapability(v,1024),y.set(v.scheme,d)),d};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(v=>{y.delete(v.scheme)})),this.extUri=new A.ExtUri(h),this._canonicalUris=new T.SkipList((v,d)=>this.extUri.compare(v,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,A.normalizePath)(f));let y=this._canonicalUris.get(f);return y?y.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new E(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,v)=>h[1].touch<v[1].touch?1:h[1].touch>v[1].touch?-1:0);E._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let h=0;h<y;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};I=de([J(0,L.IFileService)],I),e.UriIdentityService=I,(0,n.registerSingleton)(D.IUriIdentityService,I,!0)}),define(ne[222],ie([0,1,3,2,40,39,17]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends n.Disposable{constructor(E,I,C,f,y){super();this.fileSystemScheme=E,this.fileSystemProvider=I,this.userDataScheme=C,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(f.onDidFilesChange(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,I){this.watchResources.set(E,E);const C=this.fileSystemProvider.watch(this.toFileSystemResource(E),I);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),C.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,I,C){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(I),C)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,I,C){const f=(0,L.newWriteableStream)(y=>T.VSBuffer.concat(y.map(h=>T.VSBuffer.wrap(h))).buffer);return(async()=>{try{const y=await this.readFile(E);f.end(y)}catch(y){f.error(y),f.end()}})(),f}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,I,C){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),I,C)}delete(E,I){return this.fileSystemProvider.delete(this.toFileSystemResource(E),I)}handleFileChanges(E){const I=[];for(const C of E.rawChanges){if(C.resource.scheme!==this.fileSystemScheme)continue;const f=this.toUserDataResource(C.resource);this.watchResources.findSubstr(f)&&I.push({resource:f,type:C.type})}I.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(I))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[53],ie([0,1,69]),function(Y,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(T,R,b,E){const I=(0,D.setProperty)(T,R,b,E)[0];return I&&(T=T.substring(0,I.offset)+I.content+T.substring(I.offset+I.length)),T}e.edit=n;function L(T,R,b){let E=b;for(;E>=0;){if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1)return E+1;if(E--,R.length===2&&E>=0&&T.charAt(E)===R.charAt(0))return E+2}return 0}e.getLineStartOffset=L;function A(T,R,b){let E=b;for(;E>=0;)if(T.charAt(E)===R.charAt(R.length-1)&&R.length===1||(E++,R.length===2&&E>=0&&T.charAt(E)===R.charAt(1)))return E;return T.length-1}e.getLineEndOffset=A}),define(ne[223],ie([0,1,28,61,14]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(f,y,h,v,d){const g=[],w=[],m=[];if(!y){const O=f.filter(({identifier:F})=>d.every($=>$.toLowerCase()!==F.id.toLowerCase()));return{local:{added:g,removed:w,updated:m},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}f=f.map(I),y=y.map(I),h=h?h.map(I):null;const S=new Map,l=O=>{O.uuid&&S.set(O.id.toLowerCase(),O.uuid)};f.forEach(({identifier:O})=>l(O)),y.forEach(({identifier:O})=>l(O)),h&&h.forEach(({identifier:O})=>l(O));const r=O=>{const F=O.identifier.uuid||S.get(O.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${O.identifier.id.toLowerCase()}`},a=(O,F)=>(O.set(r(F),F),O),i=f.reduce(a,new Map),t=y.reduce(a,new Map),o=y.reduce((O,F)=>{const $=r(F);F=(0,D.deepClone)(F);const k=i.get($);return k&&(k.installed&&(F.installed=!0),F.version||(F.version=k.version)),a(O,F)},new Map),s=h?h.reduce(a,new Map):null,c=v.reduce(a,new Map),u=d.reduce((O,F)=>{const $=S.get(F.toLowerCase());return O.add($?`uuid:${$}`:`id:${F.toLowerCase()}`)},new Set),p=T(i,t,u);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const O=T(s,i,u),F=T(s,t,u),$=(k,M)=>{const j=i.get(k);if(j){const U=t.get(k),G=M?U:j;return{...G,version:(U.version&&n.gt(U.version,j.version),j.version),state:R(j,U,s?.get(k)),preRelease:(0,L.isUndefined)(G.preRelease)?j.preRelease:G.preRelease}}};for(const k of F.removed.values()){const M=i.get(k);M&&w.push(M.identifier)}for(const k of F.added.values())if(O.added.has(k)){if(p.updated.has(k)){const M=$(k,!0);M&&(m.push(C(M,k)),o.set(k,M))}}else{const M=t.get(k);M.installed&&g.push(C(M,k))}for(const k of F.updated.values()){const M=$(k,!0);M&&(m.push(C(M,k)),o.set(k,M))}for(const k of O.added.values())F.added.has(k)||o.set(k,i.get(k));for(const k of O.updated.values())if(!F.removed.has(k)&&!F.updated.has(k)){const M=$(k,!1);M&&(o.get(k)?.installed&&(M.installed=!0),o.set(k,M))}for(const k of O.removed.values())!c.has(k)&&!F.updated.has(k)&&s?.get(k)?.installed&&o.delete(k)}const P=[],_=T(t,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&o.forEach((O,F)=>P.push(C(O,F))),{local:{added:g,removed:w,updated:m},remote:P.length?{added:[..._.added].map(O=>o.get(O)),updated:[..._.updated].map(O=>o.get(O)),removed:[..._.removed].map(O=>t.get(O)),all:P}:null}}e.merge=A;function T(f,y,h,{checkInstalledProperty:v,checkVersionProperty:d}={checkInstalledProperty:!1,checkVersionProperty:!1}){const g=f?[...f.keys()].filter(r=>!h.has(r)):[],w=[...y.keys()].filter(r=>!h.has(r)),m=w.filter(r=>g.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),S=g.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=new Set;for(const r of g){if(S.has(r))continue;const a=f.get(r),i=y.get(r);(!i||a.disabled!==i.disabled||a.preRelease!==i.preRelease||!E(a.state,i.state)||d&&a.version!==i.version||v&&a.installed!==i.installed)&&l.add(r)}return{added:m,removed:S,updated:l}}function R(f,y,h){const v=f.state,d=y.state,g=h?.state;if(!y.version||v&&n.gt(f.version,y.version))return v;if(d&&n.gt(y.version,f.version)||!v)return d;if(!d)return v;const w=(0,D.deepClone)(v),m=g?b(g,d):{added:Object.keys(d).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set},S=g?b(g,v):{added:Object.keys(v).reduce((l,r)=>(l.add(r),l),new Set),removed:new Set,updated:new Set};for(const l of[...m.added.values(),...m.updated.values()])w[l]=d[l];for(const l of m.removed.values())S.updated.has(l)||delete w[l];return w}function b(f,y){const h=Object.keys(f),v=Object.keys(y),d=v.filter(m=>h.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),g=h.filter(m=>v.indexOf(m)===-1).reduce((m,S)=>(m.add(S),m),new Set),w=new Set;for(const m of h){if(g.has(m))continue;const S=f[m],l=y[m];(0,D.equals)(S,l)||w.add(m)}return{added:d,removed:g,updated:w}}function E(f={},y={}){const{added:h,removed:v,updated:d}=b(f,y);return h.size===0&&v.size===0&&d.size===0}function I(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function C(f,y){const h={identifier:{id:f.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(h.version=f.version),f.disabled&&(h.disabled=!0),f.installed&&(h.installed=!0),f.state&&(h.state=f.state),h}}),define(ne[98],ie([0,1,16,20,6]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,L.createDecorator)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==R&&I!==`-${R}`),b&&E.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}updateSynchronizedExtensions(R,b){let E=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return E=E.filter(I=>I!==R&&I!==`-${R}`),b&&E.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",E.length?E:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),E=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),I=[],C=[];if(Array.isArray(E))for(const f of E)f.startsWith("-")?C.push(f.substring(1)):I.push(f);return(0,D.distinct)([...b,...I].filter(f=>C.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};A=de([J(0,n.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(ne[224],ie([0,1,16,35,28,158,53]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(S){return(0,n.parse)(S)||[]}e.parseKeybindings=R;async function b(S,l,r,a,i){const t=R(S),o=R(l),s=r?R(r):null,c=[...t,...o,...s||[]].map(U=>U.key),u=await i.resolveUserBindings(c);let p=I(t,o,s,u);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const P=f(t),_=f(o),O=s?f(s):null,F=h(P,_,u),$=O?h(O,P,u):{added:[...P.keys()].reduce((U,G)=>(U.add(G),U),new Set),removed:new Set,updated:new Set},k=O?h(O,_,u):{added:[..._.keys()].reduce((U,G)=>(U.add(G),U),new Set),removed:new Set,updated:new Set},M=E(F,$,k);let j=S;for(const U of M.removed.values())M.conflicts.has(U)||(j=w(j,U,a));for(const U of M.added.values()){if(M.conflicts.has(U))continue;const G=_.get(U);if(G.some(K=>K.command!==`-${U}`&&p.conflicts.has(u[K.key]))){M.conflicts.add(U);continue}j=g(j,G,a)}for(const U of M.updated.values()){if(M.conflicts.has(U))continue;const G=_.get(U);if(G.some(K=>K.command!==`-${U}`&&p.conflicts.has(u[K.key]))){M.conflicts.add(U);continue}j=m(j,U,G,a)}return{mergeContent:j,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=b;function E(S,l,r){const a=new Set,i=new Set,t=new Set,o=new Set;for(const s of l.removed.values())r.updated.has(s)&&o.add(s);for(const s of r.removed.values())o.has(s)||(l.updated.has(s)?o.add(s):i.add(s));for(const s of l.added.values())o.has(s)||r.added.has(s)&&S.updated.has(s)&&o.add(s);for(const s of r.added.values())o.has(s)||(l.added.has(s)?S.updated.has(s)&&o.add(s):a.add(s));for(const s of l.updated.values())o.has(s)||r.updated.has(s)&&S.updated.has(s)&&o.add(s);for(const s of r.updated.values())o.has(s)||(l.updated.has(s)?S.updated.has(s)&&o.add(s):t.add(s));return{added:a,removed:i,updated:t,conflicts:o}}function I(S,l,r,a){const i=new Set,t=C(S,a),o=C(l,a),s=r?C(r,a):null,c=y(t,o);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const u=s?y(s,t):{added:[...t.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const p=s?y(s,o):{added:[...o.keys()].reduce(($,k)=>($.add(k),$),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:P,removed:_,updated:O,conflicts:F}=E(c,u,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:_,updated:O,conflicts:F}}function C(S,l){const r=new Map;for(const a of S){const i=l[a.key];let t=r.get(i);t||(t=[],r.set(i,t)),t.push(a)}return r}function f(S){const l=new Map;for(const r of S){const a=r.command[0]==="-"?r.command.substring(1):r.command;let i=l.get(a);i||(i=[],l.set(a,i)),i.push(r)}return l}function y(S,l){const r=[...S.keys()],a=[...l.keys()],i=a.filter(s=>r.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),t=r.filter(s=>a.indexOf(s)===-1).reduce((s,c)=>(s.add(c),s),new Set),o=new Set;for(const s of r){if(t.has(s))continue;const c=S.get(s).map(p=>({...p,key:s})),u=l.get(s).map(p=>({...p,key:s}));(0,D.equals)(c,u,(p,P)=>d(p,P))||o.add(s)}return{added:i,removed:t,updated:o}}function h(S,l,r){const a=[...S.keys()],i=[...l.keys()],t=i.filter(c=>a.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),o=a.filter(c=>i.indexOf(c)===-1).reduce((c,u)=>(c.add(u),c),new Set),s=new Set;for(const c of a){if(o.has(c))continue;const u=S.get(c).map(P=>({...P,key:r[P.key]})),p=l.get(c).map(P=>({...P,key:r[P.key]}));v(u,p)||s.add(c)}return{added:t,removed:o,updated:s}}function v(S,l){return!(!(0,D.equals)(S.filter(({command:r})=>r[0]!=="-"),l.filter(({command:r})=>r[0]!=="-"),(r,a)=>d(r,a))||!(0,D.equals)(S.filter(({command:r})=>r[0]==="-"),l.filter(({command:r})=>r[0]==="-"),(r,a)=>d(r,a)))}function d(S,l){if(S.command!==l.command||S.key!==l.key)return!1;const r=A.ContextKeyExpr.deserialize(S.when),a=A.ContextKeyExpr.deserialize(l.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!L.equals(S.args,l.args))}function g(S,l,r){for(const a of l)S=T.edit(S,[-1],a,r);return S}function w(S,l,r){const a=R(S);for(let i=a.length-1;i>=0;i--)(a[i].command===l||a[i].command===`-${l}`)&&(S=T.edit(S,[i],void 0,r));return S}function m(S,l,r,a){const i=R(S),t=i.findIndex(o=>o.command===l||o.command===`-${l}`);for(let o=i.length-1;o>=0;o--)(i[o].command===l||i[o].command===`-${l}`)&&(S=T.edit(S,[o],void 0,a));for(let o=r.length-1;o>=0;o--)S=T.edit(S,[t],r[o],a);return S}}),define(ne[225],ie([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(A,T,R){const b={},E={},I=new Set;if(!T)return{local:{added:b,updated:E,removed:[...I.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const C=n(A,T);if(C.added.size===0&&C.removed.size===0&&C.updated.size===0)return{local:{added:b,updated:E,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=n(R,A),y=n(R,T),h={},v={},d=new Set,g=new Set;for(const w of f.removed.values())y.updated.has(w)?b[w]=T[w]:d.add(w);for(const w of y.removed.values())g.has(w)||(f.updated.has(w)?g.add(w):I.add(w));for(const w of f.updated.values())g.has(w)||(y.updated.has(w)?C.updated.has(w)&&g.add(w):v[w]=A[w]);for(const w of y.updated.values())g.has(w)||(f.updated.has(w)?C.updated.has(w)&&g.add(w):A[w]!==void 0&&(E[w]=T[w]));for(const w of f.added.values())g.has(w)||(y.added.has(w)?C.updated.has(w)&&g.add(w):h[w]=A[w]);for(const w of y.added.values())g.has(w)||(f.added.has(w)?C.updated.has(w)&&g.add(w):b[w]=T[w]);return{local:{added:b,removed:[...I.values()],updated:E},remote:{added:h,removed:[...d.values()],updated:v},conflicts:[...g.values()]}}e.merge=D;function n(A,T){const R=A?Object.keys(A):[],b=T?Object.keys(T):[],E=b.filter(f=>R.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),I=R.filter(f=>b.indexOf(f)===-1).reduce((f,y)=>(f.add(y),f),new Set),C=new Set;for(const f of R){if(I.has(f))continue;const y=A[f],h=T[f];y!==h&&C.add(f)}return{added:E,removed:I,updated:C}}function L(A,T){const{added:R,removed:b,updated:E}=n(A,T);return R.size===0&&b.size===0&&E.size===0}e.areSame=L}),define(ne[25],ie([0,1,16,19,14,147,42,30,6,88,38]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function C(){const s=I.Registry.as(T.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(c=>!!s[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=C;function f(){const s=I.Registry.as(T.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(s).filter(P=>!!s[P].ignoreSync),u=Object.keys(s).filter(P=>s[P].scope===2||s[P].scope===6),p=C();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...u,...p])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const s="vscode://schemas/ignoredSettings",c=I.Registry.as(T.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=I.Registry.as(E.Extensions.JSONContribution),p=()=>{const P=C(),_=f().filter(k=>k!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(T.allSettings.properties).filter(k=>_.indexOf(k)===-1),F=_.filter(k=>P.indexOf(k)===-1),$={items:{type:"string",enum:[...O,...F.map(k=>`-${k}`)]}};u.registerSchema(s,$)};return c.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=y;function h(s){return s&&(0,L.isObject)(s)&&(0,L.isString)(s.id)&&(0,L.isArray)(s.scopes)}e.isAuthenticationProvider=h;var v;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Extensions="extensions",s.GlobalState="globalState"})(v=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function d(s,c,u){return u.joinPath(c.userDataSyncHome,s,`lastSync${s}.json`)}e.getLastSyncResourceUri=d,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function g(s){const c={};return c[e.HEADER_EXECUTION_ID]=s,c}e.createSyncHeaders=g;var w;(function(s){s.Unauthorized="Unauthorized",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.UnresolvedConflicts="UnresolvedConflicts",s.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class m extends Error{constructor(c,u,p,P){super(c);this.code=u,this.resource=p,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=m;class S extends m{constructor(c,u,p,P,_){super(c,p,void 0,_);this.url=u,this.serverCode=P}}e.UserDataSyncStoreError=S;class l extends m{constructor(c,u){super(c,u)}}e.UserDataAutoSyncError=l,function(s){function c(u){if(u instanceof s)return u;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(p&&p[1]){const P=p[2]==="unknown"?void 0:p[2],_=p[3]==="unknown"?void 0:p[3];return new s(u.message,p[1],P,_)}return new s(u.message,"Unknown")}s.toUserDataSyncError=c}(m=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var i;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(s){return`sync.enable.${s}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(s,c){if(s.scheme!==e.USER_DATA_SYNC_SCHEME)return s=s.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,n.isEqualOrParent)(s,(0,n.joinPath)(c.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[47],ie([0,1,16,5,17,23,3,35,2,26,14,7,143,20,15,13,8,46,24,21,34,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&(Object.keys(s).length===2||Object.keys(s).length===3&&s.machineId!==void 0&&typeof s.machineId=="string"))}e.isSyncData=r;let a=class extends b.Disposable{constructor(c,u,p,P,_,O,F,$,k,M,j){super();this.resource=c,this.fileService=u,this.environmentService=p,this.userDataSyncStoreService=_,this.userDataSyncBackupStoreService=O,this.userDataSyncEnablementService=F,this.telemetryService=$,this.logService=k,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,E.uppercaseFirstLetter)(this.resource),this.extUri=j.extUri,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,l.PREVIEW_DIR_NAME),this.lastSyncResource=(0,l.getLastSyncResourceUri)(c,p,this.extUri),this.currentMachineIdPromise=(0,g.getServiceMachineId)(p,u,P)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const u=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(u)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const u=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),u==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,u={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),u)}async preview(c,u,p={}){return this._sync(c,!1,u,p)}async apply(c,u={}){try{this.syncHeaders={...u};const p=await this.doApply(c);return this.setStatus(p),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,u,p,P){try{if(this.syncHeaders={...P},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let _="idle";try{const O=await this.getLastSyncUserData(),F=await this.getLatestRemoteUserData(c,O);return _=await this.performSync(F,O,u,p),_==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):_==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(_)}}finally{this.syncHeaders={}}}async replace(c){const u=await this.resolveContent(c);if(!u)return!1;const p=this.parseSyncData(u);if(!p)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const P=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(null,P),O=await this.isRemoteDataFromCurrentMachine(_),F=await this.generateSyncPreview({ref:_.ref,syncData:p},P,O,this.getUserDataSyncConfiguration(),A.CancellationToken.None),$=[];for(const k of F){const M=await this.getAcceptResult(k,k.remoteResource,void 0,A.CancellationToken.None),{remoteChange:j}=await this.getAcceptResult(k,k.previewResource,k.remoteContent,A.CancellationToken.None);$.push([k,{...M,remoteChange:j!==0?j:2}])}await this.applyResult(_,P,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const u=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===u}async getLatestRemoteUserData(c,u){if(u){const p=c&&c.latest?c.latest[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async performSync(c,u,p,P){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new l.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,u,p,P)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,u,p,P);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.performSync(c,u,p,P)}throw _}}async doSync(c,u,p,P){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(O=>this.doGenerateSyncResourcePreview(c,u,p,P,O)));const _=await this.syncPreviewPromise;return this.updateConflicts(_.resourcePreviews),_.resourcePreviews.some(({mergeState:O})=>O==="conflict")?"hasConflicts":p?await this.doApply(!1):"syncing"}catch(_){throw this.syncPreviewPromise=null,_}}async merge(c){return await this.updateSyncResourcePreview(c,async u=>{const p=await this.getMergeResult(u,A.CancellationToken.None);await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(p?.content||""));const P=p&&!p.hasConflicts?await this.getAcceptResult(u,u.previewResource,void 0,A.CancellationToken.None):void 0;return u.acceptResult=P,u.mergeState=p.hasConflicts?"conflict":P?"accepted":"preview",u.localChange=P?P.localChange:p.localChange,u.remoteChange=P?P.remoteChange:p.remoteChange,u}),this.syncPreviewPromise}async accept(c,u){return await this.updateSyncResourcePreview(c,async p=>{const P=await this.getAcceptResult(p,c,u,A.CancellationToken.None);return p.acceptResult=P,p.mergeState="accepted",p.localChange=P.localChange,p.remoteChange=P.remoteChange,p}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async u=>{const p=await this.getMergeResult(u,A.CancellationToken.None);return await this.fileService.writeFile(u.previewResource,L.VSBuffer.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.syncPreviewPromise}async updateSyncResourcePreview(c,u){if(!this.syncPreviewPromise)return;let p=await this.syncPreviewPromise;const P=p.resourcePreviews.findIndex(({localResource:_,remoteResource:O,previewResource:F})=>this.extUri.isEqual(_,c)||this.extUri.isEqual(O,c)||this.extUri.isEqual(F,c));P!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async _=>{const O=[...p.resourcePreviews];return O[P]=await u(O[P]),{...p,resourcePreviews:O}}),p=await this.syncPreviewPromise,this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:_})=>_==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const u=await this.syncPreviewPromise;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.applyResult(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(c){const u=c.filter(({mergeState:p})=>p==="conflict");(0,D.equals)(this._conflicts,u,(p,P)=>this.extUri.isEqual(p.previewResource,P.previewResource))||(this._conflicts=u,this._onDidChangeConflicts.fire(u))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:u,ref:p})=>({created:u,uri:this.toRemoteBackupResource(p)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:u,ref:p})=>({created:u,uri:this.toLocalBackupResource(p)}))}toRemoteBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return C.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:p}=await this.getUserData(u);if(p)return this.parseSyncData(p)?.machineId}}async resolveContent(c){const u=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(u))){const{content:p}=await this.getUserData(u);return p}return this.extUri.isEqual(c,this.toLocalBackupResource(u))?this.userDataSyncBackupStoreService.resolveContent(this.resource,u):null}async resolvePreviewContent(c){const u=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(u)for(const p of u.resourcePreviews){if(this.extUri.isEqual(p.acceptedResource,c))return p.acceptResult?p.acceptResult.content:null;if(this.extUri.isEqual(p.remoteResource,c))return p.remoteContent;if(this.extUri.isEqual(p.localResource,c))return p.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(c,u,p,P,_){const O=await this.isRemoteDataFromCurrentMachine(c),F=await this.generateSyncPreview(c,u,O,P,_),$=[];for(const k of F){const M=k.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(k.localChange===0&&k.remoteChange===0)$.push({...k,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const j=p?await this.getMergeResult(k,_):void 0;if(_.isCancellationRequested)break;await this.fileService.writeFile(k.previewResource,L.VSBuffer.fromString(j?.content||""));const U=j&&!j.hasConflicts?await this.getAcceptResult(k,k.previewResource,void 0,_):void 0;$.push({...k,acceptResult:U,mergeState:j?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:j?j.localChange:k.localChange,remoteChange:U?U.remoteChange:j?j.remoteChange:k.remoteChange})}}return{remoteUserData:c,lastSyncUserData:u,resourcePreviews:$,isLastSyncFromCurrentMachine:O}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),u=JSON.parse(c.value.toString()),p=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=u.version&&p&&u.version!==p,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;const P=u;if(P.content===null)return{ref:u.ref,syncData:null};const _=JSON.parse(P.content);if(r(_))return{...u,syncData:_,content:void 0}}catch(c){c instanceof v.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,u={}){if(u.ref||u.content||u.version)throw new Error("Cannot have core properties as additional");const p=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),P={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:p,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(P)))}async getRemoteUserData(c){const{ref:u,content:p}=await this.getUserData(c);let P=null;return p!==null&&(P=this.parseSyncData(p)),{ref:u,syncData:P}}parseSyncData(c){try{const u=JSON.parse(c);if(r(u))return u}catch(u){this.logService.error(u)}throw new l.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,I.isString)(c)){const u=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:u}}else{const u=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,u,this.syncHeaders)}}async updateRemoteUserData(c,u){const p=await this.currentMachineIdPromise,P={version:this.version,machineId:p,content:c};return u=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(P),u,this.syncHeaders),{ref:u,syncData:P}}async backupLocal(c){const u={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(u))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([J(1,v.IFileService),J(2,h.IEnvironmentService),J(3,w.IStorageService),J(4,l.IUserDataSyncStoreService),J(5,l.IUserDataSyncBackupStoreService),J(6,l.IUserDataSyncEnablementService),J(7,m.ITelemetryService),J(8,l.IUserDataSyncLogService),J(9,y.IConfigurationService),J(10,S.IUriIdentityService)],a),e.AbstractSynchroniser=a;let i=class extends a{constructor(c,u,p,P,_,O,F,$,k,M,j,U){super(u,p,P,_,O,F,$,k,M,j,U);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(c,u,p){try{u?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),p?void 0:u):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:p})}catch(P){throw P instanceof v.FileOperationError&&P.fileOperationResult===1||P instanceof v.FileOperationError&&P.fileOperationResult===3?new l.UserDataSyncError(P.message,"LocalPreconditionFailed"):P}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};i=de([J(2,v.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,m.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,y.IConfigurationService),J(11,S.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let t=class extends i{constructor(c,u,p,P,_,O,F,$,k,M,j,U,G){super(c,u,p,P,_,O,F,$,k,M,U,G);this.userDataSyncUtilService=j,this._formattingOptions=void 0}hasErrors(c){const u=[];return(0,R.parse)(c,u,{allowEmptyContent:!0,allowTrailingComma:!0}),u.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([J(2,v.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,l.IUserDataSyncStoreService),J(6,l.IUserDataSyncBackupStoreService),J(7,l.IUserDataSyncEnablementService),J(8,m.ITelemetryService),J(9,l.IUserDataSyncLogService),J(10,l.IUserDataSyncUtilService),J(11,y.IConfigurationService),J(12,S.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let o=class{constructor(c,u,p,P,_){this.resource=c,this.environmentService=u,this.logService=p,this.fileService=P,this.extUri=_.extUri,this.lastSyncResource=(0,l.getLastSyncResourceUri)(this.resource,u,this.extUri)}async initialize({ref:c,content:u}){if(!u){this.logService.info("Remote content does not exist.",this.resource);return}const p=this.parseSyncData(u);if(!!p)try{await this.doInitialize({ref:c,syncData:p})}catch(P){this.logService.error(P)}}parseSyncData(c){try{const u=JSON.parse(c);if(r(u))return u}catch(u){this.logService.error(u)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,u={}){const p={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...u};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(p)))}};o=de([J(1,h.IEnvironmentService),J(2,d.ILogService),J(3,v.IFileService),J(4,S.IUriIdentityService)],o),e.AbstractInitializer=o}),define(ne[226],ie([0,1,5,23,9,3,49,26,7,20,15,30,31,63,13,8,24,21,34,47,223,98,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function a(o,s){const c=JSON.parse(o.content);if(o.version===1||o.version===2){const u=(await s.getInstalled(0)).filter(p=>p.isBuiltin);for(const p of c)o.version===1&&(p.enabled===!1&&(p.disabled=!0),delete p.enabled),o.version===2&&u.every(P=>!(0,f.areSameExtensions)(P.identifier,p.identifier))&&(p.installed=!0)}return c}let i=class mt extends m.AbstractSynchroniser{constructor(s,c,u,p,P,_,O,F,$,k,M,j,U,G,K){super("extensions",c,s,u,p,P,j,U,$,M,K);this.extensionManagementService=_,this.extensionEnablementService=O,this.ignoredExtensionsManagementService=F,this.extensionGalleryService=k,this.extensionStorageService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(A.Event.debounce(A.Event.any(A.Event.filter(this.extensionManagementService.onDidInstallExtensions,x=>x.some(({local:q})=>!!q)),A.Event.filter(this.extensionManagementService.onDidUninstallExtension,x=>!x.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(s,c){const u=s.syncData?await a(s.syncData,this.extensionManagementService):null,p=c?.skippedExtensions||[],P=c?.syncData?await a(c.syncData,this.extensionManagementService):null,_=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(_),F=this.ignoredExtensionsManagementService.getIgnoredExtensions(_);u?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:k}=(0,S.merge)(O,u,P,p,F),M={local:$,remote:k,content:this.getPreviewContent(O,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:k!==null?2:0};return[{skippedExtensions:p,localResource:this.localResource,localContent:this.stringify(O,!1),localExtensions:O,remoteResource:this.remoteResource,remoteContent:u?this.stringify(u,!1):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(s){const c=s.syncData?await a(s.syncData,this.extensionManagementService):null,u=await this.extensionManagementService.getInstalled(void 0,!0),p=this.getLocalExtensions(u),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),{remote:_}=(0,S.merge)(p,c,c,s.skippedExtensions||[],P);return _!==null}getPreviewContent(s,c,u,p){const P=[...c,...u],_=new Set,O=F=>{_.add(F.id.toLowerCase()),F.uuid&&_.add(F.uuid)};P.forEach(({identifier:F})=>O(F)),p.forEach(O);for(const F of s)_.has(F.identifier.id.toLowerCase())||F.identifier.uuid&&_.has(F.identifier.uuid)||P.push(F);return this.stringify(P,!1)}async getMergeResult(s,c){return{...s.previewResult,hasConflicts:!1}}async getAcceptResult(s,c,u,p){if(this.extUri.isEqual(c,this.localResource))return this.acceptLocal(s);if(this.extUri.isEqual(c,this.remoteResource))return this.acceptRemote(s);if(this.extUri.isEqual(c,this.previewResource))return s.previewResult;throw new Error(`Invalid Resource: ${c.toString()}`)}async acceptLocal(s){const c=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),p=(0,S.merge)(s.localExtensions,null,null,s.skippedExtensions,u),{local:P,remote:_}=p;return{content:s.localContent,local:P,remote:_,localChange:P.added.length>0||P.removed.length>0||P.updated.length>0?2:0,remoteChange:_!==null?2:0}}async acceptRemote(s){const c=await this.extensionManagementService.getInstalled(),u=this.ignoredExtensionsManagementService.getIgnoredExtensions(c),p=s.remoteContent?JSON.parse(s.remoteContent):null;if(p!==null){const P=(0,S.merge)(s.localExtensions,p,s.localExtensions,[],u),{local:_,remote:O}=P;return{content:s.remoteContent,local:_,remote:O,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:s.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(s,c,u,p){let{skippedExtensions:P,localExtensions:_}=u[0][0],{local:O,remote:F,localChange:$,remoteChange:k}=u[0][1];if($===0&&k===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(_)),P=await this.updateLocalExtensions(O.added,O.removed,O.updated,P)),F){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify(F.all);s=await this.updateRemoteUserData(M,p?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${F.added.length?` Added: ${JSON.stringify(F.added.map(j=>j.identifier.id))}.`:""}${F.updated.length?` Updated: ${JSON.stringify(F.updated.map(j=>j.identifier.id))}.`:""}${F.removed.length?` Removed: ${JSON.stringify(F.removed.map(j=>j.identifier.id))}.`:""}`)}c?.ref!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(s,{skippedExtensions:P}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${P.length?` Skipped: ${JSON.stringify(P.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:s}){return[{resource:this.extUri.joinPath(s,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(s){if(this.extUri.isEqual(s,mt.EXTENSIONS_DATA_URI)){const u=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),P=this.getLocalExtensions(u).filter(_=>!p.some(O=>(0,f.areSameExtensions)({id:O},_.identifier)));return this.stringify(P,!0)}if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s)){const u=await this.resolvePreviewContent(s);return u&&this.stringify(JSON.parse(u),!0)}let c=await super.resolveContent(s);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(s)),c){const u=this.parseSyncData(c);if(u)switch(this.extUri.basename(s)){case"extensions.json":return this.stringify(this.parseExtensions(u),!0)}}return null}stringify(s,c){return s.sort((u,p)=>!u.identifier.uuid&&p.identifier.uuid?-1:u.identifier.uuid&&!p.identifier.uuid?1:(0,R.compare)(u.identifier.id,p.identifier.id)),c?(0,T.toFormattedString)(s,{}):JSON.stringify(s)}async hasLocalData(){try{const s=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(s).some(u=>u.installed||u.disabled))return!0}catch{}return!1}async updateLocalExtensions(s,c,u,p){const P=[],_=[],O=await this.extensionManagementService.getInstalled();if(c.length){const $=O.filter(({identifier:k,isBuiltin:M})=>!M&&c.some(j=>(0,f.areSameExtensions)(k,j)));await D.Promises.settled($.map(async k=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,k.identifier.id),await this.extensionManagementService.uninstall(k,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,k.identifier.id),P.push(k.identifier)}))}(s.length||u.length)&&await D.Promises.settled([...s,...u].map(async $=>{const k=O.find(j=>(0,f.areSameExtensions)(j.identifier,$.identifier));if(k&&k.isBuiltin){$.state&&k.manifest.version===$.version&&this.updateExtensionState($.state,k,k.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(U=>(0,f.areSameExtensions)(U,$.identifier))!==!!$.disabled&&($.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id))),P.push($.identifier);return}const M=(await this.extensionGalleryService.getExtensions([{...$.identifier,preRelease:$.preRelease}],n.CancellationToken.None))[0];if($.state&&(k?k.manifest.version===$.version:!!M)&&this.updateExtensionState($.state,k||M,k?.manifest.version),M)try{this.extensionEnablementService.getDisabledExtensions().some(U=>(0,f.areSameExtensions)(U,$.identifier))!==!!$.disabled&&($.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,M.version))),(!k||k.preRelease!==$.preRelease)&&(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:$.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,M.version),P.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),_.push($)))}catch(j){_.push($),j instanceof C.ExtensionManagementError&&[C.ExtensionManagementErrorCode.Incompatible,C.ExtensionManagementErrorCode.IncompatiblePreRelease,C.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(j),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else _.push($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,$.identifier.id)}));const F=[];for(const $ of p)P.some(k=>(0,f.areSameExtensions)(k,$.identifier))||F.push($);for(const $ of _)F.some(k=>(0,f.areSameExtensions)(k.identifier,$.identifier))||F.push($);return F}updateExtensionState(s,c,u){const p=this.extensionStorageService.getExtensionState(c,!0)||{},P=u?this.extensionStorageService.getKeysForSync({id:c.identifier.id,version:u}):void 0;P?P.forEach(_=>{p[_]=s[_]}):Object.keys(s).forEach(_=>p[_]=s[_]),this.extensionStorageService.setExtensionState(c,p,!0)}parseExtensions(s){return JSON.parse(s.content)}getLocalExtensions(s){const c=this.extensionEnablementService.getDisabledExtensions();return s.map(u=>{const{identifier:p,isBuiltin:P,manifest:_,preRelease:O}=u,F={identifier:p,preRelease:O,version:_.version};c.some($=>(0,f.areSameExtensions)($,p))&&(F.disabled=!0),P||(F.installed=!0);try{const $=this.extensionStorageService.getKeysForSync({id:p.id,version:_.version});if($){const k=this.extensionStorageService.getExtensionState(u,!0)||{};F.state=Object.keys(k).reduce((M,j)=>($.includes(j)&&(M[j]=k[j]),M),{})}}catch($){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,L.getErrorMessage)($))}return F})}};i.EXTENSIONS_DATA_URI=b.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([J(0,I.IEnvironmentService),J(1,h.IFileService),J(2,d.IStorageService),J(3,r.IUserDataSyncStoreService),J(4,r.IUserDataSyncBackupStoreService),J(5,C.IExtensionManagementService),J(6,C.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,r.IUserDataSyncLogService),J(9,C.IExtensionGalleryService),J(10,E.IConfigurationService),J(11,r.IUserDataSyncEnablementService),J(12,g.ITelemetryService),J(13,y.IExtensionStorageService),J(14,w.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let t=class extends m.AbstractInitializer{constructor(s,c,u,p,P,_){super("extensions",p,P,u,_);this.extensionManagementService=s,this.ignoredExtensionsManagementService=c}async parseExtensions(s){return s.syncData?await a(s.syncData,this.extensionManagementService):null}generatePreview(s,c){const u=[],p=[],P=[];for(const _ of s){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(_.identifier.id))continue;const O=c.find(F=>(0,f.areSameExtensions)(F.identifier,_.identifier));O?(u.push(O),_.disabled&&P.push(_.identifier)):_.installed&&(p.push(_.identifier),_.disabled&&P.push(_.identifier))}return{installedExtensions:u,newExtensions:p,disabledExtensions:P,remoteExtensions:s}}};t=de([J(0,C.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,h.IFileService),J(3,I.IEnvironmentService),J(4,v.ILogService),J(5,w.IUriIdentityService)],t),e.AbstractExtensionsInitializer=t}),define(ne[227],ie([0,1,28,25]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(R,b,E,I,C){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=A(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=E?A(E,b):{added:Object.keys(b).reduce((w,m)=>(w.add(m),w),new Set),removed:new Set,updated:new Set},h=E?A(E,R):{added:Object.keys(R).reduce((w,m)=>(w.add(m),w),new Set),removed:new Set,updated:new Set},v={added:{},removed:[],updated:{}},d=D.deepClone(b),g=!E;for(const w of h.added.values())w!==n.SYNC_SERVICE_URL_TYPE&&g&&y.added.has(w)||(d[w]=R[w]);for(const w of h.updated.values())d[w]=R[w];for(const w of h.removed.values())I.unregistered.includes(w)||delete d[w];for(const w of y.added.values()){const m=b[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(E&&h.added.has(w))continue;const S=R[w];S&&S.value===m.value||w===n.SYNC_SERVICE_URL_TYPE&&g&&h.added.has(w)||(S?v.updated[w]=m:v.added[w]=m)}for(const w of y.updated.values()){const m=b[w];if(I.machine.includes(w)){C.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const S=R[w];S&&S.value===m.value||(v.updated[w]=m)}for(const w of y.removed.values()){if(I.machine.includes(w)){C.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||v.removed.push(w)}return{local:v,remote:T(d,b)?null:d}}e.merge=L;function A(R,b){const E=Object.keys(R),I=Object.keys(b),C=I.filter(h=>E.indexOf(h)===-1).reduce((h,v)=>(h.add(v),h),new Set),f=E.filter(h=>I.indexOf(h)===-1).reduce((h,v)=>(h.add(v),h),new Set),y=new Set;for(const h of E){if(f.has(h))continue;const v=R[h],d=b[h];D.equals(v,d)||y.add(h)}return{added:C,removed:f,updated:y}}function T(R,b){const{added:E,removed:I,updated:C}=A(R,b);return E.size===0&&I.size===0&&C.size===0}}),define(ne[228],ie([0,1,17,9,3,35,49,4,7,29,20,15,13,8,46,24,21,34,47,53,227,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function i(u,p){const P=u.storage?Object.keys(u.storage).sort():[],_={};return P.forEach(O=>_[O]=u.storage[O]),u.storage=_,p?(0,T.toFormattedString)(u,{}):JSON.stringify(u)}const t=1;let o=class vt extends w.AbstractSynchroniser{constructor(p,P,_,O,F,$,k,M,j,U){super("globalState",p,F,j,P,_,$,k,O,M,U);this.storageService=j,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(p.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(p.onDidFilesChange,G=>G.contains(this.environmentService.argvResource)),L.Event.filter(j.onDidChangeValue,G=>G.scope===0&&G.target!==void 0?G.target===0:j.keys(0,0).includes(G.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(p,P,_){const O=p.syncData?JSON.parse(p.syncData.content):null;P=P===null&&_?p:P;const F=P&&P.syncData?JSON.parse(P.syncData.content):null,$=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const k=this.getStorageKeys(F),{local:M,remote:j}=(0,S.merge)($.storage,O?O.storage:null,F?F.storage:null,k,this.logService),U={content:null,local:M,remote:j,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:j!==null?2:0};return[{localResource:this.localResource,localContent:i($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:O?i(O,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:k}]}async hasRemoteChanged(p){const P=p.syncData?JSON.parse(p.syncData.content):null;if(P===null)return!0;const _=await this.getLocalGlobalState(),O=this.getStorageKeys(P),{remote:F}=(0,S.merge)(_.storage,P.storage,P.storage,O,this.logService);return F!==null}async getMergeResult(p,P){return{...p.previewResult,hasConflicts:!1}}async getAcceptResult(p,P,_,O){if(this.extUri.isEqual(P,this.localResource))return this.acceptLocal(p);if(this.extUri.isEqual(P,this.remoteResource))return this.acceptRemote(p);if(this.extUri.isEqual(P,this.previewResource))return p.previewResult;throw new Error(`Invalid Resource: ${P.toString()}`)}async acceptLocal(p){return{content:p.localContent,local:{added:{},removed:[],updated:{}},remote:p.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(p){if(p.remoteContent!==null){const P=JSON.parse(p.remoteContent),{local:_,remote:O}=(0,S.merge)(p.localUserData.storage,P.storage,null,p.storageKeys,this.logService);return{content:p.remoteContent,local:_,remote:O,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:p.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(p,P,_,O){let{localUserData:F}=_[0][0],{local:$,remote:k,localChange:M,remoteChange:j}=_[0][1];if(M===0&&j===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),j!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:k});p=await this.updateRemoteUserData(U,O?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}P?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:p}){return[{resource:this.extUri.joinPath(p,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(p){if(this.extUri.isEqual(p,vt.GLOBAL_STATE_DATA_URI)){const _=await this.getLocalGlobalState();return i(_,!0)}if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p)){const _=await this.resolvePreviewContent(p);return _&&i(JSON.parse(_),!0)}let P=await super.resolveContent(p);if(P)return P;if(P=await super.resolveContent(this.extUri.dirname(p)),P){const _=this.parseSyncData(P);if(_)switch(this.extUri.basename(p)){case"globalState.json":return i(JSON.parse(_.content),!0)}}return null}async hasLocalData(){try{const{storage:p}=await this.getLocalGlobalState();if(Object.keys(p).length>1||p[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const p={},P=await this.getLocalArgvContent(),_=(0,A.parse)(P);for(const O of a)_[O]!==void 0&&(p[`${r}${O}`]={version:1,value:_[O]});for(const O of this.storageService.keys(0,0)){const F=this.storageService.get(O,0);F&&(p[O]={version:1,value:F})}return{storage:p}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const p=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),p.value.toString()}catch(p){this.logService.debug((0,n.getErrorMessage)(p))}return"{}"}async writeLocalGlobalState({added:p,removed:P,updated:_}){const O={},F={},$=(M,j)=>{for(const U of M){if(U.startsWith(r)){O[U.substring(r.length)]=j?j[U].value:void 0;continue}if(j){const G=j[U];G.value!==String(this.storageService.get(U,0))&&(F[U]=G.value)}else this.storageService.get(U,0)!==void 0&&(F[U]=void 0)}};if($(Object.keys(p),p),$(Object.keys(_),_),$(P),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(F))this.storageService.store(M,F[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(p){const P=await this.getLocalArgvContent();let _=P;for(const O of Object.keys(p))_=(0,m.edit)(_,[O],p[O],{});P!==_&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(_)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(p){const P=this.storageService.keys(0,0),_=this.storageService.keys(0,1),O=[...P,..._],F=p?.storage?Object.keys(p.storage).filter($=>!$.startsWith(r)&&!O.includes($)&&this.storageService.get($,0)!==void 0):[];if(!R.isWeb){const $=[...l.ALL_SYNC_RESOURCES.map(k=>(0,l.getEnablementKey)(k)),l.SYNC_SERVICE_URL_TYPE];F.push(...$),_.push(...$)}return{user:P,machine:_,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=b.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([J(0,f.IFileService),J(1,l.IUserDataSyncStoreService),J(2,l.IUserDataSyncBackupStoreService),J(3,l.IUserDataSyncLogService),J(4,C.IEnvironmentService),J(5,l.IUserDataSyncEnablementService),J(6,d.ITelemetryService),J(7,I.IConfigurationService),J(8,v.IStorageService),J(9,g.IUriIdentityService)],o),e.GlobalStateSynchroniser=o;let s=class extends w.AbstractInitializer{constructor(p,P,_,O,F){super("globalState",_,O,P,F);this.storageService=p}async doInitialize(p){const P=p.syncData?JSON.parse(p.syncData.content):null;if(!P){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const _={},O={};for(const F of Object.keys(P.storage))F.startsWith(r)?_[F.substring(r.length)]=P.storage[F].value:this.storageService.get(F,0)===void 0&&(O[F]=P.storage[F].value);if(Object.keys(_).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(_))F=(0,m.edit)(F,[$],_[$],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(F))}if(Object.keys(O).length)for(const F of Object.keys(O))this.storageService.store(F,O[F],0,0)}};s=de([J(0,v.IStorageService),J(1,f.IFileService),J(2,C.IEnvironmentService),J(3,l.IUserDataSyncLogService),J(4,g.IUriIdentityService)],s),e.GlobalStateInitializer=s;let c=class{constructor(p,P,_,O,F){this.userDataSyncStoreClient=p,this.storageService=P,this.environmentService=_,this.fileService=O,this.logService=F}getSyncStoreType(p){return this.parseGlobalState(p)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(p){const P=(0,l.createSyncHeaders)((0,E.generateUuid)());try{return await this.doSync(p,P)}catch(_){if(_ instanceof l.UserDataSyncError)switch(_.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(p,P)}throw _}}async doSync(p,P){const _=await this.userDataSyncStoreClient.read("globalState",null,P),O=this.parseGlobalState(_)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:p,version:t};const F=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:F,content:i(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),_.ref,P)}parseGlobalState({content:p}){if(!p)return null;const P=JSON.parse(p);if((0,w.isSyncData)(P))return P?JSON.parse(P.content):null;throw new Error("Invalid remote data")}};c=de([J(1,v.IStorageService),J(2,C.IEnvironmentService),J(3,f.IFileService),J(4,y.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(ne[229],ie([0,1,16,17,3,35,4,14,144,20,15,13,24,21,34,47,224,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(l,r,a){try{const i=JSON.parse(l);if(!r)return(0,R.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,R.isUndefined)(i.mac)?null:i.mac;case 3:return(0,R.isUndefined)(i.linux)?null:i.linux;case 1:return(0,R.isUndefined)(i.windows)?null:i.windows}}catch(i){return a.error(i),null}}e.getKeybindingsContentFromSyncContent=w;let m=class extends v.AbstractJsonFileSynchroniser{constructor(r,a,i,t,o,s,c,u,p,P,_){super(c.keybindingsResource,"keybindings",s,c,u,r,a,o,P,i,p,t,_);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.filter(t.onDidChangeConfiguration,O=>O.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,i,t){const o=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&i?r:a;const s=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),u=await this.getFormattingOptions();let p=null,P=!1,_=!1,O=!1;if(o){let $=c?c.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new g.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!s||s!==$||s!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const k=await(0,d.merge)($,o,s,u,this.userDataSyncUtilService);k.hasChanges&&(p=k.mergeContent,O=k.hasConflicts,P=O||k.mergeContent!==$,_=O||k.mergeContent!==o)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),p=c.value.toString(),_=!0);const F={content:p,localChange:P?c?2:1:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString():"",o=await this.getFormattingOptions(),s=await(0,d.merge)(t||"[]",a,a,o,this.userDataSyncUtilService);return s.hasConflicts||s.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,i,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:c,remoteChange:u}=i[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),s!==null&&(s=s.trim(),s=s||"[]",this.hasErrors(s)))throw new g.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(s||"[]",o,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),u!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const p=this.toSyncContent(s||"[]",r.syncData?.content);r=await this.updateRemoteUserData(p,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,A.parse)(r.value.toString());if((0,D.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return w(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let i={};try{i=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};m=de([J(0,g.IUserDataSyncStoreService),J(1,g.IUserDataSyncBackupStoreService),J(2,g.IUserDataSyncLogService),J(3,E.IConfigurationService),J(4,g.IUserDataSyncEnablementService),J(5,C.IFileService),J(6,I.IEnvironmentService),J(7,f.IStorageService),J(8,g.IUserDataSyncUtilService),J(9,y.ITelemetryService),J(10,h.IUriIdentityService)],m),e.KeybindingsSynchroniser=m;let S=class extends v.AbstractInitializer{constructor(r,a,i,t){super("keybindings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,n.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,A.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};S=de([J(0,C.IFileService),J(1,I.IEnvironmentService),J(2,g.IUserDataSyncLogService),J(3,h.IUriIdentityService)],S),e.KeybindingsInitializer=S}),define(ne[230],ie([0,1,16,35,69,49,28,53,25]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function E(s,c,u){let p=[];u?p=C(u):p=I(c);const P=[],_=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const O of p)O.startsWith("-")?_.push(O.substring(1)):P.push(O);return(0,D.distinct)([...s,...P].filter(O=>_.indexOf(O)===-1))}e.getIgnoredSettings=E;function I(s){let c=s.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=s.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:s.getValue("settingsSync.ignoredSettings")||[]}function C(s){const c=(0,n.parse)(s);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function f(s,c,u,p){if(u.length){const P=o(c),_=(0,n.parse)(c),O=(0,n.parse)(s),F=[];for(const $ of u){const k=_[$],M=O[$];k===void 0?s=R.edit(s,[$],void 0,p):M!==void 0?s=R.edit(s,[$],k,p):F.push(l($,P))}F.sort(($,k)=>$.startOffset-k.startOffset),F.forEach($=>s=g($.setting.key,c,s,p))}return s}e.updateIgnoredSettings=f;function y(s,c,u,p,P,_){const O=f(s,c,p,_),F=u!==O,$=u!==c;if(!F&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!$)return{conflictsSettings:[],localContent:null,remoteContent:O,hasConflicts:!1};if($&&!F)return{conflictsSettings:[],localContent:f(c,s,p,_),remoteContent:null,hasConflicts:!1};if(u===null&&v(s)){const z=h(s,c,p)?null:f(c,s,p,_);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let k=s,M=c;const j=(0,n.parse)(s),U=(0,n.parse)(c),G=u?(0,n.parse)(u):null,K=p.reduce((z,B)=>(z.add(B),z),new Set),x=d(j,U,K),q=d(G,j,K),X=d(G,U,K),H=new Map,Z=new Set,ee=z=>{Z.add(z);const B=P.filter(({key:te})=>te===z)[0];B?(k=R.edit(k,[z],B.value,_),M=R.edit(M,[z],B.value,_)):H.set(z,{key:z,localValue:j[z],remoteValue:U[z]})};for(const z of q.removed.values())X.updated.has(z)?ee(z):M=R.edit(M,[z],void 0,_);for(const z of X.removed.values())Z.has(z)||(q.updated.has(z)?ee(z):k=R.edit(k,[z],void 0,_));for(const z of q.updated.values())Z.has(z)||(X.updated.has(z)?x.updated.has(z)&&ee(z):M=R.edit(M,[z],j[z],_));for(const z of X.updated.values())Z.has(z)||(q.updated.has(z)?x.updated.has(z)&&ee(z):k=R.edit(k,[z],U[z],_));for(const z of q.added.values())Z.has(z)||(X.added.has(z)?x.updated.has(z)&&ee(z):M=g(z,k,M,_));for(const z of X.added.values())Z.has(z)||(q.added.has(z)?x.updated.has(z)&&ee(z):k=g(z,M,k,_));const W=H.size>0||!h(k,M,p),N=W||!h(k,s,[]),V=W||!h(M,c,[]);return{localContent:N?k:null,remoteContent:V?M:null,conflictsSettings:[...H.values()],hasConflicts:W}}e.merge=y;function h(s,c,u){if(s===c)return!0;const p=(0,n.parse)(s),P=(0,n.parse)(c),_=u.reduce(($,k)=>($.add(k),$),new Set),O=o(s).filter($=>!($.setting&&_.has($.setting.key))),F=o(c).filter($=>!($.setting&&_.has($.setting.key)));if(O.length!==F.length)return!1;for(let $=0;$<O.length;$++){const k=O[$],M=F[$];if(k.setting&&M.setting){if(k.setting.key!==M.setting.key||!T.equals(p[k.setting.key],P[k.setting.key]))return!1}else if(!k.setting&&!M.setting){if(k.value!==M.value)return!1}else return!1}return!0}e.areSame=h;function v(s){return s?o(s).length===0:!0}e.isEmpty=v;function d(s,c,u){const p=s?Object.keys(s).filter($=>!u.has($)):[],P=Object.keys(c).filter($=>!u.has($)),_=P.filter($=>p.indexOf($)===-1).reduce(($,k)=>($.add(k),$),new Set),O=p.filter($=>P.indexOf($)===-1).reduce(($,k)=>($.add(k),$),new Set),F=new Set;if(s)for(const $ of p){if(O.has($))continue;const k=s[$],M=c[$];T.equals(k,M)||F.add($)}return{added:_,removed:O,updated:F}}function g(s,c,u,p){const P=(0,n.parse)(c),_=o(c),O=o(u),F=w(s,_,O);return m(u,s,P[s],F,O,p)}e.addSetting=g;function w(s,c,u){const p=c.findIndex(_=>_.setting?.key===s),P=c[p-1];if(P){if(P.setting){const O=l(P.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!0}}else{const O=r(p,c);if(O){const F=l(O.setting.key,u);if(F){const $=a(u.indexOf(F),u),k=i(c,O,c[p]);if($){const M=i(u,F,$),j=t(k,M);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.indexOf($),insertAfter:!1}}else{const M=i(u,F,u[u.length-1]),j=t(k,M);return j?{index:u.indexOf(j),insertAfter:!0}:{index:u.length-1,insertAfter:!0}}}}}const _=c[p+1];if(_)if(_.setting){const O=l(_.setting.key,u);if(O)return{index:u.indexOf(O),insertAfter:!1}}else{const O=a(p,c);if(O){const F=l(O.setting.key,u);if(F){const $=r(u.indexOf(F),u),k=i(c,c[p],O);if($){const M=i(u,$,F),j=t(k.reverse(),M.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:u.indexOf($),insertAfter:!0}}else{const M=i(u,u[0],F),j=t(k.reverse(),M.reverse());return j?{index:u.indexOf(j),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:u.length-1,insertAfter:!0}}function m(s,c,u,p,P,_){let O;return p.index===-1?O=(0,L.setProperty)(s,[c],u,_):O=S(s,c,u,p,P,_).map(F=>(0,L.withFormatting)(s,F,_)[0]),(0,L.applyEdits)(s,O)}function S(s,c,u,p,P,_){const O=`${JSON.stringify(c)}: ${JSON.stringify(u)}`,F=(0,A.getEOL)(_,s),$=P[p.index];if(p.insertAfter){const k=[];if($.setting)k.push({offset:$.endOffset,length:0,content:","+O});else{const M=a(p.index,P),j=r(p.index,P),U=j?.setting?.commaOffset;j&&U===void 0&&k.push({offset:j.endOffset,length:0,content:","});const G=U!==void 0&&U>$.endOffset;k.push({offset:G?U+1:$.endOffset,length:0,content:M?F+O+",":F+O})}return k}else{if($.setting)return[{offset:$.startOffset,length:0,content:O+","}];const k=(P[p.index-1]&&!P[p.index-1].setting?F:"")+O+(a(p.index,P)?",":"")+F;return[{offset:$.startOffset,length:0,content:k}]}}function l(s,c){return c.filter(u=>u.setting?.key===s)[0]}function r(s,c){for(let u=s-1;u>=0;u--)if(c[u].setting)return c[u]}function a(s,c){for(let u=s+1;u<c.length;u++)if(c[u].setting)return c[u]}function i(s,c,u){const p=s.indexOf(c),P=s.indexOf(u);return s.filter((_,O)=>p<O&&O<P)}function t(s,c){if(s.length&&c.length){let u=0;for(;u<c.length&&u<s.length;u++)if(s[u].value!==c[u].value)return c[u-1];return c[u-1]}}function o(s){const c=[];let u=-1,p,P;const _={onObjectBegin:O=>{u++},onObjectProperty:(O,F,$)=>{u===0&&(p=F,P=O)},onObjectEnd:(O,F)=>{u--,u===0&&c.push({startOffset:p,endOffset:O+F,value:s.substring(p,O+F),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(O,F)=>{u++},onArrayEnd:(O,F)=>{u--,u===0&&c.push({startOffset:p,endOffset:O+F,value:s.substring(p,O+F),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(O,F,$)=>{u===0&&c.push({startOffset:p,endOffset:F+$,value:s.substring(p,F+$),setting:{key:P,commaOffset:void 0}})},onSeparator:(O,F,$)=>{if(u===0&&O===","){let k=c.length-1;for(;k>=0&&!c[k].setting;k--);const M=c[k];M&&c.splice(k,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:F}})}},onComment:(O,F)=>{u===0&&c.push({startOffset:O,endOffset:O+F,value:s.substring(O,O+F)})}};return(0,n.visit)(s,_),c}}),define(ne[231],ie([0,1,17,3,145,20,89,15,30,13,24,21,34,47,53,230,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(l){return l&&l.settings&&typeof l.settings=="string"&&Object.keys(l).length===1}function w(l){const r=JSON.parse(l);return g(r)?r:{settings:l}}e.parseSettingsSyncContent=w;let m=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,i,t,o,s,c,u,p,P,_,O){super(a.settingsResource,"settings",r,a,i,t,o,p,P,s,c,u,O);this.extensionManagementService=_,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(i),o=new T.ConfigurationModelParser(d.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&o.parse(t.settings),o.configurationModel.getValue(d.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,i){const t=await this.getLocalFileContent(),o=await this.getFormattingOptions(),s=this.getSettingsSyncContent(r);a=a===null&&i?r:a;const c=a?this.getSettingsSyncContent(a):null,u=await this.getIgnoredSettings();let p=null,P=!1,_=!1,O=!1;if(s){let $=t?t.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const k=(0,v.merge)($,s.settings,c?c.settings:null,u,[],o);p=k.localContent||k.remoteContent,P=k.localContent!==null,_=k.remoteContent!==null,O=k.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),p=t.value.toString(),_=!0);const F={content:p,localChange:P?2:0,remoteChange:_?2:0,hasConflicts:O};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:s?s.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const i=await this.getLocalFileContent(),t=i?i.value.toString().trim():"",o=await this.getIgnoredSettings(),s=await this.getFormattingOptions();return(0,v.merge)(t||"{}",a.settings,a.settings,o,[],s).remoteContent!==null}async getMergeResult(r,a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,v.updateIgnoredSettings)(r.previewResult.content,"{}",t,i):null}}async getAcceptResult(r,a,i,t){const o=await this.getFormattingOptions(),s=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,v.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",s,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,v.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,v.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",s,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,i,t){const{fileContent:o}=i[0][0];let{content:s,localChange:c,remoteChange:u}=i[0][1];if(c===0&&u===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),s=s?s.trim():"{}",s=s||"{}",this.validateContent(s),c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(s,o,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),u!==0){const p=await this.getFormattingOptions(),P=this.getSettingsSyncContent(r),_=await this.getIgnoredSettings(s);s=(0,v.updateIgnoredSettings)(s,P?P.settings:"{}",_,p),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(s)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),i=(0,h.edit)(r.value.toString(),[d.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,v.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const i=this.parseSyncData(a);if(i){const t=this.parseSettingsSyncContent(i.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const i=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,v.updateIgnoredSettings)(a,"{}",t,i)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:o})=>!!o)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new d.UserDataSyncError((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};m=de([J(0,E.IFileService),J(1,R.IEnvironmentService),J(2,I.IStorageService),J(3,d.IUserDataSyncStoreService),J(4,d.IUserDataSyncBackupStoreService),J(5,d.IUserDataSyncLogService),J(6,d.IUserDataSyncUtilService),J(7,A.IConfigurationService),J(8,d.IUserDataSyncEnablementService),J(9,C.ITelemetryService),J(10,b.IExtensionManagementService),J(11,f.IUriIdentityService)],m),e.SettingsSynchroniser=m;let S=class extends y.AbstractInitializer{constructor(r,a,i,t){super("settings",a,i,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}};S=de([J(0,E.IFileService),J(1,R.IEnvironmentService),J(2,d.IUserDataSyncLogService),J(3,f.IUriIdentityService)],S),e.SettingsInitializer=S}),define(ne[232],ie([0,1,17,3,28,20,15,13,24,21,34,47,225,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends C.AbstractSynchroniser{constructor(g,w,m,S,l,r,a,i,t,o){super("snippets",w,g,m,S,l,i,t,r,a,o);this.version=1,this.snippetsFolder=g.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,s=>s.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,w,m){const S=await this.getSnippetsFileContents(),l=this.toSnippetsContents(S),r=g.syncData?this.parseSnippets(g.syncData):null;w=w===null&&m?g:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,f.merge)(l,r,a);return this.getResourcePreviews(i,S,r||{})}async hasRemoteChanged(g){const w=g.syncData?this.parseSnippets(g.syncData):null;if(w===null)return!0;const m=await this.getSnippetsFileContents(),S=this.toSnippetsContents(m),l=(0,f.merge)(S,w,w);return Object.keys(l.remote.added).length>0||Object.keys(l.remote.updated).length>0||l.remote.removed.length>0||l.conflicts.length>0}async getMergeResult(g,w){return g.previewResult}async getAcceptResult(g,w,m,S){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return m===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:m,localChange:m===null?g.fileContent!==null?3:0:2,remoteChange:m===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(g,w,m,S){const l=m.map(([r,a])=>({...r,acceptResult:a}));l.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),l.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(l),await this.updateLocalSnippets(l,S)),l.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(l,g,S)),w?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of l)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,w,m){const S=new Map;for(const l of Object.keys(g.local.added)){const r={content:g.local.added[l],hasConflicts:!1,localChange:1,remoteChange:0};S.set(l,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.local.updated)){const r={content:g.local.updated[l],hasConflicts:!1,localChange:2,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.added)){const r={content:g.remote.added[l],hasConflicts:!1,localChange:0,remoteChange:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(g.remote.updated)){const r={content:g.remote.updated[l],hasConflicts:!1,localChange:0,remoteChange:2};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l],localContent:w[l].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l],previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of g.conflicts){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!0,localChange:w[l]?2:1,remoteChange:m[l]?2:1};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const l of Object.keys(w))if(!S.has(l)){const r={content:w[l]?w[l].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};S.set(l,{localResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[l]||null,localContent:w[l]?w[l].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:m[l]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,l),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,l).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...S.values()]}async getAssociatedResources({uri:g}){let w=await super.resolveContent(g);if(w){const m=this.parseSyncData(w);if(m){const S=this.parseSnippets(m),l=[];for(const r of Object.keys(S)){const a=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(i);l.push({resource:a,comparableResource:t?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"})})}return l}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:y.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let w=await super.resolveContent(g);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(g)),w){const m=this.parseSyncData(w);if(m)return this.parseSnippets(m)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const w={};for(const m of g)m.fileContent&&(w[this.extUri.basename(m.localResource)]=m.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(g,w){for(const{fileContent:m,acceptResult:S,localResource:l,remoteResource:r,localChange:a}of g)if(a!==0){const i=r?this.extUri.basename(r):this.extUri.basename(l),t=this.extUri.joinPath(this.snippetsFolder,i);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,D.VSBuffer.fromString(S.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,D.VSBuffer.fromString(S.content),w?void 0:m),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(g,w,m){const S=w.syncData?this.parseSnippets(w.syncData):{},l=(0,L.deepClone)(S);for(const{acceptResult:r,localResource:a,remoteResource:i,remoteChange:t}of g)if(t!==0){const o=a?this.extUri.basename(a):this.extUri.basename(i);t===3?delete l[o]:l[o]=r.content}return(0,f.areSame)(S,l)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(l),m?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const w={};for(const m of Object.keys(g))w[m]=g[m].value.toString();return w}async getSnippetsFileContents(){const g={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(m){if(m instanceof R.FileOperationError&&m.fileOperationResult===1)return g;throw m}for(const m of w.children||[]){const S=m.resource,l=this.extUri.extname(S);if(l===".json"||l===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,S),a=await this.fileService.readFile(S);g[r]=a}}return g}};h=de([J(0,T.IEnvironmentService),J(1,R.IFileService),J(2,b.IStorageService),J(3,y.IUserDataSyncStoreService),J(4,y.IUserDataSyncBackupStoreService),J(5,y.IUserDataSyncLogService),J(6,A.IConfigurationService),J(7,y.IUserDataSyncEnablementService),J(8,E.ITelemetryService),J(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let v=class extends C.AbstractInitializer{constructor(g,w,m,S){super("snippets",w,m,g,S)}async doInitialize(g){const w=g.syncData?JSON.parse(g.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const S of Object.keys(w)){const l=w[S];if(l){const r=this.extUri.joinPath(this.environmentService.snippetsHome,S);await this.fileService.createFile(r,D.VSBuffer.fromString(l)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};v=de([J(0,R.IFileService),J(1,T.IEnvironmentService),J(2,y.IUserDataSyncLogService),J(3,I.IUriIdentityService)],v),e.SnippetsInitializer=v}),define(ne[64],ie([0,1,3,2,6,25]),function(Y,e,D,n,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,L.createDecorator)("IUserDataSyncAccountService");let T=class extends n.Disposable{constructor(b,E){super();this.userDataSyncStoreService=b,this.logService=E,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};T=de([J(0,A.IUserDataSyncStoreService),J(1,A.IUserDataSyncLogService)],T),e.UserDataSyncAccountService=T}),define(ne[233],ie([0,1,5,17,57,2,19,20,15,13,25]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let C=class extends A.Disposable{constructor(y,h,v,d){super();this.environmentService=y,this.fileService=h,this.configurationService=v,this.logService=d,I.ALL_SYNC_RESOURCES.forEach(g=>this.cleanUpBackup(g))}async getAllRefs(y){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),v=await this.fileService.resolve(h);return v.children?v.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort().reverse().map(g=>({ref:g.name,created:this.getCreationTime(g)})):[]}async resolveContent(y,h){if(!h){const v=await this.getAllRefs(y);v.length&&(h=v[v.length-1].ref)}if(h){const v=(0,T.joinPath)(this.environmentService.userDataSyncHome,y,h);return(await this.fileService.readFile(v)).value.toString()}return null}async backup(y,h){const v=(0,T.joinPath)(this.environmentService.userDataSyncHome,y),d=(0,T.joinPath)(v,`${(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(d,n.VSBuffer.fromString(h))}catch(g){this.logService.error(g)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const h=(0,T.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(h))return}catch{return}const v=await this.fileService.resolve(h);if(v.children){const d=v.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),g=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=d.filter(S=>Date.now()-this.getCreationTime(S)>g);const m=d.length-w.length;m<10&&(w=w.slice(10-m)),await D.Promises.settled(w.map(async S=>{this.logService.info("Deleting from backup",S.resource.path),await this.fileService.del(S.resource)}))}}catch(v){this.logService.error(v)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};C=de([J(0,b.IEnvironmentService),J(1,E.IFileService),J(2,R.IConfigurationService),J(3,I.IUserDataSyncLogService)],C),e.UserDataSyncBackupStoreService=C}),define(ne[234],ie([0,1,3,2,4,15,24,21,25]),function(Y,e,D,n,L,A,T,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const E="sync.enable";let I=class extends n.Disposable{constructor(f,y,h,v){super();this.storageService=f,this.telemetryService=y,this.environmentService=h,this.userDataSyncStoreManagementService=v,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(d=>this.onDidStorageChange(d)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(E,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(E,{enabled:f}),this.storageService.store(E,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,y){if(this.isResourceEnabled(f)!==y){const h=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(h,{enabled:y}),this.storeResourceEnablement(h,y)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,y){this.storageService.store(f,y,0,L.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(E===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=b.ALL_SYNC_RESOURCES.filter(h=>(0,b.getEnablementKey)(h)===f.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};I=de([J(0,T.IStorageService),J(1,R.ITelemetryService),J(2,A.IEnvironmentService),J(3,b.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(ne[235],ie([0,1,2,7]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(f){this.service=f}listen(f,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class A{constructor(f){this.service=f}listen(f,y){throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class T{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=T;class R{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(f,y,h){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class E{constructor(f){this.service=f}listen(f,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(f,y,h){switch(y){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=E;class I extends D.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:n.URI.revive(f.url),type:f.type,defaultUrl:n.URI.revive(f.defaultUrl),insidersUrl:n.URI.revive(f.insidersUrl),stableUrl:n.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(ne[236],ie([0,1,15,8]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends n.AbstractLogger{constructor(T,R){super();this.logger=this._register(T.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(T,...R){this.logger.trace(T,...R)}debug(T,...R){this.logger.debug(T,...R)}info(T,...R){this.logger.info(T,...R)}warn(T,...R){this.logger.warn(T,...R)}error(T,...R){this.logger.error(T,...R)}critical(T,...R){this.logger.critical(T,...R)}flush(){this.logger.flush()}};L=de([J(0,n.ILoggerService),J(1,D.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(ne[65],ie([0,1,3,2,4,26,148,15,13,6,27,46,24,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,E.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let v=class Ze extends n.Disposable{constructor(g,w,m,S,l,r){super();this.storageService=m,this.userDataSyncStoreService=S,this.logService=l,this.productService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,C.getServiceMachineId)(g,w,m)}async getMachines(g){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(g)).machines.map(S=>({...S,isCurrent:S.id===w}))}async addCurrentMachine(g){const w=await this.currentMachineIdPromise,m=await this.readMachinesData(g);m.machines.some(({id:S})=>S===w)||(m.machines.push({id:w,name:this.computeCurrentMachineName(m.machines)}),await this.writeMachinesData(m))}async removeCurrentMachine(g){const w=await this.currentMachineIdPromise,m=await this.readMachinesData(g),S=m.machines.filter(({id:l})=>l!==w);S.length!==m.machines.length&&(m.machines=S,await this.writeMachinesData(m))}async renameMachine(g,w,m){const S=await this.currentMachineIdPromise,l=await this.readMachinesData(m),r=l.machines.find(({id:a})=>a===g);r&&(r.name=w,await this.writeMachinesData(l),l.machines.some(({id:a})=>a===S)&&this.storageService.store(h,w,0,1))}async setEnablement(g,w){const m=await this.readMachinesData(),S=m.machines.find(({id:l})=>l===g);S&&(S.disabled=w?void 0:!0,await this.writeMachinesData(m))}computeCurrentMachineName(g){const w=this.storageService.get(h,0);if(w)return w;const m=`${this.productService.nameLong} (${(0,L.PlatformToString)(L.isWeb?0:L.platform)})`,S=new RegExp(`${(0,A.escapeRegExpCharacters)(m)}\\s#(\\d+)`);let l=0;for(const r of g){const a=S.exec(r.name),i=a?parseInt(a[1]):0;l=i>l?i:l}return`${m} #${l+1}`}async readMachinesData(g){this.userData=await this.readUserData(g);const w=this.parse(this.userData);if(w.version!==Ze.VERSION)throw new Error((0,T.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(g){const w=JSON.stringify(g),m=await this.userDataSyncStoreService.write(Ze.RESOURCE,w,this.userData?.ref||null);this.userData={ref:m,content:w},this._onDidChange.fire()}async readUserData(g){if(this.userData){const w=g&&g.latest?g.latest[Ze.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ze.RESOURCE,this.userData)}parse(g){if(g.content!==null)try{return JSON.parse(g.content)}catch(w){this.logService.error(w)}return{version:Ze.VERSION,machines:[]}}};v.VERSION=1,v.RESOURCE="machines",v=de([J(0,R.IEnvironmentService),J(1,b.IFileService),J(2,f.IStorageService),J(3,y.IUserDataSyncStoreService),J(4,y.IUserDataSyncLogService),J(5,I.IProductService)],v),e.UserDataSyncMachinesService=v}),define(ne[237],ie([0,1,5,57,37,9,3,2,4,19,7,146,27,24,21,25,64,65]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",m="sync.sessionId",S="sync.storeUrl",l="sync.productQuality";let r=class extends R.Disposable{constructor(t,o,s,c,u,p,P,_,O,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=s,this.userDataSyncEnablementService=c,this.userDataSyncService=u,this.logService=p,this.userDataSyncAccountService=P,this.telemetryService=_,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new T.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,E.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(P.onDidChangeAccount(()=>this.updateAutoSync())),this._register(s.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(T.Event.debounce(u.onDidChangeLocal,($,k)=>$?[...$,k]:[k],1e3)($=>this.triggerSync($,!1,!1))),this._register(T.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(S,0);return t?I.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(S,t.toString(),0,1):this.storageService.remove(S,0)}get productQuality(){return this.storageService.get(l,0)}set productQuality(t){t?this.storageService.store(l,t,0,1):this.storageService.remove(l,0)}updateAutoSync(){const{enabled:t,message:o}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(s=>this.onDidFinishSync(s))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,o,s){try{this.userDataSyncAccountService.account&&!s&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(m,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(o)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const o=v.UserDataSyncError.toUserDataSyncError(t);o instanceof v.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"||o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?b.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,o,s){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",s)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([J(0,f.IProductService),J(1,v.IUserDataSyncStoreManagementService),J(2,v.IUserDataSyncStoreService),J(3,v.IUserDataSyncEnablementService),J(4,v.IUserDataSyncService),J(5,v.IUserDataSyncLogService),J(6,d.IUserDataSyncAccountService),J(7,h.ITelemetryService),J(8,g.IUserDataSyncMachinesService),J(9,y.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,o,s,c,u,p,P,_){super();this.lastSyncUrl=t,this.interval=o,this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=c,this.userDataSyncService=u,this.userDataSyncMachinesService=p,this.logService=P,this.storageService=_,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new T.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new T.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,o){const s=(0,D.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(u){if((0,A.isCancellationError)(u))return}return this.doSync(t,o,c)});return this.syncPromise=s,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,E.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!t&&(!(0,E.isEqual)(o.defaultUrl,t.defaultUrl)||!(0,E.isEqual)(o.insidersUrl,t.insidersUrl)||!(0,E.isEqual)(o.stableUrl,t.stableUrl))}async doSync(t,o,s){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),s.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(0,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(1,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(2,null),"TurnedOff");const u=this.storageService.get(m,0);if(u&&this.manifest&&u!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new v.UserDataAutoSyncError((0,C.localize)(3,null),"DefaultServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(4,null),"ServiceChanged"):new v.UserDataAutoSyncError((0,C.localize)(5,null),"SessionExpired");const p=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(s.isCancellationRequested)return;const P=p.find(_=>_.isCurrent);if(P?.disabled)throw new v.UserDataAutoSyncError((0,C.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(_){throw new v.UserDataAutoSyncError((0,L.toErrorMessage)(_),_ instanceof v.UserDataSyncError?_.code:"Unknown")}if(this.manifest&&this.manifest.session!==u&&this.storageService.store(m,this.manifest.session,0,1),s.isCancellationRequested)return;P||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(u){this.logService.error(u),c=u}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ne[238],ie([0,1,16,5,37,3,2,19,14,29,20,30,6,24,21,226,228,229,231,232,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const l="sync.lastSyncTime";let r=class extends T.Disposable{constructor(s,c,u,p,P,_,O,F){super();this.userDataSyncStoreService=s,this.userDataSyncStoreManagementService=c,this.instantiationService=u,this.configurationService=p,this.logService=P,this.telemetryService=_,this.storageService=O,this.userDataSyncEnablementService=F,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new T.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(l,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(s,c){this.checkEnablement();const u=(0,E.generateUuid)();try{const F=(0,S.createSyncHeaders)(u);c&&(F["Cache-Control"]="no-cache"),s=await this.userDataSyncStoreService.manifest(s,F)}catch(F){const $=S.UserDataSyncError.toUserDataSyncError(F);throw this.reportUserDataSyncError($,u),$}let p=!1;const P=this,_=this.getEnabledSynchronizers();let O;return{manifest:s,async run(){if(p)throw new Error("Can run a task only once");return O=(0,n.createCancelablePromise)(F=>P.sync(_,s,u,F)),O.finally(()=>O=void 0)},async stop(){if(O&&O.cancel(),P.status!=="idle")return P.stop(_)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new S.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const s=(0,E.generateUuid)(),c=(0,S.createSyncHeaders)(s);let u;try{u=await this.userDataSyncStoreService.manifest(null,c)}catch(P){const _=S.UserDataSyncError.toUserDataSyncError(P);throw this.reportUserDataSyncError(_,s),_}await this.resetLocal();const p=this.getEnabledSynchronizers();return new a(s,u,c,p,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(s,c,u,p){if(p.isCancellationRequested||!s.length)return;const P=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const _=(0,S.createSyncHeaders)(u);for(const O of s){if(p.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(O.resource))return;try{await O.sync(c,_)}catch(F){let $=!1;if(F instanceof S.UserDataSyncError)switch(F.code){case"TooLarge":F=new S.UserDataSyncError(F.message,F.code,O.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const k=S.UserDataSyncError.toUserDataSyncError(F);if(this.reportUserDataSyncError(k,u),$)throw k;this.logService.error(F),this.logService.error(`${O.resource}: ${(0,L.toErrorMessage)(F)}`),this._syncErrors.push([O.resource,k])}}this.logService.info(`Sync done. Took ${new Date().getTime()-P}ms`),this.updateLastSyncTime()}catch(_){const O=S.UserDataSyncError.toUserDataSyncError(_);throw this.reportUserDataSyncError(O,u),O}finally{this.updateStatus(s),this._onSyncErrors.fire(this._syncErrors)}}async stop(s){if(this.status!=="idle")for(const c of s)try{c.status!=="idle"&&await c.stop()}catch(u){this.logService.error(u)}}async replace(s){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(s))return!0})}async accept(s,c,u,p){this.checkEnablement(),await this.performSynchronizerAction(async P=>{if(P.resource===s)return await P.accept(c,u),p&&await P.apply(!1,(0,S.createSyncHeaders)((0,E.generateUuid)())),!0})}async resolveContent(s){return this.performSynchronizerAction(async c=>{const u=await c.resolveContent(s);if(u)return u})}async getRemoteSyncResourceHandles(s){return await this.performSynchronizerAction(async u=>{if(u.resource===s)return u.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(s){return await this.performSynchronizerAction(async u=>{if(u.resource===s)return u.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(s,c){return await this.performSynchronizerAction(async p=>{if(p.resource===s)return p.getAssociatedResources(c)})||[]}async getMachineId(s,c){return await this.performSynchronizerAction(async p=>{if(p.resource===s)return await p.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(s){this.logService.error(s)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(l,0),this.synchronizers.value){for(const s of this.synchronizers.value.enabled)try{await s.resetLocal()}catch(c){this.logService.error(`${s.resource}: ${(0,L.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(s){const c=new T.DisposableStore;try{const u=this.synchronizers.value||c.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),p=[...u.enabled,...u.disabled.map(P=>c.add(u.createSynchronizer(P)))];for(const P of p){const _=await s(P);if(!(0,b.isUndefined)(_))return _}return null}finally{c.dispose()}}setStatus(s){const c=this._status;this._status!==s&&(this._status=s,this._onDidChangeStatus.fire(s),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(s){this.updateConflicts(s);const c=this.computeStatus(s);this.setStatus(c)}updateConflicts(s){const c=this.computeConflicts(s);(0,D.equals)(this._conflicts,c,([u,p],[P,_])=>u===u&&(0,D.equals)(p,_,(O,F)=>(0,R.isEqual)(O.previewResource,F.previewResource)))||(this._conflicts=this.computeConflicts(s),this._onDidChangeConflicts.fire(c))}computeConflicts(s){return s.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(s){return this.userDataSyncStoreManagementService.userDataSyncStore?s.some(c=>c.status==="hasConflicts")?"hasConflicts":s.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(l,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(s,c){this.telemetryService.publicLog2("sync/error",{code:s.code,serverCode:s instanceof S.UserDataSyncStoreError?String(s.serverCode):void 0,url:s instanceof S.UserDataSyncStoreError?s.url:void 0,resource:s.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,s=>this.updateStatus(s),s=>this.updateConflicts(s),s=>this._onDidChangeLocal.fire(s))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([J(0,S.IUserDataSyncStoreService),J(1,S.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,I.IConfigurationService),J(4,S.IUserDataSyncLogService),J(5,h.ITelemetryService),J(6,y.IStorageService),J(7,S.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends T.Disposable{constructor(s,c,u,p,P,_,O){super();this.id=s,this.manifest=c,this.syncHeaders=u,this.synchronisers=p,this.onStop=P,this.configurationService=_,this.logService=O,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(s=>s.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(s=>s.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(s=>this.getPreviews(s))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(s){throw this.logService.error(s),s}}async accept(s,c){try{return await this.performAction(s,u=>u.accept(s,c))}catch(u){throw this.logService.error(u),u}}async merge(s){try{return s?await this.performAction(s,c=>c.merge(s)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(s){try{return await this.performAction(s,c=>c.discard(s))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const s=[];for(const[,c]of this.previews)for(const u of c.resourcePreviews)u.mergeState==="conflict"&&s.push(u.previewResource);for(const c of s)await this.discard(c);return this.previews}catch(s){throw this.logService.error(s),s}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const s=[];for(const[c,u]of this.previews){this.synchronizingResources.push([c,u.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const p=this.synchronisers.find(_=>_.resource===c);for(const _ of u.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&await p.merge(_.previewResource);const P=await p.apply(!1,this.syncHeaders);P&&s.push(this.toSyncResourcePreview(p.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}catch(s){throw this.logService.error(s),s}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===s);for(const p of c.resourcePreviews)await u.accept(p.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[s,c]of this.previews){this.synchronizingResources.push([s,c.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(p=>p.resource===s);for(const p of c.resourcePreviews)await u.accept(p.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===s),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(s){throw this.logService.error(s),s}}async stop(){await this.onStop(),this.reset()}async performAction(s,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:j,previewResource:U,remoteResource:G})=>(0,R.isEqual)(s,j)||(0,R.isEqual)(s,U)||(0,R.isEqual)(s,G)));if(u===-1)return this.previews;const[p,P]=this.previews[u],_=P.resourcePreviews.find(({localResource:M,remoteResource:j,previewResource:U})=>(0,R.isEqual)(M,s)||(0,R.isEqual)(j,s)||(0,R.isEqual)(U,s));if(!_)return this.previews;let O=this.synchronizingResources.find(M=>M[0]===p);O||(O=[p,[]],this.synchronizingResources.push(O)),O[1].some(M=>(0,R.isEqual)(M,_.localResource))||(O[1].push(_.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const F=this.synchronisers.find(M=>M.resource===this.previews[u][0]),$=await c(F);$?this.previews.splice(u,1,this.toSyncResourcePreview(F.resource,$)):this.previews.splice(u,1);const k=this.synchronizingResources.findIndex(M=>M[0]===p);return this.synchronizingResources[k][1].splice(O[1].findIndex(M=>(0,R.isEqual)(M,_.localResource)),1),O[1].length||(this.synchronizingResources.splice(k,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const s=[];for(const[c,u]of this.previews){this.synchronizingResources.push([c,u.resourcePreviews.map(_=>_.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const p=this.synchronisers.find(_=>_.resource===c);let P=u;for(const _ of u.resourcePreviews)(_.localChange!==0||_.remoteChange!==0)&&_.mergeState==="preview"&&(P=await p.merge(_.previewResource));P&&s.push(this.toSyncResourcePreview(p.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(_=>_[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=s,this.previews}async getPreviews(s){const c=[],u=await this.getUserDataSyncConfiguration();for(const p of this.synchronisers){if(s.isCancellationRequested)return[];const P=await p.preview(this.manifest,u,this.syncHeaders);P&&c.push(this.toSyncResourcePreview(p.resource,P))}return c}async getUserDataSyncConfiguration(){const s=this.configurationService.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(u=>u instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...s,...c}}toSyncResourcePreview(s,c){return[s,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends T.Disposable{constructor(s,c,u,p,P,_,O){super();this.onDidChangeStatus=s,this.onDidChangeConflicts=c,this.onDidChangeLocal=u,this.userDataSyncEnablementService=p,this.instantiationService=P,this.extensionGalleryService=_,this.logService=O,this._enabled=[],this._register(p.onDidChangeResourceEnablement(([F,$])=>this.onDidChangeResourceEnablement(F,$))),this._register((0,T.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,F])=>F.dispose())));for(const F of S.ALL_SYNC_RESOURCES)p.isResourceEnabled(F)&&this.registerSynchronizer(F)}get enabled(){return this._enabled.sort((s,c)=>s[1]-c[1]).map(([s])=>s)}get disabled(){return S.ALL_SYNC_RESOURCES.filter(s=>!this.userDataSyncEnablementService.isResourceEnabled(s))}onDidChangeResourceEnablement(s,c){c?this.registerSynchronizer(s):this.deRegisterSynchronizer(s)}registerSynchronizer(s){if(this._enabled.some(([P])=>P.resource===s))return;if(s==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new T.DisposableStore,u=c.add(this.createSynchronizer(s));c.add(u.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(u.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(u.onDidChangeLocal(()=>this.onDidChangeLocal(s)));const p=this.getOrder(s);this._enabled.push([u,p,c])}deRegisterSynchronizer(s){const c=this._enabled.findIndex(([u])=>u.resource===s);if(c!==-1){const u=this._enabled.splice(c,1);for(const[p,,P]of u){if(p.status!=="idle"){const _=p.conflicts.length>0;p.stop(),_&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}P.dispose()}}}createSynchronizer(s){switch(s){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(g.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(m.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(d.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(v.ExtensionsSynchroniser)}}getOrder(s){switch(s){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};i=de([J(3,S.IUserDataSyncEnablementService),J(4,f.IInstantiationService),J(5,C.IExtensionGalleryService),J(6,S.IUserDataSyncLogService)],i);function t(o){return{localResource:o.localResource,previewResource:o.previewResource,remoteResource:o.remoteResource,acceptedResource:o.acceptedResource,localChange:o.localChange,remoteChange:o.remoteChange,mergeState:o.mergeState}}}),define(ne[239],ie([0,1,3,2,14,7,25]),function(Y,e,D,n,L,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(C,f){this.service=C,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(C,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(C,f,y){try{return await this._call(C,f,y)}catch(h){throw this.logService.error(h),h}}async _call(C,f,y){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(A.URI.revive(y[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(y[0],A.URI.revive(y[1]),y[2],y[3]);case"resolveContent":return this.service.resolveContent(A.URI.revive(y[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(y[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(y[0]);case"getAssociatedResources":return this.service.getAssociatedResources(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"getMachineId":return this.service.getMachineId(y[0],{created:y[1].created,uri:A.URI.revive(y[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),v=y[0],d=this.getManualSyncTask(v);switch(y=y.slice(1),h){case"preview":return d.preview();case"accept":return d.accept(A.URI.revive(y[0]),y[1]);case"merge":return d.merge(A.URI.revive(y[0]));case"discard":return d.discard(A.URI.revive(y[0]));case"discardConflicts":return d.discardConflicts();case"apply":return d.apply();case"pull":return d.pull();case"push":return d.push();case"stop":return d.stop();case"_getStatus":return d.status;case"dispose":return this.disposeManualSyncTask(d)}}throw new Error("Invalid call")}getManualSyncTask(C){const f=this.manualSyncTasks.get(this.createKey(C));if(!f)throw new Error(`Manual sync taks not found: ${C}`);return f.manualSyncTask}async createManualSyncTask(){const C=new n.DisposableStore,f=C.add(await this.service.createManualSyncTask());return C.add(f.onSynchronizeResources(y=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:y}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:C}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(C){C.dispose();const f=this.createKey(C.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(C){return`manualSyncTask-${C}`}}e.UserDataSyncChannel=R;class b extends n.Disposable{constructor(C){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,y,h){return C.call(f,y,h).then(null,v=>{throw T.UserDataSyncError.toUserDataSyncError(v)})},listen(f,y){return C.listen(f,y)}},this.channel.call("_getInitialData").then(([f,y,h])=>{this.updateStatus(f),this.updateConflicts(y),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(v=>this.updateStatus(v))),this._register(this.channel.listen("onDidChangeLastSyncTime")(v=>this.updateLastSyncTime(v)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([y,h])=>[y,T.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:C,manifest:f,status:y}=await this.channel.call("createManualSyncTask"),h=this,v=new E(C,f,y,{async call(d,g,w){return h.channel.call(`manualSync/${d}`,[C,...(0,L.isArray)(g)?g:[g]],w)},listen(d,g){return D.Event.map(D.Event.filter(h.channel.listen(`manualSync/${d}`,g),w=>!v.isDiposed()&&w.manualSyncTaskId===C),w=>w.data)}});return v}replace(C){return this.channel.call("replace",[C])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(C,f,y,h){return this.channel.call("accept",[C,f,y,h])}resolveContent(C){return this.channel.call("resolveContent",[C])}async getLocalSyncResourceHandles(C){return(await this.channel.call("getLocalSyncResourceHandles",[C])).map(({created:y,uri:h})=>({created:y,uri:A.URI.revive(h)}))}async getRemoteSyncResourceHandles(C){return(await this.channel.call("getRemoteSyncResourceHandles",[C])).map(({created:y,uri:h})=>({created:y,uri:A.URI.revive(h)}))}async getAssociatedResources(C,f){return(await this.channel.call("getAssociatedResources",[C,f])).map(({resource:h,comparableResource:v})=>({resource:A.URI.revive(h),comparableResource:A.URI.revive(v)}))}async getMachineId(C,f){return this.channel.call("getMachineId",[C,f])}async updateStatus(C){this._status=C,this._onDidChangeStatus.fire(C)}async updateConflicts(C){this._conflicts=C.map(([f,y])=>[f,y.map(h=>({...h,localResource:A.URI.revive(h.localResource),remoteResource:A.URI.revive(h.remoteResource),previewResource:A.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(C){this._lastSyncTime!==C&&(this._lastSyncTime=C,this._onDidChangeLastSyncTime.fire(C))}}e.UserDataSyncChannelClient=b;class E extends n.Disposable{constructor(C,f,y,h){super();this.id=C,this.manifest=f,this._disposed=!1,this._status=y;const v=this;this.channel={async call(d,g,w){try{const m=await h.call(d,g,w);return v.isDiposed()||(v._status=await h.call("_getStatus")),m}catch(m){throw T.UserDataSyncError.toUserDataSyncError(m)}},listen(d,g){return h.listen(d,g)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const C=await this.channel.call("preview");return this.deserializePreviews(C)}async accept(C,f){const y=await this.channel.call("accept",[C,f]);return this.deserializePreviews(y)}async merge(C){const f=await this.channel.call("merge",[C]);return this.deserializePreviews(f)}async discard(C){const f=await this.channel.call("discard",[C]);return this.deserializePreviews(f)}async discardConflicts(){const C=await this.channel.call("discardConflicts");return this.deserializePreviews(C)}async apply(){const C=await this.channel.call("apply");return this.deserializePreviews(C)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(C){return C.map(([f,y])=>[f,{isLastSyncFromCurrentMachine:y.isLastSyncFromCurrentMachine,resourcePreviews:y.resourcePreviews.map(h=>({...h,localResource:A.URI.revive(h.localResource),remoteResource:A.URI.revive(h.remoteResource),previewResource:A.URI.revive(h.previewResource),acceptedResource:A.URI.revive(h.acceptedResource)}))}])}}}),define(ne[240],ie([0,1,5,23,9,3,2,102,4,19,14,7,29,20,15,13,27,43,46,24,25]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const l="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",i="sync.machine-session-id",t=100,o=1e3*60*5;let s=class extends T.Disposable{constructor(O,F,$){super();this.productService=O,this.configurationService=F,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new A.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(A.Event.filter($.onDidChangeValue,k=>k.key===S.SYNC_SERVICE_URL_TYPE&&k.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(S.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(O){this.storageService.store(S.SYNC_SERVICE_URL_TYPE,O,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[S.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=b.isWeb&&O?.web?{...O,...O.web}:O;const $={...O||{},...F||{}};if($&&(0,I.isString)($.url)&&(0,I.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(k=>(0,I.isArray)($.authenticationProviders[k].scopes))){const k=$,M=!!k.canSwitch&&!F?.url,j=k.url===k.insidersUrl?"insiders":"stable",U=(M?this.userDataSyncStoreType:void 0)||j,G=F?.url||(U==="insiders"?k.insidersUrl:U==="stable"?k.stableUrl:k.url);return{url:C.URI.parse(G),type:U,defaultType:j,defaultUrl:C.URI.parse(k.url),stableUrl:C.URI.parse(k.stableUrl),insidersUrl:C.URI.parse(k.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(k.authenticationProviders).reduce((K,x)=>(K.push({id:x,scopes:k.authenticationProviders[x].scopes}),K),[])}}}};s=de([J(0,d.IProductService),J(1,y.IConfigurationService),J(2,m.IStorageService)],s),e.AbstractUserDataSyncStoreManagementService=s;let c=class extends s{constructor(O,F,$){super(O,F,$);const k=this.storageService.get(l,0);k&&(this.previousConfigurationSyncStore=JSON.parse(k));const M=this.productService[S.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(l,JSON.stringify(M),0,1):this.storageService.remove(l,0)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([J(0,d.IProductService),J(1,y.IConfigurationService),J(2,m.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let u=class extends T.Disposable{constructor(O,F,$,k,M,j,U){super();this.requestService=$,this.logService=k,this.storageService=U,this._onTokenFailed=this._register(new A.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new A.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new A.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,w.getServiceMachineId)(M,j,U).then(G=>{const K={"X-Client-Name":`${F.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(K["X-Client-Commit"]=F.commit),K}),this.session=new P(t,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,T.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,E.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(r,0);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O),$={},k=await this.request(F.toString(),{type:"GET",headers:$},[],n.CancellationToken.None);return(await(0,g.asJson)(k)||[]).map(({url:j,created:U})=>({ref:(0,E.relativePath)(F,F.with({path:j})),created:U*1e3}))}async resolveContent(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString(),k={};k["Cache-Control"]="no-cache";const M=await this.request($,{type:"GET",headers:k},[],n.CancellationToken.None);return await(0,g.asText)(M)}async delete(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),$={};await this.request(F,{type:"DELETE",headers:$},[],n.CancellationToken.None)}async read(O,F,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();$={...$},$["Cache-Control"]="no-cache",F&&($["If-None-Match"]=F.ref);const M=await this.request(k,{type:"GET",headers:$},[304],n.CancellationToken.None);let j=null;if(M.res.statusCode===304&&(j=F),j===null){const U=M.res.headers.etag;if(!U)throw new S.UserDataSyncStoreError("Server did not return the ref",k,"NoRef",M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(M);if(!G&&M.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",k,"EmptyResponse",M.res.statusCode,M.res.headers[S.HEADER_OPERATION_ID]);j={ref:U,content:G}}return j}async write(O,F,$,k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();k={...k},k["Content-Type"]=R.Mimes.text,$&&(k["If-Match"]=$);const j=await this.request(M,{type:"POST",data:F,headers:k},[],n.CancellationToken.None),U=j.res.headers.etag;if(!U)throw new S.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",j.res.statusCode,j.res.headers[S.HEADER_OPERATION_ID]);return U}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,E.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const k=await this.request($,{type:"GET",headers:F},[304],n.CancellationToken.None);let M=null;if(k.res.statusCode===304&&(M=O),!M){const U=k.res.headers.etag;if(!U)throw new S.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",k.res.statusCode,k.res.headers[S.HEADER_OPERATION_ID]);const G=await(0,g.asText)(k);if(!G&&k.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",$,"EmptyResponse",k.res.statusCode,k.res.headers[S.HEADER_OPERATION_ID]);G&&(M={...JSON.parse(G),ref:U})}const j=this.storageService.get(a,0);return j&&M&&j!==M.session&&this.clearSession(),M===null&&j&&this.clearSession(),M&&this.storageService.store(a,M.session,0,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,E.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":R.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(i,0)}async request(O,F,$,k){if(!this.authToken)throw new S.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;F.headers={...F.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let j;try{j=await this.session.request(O,F,k)}catch(x){if(!(x instanceof S.UserDataSyncStoreError)){let q="RequestFailed";const X=(0,L.getErrorMessage)(x).toLowerCase();X.includes("xhr timeout")?q="RequestTimeout":X.includes("protocol")&&X.includes("not supported")?q="RequestProtocolNotSupported":X.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":X.includes("headers must be an object")?q="RequestHeadersNotObject":(0,L.isCancellationError)(x)&&(q="RequestCanceled"),x=new S.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,q,void 0,void 0)}throw this.logService.info("Request failed",O),x}const U=j.res.headers[S.HEADER_OPERATION_ID],G={url:O,status:j.res.statusCode,"execution-id":F.headers[S.HEADER_EXECUTION_ID],"operation-id":U},K=(0,g.isSuccess)(j)||j.res.statusCode&&$.indexOf(j.res.statusCode)!==-1;if(K?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),j.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new S.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",j.res.statusCode,U);if(this._onTokenSucceed.fire(),j.res.statusCode===409)throw new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",j.res.statusCode,U);if(j.res.statusCode===410)throw new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",j.res.statusCode,U);if(j.res.statusCode===412)throw new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",j.res.statusCode,U);if(j.res.statusCode===413)throw new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",j.res.statusCode,U);if(j.res.statusCode===426)throw new S.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",j.res.statusCode,U);if(j.res.statusCode===429){const x=j.res.headers["retry-after"];throw x?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(x)*1e3)),new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",j.res.statusCode,U)):new S.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",j.res.statusCode,U)}if(!K)throw new S.UserDataSyncStoreError("Server returned "+j.res.statusCode,O,"Unknown",j.res.statusCode,U);return j}addSessionHeaders(O){let F=this.storageService.get(i,0);F===void 0&&(F=(0,f.generateUuid)(),this.storageService.store(i,F,0,1)),O["X-Machine-Session-Id"]=F;const $=this.storageService.get(a,0);$!==void 0&&(O["X-User-Session-Id"]=$)}};u=de([J(1,d.IProductService),J(2,g.IRequestService),J(3,S.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,v.IFileService),J(6,m.IStorageService)],u),e.UserDataSyncStoreClient=u;let p=class extends u{constructor(O,F,$,k,M,j,U){super(O.userDataSyncStore?.url,F,$,k,M,j,U);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};p=de([J(0,S.IUserDataSyncStoreManagementService),J(1,d.IProductService),J(2,g.IRequestService),J(3,S.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,v.IFileService),J(6,m.IStorageService)],p),e.UserDataSyncStoreService=p;class P{constructor(O,F,$,k){this.limit=O,this.interval=F,this.requestService=$,this.logService=k,this.requests=[],this.startTime=void 0}request(O,F,$){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new S.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(ne[241],ie([0,1,3,60,27,24,21,237,25,64,65]),function(Y,e,D,n,L,A,T,R,b,E,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let C=class extends R.UserDataAutoSyncService{constructor(y,h,v,d,g,w,m,S,l,r,a){super(y,h,v,d,g,m,S,l,r,a);this._register(D.Event.debounce(D.Event.any(D.Event.map(w.onDidFocusWindow,()=>"windowFocus"),D.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(i,t)=>i?[...i,t]:[t],1e3)(i=>this.triggerSync(i,!0,!1)))}};C=de([J(0,L.IProductService),J(1,b.IUserDataSyncStoreManagementService),J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncEnablementService),J(4,b.IUserDataSyncService),J(5,n.INativeHostService),J(6,b.IUserDataSyncLogService),J(7,E.IUserDataSyncAccountService),J(8,T.ITelemetryService),J(9,I.IUserDataSyncMachinesService),J(10,A.IStorageService)],C),e.UserDataAutoSyncService=C}),define(ne[242],ie([0,1,5,3,2]),function(Y,e,D,n,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends L.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:E}){super();this.disposables=this._register(new L.DisposableStore),n.Event.latch(n.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>E()),(async()=>{try{const C=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:C}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(ne[66],ie([0,1,50,5,10,14,22,124,255,256]),function(Y,e,D,n,L,A,T,R,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,a){let i=a.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=r,this.cause=a}}e.ExtractError=I;function C(l){const r=l.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,i)=>a+i,r&61440)}function f(l){if(l instanceof I)return l;let r;return/end of central directory record signature not found/.test(l.message)&&(r="CorruptZip"),new I(r,l)}function y(l,r,a,i,t,o){const s=L.dirname(r),c=L.join(i,s);if(!c.startsWith(i))return Promise.reject(new Error(R.localize(0,null,r)));const u=L.join(i,r);let p;return o.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(T.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((P,_)=>{if(!o.isCancellationRequested)try{p=(0,D.createWriteStream)(u,{mode:a}),p.once("close",()=>P()),p.once("error",_),l.once("error",_),l.pipe(p)}catch(O){_(O)}}))}function h(l,r,a,i){let t=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{t.cancel(),l.close()}),new Promise((s,c)=>{const u=new n.Sequencer,p=P=>{P.isCancellationRequested||(o++,l.readEntry())};l.once("error",c),l.once("close",()=>t.then(()=>{i.isCancellationRequested||l.entryCount===o?s():c(new I("Incomplete",new Error(R.localize(1,null,o,l.entryCount))))},c)),l.readEntry(),l.on("entry",P=>{if(i.isCancellationRequested)return;if(!a.sourcePathRegex.test(P.fileName)){p(i);return}const _=P.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(_)){const $=L.join(r,_);t=(0,n.createCancelablePromise)(k=>T.Promises.mkdir($,{recursive:!0}).then(()=>p(k)).then(void 0,c));return}const O=d(l,P),F=C(P);t=(0,n.createCancelablePromise)($=>u.queue(()=>O.then(k=>y(k,_,F,r,a,$).then(()=>p($)))).then(null,c))})})}function v(l,r=!1){return new Promise((a,i)=>{(0,b.open)(l,r?{lazyEntries:!0}:void 0,(t,o)=>{t?i(f(t)):a((0,A.assertIsDefined)(o))})})}function d(l,r){return new Promise((a,i)=>{l.openReadStream(r,(t,o)=>{t?i(f(t)):a((0,A.assertIsDefined)(o))})})}function g(l,r){return new Promise((a,i)=>{const t=new E.ZipFile;r.forEach(s=>{s.contents?t.addBuffer(typeof s.contents=="string"?Buffer.from(s.contents,"utf8"):s.contents,s.path):s.localPath&&t.addFile(s.localPath,s.path)}),t.end();const o=(0,D.createWriteStream)(l);t.outputStream.pipe(o),t.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>a(l))})}e.zip=g;function w(l,r,a={},i){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let o=v(l,!0);return a.overwrite&&(o=o.then(s=>T.Promises.rm(r).then(()=>s))),o.then(s=>h(s,r,{sourcePathRegex:t},i))}e.extract=w;function m(l,r){return v(l).then(a=>new Promise((i,t)=>{a.on("entry",o=>{o.fileName===r&&d(a,o).then(s=>i(s),s=>t(s))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function S(l,r){return m(l,r).then(a=>new Promise((i,t)=>{const o=[];a.once("error",t),a.on("data",s=>o.push(s)),a.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=S}),define(ne[243],ie([0,1,66,133]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(A){return(0,D.buffer)(A,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=L}),define(ne[244],ie([0,1,16,5,9,2,18,10,4,19,61,7,29,22,66,134,15,30,31,154,13,8,27]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends A.Disposable{constructor(t,o,s,c,u){super();this.beforeRemovingExtension=t,this.fileService=o,this.logService=s,this.environmentService=c,this.productService=u,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const o=[];(t===null||t===0)&&o.push(this.scanSystemExtensions().then(null,s=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(s).message,g.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&o.push(this.scanUserExtensions(!0).then(null,s=>Promise.reject(new g.ExtensionManagementError(this.joinErrors(s).message,g.ExtensionManagementErrorCode.Internal))));try{const s=await Promise.all(o);return(0,D.flatten)(s)}catch(s){throw this.joinErrors(s)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[o,s]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return s=s.filter(c=>!o[new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(s=(0,w.groupByExtension)(s,u=>u.identifier).map(u=>u.sort((p,P)=>I.rcompare(p.manifest.version,P.manifest.version))[0])),this.logService.trace("Scanned user extensions:",s.length),s}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,o,s,c){const u=t.key(),p=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),P=R.join(this.extensionsPath,u);try{await y.Promises.rm(P)}catch{try{await y.Promises.rm(P)}catch{}throw new g.ExtensionManagementError((0,v.localize)(0,null,P,t.id),g.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,o,p,c);let _=await this.scanExtension(C.URI.file(p),1);if(!_)throw new Error((0,v.localize)(1,null,p));await this.storeMetadata(_,{...s,installedTimestamp:Date.now()});try{await this.rename(t,p,P,Date.now()+2*60*1e3),this.logService.info("Renamed to",P)}catch(O){try{await y.Promises.rm(p)}catch{}if(O.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,L.getErrorMessage)(O)}. Deleted from extracted location`,p),O}try{_=await this.scanExtension(C.URI.file(P),1)}catch{}if(_)return _;throw new Error((0,v.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,o){return this.setMetadata(t,o),await this.storeMetadata(t,{...o,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const s=R.join(t.location.fsPath,"package.json"),c=await y.Promises.readFile(s,"utf8"),{manifest:u}=await this.parseManifest(c);return u.__metadata=o,await y.Promises.writeFile(s,JSON.stringify(u,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const o=t.map(s=>new w.ExtensionIdentifierWithVersion(s.identifier,s.manifest.version));await this.withUninstalledExtensions(s=>{o.forEach(c=>s[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const s=(await this.scanExtensions(1)).find(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return s?(await this.storeMetadata(s,{installedTimestamp:Date.now()}),this.scanExtension(s.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let s={};if(o)try{s=JSON.parse(o)}catch{}return t&&(t(s),Object.keys(s).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(s)):await y.Promises.rm(this.uninstalledPath)),s})}async removeExtension(t,o){this.logService.trace(`Deleting ${o} extension from disk`,t.identifier.id,t.location.fsPath),await y.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,o,s,c){this.logService.trace(`Started extracting the extension from ${o} to ${s}`);try{await y.Promises.rm(s)}catch(u){throw new g.ExtensionManagementError(this.joinErrors(u).message,g.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(o,s,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${s}:`,t.id)}catch(u){try{await y.Promises.rm(s)}catch{}let p=g.ExtensionManagementErrorCode.Extract;throw u instanceof h.ExtractError&&(u.type==="CorruptZip"?p=g.ExtensionManagementErrorCode.CorruptZip:u.type==="Incomplete"&&(p=g.ExtensionManagementErrorCode.IncompleteZip)),new g.ExtensionManagementError(u.message,p)}}async rename(t,o,s,c){try{await y.Promises.rename(o,s)}catch(u){if(b.isWindows&&u&&u.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${o} to ${s} with 'EPERM' error. Trying again...`,t.id),this.rename(t,o,s,c);throw new g.ExtensionManagementError(u.message||(0,v.localize)(3,null,o,s),u.code||g.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const o=this.scanDevSystemExtensions(),[s,c]=await Promise.all([t,o]);return[...s,...c]}async scanExtensionsInDir(t,o){const s=new n.Limiter(10),c=await this.fileService.resolve(C.URI.file(t));return c.children?(await Promise.all(c.children.filter(p=>p.isDirectory).map(p=>s.queue(async()=>o===1&&(0,E.basename)(p.resource).indexOf(".")===0?null:this.scanExtension(p.resource,o))))).filter(p=>p&&p.identifier):[]}async scanExtension(t,o){try{const s=await this.fileService.resolve(t);if(s.children){const{manifest:c,metadata:u}=await this.readManifest(t.fsPath),p=s.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,P=s.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource,_={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},O={type:o,identifier:_,manifest:c,location:t,readmeUrl:p,changelogUrl:P,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return this.setMetadata(O,u),O}}catch(s){o!==0&&this.logService.trace(s)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(s=>t.some(c=>(0,w.areSameExtensions)(s.identifier,{id:c})))}else return[]}setMetadata(t,o){t.publisherDisplayName=o?.publisherDisplayName||null,t.publisherId=o?.publisherId||null,t.identifier.uuid=o?.id,t.isMachineScoped=!!o?.isMachineScoped,t.isPreReleaseVersion=!!o?.isPreReleaseVersion,t.preRelease=!!o?.preRelease,t.isBuiltin=t.type===0||!!o?.isBuiltin,t.installedTimestamp=o?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),s=new Set;for(const p of o)t[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]||s.add(p.identifier.id.toLowerCase());const c=(0,w.groupByExtension)(o,p=>p.identifier);await n.Promises.settled(c.map(async p=>{const P=p.sort((_,O)=>I.rcompare(_.manifest.version,O.manifest.version))[0];s.has(P.identifier.id.toLowerCase())||await this.beforeRemovingExtension(P)}));const u=o.filter(p=>t[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]);await n.Promises.settled(u.map(p=>this.removeUninstalledExtension(p)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),o=[],s=(0,w.groupByExtension)(t,c=>c.identifier);o.push(...(0,D.flatten)(s.map(c=>c.sort((u,p)=>I.rcompare(u.manifest.version,p.manifest.version)).slice(1)))),await n.Promises.settled(o.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const o=Array.isArray(t)?t:[t];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((s,c)=>new Error(`${s.message}${s.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(T.FileAccess.asFileUri("",Y).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const o=[y.Promises.readFile(R.join(t,"package.json"),"utf8").then(p=>this.parseManifest(p)),y.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,p=>p.code!=="ENOENT"?Promise.reject(p):"{}").then(p=>JSON.parse(p))],[{manifest:s,metadata:c},u]=await Promise.all(o);return{manifest:(0,m.localizeManifest)(s,u),metadata:c}}parseManifest(t){return new Promise((o,s)=>{try{const c=JSON.parse(t),u=c.__metadata||null;o({manifest:c,metadata:u})}catch{s(new Error((0,v.localize)(4,null)))}})}};a=de([J(1,S.IFileService),J(2,l.ILogService),J(3,d.INativeEnvironmentService),J(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ne[245],ie([0,1,37,9,18,10,4,32,19,61,7,29,22,66,132,81,15,206,30,31,188,174,243,189,244,220,78,13,6,8,27,21,34]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l,r,a,i,t,o,s,c,u,p,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let O=class extends g.AbstractExtensionManagementService{constructor(U,G,K,x,q,X,H,Z,ee){super(U,G,K,Z);this.environmentService=x,this.downloadService=q,this.fileService=H;const W=this._register(X.createInstance(l.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(i.ExtensionsScanner,V=>W.postUninstall(V))),this.manifestCache=this._register(new a.ExtensionsManifestCache(x,this)),this.extensionsDownloader=this._register(X.createInstance(S.ExtensionsDownloader));const N=this._register(new t.ExtensionsWatcher(this,H,x,K,ee));this._register(N.onDidChangeExtensionsByAnotherSource(({added:V,removed:z})=>{V.length&&this._onDidInstallExtensions.fire(V.map(B=>({identifier:B.identifier,operation:1,local:B}))),z.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(U?"alpine":T.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!T.isLinux)return!1;let U;try{U=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(K){this.logService.debug("Error while getting the os-release file.",(0,n.getErrorMessage)(K))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const G=await this.collectFiles(U),K=await(0,y.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,G);return I.URI.file(K)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const G=await this.downloadVsix(U),K=A.resolve(G.fsPath);return(0,r.getManifest)(K)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,G={}){this.logService.trace("ExtensionManagementService#install",U.toString());const K=await this.downloadVsix(U),x=await(0,r.getManifest)(A.resolve(K.fsPath));if(x.engines&&x.engines.vscode&&!(0,o.isEngineValid)(x.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,m.getGalleryExtensionId)(x.publisher,x.name),this.productService.version));return this.installExtension(x,K,G)}async updateMetadata(U,G){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const K={...U.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(K.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,K),this.manifestCache.invalidate(),U}async updateExtensionScope(U,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===L.Schemas.file)return U;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(U,G),G}createInstallExtensionTask(U,G,K){return I.URI.isUri(G)?new k(U,G,K,this.galleryService,this.extensionsScanner,this.logService):new $(G,K,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,G){return new M(U,G,this.extensionsScanner)}async collectFiles(U){const G=async x=>{let q=await f.Promises.readdir(x);q=q.map(Z=>A.join(x,Z));const X=await Promise.all(q.map(Z=>f.Promises.stat(Z)));let H=Promise.resolve([]);return X.forEach((Z,ee)=>{const W=q[ee];Z.isFile()&&(H=H.then(N=>[...N,W])),Z.isDirectory()&&(H=H.then(N=>G(W).then(V=>[...N,...V])))}),H};return(await G(U.location.fsPath)).map(x=>({path:`extension/${A.relative(U.location.fsPath,x)}`,localPath:x}))}};O=de([J(0,w.IExtensionGalleryService),J(1,P.ITelemetryService),J(2,u.ILogService),J(3,d.INativeEnvironmentService),J(4,v.IDownloadService),J(5,c.IInstantiationService),J(6,s.IFileService),J(7,p.IProductService),J(8,_.IUriIdentityService)],O),e.ExtensionManagementService=O;class F extends g.AbstractExtensionTask{constructor(U,G,K,x){super();this.identifier=U,this.source=G,this.extensionsScanner=K,this.logService=x,this._operation=2}get operation(){return this._operation}async installExtension(U,G){try{const K=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(K)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(K,{...K.manifest.__metadata||{},...U.metadata}):K}catch{throw T.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(U,G)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const K=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),K}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:G,metadata:K},x){let q=await this.extensionsScanner.extractUserExtension(G,U,K,x);return this.logService.info("Extracting completed.",G.id),q}}class $ extends F{constructor(U,G,K,x,q){super(U.identifier,U,x,q);this.gallery=U,this.options=G,this.extensionsDownloader=K}async doRun(U){const K=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,m.areSameExtensions)(q.identifier,this.gallery.identifier));K&&(this._operation=3);const x=await this.downloadInstallableExtension(this.gallery,this._operation);x.metadata.isMachineScoped=this.options.isMachineScoped||K?.isMachineScoped,x.metadata.isBuiltin=this.options.isBuiltin||K?.isBuiltin,x.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,x.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:K?.preRelease||this.options.installPreReleaseVersion;try{const q=await this.installExtension(x,U);return K&&E.neq(K.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(K),q}catch(q){throw await this.deleteDownloadedVSIX(x.zipPath),q}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(I.URI.file(U))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,n.getErrorMessage)(G))}}async downloadInstallableExtension(U,G){const K={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let x;try{this.logService.trace("Started downloading extension:",U.identifier.id),x=(await this.extensionsDownloader.downloadExtension(U,G)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,x)}catch(q){throw new w.ExtensionManagementError((0,g.joinErrors)(q).message,w.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(x);return{zipPath:x,identifierWithVersion:new m.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:K}}catch(q){throw await this.deleteDownloadedVSIX(x),new w.ExtensionManagementError((0,g.joinErrors)(q).message,w.ExtensionManagementErrorCode.Invalid)}}}class k extends F{constructor(U,G,K,x,q,X){super({id:(0,m.getGalleryExtensionId)(U.publisher,U.name)},G,q,X);this.manifest=U,this.location=G,this.options=K,this.galleryService=x}async doRun(U){const G=new m.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),x=(await this.extensionsScanner.scanExtensions(1)).find(X=>(0,m.areSameExtensions)(this.identifier,X.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(q.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||x?.isBuiltin,x)if(this._operation=3,G.equals(new m.ExtensionIdentifierWithVersion(x.identifier,x.manifest.version)))try{await this.extensionsScanner.removeExtension(x,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else E.gt(x.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(x);else{const X=await this.unsetUninstalledAndGetLocal(G);if(X)try{await this.extensionsScanner.removeExtension(X,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:A.resolve(this.location.fsPath),identifierWithVersion:G,metadata:q},U)}async getMetadata(U,G,K){try{let[x]=await this.galleryService.getExtensions([{id:U,version:G}],K);if(x||([x]=await this.galleryService.getExtensions([{id:U}],K)),x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId,isPreReleaseVersion:x.properties.isPreReleaseVersion,preRelease:x.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class M extends g.AbstractExtensionTask{constructor(U,G,K){super();this.extension=U,this.options=G,this.extensionsScanner=K}async doRun(U){const G=[],K=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const x=new m.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...K.filter(q=>x.equals(new m.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else G.push(...K.filter(x=>(0,m.areSameExtensions)(x.identifier,this.extension.identifier)));if(!G.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const x of G)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(x)}catch(q){throw new Error(h.localize(6,null,(0,D.toErrorMessage)(q)))}}}}),define(ne[246],ie([0,1,83,56,33,17,9,3,2,10,4,29,36,73,257]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{constructor(P,_=""){this.debugLabel=_,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=O=>{if(this.traceSocketEvent("error",{code:O?.code,message:O?.message}),O){if(O.code==="EPIPE")return;(0,T.onUnexpectedError)(O)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,_){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,_)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const _=O=>{this.traceSocketEvent("read",O),P(A.VSBuffer.wrap(O))};return this.socket.on("data",_),{dispose:()=>this.socket.off("data",_)}}onClose(P){const _=O=>{this.traceSocketEvent("close",{hadError:O}),P({type:0,hadError:O,error:void 0})};return this.socket.on("close",_),{dispose:()=>this.socket.off("close",_)}}onEnd(P){const _=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",_),{dispose:()=>this.socket.off("end",_)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,_=>{if(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}})}catch(_){if(_.code==="EPIPE")return;(0,T.onUnexpectedError)(_)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,_)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const O=()=>{this.socket.off("close",O),this.socket.off("end",O),this.socket.off("error",O),this.socket.off("timeout",O),this.socket.off("drain",O),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",O),this.socket.on("end",O),this.socket.on("error",O),this.socket.on("timeout",O),this.socket.on("drain",O)})}}e.NodeSocket=v;var d;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(d||(d={}));var g;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(g||(g={}));class w extends b.Disposable{constructor(P,_,O,F){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:_,inflateBytesLength:O?.byteLength||0,recordInflateBytes:F}),this._flowManager=this._register(new m(this,_,O,F,this._onData,($,k)=>this._write($,k))),this._register(this._flowManager.onError($=>{console.error($),(0,T.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,_){this.socket.traceSocketEvent(P,_)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,_){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let O=2;P.byteLength<126?O+=0:P.byteLength<2**16?O+=2:O+=8;const F=A.VSBuffer.alloc(O);if(_?F.writeUInt8(194,0):F.writeUInt8(130,0),P.byteLength<126)F.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){F.writeUInt8(126,1);let $=1;F.writeUInt8(P.byteLength>>>8&255,++$),F.writeUInt8(P.byteLength>>>0&255,++$)}else{F.writeUInt8(127,1);let $=1;F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(0,++$),F.writeUInt8(P.byteLength>>>24&255,++$),F.writeUInt8(P.byteLength>>>16&255,++$),F.writeUInt8(P.byteLength>>>8&255,++$),F.writeUInt8(P.byteLength>>>0&255,++$)}this.socket.write(A.VSBuffer.concat([F,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const _=this._incomingData.peek(this._state.readLen),O=_.readUInt8(0),F=(O&128)>>>7,$=(O&64)>>>6,k=_.readUInt8(1),M=(k&128)>>>7,j=k&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=F,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(F),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const _=this._incomingData.read(this._state.readLen),O=_.readUInt8(1),F=(O&128)>>>7;let $=O&127,k=1;$===126?$=_.readUInt8(++k)*2**8+_.readUInt8(++k):$===127&&($=_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*0+_.readUInt8(++k)*2**24+_.readUInt8(++k)*2**16+_.readUInt8(++k)*2**8+_.readUInt8(++k));let M=0;F&&(M=_.readUInt8(++k)*2**24+_.readUInt8(++k)*2**16+_.readUInt8(++k)*2**8+_.readUInt8(++k)),this._state.state=3,this._state.readLen=$,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const _=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",_),r(_,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",_),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(_,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class m extends b.Disposable{constructor(P,_,O,F,$,k){super();this._tracer=P,this._onData=$,this._writeFn=k,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,_?(this._zlibInflateStream=this._register(new S(this._tracer,F,O,{windowBits:15})),this._zlibDeflateStream=this._register(new l(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:A.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const _=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(_,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,_){return new Promise((O,F)=>{P.write(_),P.flush($=>O($))})}acceptFrame(P,_,O){this._readQueue.push({data:P,isCompressed:_,isLastFrameOfMessage:O}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const _=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(_)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,_,O){return new Promise((F,$)=>{P.write(_),O&&P.write(A.VSBuffer.fromByteArray([0,0,255,255])),P.flush(k=>F(k))})}}class S extends b.Disposable{constructor(P,_,O,F){super();this._tracer=P,this._recordInflateBytes=_,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(F),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(A.VSBuffer.wrap($))}),O&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",O.buffer),this._zlibInflate.write(O.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?A.VSBuffer.concat(this._recordedInflateBytes):A.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const _=A.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(_)})}}class l extends b.Disposable{constructor(P,_){super();this._tracer=P,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibDeflate.on("data",O=>{this._tracer.traceSocketEvent("zlibDeflateData",O),this._pendingDeflateData.push(A.VSBuffer.wrap(O))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let _=A.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,_=_.slice(0,_.byteLength-4),P(_)})}}function r(p,P){if(P===0)return;let _=p.byteLength>>>2;for(let j=0;j<_;j++){const U=p.readUInt32BE(j*4);p.writeUInt32BE(U^P,j*4)}let O=_*4,F=p.byteLength-O;const $=P>>>24&255,k=P>>>16&255,M=P>>>8&255;F>=1&&p.writeUInt8(p.readUInt8(O)^$,O),F>=2&&p.writeUInt8(p.readUInt8(O+1)^k,O+1),F>=3&&p.writeUInt8(p.readUInt8(O+2)^M,O+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const p=(0,C.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):P=(0,E.join)((0,L.tmpdir)(),`vscode-ipc-${p}.sock`),o(P),P}e.createRandomIPCHandle=i;function t(p,P,_){const O=(0,D.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${_}-${P}-sock`;let F;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?F=(0,E.join)(e.XDG_RUNTIME_DIR,`vscode-${O.substr(0,8)}-${_}-${P}.sock`):F=(0,E.join)(p,`${_}-${P}.sock`),o(F),F}e.createStaticIPCHandle=t;function o(p){const P=a[I.platform];typeof P=="number"&&p.length>=P&&console.warn(`WARNING: IPC handle "${p}" is longer than ${P} chars, try a shorter --user-data-dir`)}class s extends f.IPCServer{constructor(P){super(s.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const _=R.Event.fromNodeEventEmitter(P,"connection");return R.Event.map(_,O=>({protocol:new y.Protocol(new v(O,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(O,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function c(p){return new Promise((P,_)=>{const O=(0,n.createServer)();O.on("error",_),O.listen(p,()=>{O.removeListener("error",_),P(new s(O))})})}e.serve=c;function u(p,P){return new Promise((_,O)=>{const F=(0,n.createConnection)(p,()=>{F.removeListener("error",O),_(y.Client.fromSocket(new v(F,`ipc-client${P}`),P))});F.once("error",O)})}e.connect=u}),define(ne[247],ie([0,1,56,246]),function(Y,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,A,T,R,b){const E=C=>b(C,void 0),I=D.createConnection({host:L,port:A},()=>{I.removeListener("error",E);const C=Buffer.alloc(16);for(let v=0;v<16;v++)C[v]=Math.round(Math.random()*256);const f=C.toString("base64"),y=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${A}/?${T}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];I.write(y.join(`\r
`)+`\r
\r
`);const h=v=>{v.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",h),b(void 0,new n.NodeSocket(I,R)))};I.on("data",h)});I.setNoDelay(!0),I.once("error",E)}}}),define(ne[248],ie([0,1,56,115,247,5,2,20,8,27,185,62,92]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(w,m,S,l,r){let a;for(let i=3;i&&(a&&a.dispose(),a=await new h(w,m,S,l,r).waitForReady(),!(r&&n.BROWSER_RESTRICTED_PORTS[r]||!n.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));i--);return a}class h extends T.Disposable{constructor(m,S,l,r,a){super();this.defaultTunnelHost=S,this.suggestedLocalPort=a,this.privacy=C.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=m,this._server=D.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=i=>this._onConnection(i),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(S=>{S()})}async waitForReady(){let m=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),S=null;return this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address(),S||(m=0,this._server.listen(m,this.defaultTunnelHost),await this._barrier.wait(),S=this._server.address()),this.tunnelLocalPort=S.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${S.port}`,this}async _onConnection(m){m.pause();const S=(0,C.isLocalhost)(this.tunnelRemoteHost)||(0,C.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,I.connectRemoteAgentTunnel)(this._options,S,this.tunnelRemotePort),r=l.getSocket().socket,a=l.readEntireBuffer();l.dispose(),a.byteLength>0&&m.write(a.buffer),m.on("end",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),r.end()}),m.on("close",()=>r.end()),m.on("error",()=>{m.localAddress&&this._socketsDispose.delete(m.localAddress),r.destroy()}),r.on("end",()=>m.end()),r.on("close",()=>m.end()),r.on("error",()=>{m.destroy()}),m.pipe(r),r.pipe(m),m.localAddress&&this._socketsDispose.set(m.localAddress,()=>{m.end(),r.end()})}}let v=class extends C.AbstractTunnelService{constructor(m,S,l,r,a){super(S);this.socketFactory=m,this.signService=l,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const m=this.configurationService.getValue("remote.localPortHost");return!m||m==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(m,S,l,r,a,i,t){const o=this.getTunnelFromMap(S,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,S,l,r,a,i,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${S}:${l} on local port ${r}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:m,signService:this.signService,logService:this.logService,ipcLogger:null},c=y(s,this.defaultTunnelHost,S,l,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(S,l,c),c}}};v=de([J(1,b.ILogService),J(2,f.ISignService),J(3,E.IProductService),J(4,R.IConfigurationService)],v),e.BaseTunnelService=v;let d=class extends v{constructor(m,S,l,r){super(L.nodeSocketFactory,m,S,l,r)}};d=de([J(0,b.ILogService),J(1,f.ISignService),J(2,E.IProductService),J(3,R.IConfigurationService)],d),e.TunnelService=d;let g=class extends T.Disposable{constructor(m,S,l,r){super();this.logService=m,this.productService=S,this.signService=l,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(m,S,l,r,a,i,t,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${r} on local port ${a}.`),!this._tunnelServices.has(m)){const s=new d(this.logService,this.signService,this.productService,this.configurationService);this._register(s),this._tunnelServices.set(m,s),s.onTunnelClosed(async()=>{(await s.tunnels).length===0&&(s.dispose(),this._tunnelServices.delete(m))})}return this._tunnelServices.get(m).openTunnel(S,l,r,a,i,t,o)}};g=de([J(0,b.ILogService),J(1,E.IProductService),J(2,f.ISignService),J(3,R.IConfigurationService)],g),e.SharedTunnelsService=g}),define(ne[258],ie([0,1,74,33,37,9,2,18,19,7,36,118,179,201,180,171,172,173,157,160,20,183,80,205,81,194,15,198,200,209,30,159,207,245,82,155,13,176,178,51,6,168,85,169,170,59,190,8,86,60,87,27,193,43,24,203,204,21,93,94,95,44,210,211,96,213,219,63,98,25,64,233,235,236,65,234,238,239,240,241,242,92,199,62,248,191,192,91,197,208,34,221,4,222,163,182,181]),function(Y,e,D,n,L,A,T,R,b,E,I,C,f,y,h,v,d,g,w,m,S,l,r,a,i,t,o,s,c,u,p,P,_,O,F,$,k,M,j,U,G,K,x,q,X,H,Z,ee,W,N,V,z,B,te,se,ce,he,ve,pe,Ee,Ce,we,be,Re,Fe,Ue,qe,Be,re,ae,ue,ye,Pe,Ne,Te,Oe,_e,Q,oe,le,fe,ge,Le,Se,De,ke,Ie,Ae,$e,je,xe,It,Rt,Dt,pt,kt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends T.Disposable{constructor(me){super();this.configuration=me,this.server=this._register(new C.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const me=()=>this.dispose();process.once("exit",me),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",me);const Me="vscode:electron-main->shared-process=disposeWorker",ze=(Ye,We)=>this.onDisposeWorker(We);D.ipcRenderer.on(Me,ze),this._register((0,T.toDisposable)(()=>D.ipcRenderer.removeListener(Me,ze)))}onDisposeWorker(me){this.sharedProcessWorkerService?.disposeWorker(me)}async open(){const me=await this.initServices();(0,ae.registerConfiguration)(),me.invokeFunction(Me=>{const ze=Me.get(ee.ILogService);ze.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Me),this.registerErrorHandler(ze)}),this._register((0,T.combinedDisposable)(me.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),me.createInstance(h.LanguagePackCachedDataCleaner),me.createInstance(g.StorageDataCleaner,this.configuration.backupWorkspacesPath),me.createInstance(d.LogsDataCleaner),me.createInstance(v.LocalizationsUpdater),me.createInstance(y.ExtensionsCleaner)))}async initServices(){const me=new x.ServiceCollection,Me={_serviceBrand:void 0,...V.default};me.set(z.IProductService,Me);const ze=new I.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,ze);me.set(X.IMainProcessService,Ye);const We=new s.SharedProcessEnvironmentService(this.configuration.args,Me);me.set(o.INativeEnvironmentService,We);const it=new W.LogLevelChannelClient(this.server.getChannel("logLevel",ze)),Xe=new W.LoggerChannelClient(this.configuration.logLevel,it.onDidChangeLogLevel,Ye.getChannel("logger"));me.set(ee.ILoggerService,Xe);const ot=this._register(new ee.MultiplexLogService([this._register(new ee.ConsoleLogger(this.configuration.logLevel)),this._register(Xe.createLogger((0,b.joinPath)(E.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new W.FollowerLogService(it,ot));me.set(ee.ILogService,Je),this.sharedProcessWorkerService=new $e.SharedProcessWorkerService(Je),me.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new M.FileService(Je));me.set(k.IFileService,Ve);const at=this._register(new j.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,at);const ct=this._register(new Dt.FileUserDataProvider(R.Schemas.file,this._register(new pt.DiskFileSystemProviderClient(Ye.getChannel(pt.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Rt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,ct);const He=this._register(new l.ConfigurationService(We.settingsResource,Ve));me.set(S.IConfigurationService,He);const et=new ce.NativeStorageService(void 0,Ye,We);me.set(se.IStorageService,et),this._register((0,T.toDisposable)(()=>et.flush())),await Promise.all([He.initialize(),et.initialize()]),me.set(xe.IUriIdentityService,new It.UriIdentityService(Ve)),me.set(te.IRequestService,new U.SyncDescriptor(B.RequestService)),me.set(w.IChecksumService,new U.SyncDescriptor(m.ChecksumService)),me.set(St.IV8InspectProfilingService,new U.SyncDescriptor(kt.InspectProfilingService));const rt=I.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});me.set(N.INativeHostService,rt),me.set(i.IDownloadService,new U.SyncDescriptor(t.DownloadService));const lt=this._register(new fe.ActiveWindowManager(rt)),ut=new I.StaticRouter(Ge=>lt.getActiveClientId().then(dt=>Ge===dt));me.set(F.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new je.AssignmentService(this.configuration.machineId,He,Me);let tt;const Qe=[];if((0,we.supportsTelemetry)(Me,We)){const Ge=new Ee.TelemetryLogAppender(Xe,We);Qe.push(Ge);const{appRoot:dt,extensionsPath:_t,installSourcePath:Ot}=We;if(Me.aiConfig&&Me.aiConfig.asimovKey){const st=await ht.getTreatment("telemetryMigration")??!1,ft=Me.quality!=="stable";if(ft&&st){const bt=new be.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,st,!0);this._register((0,T.toDisposable)(()=>bt.flush())),Qe.push(bt)}const Et=new be.AppInsightsAppender("monacoworkbench",null,Me.aiConfig.asimovKey,ft?!1:st,st&&ft);this._register((0,T.toDisposable)(()=>Et.flush())),Qe.push(Et)}tt=new Ce.TelemetryService({appenders:Qe,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,n.release)(),(0,n.hostname)(),process.arch,Me.commit,Me.version,this.configuration.machineId,Me.msftInternalDomains,Ot),sendErrorTelemetry:!0,piiPaths:[dt,_t]},He)}else{tt=we.NullTelemetryService;const Ge=we.NullAppender;Qe.push(Ge)}this.server.registerChannel("telemetryAppender",new pe.TelemetryAppenderChannel(Qe)),me.set(ve.ITelemetryService,tt);const At=new Re.CustomEndpointTelemetryService(He,tt,Xe,We);me.set(ve.ICustomEndpointTelemetryService,At),me.set(p.IExtensionManagementService,new U.SyncDescriptor(O.ExtensionManagementService)),me.set(p.IExtensionGalleryService,new U.SyncDescriptor(u.ExtensionGalleryService)),me.set(p.IExtensionTipsService,new U.SyncDescriptor(_.ExtensionTipsService)),me.set(H.ILocalizationsService,new U.SyncDescriptor(Z.LocalizationsService)),me.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),me.set(ue.IUserDataSyncAccountService,new U.SyncDescriptor(ue.UserDataSyncAccountService)),me.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(Ne.UserDataSyncLogService)),me.set(ae.IUserDataSyncUtilService,new Pe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),me.set(p.IGlobalExtensionEnablementService,new U.SyncDescriptor(c.GlobalExtensionEnablementService)),me.set(re.IIgnoredExtensionsManagementService,new U.SyncDescriptor(re.IgnoredExtensionsManagementService)),me.set(Be.IExtensionStorageService,new U.SyncDescriptor(Be.ExtensionStorageService)),me.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(oe.UserDataSyncStoreManagementService)),me.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(oe.UserDataSyncStoreService)),me.set(Te.IUserDataSyncMachinesService,new U.SyncDescriptor(Te.UserDataSyncMachinesService)),me.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(ye.UserDataSyncBackupStoreService)),me.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Oe.UserDataSyncEnablementService)),me.set(ae.IUserDataSyncService,new U.SyncDescriptor(_e.UserDataSyncService));const wt=new qe.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,We,Je,tt);return await wt.initialize(),me.set(Ue.ILocalPtyService,this._register(wt)),me.set(ge.ISignService,new U.SyncDescriptor(Le.SignService)),me.set(Se.ISharedTunnelsService,new U.SyncDescriptor(De.SharedTunnelsService)),me.set(ke.ISharedProcessTunnelService,new U.SyncDescriptor(Ie.SharedProcessTunnelService)),new K.InstantiationService(me)}initChannels(me){const Me=new P.ExtensionManagementChannel(me.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Me);const ze=I.ProxyChannel.fromService(me.get(H.ILocalizationsService));this.server.registerChannel("localizations",ze);const Ye=I.ProxyChannel.fromService(me.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const We=new P.ExtensionTipsChannel(me.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const it=I.ProxyChannel.fromService(me.get(w.IChecksumService));this.server.registerChannel("checksum",it);const Xe=I.ProxyChannel.fromService(me.get(St.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Xe);const ot=new Pe.UserDataSyncMachinesServiceChannel(me.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",ot);const Je=I.ProxyChannel.fromService(me.get(ve.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Pe.UserDataSyncAccountServiceChannel(me.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const at=new Pe.UserDataSyncStoreManagementServiceChannel(me.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",at);const ct=new Q.UserDataSyncChannel(me.get(ae.IUserDataSyncService),me.get(ee.ILogService));this.server.registerChannel("userDataSync",ct);const He=this._register(me.get(G.IInstantiationService).createInstance(le.UserDataAutoSyncService)),et=new Pe.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",et);const rt=me.get(Ue.ILocalPtyService),lt=I.ProxyChannel.fromService(rt);this.server.registerChannel(Fe.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(me.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(me.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(me){window.addEventListener("unhandledrejection",Me=>{(0,A.onUnexpectedError)(Me.reason),Me.preventDefault()}),(0,A.setUnexpectedErrorHandler)(Me=>{const ze=(0,L.toErrorMessage)(Me,!0);!ze||me.error(`[uncaught exception in sharedProcess]: ${ze}`)})}}async function Tt(yt){const me=new Lt(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await me.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Tt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a7f1b7395175418c74fe0041560eb3f0423d4d27/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
