/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/base/common/types","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/arrays","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Z=function(z){for(var t=[],C=0,D=z.length;C<D;C++)t[C]=Q[z[C]];return t};define(Q[55],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function C(D,P){if(!D)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}t.ok=C}),define(Q[44],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function C(L){return(I,u,g)=>{let b=null,O=null;if(typeof g.value=="function"?(b="value",O=g.value):typeof g.get=="function"&&(b="get",O=g.get),!O)throw new Error("not supported");g[b]=L(O,u)}}t.createDecorator=C;function D(L,I,u){let g=null,b=null;if(typeof u.value=="function"?(g="value",b=u.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(g="get",b=u.get),!b)throw new Error("not supported");const O=`$memoize$${I}`;u[g]=function(...d){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,d)}),this[O]}}t.memoize=D;function P(L,I,u){return C((g,b)=>{const O=`$debounce$${b}`,d=`$debounce$result$${b}`;return function(...S){this[d]||(this[d]=u?u():void 0),clearTimeout(this[O]),I&&(this[d]=I(this[d],...S),S=[this[d]]),this[O]=setTimeout(()=>{g.apply(this,S),this[d]=u?u():void 0},L)}})}t.debounce=P;function R(L,I,u){return C((g,b)=>{const O=`$throttle$timer$${b}`,d=`$throttle$result$${b}`,S=`$throttle$lastRun$${b}`,p=`$throttle$pending$${b}`;return function(...m){if(this[d]||(this[d]=u?u():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),I&&(this[d]=I(this[d],...m)),this[p])return;const c=this[S]+L;c<=Date.now()?(this[S]=Date.now(),g.apply(this,[this[d]]),this[d]=u?u():void 0):(this[p]=!0,this[O]=setTimeout(()=>{this[p]=!1,this[S]=Date.now(),g.apply(this,[this[d]]),this[d]=u?u():void 0},c-Date.now()))}})}t.throttle=R}),define(Q[56],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var C;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(C=t.ScanError||(t.ScanError={}));var D;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var P;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(P=t.ParseErrorCode||(t.ParseErrorCode={}));var R;(function(n){n.DEFAULT={allowTrailingComma:!0}})(R=t.ParseOptions||(t.ParseOptions={}));function L(n,r=!1){let e=0,i=n.length,s="",l=0,f=16,y=0;function w(te){let ge=0,$=0;for(;ge<te;){const q=n.charCodeAt(e);if(q>=48&&q<=57)$=$*16+q-48;else if(q>=65&&q<=70)$=$*16+q-65+10;else if(q>=97&&q<=102)$=$*16+q-97+10;else break;e++,ge++}return ge<te&&($=-1),$}function T(te){e=te,s="",l=0,f=16,y=0}function A(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&g(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&g(n.charCodeAt(e)))for(e++;e<n.length&&g(n.charCodeAt(e));)e++;else return y=3,n.substring(te,e);let ge=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&g(n.charCodeAt(e))){for(e++;e<n.length&&g(n.charCodeAt(e));)e++;ge=e}else y=3;return n.substring(te,ge)}function B(){let te="",ge=e;for(;;){if(e>=i){te+=n.substring(ge,e),y=2;break}const $=n.charCodeAt(e);if($===34){te+=n.substring(ge,e),e++;break}if($===92){if(te+=n.substring(ge,e),e++,e>=i){y=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const re=w(4);re>=0?te+=String.fromCharCode(re):y=4;break}default:y=5}ge=e;continue}if($>=0&&$<=31)if(u($)){te+=n.substring(ge,e),y=2;break}else y=6;e++}return te}function J(){if(s="",y=0,l=e,e>=i)return l=i,f=17;let te=n.charCodeAt(e);if(I(te)){do e++,s+=String.fromCharCode(te),te=n.charCodeAt(e);while(I(te));return f=15}if(u(te))return e++,s+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,s+=`
`),f=14;switch(te){case 123:return e++,f=1;case 125:return e++,f=2;case 91:return e++,f=3;case 93:return e++,f=4;case 58:return e++,f=6;case 44:return e++,f=5;case 34:return e++,s=B(),f=10;case 47:{const ge=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<i&&!u(n.charCodeAt(e));)e++;return s=n.substring(ge,e),f=12}if(n.charCodeAt(e+1)===42){e+=2;const $=i-1;let q=!1;for(;e<$;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,q=!0;break}e++}return q||(e++,y=1),s=n.substring(ge,e),f=13}return s+=String.fromCharCode(te),e++,f=16}case 45:if(s+=String.fromCharCode(te),e++,e===i||!g(n.charCodeAt(e)))return f=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=A(),f=11;default:for(;e<i&&se(te);)e++,te=n.charCodeAt(e);if(l!==e){switch(s=n.substring(l,e),s){case"true":return f=8;case"false":return f=9;case"null":return f=7}return f=16}return s+=String.fromCharCode(te),e++,f=16}}function se(te){if(I(te)||u(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ie(){let te;do te=J();while(te>=12&&te<=15);return te}return{setPosition:T,getPosition:()=>e,scan:r?ie:J,getToken:()=>f,getTokenValue:()=>s,getTokenOffset:()=>l,getTokenLength:()=>e-l,getTokenError:()=>y}}t.createScanner=L;function I(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function u(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function O(n,r){const e=[],i=new Object;let s;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let f=!1;function y(w,T,A,B){l.value=w,l.offset=T,l.length=A,l.type=B,l.colonOffset=void 0,s=l}try{a(n,{onObjectBegin:(w,T)=>{if(r<=w)throw i;s=void 0,f=r>w,e.push("")},onObjectProperty:(w,T,A)=>{if(r<T||(y(w,T,A,"property"),e[e.length-1]=w,r<=T+A))throw i},onObjectEnd:(w,T)=>{if(r<=w)throw i;s=void 0,e.pop()},onArrayBegin:(w,T)=>{if(r<=w)throw i;s=void 0,e.push(0)},onArrayEnd:(w,T)=>{if(r<=w)throw i;s=void 0,e.pop()},onLiteralValue:(w,T,A)=>{if(r<T||(y(w,T,A,o(w)),r<=T+A))throw i},onSeparator:(w,T,A)=>{if(r<=T)throw i;if(w===":"&&s&&s.type==="property")s.colonOffset=T,f=!1,s=void 0;else if(w===","){const B=e[e.length-1];typeof B=="number"?e[e.length-1]=B+1:(f=!0,e[e.length-1]=""),s=void 0}}})}catch(w){if(w!==i)throw w}return{path:e,previousNode:s,isAtPropertyKey:f,matches:w=>{let T=0;for(let A=0;T<w.length&&A<e.length;A++)if(w[T]===e[A]||w[T]==="*")T++;else if(w[T]!=="**")return!1;return T===w.length}}}t.getLocation=O;function d(n,r=[],e=R.DEFAULT){let i=null,s=[];const l=[];function f(w){Array.isArray(s)?s.push(w):i!==null&&(s[i]=w)}return a(n,{onObjectBegin:()=>{const w={};f(w),l.push(s),s=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{s=l.pop()},onArrayBegin:()=>{const w=[];f(w),l.push(s),s=w,i=null},onArrayEnd:()=>{s=l.pop()},onLiteralValue:f,onError:(w,T,A)=>{r.push({error:w,offset:T,length:A})}},e),s[0]}t.parse=d;function S(n,r=[],e=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function l(w){return i.children.push(w),w}a(n,{onObjectBegin:w=>{i=l({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,T,A)=>{i=l({type:"property",offset:T,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:T,length:A,parent:i})},onObjectEnd:(w,T)=>{i.length=w+T-i.offset,i=i.parent,s(w+T)},onArrayBegin:(w,T)=>{i=l({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,T)=>{i.length=w+T-i.offset,i=i.parent,s(w+T)},onLiteralValue:(w,T,A)=>{l({type:o(w),offset:T,length:A,parent:i,value:w}),s(T+A)},onSeparator:(w,T,A)=>{i.type==="property"&&(w===":"?i.colonOffset=T:w===","&&s(T))},onError:(w,T,A)=>{r.push({error:w,offset:T,length:A})}},e);const y=i.children[0];return y&&delete y.parent,y}t.parseTree=S;function p(n,r){if(!n)return;let e=n;for(let i of r)if(typeof i=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let s=!1;for(const l of e.children)if(Array.isArray(l.children)&&l.children[0].value===i){e=l.children[1],s=!0;break}if(!s)return}else{const s=i;if(e.type!=="array"||s<0||!Array.isArray(e.children)||s>=e.children.length)return;e=e.children[s]}return e}t.findNodeAtLocation=p;function m(n){if(!n.parent||!n.parent.children)return[];const r=m(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;r.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&r.push(e)}return r}t.getNodePath=m;function c(n){switch(n.type){case"array":return n.children.map(c);case"object":{const r=Object.create(null);for(let e of n.children){const i=e.children[1];i&&(r[e.children[0].value]=c(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}t.getNodeValue=c;function h(n,r,e=!1){return r>=n.offset&&r<n.offset+n.length||e&&r===n.offset+n.length}t.contains=h;function E(n,r,e=!1){if(h(n,r,e)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const l=E(i[s],r,e);if(l)return l}return n}}t.findNodeAtOffset=E;function a(n,r,e=R.DEFAULT){const i=L(n,!1);function s(K){return K?()=>K(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(K){return K?ee=>K(ee,i.getTokenOffset(),i.getTokenLength()):()=>!0}const f=s(r.onObjectBegin),y=l(r.onObjectProperty),w=s(r.onObjectEnd),T=s(r.onArrayBegin),A=s(r.onArrayEnd),B=l(r.onLiteralValue),J=l(r.onSeparator),se=s(r.onComment),ie=l(r.onError),te=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function $(){for(;;){const K=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:te||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(K){case 12:case 13:te?q(10):se();break;case 16:q(1);break;case 15:case 14:break;default:return K}}}function q(K,ee=[],G=[]){if(ie(K),ee.length+G.length>0){let ae=i.getToken();for(;ae!==17;){if(ee.indexOf(ae)!==-1){$();break}else if(G.indexOf(ae)!==-1)break;ae=$()}}}function re(K){const ee=i.getTokenValue();return K?B(ee):y(ee),$(),!0}function M(){switch(i.getToken()){case 11:{let K=0;try{K=JSON.parse(i.getTokenValue()),typeof K!="number"&&(q(2),K=0)}catch{q(2)}B(K);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return $(),!0}function F(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(re(!1),i.getToken()===6?(J(":"),$(),ne()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){f(),$();let K=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(K||q(4,[],[]),J(","),$(),i.getToken()===2&&ge)break}else K&&q(6,[],[]);F()||q(4,[],[2,5]),K=!0}return w(),i.getToken()!==2?q(7,[2],[]):$(),!0}function H(){T(),$();let K=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(K||q(4,[],[]),J(","),$(),i.getToken()===4&&ge)break}else K&&q(6,[],[]);ne()||q(4,[],[4,5]),K=!0}return A(),i.getToken()!==4?q(8,[4],[]):$(),!0}function ne(){switch(i.getToken()){case 3:return H();case 1:return W();case 10:return re(!0);default:return M()}}return $(),i.getToken()===17?e.allowEmptyContent?!0:(q(4,[],[]),!1):ne()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}t.visit=a;function v(n,r){let e=L(n),i=[],s,l=0,f;do switch(f=e.getPosition(),s=e.scan(),s){case 12:case 13:case 17:l!==f&&i.push(n.substring(l,f)),r!==void 0&&i.push(e.getTokenValue().replace(/[^\r\n]/g,r)),l=e.getPosition();break}while(s!==17);return i.join("")}t.stripComments=v;function o(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function z(P){const R=[];typeof P=="number"&&R.push("code/timeOrigin",P);function L(u){R.push(u,Date.now())}function I(){const u=[];for(let g=0;g<R.length;g+=2)u.push({name:R[g],startTime:R[g+1]});return u}return{mark:L,getMarks:I}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?z():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(P+L.startTime)});return R}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return z(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),z()}function C(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=t()),P.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=C(D))}(),define(Q[57],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var C;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(C=t.Source||(t.Source={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D=t.TerminateResponseCode||(t.TerminateResponseCode={}));function P(R,...L){const I=L.reduce((b,O)=>(b[O]=!0,b),{}),u=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(b=>!I[b]).forEach(b=>{for(let O=0;O<u.length;O++)if(b.search(u[O])!==-1){delete R[b];break}})}t.sanitizeProcessEnvironment=P}),function(z,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var C=t();for(var D in C)(typeof exports=="object"?exports:z)[D]=C[D]}}(typeof self!="undefined"?self:this,function(){return function(z){var t={};function C(D){if(t[D])return t[D].exports;var P=t[D]={i:D,l:!1,exports:{}};return z[D].call(P.exports,P,P.exports,C),P.l=!0,P.exports}return C.m=z,C.c=t,C.d=function(D,P,R){C.o(D,P)||Object.defineProperty(D,P,{enumerable:!0,get:R})},C.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},C.t=function(D,P){if(1&P&&(D=C(D)),8&P||4&P&&typeof D=="object"&&D&&D.__esModule)return D;var R=Object.create(null);if(C.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:D}),2&P&&typeof D!="string")for(var L in D)C.d(R,L,function(I){return D[I]}.bind(null,L));return R},C.n=function(D){var P=D&&D.__esModule?function(){return D.default}:function(){return D};return C.d(P,"a",P),P},C.o=function(D,P){return Object.prototype.hasOwnProperty.call(D,P)},C.p="",C(C.s=0)}([function(z,t,C){(function(D){var P;t=z.exports=G,P=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var N=Array.prototype.slice.call(arguments,0);N.unshift("SEMVER"),console.log.apply(console,N)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,I=t.re=[],u=t.src=[],g=0,b=g++;u[b]="0|[1-9]\\d*";var O=g++;u[O]="[0-9]+";var d=g++;u[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=g++;u[S]="("+u[b]+")\\.("+u[b]+")\\.("+u[b]+")";var p=g++;u[p]="("+u[O]+")\\.("+u[O]+")\\.("+u[O]+")";var m=g++;u[m]="(?:"+u[b]+"|"+u[d]+")";var c=g++;u[c]="(?:"+u[O]+"|"+u[d]+")";var h=g++;u[h]="(?:-("+u[m]+"(?:\\."+u[m]+")*))";var E=g++;u[E]="(?:-?("+u[c]+"(?:\\."+u[c]+")*))";var a=g++;u[a]="[0-9A-Za-z-]+";var v=g++;u[v]="(?:\\+("+u[a]+"(?:\\."+u[a]+")*))";var o=g++,n="v?"+u[S]+u[h]+"?"+u[v]+"?";u[o]="^"+n+"$";var r="[v=\\s]*"+u[p]+u[E]+"?"+u[v]+"?",e=g++;u[e]="^"+r+"$";var i=g++;u[i]="((?:<|>)?=?)";var s=g++;u[s]=u[O]+"|x|X|\\*";var l=g++;u[l]=u[b]+"|x|X|\\*";var f=g++;u[f]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[h]+")?"+u[v]+"?)?)?";var y=g++;u[y]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[E]+")?"+u[v]+"?)?)?";var w=g++;u[w]="^"+u[i]+"\\s*"+u[f]+"$";var T=g++;u[T]="^"+u[i]+"\\s*"+u[y]+"$";var A=g++;u[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=g++;u[B]="(?:~>?)";var J=g++;u[J]="(\\s*)"+u[B]+"\\s+",I[J]=new RegExp(u[J],"g");var se=g++;u[se]="^"+u[B]+u[f]+"$";var ie=g++;u[ie]="^"+u[B]+u[y]+"$";var te=g++;u[te]="(?:\\^)";var ge=g++;u[ge]="(\\s*)"+u[te]+"\\s+",I[ge]=new RegExp(u[ge],"g");var $=g++;u[$]="^"+u[te]+u[f]+"$";var q=g++;u[q]="^"+u[te]+u[y]+"$";var re=g++;u[re]="^"+u[i]+"\\s*("+r+")$|^$";var M=g++;u[M]="^"+u[i]+"\\s*("+n+")$|^$";var F=g++;u[F]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[f]+")",I[F]=new RegExp(u[F],"g");var W=g++;u[W]="^\\s*("+u[f]+")\\s+-\\s+("+u[f]+")\\s*$";var H=g++;u[H]="^\\s*("+u[y]+")\\s+-\\s+("+u[y]+")\\s*$";var ne=g++;u[ne]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)P(K,u[K]),I[K]||(I[K]=new RegExp(u[K]));function ee(N,V){if(N instanceof G)return N;if(typeof N!="string"||N.length>R||!(V?I[e]:I[o]).test(N))return null;try{return new G(N,V)}catch{return null}}function G(N,V){if(N instanceof G){if(N.loose===V)return N;N=N.version}else if(typeof N!="string")throw new TypeError("Invalid Version: "+N);if(N.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof G))return new G(N,V);P("SemVer",N,V),this.loose=V;var _=N.trim().match(V?I[e]:I[o]);if(!_)throw new TypeError("Invalid Version: "+N);if(this.raw=N,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(ce){if(/^[0-9]+$/.test(ce)){var ve=+ce;if(ve>=0&&ve<L)return ve}return ce}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}t.parse=ee,t.valid=function(N,V){var _=ee(N,V);return _?_.version:null},t.clean=function(N,V){var _=ee(N.trim().replace(/^[=v]+/,""),V);return _?_.version:null},t.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(N){return P("SemVer.compare",this.version,this.loose,N),N instanceof G||(N=new G(N,this.loose)),this.compareMain(N)||this.comparePre(N)},G.prototype.compareMain=function(N){return N instanceof G||(N=new G(N,this.loose)),U(this.major,N.major)||U(this.minor,N.minor)||U(this.patch,N.patch)},G.prototype.comparePre=function(N){if(N instanceof G||(N=new G(N,this.loose)),this.prerelease.length&&!N.prerelease.length)return-1;if(!this.prerelease.length&&N.prerelease.length)return 1;if(!this.prerelease.length&&!N.prerelease.length)return 0;var V=0;do{var _=this.prerelease[V],ce=N.prerelease[V];if(P("prerelease compare",V,_,ce),_===void 0&&ce===void 0)return 0;if(ce===void 0)return 1;if(_===void 0)return-1;if(_!==ce)return U(_,ce)}while(++V)},G.prototype.inc=function(N,V){switch(N){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+N)}return this.format(),this.raw=this.version,this},t.inc=function(N,V,_,ce){typeof _=="string"&&(ce=_,_=void 0);try{return new G(N,_).inc(V,ce).version}catch{return null}},t.diff=function(N,V){if(Y(N,V))return null;var _=ee(N),ce=ee(V);if(_.prerelease.length||ce.prerelease.length){for(var ve in _)if((ve==="major"||ve==="minor"||ve==="patch")&&_[ve]!==ce[ve])return"pre"+ve;return"prerelease"}for(var ve in _)if((ve==="major"||ve==="minor"||ve==="patch")&&_[ve]!==ce[ve])return ve},t.compareIdentifiers=U;var ae=/^[0-9]+$/;function U(N,V){var _=ae.test(N),ce=ae.test(V);return _&&ce&&(N=+N,V=+V),_&&!ce?-1:ce&&!_?1:N<V?-1:N>V?1:0}function k(N,V,_){return new G(N,_).compare(new G(V,_))}function x(N,V,_){return k(N,V,_)>0}function j(N,V,_){return k(N,V,_)<0}function Y(N,V,_){return k(N,V,_)===0}function X(N,V,_){return k(N,V,_)!==0}function fe(N,V,_){return k(N,V,_)>=0}function le(N,V,_){return k(N,V,_)<=0}function Ee(N,V,_,ce){var ve;switch(V){case"===":typeof N=="object"&&(N=N.version),typeof _=="object"&&(_=_.version),ve=N===_;break;case"!==":typeof N=="object"&&(N=N.version),typeof _=="object"&&(_=_.version),ve=N!==_;break;case"":case"=":case"==":ve=Y(N,_,ce);break;case"!=":ve=X(N,_,ce);break;case">":ve=x(N,_,ce);break;case">=":ve=fe(N,_,ce);break;case"<":ve=j(N,_,ce);break;case"<=":ve=le(N,_,ce);break;default:throw new TypeError("Invalid operator: "+V)}return ve}function de(N,V){if(N instanceof de){if(N.loose===V)return N;N=N.value}if(!(this instanceof de))return new de(N,V);P("comparator",N,V),this.loose=V,this.parse(N),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}t.rcompareIdentifiers=function(N,V){return U(V,N)},t.major=function(N,V){return new G(N,V).major},t.minor=function(N,V){return new G(N,V).minor},t.patch=function(N,V){return new G(N,V).patch},t.compare=k,t.compareLoose=function(N,V){return k(N,V,!0)},t.rcompare=function(N,V,_){return k(V,N,_)},t.sort=function(N,V){return N.sort(function(_,ce){return t.compare(_,ce,V)})},t.rsort=function(N,V){return N.sort(function(_,ce){return t.rcompare(_,ce,V)})},t.gt=x,t.lt=j,t.eq=Y,t.neq=X,t.gte=fe,t.lte=le,t.cmp=Ee,t.Comparator=de;var ue={};function he(N,V){if(N instanceof he)return N.loose===V?N:new he(N.raw,V);if(N instanceof de)return new he(N.value,V);if(!(this instanceof he))return new he(N,V);if(this.loose=V,this.raw=N,this.set=N.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+N);this.format()}function me(N){return!N||N.toLowerCase()==="x"||N==="*"}function Fe(N,V,_,ce,ve,De,Se,ke,Ie,Oe,Me,Re,Le){return((V=me(_)?"":me(ce)?">="+_+".0.0":me(ve)?">="+_+"."+ce+".0":">="+V)+" "+(ke=me(Ie)?"":me(Oe)?"<"+(+Ie+1)+".0.0":me(Me)?"<"+Ie+"."+(+Oe+1)+".0":Re?"<="+Ie+"."+Oe+"."+Me+"-"+Re:"<="+ke)).trim()}function Ce(N,V){for(var _=0;_<N.length;_++)if(!N[_].test(V))return!1;if(V.prerelease.length){for(_=0;_<N.length;_++)if(P(N[_].semver),N[_].semver!==ue&&N[_].semver.prerelease.length>0){var ce=N[_].semver;if(ce.major===V.major&&ce.minor===V.minor&&ce.patch===V.patch)return!0}return!1}return!0}function Ue(N,V,_){try{V=new he(V,_)}catch{return!1}return V.test(N)}function Ve(N,V,_,ce){var ve,De,Se,ke,Ie;switch(N=new G(N,ce),V=new he(V,ce),_){case">":ve=x,De=le,Se=j,ke=">",Ie=">=";break;case"<":ve=j,De=fe,Se=x,ke="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(N,V,ce))return!1;for(var Oe=0;Oe<V.set.length;++Oe){var Me=V.set[Oe],Re=null,Le=null;if(Me.forEach(function(Ae){Ae.semver===ue&&(Ae=new de(">=0.0.0")),Re=Re||Ae,Le=Le||Ae,ve(Ae.semver,Re.semver,ce)?Re=Ae:Se(Ae.semver,Le.semver,ce)&&(Le=Ae)}),Re.operator===ke||Re.operator===Ie||(!Le.operator||Le.operator===ke)&&De(N,Le.semver)||Le.operator===Ie&&Se(N,Le.semver))return!1}return!0}de.prototype.parse=function(N){var V=this.loose?I[re]:I[M],_=N.match(V);if(!_)throw new TypeError("Invalid comparator: "+N);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new G(_[2],this.loose):this.semver=ue},de.prototype.toString=function(){return this.value},de.prototype.test=function(N){return P("Comparator.test",N,this.loose),this.semver===ue||(typeof N=="string"&&(N=new G(N,this.loose)),Ee(N,this.operator,this.semver,this.loose))},de.prototype.intersects=function(N,V){if(!(N instanceof de))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new he(N.value,V),Ue(this.value,_,V);if(N.operator==="")return _=new he(this.value,V),Ue(N.semver,_,V);var ce=!(this.operator!==">="&&this.operator!==">"||N.operator!==">="&&N.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||N.operator!=="<="&&N.operator!=="<"),De=this.semver.version===N.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||N.operator!==">="&&N.operator!=="<="),ke=Ee(this.semver,"<",N.semver,V)&&(this.operator===">="||this.operator===">")&&(N.operator==="<="||N.operator==="<"),Ie=Ee(this.semver,">",N.semver,V)&&(this.operator==="<="||this.operator==="<")&&(N.operator===">="||N.operator===">");return ce||ve||De&&Se||ke||Ie},t.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(N){return N.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(N){var V=this.loose;N=N.trim(),P("range",N,V);var _=V?I[H]:I[W];N=N.replace(_,Fe),P("hyphen replace",N),N=N.replace(I[F],"$1$2$3"),P("comparator trim",N,I[F]),N=(N=(N=N.replace(I[J],"$1~")).replace(I[ge],"$1^")).split(/\s+/).join(" ");var ce=V?I[re]:I[M],ve=N.split(" ").map(function(De){return function(Se,ke){return P("comp",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(Me){return function(Re,Le){P("caret",Re,Le);var Ae=Le?I[q]:I[$];return Re.replace(Ae,function(Ne,ye,we,be,Pe){var Te;return P("caret",Re,Ne,ye,we,be,Pe),me(ye)?Te="":me(we)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(be)?Te=ye==="0"?">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+".0 <"+(+ye+1)+".0.0":Pe?(P("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+Pe+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+Pe+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+Pe+" <"+(+ye+1)+".0.0"):(P("no pr"),Te=ye==="0"?we==="0"?">="+ye+"."+we+"."+be+" <"+ye+"."+we+"."+(+be+1):">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0":">="+ye+"."+we+"."+be+" <"+(+ye+1)+".0.0"),P("caret return",Te),Te})}(Me,Oe)}).join(" ")}(Se,ke),P("caret",Se),Se=function(Ie,Oe){return Ie.trim().split(/\s+/).map(function(Me){return function(Re,Le){var Ae=Le?I[ie]:I[se];return Re.replace(Ae,function(Ne,ye,we,be,Pe){var Te;return P("tilde",Re,Ne,ye,we,be,Pe),me(ye)?Te="":me(we)?Te=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(be)?Te=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0":Pe?(P("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Te=">="+ye+"."+we+"."+be+Pe+" <"+ye+"."+(+we+1)+".0"):Te=">="+ye+"."+we+"."+be+" <"+ye+"."+(+we+1)+".0",P("tilde return",Te),Te})}(Me,Oe)}).join(" ")}(Se,ke),P("tildes",Se),Se=function(Ie,Oe){return P("replaceXRanges",Ie,Oe),Ie.split(/\s+/).map(function(Me){return function(Re,Le){Re=Re.trim();var Ae=Le?I[T]:I[w];return Re.replace(Ae,function(Ne,ye,we,be,Pe,Te){P("xRange",Re,Ne,ye,we,be,Pe,Te);var je=me(we),ze=je||me(be),xe=ze||me(Pe);return ye==="="&&xe&&(ye=""),je?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&xe?(ze&&(be=0),xe&&(Pe=0),ye===">"?(ye=">=",ze?(we=+we+1,be=0,Pe=0):xe&&(be=+be+1,Pe=0)):ye==="<="&&(ye="<",ze?we=+we+1:be=+be+1),Ne=ye+we+"."+be+"."+Pe):ze?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":xe&&(Ne=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),P("xRange return",Ne),Ne})}(Me,Oe)}).join(" ")}(Se,ke),P("xrange",Se),Se=function(Ie,Oe){return P("replaceStars",Ie,Oe),Ie.trim().replace(I[ne],"")}(Se,ke),P("stars",Se),Se}(De,V)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(De){return!!De.match(ce)})),ve=ve.map(function(De){return new de(De,V)})},he.prototype.intersects=function(N,V){if(!(N instanceof he))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(ce){return N.set.some(function(ve){return ve.every(function(De){return ce.intersects(De,V)})})})})},t.toComparators=function(N,V){return new he(N,V).set.map(function(_){return _.map(function(ce){return ce.value}).join(" ").trim().split(" ")})},he.prototype.test=function(N){if(!N)return!1;typeof N=="string"&&(N=new G(N,this.loose));for(var V=0;V<this.set.length;V++)if(Ce(this.set[V],N))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(N,V,_){var ce=null,ve=null;try{var De=new he(V,_)}catch{return null}return N.forEach(function(Se){De.test(Se)&&(ce&&ve.compare(Se)!==-1||(ve=new G(ce=Se,_)))}),ce},t.minSatisfying=function(N,V,_){var ce=null,ve=null;try{var De=new he(V,_)}catch{return null}return N.forEach(function(Se){De.test(Se)&&(ce&&ve.compare(Se)!==1||(ve=new G(ce=Se,_)))}),ce},t.validRange=function(N,V){try{return new he(N,V).range||"*"}catch{return null}},t.ltr=function(N,V,_){return Ve(N,V,"<",_)},t.gtr=function(N,V,_){return Ve(N,V,">",_)},t.outside=Ve,t.prerelease=function(N,V){var _=ee(N,V);return _&&_.prerelease.length?_.prerelease:null},t.intersects=function(N,V,_){return N=new he(N,_),V=new he(V,_),N.intersects(V)},t.coerce=function(N){if(N instanceof G)return N;if(typeof N!="string")return null;var V=N.match(I[A]);return V==null?null:ee((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,C(1))},function(z,t){var C,D,P=z.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function I(c){if(C===setTimeout)return setTimeout(c,0);if((C===R||!C)&&setTimeout)return C=setTimeout,setTimeout(c,0);try{return C(c,0)}catch{try{return C.call(null,c,0)}catch{return C.call(this,c,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:R}catch{C=R}try{D=typeof clearTimeout=="function"?clearTimeout:L}catch{D=L}})();var u,g=[],b=!1,O=-1;function d(){b&&u&&(b=!1,u.length?g=u.concat(g):O=-1,g.length&&S())}function S(){if(!b){var c=I(d);b=!0;for(var h=g.length;h;){for(u=g,g=[];++O<h;)u&&u[O].run();O=-1,h=g.length}u=null,b=!1,function(E){if(D===clearTimeout)return clearTimeout(E);if((D===L||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(E);try{D(E)}catch{try{return D.call(null,E)}catch{return D.call(this,E)}}}(c)}}function p(c,h){this.fun=c,this.array=h}function m(){}P.nextTick=function(c){var h=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)h[E-1]=arguments[E];g.push(new p(c,h)),g.length!==1||b||I(S)},p.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=m,P.addListener=m,P.once=m,P.off=m,P.removeListener=m,P.removeAllListeners=m,P.emit=m,P.prependListener=m,P.prependOnceListener=m,P.listeners=function(c){return[]},P.binding=function(c){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(c){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[58],Z([0,1]),function(z,t){"use strict";var C;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class D{constructor(I,u,g){this.level=I,this.key=u,this.value=g,this.forward=[]}}const P=void 0;class R{constructor(I,u=2**16){this.comparator=I,this[C]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(u)|0),this._header=new D(this._maxLevel,P,P)}get size(){return this._size}clear(){this._header=new D(this._maxLevel,P,P)}has(I){return Boolean(R._search(this,I,this.comparator))}get(I){return R._search(this,I,this.comparator)?.value}set(I,u){return R._insert(this,I,u,this.comparator)&&(this._size+=1),this}delete(I){const u=R._delete(this,I,this.comparator);return u&&(this._size-=1),u}forEach(I,u){let g=this._header.forward[0];for(;g;)I.call(u,g.value,g.key,this),g=g.forward[0]}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this._header.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this._header.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this._header.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",u=this._header.forward[0];for(;u;)I+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return I}static _search(I,u,g){let b=I._header;for(let O=I._level-1;O>=0;O--)for(;b.forward[O]&&g(b.forward[O].key,u)<0;)b=b.forward[O];if(b=b.forward[0],b&&g(b.key,u)===0)return b}static _insert(I,u,g,b){let O=[],d=I._header;for(let S=I._level-1;S>=0;S--){for(;d.forward[S]&&b(d.forward[S].key,u)<0;)d=d.forward[S];O[S]=d}if(d=d.forward[0],d&&b(d.key,u)===0)return d.value=g,!1;{let S=R._randomLevel(I);if(S>I._level){for(let p=I._level;p<S;p++)O[p]=I._header;I._level=S}d=new D(S,u,g);for(let p=0;p<S;p++)d.forward[p]=O[p].forward[p],O[p].forward[p]=d;return!0}}static _randomLevel(I,u=.5){let g=1;for(;Math.random()<u&&g<I._maxLevel;)g+=1;return g}static _delete(I,u,g){let b=[],O=I._header;for(let d=I._level-1;d>=0;d--){for(;O.forward[d]&&g(O.forward[d].key,u)<0;)O=O.forward[d];b[d]=O}if(O=O.forward[0],!O||g(O.key,u)!==0)return!1;for(let d=0;d<I._level&&b[d].forward[d]===O;d++)b[d].forward[d]=O.forward[d];for(;I._level>0&&I._header.forward[I._level-1]===P;)I._level-=1;return!0}}t.SkipList=R}),define(Q[37],Z([0,1,7,2]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function P(a){const v=a;return v?[v.on,v.pause,v.resume,v.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=P;function R(a){const v=a;return v?P(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}t.isReadableBufferedStream=R;function L(a,v){return new I(a,v)}t.newWriteableStream=L;class I{constructor(v,o){this.reducer=v,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(v){if(!this.state.destroyed){if(this.state.flowing)this.emitData(v);else if(this.buffer.data.push(v),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(v){this.state.destroyed||(this.state.flowing?this.emitError(v):this.buffer.error.push(v))}end(v){this.state.destroyed||(typeof v!="undefined"&&this.write(v),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(v){this.listeners.data.slice(0).forEach(o=>o(v))}emitError(v){this.listeners.error.length===0?(0,C.onUnexpectedError)(v):this.listeners.error.slice(0).forEach(o=>o(v))}emitEnd(){this.listeners.end.slice(0).forEach(v=>v())}on(v,o){if(!this.state.destroyed)switch(v){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(v,o){if(this.state.destroyed)return;let n;switch(v){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const r=n.indexOf(o);r>=0&&n.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const v=this.reducer(this.buffer.data);this.emitData(v),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const v of this.buffer.error)this.emitError(v);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(a,v){const o=[];let n;for(;(n=a.read())!==null;)o.push(n);return v(o)}t.consumeReadable=u;function g(a,v,o){const n=[];let r;for(;(r=a.read())!==null&&n.length<o;)n.push(r);return r===null&&n.length>0?v(n):{read:()=>{if(n.length>0)return n.shift();if(typeof r!="undefined"){const e=r;return r=void 0,e}return a.read()}}}t.peekReadable=g;function b(a,v){return new Promise((o,n)=>{const r=[];O(a,{onData:e=>{v&&r.push(e)},onError:e=>{v?n(e):o(void 0)},onEnd:()=>{o(v?v(r):void 0)}})})}t.consumeStream=b;function O(a,v){let o=!1;return a.on("error",n=>{o||v.onError(n)}),a.on("end",()=>{o||v.onEnd()}),a.on("data",n=>{o||v.onData(n)}),(0,D.toDisposable)(()=>o=!0)}t.listenStream=O;function d(a,v){return new Promise((o,n)=>{const r=new D.DisposableStore,e=[],i=f=>{if(e.push(f),e.length>v)return r.dispose(),a.pause(),o({stream:a,buffer:e,ended:!1})},s=f=>n(f),l=()=>o({stream:a,buffer:e,ended:!0});r.add((0,D.toDisposable)(()=>a.removeListener("error",s))),a.on("error",s),r.add((0,D.toDisposable)(()=>a.removeListener("end",l))),a.on("end",l),r.add((0,D.toDisposable)(()=>a.removeListener("data",i))),a.on("data",i)})}t.peekStream=d;function S(a,v){const o=L(v);return o.end(a),o}t.toStream=S;function p(){const a=L(()=>{throw new Error("not supported")});return a.end(),a}t.emptyStream=p;function m(a){let v=!1;return{read:()=>v?null:(v=!0,a)}}t.toReadable=m;function c(a,v,o){const n=L(o);return O(a,{onData:r=>n.write(v.data(r)),onError:r=>n.error(v.error?v.error(r):r),onEnd:()=>n.end()}),n}t.transform=c;function h(a,v,o){let n=!1;return{read:()=>{const r=v.read();return n?r:(n=!0,r!==null?o([a,r]):a)}}}t.prefixedReadable=h;function E(a,v,o){let n=!1;const r=L(o);return O(v,{onData:e=>n?r.write(e):(n=!0,r.write(o([a,e]))),onError:e=>r.error(e),onEnd:()=>{n||(n=!0,r.write(a)),r.end()}}),r}t.prefixedStream=E}),define(Q[17],Z([0,1,37]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let P,R;class L{constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}static alloc(y){return D?new L(Buffer.allocUnsafe(y)):new L(new Uint8Array(y))}static wrap(y){return D&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new L(y)}static fromString(y,w){return!(w?.dontUseNodeBuffer||!1)&&D?new L(Buffer.from(y)):(P||(P=new TextEncoder),new L(P.encode(y)))}static fromByteArray(y){const w=L.alloc(y.length);for(let T=0,A=y.length;T<A;T++)w.buffer[T]=y[T];return w}static concat(y,w){if(typeof w=="undefined"){w=0;for(let B=0,J=y.length;B<J;B++)w+=y[B].byteLength}const T=L.alloc(w);let A=0;for(let B=0,J=y.length;B<J;B++){const se=y[B];T.set(se,A),A+=se.byteLength}return T}clone(){const y=L.alloc(this.byteLength);return y.set(this),y}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(y,w){return new L(this.buffer.subarray(y,w))}set(y,w){if(y instanceof L)this.buffer.set(y.buffer,w);else if(y instanceof Uint8Array)this.buffer.set(y,w);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),w);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),w);else throw new Error("Unkown argument 'array'")}readUInt32BE(y){return g(this.buffer,y)}writeUInt32BE(y,w){b(this.buffer,y,w)}readUInt32LE(y){return O(this.buffer,y)}writeUInt32LE(y,w){d(this.buffer,y,w)}readUInt8(y){return S(this.buffer,y)}writeUInt8(y,w){p(this.buffer,y,w)}}t.VSBuffer=L;function I(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0}t.readUInt16LE=I;function u(f,y,w){f[w+0]=y&255,y=y>>>8,f[w+1]=y&255}t.writeUInt16LE=u;function g(f,y){return f[y]*2**24+f[y+1]*2**16+f[y+2]*2**8+f[y+3]}t.readUInt32BE=g;function b(f,y,w){f[w+3]=y,y=y>>>8,f[w+2]=y,y=y>>>8,f[w+1]=y,y=y>>>8,f[w]=y}t.writeUInt32BE=b;function O(f,y){return f[y+0]<<0>>>0|f[y+1]<<8>>>0|f[y+2]<<16>>>0|f[y+3]<<24>>>0}t.readUInt32LE=O;function d(f,y,w){f[w+0]=y&255,y=y>>>8,f[w+1]=y&255,y=y>>>8,f[w+2]=y&255,y=y>>>8,f[w+3]=y&255}t.writeUInt32LE=d;function S(f,y){return f[y]}t.readUInt8=S;function p(f,y,w){f[w]=y}t.writeUInt8=p;function m(f){return C.consumeReadable(f,y=>L.concat(y))}t.readableToBuffer=m;function c(f){return C.toReadable(f)}t.bufferToReadable=c;function h(f){return C.consumeStream(f,y=>L.concat(y))}t.streamToBuffer=h;async function E(f){return f.ended?L.concat(f.buffer):L.concat([...f.buffer,await h(f.stream)])}t.bufferedStreamToBuffer=E;function a(f){return C.toStream(f,y=>L.concat(y))}t.bufferToStream=a;function v(f){return C.transform(f,{data:y=>typeof y=="string"?L.fromString(y):L.wrap(y)},y=>L.concat(y))}t.streamToBufferReadableStream=v;function o(f){return C.newWriteableStream(y=>L.concat(y),f)}t.newWriteableBufferStream=o;function n(f,y){return C.prefixedReadable(f,y,w=>L.concat(w))}t.prefixedBufferReadable=n;function r(f,y){return C.prefixedStream(f,y,w=>L.concat(w))}t.prefixedBufferStream=r;function e(f){let y=0,w=0,T=0;const A=new Uint8Array(Math.floor(f.length/4*3)),B=se=>{switch(w){case 3:A[T++]=y|se,w=0;break;case 2:A[T++]=y|se>>>2,y=se<<6,w=3;break;case 1:A[T++]=y|se>>>4,y=se<<4,w=2;break;default:y=se<<2,w=1}};for(let se=0;se<f.length;se++){const ie=f.charCodeAt(se);if(ie>=65&&ie<=90)B(ie-65);else if(ie>=97&&ie<=122)B(ie-97+26);else if(ie>=48&&ie<=57)B(ie-48+52);else if(ie===43||ie===45)B(62);else if(ie===47||ie===95)B(63);else{if(ie===61)break;throw new SyntaxError(`Unexpected base64 character ${f[se]}`)}}const J=T;for(;w>0;)B(0);return L.wrap(A).slice(0,J)}t.decodeBase64=e;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:f},y=!0,w=!1){const T=w?s:i;let A="";const B=f.byteLength%3;let J=0;for(;J<f.byteLength-B;J+=3){const se=f[J+0],ie=f[J+1],te=f[J+2];A+=T[se>>>2],A+=T[(se<<4|ie>>>4)&63],A+=T[(ie<<2|te>>>6)&63],A+=T[te&63]}if(B===1){const se=f[J+0];A+=T[se>>>2],A+=T[se<<4&63],y&&(A+="==")}else if(B===2){const se=f[J+0],ie=f[J+1];A+=T[se>>>2],A+=T[(se<<4|ie>>>4)&63],A+=T[ie<<2&63],y&&(A+="=")}return A}t.encodeBase64=l}),define(Q[59],Z([0,1,26]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function D(h){return P(h,0)}t.hash=D;function P(h,E){switch(typeof h){case"object":return h===null?R(349,E):Array.isArray(h)?u(h,E):g(h,E);case"string":return I(h,E);case"boolean":return L(h,E);case"number":return R(h,E);case"undefined":return R(937,E);default:return R(617,E)}}t.doHash=P;function R(h,E){return(E<<5)-E+h|0}t.numberHash=R;function L(h,E){return R(h?433:863,E)}function I(h,E){E=R(149417,E);for(let a=0,v=h.length;a<v;a++)E=R(h.charCodeAt(a),E);return E}t.stringHash=I;function u(h,E){return E=R(104579,E),h.reduce((a,v)=>P(v,a),E)}function g(h,E){return E=R(181387,E),Object.keys(h).sort().reduce((a,v)=>(a=I(v,a),P(h[v],a)),E)}class b{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=P(E,this._value),this._value}}t.Hasher=b;var O;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function d(h,E,a=32){const v=a-E,o=~((1<<v)-1);return(h<<E|(o&h)>>>v)>>>0}function S(h,E=0,a=h.byteLength,v=0){for(let o=0;o<a;o++)h[E+o]=v}function p(h,E,a="0"){for(;h.length<E;)h=a+h;return h}function m(h,E=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(a=>a.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),E/4)}t.toHexString=m;class c{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const a=E.length;if(a===0)return;const v=this._buff;let o=this._buffLen,n=this._leftoverHighSurrogate,r,e;for(n!==0?(r=n,e=-1,n=0):(r=E.charCodeAt(0),e=0);;){let i=r;if(C.isHighSurrogate(r))if(e+1<a){const s=E.charCodeAt(e+1);C.isLowSurrogate(s)?(e++,i=C.computeCodePoint(r,s)):i=65533}else{n=r;break}else C.isLowSurrogate(r)&&(i=65533);if(o=this._push(v,o,i),e++,e<a)r=E.charCodeAt(e);else break}this._buffLen=o,this._leftoverHighSurrogate=n}_push(E,a,v){return v<128?E[a++]=v:v<2048?(E[a++]=192|(v&1984)>>>6,E[a++]=128|(v&63)>>>0):v<65536?(E[a++]=224|(v&61440)>>>12,E[a++]=128|(v&4032)>>>6,E[a++]=128|(v&63)>>>0):(E[a++]=240|(v&1835008)>>>18,E[a++]=128|(v&258048)>>>12,E[a++]=128|(v&4032)>>>6,E[a++]=128|(v&63)>>>0),a>=64&&(this._step(),a-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),a}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=c._bigBlock32,a=this._buffDV;for(let f=0;f<64;f+=4)E.setUint32(f,a.getUint32(f,!1),!1);for(let f=64;f<320;f+=4)E.setUint32(f,d(E.getUint32(f-12,!1)^E.getUint32(f-32,!1)^E.getUint32(f-56,!1)^E.getUint32(f-64,!1),1),!1);let v=this._h0,o=this._h1,n=this._h2,r=this._h3,e=this._h4,i,s,l;for(let f=0;f<80;f++)f<20?(i=o&n|~o&r,s=1518500249):f<40?(i=o^n^r,s=1859775393):f<60?(i=o&n|o&r|n&r,s=2400959708):(i=o^n^r,s=3395469782),l=d(v,5)+i+e+s+E.getUint32(f*4,!1)&4294967295,e=r,r=n,n=d(o,30),o=v,v=l;this._h0=this._h0+v&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+e&4294967295}}t.StringSHA1=c,c._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[21],Z([0,1,8]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const c=Array.isArray(m)?[]:{};return Object.keys(m).forEach(h=>{m[h]&&typeof m[h]=="object"?c[h]=D(m[h]):c[h]=m[h]}),c}t.deepClone=D;function P(m){if(!m||typeof m!="object")return m;const c=[m];for(;c.length>0;){const h=c.shift();Object.freeze(h);for(const E in h)if(R.call(h,E)){const a=h[E];typeof a=="object"&&!Object.isFrozen(a)&&c.push(a)}}return m}t.deepFreeze=P;const R=Object.prototype.hasOwnProperty;function L(m,c){return I(m,c,new Set)}t.cloneAndChange=L;function I(m,c,h){if((0,C.isUndefinedOrNull)(m))return m;const E=c(m);if(typeof E!="undefined")return E;if((0,C.isArray)(m)){const a=[];for(const v of m)a.push(I(v,c,h));return a}if((0,C.isObject)(m)){if(h.has(m))throw new Error("Cannot clone recursive data-structure");h.add(m);const a={};for(let v in m)R.call(m,v)&&(a[v]=I(m[v],c,h));return h.delete(m),a}return m}function u(m,c,h=!0){return(0,C.isObject)(m)?((0,C.isObject)(c)&&Object.keys(c).forEach(E=>{E in m?h&&((0,C.isObject)(m[E])&&(0,C.isObject)(c[E])?u(m[E],c[E],h):m[E]=c[E]):m[E]=c[E]}),m):c}t.mixin=u;function g(m,c){if(m===c)return!0;if(m==null||c===null||c===void 0||typeof m!=typeof c||typeof m!="object"||Array.isArray(m)!==Array.isArray(c))return!1;let h,E;if(Array.isArray(m)){if(m.length!==c.length)return!1;for(h=0;h<m.length;h++)if(!g(m[h],c[h]))return!1}else{const a=[];for(E in m)a.push(E);a.sort();const v=[];for(E in c)v.push(E);if(v.sort(),!g(a,v))return!1;for(h=0;h<a.length;h++)if(!g(m[a[h]],c[a[h]]))return!1}return!0}t.equals=g;function b(m){const c=new Set;return JSON.stringify(m,(h,E)=>{if((0,C.isObject)(E)||Array.isArray(E)){if(c.has(E))return"[Circular]";c.add(E)}return E})}t.safeStringify=b;function O(m,c,h){const E=c(m);return typeof E=="undefined"?h:E}t.getOrDefault=O;function d(m,c){const h=Object.create(null);return!m||!c||Object.keys(c).forEach(a=>{const v=m[a],o=c[a];g(v,o)||(h[a]=o)}),h}t.distinct=d;function S(m,c){const h=c.toLowerCase(),E=Object.keys(m).find(a=>a.toLowerCase()===h);return E?m[E]:m[c]}t.getCaseInsensitive=S;function p(m,c){const h=Object.create(null);for(const[E,a]of Object.entries(m))c(E,a)&&(h[E]=a);return h}t.filter=p}),define(Q[60],Z([0,1,9]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(g){const b=g;return b&&typeof b.type=="string"&&typeof b.severity=="string"}t.isRemoteConsoleLog=D;function P(g){const b=[];let O;try{const d=JSON.parse(g.arguments),S=d[d.length-1];S&&S.__$stack&&(d.pop(),O=S.__$stack),b.push(...d)}catch{b.push("Unable to log remote console arguments",g.arguments)}return{args:b,stack:O}}t.parse=P;function R(g){if(typeof g!="string")return R(P(g).stack);const b=g;if(b){const O=L(b),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(d&&d.length===4)return{uri:C.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}t.getFirstFrame=R;function L(g){if(!g)return g;const b=g.indexOf(`
`);return b===-1?g:g.substring(0,b)}function I(g,b){const{args:O,stack:d}=P(g),S=typeof O[0]=="string"&&O.length===1;let p=L(d);p&&(p=`(${p.trim()})`);let m=[];if(typeof O[0]=="string"?p&&S?m=[`%c[${b}] %c${O[0]} %c${p}`,u("blue"),u(""),u("grey")]:m=[`%c[${b}] %c${O[0]}`,u("blue"),u(""),...O.slice(1)]:m=[`%c[${b}]%`,u("blue"),...O],p&&!S&&m.push(p),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,m)}t.log=I;function u(g){return`color: ${g}`}}),define(Q[61],Z([0,1,17,26,9]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function R(b){return JSON.stringify(b,u)}t.stringify=R;function L(b){let O=JSON.parse(b);return O=g(O),O}t.parse=L;var I;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext",b[b.Date=14]="Date"})(I=t.MarshalledId||(t.MarshalledId={}));function u(b,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,D.regExpFlags)(O)}:O}function g(b,O=0){if(!b||O>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return P.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 14:return new Date(b.source)}if(b instanceof C.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let d=0;d<b.length;++d)b[d]=g(b[d],O+1);else for(const d in b)Object.hasOwnProperty.call(b,d)&&(b[d]=g(b[d],O+1))}return b}t.revive=g}),define(Q[62],Z([0,1,45,10,11,12,19,26,9]),function(z,t,C,D,P,R,L,I,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function g(i,s,l){if(typeof i=="string"&&(i=u.URI.file(i)),l){const y=l.getWorkspaceFolder(i);if(y){const w=l.getWorkspace().folders.length>1;let T;if((0,L.isEqual)(y.uri,i)?T="":T=(0,L.relativePath)(y.uri,i),w){const A=y.name?y.name:(0,L.basename)(y.uri);T=T?A+" \u2022 "+T:A}return T}}if(i.scheme!==D.Schemas.file&&i.scheme!==D.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,C.hasDriveLetter)(i.fsPath))return(0,P.normalize)(O(i.fsPath));let f=(0,P.normalize)(i.fsPath);return!R.isWindows&&s?.userHome&&(f=S(f,s.userHome.fsPath)),f}t.getPathLabel=g;function b(i){if(!i)return;typeof i=="string"&&(i=u.URI.file(i));const s=(0,L.basename)(i)||(i.scheme===D.Schemas.file?i.fsPath:i.path);return R.isWindows&&(0,C.isRootOrDriveLetter)(s)?O(s):s}t.getBaseLabel=b;function O(i,s){return(0,C.hasDriveLetter)(i,s)?i.charAt(0).toUpperCase()+i.slice(1):i}t.normalizeDriveLetter=O;let d=Object.create(null);function S(i,s){if(R.isWindows||!i||!s)return i;let l=d.original===s?d.normalized:void 0;return l||(l=`${(0,I.rtrim)(s,P.posix.sep)}${P.posix.sep}`,d={original:s,normalized:l}),(R.isLinux?i.startsWith(l):(0,I.startsWithIgnoreCase)(i,l))&&(i=`~/${i.substr(l.length)}`),i}t.tildify=S;function p(i,s){return i.replace(/^~($|\/|\\)/,`${s}$1`)}t.untildify=p;const m="\u2026",c="\\\\",h="~";function E(i,s=P.sep){const l=new Array(i.length);let f=!1;for(let y=0;y<i.length;y++){let w=i[y];if(w===""){l[y]=`.${s}`;continue}if(!w){l[y]=w;continue}f=!0;let T="";w.indexOf(c)===0?(T=w.substr(0,w.indexOf(c)+c.length),w=w.substr(w.indexOf(c)+c.length)):w.indexOf(s)===0?(T=w.substr(0,w.indexOf(s)+s.length),w=w.substr(w.indexOf(s)+s.length)):w.indexOf(h)===0&&(T=w.substr(0,w.indexOf(h)+h.length),w=w.substr(w.indexOf(h)+h.length));const A=w.split(s);for(let B=1;f&&B<=A.length;B++)for(let J=A.length-B;f&&J>=0;J--){f=!1;let se=A.slice(J,J+B).join(s);for(let ie=0;!f&&ie<i.length;ie++)if(ie!==y&&i[ie]&&i[ie].indexOf(se)>-1){const te=J+B===A.length,ge=J>0&&i[ie].indexOf(s)>-1?s+se:se,$=i[ie].endsWith(ge);f=!te||$}if(!f){let ie="";(A[0].endsWith(":")||T!=="")&&(J===1&&(J=0,B++,se=A[0]+s+se),J>0&&(ie=A[0]+s),ie=T+ie),J>0&&(ie=ie+m+s),ie=ie+se,J+B<A.length&&(ie=ie+s+m),l[y]=ie}}f&&(l[y]=w)}return l}t.shorten=E;var a;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function v(i,s=Object.create(null)){const l=[];let f=!1,y="";for(const w of i)if(w==="$"||f&&w==="{")y&&l.push({value:y,type:a.TEXT}),y="",f=!0;else if(w==="}"&&f){const T=s[y];if(typeof T=="string")T.length&&l.push({value:T,type:a.VARIABLE});else if(T){const A=l[l.length-1];(!A||A.type!==a.SEPARATOR)&&l.push({value:T.label,type:a.SEPARATOR})}y="",f=!1}else y+=w;return y&&!f&&l.push({value:y,type:a.TEXT}),l.filter((w,T)=>{if(w.type===a.SEPARATOR){const A=l[T-1],B=l[T+1];return[A,B].every(J=>J&&(J.type===a.VARIABLE||J.type===a.TEXT)&&J.value.length>0)}return!0}).map(w=>w.value).join("")}t.template=v;function o(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function n(i,s){return R.isMacintosh||s?i.replace(/\(&&\w\)|&&/g,""):R.isWindows?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}t.mnemonicButtonLabel=n;function r(i){return i.replace(/&/g,"&&")}t.unmnemonicLabel=r;function e(i){const s=i.indexOf("/")!==-1?P.posix:P.win32,l=s.basename(i),f=s.dirname(i);return l.length?{name:l,parentPath:f}:{name:f,parentPath:""}}t.splitName=e}),define(Q[27],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(u){return C.test(u)}t.isUUID=D;const P=new Uint8Array(16),R=[];for(let u=0;u<256;u++)R.push(u.toString(16).padStart(2,"0"));let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(u){for(let g=0;g<u.length;g++)u[g]=Math.floor(Math.random()*256);return u};function I(){L(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let u=0,g="";return g+=R[P[u++]],g+=R[P[u++]],g+=R[P[u++]],g+=R[P[u++]],g+="-",g+=R[P[u++]],g+=R[P[u++]],g+="-",g+=R[P[u++]],g+=R[P[u++]],g+="-",g+=R[P[u++]],g+=R[P[u++]],g+="-",g+=R[P[u++]],g+=R[P[u++]],g+=R[P[u++]],g+=R[P[u++]],g+=R[P[u++]],g+=R[P[u++]],g}t.generateUuid=I}),define(Q[63],Z([0,1,131]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(R="utf8"){this.stringDecoder=new C.StringDecoder(R),this.remaining=null}write(R){const L=[],I=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(I.length<1)return L;let u=0,g,b=u;for(;b<I.length;)if(g=I.charCodeAt(b),g===13||g===10){if(L.push(I.substring(u,b)),b++,b<I.length){const O=g;g=I.charCodeAt(b),(O===13&&g===10||O===10&&g===13)&&b++}u=b}else b++;return this.remaining=u<I.length?I.substr(u):null,L}end(){return this.remaining}}t.LineDecoder=D}),define(Q[64],Z([0,1,33,11,15]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,L=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var u;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(u||(u={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class O{constructor(o,n,r){this.exePath=o,this.displayName=n,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await P.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:v=!1}={}){return v?g===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:v=!1,findPreview:o=!1}={}){const n=d({useAlternateBitness:v});if(!n)return null;const r=D.join(n,"PowerShell");if(!await P.SymlinkSupport.existsDirectory(r))return null;let e=-1,i=null;for(const f of await P.Promises.readdir(r)){let y=-1;if(o){const T=f.indexOf("-");if(T<0)continue;const A=f.substring(0,T);if(!R.test(A)||f.substring(T+1)!=="preview")continue;y=parseInt(A,10)}else{if(!R.test(f))continue;y=parseInt(f,10)}if(y<=e)continue;const w=D.join(r,f,"pwsh.exe");!await P.SymlinkSupport.existsFile(w)||(i=w,e=y)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",l=o?" Preview":"";return new O(i,`PowerShell${l}${s}`,!0)}async function p({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await P.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=v?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const e of await P.Promises.readdir(o))if(n.test(e)){const i=D.join(o,e,"pwsh.exe");return new O(i,r)}return null}function m(){const v=D.join(C.homedir(),".dotnet","tools","pwsh.exe");return new O(v,".NET Core PowerShell Global Tool")}function c(){const v=D.join(process.env.windir,g===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(v,"Windows PowerShell",!0)}async function*h(){let v=await S();v&&(yield v),v=await S({useAlternateBitness:!0}),v&&(yield v),v=await p(),v&&(yield v),v=m(),v&&(yield v),v=await S({findPreview:!0}),v&&(yield v),v=await p({findPreview:!0}),v&&(yield v),v=await S({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=c(),v&&(yield v)}async function*E(){for await(const v of h())await v.exists()&&(yield v)}t.enumeratePowerShellInstallations=E;async function a(){for await(const v of E())return v;return null}t.getFirstAvailablePowerShellInstallation=a});var pe=this&&this.__decorate||function(z,t,C,D){var P=arguments.length,R=P<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,C):D,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(z,t,C,D);else for(var I=z.length-1;I>=0;I--)(L=z[I])&&(R=(P<3?L(R):P>3?L(t,C,R):L(t,C))||R);return P>3&&R&&Object.defineProperty(t,C,R),R};define(Q[46],Z([0,1,18,3,17,24,44,7,6,2,61,26,8]),function(z,t,C,D,P,R,L,I,u,g,b,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=t.RequestType||(t.RequestType={}));function p(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(m=t.ResponseType||(t.ResponseType={}));function c(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(h||(h={}));class E{constructor(F){this.buffer=F,this.pos=0}read(F){const W=this.buffer.slice(this.pos,this.pos+F);return this.pos+=W.byteLength,W}}class a{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var v;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(v||(v={}));function o(M){const F=P.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function n(M){return M.read(4).readUInt32BE(0)}function r(M){const F=P.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const e={Undefined:r(v.Undefined),String:r(v.String),Buffer:r(v.Buffer),VSBuffer:r(v.VSBuffer),Array:r(v.Array),Object:r(v.Object)},i=typeof Buffer!="undefined";function s(M,F){if(typeof F=="undefined")M.write(e.Undefined);else if(typeof F=="string"){const W=P.VSBuffer.fromString(F);M.write(e.String),M.write(o(W.byteLength)),M.write(W)}else if(i&&Buffer.isBuffer(F)){const W=P.VSBuffer.wrap(F);M.write(e.Buffer),M.write(o(W.byteLength)),M.write(W)}else if(F instanceof P.VSBuffer)M.write(e.VSBuffer),M.write(o(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(e.Array),M.write(o(F.length));for(const W of F)s(M,W)}else{const W=P.VSBuffer.fromString(JSON.stringify(F));M.write(e.Object),M.write(o(W.byteLength)),M.write(W)}}function l(M){switch(M.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return M.read(n(M)).toString();case v.Buffer:return M.read(n(M)).buffer;case v.VSBuffer:return M.read(n(M));case v.Array:{const W=n(M),H=[];for(let ne=0;ne<W;ne++)H.push(l(M));return H}case v.Object:return JSON.parse(M.read(n(M)).toString())}}class f{constructor(F,W,H=null,ne=1e3){this.protocol=F,this.ctx=W,this.logger=H,this.timeoutDelay=ne,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(F,W){this.channels.set(F,W),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const W=this.send([F.type]);this.logger&&this.logger.logOutgoing(W,0,1,c(F.type));return}case 201:case 202:case 204:case 203:{const W=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(W,F.id,1,c(F.type),F.data);return}}}send(F,W=void 0){const H=new a;return s(H,F),s(H,W),this.sendBuffer(H.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const W=new E(F),H=l(W),ne=l(W),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${p(K)}: ${H[2]}.${H[3]}`,ne),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${p(K)}: ${H[2]}.${H[3]}`,ne),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ne});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${p(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],1,`${p(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const H=new R.CancellationTokenSource;let ne;try{ne=W.call(this.ctx,F.name,F.arg,H.token)}catch(G){ne=Promise.reject(G)}const K=F.id;ne.then(G=>{this.sendResponse({id:K,data:G,type:201}),this.activeRequests.delete(F.id)},G=>{G instanceof Error?this.sendResponse({id:K,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:K,data:G,type:203}),this.activeRequests.delete(F.id)});const ee=(0,g.toDisposable)(()=>H.cancel());this.activeRequests.set(F.id,ee)}onEventListen(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const H=F.id,K=W.listen(this.ctx,F.name,F.arg)(ee=>this.sendResponse({id:H,data:ee,type:204}));this.activeRequests.set(F.id,K)}disposeActiveRequest(F){const W=this.activeRequests.get(F.id);W&&(W.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let W=this.pendingRequests.get(F.channelName);W||(W=[],this.pendingRequests.set(F.channelName,W));const H=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:F,timeoutTimer:H})}flushPendingRequests(F){const W=this.pendingRequests.get(F);if(W){for(const H of W)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}t.ChannelServer=f;var y;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(y=t.RequestInitiator||(t.RequestInitiator={}));class w{constructor(F,W=null){this.protocol=F,this.isDisposed=!1,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=W}getChannel(F){const W=this;return{call(H,ne,K){return W.isDisposed?Promise.reject(I.canceled()):W.requestPromise(F,H,ne,K)},listen(H,ne){return W.isDisposed?Promise.reject(I.canceled()):W.requestEvent(F,H,ne)}}}requestPromise(F,W,H,ne=R.CancellationToken.None){const K=this.lastRequestId++,G={id:K,type:100,channelName:F,name:W,arg:H};if(ne.isCancellationRequested)return Promise.reject(I.canceled());let ae;return new Promise((k,x)=>{if(ne.isCancellationRequested)return x(I.canceled());const j=()=>{const le=Ee=>{switch(Ee.type){case 201:this.handlers.delete(K),k(Ee.data);break;case 202:{this.handlers.delete(K);const de=new Error(Ee.data.message);de.stack=Ee.data.stack,de.name=Ee.data.name,x(de);break}case 203:this.handlers.delete(K),x(Ee.data);break}};this.handlers.set(K,le),this.sendRequest(G)};let Y=null;this.state===h.Idle?j():(Y=(0,D.createCancelablePromise)(le=>this.whenInitialized()),Y.then(()=>{Y=null,j()}));const X=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:K,type:101}),x(I.canceled())},fe=ne.onCancellationRequested(X);ae=(0,g.combinedDisposable)((0,g.toDisposable)(X),fe),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(F,W,H){const ne=this.lastRequestId++,ee={id:ne,type:102,channelName:F,name:W,arg:H};let G=null;const ae=new u.Emitter({onFirstListenerAdd:()=>{G=(0,D.createCancelablePromise)(k=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(ae),this.sendRequest(ee)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(ae),this.sendRequest({id:ne,type:103}))}}),U=k=>ae.fire(k.data);return this.handlers.set(ne,U),ae.event}sendRequest(F){switch(F.type){case 100:case 102:{const W=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(W,F.id,0,`${p(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(W,F.id,0,p(F.type));return}}}send(F,W=void 0){const H=new a;return s(H,F),s(H,W),this.sendBuffer(H.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const W=new E(F),H=l(W),ne=l(W),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,c(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,H[1],0,c(K),ne),this.onResponse({type:H[0],id:H[1],data:ne})}}onResponse(F){if(F.type===200){this.state=h.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(F.id);W&&W(F)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}pe([L.memoize],w.prototype,"onDidInitializePromise",null),t.ChannelClient=w;class T{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:W,onDidClientDisconnect:H})=>{u.Event.once(W.onMessage)(K=>{const ee=new E(K),G=l(ee),ae=new f(W,G),U=new w(W);this.channels.forEach((x,j)=>ae.registerChannel(j,x));const k={channelServer:ae,channelClient:U,ctx:G};this._connections.add(k),this._onDidAddConnection.fire(k),H(()=>{ae.dispose(),U.dispose(),this._connections.delete(k),this._onDidRemoveConnection.fire(k)})})})}get connections(){const F=[];return this._connections.forEach(W=>F.push(W)),F}getChannel(F,W){const H=this;return{call(ne,K,ee){let G;if((0,d.isFunction)(W)){let U=(0,C.getRandomElement)(H.connections.filter(W));G=U?Promise.resolve(U):u.Event.toPromise(u.Event.filter(H.onDidAddConnection,W))}else G=W.routeCall(H,ne,K);const ae=G.then(U=>U.channelClient.getChannel(F));return B(ae).call(ne,K,ee)},listen(ne,K){if((0,d.isFunction)(W))return H.getMulticastEvent(F,W,ne,K);const ee=W.routeEvent(H,ne,K).then(G=>G.channelClient.getChannel(F));return B(ee).listen(ne,K)}}}getMulticastEvent(F,W,H,ne){const K=this;let ee=new g.DisposableStore;const G=new u.Emitter({onFirstListenerAdd:()=>{ee=new g.DisposableStore;const ae=new u.EventMultiplexer,U=new Map,k=j=>{const X=j.channelClient.getChannel(F).listen(H,ne),fe=ae.add(X);U.set(j,fe)},x=j=>{const Y=U.get(j);!Y||(Y.dispose(),U.delete(j))};K.connections.filter(W).forEach(k),u.Event.filter(K.onDidAddConnection,W)(k,void 0,ee),K.onDidRemoveConnection(x,void 0,ee),ae.event(G.fire,G,ee),ee.add(ae)},onLastListenerRemove:()=>{ee.dispose()}});return G.event}registerChannel(F,W){this.channels.set(F,W),this._connections.forEach(H=>{H.channelServer.registerChannel(F,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=T;class A{constructor(F,W,H=null){const ne=new a;s(ne,W),F.send(ne.buffer),this.channelClient=new w(F,H),this.channelServer=new f(F,W,H)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,W){this.channelServer.registerChannel(F,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=A;function B(M){return{call(F,W,H){return M.then(ne=>ne.call(F,W,H))},listen(F,W){const H=new u.Relay;return M.then(ne=>H.input=ne.listen(F,W)),H.event}}}t.getDelayedChannel=B;function J(M){let F=!1;return{call(W,H,ne){return F?M.call(W,H,ne):(0,D.timeout)(0).then(()=>F=!0).then(()=>M.call(W,H,ne))},listen(W,H){if(F)return M.listen(W,H);const ne=new u.Relay;return(0,D.timeout)(0).then(()=>F=!0).then(()=>ne.input=M.listen(W,H)),ne.event}}}t.getNextTickChannel=J;class se{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const W of F.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await u.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=se;var ie;(function(M){function F(K,ee){const G=K,ae=ee&&ee.disableMarshalling,U=new Map;for(const k in G)H(k)&&U.set(k,u.Event.buffer(G[k],!0));return new class{listen(k,x,j){const Y=U.get(x);if(Y)return Y;if(ne(x)){const X=G[x];if(typeof X=="function")return X.call(G,j)}throw new Error(`Event not found: ${x}`)}call(k,x,j){const Y=G[x];if(typeof Y=="function"){if(!ae&&Array.isArray(j))for(let X=0;X<j.length;X++)j[X]=(0,b.revive)(j[X]);return Y.apply(G,j)}throw new Error(`Method not found: ${x}`)}}}M.fromService=F;function W(K,ee){const G=ee&&ee.disableMarshalling;return new Proxy({},{get(ae,U){if(typeof U=="string")return ee?.properties?.has(U)?ee.properties.get(U):ne(U)?function(k){return K.listen(U,k)}:H(U)?K.listen(U):async function(...k){let x;ee&&!(0,d.isUndefinedOrNull)(ee.context)?x=[ee.context,...k]:x=k;const j=await K.call(U,x);return G?j:(0,b.revive)(j)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=W;function H(K){return K[0]==="o"&&K[1]==="n"&&O.isUpperAsciiLetter(K.charCodeAt(2))}function ne(K){return/^onDynamic/.test(K)&&O.isUpperAsciiLetter(K.charCodeAt(9))}})(ie=t.ProxyChannel||(t.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let F=M.toString();if(F!=="[object Object]")return F}return M}function $(M){return Array.isArray(M)?M.map(ge):ge(M)}function q(M,F,W,H,ne,K,ee){ee=$(ee);const G=te[ne],ae=G[H%G.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(K)?(U=U.concat(ee),U.push(")")):U.push(ee),console.log.apply(console,U)}t.logWithColors=q;class re{constructor(F,W){this._outgoingPrefix=F,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,W,H,ne,K){this._totalOutgoing+=F,q(this._outgoingPrefix,this._totalOutgoing,F,W,H,ne,K)}logIncoming(F,W,H,ne,K){this._totalIncoming+=F,q(this._incomingPrefix,this._totalIncoming,F,W,H,ne,K)}}t.IPCLogger=re}),define(Q[65],Z([0,1,3,6,2,8]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var L;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(L=t.StorageHint||(t.StorageHint={}));function I(O){const d=O;return d?.changed instanceof Map||d?.deleted instanceof Set}t.isStorageItemsChangeEvent=I;var u;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(u||(u={}));class g extends P.Disposable{constructor(d,S=Object.create(null)){super();this.database=d,this.options=S,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=u.None,this.cache=new Map,this.flushDelayer=new C.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((S,p)=>this.accept(p,S)),d.deleted?.forEach(S=>this.accept(S,void 0))}accept(d,S){if(this.state===u.Closed)return;let p=!1;(0,R.isUndefinedOrNull)(S)?p=this.cache.delete(d):this.cache.get(d)!==S&&(this.cache.set(d,S),p=!0),p&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===u.None&&(this.state=u.Initialized,this.options.hint!==L.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,S){const p=this.cache.get(d);return(0,R.isUndefinedOrNull)(p)?S:p}getBoolean(d,S){const p=this.get(d);return(0,R.isUndefinedOrNull)(p)?S:p==="true"}getNumber(d,S){const p=this.get(d);return(0,R.isUndefinedOrNull)(p)?S:parseInt(p,10)}async set(d,S){if(this.state===u.Closed)return;if((0,R.isUndefinedOrNull)(S))return this.delete(d);const p=String(S);if(this.cache.get(d)!==p)return this.cache.set(d,p),this.pendingInserts.set(d,p),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===u.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=u.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((S,p)=>this.items.set(p,S)),d.delete&&d.delete.forEach(S=>this.items.delete(S))}async close(){}}t.InMemoryStorageDatabase=b}),define(Q[66],Z([4,5]),function(z,t){return z.create("vs/base/common/date",t)}),define(Q[67],Z([0,1,66]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,P=D*60,R=P*24,L=R*7,I=R*30,u=R*365;function g(O,d,S){typeof O!="number"&&(O=O.getTime());const p=Math.round((new Date().getTime()-O)/1e3);if(p<-30)return(0,C.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(p<30)return(0,C.localize)(1,null);let m;return p<D?(m=p,d?m===1?S?(0,C.localize)(2,null,m):(0,C.localize)(3,null,m):S?(0,C.localize)(4,null,m):(0,C.localize)(5,null,m):m===1?S?(0,C.localize)(6,null,m):(0,C.localize)(7,null,m):S?(0,C.localize)(8,null,m):(0,C.localize)(9,null,m)):p<P?(m=Math.floor(p/D),d?m===1?S?(0,C.localize)(10,null,m):(0,C.localize)(11,null,m):S?(0,C.localize)(12,null,m):(0,C.localize)(13,null,m):m===1?S?(0,C.localize)(14,null,m):(0,C.localize)(15,null,m):S?(0,C.localize)(16,null,m):(0,C.localize)(17,null,m)):p<R?(m=Math.floor(p/P),d?m===1?S?(0,C.localize)(18,null,m):(0,C.localize)(19,null,m):S?(0,C.localize)(20,null,m):(0,C.localize)(21,null,m):m===1?S?(0,C.localize)(22,null,m):(0,C.localize)(23,null,m):S?(0,C.localize)(24,null,m):(0,C.localize)(25,null,m)):p<L?(m=Math.floor(p/R),d?m===1?(0,C.localize)(26,null,m):(0,C.localize)(27,null,m):m===1?(0,C.localize)(28,null,m):(0,C.localize)(29,null,m)):p<I?(m=Math.floor(p/L),d?m===1?S?(0,C.localize)(30,null,m):(0,C.localize)(31,null,m):S?(0,C.localize)(32,null,m):(0,C.localize)(33,null,m):m===1?S?(0,C.localize)(34,null,m):(0,C.localize)(35,null,m):S?(0,C.localize)(36,null,m):(0,C.localize)(37,null,m)):p<u?(m=Math.floor(p/I),d?m===1?S?(0,C.localize)(38,null,m):(0,C.localize)(39,null,m):S?(0,C.localize)(40,null,m):(0,C.localize)(41,null,m):m===1?S?(0,C.localize)(42,null,m):(0,C.localize)(43,null,m):S?(0,C.localize)(44,null,m):(0,C.localize)(45,null,m)):(m=Math.floor(p/u),d?m===1?S?(0,C.localize)(46,null,m):(0,C.localize)(47,null,m):S?(0,C.localize)(48,null,m):(0,C.localize)(49,null,m):m===1?S?(0,C.localize)(50,null,m):(0,C.localize)(51,null,m):S?(0,C.localize)(52,null,m):(0,C.localize)(53,null,m))}t.fromNow=g;function b(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=b}),define(Q[68],Z([4,5]),function(z,t){return z.create("vs/base/common/errorMessage",t)}),define(Q[28],Z([0,1,18,8,68]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function R(g,b){return b&&(g.stack||g.stacktrace)?P.localize(0,null,I(g),L(g.stack)||L(g.stacktrace)):I(g)}function L(g){return Array.isArray(g)?g.join(`
`):g}function I(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?P.localize(1,null,g.message):g.message||P.localize(2,null)}function u(g=null,b=!1){if(!g)return P.localize(3,null);if(Array.isArray(g)){const O=C.coalesce(g),d=u(O[0],b);return O.length>1?P.localize(4,null,d,O.length):d}if(D.isString(g))return g;if(g.detail){const O=g.detail;if(O.error)return R(O.error,b);if(O.exception)return R(O.exception,b)}return g.stack?R(g,b):g.message?g.message:P.localize(5,null)}t.toErrorMessage=u}),define(Q[69],Z([4,5]),function(z,t){return z.create("vs/base/node/processes",t)}),define(Q[47],Z([0,1,38,45,10,21,11,12,29,57,8,63,15,69]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.removeDangerousEnvVariables=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function p(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(n,r){if(I.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};r&&(e.cwd=r);const i=C.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(s=>{i.once("error",l=>{s({success:!1,error:l})}),i.once("exit",(l,f)=>{s(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?p(e.status):1})}else if(I.isLinux||I.isMacintosh)try{const e=P.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",z).fsPath;return new Promise(i=>{C.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(s,l,f)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function c(n){!n||(delete n.DEBUG,I.isMacintosh&&delete n.DYLD_LIBRARY_PATH,I.isLinux&&delete n.LD_PRELOAD)}t.removeDangerousEnvVariables=c;function h(n=u.env){return n.comspec||"cmd.exe"}t.getWindowsShell=h;class E{constructor(r,e,i,s){if(e!==void 0&&i!==void 0&&s!==void 0)this.cmd=r,this.args=e,this.shell=i,this.options=s;else{const l=r;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(u.env).forEach(f=>{l[f]=u.env[f]}),Object.keys(this.options.env).forEach(f=>{l[f]=this.options.env[f]}),this.options.env=l}}getSanitizedCommand(){let r=this.cmd.toLowerCase();const e=r.lastIndexOf(L.sep);return e!==-1&&(r=r.substring(e+1)),E.WellKnowCommands[r]?r:"other"}start(r){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(u.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(e=>{let i,s;const l=new Promise((f,y)=>{i=f,s=y});if(e){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=C.exec(f,this.options,(y,w,T)=>{this.childProcess=null;const A=y;A&&A.killed?s({killed:this.terminateRequested,stdout:w.toString(),stderr:T.toString()}):this.handleExec(i,r,y,w,T)})}else{let f=null;const y=w=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(w,i,r,s);const T={terminated:this.terminateRequested};b.isNumber(w)&&(T.cmdCode=w),i(T)};if(this.shell&&I.isWindows){const w=R.deepClone(this.options);w.windowsVerbatimArguments=!0,w.detached=!1;let T=!1,A=!1;const B=[];let J=this.ensureQuotes(this.cmd);B.push(J.value),T=J.quoted,this.args&&this.args.forEach(ie=>{J=this.ensureQuotes(ie),B.push(J.value),A=A&&J.quoted});const se=["/s","/c"];T?A?se.push('"'+B.join(" ")+'"'):B.length>1?se.push('"'+B[0]+'" '+B.slice(1).join(" ")):se.push('"'+B[0]+'"'):se.push(B.join(" ")),f=C.spawn(h(),se,w)}else this.cmd&&(f=C.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(b.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",w=>{this.childProcess=null,s({terminated:this.terminateRequested,error:w})}),f.pid&&(this.childProcess.on("close",y),this.handleSpawn(f,i,r,s,!0)))}return l})}handleClose(r,e,i,s){}ensureQuotes(r){return E.regexp.test(r)?{value:'"'+r+'"',quoted:!0}:{value:r,quoted:r.length>0&&r[0]==='"'&&r[r.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(r=>r.pid,r=>-1):new Promise(r=>{this.pidResolve=r})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(r=>(this.terminateRequested=!0,m(r,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),r=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(r=>{if(!this.shell||!I.isWindows)return r(!1);const e=C.spawn(h(),["/s","/c"]);e.on("error",i=>r(!0)),e.on("exit",i=>r(!1))})}}t.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class a extends E{constructor(r,e,i,s){super(r,e,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(r,e,i,s,l){[s,l].forEach((f,y)=>{const w=new O.LineDecoder;w.write(f).forEach(B=>{e({line:B,source:y===0?0:1})});const A=w.end();A&&e({line:A,source:y===0?0:1})}),r({terminated:this.terminateRequested,error:i})}handleSpawn(r,e,i,s,l){const f=new O.LineDecoder,y=new O.LineDecoder;r.stdout.on("data",w=>{f.write(w).forEach(A=>i({line:A,source:0}))}),r.stderr.on("data",w=>{y.write(w).forEach(A=>i({line:A,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=y}handleClose(r,e,i,s){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&i({line:l,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&i({line:f,source:1})}}t.LineProcess=a;function v(n){let r=[],e=!1;const i=function(s){if(e){r.push(s);return}(!n.send(s,f=>{if(f&&console.error(f),e=!1,r.length>0){const y=r.slice(0);r=[],y.forEach(w=>i(w))}})||I.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=v;var o;(function(n){async function r(e,i,s){if(L.isAbsolute(e))return e;if(i===void 0&&(i=u.cwd()),L.dirname(e)!=="."||(s===void 0&&b.isString(u.env.PATH)&&(s=u.env.PATH.split(L.delimiter)),s===void 0||s.length===0))return L.join(i,e);async function f(y){if(await d.Promises.exists(y)){let w;try{w=await d.Promises.stat(y)}catch(T){T.message.startsWith("EACCES")&&(w=await d.Promises.lstat(y))}return w?!w.isDirectory():!1}return!1}for(let y of s){let w;if(L.isAbsolute(y)?w=L.join(y,e):w=L.join(i,y,e),await f(w))return w;let T=w+".com";if(await f(T)||(T=w+".exe",await f(T)))return T}return L.join(i,e)}n.findExecutable=r})(o=t.win32||(t.win32={}))}),define(Q[70],Z([0,1,33,12,64,47]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function L(S,p){return S===1?D.isWindows?O():R.getWindowsShell(p):g(S,p)}t.getSystemShell=L;function I(S,p){return S===1?D.isWindows?d(p):R.getWindowsShell(p):g(S,p)}t.getSystemShellSync=I;let u=null;function g(S,p){if(D.isLinux&&S===2||D.isMacintosh&&S===3)return"/bin/bash";if(!u){let m;if(D.isWindows)m="/bin/bash";else{if(m=p.SHELL,!m)try{m=(0,C.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}u=m}return u}let b=null;async function O(){return b||(b=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),b}function d(S){if(b)return b;const p=D.isWindows&&parseFloat((0,C.release)())>=10,m=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),c=`${S.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return p?c:R.getWindowsShell(S)}}),define(Q[71],Z([0,1,38,3,17,24,60,7,6,2,21,47,46]),function(z,t,C,D,P,R,L,I,u,g,b,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class S extends d.ChannelServer{constructor(c){super({send:h=>{try{process.send&&process.send(h.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",h=>P.VSBuffer.wrap(Buffer.from(h,"base64")))},c);process.once("disconnect",()=>this.dispose())}}t.Server=S;class p{constructor(c,h){this.modulePath=c,this.options=h,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=h&&h.timeout?h.timeout:6e4;this.disposeDelayer=new D.Delayer(E),this.child=null,this._client=null}getChannel(c){const h=this;return{call(E,a,v){return h.requestPromise(c,E,a,v)},listen(E,a){return h.requestEvent(c,E,a)}}}requestPromise(c,h,E,a=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const v=this.getCachedChannel(c),o=(0,D.createCancelablePromise)(e=>v.call(h,E,e)),n=a.onCancellationRequested(()=>o.cancel()),r=(0,g.toDisposable)(()=>o.cancel());return this.activeRequests.add(r),o.finally(()=>{n.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),o}requestEvent(c,h,E){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let a;const v=new u.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(c).listen(h,E)(v.fire,v),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return v.event}get client(){if(!this._client){const c=this.options&&this.options.args?this.options.args:[],h=Object.create(null);h.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(h.env={...h.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(h.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,O.removeDangerousEnvVariables)(h.env),this.child=(0,C.fork)(this.modulePath,c,h);const E=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,L.isRemoteConsoleLog)(i)){(0,L.log)(i,`IPC Library: ${this.options.serverName}`);return}E.fire(P.VSBuffer.wrap(Buffer.from(i,"base64")))});const v=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,o=i=>this.child&&this.child.connected&&v.send(i.buffer.toString("base64")),n=E.event,r={send:o,onMessage:n};this._client=new d.ChannelClient(r);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,s)=>{process.removeListener("exit",e),this.activeRequests.forEach(l=>(0,g.dispose)(l)),this.activeRequests.clear(),i!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:s})})}return this._client}getCachedChannel(c){let h=this.channels.get(c);return h||(h=this.client.getChannel(c),this.channels.set(c,h)),h}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=p}),define(Q[72],Z([4,5]),function(z,t){return z.create("vs/base/node/zip",t)}),define(Q[73],Z([4,5]),function(z,t){return z.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[74],Z([4,5]),function(z,t){return z.create("vs/platform/environment/node/shellEnv",t)}),define(Q[75],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Q[76],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[77],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[78],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[79],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[80],Z([4,5]),function(z,t){return z.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[81],Z([4,5]),function(z,t){return z.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[82],Z([4,5]),function(z,t){return z.create("vs/platform/files/common/fileService",t)}),define(Q[83],Z([4,5]),function(z,t){return z.create("vs/platform/files/common/io",t)}),define(Q[84],Z([4,5]),function(z,t){return z.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[85],Z([4,5]),function(z,t){return z.create("vs/platform/request/common/request",t)}),define(Q[86],Z([4,5]),function(z,t){return z.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[87],Z([0,1,67,44,10,11,29,19,9]),function(z,t,C,D,P,R,L,I,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class g{constructor(m,c,h){this._args=m,this.paths=c,this.productService=h}get appRoot(){return(0,R.dirname)(P.FileAccess.asFileUri("",z).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,C.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(u.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=L.env.VSCODE_PORTABLE;return m?u.URI.file((0,R.join)(m,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.resolve)(m):(0,R.normalize)((0,R.join)(P.FileAccess.asFileUri("",z).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,R.resolve)(m):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.resolve)(m);const c=L.env.VSCODE_EXTENSIONS;if(c)return c;const h=L.env.VSCODE_PORTABLE;return h?(0,R.join)(h,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(c=>/^[^:/?#]+?:\/\//.test(c)?u.URI.parse(c):u.URI.file((0,R.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,R.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return u.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}pe([D.memoize],g.prototype,"appRoot",null),pe([D.memoize],g.prototype,"userHome",null),pe([D.memoize],g.prototype,"userDataPath",null),pe([D.memoize],g.prototype,"appSettingsHome",null),pe([D.memoize],g.prototype,"tmpDir",null),pe([D.memoize],g.prototype,"cacheHome",null),pe([D.memoize],g.prototype,"userRoamingDataHome",null),pe([D.memoize],g.prototype,"settingsResource",null),pe([D.memoize],g.prototype,"userDataSyncHome",null),pe([D.memoize],g.prototype,"userDataSyncLogResource",null),pe([D.memoize],g.prototype,"sync",null),pe([D.memoize],g.prototype,"machineSettingsResource",null),pe([D.memoize],g.prototype,"globalStorageHome",null),pe([D.memoize],g.prototype,"workspaceStorageHome",null),pe([D.memoize],g.prototype,"keybindingsResource",null),pe([D.memoize],g.prototype,"keyboardLayoutResource",null),pe([D.memoize],g.prototype,"argvResource",null),pe([D.memoize],g.prototype,"snippetsHome",null),pe([D.memoize],g.prototype,"isExtensionDevelopment",null),pe([D.memoize],g.prototype,"untitledWorkspacesHome",null),pe([D.memoize],g.prototype,"installSourcePath",null),pe([D.memoize],g.prototype,"builtinExtensionsPath",null),pe([D.memoize],g.prototype,"extensionsPath",null),pe([D.memoize],g.prototype,"extensionDevelopmentLocationURI",null),pe([D.memoize],g.prototype,"extensionDevelopmentKind",null),pe([D.memoize],g.prototype,"extensionTestsLocationURI",null),pe([D.memoize],g.prototype,"debugExtensionHost",null),pe([D.memoize],g.prototype,"serviceMachineIdResource",null),pe([D.memoize],g.prototype,"telemetryLogResource",null),pe([D.memoize],g.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=g;function b(p,m){return S(p["inspect-extensions"],p["inspect-brk-extensions"],5870,m,p.debugId,p.extensionEnvironment)}t.parseExtensionHostPort=b;function O(p,m){return S(p["inspect-search"],p["inspect-brk-search"],5876,m,p.extensionEnvironment)}t.parseSearchPort=O;function d(p,m){return S(p["inspect-ptyhost"],p["inspect-brk-ptyhost"],5877,m,p.extensionEnvironment)}t.parsePtyHostPort=d;function S(p,m,c,h,E,a){const o=Number(m||p)||(h?null:c),n=o?Boolean(!!m):!1;let r;if(a)try{r=JSON.parse(a)}catch{}return{port:o,break:n,debugId:E,env:r}}}),function(){"use strict";function z(t,C,D,P){function R(I){const u=L(I),g=[u];return t.isAbsolute(u)||g.unshift(P),t.resolve(...g)}function L(I){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return t.join(g,D);const b=I["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=t.join(O,"AppData","Roaming")}break;case"darwin":g=t.join(C.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||t.join(C.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(g,D)}return{getUserDataPath:R}}if(typeof define=="function")define(Q[88],Z([0,132,33,10,19,29]),function(t,C,D,P,R,L){const I=R.dirname(P.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(R.joinPath(I,"package.json").fsPath);return z(C,D,u.name,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),C=require("path"),D=require("os");module.exports=z(C,D,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,33,87,88]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class R extends D.AbstractNativeEnvironmentService{constructor(I,u){super(I,{homeDir:(0,C.homedir)(),tmpDir:(0,C.tmpdir)(),userDataDir:(0,P.getUserDataPath)(I)},u)}}t.NativeEnvironmentService=R}),define(Q[90],Z([0,1,21]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function P(R,L){const I=u=>{if(typeof u!="string")return;const g=D.exec(u);if(!g)return;const b=L[g[1]]??u;return typeof b=="string"?b:typeof b.message=="string"?b.message:u};return(0,C.cloneAndChange)(R,I)}t.localizeManifest=P}),define(Q[48],Z([0,1,81]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function R(d){return d=d.trim(),d==="*"||D.test(d)}t.isValidVersionStr=R;function L(d){if(!R(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=d.match(D);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}t.parseVersion=L;function I(d){if(!d)return null;let S=d.majorBase,p=d.majorMustEqual,m=d.minorBase,c=d.minorMustEqual,h=d.patchBase,E=d.patchMustEqual;d.hasCaret&&(S===0||(c=!1),E=!1);let a=0;if(d.preRelease){const v=P.exec(d.preRelease);if(v){const[,o,n,r]=v;a=Date.UTC(Number(o),Number(n)-1,Number(r))}}return{majorBase:S,majorMustEqual:p,minorBase:m,minorMustEqual:c,patchBase:h,patchMustEqual:E,isMinimum:d.hasGreaterEquals,notBefore:a}}t.normalizeVersion=I;function u(d,S,p){let m;typeof d=="string"?m=I(L(d)):m=d;let c;S instanceof Date?c=S.getTime():typeof S=="string"&&(c=new Date(S).getTime());let h;if(typeof p=="string"?h=I(L(p)):h=p,!m||!h)return!1;let E=m.majorBase,a=m.minorBase,v=m.patchBase,o=h.majorBase,n=h.minorBase,r=h.patchBase,e=h.notBefore,i=h.majorMustEqual,s=h.minorMustEqual,l=h.patchMustEqual;return h.isMinimum?E>o?!0:E<o?!1:a>n?!0:a<n||c&&c<e?!1:v>=r:(E===1&&o===0&&(!i||!s||!l)&&(o=1,n=0,r=0,i=!0,s=!1,l=!1),E<o?!1:E>o?!i:a<n?!1:a>n?!s:v<r?!1:v>r?!l:!(c&&c<e))}t.isValidVersion=u;function g(d,S,p,m){return p.isBuiltin||typeof p.main=="undefined"?!0:O(d,S,p.engines.vscode,m)}t.isValidExtensionVersion=g;function b(d,S,p){return d==="*"||O(S,p,d)}t.isEngineValid=b;function O(d,S,p,m=[]){let c=I(L(p));if(!c)return m.push(C.localize(0,null,p)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(C.localize(1,null,p)),!1}else if(!c.majorMustEqual)return m.push(C.localize(2,null,p)),!1;return u(d,S,c)?!0:(m.push(C.localize(3,null,d,p)),!1)}}),define(Q[39],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class C{constructor(P,R=[],L=!1){this.ctor=P,this.staticArguments=R,this.supportsDelayedInstantiation=L}}t.SyncDescriptor=C}),define(Q[91],Z([0,1,39]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const D=[];function P(L,I,u){I instanceof C.SyncDescriptor||(I=new C.SyncDescriptor(I,[],u)),D.push([L,I])}t.registerSingleton=P;function R(){return D}t.getSingletonServiceDescriptors=R}),define(Q[92],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class C{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}t.Node=C;class D{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let L of this._nodes.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const I=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(L);I.outgoing.set(this._hashFn(L),u),u.incoming.set(this._hashFn(R),I)}removeNode(R){const L=this._hashFn(R);this._nodes.delete(L);for(let I of this._nodes.values())I.outgoing.delete(L),I.incoming.delete(L)}lookupOrInsertNode(R){const L=this._hashFn(R);let I=this._nodes.get(L);return I||(I=new C(R),this._nodes.set(L,I)),I}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[L,I]of this._nodes)R.push(`${L}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,L]of this._nodes){const I=new Set([R]),u=this._findCycle(L,I);if(u)return u}}_findCycle(R,L){for(let[I,u]of R.outgoing){if(L.has(I))return[...L,I].join(" -> ");L.add(I);const g=this._findCycle(u,L);if(g)return g;L.delete(I)}}}t.Graph=D}),define(Q[25],Z([0,1,8,9,13]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,P.createDecorator)("configurationService");function R(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}t.isConfigurationOverrides=R;function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||C.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}t.isConfigurationUpdateOverrides=L;var I;(function(c){c[c.USER=1]="USER",c[c.USER_LOCAL=2]="USER_LOCAL",c[c.USER_REMOTE=3]="USER_REMOTE",c[c.WORKSPACE=4]="WORKSPACE",c[c.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",c[c.DEFAULT=6]="DEFAULT",c[c.MEMORY=7]="MEMORY"})(I=t.ConfigurationTarget||(t.ConfigurationTarget={}));function u(c){switch(c){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=u;function g(c,h){const E=Object.create(null);for(let a in c)b(E,a,c[a],h);return E}t.toValuesTree=g;function b(c,h,E,a){const v=h.split("."),o=v.pop();let n=c;for(let r=0;r<v.length;r++){let e=v[r],i=n[e];switch(typeof i){case"undefined":i=n[e]=Object.create(null);break;case"object":break;default:a(`Ignoring ${h} as ${v.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[o]=E}catch{a(`Ignoring ${h} as ${v.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${h} as ${v.join(".")} is ${JSON.stringify(n)}`)}t.addToValueTree=b;function O(c,h){const E=h.split(".");d(c,E)}t.removeFromValueTree=O;function d(c,h){const E=h.shift();if(h.length===0){delete c[E];return}if(Object.keys(c).indexOf(E)!==-1){const a=c[E];typeof a=="object"&&!Array.isArray(a)&&(d(a,h),Object.keys(a).length===0&&delete c[E])}}function S(c,h,E){function a(n,r){let e=n;for(const i of r){if(typeof e!="object"||e===null)return;e=e[i]}return e}const v=h.split("."),o=a(c,v);return typeof o=="undefined"?E:o}t.getConfigurationValue=S;function p(c,h,E){Object.keys(h).forEach(a=>{a!=="__proto__"&&(a in c?C.isObject(c[a])&&C.isObject(h[a])?p(c[a],h[a],E):E&&(c[a]=h[a]):c[a]=h[a])})}t.merge=p;function m(c,h,E){const a=c.inspect(h),v=c.inspect(E);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:a.defaultValue}t.getMigratedSettingValue=m}),define(Q[49],Z([0,1,13]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,C.createDecorator)("downloadService")}),define(Q[20],Z([0,1,13]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,C.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,C.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[22],Z([0,1,10,76,13]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.TargetPlatform=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";var R;(function(a){a.WIN32_X64="win32-x64",a.WIN32_IA32="win32-ia32",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(R=t.TargetPlatform||(t.TargetPlatform={}));function L(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=L;function I(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=I;function u(a,v){switch(a){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=u;function g(a,v){return v==="web"&&!a.includes("web")}t.isNotWebExtensionInWebTargetPlatform=g;function b(a,v,o){return g(v,o)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===o?!0:O(o).includes(a)}t.isTargetPlatformCompatible=b;function O(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=O;function d(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}t.isIExtensionIdentifier=d;var S;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(S=t.SortBy||(t.SortBy={}));var p;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(p=t.SortOrder||(t.SortOrder={}));var m;(function(a){a.Install="install",a.Uninstall="uninstall"})(m=t.StatisticType||(t.StatisticType={}));var c;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(c=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var h;(function(a){a.Unsupported="Unsupported",a.UnsupportedPreRelease="UnsupportedPreRelease",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(h=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class E extends Error{constructor(v,o){super(v);this.code=o,this.name=o}}t.ExtensionManagementError=E,t.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",z).toString(!0),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,P.createDecorator)("IExtensionManagementCLIService")}),define(Q[93],Z([0,1,38,11,74,24,28,7,12,27,70,133,3]),function(z,t,C,D,P,R,L,I,u,g,b,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const S=1e4;let p;async function m(h,E,a){return E["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.isWindows?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.isLaunchedFromCli)(a)&&!E["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.isLaunchedFromCli)(a)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=d.Promises.withAsyncBody(async(v,o)=>{const n=new R.CancellationTokenSource,r=setTimeout(()=>{n.dispose(!0),o(new Error((0,P.localize)(0,null)))},S);try{v(await c(h,n.token))}catch(e){!(0,I.isCancellationError)(e)&&!n.token.isCancellationRequested?o(new Error((0,P.localize)(1,null,(0,L.toErrorMessage)(e)))):v({})}finally{clearTimeout(r),n.dispose()}})),p)}t.getResolvedShellEnv=m;async function c(h,E){const a=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",a);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",v);const o=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(o+"(.*)"+o),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};h.trace("getUnixShellEnvironment#env",r);const e=await(0,b.getSystemShell)(u.OS,r);return h.trace("getUnixShellEnvironment#shell",e),new Promise((i,s)=>{if(E.isCancellationRequested)return s((0,I.canceled)());const l=(0,D.basename)(e);let f,y;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(f=`& '${process.execPath}' ${w} -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,y=["-Login","-Command"]):(f=`'${process.execPath}' ${w} -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,l==="tcsh"?y=["-ic"]:y=["-ilc"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),f);const T=(0,C.spawn)(e,[...y,f],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});E.onCancellationRequested(()=>(T.kill(),s((0,I.canceled)()))),T.on("error",J=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,L.toErrorMessage)(J)),s(J)});const A=[];T.stdout.on("data",J=>A.push(J));const B=[];T.stderr.on("data",J=>B.push(J)),T.on("close",(J,se)=>{const ie=Buffer.concat(A).toString("utf8");h.trace("getUnixShellEnvironment#raw",ie);const te=Buffer.concat(B).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),J||se)return s(new Error((0,P.localize)(2,null,J,se)));const ge=n.exec(ie),$=ge?ge[1]:"{}";try{const q=JSON.parse($);a?q.ELECTRON_RUN_AS_NODE=a:delete q.ELECTRON_RUN_AS_NODE,v?q.ELECTRON_NO_ATTACH_CONSOLE=v:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){h.error("getUnixShellEnvironment#errorCaught",(0,L.toErrorMessage)(q)),s(q)}})})}}),define(Q[50],Z([0,1,17,7,83,16]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(b,O,d,S,p,m){let c;try{await I(b,O,d,S,p,m)}catch(h){c=h}finally{c&&p.errorTransformer&&(c=p.errorTransformer(c)),typeof c!="undefined"&&d.error(c),d.end()}}t.readFileIntoStream=L;async function I(b,O,d,S,p,m){u(m);const c=await b.open(O,{create:!1});try{u(m);let h=0,E=0,a=p&&typeof p.length=="number"?p.length:void 0,v=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof a=="number"?a:p.bufferSize)),o=p&&typeof p.position=="number"?p.position:0,n=0;do E=await b.read(c,o,v.buffer,n,v.byteLength-n),o+=E,n+=E,h+=E,typeof a=="number"&&(a-=E),n===v.byteLength&&(await d.write(S(v)),v=C.VSBuffer.alloc(Math.min(p.bufferSize,typeof a=="number"?a:p.bufferSize)),n=0);while(E>0&&(typeof a!="number"||a>0)&&u(m)&&g(h,p));if(n>0){let r=n;typeof a=="number"&&(r=Math.min(n,a)),d.write(S(v.slice(0,r)))}}catch(h){throw(0,R.ensureFileSystemProviderError)(h)}finally{await b.close(c)}}function u(b){if(b.isCancellationRequested)throw(0,D.canceled)();return!0}function g(b,O){if(O?.limits){if(typeof O.limits.memory=="number"&&b>O.limits.memory)throw(0,R.createFileSystemProviderError)((0,P.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof O.limits.size=="number"&&b>O.limits.size)throw(0,R.createFileSystemProviderError)((0,P.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[94],Z([0,1,18,6,2,12,134]),function(z,t,C,D,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class I extends P.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(g){const b=this.normalizeRequests(g),O=b.filter(S=>{const p=this.watchers.get(S.path);return p?!(0,C.equals)(p.request.excludes,S.excludes):!0}),d=Array.from(this.watchers.values()).filter(({request:S})=>!b.find(p=>p.path===S.path&&(0,C.equals)(p.excludes,S.excludes))).map(({request:S})=>S.path);O.length&&this.trace(`Request to start watching: ${O.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"})`).join(",")}`),d.length&&this.trace(`Request to stop watching: ${d.join(",")}`);for(const S of d)this.stopWatching(S);for(const S of O)this.startWatching(S)}startWatching(g){const b=new L.NodeJSFileWatcherLibrary(g,d=>this._onDidChangeFile.fire(d),d=>this._onDidLogMessage.fire(d),this.verboseLogging),O={request:g,instance:b};this.watchers.set(g.path,O)}async stop(){for(const[g]of this.watchers)this.stopWatching(g);this.watchers.clear()}stopWatching(g){const b=this.watchers.get(g);b&&(this.watchers.delete(g),b.instance.dispose())}normalizeRequests(g){const b=new Map;for(const O of g){const d=R.isLinux?O.path:O.path.toLowerCase();b.set(d,O)}return Array.from(b.values())}async setVerboseLogging(g){this.verboseLogging=g;for(const[,b]of this.watchers)b.instance.setVerboseLogging(g)}trace(g){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(g)})}toMessage(g,b){return b?`[File Watcher (node.js)] ${g} (path: ${b.request.path})`:`[File Watcher (node.js)] ${g}`}}t.NodeJSWatcher=I}),define(Q[95],Z([0,1,51,94]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class P extends C.AbstractNonRecursiveWatcherClient{constructor(L,I,u){super(L,I,u);this.init()}createWatcher(){return new D.NodeJSWatcher}}t.NodeJSWatcherClient=P}),define(Q[96],Z([0,1,10,46,71,51]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class L extends R.AbstractUniversalWatcherClient{constructor(u,g,b){super(u,g,b);this.init()}createWatcher(u){const g=u.add(new P.Client(C.FileAccess.asFileUri("bootstrap-fork",z).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(g.onDidProcessExit(({code:b,signal:O})=>this.onError(`terminated by itself with code ${b}, signal: ${O}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(g.getChannel("watcher")))}}t.UniversalWatcherClient=L}),define(Q[52],Z([0,1]),function(z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class C{constructor(...P){this._entries=new Map;for(let[R,L]of P)this.set(R,L)}set(P,R){const L=this._entries.get(P);return this._entries.set(P,R),L}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}t.ServiceCollection=C}),define(Q[97],Z([0,1,3,7,39,92,13,52]),function(z,t,C,D,P,R,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const u=!1;class g extends Error{constructor(p){super("cyclic dependency between services");this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class b{constructor(p=new I.ServiceCollection,m=!1,c){this._activeInstantiations=new Set,this._services=p,this._strict=m,this._parent=c,this._services.set(L.IInstantiationService,this)}createChild(p){return new b(p,this._strict,this)}invokeFunction(p,...m){let c=d.traceInvocation(p),h=!1;try{return p({get:a=>{if(h)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const v=this._getOrCreateServiceInstance(a,c);if(!v)throw new Error(`[invokeFunction] unknown service '${a}'`);return v}},...m)}finally{h=!0,c.stop()}}createInstance(p,...m){let c,h;return p instanceof P.SyncDescriptor?(c=d.traceCreation(p.ctor),h=this._createInstance(p.ctor,p.staticArguments.concat(m),c)):(c=d.traceCreation(p),h=this._createInstance(p,m,c)),c.stop(),h}_createInstance(p,m=[],c){let h=L._util.getServiceDependencies(p).sort((v,o)=>v.index-o.index),E=[];for(const v of h){let o=this._getOrCreateServiceInstance(v.id,c);if(!o&&this._strict&&!v.optional)throw new Error(`[createInstance] ${p.name} depends on UNKNOWN service ${v.id}.`);E.push(o)}let a=h.length>0?h[0].index:m.length;if(m.length!==a){console.warn(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${m.length} static arguments`);let v=a-m.length;v>0?m=m.concat(new Array(v)):m=m.slice(0,a)}return new p(...[...m,...E])}_setServiceInstance(p,m){if(this._services.get(p)instanceof P.SyncDescriptor)this._services.set(p,m);else if(this._parent)this._parent._setServiceInstance(p,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(p){let m=this._services.get(p);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(p):m}_getOrCreateServiceInstance(p,m){let c=this._getServiceInstanceOrDescriptor(p);return c instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(p,c,m.branch(p,!0)):(m.branch(p,!1),c)}_safeCreateAndCacheServiceInstance(p,m,c){if(this._activeInstantiations.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this._activeInstantiations.add(p);try{return this._createAndCacheServiceInstance(p,m,c)}finally{this._activeInstantiations.delete(p)}}_createAndCacheServiceInstance(p,m,c){const h=new R.Graph(v=>v.id.toString());let E=0;const a=[{id:p,desc:m,_trace:c}];for(;a.length;){const v=a.pop();if(h.lookupOrInsertNode(v),E++>1e3)throw new g(h);for(let o of L._util.getServiceDependencies(v.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(o.id);if(!n&&!o.optional&&console.warn(`[createInstance] ${p} depends on ${o.id} which is NOT registered.`),n instanceof P.SyncDescriptor){const r={id:o.id,desc:n,_trace:v._trace.branch(o.id,!0)};h.insertEdge(v,r),a.push(r)}}}for(;;){const v=h.roots();if(v.length===0){if(!h.isEmpty())throw new g(h);break}for(const{data:o}of v){if(this._getServiceInstanceOrDescriptor(o.id)instanceof P.SyncDescriptor){const r=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,r)}h.removeNode(o)}}return this._getServiceInstanceOrDescriptor(p)}_createServiceInstanceWithOwner(p,m,c=[],h,E){if(this._services.get(p)instanceof P.SyncDescriptor)return this._createServiceInstance(m,c,h,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(p,m,c,h,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(p,m=[],c,h){if(c){const E=new C.IdleValue(()=>this._createInstance(p,m,h));return new Proxy(Object.create(null),{get(a,v){if(v in a)return a[v];let o=E.value,n=o[v];return typeof n!="function"||(n=n.bind(o),a[v]=n),n},set(a,v,o){return E.value[v]=o,!0}})}else return this._createInstance(p,m,h)}}t.InstantiationService=b;var O;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(O||(O={}));class d{constructor(p,m){this.type=p,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(p){return u?new d(1,p.name||p.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(p){return u?new d(0,p.name):d._None}branch(p,m){let c=new d(2,p.toString());return this._dep.push([p,m,c]),c}stop(){let p=Date.now()-this._start;d._totals+=p;let m=!1;function c(E,a){let v=[],o=new Array(E+1).join("	");for(const[n,r,e]of a._dep)if(r&&e){m=!0,v.push(`${o}CREATES -> ${n}`);let i=c(E+1,e);i&&v.push(i)}else v.push(`${o}uses -> ${n}`);return v.join(`
`)}let h=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(p>2||m)&&console.log(h.join(`
`))}}t.Trace=d,d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Q[53],Z([0,1,13]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,C.createDecorator)("localizationsService");function D(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const R of P.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}t.isValidLocalization=D}),define(Q[14],Z([0,1,28,6,2,12,13]),function(z,t,C,D,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,L.createDecorator)("logService"),t.ILoggerService=(0,L.createDecorator)("loggerService");function I(){return new Date().toISOString()}var u;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;function g(r,e,i){switch(e){case u.Trace:r.trace(i);break;case u.Debug:r.debug(i);break;case u.Info:r.info(i);break;case u.Warning:r.warn(i);break;case u.Error:r.error(i);break;case u.Critical:r.critical(i);break;default:throw new Error("Invalid log level")}}t.log=g;function b(r){let e="";for(let i=0;i<r.length;i++){let s=r[i];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}e+=(i>0?" ":"")+s}return e}t.format=b;class O extends P.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=O;class d extends O{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,b([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,b([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,b([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,b([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=e.stack,this.log(u.Error,b(s))}else this.log(u.Error,b([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,b([e,...i]))}flush(){}}t.AbstractMessageLogger=d;class S extends O{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!R.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...i):console.log(`[main ${I()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...i):console.log(`[main ${I()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,e,...i):console.log(`[main ${I()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,e,...i):console.warn(`[main ${I()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,e,...i):console.error(`[main ${I()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,e,...i):console.error(`[main ${I()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=S;class p extends O{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=p;class m extends O{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,C.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=m;class c extends O{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const s of this.logServices)s.trace(e,...i)}debug(e,...i){for(const s of this.logServices)s.debug(e,...i)}info(e,...i){for(const s of this.logServices)s.info(e,...i)}warn(e,...i){for(const s of this.logServices)s.warn(e,...i)}error(e,...i){for(const s of this.logServices)s.error(e,...i)}critical(e,...i){for(const s of this.logServices)s.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=c;class h extends P.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=h;class E extends P.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(s))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let s=this.loggers.get(e.toString());return s||(s=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),s),i?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=E;class a{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=a;function v(r){if(r.verbose)return u.Trace;if(typeof r.logLevel=="string"){const e=o(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=v;function o(r){switch(r){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=o;function n(r){switch(r){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=n});var oe=this&&this.__param||function(z,t){return function(C,D){t(C,D,z)}};define(Q[98],Z([0,1,38,3,28,6,2,10,11,15,20,14]),function(z,t,C,D,P,R,L,I,u,g,b,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let d=class extends L.Disposable{constructor(p,m){super();this.environmentService=p,this.logService=m,this.processesLimiter=new D.Limiter(5)}async postUninstall(p){const m=this.parseScript(p,"uninstall");return m&&(this.logService.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,p).then(()=>this.logService.info(p.identifier.id,p.manifest.version,"Finished running post uninstall script"),c=>this.logService.error(p.identifier.id,p.manifest.version,`Failed to run post uninstall script: ${c}`)))),g.Promises.rm(this.getExtensionStoragePath(p)).then(void 0,c=>this.logService.error("Error while removing extension storage path",c))}parseScript(p,m){const c=`vscode:${m}`;if(p.location.scheme===I.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[c]=="string"){const h=p.manifest.scripts[c].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.logService.warn(p.identifier.id,p.manifest.version,`${c} should be a node script`),null):{script:(0,u.join)(p.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}runLifecycleHook(p,m,c,h,E){return new Promise((a,v)=>{const o=this.start(p,m,c,E);let n;const r=e=>{n&&(clearTimeout(n),n=null),e?v(e):a(void 0)};o.on("error",e=>{r((0,P.toErrorMessage)(e)||"Unknown")}),o.on("exit",(e,i)=>{r(e?`post-${m} process exited with code ${e}`:void 0)}),h&&(n=setTimeout(()=>{n=null,o.kill(),v("timed out")},5e3))})}start(p,m,c,h){const E={silent:!0,execArgv:void 0},a=(0,C.fork)(p,[`--type=extension-post-${m}`,...c],E);a.stdout.setEncoding("utf8"),a.stderr.setEncoding("utf8");const v=R.Event.fromNodeEventEmitter(a.stdout,"data"),o=R.Event.fromNodeEventEmitter(a.stderr,"data");v(e=>this.logService.info(h.identifier.id,h.manifest.version,`post-${m}`,e)),o(e=>this.logService.error(h.identifier.id,h.manifest.version,`post-${m}`,e));const n=R.Event.any(R.Event.map(v,e=>({data:`%c${e}`,format:[""]})),R.Event.map(o,e=>({data:`%c${e}`,format:["color: red"]})));return R.Event.debounce(n,(e,i)=>e?{data:e.data+i.data,format:[...e.format,...i.format]}:{data:i.data,format:i.format},100)(e=>{console.group(h.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),a}getExtensionStoragePath(p){return(0,u.join)(this.environmentService.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};d=pe([oe(0,b.IEnvironmentService),oe(1,O.ILogService)],d),t.ExtensionsLifecycle=d}),define(Q[99],Z([0,1,18,3,7,6,2,11,51,14]),function(z,t,C,D,P,R,L,I,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class b extends L.Disposable{constructor(d,S){super();this.logService=d,this.options=S,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new D.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(d,S){return S.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(d,S):this.watchNonRecursive(d,S)}watchUniversal(d,S){const p={path:this.toFilePath(d),excludes:S.excludes,recursive:S.recursive},m=(0,C.insert)(this.universalPathsToWatch,p);return this.refreshUniversalWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(d=>(0,P.onUnexpectedError)(d))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(S=>this._onDidChangeFile.fire((0,u.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})));const d=this.options?.watcher?.recursive?.usePolling;if(d===!0)for(const S of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(S)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const S of this.universalPathsToWatch)(0,u.isRecursiveWatchRequest)(S)&&d.includes(S.path)&&(S.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(d,S){const p={path:this.toFilePath(d),excludes:S.excludes,recursive:!1},m=(0,C.insert)(this.nonRecursivePathsToWatch,p);return this.refreshNonRecursiveWatchers(),(0,L.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(d=>(0,P.onUnexpectedError)(d))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(d=>this._onDidChangeFile.fire((0,u.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,I.normalize)(d.fsPath)}}t.AbstractDiskFileSystemProvider=b}),define(Q[100],Z([0,1,18,3,17,24,6,59,135,2,54,10,101,19,37,82,16,50,14]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c,h,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let a=class extends g.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new L.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new L.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new L.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new L.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new L.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(o,n){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const r=new g.DisposableStore;return this.provider.set(o,n),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:n}),r.add(n.onDidChangeFile(e=>this._onDidFilesChange.fire(new c.FileChangesEvent(e,!this.isPathCaseSensitive(n))))),typeof n.onDidWatchError=="function"&&r.add(n.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),r.add(n.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:n,scheme:o}))),(0,g.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:n}),this.provider.delete(o),(0,g.dispose)(r)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const n=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(r){n.push(r)}}),!this.provider.has(o)&&await D.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,n){const r=this.provider.get(o.scheme);return!!(r&&r.capabilities&n)}listCapabilities(){return u.Iterable.map(this.provider,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async withProvider(o){if(!(0,S.isAbsolutePath)(o))throw new c.FileOperationError((0,m.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const n=this.provider.get(o.scheme);if(!n){const r=new Error;throw r.name="ENOPRO",r.message=(0,m.localize)(1,null,o.toString()),r}return n}async withReadProvider(o){const n=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)||(0,c.hasFileReadStreamCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const n=await this.withProvider(o);if((0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.doResolveFile(o,n)}catch(r){throw(0,c.toFileSystemProviderErrorCode)(r)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,m.localize)(2,null,this.resourceForError(o)),1):(0,c.ensureFileSystemProviderError)(r)}}async doResolveFile(o,n){const r=await this.withProvider(o),e=this.isPathCaseSensitive(r),i=n?.resolveTo,s=n?.resolveSingleChildDescendants,l=n?.resolveMetadata,f=await r.stat(o);let y;return this.toFileStat(r,o,f,void 0,!!l,(w,T)=>(y||(y=b.TernarySearchTree.forUris(()=>!e),y.set(o,!0),i&&y.fill(!0,i)),y.get(w.resource)||y.findSuperstr(w.resource.with({query:null,fragment:null}))?!0:w.isDirectory&&s?T===1:!1))}async toFileStat(o,n,r,e,i,s){const{providerExtUri:l}=this.getExtUri(o),f={resource:n,name:l.basename(n),isFile:(r.type&c.FileType.File)!=0,isDirectory:(r.type&c.FileType.Directory)!=0,isSymbolicLink:(r.type&c.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&c.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,c.etag)({mtime:r.mtime,size:r.size})};if(f.isDirectory&&s(f,e)){try{const y=await o.readdir(n),w=await D.Promises.settled(y.map(async([T,A])=>{try{const B=l.joinPath(n,T),J=i?await o.stat(B):{type:A};return await this.toFileStat(o,B,J,y.length,i,s)}catch(B){return this.logService.trace(B),null}}));f.children=(0,C.coalesce)(w)}catch(y){this.logService.trace(y),f.children=[]}return f}return f}async resolveAll(o){return D.Promises.settled(o.map(async n=>{try{return{stat:await this.doResolveFile(n.resource,n.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(o){const n=await this.withProvider(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.doValidateCreateFile(o,n)}catch(r){return r}return!0}async doValidateCreateFile(o,n){if(!n?.overwrite&&await this.exists(o))throw new c.FileOperationError((0,m.localize)(3,null,this.resourceForError(o)),3,n)}async createFile(o,n=P.VSBuffer.fromString(""),r){await this.doValidateCreateFile(o,r);const e=await this.writeFile(o,n);return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,e)),e}async writeFile(o,n,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:i}=this.getExtUri(e);try{await this.validateWriteFile(e,o,r)||await this.mkdirp(e,i.dirname(o));let l;if((0,c.hasReadWriteCapability)(e)&&!(n instanceof P.VSBuffer))if((0,p.isReadableStream)(n)){const f=await(0,p.peekStream)(n,3);f.ended?l=P.VSBuffer.concat(f.buffer):l=f}else l=(0,p.peekReadable)(n,f=>P.VSBuffer.concat(f),3);else l=n;!(0,c.hasOpenReadWriteCloseCapability)(e)||(0,c.hasReadWriteCapability)(e)&&l instanceof P.VSBuffer?await this.doWriteUnbuffered(e,o,r,l):await this.doWriteBuffered(e,o,r,l instanceof P.VSBuffer?(0,P.bufferToReadable)(l):l)}catch(s){throw new c.FileOperationError((0,m.localize)(4,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(s).toString()),(0,c.toFileOperationResult)(s),r)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,n,r){if(!!r?.unlock&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(n)));let i;try{i=await o.stat(n)}catch{return}if((i.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,m.localize)(6,null,this.resourceForError(n)),0,r);if(this.throwIfFileIsReadonly(n,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==c.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,c.etag)({mtime:r.mtime,size:i.size}))throw new c.FileOperationError((0,m.localize)(7,null),3,r);return i}async readFile(o,n,r){const e=await this.withReadProvider(o);return n?.atomic?this.doReadFileAtomic(e,o,n,r):this.doReadFile(e,o,n,r)}async doReadFileAtomic(o,n,r,e){return new Promise((i,s)=>{this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(o,n,r,e);i(l)}catch(l){s(l)}})})}async doReadFile(o,n,r,e){const i=await this.doReadFileStream(o,n,{...r,preferUnbuffered:!0},e);return{...i,value:await(0,P.streamToBuffer)(i.value)}}async readFileStream(o,n,r){const e=await this.withReadProvider(o);return this.doReadFileStream(e,o,n,r)}async doReadFileStream(o,n,r,e){const i=new R.CancellationTokenSource(e),s=this.validateReadFile(n,r).then(f=>f,f=>{throw i.cancel(),f});let l;try{return typeof r?.etag=="string"&&r.etag!==c.ETAG_DISABLED&&await s,r?.atomic&&(0,c.hasFileAtomicReadCapability)(o)||!((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasFileReadStreamCapability)(o))||(0,c.hasReadWriteCapability)(o)&&r?.preferUnbuffered?l=this.readFileUnbuffered(o,n,r):(0,c.hasFileReadStreamCapability)(o)?l=this.readFileStreamed(o,n,i.token,r):l=this.readFileBuffered(o,n,i.token,r),{...await s,value:l}}catch(f){l&&await(0,p.consumeStream)(l);const y=(0,m.localize)(8,null,this.resourceForError(n),(0,c.ensureFileSystemProviderError)(f).toString());throw f instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(y,f.stat,r):new c.FileOperationError(y,(0,c.toFileOperationResult)(f),r)}}readFileStreamed(o,n,r,e=Object.create(null)){const i=o.readFileStream(n,e,r);return(0,p.transform)(i,{data:s=>s instanceof P.VSBuffer?s:P.VSBuffer.wrap(s),error:s=>new c.FileOperationError((0,m.localize)(9,null,this.resourceForError(n),(0,c.ensureFileSystemProviderError)(s).toString()),(0,c.toFileOperationResult)(s),e)},s=>P.VSBuffer.concat(s))}readFileBuffered(o,n,r,e=Object.create(null)){const i=(0,P.newWriteableBufferStream)();return(0,h.readFileIntoStream)(o,n,i,s=>s,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new c.FileOperationError((0,m.localize)(10,null,this.resourceForError(n),(0,c.ensureFileSystemProviderError)(s).toString()),(0,c.toFileOperationResult)(s),e)},r),i}readFileUnbuffered(o,n,r){const e=(0,p.newWriteableStream)(i=>P.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,c.hasFileAtomicReadCapability)(o)?i=await o.readFile(n,{atomic:!0}):i=await o.readFile(n),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(n,i.byteLength,r),e.end(P.VSBuffer.wrap(i))}catch(i){e.error(i),e.end()}})(),e}async validateReadFile(o,n){const r=await this.resolve(o,{resolveMetadata:!0});if(r.isDirectory)throw new c.FileOperationError((0,m.localize)(11,null,this.resourceForError(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==c.ETAG_DISABLED&&n.etag===r.etag)throw new c.NotModifiedSinceFileOperationError((0,m.localize)(12,null),r,n);return this.validateReadFileLimits(o,r.size,n),r}validateReadFileLimits(o,n,r){if(r?.limits){let e;if(typeof r.limits.memory=="number"&&n>r.limits.memory&&(e=9),typeof r.limits.size=="number"&&n>r.limits.size&&(e=7),typeof e=="number")throw new c.FileOperationError((0,m.localize)(13,null,this.resourceForError(o)),e)}}async canMove(o,n,r){return this.doCanMoveCopy(o,n,"move",r)}async canCopy(o,n,r){return this.doCanMoveCopy(o,n,"copy",r)}async doCanMoveCopy(o,n,r,e){if(o.toString()!==n.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n);await this.doValidateMoveCopy(i,o,s,n,r,e)}catch(i){return i}return!0}async move(o,n,r){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(e,o,i,n,"move",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,s==="move"?2:3,l)),l}async copy(o,n,r){const e=await this.withReadProvider(o),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(n),n),s=await this.doMoveCopy(e,o,i,n,"copy",!!r),l=await this.resolve(n,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,s==="copy"?3:2,l)),l}async doMoveCopy(o,n,r,e,i,s){if(n.toString()===e.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(o,n,r,e,i,s);if(l&&!f&&s&&await this.del(e,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(e)),i==="copy"){if(o===r&&(0,c.hasFileFolderCopyCapability)(o))await o.copy(n,e,{overwrite:s});else{const y=await this.resolve(n);y.isDirectory?await this.doCopyFolder(o,y,r,e):await this.doCopyFile(o,n,r,e)}return i}else return o===r?(await o.rename(n,e,{overwrite:s}),i):(await this.doMoveCopy(o,n,r,e,"copy",s),await this.del(n,{recursive:!0}),"copy")}async doCopyFile(o,n,r,e){if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(o,n,r,e);if((0,c.hasOpenReadWriteCloseCapability)(o)&&(0,c.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(o,n,r,e);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(o,n,r,e);if((0,c.hasReadWriteCapability)(o)&&(0,c.hasReadWriteCapability)(r))return this.doPipeUnbuffered(o,n,r,e)}async doCopyFolder(o,n,r,e){await r.mkdir(e),Array.isArray(n.children)&&await D.Promises.settled(n.children.map(async i=>{const s=this.getExtUri(r).providerExtUri.joinPath(e,i.name);return i.isDirectory?this.doCopyFolder(o,await this.resolve(i.resource),r,s):this.doCopyFile(o,i.resource,r,s)}))}async doValidateMoveCopy(o,n,r,e,i,s){let l=!1;if(o===r){const{providerExtUri:y,isPathCaseSensitive:w}=this.getExtUri(o);if(w||(l=y.isEqual(n,e)),l&&i==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(n),this.resourceForError(e)));if(!l&&y.isEqualOrParent(e,n))throw new Error((0,m.localize)(15,null,this.resourceForError(n),this.resourceForError(e)))}const f=await this.exists(e);if(f&&!l){if(!s)throw new c.FileOperationError((0,m.localize)(16,null,this.resourceForError(n),this.resourceForError(e)),4);if(o===r){const{providerExtUri:y}=this.getExtUri(o);if(y.isEqualOrParent(n,e))throw new Error((0,m.localize)(17,null,this.resourceForError(n),this.resourceForError(e)))}}return{exists:f,isSameResourceWithDifferentPathCase:l}}getExtUri(o){const n=this.isPathCaseSensitive(o);return{providerExtUri:n?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:n}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(n,o);const r=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(o,0,r)),r}async mkdirp(o,n){const r=[],{providerExtUri:e}=this.getExtUri(o);for(;!e.isEqual(n,e.dirname(n));)try{if(((await o.stat(n)).type&c.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(n)));break}catch(i){if((0,c.toFileSystemProviderErrorCode)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(e.basename(n)),n=e.dirname(n)}for(let i=r.length-1;i>=0;i--){n=e.joinPath(n,r[i]);try{await o.mkdir(n)}catch(s){if((0,c.toFileSystemProviderErrorCode)(s)!==c.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(o,n){try{await this.doValidateDelete(o,n)}catch(r){return r}return!0}async doValidateDelete(o,n){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!n?.useTrash&&!(r.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(o)));let i;try{i=await r.stat(o)}catch{}if(i)this.throwIfFileIsReadonly(o,i);else throw new c.FileOperationError((0,m.localize)(20,null,this.resourceForError(o)),1);if(!!!n?.recursive){const l=await this.resolve(o);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(o)))}return r}async del(o,n){const r=await this.doValidateDelete(o,n),e=!!n?.useTrash,i=!!n?.recursive;await r.delete(o,{recursive:i,useTrash:e}),this._onDidRunOperation.fire(new c.FileOperationEvent(o,1))}watch(o,n={recursive:!1,excludes:[]}){const r=new g.DisposableStore;let e=!1,i=()=>{e=!0};return r.add((0,g.toDisposable)(()=>i())),(async()=>{try{const s=await this.doWatch(o,n);e?(0,g.dispose)(s):i=()=>(0,g.dispose)(s)}catch(s){this.logService.error(s)}})(),r}async doWatch(o,n){const r=await this.withProvider(o),e=(0,I.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(o),n]);let i=this.activeWatchers.get(e);return i||(i={count:0,disposable:r.watch(o,n)},this.activeWatchers.set(e,i)),i.count+=1,(0,g.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,g.dispose)(i.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,g.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,n,r,e){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(async()=>{const i=await o.open(n,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(e)||(0,p.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(o,i,e):await this.doWriteReadableBufferedQueued(o,i,e)}catch(s){throw(0,c.ensureFileSystemProviderError)(s)}finally{await o.close(i)}})}async doWriteStreamBufferedQueued(o,n,r){let e=0,i;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const s=P.VSBuffer.concat(r.buffer);await this.doWriteBuffer(o,n,s,s.byteLength,e,0),e+=s.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((s,l)=>{(0,p.listenStream)(i,{onData:async f=>{i.pause();try{await this.doWriteBuffer(o,n,f,f.byteLength,e,0)}catch(y){return l(y)}e+=f.byteLength,setTimeout(()=>i.resume())},onError:f=>l(f),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(o,n,r){let e=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(o,n,i,i.byteLength,e,0),e+=i.byteLength}async doWriteBuffer(o,n,r,e,i,s){let l=0;for(;l<e;)l+=await o.write(n,i+l,r.buffer,s+l,e-l)}async doWriteUnbuffered(o,n,r,e){return this.writeQueue.queueFor(n,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,n,r,e))}async doWriteUnbufferedQueued(o,n,r,e){let i;e instanceof P.VSBuffer?i=e:(0,p.isReadableStream)(e)?i=await(0,P.streamToBuffer)(e):(0,p.isReadableBufferedStream)(e)?i=await(0,P.bufferedStreamToBuffer)(e):i=(0,P.readableToBuffer)(e),await o.writeFile(n,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(o,n,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,n,r,e))}async doPipeBufferedQueued(o,n,r,e){let i,s;try{i=await o.open(n,{create:!1}),s=await r.open(e,{create:!0,unlock:!1});const l=P.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,y=0,w=0;do w=await o.read(i,f,l.buffer,y,l.byteLength-y),await this.doWriteBuffer(r,s,l,w,f,y),f+=w,y+=w,y===l.byteLength&&(y=0);while(w>0)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await D.Promises.settled([typeof i=="number"?o.close(i):Promise.resolve(),typeof s=="number"?r.close(s):Promise.resolve()])}}async doPipeUnbuffered(o,n,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,n,r,e))}async doPipeUnbufferedQueued(o,n,r,e){return r.writeFile(e,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,n,r,e){return this.writeQueue.queueFor(e,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,n,r,e))}async doPipeUnbufferedToBufferedQueued(o,n,r,e){const i=await r.open(e,{create:!0,unlock:!1});try{const s=await o.readFile(n);await this.doWriteBuffer(r,i,P.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw(0,c.ensureFileSystemProviderError)(s)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(o,n,r,e){const i=await(0,P.streamToBuffer)(this.readFileBuffered(o,n,R.CancellationToken.None));await this.doWriteUnbuffered(r,e,void 0,i)}throwIfFileSystemIsReadonly(o,n){if(o.capabilities&2048)throw new c.FileOperationError((0,m.localize)(22,null,this.resourceForError(n)),6);return o}throwIfFileIsReadonly(o,n){if((n.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,m.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};a=pe([oe(0,E.ILogService)],a),t.FileService=a}),define(Q[102],Z([0,1,103,136,3,54,17,6,45,2,11,12,19,37,15,84,16,50,99,28,96,95]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c,h,E,a,v,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(C)}catch(r){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(r)}`)}})();class n extends E.AbstractDiskFileSystemProvider{constructor(e,i){super(e,i);this.onDidChangeCapabilities=I.Event.None,this.resourceLocks=new R.ResourceMap(s=>d.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(e){try{const i=await p.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async l=>{try{let f;l.isSymbolicLink()?f=(await this.stat((0,d.joinPath)(e,l.name))).type:f=this.toType(l),s.push([l.name,f])}catch(f){this.logService.trace(f)}})),s}catch(i){throw this.toFileSystemProviderError(i)}}toType(e,i){let s;return i?.dangling?s=c.FileType.Unknown:e.isFile()?s=c.FileType.File:e.isDirectory()?s=c.FileType.Directory:s=c.FileType.Unknown,i&&(s|=c.FileType.SymbolicLink),s}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let i;for(;i=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await i.wait();const s=new P.Barrier;return this.resourceLocks.set(e,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,g.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),s.open()})}async readFile(e,i){let s;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),s=await this.createResourceLock(e));const l=this.toFilePath(e);return await p.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{s?.dispose()}}readFileStream(e,i,s){const l=(0,S.newWriteableStream)(f=>L.VSBuffer.concat(f.map(y=>L.VSBuffer.wrap(y))).buffer);return(0,h.readFileIntoStream)(this,e,l,f=>f.buffer,{...i,bufferSize:256*1024},s),l}async writeFile(e,i,s){let l;try{const f=this.toFilePath(e);if(!s.create||!s.overwrite){if(await p.Promises.exists(f)){if(!s.overwrite)throw(0,c.createFileSystemProviderError)((0,m.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,c.createFileSystemProviderError)((0,m.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(e,{create:!0,unlock:s.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(f){throw await this.toFileSystemProviderWriteError(e,f)}finally{typeof l=="number"&&await this.close(l)}}async open(e,i){let s;(0,c.isFileOpenForWriteOptions)(i)&&(s=await this.createResourceLock(e));let l;try{const f=this.toFilePath(e);if((0,c.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(f);w.mode&128||await p.Promises.chmod(f,w.mode|128)}catch(w){this.logService.trace(w)}let y;if((0,c.isFileOpenForWriteOptions)(i)){if(O.isWindows)try{await p.Promises.truncate(f,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.logService.trace(w)}y||(y="w")}else y="r";l=await p.Promises.open(f,y)}catch(f){throw s?.dispose(),(0,c.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(e,f):this.toFileSystemProviderError(f)}return this.mapHandleToPos.set(l,0),(0,c.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(l,e),s&&this.mapHandleToLock.set(l,s),l}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await p.Promises.fdatasync(e)}catch(i){this.canFlush=!1,this.logService.error(i)}return await p.Promises.close(e)}catch(i){throw this.toFileSystemProviderError(i)}finally{const i=this.mapHandleToLock.get(e);i&&(this.mapHandleToLock.delete(e),i.dispose())}}async read(e,i,s,l,f){const y=this.normalizePos(e,i);let w=null;try{const{bytesRead:T}=await p.Promises.read(e,s,l,f,y);return T}catch(T){throw this.toFileSystemProviderError(T)}finally{this.updatePos(e,y,w)}}normalizePos(e,i){return i===this.mapHandleToPos.get(e)?null:i}updatePos(e,i,s){const l=this.mapHandleToPos.get(e);typeof l=="number"&&(typeof i=="number"||(typeof s=="number"?this.mapHandleToPos.set(e,l+s):this.mapHandleToPos.delete(e)))}async write(e,i,s,l,f){return(0,P.retry)(()=>this.doWrite(e,i,s,l,f),100,3)}async doWrite(e,i,s,l,f){const y=this.normalizePos(e,i);let w=null;try{const{bytesWritten:T}=await p.Promises.write(e,s,l,f,y);return T}catch(T){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),T)}finally{this.updatePos(e,y,w)}}async mkdir(e){try{await p.Promises.mkdir(this.toFilePath(e))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(e,i){try{const s=this.toFilePath(e);i.recursive?await p.Promises.rm(s,p.RimRafMode.MOVE):await p.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(e,i,s){const l=this.toFilePath(e),f=this.toFilePath(i);if(l!==f)try{await this.validateTargetDeleted(e,i,"move",s.overwrite),await p.Promises.move(l,f)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,m.localize)(2,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(f)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(e,i,s){const l=this.toFilePath(e),f=this.toFilePath(i);if(l!==f)try{await this.validateTargetDeleted(e,i,"copy",s.overwrite),await p.Promises.copy(l,f,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,m.localize)(3,null,(0,b.basename)(l),(0,b.basename)((0,b.dirname)(f)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(e,i,s,l){const f=this.toFilePath(e),y=this.toFilePath(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,u.isEqual)(f,y,!0)),w&&s==="copy")throw(0,c.createFileSystemProviderError)((0,m.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!w&&await p.Promises.exists(y)){if(!l)throw(0,c.createFileSystemProviderError)((0,m.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}createUniversalWatcher(e,i,s){return new v.UniversalWatcherClient(l=>e(l),l=>i(l),s)}createNonRecursiveWatcher(e,i,s){return new o.NodeJSWatcherClient(l=>e(l),l=>i(l),s)}toFileSystemProviderError(e){if(e instanceof c.FileSystemProviderError)return e;let i;switch(e.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(e,i)}async toFileSystemProviderWriteError(e,i){let s=this.toFileSystemProviderError(i);if(e&&s.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await p.SymlinkSupport.stat(this.toFilePath(e));l.mode&128||(s=(0,c.createFileSystemProviderError)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return s}}t.DiskFileSystemProvider=n}),define(Q[104],Z([0,1,16,14]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function P(I,u,g,b,O){try{const d=await new Promise((p,m)=>{z(["spdlog"],p,m)});d.setFlushOn(D.LogLevel.Trace);const S=await d.createAsyncRotatingLogger(I,u,g,b);return O&&S.clearFormatters(),S}catch(d){console.error(d)}return null}function R(I,u,g){switch(u){case D.LogLevel.Trace:I.trace(g);break;case D.LogLevel.Debug:I.debug(g);break;case D.LogLevel.Info:I.info(g);break;case D.LogLevel.Warning:I.warn(g);break;case D.LogLevel.Error:I.error(g);break;case D.LogLevel.Critical:I.critical(g);break;default:throw new Error("Invalid log level")}}class L extends D.AbstractMessageLogger{constructor(u,g,b,O,d){super();this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(u,g,b,O),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(u,g,b,O){const d=b?6:1,S=30/d*C.ByteSize.MB,p=await P(u,g,S,d,O);if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:m,message:c}of this.buffer)R(this._logger,m,c);this.buffer=[]}}log(u,g){this._logger?R(this._logger,u,g):this.getLevel()<=u&&this.buffer.push({level:u,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Q[32],Z([0,1,13]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,C.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Q[30],Z([0,1,55,8]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class P{constructor(){this.data=new Map}add(L,I){C.ok(D.isString(L)),C.ok(D.isObject(I)),C.ok(!this.data.has(L),"There is already an extension with this id"),this.data.set(L,I)}knows(L){return this.data.has(L)}as(L){return this.data.get(L)||null}}t.Registry=new P}),define(Q[105],Z([0,1,6,30]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function P(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class R{constructor(){this._onDidChangeSchema=new C.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,g){this.schemasById[P(u)]=g,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const L=new R;D.Registry.add(t.Extensions.JSONContribution,L)}),define(Q[34],Z([0,1,18,6,8,73,105,30]),function(z,t,C,D,P,R,L,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var u;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(u=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var g;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(L.Extensions.JSONContribution);class O{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(o,n=!0){this.registerConfigurations([o],n)}registerConfigurations(o,n=!0){const r=this.doRegisterConfigurations(o,n);b.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}deregisterConfigurations(o){const n=this.doDeregisterConfigurations(o);b.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:o,remove:n}){const r=[];r.push(...this.doDeregisterConfigurations(n)),r.push(...this.doRegisterConfigurations(o,!1)),b.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,C.distinct)(r)})}registerDefaultConfigurations(o){const n=[],r=[];for(const{overrides:e,source:i}of o)for(const s in e)if(n.push(s),t.OVERRIDE_PROPERTY_REGEX.test(s)){const l={...this.configurationDefaultsOverrides.get(s)?.value||{},...e[s]};this.configurationDefaultsOverrides.set(s,{source:i,value:l});const f={type:"object",default:l,description:R.localize(1,null,s),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:l,source:P.isString(i)?void 0:i};r.push(...p(s)),this.configurationProperties[s]=f,this.defaultLanguageConfigurationOverridesNode.properties[s]=f}else{this.configurationDefaultsOverrides.set(s,{value:e[s],source:i});const l=this.configurationProperties[s];l&&(this.updatePropertyDefaultValue(s,l),this.updateSchema(s,l))}this.registerOverrideIdentifiers(r),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(o){const n=[];for(const{overrides:r,source:e}of o)for(const i in r){const s=this.configurationDefaultsOverrides.get(i),l=P.isString(e)?e:e?.id,f=P.isString(s?.source)?s?.source:s?.source?.id;if(l===f)if(n.push(i),this.configurationDefaultsOverrides.delete(i),t.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const y=this.configurationProperties[i];y&&(this.updatePropertyDefaultValue(i,y),this.updateSchema(i,y))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...o){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(o){for(const n of o)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(o,n){const r=[];return o.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),r}doDeregisterConfigurations(o){const n=[],r=e=>{if(e.properties)for(const i in e.properties)n.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,e.properties[i]);e.allOf&&e.allOf.forEach(i=>r(i))};for(const e of o){r(e);const i=this.configurationContributors.indexOf(e);i!==-1&&this.configurationContributors.splice(i,1)}return n}validateAndRegisterProperties(o,n=!0,r,e,i=3){i=P.isUndefinedOrNull(o.scope)?i:o.scope;let s=[],l=o.properties;if(l)for(let y in l){if(n&&E(y)){delete l[y];continue}const w=l[y];if(w.source=r,w.defaultDefaultValue=l[y].default,this.updatePropertyDefaultValue(y,w),t.OVERRIDE_PROPERTY_REGEX.test(y)?w.scope=void 0:(w.scope=P.isUndefinedOrNull(w.scope)?i:w.scope,w.restricted=P.isUndefinedOrNull(w.restricted)?!!e?.includes(y):w.restricted),l[y].hasOwnProperty("included")&&!l[y].included){this.excludedConfigurationProperties[y]=l[y],delete l[y];continue}else this.configurationProperties[y]=l[y];!l[y].deprecationMessage&&l[y].markdownDeprecationMessage&&(l[y].deprecationMessage=l[y].markdownDeprecationMessage),s.push(y)}let f=o.allOf;if(f)for(let y of f)s.push(...this.validateAndRegisterProperties(y,n,r,e,i));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(o){const n=r=>{let e=r.properties;if(e)for(const s in e)this.updateSchema(s,e[s]);let i=r.allOf;i&&i.forEach(n)};n(o)}updateSchema(o,n){switch(t.allSettings.properties[o]=n,n.scope){case 1:t.applicationSettings.properties[o]=n;break;case 2:t.machineSettings.properties[o]=n;break;case 6:t.machineOverridableSettings.properties[o]=n;break;case 3:t.windowSettings.properties[o]=n;break;case 4:t.resourceSettings.properties[o]=n;break;case 5:t.resourceSettings.properties[o]=n,this.resourceLanguageSettingsSchema.properties[o]=n;break}}removeFromSchema(o,n){switch(delete t.allSettings.properties[o],n.scope){case 1:delete t.applicationSettings.properties[o];break;case 2:delete t.machineSettings.properties[o];break;case 6:delete t.machineOverridableSettings.properties[o];break;case 3:delete t.windowSettings.properties[o];break;case 4:case 5:delete t.resourceSettings.properties[o],delete this.resourceLanguageSettingsSchema.properties[o];break}}updateOverridePropertyPatternKey(){for(const o of this.overrideIdentifiers.values()){const n=`[${o}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,r),t.allSettings.properties[n]=r,t.applicationSettings.properties[n]=r,t.machineSettings.properties[n]=r,t.machineOverridableSettings.properties[n]=r,t.windowSettings.properties[n]=r,t.resourceSettings.properties[n]=r}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const o={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=o,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(o,n){const r=this.configurationDefaultsOverrides.get(o);let e=r?.value,i=r?.source;P.isUndefined(e)&&(e=n.defaultDefaultValue,i=void 0),P.isUndefined(e)&&(e=c(n.type)),n.default=e,n.defaultValueSource=i}}const d="\\[([^\\]]+)\\]",S=new RegExp(d,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function p(v){const o=[];if(t.OVERRIDE_PROPERTY_REGEX.test(v)){let n=S.exec(v);for(;n?.length;){const r=n[1].trim();r&&o.push(r),n=S.exec(v)}}return(0,C.distinct)(o)}t.overrideIdentifiersFromKey=p;function m(v){return v.reduce((o,n)=>`${o}[${n}]`,"")}t.keyFromOverrideIdentifiers=m;function c(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=c;const h=new O;I.Registry.add(t.Extensions.Configuration,h);function E(v){return v.trim()?t.OVERRIDE_PROPERTY_REGEX.test(v)?R.localize(7,null,v):h.getConfigurationProperties()[v]!==void 0?R.localize(8,null,v):null:R.localize(6,null)}t.validateProperty=E;function a(){const v=[],o=h.getConfigurationProperties();for(const n of Object.keys(o))v.push([n,o[n].scope]);return v.push(["launch",4]),v.push(["task",4]),v}t.getScopes=a}),define(Q[106],Z([0,1,18,6,56,2,54,21,8,9,25,34,30]),function(z,t,C,D,P,R,L,I,u,g,b,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class S{constructor(e={},i=[],s=[]){this._contents=e,this._keys=i,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,b.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const s=this.getContentsForOverrideIdentifer(i);return s?e?(0,b.getConfigurationValue)(s,e):s:void 0}getKeysForOverrideIdentifier(e){const i=[];for(const s of this.overrides)s.identifiers.includes(e)&&i.push(...s.keys);return C.distinct(i)}getAllOverrideIdentifiers(){const e=[];for(const i of this.overrides)e.push(...i.identifiers);return C.distinct(e)}override(e){let i=this.overrideConfigurations.get(e);return i||(i=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,i)),i}merge(...e){const i=I.deepClone(this.contents),s=I.deepClone(this.overrides),l=[...this.keys];for(const f of e){this.mergeContents(i,f.contents);for(const y of f.overrides){const[w]=s.filter(T=>C.equals(T.identifiers,y.identifiers));w?(this.mergeContents(w.contents,y.contents),w.keys.push(...y.keys),w.keys=C.distinct(w.keys)):s.push(I.deepClone(y))}for(const y of f.keys)l.indexOf(y)===-1&&l.push(y)}return new S(i,l,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const l of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let f=this.contents[l],y=i[l];y&&(typeof f=="object"&&typeof y=="object"?(f=I.deepClone(f),this.mergeContents(f,y)):f=y),s[l]=f}return new S(s,this.keys,this.overrides)}mergeContents(e,i){for(const s of Object.keys(i)){if(s in e&&u.isObject(e[s])&&u.isObject(i[s])){this.mergeContents(e[s],i[s]);continue}e[s]=I.deepClone(i[s])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?I.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let i=null,s=null;const l=f=>{f&&(s?this.mergeContents(s,f):s=I.deepClone(f))};for(const f of this.overrides)C.equals(f.identifiers,[e])?i=f.contents:f.identifiers.includes(e)&&l(f.contents);return l(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,b.addToValueTree)(this.contents,e,i,s=>{throw new Error(s)})}removeValue(e){this.removeKey(e)&&(0,b.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let s=0;s<i;s++)e.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=S;class p extends S{constructor(e={}){const i=d.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(i),l=Object.create(null),f=[];for(const y in i){const w=e[y],T=w!==void 0?w:i[y].default;(0,b.addToValueTree)(l,y,T,A=>console.error(`Conflict in default settings: ${A}`))}for(const y of Object.keys(l))O.OVERRIDE_PROPERTY_REGEX.test(y)&&f.push({identifiers:(0,O.overrideIdentifiersFromKey)(y),keys:Object.keys(l[y]),contents:(0,b.toValuesTree)(l[y],w=>console.error(`Conflict in default settings file: ${w}`))});super(l,s,f)}}t.DefaultConfigurationModel=p;class m{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!u.isUndefinedOrNull(e)){const s=this.doParseContent(e);this.parseRaw(s,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:s,keys:l,overrides:f,restricted:y}=this.doParseRaw(e,i);this._configurationModel=new S(s,l,f),this._restrictedConfigurations=y||[]}doParseContent(e){let i={},s=null,l=[],f=[],y=[];function w(A){Array.isArray(l)?l.push(A):s!==null&&(l[s]=A)}let T={onObjectBegin:()=>{let A={};w(A),f.push(l),l=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{l=f.pop()},onArrayBegin:()=>{let A=[];w(A),f.push(l),l=A,s=null},onArrayEnd:()=>{l=f.pop()},onLiteralValue:w,onError:(A,B,J)=>{y.push({error:A,offset:B,length:J})}};if(e)try{P.visit(e,T),i=l[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return i}doParseRaw(e,i){const s=d.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),l=this.filter(e,s,!0,i);e=l.raw;const f=(0,b.toValuesTree)(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),y=Object.keys(e),w=this.toOverrides(e,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:f,keys:y,overrides:w,restricted:l.restricted}}filter(e,i,s,l){if(!l?.scopes&&!l?.skipRestricted)return{raw:e,restricted:[]};const f={},y=[];for(let w in e)if(O.OVERRIDE_PROPERTY_REGEX.test(w)&&s){const T=this.filter(e[w],i,!1,l);f[w]=T.raw,y.push(...T.restricted)}else{const T=i[w],A=T?typeof T.scope!="undefined"?T.scope:3:void 0;T?.restricted&&y.push(w),(A===void 0||l.scopes===void 0||l.scopes.includes(A))&&(l.skipRestricted&&T?.restricted||(f[w]=e[w]))}return{raw:f,restricted:y}}toOverrides(e,i){const s=[];for(const l of Object.keys(e))if(O.OVERRIDE_PROPERTY_REGEX.test(l)){const f={};for(const y in e[l])f[y]=e[l][y];s.push({identifiers:(0,O.overrideIdentifiersFromKey)(l),keys:Object.keys(f),contents:(0,b.toValuesTree)(f,i)})}return s}}t.ConfigurationModelParser=m;class c extends R.Disposable{constructor(e,i,s,l){super();this.userSettingsResource=e,this.scopes=i,this.fileService=l,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=c;class h{constructor(e,i,s=new S,l=new S,f=new L.ResourceMap,y=new S,w=new L.ResourceMap,T=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=l,this._folderConfigurations=f,this._memoryConfiguration=y,this._memoryConfigurationByResource=w,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(e,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(e)}updateValue(e,i,s={}){let l;s.resource?(l=this._memoryConfigurationByResource.get(s.resource),l||(l=new S,this._memoryConfigurationByResource.set(s.resource,l))):l=this._memoryConfiguration,i===void 0?l.removeValue(e):l.setValue(e,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,s){const l=this.getConsolidateConfigurationModel(i,s),f=this.getFolderConfigurationModelForResource(i.resource,s),y=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,w=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),A=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),B=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),J=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,se=f?i.overrideIdentifier?f.freeze().override(i.overrideIdentifier).getValue(e):f.freeze().getValue(e):void 0,ie=i.overrideIdentifier?y.override(i.overrideIdentifier).getValue(e):y.getValue(e),te=l.getValue(e),ge=C.distinct(C.flatten(l.overrides.map($=>$.identifiers))).filter($=>l.getOverrideValue(e,$)!==void 0);return{defaultValue:w,userValue:T,userLocalValue:A,userRemoteValue:B,workspaceValue:J,workspaceFolderValue:se,memoryValue:ie,value:te,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:B!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:J!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:f?.freeze().getValue(e),override:i.overrideIdentifier?f?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:y.getValue(e),override:i.overrideIdentifier?y.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ge.length?ge:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const s=[];if(!i){const{added:l,updated:f,removed:y}=o(this._defaultConfiguration,e);i=[...l,...f,...y]}for(const l of i)for(const f of(0,O.overrideIdentifiersFromKey)(l)){const y=this._defaultConfiguration.getKeysForOverrideIdentifier(f),w=e.getKeysForOverrideIdentifier(f),T=[...w.filter(A=>y.indexOf(A)===-1),...y.filter(A=>w.indexOf(A)===-1),...y.filter(A=>!I.equals(this._defaultConfiguration.override(f).getValue(A),e.override(f).getValue(A)))];s.push([f,T])}return this.updateDefaultConfiguration(e),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:s,removed:l,overrides:f}=o(this.localUserConfiguration,e),y=[...i,...s,...l];return y.length&&this.updateLocalUserConfiguration(e),{keys:y,overrides:f}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:s,removed:l,overrides:f}=o(this.remoteUserConfiguration,e);let y=[...i,...s,...l];return y.length&&this.updateRemoteUserConfiguration(e),{keys:y,overrides:f}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:s,removed:l,overrides:f}=o(this.workspaceConfiguration,e);let y=[...i,...s,...l];return y.length&&this.updateWorkspaceConfiguration(e),{keys:y,overrides:f}}compareAndUpdateFolderConfiguration(e,i){const s=this.folderConfigurations.get(e),{added:l,updated:f,removed:y,overrides:w}=o(s,i);let T=[...l,...f,...y];return(T.length||!s)&&this.updateFolderConfiguration(e,i),{keys:T,overrides:w}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:s,updated:l,removed:f,overrides:y}=o(i,void 0);return{keys:[...s,...l,...f],overrides:y}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let s=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?s.override(e.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:e},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const l=i.getFolder(e);l&&(s=this.getFolderConsolidatedConfiguration(l.uri)||s);const f=this._memoryConfigurationByResource.get(e);f&&(s=s.merge(f))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),l=this._folderConfigurations.get(e);l?(i=s.merge(l),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=s}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const s=i.getFolder(e);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:s,overrides:l,keys:f}=this._folderConfigurations.get(i);return e.push([i,{contents:s,overrides:l,keys:f}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>e.add(s))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(s=>e.add(s))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(e).forEach(l=>i.add(l))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),s=this.parseConfigurationModel(e.user),l=this.parseConfigurationModel(e.workspace),f=e.folders.reduce((y,w)=>(y.set(g.URI.revive(w[0]),this.parseConfigurationModel(w[1])),y),new L.ResourceMap);return new h(i,s,new S,l,f,new S,new L.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=h;function E(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const l of r)l.keys.forEach(f=>e.add(f)),l.overrides.forEach(([f,y])=>{const w=(0,L.getOrSet)(i,f,new Set);y.forEach(T=>w.add(T))});const s=[];return i.forEach((l,f)=>s.push([f,[...l.values()]])),{keys:[...e.values()],overrides:s}}t.mergeChanges=E;class a{constructor(e,i,s,l){this.change=e,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=l,this._previousConfiguration=void 0;const f=new Set;e.keys.forEach(w=>f.add(w)),e.overrides.forEach(([,w])=>w.forEach(T=>f.add(T))),this.affectedKeys=[...f.values()];const y=new S;this.affectedKeys.forEach(w=>y.setValue(w,{})),this.affectedKeysTree=y.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=h.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,l=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!I.equals(s,l)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let s=(0,b.toValuesTree)({[i]:!0},()=>{}),l;for(;typeof s=="object"&&(l=Object.keys(s)[0]);){if(e=e[l],!e)return!1;s=s[l]}return!0}}t.ConfigurationChangeEvent=a;class v extends a{constructor(e,i,s,l){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=s,this.sourceConfig=l}}t.AllKeysConfigurationChangeEvent=v;function o(r,e){const{added:i,removed:s,updated:l}=n(e,r),f=[],y=r?.getAllOverrideIdentifiers()||[],w=e?.getAllOverrideIdentifiers()||[];if(e){const T=w.filter(A=>!y.includes(A));for(const A of T)f.push([A,e.getKeysForOverrideIdentifier(A)])}if(r){const T=y.filter(A=>!w.includes(A));for(const A of T)f.push([A,r.getKeysForOverrideIdentifier(A)])}if(e&&r){for(const T of y)if(w.includes(T)){const A=n({contents:r.getOverrideValue(void 0,T)||{},keys:r.getKeysForOverrideIdentifier(T)},{contents:e.getOverrideValue(void 0,T)||{},keys:e.getKeysForOverrideIdentifier(T)});f.push([T,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:s,updated:l,overrides:f}}function n(r,e){const i=r?e?r.keys.filter(f=>e.keys.indexOf(f)===-1):[...r.keys]:[],s=e?r?e.keys.filter(f=>r.keys.indexOf(f)===-1):[...e.keys]:[],l=[];if(r&&e){for(const f of e.keys)if(r.keys.indexOf(f)!==-1){const y=(0,b.getConfigurationValue)(e.contents,f),w=(0,b.getConfigurationValue)(r.contents,f);I.equals(y,w)||l.push(f)}}return{added:i,removed:s,updated:l}}}),define(Q[107],Z([0,1,3,6,2,19,25,106,34,30]),function(z,t,C,D,P,R,L,I,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class b extends P.Disposable{constructor(d,S){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,S)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new C.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(({properties:p})=>this.onDidDefaultConfigurationChange(p))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,S){const p=typeof d=="string"?d:void 0,m=(0,L.isConfigurationOverrides)(d)?d:(0,L.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(p,m,void 0)}updateValue(d,S,p,m){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const S=this.configuration.toData(),p=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(p,S,1)}onDidDefaultConfigurationChange(d){const S=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,d);this.trigger(p,S,6)}trigger(d,S,p){const m=new I.ConfigurationChangeEvent(d,{data:S},this.configuration);m.source=p,m.sourceConfig=this.getTargetConfiguration(p),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=b}),define(Q[108],Z([0,1,10]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVirtualWorkspace=t.getVirtualWorkspaceScheme=t.getVirtualWorkspaceLocation=t.isVirtualResource=t.getRemoteName=t.getRemoteAuthority=void 0;function D(g){return g.scheme===C.Schemas.vscodeRemote?g.authority:void 0}t.getRemoteAuthority=D;function P(g){if(!g)return;const b=g.indexOf("+");return b<0?g:g.substr(0,b)}t.getRemoteName=P;function R(g){return g.scheme!==C.Schemas.file&&g.scheme!==C.Schemas.vscodeRemote}t.isVirtualResource=R;function L(g){if(g.folders.length)return g.folders.every(b=>R(b.uri))?g.folders[0].uri:void 0;if(g.configuration&&R(g.configuration))return g.configuration}t.getVirtualWorkspaceLocation=L;function I(g){return L(g)?.scheme}t.getVirtualWorkspaceScheme=I;function u(g){return L(g)!==void 0}t.isVirtualWorkspace=u}),define(Q[40],Z([0,1,26,13,108]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}t.getWorkspaceSupportTypeMessage=R;function L(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}t.isIExtensionIdentifier=L,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(I=t.ExtensionType||(t.ExtensionType={}));class u{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,p){if(typeof S=="undefined"||S===null)return typeof p=="undefined"||p===null;if(typeof p=="undefined"||p===null)return!1;if(typeof S=="string"||typeof p=="string"){let m=typeof S=="string"?S:S.value,c=typeof p=="string"?p:p.value;return C.equalsIgnoreCase(m,c)}return S._lower===p._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}t.ExtensionIdentifier=u;function g(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}t.isLanguagePackExtension=g;function b(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=b;function O(d,S){if(S){const p=`onResolveRemoteAuthority:${(0,P.getRemoteName)(S)}`;return d.activationEvents?.indexOf(p)!==-1}return!1}t.isResolverExtension=O,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[23],Z([0,1,26,40]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function P(p,m){return p.uuid&&m.uuid?p.uuid===m.uuid:p.id===m.id?!0:(0,C.compareIgnoreCase)(p.id,m.id)===0}t.areSameExtensions=P;class R{constructor(m,c){this.version=c,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof R?P(this,m)&&this.version===m.version:!1}}t.ExtensionIdentifierWithVersion=R;function L(p,m){return`${p}.${m}`}t.getExtensionId=L;function I(p){return p.toLocaleLowerCase()}t.adoptToGalleryExtensionId=I;function u(p,m){return I(L(p,m))}t.getGalleryExtensionId=u;function g(p,m){const c=[],h=E=>{for(const a of c)if(a.some(v=>P(m(v),m(E))))return a;return null};for(const E of p){const a=h(E);a?a.push(E):c.push([E])}return c}t.groupByExtension=g;function b(p){return{id:p.identifier.id,name:p.manifest.name,galleryId:null,publisherId:p.publisherId,publisherName:p.manifest.publisher,publisherDisplayName:p.publisherDisplayName,dependencies:p.manifest.extensionDependencies&&p.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=b;function O(p){return{id:p.identifier.id,name:p.name,galleryId:p.identifier.uuid,publisherId:p.publisherId,publisherName:p.publisher,publisherDisplayName:p.publisherDisplayName,isPreReleaseVersion:p.properties.isPreReleaseVersion,dependencies:!!(p.properties.dependencies&&p.properties.dependencies.length>0),...p.telemetryData}}t.getGalleryExtensionTelemetryData=O,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function d(p){const m=new Set;if(p.malicious)for(const c of p.malicious)m.add(c.id);return m}t.getMaliciousExtensionsSet=d;function S(p,m){const c=[],h=m.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const E=h.shift();if(E&&c.every(a=>!P(a.identifier,{id:E}))){const a=p.filter(v=>P(v.identifier,{id:E}));a.length===1&&(c.push(a[0]),h.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}t.getExtensionDependencies=S}),define(Q[109],Z([0,1,24,7,62,10,41,9,77,22,23,40]),function(z,t,C,D,P,R,L,I,u,g,b,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const d=E=>(0,u.localize)(0,null,E),S=(0,u.localize)(1,null,"ms-dotnettools.csharp");function p(E,a){return a?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}const m=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function c(E){const a=m.exec(E);return a&&a[1]?[(0,b.adoptToGalleryExtensionId)(a[1]),a[2]]:[(0,b.adoptToGalleryExtensionId)(E),void 0]}t.getIdAndVersion=c;let h=class{constructor(a,v){this.extensionManagementService=a,this.extensionGalleryService=v}get location(){}async listExtensions(a,v,o=console){let n=await this.extensionManagementService.getInstalled(1);const r=O.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(v&&v!==""){if(r.indexOf(v.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(i=>i.manifest.categories?i.manifest.categories.map(l=>l.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){o.log("Possible Categories: "),r.forEach(i=>{o.log(i)});return}this.location&&o.log((0,u.localize)(2,null,this.location)),n=n.sort((i,s)=>i.identifier.id.localeCompare(s.identifier.id));let e;for(let i of n)e!==i.identifier.id&&(e=i.identifier.id,o.log(p(i.manifest,a)))}async installExtensions(a,v,o,n,r=console){const e=[],i=[];a.length&&r.log(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const s=await this.extensionManagementService.getInstalled(1),l=(w,T)=>{const A=s.find(B=>(0,b.areSameExtensions)(B.identifier,{id:w}));if(A){if(!T&&!n)return r.log((0,u.localize)(5,null,w,A.manifest.version,w)),!1;if(T&&A.manifest.version===T)return r.log((0,u.localize)(6,null,`${w}@${T}`)),!1}return!0},f=[],y=[];for(const w of a)if(w instanceof I.URI)f.push(w);else{const[T,A]=c(w);l(T,A)&&y.push({id:T,version:A,installOptions:{...o,isBuiltin:!1}})}for(const w of v){const[T,A]=c(w);l(T,A)&&y.push({id:T,version:A,installOptions:{...o,isBuiltin:!0}})}if(f.length&&await Promise.all(f.map(async w=>{try{const T=await this.installVSIX(w,{...o,isBuiltin:!1},n,r);T&&i.push(T)}catch(T){r.error(T.message||T.stack||T),e.push(w.toString())}})),y.length){const w=await this.getGalleryExtensions(y);await Promise.all(y.map(async T=>{const A=w.get(T.id.toLowerCase());if(A)try{const B=await this.installFromGallery(T,A,s,n,r);B&&i.push(B)}catch(B){r.error(B.message||B.stack||B),e.push(T.id)}else r.error(`${d(T.version?`${T.id}@${T.version}`:T.id)}
${S}`),e.push(T.id)}))}if(e.length)throw new Error((0,u.localize)(7,null,e.join(", ")))}async installVSIX(a,v,o,n){const r=await this.extensionManagementService.getManifest(a);if(!r)throw new Error("Invalid vsix");if(await this.validateVSIX(r,o,n))try{return await this.extensionManagementService.install(a,v),n.log((0,u.localize)(8,null,(0,P.getBaseLabel)(a))),r}catch(i){if((0,D.isCancellationError)(i))return n.log((0,u.localize)(9,null,(0,P.getBaseLabel)(a))),null;throw i}return null}async getGalleryExtensions(a){const v=new Map,o=a.some(r=>r.installOptions.installPreReleaseVersion),n=await this.extensionGalleryService.getExtensions(a.map(r=>({...r,preRelease:o})),C.CancellationToken.None);for(const r of n)v.set(r.identifier.id.toLowerCase(),r);return v}async installFromGallery({id:a,version:v,installOptions:o},n,r,e,i){const s=await this.extensionGalleryService.getManifest(n,C.CancellationToken.None);if(s&&!this.validateExtensionKind(s,i))return null;const l=r.find(f=>(0,b.areSameExtensions)(f.identifier,n.identifier));if(l){if(n.version===l.manifest.version)return i.log((0,u.localize)(10,null,v?`${a}@${v}`:a)),null;i.log((0,u.localize)(11,null,a,n.version))}try{return o.isBuiltin?i.log(v?(0,u.localize)(12,null,a,v):(0,u.localize)(13,null,a)):i.log(v?(0,u.localize)(14,null,a,v):(0,u.localize)(15,null,a)),await this.extensionManagementService.installFromGallery(n,{...o,installGivenVersion:!!v}),i.log((0,u.localize)(16,null,a,n.version)),s}catch(f){if((0,D.isCancellationError)(f))return i.log((0,u.localize)(17,null,a)),null;throw f}}validateExtensionKind(a,v){return!0}async validateVSIX(a,v,o){const n={id:(0,b.getGalleryExtensionId)(a.publisher,a.name)},e=(await this.extensionManagementService.getInstalled(1)).find(i=>(0,b.areSameExtensions)(n,i.identifier)&&(0,L.gt)(i.manifest.version,a.version));return e&&!v?(o.log((0,u.localize)(18,null,e.identifier.id,e.manifest.version,a.version)),!1):this.validateExtensionKind(a,o)}async uninstallExtensions(a,v,o=console){const n=async e=>{if(e instanceof I.URI){const i=await this.extensionManagementService.getManifest(e);return p(i)}return e},r=[];for(const e of a){const i=await n(e),l=(await this.extensionManagementService.getInstalled()).filter(f=>(0,b.areSameExtensions)(f.identifier,{id:i}));if(!l.length)throw new Error(`${this.notInstalled(i)}
${S}`);if(l.some(f=>f.type===0)){o.log((0,u.localize)(19,null,i));return}if(!v&&l.some(f=>f.isBuiltin)){o.log((0,u.localize)(20,null,i));return}o.log((0,u.localize)(21,null,i));for(const f of l)await this.extensionManagementService.uninstall(f),r.push(f);this.location?o.log((0,u.localize)(22,null,i,this.location)):o.log((0,u.localize)(23,null,i))}}async locateExtension(a,v=console){const o=await this.extensionManagementService.getInstalled();a.forEach(n=>{o.forEach(r=>{if(r.identifier.id===n&&r.location.scheme===R.Schemas.file){v.log(r.location.fsPath);return}})})}notInstalled(a){return this.location?(0,u.localize)(24,null,a,this.location):(0,u.localize)(25,null,a)}};h=pe([oe(0,g.IExtensionManagementService),oe(1,g.IExtensionGalleryService)],h),t.ExtensionManagementCLIService=h}),define(Q[110],Z([0,1,3,7,2,12,19,41,9,27,15,20,22,23,16,14]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let h=class extends P.Disposable{constructor(a,v,o,n){super();this.fileService=v,this.extensionGalleryService=o,this.logService=n,this.extensionsDownloadDir=u.URI.file(a.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(a,v){await this.cleanUpPromise;const o=this.getName(a),n=(0,L.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(n)){const r=(0,L.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(a,r,v);try{await this.rename(r,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(r)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",a.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,r.path),e}}return n}async delete(a){await this.cleanUpPromise,await this.fileService.del(a)}async rename(a,v,o){try{await b.Promises.rename(a.fsPath,v.fsPath)}catch(n){if(R.isWindows&&n&&n.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${a} to ${v} with 'EPERM' error. Trying again...`),this.rename(a,v,o);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const a=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(a.children){const v=[],o=[];for(const e of a.children){const i=this.parse(e.name);i&&o.push([i,e])}const n=(0,S.groupByExtension)(o,([e])=>e),r=[];for(const e of n)e.sort((i,s)=>I.rcompare(i[0].version,s[0].version)),v.push(...e.slice(1).map(i=>i[1].resource)),r.push(e[0][1]);r.sort((e,i)=>e.mtime-i.mtime),v.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(e=>e.resource)),await C.Promises.settled(v.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(a){this.logService.error(a)}}getName(a){return this.cache?`${new S.ExtensionIdentifierWithVersion(a.identifier,a.version).key().toLowerCase()}${a.properties.targetPlatform!=="undefined"?`-${a.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(a){const v=c.exec(a);return v&&v[1]&&v[2]?new S.ExtensionIdentifierWithVersion({id:v[1]},v[2]):null}};h=pe([oe(0,O.INativeEnvironmentService),oe(1,p.IFileService),oe(2,d.IExtensionGalleryService),oe(3,m.ILogService)],h),t.ExtensionsDownloader=h}),define(Q[111],Z([0,1,2,11,15,40]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class L extends C.Disposable{constructor(u,g){super();this.environmentService=u,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,R.MANIFEST_CACHE_FOLDER,R.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(g.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(u){u.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){P.Promises.rm(this.extensionsManifestCache,P.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=L}),define(Q[112],Z([0,1,137,18,3,2,10,11,15,20,22,23,53,14]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let p=class extends R.Disposable{constructor(h,E,a){super();this.extensionManagementService=h,this.logService=a,this.cache=this._register(new m(E,a)),this.extensionManagementService.registerParticipant({postInstall:async v=>this.postInstallExtension(v),postUninstall:async v=>this.postUninstallExtension(v)})}async getLanguageIds(){const h=await this.cache.getLanguagePacks(),E=["en",...Object.keys(h)];return(0,D.distinct)(E)}async postInstallExtension(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",h.identifier.id),await this.update())}async postUninstallExtension(h){const E=await this.cache.getLanguagePacks();Object.keys(E).some(a=>E[a]&&E[a].extensions.some(v=>(0,O.areSameExtensions)(v.extensionIdentifier,h.identifier)))&&(this.logService.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(E);return!(0,D.equals)(Object.keys(h),Object.keys(a))}};p=pe([oe(0,b.IExtensionManagementService),oe(1,g.INativeEnvironmentService),oe(2,S.ILogService)],p),t.LocalizationsService=p;let m=class extends R.Disposable{constructor(h,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,I.join)(h.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(h){return this.withLanguagePacks(E=>{Object.keys(E).forEach(a=>delete E[a]),this.createLanguagePacksFromExtensions(E,...h)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(h,...E){for(const a of E)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(h,a);Object.keys(h).forEach(a=>this.updateHash(h[a]))}createLanguagePacksFromExtension(h,E){const a=E.identifier,v=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const o of v)if(E.location.scheme===L.Schemas.file&&(0,d.isValidLocalization)(o)){let n=h[o.languageId];n||(n={hash:"",extensions:[],translations:{}},h[o.languageId]=n);let r=n.extensions.filter(e=>(0,O.areSameExtensions)(e.extensionIdentifier,a))[0];r?r.version=E.manifest.version:n.extensions.push({extensionIdentifier:a,version:E.manifest.version});for(const e of o.translations)n.translations[e.id]=(0,I.join)(E.location.fsPath,e.path)}}updateHash(h){if(h){const E=(0,C.createHash)("md5");for(const a of h.extensions)E.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);h.hash=E.digest("hex")}}withLanguagePacks(h=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(E=h(a),a)).then(a=>{for(const o of Object.keys(a))a[o]||delete a[o];this.languagePacks=a,this.initializedCache=!0;const v=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",v),u.Promises.writeFile(this.languagePacksFilePath,v)}).then(()=>E,a=>this.logService.error(a))})}};m=pe([oe(0,g.INativeEnvironmentService),oe(1,S.ILogService)],m)}),define(Q[42],Z([0,1,17,85,34,13,30]),function(z,t,C,D,P,R,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,R.createDecorator)("requestService");function I(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}t.isSuccess=I;function u(p){return p.res.statusCode===204}async function g(p){if(!I(p))throw new Error("Server returned "+p.res.statusCode);return u(p)?null:(await(0,C.streamToBuffer)(p.stream)).toString()}t.asText=g;async function b(p){if(!I(p))throw new Error("Server returned "+p.res.statusCode);if(u(p))return null;const c=(await(0,C.streamToBuffer)(p.stream)).toString();try{return JSON.parse(c)}catch(h){throw h.message+=`:
`+c,h}}t.asJson=b;function O(p){S(p)}t.updateProxyConfigurationsScope=O;let d;function S(p){const m=L.Registry.as(P.Extensions.Configuration),c=d;d={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[d],remove:c?[c]:[]})}S(2)}),define(Q[113],Z([0,1,24,10,16,42]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let L=class{constructor(u,g){this.requestService=u,this.fileService=g}async download(u,g,b=C.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.fileService.copy(u,g);return}const O={type:"GET",url:u.toString()},d=await this.requestService.request(O,b);if(d.res.statusCode===200)await this.fileService.writeFile(g,d.stream);else{const S=await(0,R.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${S}`)}}};L=pe([oe(0,R.IRequestService),oe(1,P.IFileService)],L),t.DownloadService=L}),define(Q[114],Z([0,1,115,8]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function P(L,I){return L.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:L.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function R(L,I,u={}){const g=(0,C.parse)(L),b=u.proxyUrl||P(g,I);if(!b)return null;const O=(0,C.parse)(b);if(!/^https?:$/.test(O.protocol||""))return null;const d={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((S,p)=>{z(["http-proxy-agent"],S,p)}))(d):new(await new Promise((S,p)=>{z(["https-proxy-agent"],S,p)}))(d)}t.getProxyAgent=R}),define(Q[116],Z([0,1,17,27]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function P(R,L,I){let u=I&&I.get("storage.serviceMachineId",0)||null;if(u)return u;try{const b=(await L.readFile(R.serviceMachineIdResource)).value.toString();u=(0,D.isUUID)(b)?b:null}catch{u=null}if(!u){u=(0,D.generateUuid)();try{await L.writeFile(R.serviceMachineIdResource,C.VSBuffer.fromString(u))}catch{}}return I&&I.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=P}),define(Q[117],Z([0,1,3,6,2,101,8,65,13]),function(z,t,C,D,P,R,L,I,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";t.IStorageService=(0,u.createDecorator)("storageService");var b;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(b=t.WillSaveStateReason||(t.WillSaveStateReason={}));var O;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(O=t.StorageScope||(t.StorageScope={}));var d;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(d=t.StorageTarget||(t.StorageTarget={}));class S extends P.Disposable{constructor(h={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=h,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new C.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,C.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(h,E){E===g?(h===0?this._globalKeyTargets=void 0:h===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:h})):this._onDidChangeValue.fire({scope:h,key:E,target:this.getKeyTargets(h)[E]})}emitWillSaveState(h){this._onWillSaveState.fire({reason:h})}get(h,E,a){return this.getStorage(E)?.get(h,a)}getBoolean(h,E,a){return this.getStorage(E)?.getBoolean(h,a)}getNumber(h,E,a){return this.getStorage(E)?.getNumber(h,a)}store(h,E,a,v){if((0,L.isUndefinedOrNull)(E)){this.remove(h,a);return}this.withPausedEmitters(()=>{this.updateKeyTarget(h,a,v),this.getStorage(a)?.set(h,E)})}remove(h,E){this.withPausedEmitters(()=>{this.updateKeyTarget(h,E,void 0),this.getStorage(E)?.delete(h)})}withPausedEmitters(h){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{h()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(h,E){const a=[],v=this.getKeyTargets(h);for(const o of Object.keys(v))v[o]===E&&a.push(o);return a}updateKeyTarget(h,E,a){const v=this.getKeyTargets(E);typeof a=="number"?v[h]!==a&&(v[h]=a,this.getStorage(E)?.set(g,JSON.stringify(v))):typeof v[h]=="number"&&(delete v[h],this.getStorage(E)?.set(g,JSON.stringify(v)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(h){return h===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(h){const E=this.get(g,h);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}isNew(h){return this.getBoolean(t.IS_NEW_KEY,h)===!0}async flush(h=b.NONE){this._onWillSaveState.fire({reason:h});const E=this.getStorage(0),a=this.getStorage(1);switch(h){case b.NONE:await C.Promises.settled([E?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await C.Promises.settled([E?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve()]);break}}async logStorage(){const h=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return m(h,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class p extends S{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(h=>this.emitDidChangeValue(1,h))),this._register(this.globalStorage.onDidChangeStorage(h=>this.emitDidChangeValue(0,h)))}getStorage(h){return h===0?this.globalStorage:this.workspaceStorage}getLogDetails(h){return h===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(h){}}t.InMemoryStorageService=p;async function m(c,h,E,a){const v=l=>{try{return JSON.parse(l)}catch{return l}},o=new Map,n=new Map;c.forEach((l,f)=>{o.set(f,l),n.set(f,v(l))});const r=new Map,e=new Map;h.forEach((l,f)=>{r.set(f,l),e.set(f,v(l))}),console.group(`Storage: Global (path: ${E})`);let i=[];o.forEach((l,f)=>{i.push({key:f,value:l})}),console.table(i),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${a})`);let s=[];r.forEach((l,f)=>{s.push({key:f,value:l})}),console.table(s),console.groupEnd(),console.log(e)}t.logStorage=m}),define(Q[118],Z([0,1,12,29,9,27]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function L(g){if(C.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function I(g,b,O,d,S,p,m,c,h,E){const a=Object.create(null);a["common.machineId"]=m,a.sessionID=(0,R.generateUuid)()+Date.now(),a.commitHash=S,a.version=p,a["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,C.PlatformToString)(C.platform),a["common.nodePlatform"]=D.platform,a["common.nodeArch"]=d,a["common.product"]=E||"desktop";const v=u(c||[]);v&&(a["common.msftInternal"]=v);let o=0;const n=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),C.isLinuxSnap&&(a["common.snap"]="true");const r=L(O);r&&(a["common.platformDetail"]=r);try{const e=await g.readFile(P.URI.file(h));a["common.source"]=e.value.toString().slice(0,30)}catch{}return a}t.resolveCommonProperties=I;function u(g){const b=D.env.USERDNSDOMAIN;if(!b)return!1;const O=b.toLowerCase();return g.some(d=>O===d)}t.verifyMicrosoftInternalDomain=u}),define(Q[31],Z([0,1,13]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,C.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,C.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(D=t.TelemetryLevel||(t.TelemetryLevel={}));var P;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(P=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Q[119],Z([0,1,18,3,24,7,6,2,12,8,9,75,22,23,14,32,31]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let h=class extends I.Disposable{constructor(r,e,i,s){super();this.galleryService=r,this.telemetryService=e,this.logService=i,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,I.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(r){const e=await this.getTargetPlatform();return r.allTargetPlatforms.some(i=>(0,d.isTargetPlatformCompatible)(i,r.allTargetPlatforms,e))}async installFromGallery(r,e={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(O.localize(0,null),d.ExtensionManagementErrorCode.Internal);const i=await this.checkAndGetCompatibleVersion(r,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(i.manifest,i.extension,e)}catch(i){throw v(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(r),void 0,i),this.logService.error("Failed to install extension.",r.identifier.id),this.logService.error(i),a(i)}}async uninstall(r,e={}){return this.logService.trace("ExtensionManagementService#uninstall",r.identifier.id),this.unininstallExtension(r,e)}async reinstallFromGallery(r){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",r.identifier.id),!this.galleryService.isEnabled())throw new Error(O.localize(1,null));const e=await this.findGalleryExtension(r);if(!e)throw new Error(O.localize(2,null));await this.createUninstallExtensionTask(r,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const r=new Date().getTime();return(!this.extensionsControlManifest||r-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=r),this.extensionsControlManifest}registerParticipant(r){this.participants.push(r)}async installExtension(r,e,i){if(!b.URI.isUri(e)){let w=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(w)return this.logService.info("Extensions is already requested to install",e.identifier.id),w.waitUntilTaskIsFinished();i={...i,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],l=[],f=this.createInstallExtensionTask(r,e,i);b.URI.isUri(e)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(f.identifier,r.version).key(),f),this._onInstallExtension.fire({identifier:f.identifier,source:e}),this.logService.info("Installing extension:",f.identifier.id),s.push({task:f,manifest:r});let y=!1;try{if(i.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",f.identifier.id);else try{const T=await this.getAllDepsAndPackExtensionsToInstall(f.identifier,r,!!i.installOnlyNewlyAddedFromExtensionPack,!!i.installPreReleaseVersion);for(const{gallery:A,manifest:B}of T)if(y=y||!!B.extensionDependencies?.some(J=>(0,S.areSameExtensions)({id:J},f.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(A.identifier,A.version).key()))this.logService.info("Extension is already requested to install",A.identifier.id);else{const J=this.createInstallExtensionTask(B,A,{...i,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(J.identifier,B.version).key(),J),this._onInstallExtension.fire({identifier:J.identifier,source:A}),this.logService.info("Installing extension:",J.identifier.id),s.push({task:J,manifest:B})}}catch(T){if(b.URI.isUri(f.source))(0,C.isNonEmptyArray)(r.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",f.identifier.id,T.message),(0,C.isNonEmptyArray)(r.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",f.identifier.id,T.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",f.identifier.id),T}const w=s.reduce((T,{task:A,manifest:B})=>(T.set(A.identifier.id.toLowerCase(),{task:A,manifest:B}),T),new Map);for(;w.size;){let T;const A=[...w.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(J=>w.has(J.toLowerCase())));A.length?T=w.size===1?A:A.filter(({task:B})=>!(B===f&&!y)):(this.logService.info("Found extensions with circular dependencies",A.map(({task:B})=>B.identifier.id)),T=[...w.values()]),await this.joinAllSettled(T.map(async({task:B})=>{const J=new Date().getTime(),se=(0,g.isUndefined)(i.operation)?B.operation:i.operation;try{const ie=await B.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ie,B.source,i,P.CancellationToken.None))),!b.URI.isUri(B.source)&&(v(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(B.source),new Date().getTime()-J,void 0),u.isWeb&&se!==3))try{await this.galleryService.reportStatistic(ie.manifest.publisher,ie.manifest.name,ie.manifest.version,"install")}catch{}l.push({local:ie,identifier:B.identifier,operation:se,source:B.source})}catch(ie){throw b.URI.isUri(B.source)||v(this.telemetryService,se===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(B.source),new Date().getTime()-J,ie),this.logService.error("Error while installing the extension:",B.identifier.id),ie}finally{w.delete(B.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:T})=>this.logService.info("Extension installed successfully:",T.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:T})=>(0,S.areSameExtensions)(T,f.identifier))[0].local}catch(w){if(s.forEach(({task:T})=>T.cancel()),l.length)try{const T=await Promise.allSettled(l.map(({local:A})=>this.createUninstallExtensionTask(A,{versionOnly:!0}).run()));for(let A=0;A<T.length;A++){const B=T[A],{identifier:J}=l[A];B.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",J.id):this.logService.warn("Rollback: Error while uninstalling extension",J.id,(0,R.getErrorMessage)(B.reason))}}catch(T){this.logService.warn("Error while rolling back extensions",(0,R.getErrorMessage)(T),l.map(({identifier:A})=>A.id))}throw this._onDidInstallExtensions.fire(s.map(({task:T})=>({identifier:T.identifier,operation:2,source:T.source}))),w}finally{for(const{task:w,manifest:T}of s)if(!b.URI.isUri(w.source)){const A=new S.ExtensionIdentifierWithVersion(w.identifier,T.version).key();this.installingExtensions.delete(A)||this.logService.warn("Installation task is not found in the cache",A)}}}async joinAllSettled(r){const e=[],i=[],s=await Promise.allSettled(r);for(const l of s)l.status==="fulfilled"?e.push(l.value):i.push(l.reason);if(i.length)throw E(i);return e}async getAllDepsAndPackExtensionsToInstall(r,e,i,s){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled();const f=[r,...l.map(T=>T.identifier)],y=[],w=async(T,A)=>{const B=A.extensionDependencies||[],J=[...B];if(A.extensionPack){const se=i?l.find(ie=>(0,S.areSameExtensions)(ie.identifier,T)):void 0;for(const ie of A.extensionPack)se&&se.manifest.extensionPack&&se.manifest.extensionPack.some(te=>(0,S.areSameExtensions)({id:te},{id:ie}))||J.every(te=>!(0,S.areSameExtensions)({id:te},{id:ie}))&&J.push(ie)}if(J.length){const se=[...f,...y.map(te=>te.gallery.identifier)],ie=J.filter(te=>se.every(ge=>!(0,S.areSameExtensions)(ge,{id:te})));if(ie.length){const te=await this.galleryService.query({names:ie,pageSize:J.length},P.CancellationToken.None);for(const ge of te.firstPage){if(se.find(re=>(0,S.areSameExtensions)(re,ge.identifier)))continue;const $=B.some(re=>(0,S.areSameExtensions)({id:re},ge.identifier));let q;try{q=await this.checkAndGetCompatibleVersion(ge,!0,s)}catch(re){if(re instanceof d.ExtensionManagementError&&re.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!$){this.logService.info("Skipping the packed extension as it cannot be installed",ge.identifier.id);continue}else throw re}y.push({gallery:q.extension,manifest:q.manifest}),await w(q.extension.identifier,A)}}}};return await w(r,e),l=await this.getInstalled(),y.filter(T=>!l.some(A=>(0,S.areSameExtensions)(A.identifier,T.gallery.identifier)))}async checkAndGetCompatibleVersion(r,e,i){const s=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(s).has(r.identifier.id))throw new d.ExtensionManagementError(O.localize(3,null,r.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[r.identifier.id])throw new d.ExtensionManagementError(O.localize(4,null,r.identifier.id,s.unsupportedPreReleaseExtensions[r.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(r)){const y=await this.getTargetPlatform();throw new d.ExtensionManagementError(O.localize(5,null,r.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(y)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const l=await this.getCompatibleVersion(r,e,i);if(l){if(i&&r.hasPreReleaseVersion&&!l.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(O.localize(6,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!i&&r.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([r.identifier],P.CancellationToken.None))[0]?new d.ExtensionManagementError(O.localize(7,null,r.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.ExtensionManagementError(O.localize(8,null,r.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",l.identifier.id);const f=await this.galleryService.getManifest(l,P.CancellationToken.None);if(f===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${r.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(f.version!==l.version)throw new d.ExtensionManagementError(`Cannot install '${r.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:l,manifest:f}}async getCompatibleVersion(r,e,i){const s=await this.getTargetPlatform();let l=null;return e&&r.hasPreReleaseVersion&&r.properties.isPreReleaseVersion!==i&&(l=(await this.galleryService.getExtensions([{...r.identifier,preRelease:i}],{targetPlatform:s,compatible:!0},P.CancellationToken.None))[0]||null),!l&&await this.galleryService.isExtensionCompatible(r,i,s)&&(l=r),!l&&e&&(l=await this.galleryService.getCompatibleExtension(r,i,s)),l}async unininstallExtension(r,e){const i=this.uninstallingExtensions.get(r.identifier.id.toLowerCase());if(i)return this.logService.info("Extensions is already requested to uninstall",r.identifier.id),i.waitUntilTaskIsFinished();const s=(w,T)=>{const A=this.createUninstallExtensionTask(w,T);return this.uninstallingExtensions.set(A.extension.identifier.id.toLowerCase(),A),this.logService.info("Uninstalling extension:",w.identifier.id),this._onUninstallExtension.fire(w.identifier),A},l=(w,T)=>{T?this.logService.error("Failed to uninstall extension:",w.identifier.id,T.message):this.logService.info("Successfully uninstalled extension:",w.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(w),void 0,T),this._onDidUninstallExtension.fire({identifier:w.identifier,error:T?.code})},f=[],y=[];try{f.push(s(r,{}));const w=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",r.identifier.id);else{const T=this.getAllPackExtensionsToUninstall(r,w);for(const A of T)this.uninstallingExtensions.has(A.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",A.identifier.id):f.push(s(A,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",r.identifier.id):this.checkForDependents(f.map(T=>T.extension),w,r),await this.joinAllSettled(f.map(async T=>{try{if(await T.run(),await this.joinAllSettled(this.participants.map(A=>A.postUninstall(T.extension,e,P.CancellationToken.None))),T.extension.identifier.uuid)try{await this.galleryService.reportStatistic(T.extension.manifest.publisher,T.extension.manifest.name,T.extension.manifest.version,"uninstall")}catch{}l(T.extension)}catch(A){const B=A instanceof d.ExtensionManagementError?A:new d.ExtensionManagementError((0,R.getErrorMessage)(A),d.ExtensionManagementErrorCode.Internal);throw l(T.extension,B),B}finally{y.push(T)}}))}catch(w){const T=w instanceof d.ExtensionManagementError?w:new d.ExtensionManagementError((0,R.getErrorMessage)(w),d.ExtensionManagementErrorCode.Internal);for(const A of f){try{A.cancel()}catch{}y.includes(A)||l(A.extension,T)}throw T}finally{for(const w of f)this.uninstallingExtensions.delete(w.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",w.extension.identifier.id)}}checkForDependents(r,e,i){for(const s of r){const l=this.getDependents(s,e);if(l.length){const f=l.filter(y=>!r.some(w=>(0,S.areSameExtensions)(w.identifier,y.identifier)));if(f.length)throw new Error(this.getDependentsErrorMessage(s,f,i))}}}getDependentsErrorMessage(r,e,i){return i===r?e.length===1?O.localize(9,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(10,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(11,null,i.manifest.displayName||i.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?O.localize(12,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(13,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(14,null,i.manifest.displayName||i.manifest.name,r.manifest.displayName||r.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(r,e,i=[]){if(i.indexOf(r)!==-1)return[];i.push(r);const s=r.manifest.extensionPack?r.manifest.extensionPack:[];if(s.length){const l=e.filter(y=>!y.isBuiltin&&s.some(w=>(0,S.areSameExtensions)({id:w},y.identifier))),f=[];for(const y of l)f.push(...this.getAllPackExtensionsToUninstall(y,e,i));return[...l,...f]}return[]}getDependents(r,e){return e.filter(i=>i.manifest.extensionDependencies&&i.manifest.extensionDependencies.some(s=>(0,S.areSameExtensions)({id:s},r.identifier)))}async findGalleryExtension(r){if(r.identifier.uuid){const e=await this.findGalleryExtensionById(r.identifier.uuid);return e||this.findGalleryExtensionByName(r.identifier.id)}return this.findGalleryExtensionByName(r.identifier.id)}async findGalleryExtensionById(r){return(await this.galleryService.query({ids:[r],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(r){return(await this.galleryService.query({names:[r],pageSize:1},P.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const r=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",r),r}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};h=pe([oe(0,d.IExtensionGalleryService),oe(1,c.ITelemetryService),oe(2,p.ILogService),oe(3,m.IProductService)],h),t.AbstractExtensionManagementService=h;function E(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((e,i)=>new Error(`${e.message}${e.message?",":""}${i instanceof Error?i.message:i}`),new Error(""))}t.joinErrors=E;function a(n){if(n instanceof d.ExtensionManagementError)return n;const r=new d.ExtensionManagementError(n.message,d.ExtensionManagementErrorCode.Internal);return r.stack=n.stack,r}function v(n,r,e,i,s){const l=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(r,{...e,success:!s,duration:i,errorcode:l})}t.reportTelemetry=v;class o{constructor(){this.barrier=new D.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>this.doRun(r))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,D.createCancelablePromise)(r=>new Promise((e,i)=>{const s=r.onCancellationRequested(()=>{s.dispose(),i((0,R.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=o}),define(Q[35],Z([0,1,21,8,25,31]),function(z,t,C,D,P,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class L{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(h,E){return Promise.resolve(void 0)}publicLog2(h,E){return this.publicLog(h,E)}publicLogError(h,E){return Promise.resolve(void 0)}publicLogError2(h,E){return this.publicLogError(h,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=L,t.NullTelemetryService=new L;class I{async publicLog(h,E,a){}async publicLogError(h,E,a){}}t.NullEndpointTelemetryService=I,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(c,h){return h.onDidChangeConfiguration(E=>{E.source!==6&&c.publicLog2("updateConfiguration",{configurationSource:(0,P.ConfigurationTargetToString)(E.source),configurationKeys:p(E.sourceConfig)})})}t.configurationTelemetry=u;function g(c,h){return!(h.disableTelemetry||!c.enableTelemetry||h.extensionTestsLocationURI)}t.supportsTelemetry=g;function b(c){const h=c.getValue(R.TELEMETRY_SETTING_ID),E=c.getValue("telemetry.enableCrashReporter");if(c.getValue(R.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=b;function O(c){const h=Object.create(null),E=Object.create(null),a=Object.create(null);S(c,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const o=a[v];typeof o=="number"?E[v]=o:typeof o=="boolean"?E[v]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${o.length}`),h[v]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(h[v]=o)}return{properties:h,measurements:E}}t.validateTelemetryData=O;function d(c){if(!c)return"none";let h="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(a=>{c.indexOf(`${a}+`)===0&&(h=a)}),h}t.cleanRemoteAuthority=d;function S(c,h,E=0,a){if(!!c)for(let v of Object.getOwnPropertyNames(c)){const o=c[v],n=a?a+v:v;Array.isArray(o)?h[n]=(0,C.safeStringify)(o):o instanceof Date?h[n]=o.toISOString():(0,D.isObject)(o)?E<2?S(o,h,E+1,n+"."):h[n]=(0,C.safeStringify)(o):h[n]=o}}function p(c){if(!c)return[];const h=[];return m(h,"",c),h}function m(c,h,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(a=>m(c,h?`${h}.${a}`:a,E[a])):c.push(h)}}),define(Q[120],Z([0,1,18,24,7,21,12,29,8,9,25,20,22,23,48,16,14,32,42,116,117,31,35]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c,h,E,a,v,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const r=L.isWeb?"web":(0,d.getTargetPlatform)(L.platform,I.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished",U[U.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(e||(e={}));function i(...U){return String(U.reduce((k,x)=>k|x,0))}var s;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class T{constructor(k=w){this.state=k}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(k,x=this.state.pageSize){return new T({...this.state,pageNumber:k,pageSize:x})}withFilter(k,...x){const j=[...this.state.criteria,...x.length?x.map(Y=>({filterType:k,value:Y})):[{filterType:k}]];return new T({...this.state,criteria:j})}withSortBy(k){return new T({...this.state,sortBy:k})}withSortOrder(k){return new T({...this.state,sortOrder:k})}withFlags(...k){return new T({...this.state,flags:k.reduce((x,j)=>x|j,0)})}withAssetTypes(...k){return new T({...this.state,assetTypes:k})}get raw(){const{criteria:k,pageNumber:x,pageSize:j,sortBy:Y,sortOrder:X,flags:fe,assetTypes:le}=this.state;return{filters:[{criteria:k,pageNumber:x,pageSize:j,sortBy:Y,sortOrder:X}],assetTypes:le,flags:fe}}get searchText(){const k=this.state.criteria.filter(x=>x.filterType===s.SearchText)[0];return k&&k.value?k.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(k=>String(k.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A(U,k){const x=(U||[]).filter(j=>j.statisticName===k)[0];return x?x.value:0}function B(U){const k="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(j=>j.assetType.indexOf(k)===0).reduce((j,Y)=>{const X=te(U,Y.assetType);return X&&j.push([Y.assetType.substring(k.length),X]),j},[])}function J(U){if(U.properties){const k=U.properties.filter(Y=>Y.key===l.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=k.filter(Y=>x.test(Y.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return te(U,l.Repository)}function se(U){return{uri:`${U.fallbackAssetUri}/${l.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${l.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ie(U){const k=te(U,l.Icon);if(k)return k;const x=d.DefaultIconPath;return{uri:x,fallbackUri:x}}function te(U,k){return U.files.filter(j=>j.assetType===k)[0]?{uri:`${U.assetUri}/${k}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${k}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function ge(U,k){const x=U.properties?U.properties.filter(Y=>Y.key===k):[],j=x.length>0&&x[0].value;return j?j.split(",").map(Y=>(0,S.adoptToGalleryExtensionId)(Y)):[]}function $(U){const k=U.properties?U.properties.filter(x=>x.key===f.Engine):[];return k.length>0&&k[0].value||""}function q(U){const k=U.properties?U.properties.filter(x=>x.key===f.PreRelease):[];return k.length>0&&k[0].value==="true"}function re(U){const k=U.properties?U.properties.filter(j=>j.key===f.LocalizedLanguages):[],x=k.length>0&&k[0].value||"";return x?x.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function F(U){return U.targetPlatform?(0,d.toTargetPlatform)(U.targetPlatform):"undefined"}function W(U){const k=(0,C.distinct)(U.versions.map(F)),x=!!U.tags?.includes(d.WEB_EXTENSION_TAG),j=k.indexOf("web");return x?j===-1&&k.push("web"):j!==-1&&k.splice(j,1),k}function H(U,k){const x=(0,d.getFallbackTargetPlarforms)(k);for(let j=0;j<U.length;j++){const Y=U[j];if(Y.version===U[j-1]?.version){let X=j;const fe=F(Y);if(fe===k)for(;X>0&&U[X-1].version===Y.version;)X--;else if(x.includes(fe))for(;X>0&&U[X-1].version===Y.version&&F(U[X-1])!==k;)X--;X!==j&&(U.splice(j,1),U.splice(X,0,Y))}}return U}t.sortExtensionVersions=H;function ne(U,k,x){const j=U.versions[0],Y={manifest:te(k,l.Manifest),readme:te(k,l.Details),changelog:te(k,l.Changelog),license:te(k,l.License),repository:J(k),download:se(k),icon:ie(k),coreTranslations:B(k)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:k.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:A(U.statistics,"install"),rating:A(U.statistics,"averagerating"),ratingCount:A(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:x,assets:Y,properties:{dependencies:ge(k,f.Dependency),extensionPack:ge(k,f.ExtensionPack),engine:$(k),localizedLanguages:re(k),targetPlatform:F(k),isPreReleaseVersion:q(k)},hasPreReleaseVersion:q(j),hasReleaseVersion:!0,preview:M(U.flags)}}let K=class{constructor(k,x,j,Y,X,fe,le,Ee){this.requestService=x,this.logService=j,this.environmentService=Y,this.telemetryService=X,this.fileService=fe,this.productService=le,this.configurationService=Ee;const de=le.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=ae(le.version,le,this.environmentService,this.configurationService,this.fileService,k)}api(k=""){return`${this.extensionsGalleryUrl}${k}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(k,x,j){const Y=D.CancellationToken.isCancellationToken(x)?{targetPlatform:r}:x,X=D.CancellationToken.isCancellationToken(x)?x:j,fe=[],le=[],Ee=[],de=[];for(const me of k)me.uuid?le.push(me.uuid):fe.push(me.id),Ee.push({...me,preRelease:!!me.preRelease}),me.version&&de.push({...me,version:me.version});if(!le.length&&!fe.length)return[];let ue=new T().withPage(1,k.length);le.length&&(ue=ue.withFilter(s.ExtensionId,...le)),fe.length&&(ue=ue.withFilter(s.ExtensionName,...fe));const{extensions:he}=await this.queryGalleryExtensions(ue,{targetPlatform:Y.targetPlatform,preRelease:Ee,versions:de,compatible:!!Y.compatible},X);return he}async getCompatibleExtension(k,x,j){if((0,d.isNotWebExtensionInWebTargetPlatform)(k.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(k,x,j))return k;const Y=new T().withFlags(e.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,k.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(Y,{targetPlatform:j,compatible:!0,preRelease:x},D.CancellationToken.None);return X[0]||null}async isExtensionCompatible(k,x,j){if(!(0,d.isTargetPlatformCompatible)(k.properties.targetPlatform,k.allTargetPlatforms,j)||!x&&k.properties.isPreReleaseVersion)return!1;let Y=k.properties.engine;if(!Y){const X=await this.getManifest(k,D.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Y=X.engines.vscode}return(0,p.isEngineValid)(Y,this.productService.version,this.productService.date)}async isValidVersion(k,x,j,Y,X){if(!(0,d.isTargetPlatformCompatible)(F(k),Y,X)||!x&&q(k))return!1;if(j){const fe=await this.getEngine(k);if(!(0,p.isEngineValid)(fe,this.productService.version,this.productService.date))return!1}return!0}async query(k,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=k.text||"";const Y=(0,R.getOrDefault)(k,ue=>ue.pageSize,50);let X=new T().withPage(1,Y);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,he,me)=>(X=X.withFilter(s.Category,me||he),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,he,me)=>(X=X.withFilter(s.Tag,me||he),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(s.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),X=X.withFilter(s.SearchText,j)),X=X.withSortBy(0)):k.ids?X=X.withFilter(s.ExtensionId,...k.ids):k.names?X=X.withFilter(s.ExtensionName,...k.names):X=X.withSortBy(4),typeof k.sortBy=="number"&&(X=X.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(X=X.withSortOrder(k.sortOrder));const fe=async(ue,he)=>{const{extensions:me,total:Fe}=await this.queryGalleryExtensions(ue,{targetPlatform:r,compatible:!1,preRelease:!!k.includePreRelease},he);return me.forEach((Ce,Ue)=>Ce.telemetryData={index:(ue.pageNumber-1)*ue.pageSize+Ue,querySource:k.source}),{extensions:me,total:Fe}},{extensions:le,total:Ee}=await fe(X,x),de=async(ue,he)=>{if(he.isCancellationRequested)throw new P.CancellationError;const{extensions:me}=await fe(X.withPage(ue+1),he);return me};return{firstPage:le,total:Ee,pageSize:X.pageSize,getPage:de}}async queryGalleryExtensions(k,x,j){const Y=k.flags;!!(k.flags&e.IncludeLatestVersionOnly)&&!!(k.flags&e.IncludeVersions)&&(k=k.withFlags(k.flags&~e.IncludeVersions,e.IncludeLatestVersionOnly)),!(k.flags&e.IncludeLatestVersionOnly)&&!(k.flags&e.IncludeVersions)&&(k=k.withFlags(k.flags,e.IncludeLatestVersionOnly)),x.versions?.length&&(k=k.withFlags(k.flags&~e.IncludeLatestVersionOnly,e.IncludeVersions)),k=k.withFlags(k.flags,e.IncludeAssetUri,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeStatistics,e.IncludeVersionProperties);const{galleryExtensions:X,total:fe}=await this.queryRawGalleryExtensions(k,j);if(!(k.flags&e.IncludeLatestVersionOnly)){const ue=[];for(const he of X){const me=await this.toGalleryExtensionWithCriteria(he,x,!0);me&&ue.push(me)}return{extensions:ue,total:fe}}const Ee=[],de=new Map;for(let ue=0;ue<X.length;ue++){const he=X[ue],me={id:(0,S.getGalleryExtensionId)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},Fe=(0,u.isBoolean)(x.preRelease)?x.preRelease:!!x.preRelease.find(Ue=>(0,S.areSameExtensions)(Ue,me))?.preRelease;let Ce=await this.toGalleryExtensionWithCriteria(he,x,!1);!Ce||Ce.properties.isPreReleaseVersion&&(!Fe||!Ce.hasReleaseVersion)||!Ce.properties.isPreReleaseVersion&&Ce.properties.targetPlatform!==x.targetPlatform&&Ce.hasPreReleaseVersion?de.set(he.extensionId,ue):Ee.push([ue,Ce])}if(de.size){const ue=new Date().getTime(),he=new T().withFlags(Y&~e.IncludeLatestVersionOnly,e.IncludeVersions).withPage(1,de.size).withFilter(s.ExtensionId,...de.keys()),{extensions:me}=await this.queryGalleryExtensions(he,x,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ue,count:de.size});for(const Fe of me){const Ce=de.get(Fe.identifier.uuid);Ee.push([Ce,Fe])}}return{extensions:Ee.sort((ue,he)=>ue[0]-he[0]).map(([,ue])=>ue),total:fe}}async toGalleryExtensionWithCriteria(k,x,j){const Y={id:(0,S.getGalleryExtensionId)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},X=x.versions?.find(de=>(0,S.areSameExtensions)(de,Y))?.version,fe=(0,u.isBoolean)(x.preRelease)?x.preRelease:!!x.preRelease.find(de=>(0,S.areSameExtensions)(de,Y))?.preRelease,le=W(k),Ee=H(k.versions,x.targetPlatform);if(x.compatible&&j&&(0,d.isNotWebExtensionInWebTargetPlatform)(le,x.targetPlatform))return null;for(let de=0;de<Ee.length;de++){const ue=Ee[de];if(!(X&&ue.version!==X)){if(await this.isValidVersion(ue,fe,x.compatible,le,x.targetPlatform))return ne(k,ue,le);if(X&&ue.version===X)return null}}return X||x.compatible?null:ne(k,k.versions[0],le)}async queryRawGalleryExtensions(k,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");k=k.withFlags(k.flags,e.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(e.Unpublished));const j=await this.commonHeadersPromise,Y=JSON.stringify(k.raw),X={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},fe=new Date().getTime();let le,Ee,de=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:X},x),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:de};const ue=await(0,E.asJson)(le);if(ue){const he=ue.results[0],me=he.extensions,Fe=he.resultMetadata&&he.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return de=Fe&&Fe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:me,total:de}}return{galleryExtensions:[],total:de}}catch(ue){throw Ee=ue,ue}finally{this.telemetryService.publicLog2("galleryService:query",{...k.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-fe,success:!!le&&(0,E.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:Ee?(0,P.isCancellationError)(Ee)?"canceled":(0,P.getErrorMessage)(Ee).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic(k,x,j,Y){if(!this.isEnabled())return;const X=L.isWeb?this.api(`/itemName/${k}.${x}/version/${j}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${k}/extensions/${x}/${j}/stats?statType=${Y}`),fe=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",Ee={...await this.commonHeadersPromise,Accept:fe};try{await this.requestService.request({type:"POST",url:X,headers:Ee},D.CancellationToken.None)}catch{}}async download(k,x,j){this.logService.trace("ExtensionGalleryService#download",k.identifier.id);const Y=(0,S.getGalleryExtensionTelemetryData)(k),X=new Date().getTime(),fe=ue=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Y,duration:ue}),le=j===2?"install":j===3?"update":"",Ee=le?{uri:`${k.assets.download.uri}${g.URI.parse(k.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${k.assets.download.fallbackUri}${g.URI.parse(k.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:k.assets.download,de=await this.getAsset(Ee);await this.fileService.writeFile(x,de.stream),fe(new Date().getTime()-X)}async getReadme(k,x){if(k.assets.readme){const j=await this.getAsset(k.assets.readme,{},x);return await(0,E.asText)(j)||""}return""}async getManifest(k,x){if(k.assets.manifest){const j=await this.getAsset(k.assets.manifest,{},x),Y=await(0,E.asText)(j);return Y?JSON.parse(Y):null}return null}async getManifestFromRawExtensionVersion(k,x){const j=te(k,l.Manifest);if(!j)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},X=await this.getAsset(j,{headers:Y});return await(0,E.asJson)(X)}async getCoreTranslation(k,x){const j=k.assets.coreTranslations.filter(Y=>Y[0]===x.toUpperCase())[0];if(j){const Y=await this.getAsset(j[1]),X=await(0,E.asText)(Y);return X?JSON.parse(X):null}return null}async getChangelog(k,x){if(k.assets.changelog){const j=await this.getAsset(k.assets.changelog,{},x);return await(0,E.asText)(j)||""}return""}async getAllCompatibleVersions(k,x,j){let Y=new T().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1);k.identifier.uuid?Y=Y.withFilter(s.ExtensionId,k.identifier.uuid):Y=Y.withFilter(s.ExtensionName,k.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(Y,D.CancellationToken.None);if(!X.length)return[];const fe=W(X[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(fe,j))return[];const le=[];for(const Ee of X[0].versions)try{le[le.length-1]?.version!==Ee.version&&await this.isValidVersion(Ee,x,!0,fe,j)&&le.push({version:Ee.version,date:Ee.lastUpdated,isPreReleaseVersion:q(Ee)})}catch{}return le}async getAsset(k,x={},j=D.CancellationToken.None){const Y=await this.commonHeadersPromise,X={type:"GET"},fe={...Y,...x.headers||{}};x={...x,...X,headers:fe};const le=k.uri,Ee=k.fallbackUri,de={...x,url:le};try{const ue=await this.requestService.request(de,j);if(ue.res.statusCode===200)return ue;const he=await(0,E.asText)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${he}`)}catch(ue){if((0,P.isCancellationError)(ue))throw ue;const he=(0,P.getErrorMessage)(ue);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:he});const me={...x,url:Ee};return this.requestService.request(me,j)}}async getEngine(k){let x=$(k);if(!x){const j=await this.getManifestFromRawExtensionVersion(k,D.CancellationToken.None);if(!j)throw new Error("Manifest was not found");x=j.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const k=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(k.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,E.asJson)(k),j=[],Y={};if(x){for(const X of x.malicious)j.push({id:X});if(x.unsupported)for(const X of Object.keys(x.unsupported)){const fe=x.unsupported[X];(0,u.isBoolean)(fe)||(Y[X.toLowerCase()]=fe.preReleaseExtension)}if(x.migrateToPreRelease)for(const[X,fe]of Object.entries(x.migrateToPreRelease))(!fe.engine||(0,p.isEngineValid)(fe.engine,this.productService.version,this.productService.date))&&(Y[X.toLowerCase()]=fe)}return{malicious:j,unsupportedPreReleaseExtensions:Y}}};K=pe([oe(1,E.IRequestService),oe(2,c.ILogService),oe(3,O.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,m.IFileService),oe(6,h.IProductService),oe(7,b.IConfigurationService)],K);let ee=class extends K{constructor(k,x,j,Y,X,fe,le,Ee){super(k,x,j,Y,X,fe,le,Ee)}};ee=pe([oe(0,v.IStorageService),oe(1,E.IRequestService),oe(2,c.ILogService),oe(3,O.IEnvironmentService),oe(4,o.ITelemetryService),oe(5,m.IFileService),oe(6,h.IProductService),oe(7,b.IConfigurationService)],ee),t.ExtensionGalleryService=ee;let G=class extends K{constructor(k,x,j,Y,X,fe,le){super(void 0,k,x,j,Y,X,fe,le)}};G=pe([oe(0,E.IRequestService),oe(1,c.ILogService),oe(2,O.IEnvironmentService),oe(3,o.ITelemetryService),oe(4,m.IFileService),oe(5,h.IProductService),oe(6,b.IConfigurationService)],G),t.ExtensionGalleryServiceWithNoStorageService=G;async function ae(U,k,x,j,Y,X){const fe={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${k.nameShort})`},le=await(0,a.getServiceMachineId)(x,Y,X);return(0,n.supportsTelemetry)(k,x)&&(0,n.getTelemetryLevel)(j)===3&&(fe["X-Market-User-Id"]=le),fe}t.resolveMarketplaceHeaders=ae}),define(Q[121],Z([0,1,2,21,12,26,86,25,34,122,30,31,35]),function(z,t,C,D,P,R,L,I,u,g,b,O,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let S=class{constructor(c,h){this._configurationService=h,this._experimentProperties={},this._disposables=new C.DisposableStore,this._cleanupPatterns=[],this._appenders=c.appenders,this._commonProperties=c.commonProperties||Promise.resolve({}),this._piiPaths=c.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!c.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,R.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(E=>{const a=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!a})})}setExperimentProperty(c,h){this._experimentProperties[c]=h}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const c=await this._commonProperties;let h=c.sessionID,E=c["common.machineId"],a=c["common.firstSessionDate"],v=c["common.msftInternal"];return{sessionId:h,machineId:E,firstSessionDate:a,msftInternal:v}}dispose(){this._disposables.dispose()}_log(c,h,E,a){return this.telemetryLevel<h?Promise.resolve(void 0):this._commonProperties.then(v=>{E=(0,D.mixin)(E,v),E=(0,D.mixin)(E,this._experimentProperties),E=(0,D.cloneAndChange)(E,o=>{if(typeof o=="string")return this._cleanupInfo(o,a)}),this._appenders.forEach(o=>o.log(c,E))},v=>{console.error(v)})}publicLog(c,h,E){return this._log(c,3,h,E)}publicLog2(c,h,E){return this.publicLog(c,h,E)}publicLogError(c,h){return this.sendErrorTelemetry?this._log(c,2,h,!0):Promise.resolve(void 0)}publicLogError2(c,h){return this.publicLogError(c,h)}_anonymizeFilePaths(c){let h=c;const E=[];for(let n of this._cleanupPatterns)for(;;){const r=n.exec(c);if(!r)break;E.push([r.index,n.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let o=0;for(h="";;){const n=v.exec(c);if(!n)break;!a.test(n[0])&&E.every(([r,e])=>n.index<r||n.index>=e)&&(h+=c.substring(o,n.index)+"<REDACTED: user-file-path>",o=v.lastIndex)}return o<c.length&&(h+=c.substr(o)),h}_removePropertiesWithPossibleUserInfo(c){if(!c)return c;const h=c.toLowerCase(),E=/@[a-zA-Z0-9-.]+/,a=/(key|token|sig|signature|password|passwd|pwd)[="':\s]/,v=/xox[pbaors]\-[a-zA-Z0-9]+\-[a-zA-Z0-9\-]+?/;return a.test(h)?"<REDACTED: secret>":E.test(h)?"<REDACTED: email>":v.test(h)?"<REDACTED: token>":c}_cleanupInfo(c,h){let E=c;h&&(E=this._anonymizeFilePaths(E));for(let a of this._cleanupPatterns)E=E.replace(a,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=pe([oe(1,I.IConfigurationService)],S),t.TelemetryService=S;function p(){const m=(0,L.localize)(0,null,g.default.nameLong),c=g.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=P.isWeb?"":(0,L.localize)(3,null),E=(0,L.localize)(4,null),a=(0,L.localize)(5,null),v=(0,L.localize)(6,null),o=(0,L.localize)(7,null),n=`
|       | ${E} | ${a} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,L.localize)(8,null);return`
${m} ${c} ${h}

&nbsp;

${o}
${n}

&nbsp;

${r}
`}b.Registry.as(u.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(9,null),properties:{[O.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(u.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[O.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,L.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,L.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${O.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[123],Z([0,1,7,21,35]),function(z,t,C,D,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function R(I,u){const g=await new Promise((O,d)=>{z(["applicationinsights"],O,d)});let b;return g.defaultClient?(b=new g.TelemetryClient(I),b.channel.setUseDiskRetryCaching(!0)):(g.setup(I).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=g.defaultClient),I.indexOf("AIF-")===0&&(b.config.endpointUrl=u?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),b}class L{constructor(u,g,b,O,d){this._eventPrefix=u,this._defaultData=g,this.testCollector=O,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof b=="function"?this._aiClient=b():this._aiClient=b,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(g=>{u(g)},g=>{(0,C.onUnexpectedError)(g),console.error(g)})}}log(u,g){!this._aiClient||(g=(0,D.mixin)(g,this._defaultData),g=(0,P.validateTelemetryData)(g),this.testCollector&&(g.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(b=>b.trackEvent({name:this._eventPrefix+"/"+u,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=L}),define(Q[124],Z([0,1,11,15]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function P(R,L){const I=Object.create(null),u=(b,O)=>{const d=JSON.parse(b);I[O]=d};if(L){const b=[],O=await D.Promises.readdir(L);for(const S of O)try{(await D.Promises.stat((0,C.join)(L,S))).isDirectory()&&b.push(S)}catch{}const d=[];for(const S of b)(await D.Promises.readdir((0,C.join)(L,S))).filter(m=>m==="telemetry.json").length===1&&d.push(S);for(const S of d){const p=(await D.Promises.readFile((0,C.join)(L,S,"telemetry.json"))).toString();u(p,S)}}let g=(await D.Promises.readFile((0,C.join)(R,"telemetry-core.json"))).toString();return u(g,"vscode-core"),g=(await D.Promises.readFile((0,C.join)(R,"telemetry-extensions.json"))).toString(),u(g,"vscode-extensions"),JSON.stringify(I,null,4)}t.buildTelemetryMessage=P}),define(Q[36],Z([0,1,13]),function(z,t,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,C.createDecorator)("IUriIdentityService")}),define(Q[125],Z([0,1,6,2,9,20,23,16,14,36]),function(z,t,C,D,P,R,L,I,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let b=class extends D.Disposable{constructor(d,S,p,m,c){super();this.extensionsManagementService=d,this.logService=m,this.uriIdentityService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new C.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(a=>a.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(E=>this.onInstallExtension(E))),this._register(d.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(d.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const h=P.URI.file(p.extensionsPath);this._register(S.watch(h)),this._register(C.Event.filter(S.onDidFilesChange,E=>E.rawChanges.some(a=>this.doesChangeAffects(a,h)))(()=>this.onDidChange()))}doesChangeAffects(d,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),S)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const S of d)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(S=>!(0,L.areSameExtensions)(S,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,L.areSameExtensions)(S,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),S=d.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(c=>(0,L.areSameExtensions)(c,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),p=this.installedExtensions.filter(m=>this.installingExtensions.some(c=>(0,L.areSameExtensions)(c,m))?!1:d.every(c=>!(0,L.areSameExtensions)(c.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=d.map(m=>m.identifier),(S.length||p.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:p})}}};b=pe([oe(1,I.IFileService),oe(2,R.INativeEnvironmentService),oe(3,u.ILogService),oe(4,g.IUriIdentityService)],b),t.ExtensionsWatcher=b}),define(Q[126],Z([0,1,36,91,16,19,58,6,2]),function(z,t,C,D,P,R,L,I,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class g{constructor(d){this.uri=d,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let b=class{constructor(d){this._fileService=d,this._dispooables=new u.DisposableStore,this._limit=2**16;const S=new Map,p=m=>{let c=S.get(m.scheme);return c===void 0&&(c=d.hasProvider(m)&&!this._fileService.hasCapability(m,1024),S.set(m.scheme,c)),c};this._dispooables.add(I.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(m=>{S.delete(m.scheme)})),this.extUri=new R.ExtUri(p),this._canonicalUris=new L.SkipList((m,c)=>this.extUri.compare(m,c,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,R.normalizePath)(d));let S=this._canonicalUris.get(d);return S?S.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new g(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((p,m)=>p[1].touch<m[1].touch?1:p[1].touch>m[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let p=0;p<S;p++)this._canonicalUris.set(d[p][0],d[p][1].touch())}};b=pe([oe(0,P.IFileService)],b),t.UriIdentityService=b,(0,D.registerSingleton)(C.IUriIdentityService,b,!0)}),define(Q[43],Z([0,1,103,3,11,8,15,72,138,139]),function(z,t,C,D,P,R,L,I,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class b extends Error{constructor(n,r){let e=r.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=r}}t.ExtractError=b;function O(o){const n=o.externalFileAttributes>>16||33188;return[448,56,7].map(r=>n&r).reduce((r,e)=>r+e,n&61440)}function d(o){if(o instanceof b)return o;let n;return/end of central directory record signature not found/.test(o.message)&&(n="CorruptZip"),new b(n,o)}function S(o,n,r,e,i,s){const l=P.dirname(n),f=P.join(e,l);if(!f.startsWith(e))return Promise.reject(new Error(I.localize(0,null,n)));const y=P.join(e,n);let w;return s.onCancellationRequested(()=>{w&&w.destroy()}),Promise.resolve(L.Promises.mkdir(f,{recursive:!0})).then(()=>new Promise((T,A)=>{if(!s.isCancellationRequested)try{w=(0,C.createWriteStream)(y,{mode:r}),w.once("close",()=>T()),w.once("error",A),o.once("error",A),o.pipe(w)}catch(B){A(B)}}))}function p(o,n,r,e){let i=(0,D.createCancelablePromise)(()=>Promise.resolve()),s=0;return e.onCancellationRequested(()=>{i.cancel(),o.close()}),new Promise((l,f)=>{const y=new D.Sequencer,w=T=>{T.isCancellationRequested||(s++,o.readEntry())};o.once("error",f),o.once("close",()=>i.then(()=>{e.isCancellationRequested||o.entryCount===s?l():f(new b("Incomplete",new Error(I.localize(1,null,s,o.entryCount))))},f)),o.readEntry(),o.on("entry",T=>{if(e.isCancellationRequested)return;if(!r.sourcePathRegex.test(T.fileName)){w(e);return}const A=T.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(A)){const se=P.join(n,A);i=(0,D.createCancelablePromise)(ie=>L.Promises.mkdir(se,{recursive:!0}).then(()=>w(ie)).then(void 0,f));return}const B=c(o,T),J=O(T);i=(0,D.createCancelablePromise)(se=>y.queue(()=>B.then(ie=>S(ie,A,J,n,r,se).then(()=>w(se)))).then(null,f))})})}function m(o,n=!1){return new Promise((r,e)=>{(0,u.open)(o,n?{lazyEntries:!0}:void 0,(i,s)=>{i?e(d(i)):r((0,R.assertIsDefined)(s))})})}function c(o,n){return new Promise((r,e)=>{o.openReadStream(n,(i,s)=>{i?e(d(i)):r((0,R.assertIsDefined)(s))})})}function h(o,n){return new Promise((r,e)=>{const i=new g.ZipFile;n.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const s=(0,C.createWriteStream)(o);i.outputStream.pipe(s),i.outputStream.once("error",e),s.once("error",e),s.once("finish",()=>r(o))})}t.zip=h;function E(o,n,r={},e){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let s=m(o,!0);return r.overwrite&&(s=s.then(l=>L.Promises.rm(n).then(()=>l))),s.then(l=>p(l,n,{sourcePathRegex:i},e))}t.extract=E;function a(o,n){return m(o).then(r=>new Promise((e,i)=>{r.on("entry",s=>{s.fileName===n&&c(r,s).then(l=>e(l),l=>i(l))}),r.once("close",()=>i(new Error(I.localize(2,null,n))))}))}function v(o,n){return a(o,n).then(r=>new Promise((e,i)=>{const s=[];r.once("error",i),r.on("data",l=>s.push(l)),r.on("end",()=>e(Buffer.concat(s)))}))}t.buffer=v}),define(Q[127],Z([0,1,43,79]),function(z,t,C,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function P(R){return(0,C.buffer)(R,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}t.getManifest=P}),define(Q[128],Z([0,1,18,3,7,2,10,11,12,19,41,9,27,15,43,80,20,22,23,90,16,14,32]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c,h,E,a,v,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let r=class extends R.Disposable{constructor(i,s,l,f,y){super();this.beforeRemovingExtension=i,this.fileService=s,this.logService=l,this.environmentService=f,this.productService=y,this._devSystemExtensionsPath=null,this.systemExtensionsPath=f.builtinExtensionsPath,this.extensionsPath=f.extensionsPath,this.uninstalledPath=I.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(i){const s=[];(i===null||i===0)&&s.push(this.scanSystemExtensions().then(null,l=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(l).message,h.ExtensionManagementErrorCode.Internal)))),(i===null||i===1)&&s.push(this.scanUserExtensions(!0).then(null,l=>Promise.reject(new h.ExtensionManagementError(this.joinErrors(l).message,h.ExtensionManagementErrorCode.Internal))));try{const l=await Promise.all(s);return(0,C.flatten)(l)}catch(l){throw this.joinErrors(l)}}async scanUserExtensions(i){this.logService.trace("Started scanning user extensions");let[s,l]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return l=l.filter(f=>!s[new E.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).key()]),i&&(l=(0,E.groupByExtension)(l,y=>y.identifier).map(y=>y.sort((w,T)=>b.rcompare(w.manifest.version,T.manifest.version))[0])),this.logService.trace("Scanned user extensions:",l.length),l}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(i,s,l,f){const y=i.key(),w=I.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),T=I.join(this.extensionsPath,y);try{await S.Promises.rm(T)}catch{try{await S.Promises.rm(T)}catch{}throw new h.ExtensionManagementError((0,m.localize)(0,null,T,i.id),h.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(i,s,w,f);let A=await this.scanExtension(O.URI.file(w),1);if(!A)throw new Error((0,m.localize)(1,null,w));await this.storeMetadata(A,{...l,installedTimestamp:Date.now()});try{await this.rename(i,w,T,Date.now()+2*60*1e3),this.logService.info("Renamed to",T)}catch(B){try{await S.Promises.rm(w)}catch{}if(B.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",i.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(B)}. Deleted from extracted location`,w),B}try{A=await this.scanExtension(O.URI.file(T),1)}catch{}if(A)return A;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(i,s){return this.setMetadata(i,s),await this.storeMetadata(i,{...s,installedTimestamp:i.installedTimestamp}),i}async storeMetadata(i,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const l=I.join(i.location.fsPath,"package.json"),f=await S.Promises.readFile(l,"utf8"),{manifest:y}=await this.parseManifest(f);return y.__metadata=s,await S.Promises.writeFile(l,JSON.stringify(y,null,"	")),i}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...i){const s=i.map(l=>new E.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version));await this.withUninstalledExtensions(l=>{s.forEach(f=>l[f.key()]=!0)})}async setInstalled(i){await this.withUninstalledExtensions(f=>delete f[i.key()]);const l=(await this.scanExtensions(1)).find(f=>new E.ExtensionIdentifierWithVersion(f.identifier,f.manifest.version).equals(i))||null;return l?(await this.storeMetadata(l,{installedTimestamp:Date.now()}),this.scanExtension(l.location,1)):null}async withUninstalledExtensions(i){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(f){if(f.code!=="ENOENT")throw f}let l={};if(s)try{l=JSON.parse(s)}catch{}return i&&(i(l),Object.keys(l).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(l)):await S.Promises.rm(this.uninstalledPath)),l})}async removeExtension(i,s){this.logService.trace(`Deleting ${s} extension from disk`,i.identifier.id,i.location.fsPath),await S.Promises.rm(i.location.fsPath),this.logService.info("Deleted from disk",i.identifier.id,i.location.fsPath)}async removeUninstalledExtension(i){await this.removeExtension(i,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new E.ExtensionIdentifierWithVersion(i.identifier,i.manifest.version).key()])}async extractAtLocation(i,s,l,f){this.logService.trace(`Started extracting the extension from ${s} to ${l}`);try{await S.Promises.rm(l)}catch(y){throw new h.ExtensionManagementError(this.joinErrors(y).message,h.ExtensionManagementErrorCode.Delete)}try{await(0,p.extract)(s,l,{sourcePath:"extension",overwrite:!0},f),this.logService.info(`Extracted extension to ${l}:`,i.id)}catch(y){try{await S.Promises.rm(l)}catch{}let w=h.ExtensionManagementErrorCode.Extract;throw y instanceof p.ExtractError&&(y.type==="CorruptZip"?w=h.ExtensionManagementErrorCode.CorruptZip:y.type==="Incomplete"&&(w=h.ExtensionManagementErrorCode.IncompleteZip)),new h.ExtensionManagementError(y.message,w)}}async rename(i,s,l,f){try{await S.Promises.rename(s,l)}catch(y){if(u.isWindows&&y&&y.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${s} to ${l} with 'EPERM' error. Trying again...`,i.id),this.rename(i,s,l,f);throw new h.ExtensionManagementError(y.message||(0,m.localize)(3,null,s,l),y.code||h.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const i=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return i;const s=this.scanDevSystemExtensions(),[l,f]=await Promise.all([i,s]);return[...l,...f]}async scanExtensionsInDir(i,s){const l=new D.Limiter(10),f=await this.fileService.resolve(O.URI.file(i));return f.children?(await Promise.all(f.children.filter(w=>w.isDirectory).map(w=>l.queue(async()=>s===1&&(0,g.basename)(w.resource).indexOf(".")===0?null:this.scanExtension(w.resource,s))))).filter(w=>w&&w.identifier):[]}async scanExtension(i,s){try{const l=await this.fileService.resolve(i);if(l.children){const{manifest:f,metadata:y}=await this.readManifest(i.fsPath),w=l.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,T=l.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource,A={id:(0,E.getGalleryExtensionId)(f.publisher,f.name)},B={type:s,identifier:A,manifest:f,location:i,readmeUrl:w,changelogUrl:T,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(B,y),B}}catch(l){s!==0&&this.logService.trace(l)}return null}async scanDefaultSystemExtensions(){const i=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",i.length),i}async scanDevSystemExtensions(){const i=this.getDevSystemExtensionsList();if(i.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(l=>i.some(f=>(0,E.areSameExtensions)(l.identifier,{id:f})))}else return[]}setMetadata(i,s){i.publisherDisplayName=s?.publisherDisplayName||null,i.publisherId=s?.publisherId||null,i.identifier.uuid=s?.id,i.isMachineScoped=!!s?.isMachineScoped,i.isPreReleaseVersion=!!s?.isPreReleaseVersion,i.preRelease=!!s?.preRelease,i.isBuiltin=i.type===0||!!s?.isBuiltin,i.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const i=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),l=new Set;for(const w of s)i[new E.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]||l.add(w.identifier.id.toLowerCase());const f=(0,E.groupByExtension)(s,w=>w.identifier);await D.Promises.settled(f.map(async w=>{const T=w.sort((A,B)=>b.rcompare(A.manifest.version,B.manifest.version))[0];l.has(T.identifier.id.toLowerCase())||await this.beforeRemovingExtension(T)}));const y=s.filter(w=>i[new E.ExtensionIdentifierWithVersion(w.identifier,w.manifest.version).key()]);await D.Promises.settled(y.map(w=>this.removeUninstalledExtension(w)))}async removeOutdatedExtensions(){const i=await this.scanAllUserExtensions(),s=[],l=(0,E.groupByExtension)(i,f=>f.identifier);s.push(...(0,C.flatten)(l.map(f=>f.sort((y,w)=>b.rcompare(y.manifest.version,w.manifest.version)).slice(1)))),await D.Promises.settled(s.map(f=>this.removeExtension(f,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(i=>i.name)}joinErrors(i){const s=Array.isArray(i)?i:[i];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((l,f)=>new Error(`${l.message}${l.message?",":""}${f instanceof Error?f.message:f}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=I.normalize(I.join(L.FileAccess.asFileUri("",z).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(i){const s=[S.Promises.readFile(I.join(i,"package.json"),"utf8").then(w=>this.parseManifest(w)),S.Promises.readFile(I.join(i,"package.nls.json"),"utf8").then(void 0,w=>w.code!=="ENOENT"?Promise.reject(w):"{}").then(w=>JSON.parse(w))],[{manifest:l,metadata:f},y]=await Promise.all(s);return{manifest:(0,a.localizeManifest)(l,y),metadata:f}}parseManifest(i){return new Promise((s,l)=>{try{const f=JSON.parse(i),y=f.__metadata||null;s({manifest:f,metadata:y})}catch{l(new Error((0,m.localize)(4,null)))}})}};r=pe([oe(1,v.IFileService),oe(2,o.ILogService),oe(3,c.INativeEnvironmentService),oe(4,n.IProductService)],r),t.ExtensionsScanner=r}),define(Q[129],Z([0,1,28,7,10,11,12,29,19,41,9,27,15,43,78,49,20,119,22,23,110,98,127,111,128,125,48,16,13,14,32,31,36]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c,h,E,a,v,o,n,r,e,i,s,l,f,y,w,T,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let B=class extends h.AbstractExtensionManagementService{constructor($,q,re,M,F,W,H,ne,K){super($,q,re,ne);this.environmentService=M,this.downloadService=F,this.fileService=H;const ee=this._register(W.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(e.ExtensionsScanner,ae=>ee.postUninstall(ae))),this.manifestCache=this._register(new r.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(W.createInstance(v.ExtensionsDownloader));const G=this._register(new i.ExtensionsWatcher(this,H,M,re,K));this._register(G.onDidChangeExtensionsByAnotherSource(({added:ae,removed:U})=>{ae.length&&this._onDidInstallExtensions.fire(ae.map(k=>({identifier:k.identifier,operation:1,local:k}))),U.forEach(k=>this._onDidUninstallExtension.fire({identifier:k}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const $=await this.isAlpineLinux(),q=(0,E.getTargetPlatform)($?"alpine":L.platform,I.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",q),q})()),this._targetPlatformPromise}async isAlpineLinux(){if(!L.isLinux)return!1;let $;try{$=(await this.fileService.readFile(b.URI.file("/etc/os-release"))).value.toString()}catch{try{$=(await this.fileService.readFile(b.URI.file("/usr/lib/os-release"))).value.toString()}catch(re){this.logService.debug("Error while getting the os-release file.",(0,D.getErrorMessage)(re))}}return!!$&&($.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip($){this.logService.trace("ExtensionManagementService#zip",$.identifier.id);const q=await this.collectFiles($),re=await(0,S.zip)((0,u.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)()).fsPath,q);return b.URI.file(re)}async unzip($){return this.logService.trace("ExtensionManagementService#unzip",$.toString()),(await this.install($)).identifier}async getManifest($){const q=await this.downloadVsix($),re=R.resolve(q.fsPath);return(0,n.getManifest)(re)}getInstalled($=null){return this.extensionsScanner.scanExtensions($)}async install($,q={}){this.logService.trace("ExtensionManagementService#install",$.toString());const re=await this.downloadVsix($),M=await(0,n.getManifest)(R.resolve(re.fsPath));if(M.engines&&M.engines.vscode&&!(0,s.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(p.localize(0,null,(0,a.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,re,q)}async updateMetadata($,q){this.logService.trace("ExtensionManagementService#updateMetadata",$.identifier.id);const re={...$.manifest.__metadata||{},...q};return q.isPreReleaseVersion&&(re.preRelease=!0),$=await this.extensionsScanner.saveMetadataForLocalExtension($,re),this.manifestCache.invalidate(),$}async updateExtensionScope($,q){return this.logService.trace("ExtensionManagementService#updateExtensionScope",$.identifier.id),$=await this.extensionsScanner.saveMetadataForLocalExtension($,{...$.manifest.__metadata||{},isMachineScoped:q}),this.manifestCache.invalidate(),$}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix($){if($.scheme===P.Schemas.file)return $;const q=(0,u.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)());return await this.downloadService.download($,q),q}createInstallExtensionTask($,q,re){return b.URI.isUri(q)?new ie($,q,re,this.galleryService,this.extensionsScanner,this.logService):new se(q,re,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask($,q){return new te($,q,this.extensionsScanner)}async collectFiles($){const q=async M=>{let F=await d.Promises.readdir(M);F=F.map(ne=>R.join(M,ne));const W=await Promise.all(F.map(ne=>d.Promises.stat(ne)));let H=Promise.resolve([]);return W.forEach((ne,K)=>{const ee=F[K];ne.isFile()&&(H=H.then(G=>[...G,ee])),ne.isDirectory()&&(H=H.then(G=>q(ee).then(ae=>[...G,...ae])))}),H};return(await q($.location.fsPath)).map(M=>({path:`extension/${R.relative($.location.fsPath,M)}`,localPath:M}))}};B=pe([oe(0,E.IExtensionGalleryService),oe(1,T.ITelemetryService),oe(2,y.ILogService),oe(3,c.INativeEnvironmentService),oe(4,m.IDownloadService),oe(5,f.IInstantiationService),oe(6,l.IFileService),oe(7,w.IProductService),oe(8,A.IUriIdentityService)],B),t.ExtensionManagementService=B;class J extends h.AbstractExtensionTask{constructor($,q,re,M){super();this.identifier=$,this.source=q,this.extensionsScanner=re,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension($,q){try{const re=await this.unsetUninstalledAndGetLocal($.identifierWithVersion);if(re)return $.metadata?this.extensionsScanner.saveMetadataForLocalExtension(re,{...re.manifest.__metadata||{},...$.metadata}):re}catch{throw L.isMacintosh?new E.ExtensionManagementError(p.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(p.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract($,q)}async unsetUninstalledAndGetLocal($){if(!await this.isUninstalled($))return null;this.logService.trace("Removing the extension from uninstalled list:",$.id);const re=await this.extensionsScanner.setInstalled($);return this.logService.info("Removed the extension from uninstalled list:",$.id),re}async isUninstalled($){return!!(await this.extensionsScanner.getUninstalledExtensions())[$.key()]}async extract({zipPath:$,identifierWithVersion:q,metadata:re},M){let F=await this.extensionsScanner.extractUserExtension(q,$,re,M);return this.logService.info("Extracting completed.",q.id),F}}class se extends J{constructor($,q,re,M,F){super($.identifier,$,M,F);this.gallery=$,this.options=q,this.extensionsDownloader=re}async doRun($){const re=(await this.extensionsScanner.scanExtensions(null)).find(F=>(0,a.areSameExtensions)(F.identifier,this.gallery.identifier));re&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||re?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||re?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:re?.preRelease||this.options.installPreReleaseVersion;try{const F=await this.installExtension(M,$);return re&&g.neq(re.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(re),F}catch(F){throw await this.deleteDownloadedVSIX(M.zipPath),F}}async deleteDownloadedVSIX($){try{await this.extensionsDownloader.delete(b.URI.file($))}catch(q){this.logService.warn("Error while deleting the downloaded vsix",$.toString(),(0,D.getErrorMessage)(q))}}async downloadInstallableExtension($,q){const re={id:$.identifier.uuid,publisherId:$.publisherId,publisherDisplayName:$.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",$.identifier.id),M=(await this.extensionsDownloader.downloadExtension($,q)).fsPath,this.logService.info("Downloaded extension:",$.identifier.id,M)}catch(F){throw new E.ExtensionManagementError((0,h.joinErrors)(F).message,E.ExtensionManagementErrorCode.Download)}try{const F=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new a.ExtensionIdentifierWithVersion($.identifier,F.version),metadata:re}}catch(F){throw await this.deleteDownloadedVSIX(M),new E.ExtensionManagementError((0,h.joinErrors)(F).message,E.ExtensionManagementErrorCode.Invalid)}}}class ie extends J{constructor($,q,re,M,F,W){super({id:(0,a.getGalleryExtensionId)($.publisher,$.name)},q,F,W);this.manifest=$,this.location=q,this.options=re,this.galleryService=M}async doRun($){const q=new a.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(W=>(0,a.areSameExtensions)(this.identifier,W.identifier)),F=await this.getMetadata(this.identifier.id,this.manifest.version,$);if(F.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,F.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,q.equals(new a.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(p.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const W=await this.unsetUninstalledAndGetLocal(q);if(W)try{await this.extensionsScanner.removeExtension(W,"existing")}catch{throw new Error(p.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:R.resolve(this.location.fsPath),identifierWithVersion:q,metadata:F},$)}async getMetadata($,q,re){try{let[M]=await this.galleryService.getExtensions([{id:$,version:q}],re);if(M||([M]=await this.galleryService.getExtensions([{id:$}],re)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class te extends h.AbstractExtensionTask{constructor($,q,re){super();this.extension=$,this.options=q,this.extensionsScanner=re}async doRun($){const q=[],re=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new a.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);q.push(...re.filter(F=>M.equals(new a.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version))))}else q.push(...re.filter(M=>(0,a.areSameExtensions)(M.identifier,this.extension.identifier)));if(!q.length)throw new Error(p.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...q),this.options.remove)for(const M of q)try{$.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(F){throw new Error(p.localize(6,null,(0,C.toErrorMessage)(F)))}}}}),define(Q[130],Z([0,1,115,3,17,7,2,8,25,20,93,14,114,140]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let p=class extends L.Disposable{constructor(c,h,E){super();this.environmentService=h,this.logService=E,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,h){this.logService.trace("RequestService#request",c.url);const{proxyUrl:E,strictSSL:a}=this;let v;try{v=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",r))}const o={...process.env,...v},n=c.agent?c.agent:await(0,d.getProxyAgent)(c.url||"",o,{proxyUrl:E,strictSSL:a});return c.agent=n,c.strictSSL=a,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,h)}async getNodeRequest(c){return((0,C.parse)(c.url).protocol==="https:"?await new Promise((a,v)=>{z(["https"],a,v)}):await new Promise((a,v)=>{z(["http"],a,v)})).request}_request(c,h){return D.Promises.withAsyncBody(async(E,a)=>{let v;const o=(0,C.parse)(c.url),n=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),r={hostname:o.hostname,port:o.port?parseInt(o.port):o.protocol==="https:"?443:80,protocol:o.protocol,path:o.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,I.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password),v=n(r,e=>{const i=(0,I.isNumber)(c.followRedirects)?c.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&i>0&&e.headers.location)this._request({...c,url:e.headers.location,followRedirects:i-1},h).then(E,a);else{let s=e;e.headers["content-encoding"]==="gzip"&&(s=e.pipe((0,S.createGunzip)())),E({res:e,stream:(0,P.streamToBufferReadableStream)(s)})}}),v.on("error",a),c.timeout&&v.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&v.write(c.data),v.end(),h.onCancellationRequested(()=>{v.abort(),a((0,R.canceled)())})})}async resolveProxy(c){}};p=pe([oe(0,u.IConfigurationService),oe(1,g.INativeEnvironmentService),oe(2,O.ILogService)],p),t.RequestService=p}),define(Q[141],Z([0,1,33,3,17,28,7,2,10,11,29,9,15,25,107,49,113,20,89,120,22,109,129,16,100,102,39,97,52,53,112,14,104,122,32,42,130,118,31,121,35,123,124,36,126]),function(z,t,C,D,P,R,L,I,u,g,b,O,d,S,p,m,c,h,E,a,v,o,n,r,e,i,s,l,f,y,w,T,A,B,J,se,ie,te,ge,$,q,re,M,F,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class H extends I.Disposable{constructor(ee){super();this.argv=ee,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ee,G]=await this.initServices();return ee.invokeFunction(async ae=>{const U=ae.get(T.ILogService),k=ae.get(r.IFileService),x=ae.get(h.INativeEnvironmentService),j=ae.get(v.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(x,j,k),await Promise.all(G.map(Y=>{(0,D.raceTimeout)(Y.flush(),1e3)}))})}async initServices(){const ee=new f.ServiceCollection,G={_serviceBrand:void 0,...B.default};ee.set(J.IProductService,G);const ae=new E.NativeEnvironmentService(this.argv,G);ee.set(h.INativeEnvironmentService,ae),await Promise.all([ae.appSettingsHome.fsPath,ae.extensionsPath].map(le=>le?d.Promises.mkdir(le,{recursive:!0}):void 0));const U=(0,T.getLogLevel)(ae),k=[];k.push(new A.SpdLogLogger("cli",(0,g.join)(ae.logsPath,"cli.log"),!0,!1,U)),U===T.LogLevel.Trace&&k.push(new T.ConsoleLogger(U));const x=this._register(new T.MultiplexLogService(k));ee.set(T.ILogService,x);const j=this._register(new e.FileService(x));ee.set(r.IFileService,j);const Y=this._register(new i.DiskFileSystemProvider(x));j.registerProvider(u.Schemas.file,Y);const X=this._register(new p.ConfigurationService(ae.settingsResource,j));ee.set(S.IConfigurationService,X),await X.initialize(),ee.set(F.IUriIdentityService,new W.UriIdentityService(j)),ee.set(se.IRequestService,new s.SyncDescriptor(ie.RequestService)),ee.set(m.IDownloadService,new s.SyncDescriptor(c.DownloadService)),ee.set(v.IExtensionManagementService,new s.SyncDescriptor(n.ExtensionManagementService)),ee.set(v.IExtensionGalleryService,new s.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),ee.set(v.IExtensionManagementCLIService,new s.SyncDescriptor(o.ExtensionManagementCLIService)),ee.set(y.ILocalizationsService,new s.SyncDescriptor(w.LocalizationsService));const fe=[];if((0,q.supportsTelemetry)(G,ae)){G.aiConfig&&G.aiConfig.asimovKey&&fe.push(new re.AppInsightsAppender("monacoworkbench",null,G.aiConfig.asimovKey));const{appRoot:le,extensionsPath:Ee,installSourcePath:de}=ae,ue={appenders:fe,sendErrorTelemetry:!1,commonProperties:(async()=>{let he;try{const me=await d.Promises.readFile((0,g.join)(ae.userDataPath,"storage.json"));he=JSON.parse(me.toString())[ge.machineIdKey]}catch(me){me.code!=="ENOENT"&&x.error(me)}return(0,te.resolveCommonProperties)(j,(0,C.release)(),(0,C.hostname)(),process.arch,G.commit,G.version,he,G.msftInternalDomains,de)})(),piiPaths:[le,Ee]};ee.set(ge.ITelemetryService,new s.SyncDescriptor($.TelemetryService,[ue]))}else ee.set(ge.ITelemetryService,q.NullTelemetryService);return[new l.InstantiationService(ee),fe]}registerErrorHandler(ee){(0,L.setUnexpectedErrorHandler)(G=>{const ae=(0,R.toErrorMessage)(G,!0);!ae||ee.error(`[uncaught exception in CLI]: ${ae}`)}),process.on("uncaughtException",G=>(0,L.onUnexpectedError)(G)),process.on("unhandledRejection",G=>(0,L.onUnexpectedError)(G))}async doRun(ee,G,ae){if(this.argv["install-source"])return this.setInstallSource(ee,ae,this.argv["install-source"]);if(this.argv["list-extensions"])return G.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return G.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return G.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return G.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(ee.appRoot,ee.extensionsPath))}}asExtensionIdOrVSIX(ee){return ee.map(G=>/\.vsix$/i.test(G)?O.URI.file((0,g.isAbsolute)(G)?G:(0,g.join)((0,b.cwd)(),G)):G)}async setInstallSource(ee,G,ae){await G.writeFile(O.URI.file(ee.installSourcePath),P.VSBuffer.fromString(ae.slice(0,30)))}}async function ne(K){const ee=new H(K);try{await ee.run()}finally{ee.dispose()}}t.main=ne})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a7f1b7395175418c74fe0041560eb3f0423d4d27/core/vs/code/node/cliProcessMain.js.map
