/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["require","exports","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/codicons","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/languages/languageSelector","vs/editor/common/languages","vs/editor/common/core/range","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/model","vs/editor/common/languages/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/remote/common/tunnel","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsDragAndDropService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],r=0,t=ee.length;r<t;r++)e[r]=ye[ee[r]];return e};define(ye[42],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function r(t,_){if(!t)throw new Error(_?`Assertion failed (${_})`:"Assertion Failed")}e.ok=r}),define(ye[52],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function r(I){return I?I.replace(/\$\((.*?)\)/g,(P,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=r;class t{constructor(P,D,T){this.id=P,this.definition=D,this.description=T,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function _(I,P){const D=["codicon","codicon-"+I];return P&&D.push("codicon-modifier-"+P),D}e.getClassNamesArray=_;var A;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function D(w){if(w instanceof t)return["codicon","codicon-"+w.id];const i=P.exec(w.id);if(!i)return D(t.error);let[,d,l]=i;const s=["codicon","codicon-"+d];return l&&s.push("codicon-modifier-"+l.substr(1)),s}I.asClassNameArray=D;function T(w){return D(w).join(" ")}I.asClassName=T;function R(w){return"."+D(w).join(".")}I.asCSSSelector=R})(A=e.CSSIcon||(e.CSSIcon={}))}),define(ye[73],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const r=Object.prototype.hasOwnProperty;function t(R){const w=[];for(let i in R)r.call(R,i)&&w.push(R[i]);return w}e.values=t;function _(R,w){for(let i in R)if(r.call(R,i)&&w({key:i,value:R[i]},function(){delete R[i]})===!1)return}e.forEach=_;function A(R,w){const i=Object.create(null);for(const d of R){const l=w(d);let s=i[l];s||(s=i[l]=[]),s.push(d)}return i}e.groupBy=A;function I(R){const w=Object.create(null);return R&&R.forEach((i,d)=>{w[d]=i}),w}e.fromMap=I;function P(R,w){const i=[],d=[];for(let l of R)w.has(l)||i.push(l);for(let l of w)R.has(l)||d.push(l);return{removed:i,added:d}}e.diffSets=P;function D(R,w){const i=[],d=[];for(let[l,s]of R)w.has(l)||i.push(s);for(let[l,s]of w)R.has(l)||d.push(s);return{removed:i,added:d}}e.diffMaps=D;class T{constructor(){this.map=new Map}add(w,i){let d=this.map.get(w);d||(d=new Set,this.map.set(w,d)),d.add(i)}delete(w,i){const d=this.map.get(w);!d||(d.delete(i),d.size===0&&this.map.delete(w))}forEach(w,i){const d=this.map.get(w);!d||d.forEach(i)}}e.SetMap=T}),define(ye[53],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function r(I){return(P,D,T)=>{let R=null,w=null;if(typeof T.value=="function"?(R="value",w=T.value):typeof T.get=="function"&&(R="get",w=T.get),!w)throw new Error("not supported");T[R]=I(w,D)}}e.createDecorator=r;function t(I,P,D){let T=null,R=null;if(typeof D.value=="function"?(T="value",R=D.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(T="get",R=D.get),!R)throw new Error("not supported");const w=`$memoize$${P}`;D[T]=function(...i){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,i)}),this[w]}}e.memoize=t;function _(I,P,D){return r((T,R)=>{const w=`$debounce$${R}`,i=`$debounce$result$${R}`;return function(...d){this[i]||(this[i]=D?D():void 0),clearTimeout(this[w]),P&&(this[i]=P(this[i],...d),d=[this[i]]),this[w]=setTimeout(()=>{T.apply(this,d),this[i]=D?D():void 0},I)}})}e.debounce=_;function A(I,P,D){return r((T,R)=>{const w=`$throttle$timer$${R}`,i=`$throttle$result$${R}`,d=`$throttle$lastRun$${R}`,l=`$throttle$pending$${R}`;return function(...s){if(this[i]||(this[i]=D?D():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[i]=P(this[i],...s)),this[l])return;const m=this[d]+I;m<=Date.now()?(this[d]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0):(this[l]=!0,this[w]=setTimeout(()=>{this[l]=!1,this[d]=Date.now(),T.apply(this,[this[i]]),this[i]=D?D():void 0},m-Date.now()))}})}e.throttle=A}),define(ye[54],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class r{constructor(_){this._prefix=_,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=r,e.defaultGenerator=new r("id#")}),define(ye[99],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var r;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(r=e.ScanError||(e.ScanError={}));var t;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var _;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(_=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(a){a.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function I(a,M=!1){let o=0,n=a.length,u="",f=0,c=16,h=0;function g(L){let W=0,B=0;for(;W<L;){const $=a.charCodeAt(o);if($>=48&&$<=57)B=B*16+$-48;else if($>=65&&$<=70)B=B*16+$-65+10;else if($>=97&&$<=102)B=B*16+$-97+10;else break;o++,W++}return W<L&&(B=-1),B}function E(L){o=L,u="",f=0,c=16,h=0}function v(){const L=o;if(a.charCodeAt(o)===48)o++;else for(o++;o<a.length&&T(a.charCodeAt(o));)o++;if(o<a.length&&a.charCodeAt(o)===46)if(o++,o<a.length&&T(a.charCodeAt(o)))for(o++;o<a.length&&T(a.charCodeAt(o));)o++;else return h=3,a.substring(L,o);let W=o;if(o<a.length&&(a.charCodeAt(o)===69||a.charCodeAt(o)===101))if(o++,(o<a.length&&a.charCodeAt(o)===43||a.charCodeAt(o)===45)&&o++,o<a.length&&T(a.charCodeAt(o))){for(o++;o<a.length&&T(a.charCodeAt(o));)o++;W=o}else h=3;return a.substring(L,W)}function k(){let L="",W=o;for(;;){if(o>=n){L+=a.substring(W,o),h=2;break}const B=a.charCodeAt(o);if(B===34){L+=a.substring(W,o),o++;break}if(B===92){if(L+=a.substring(W,o),o++,o>=n){h=2;break}switch(a.charCodeAt(o++)){case 34:L+='"';break;case 92:L+="\\";break;case 47:L+="/";break;case 98:L+="\b";break;case 102:L+="\f";break;case 110:L+=`
`;break;case 114:L+="\r";break;case 116:L+="	";break;case 117:{const q=g(4);q>=0?L+=String.fromCharCode(q):h=4;break}default:h=5}W=o;continue}if(B>=0&&B<=31)if(D(B)){L+=a.substring(W,o),h=2;break}else h=6;o++}return L}function x(){if(u="",h=0,f=o,o>=n)return f=n,c=17;let L=a.charCodeAt(o);if(P(L)){do o++,u+=String.fromCharCode(L),L=a.charCodeAt(o);while(P(L));return c=15}if(D(L))return o++,u+=String.fromCharCode(L),L===13&&a.charCodeAt(o)===10&&(o++,u+=`
`),c=14;switch(L){case 123:return o++,c=1;case 125:return o++,c=2;case 91:return o++,c=3;case 93:return o++,c=4;case 58:return o++,c=6;case 44:return o++,c=5;case 34:return o++,u=k(),c=10;case 47:{const W=o-1;if(a.charCodeAt(o+1)===47){for(o+=2;o<n&&!D(a.charCodeAt(o));)o++;return u=a.substring(W,o),c=12}if(a.charCodeAt(o+1)===42){o+=2;const B=n-1;let $=!1;for(;o<B;){if(a.charCodeAt(o)===42&&a.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,h=1),u=a.substring(W,o),c=13}return u+=String.fromCharCode(L),o++,c=16}case 45:if(u+=String.fromCharCode(L),o++,o===n||!T(a.charCodeAt(o)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=v(),c=11;default:for(;o<n&&N(L);)o++,L=a.charCodeAt(o);if(f!==o){switch(u=a.substring(f,o),u){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return u+=String.fromCharCode(L),o++,c=16}}function N(L){if(P(L)||D(L))return!1;switch(L){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function y(){let L;do L=x();while(L>=12&&L<=15);return L}return{setPosition:E,getPosition:()=>o,scan:M?y:x,getToken:()=>c,getTokenValue:()=>u,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>h}}e.createScanner=I;function P(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function D(a){return a===10||a===13||a===8232||a===8233}function T(a){return a>=48&&a<=57}var R;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(R||(R={}));function w(a,M){const o=[],n=new Object;let u;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function h(g,E,v,k){f.value=g,f.offset=E,f.length=v,f.type=k,f.colonOffset=void 0,u=f}try{b(a,{onObjectBegin:(g,E)=>{if(M<=g)throw n;u=void 0,c=M>g,o.push("")},onObjectProperty:(g,E,v)=>{if(M<E||(h(g,E,v,"property"),o[o.length-1]=g,M<=E+v))throw n},onObjectEnd:(g,E)=>{if(M<=g)throw n;u=void 0,o.pop()},onArrayBegin:(g,E)=>{if(M<=g)throw n;u=void 0,o.push(0)},onArrayEnd:(g,E)=>{if(M<=g)throw n;u=void 0,o.pop()},onLiteralValue:(g,E,v)=>{if(M<E||(h(g,E,v,C(g)),M<=E+v))throw n},onSeparator:(g,E,v)=>{if(M<=E)throw n;if(g===":"&&u&&u.type==="property")u.colonOffset=E,c=!1,u=void 0;else if(g===","){const k=o[o.length-1];typeof k=="number"?o[o.length-1]=k+1:(c=!0,o[o.length-1]=""),u=void 0}}})}catch(g){if(g!==n)throw g}return{path:o,previousNode:u,isAtPropertyKey:c,matches:g=>{let E=0;for(let v=0;E<g.length&&v<o.length;v++)if(g[E]===o[v]||g[E]==="*")E++;else if(g[E]!=="**")return!1;return E===g.length}}}e.getLocation=w;function i(a,M=[],o=A.DEFAULT){let n=null,u=[];const f=[];function c(g){Array.isArray(u)?u.push(g):n!==null&&(u[n]=g)}return b(a,{onObjectBegin:()=>{const g={};c(g),f.push(u),u=g,n=null},onObjectProperty:g=>{n=g},onObjectEnd:()=>{u=f.pop()},onArrayBegin:()=>{const g=[];c(g),f.push(u),u=g,n=null},onArrayEnd:()=>{u=f.pop()},onLiteralValue:c,onError:(g,E,v)=>{M.push({error:g,offset:E,length:v})}},o),u[0]}e.parse=i;function d(a,M=[],o=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(g){n.type==="property"&&(n.length=g-n.offset,n=n.parent)}function f(g){return n.children.push(g),g}b(a,{onObjectBegin:g=>{n=f({type:"object",offset:g,length:-1,parent:n,children:[]})},onObjectProperty:(g,E,v)=>{n=f({type:"property",offset:E,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:g,offset:E,length:v,parent:n})},onObjectEnd:(g,E)=>{n.length=g+E-n.offset,n=n.parent,u(g+E)},onArrayBegin:(g,E)=>{n=f({type:"array",offset:g,length:-1,parent:n,children:[]})},onArrayEnd:(g,E)=>{n.length=g+E-n.offset,n=n.parent,u(g+E)},onLiteralValue:(g,E,v)=>{f({type:C(g),offset:E,length:v,parent:n,value:g}),u(E+v)},onSeparator:(g,E,v)=>{n.type==="property"&&(g===":"?n.colonOffset=E:g===","&&u(E))},onError:(g,E,v)=>{M.push({error:g,offset:E,length:v})}},o);const h=n.children[0];return h&&delete h.parent,h}e.parseTree=d;function l(a,M){if(!a)return;let o=a;for(let n of M)if(typeof n=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let u=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===n){o=f.children[1],u=!0;break}if(!u)return}else{const u=n;if(o.type!=="array"||u<0||!Array.isArray(o.children)||u>=o.children.length)return;o=o.children[u]}return o}e.findNodeAtLocation=l;function s(a){if(!a.parent||!a.parent.children)return[];const M=s(a.parent);if(a.parent.type==="property"){const o=a.parent.children[0].value;M.push(o)}else if(a.parent.type==="array"){const o=a.parent.children.indexOf(a);o!==-1&&M.push(o)}return M}e.getNodePath=s;function m(a){switch(a.type){case"array":return a.children.map(m);case"object":{const M=Object.create(null);for(let o of a.children){const n=o.children[1];n&&(M[o.children[0].value]=m(n))}return M}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=m;function F(a,M,o=!1){return M>=a.offset&&M<a.offset+a.length||o&&M===a.offset+a.length}e.contains=F;function S(a,M,o=!1){if(F(a,M,o)){const n=a.children;if(Array.isArray(n))for(let u=0;u<n.length&&n[u].offset<=M;u++){const f=S(n[u],M,o);if(f)return f}return a}}e.findNodeAtOffset=S;function b(a,M,o=A.DEFAULT){const n=I(a,!1);function u(pe){return pe?()=>pe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function f(pe){return pe?fe=>pe(fe,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=u(M.onObjectBegin),h=f(M.onObjectProperty),g=u(M.onObjectEnd),E=u(M.onArrayBegin),v=u(M.onArrayEnd),k=f(M.onLiteralValue),x=f(M.onSeparator),N=u(M.onComment),y=f(M.onError),L=o&&o.disallowComments,W=o&&o.allowTrailingComma;function B(){for(;;){const pe=n.scan();switch(n.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:L||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(pe){case 12:case 13:L?$(10):N();break;case 16:$(1);break;case 15:case 14:break;default:return pe}}}function $(pe,fe=[],oe=[]){if(y(pe),fe.length+oe.length>0){let Ee=n.getToken();for(;Ee!==17;){if(fe.indexOf(Ee)!==-1){B();break}else if(oe.indexOf(Ee)!==-1)break;Ee=B()}}}function q(pe){const fe=n.getTokenValue();return pe?k(fe):h(fe),B(),!0}function ie(){switch(n.getToken()){case 11:{let pe=0;try{pe=JSON.parse(n.getTokenValue()),typeof pe!="number"&&($(2),pe=0)}catch{$(2)}k(pe);break}case 7:k(null);break;case 8:k(!0);break;case 9:k(!1);break;default:return!1}return B(),!0}function se(){return n.getToken()!==10?($(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(x(":"),B(),be()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function X(){c(),B();let pe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(pe||$(4,[],[]),x(","),B(),n.getToken()===2&&W)break}else pe&&$(6,[],[]);se()||$(4,[],[2,5]),pe=!0}return g(),n.getToken()!==2?$(7,[2],[]):B(),!0}function ge(){E(),B();let pe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(pe||$(4,[],[]),x(","),B(),n.getToken()===4&&W)break}else pe&&$(6,[],[]);be()||$(4,[],[4,5]),pe=!0}return v(),n.getToken()!==4?$(8,[4],[]):B(),!0}function be(){switch(n.getToken()){case 3:return ge();case 1:return X();case 10:return q(!0);default:return ie()}}return B(),n.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):be()?(n.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=b;function p(a,M){let o=I(a),n=[],u,f=0,c;do switch(c=o.getPosition(),u=o.scan(),u){case 12:case 13:case 17:f!==c&&n.push(a.substring(f,c)),M!==void 0&&n.push(o.getTokenValue().replace(/[^\r\n]/g,M)),f=o.getPosition();break}while(u!==17);return n.join("")}e.stripComments=p;function C(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=C}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Ae,De){for(var ve=0;ve<De.length;ve++){var te=De[ve];te.enumerable=te.enumerable||!1,te.configurable=!0,"value"in te&&(te.writable=!0),Object.defineProperty(Ae,te.key,te)}}function e(Ae,De,ve){return De&&ee(Ae.prototype,De),ve&&ee(Ae,ve),Ae}function r(Ae,De){if(!!Ae){if(typeof Ae=="string")return t(Ae,De);var ve=Object.prototype.toString.call(Ae).slice(8,-1);if(ve==="Object"&&Ae.constructor&&(ve=Ae.constructor.name),ve==="Map"||ve==="Set")return Array.from(Ae);if(ve==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ve))return t(Ae,De)}}function t(Ae,De){(De==null||De>Ae.length)&&(De=Ae.length);for(var ve=0,te=new Array(De);ve<De;ve++)te[ve]=Ae[ve];return te}function _(Ae,De){var ve=typeof Symbol!="undefined"&&Ae[Symbol.iterator]||Ae["@@iterator"];if(ve)return(ve=ve.call(Ae)).next.bind(ve);if(Array.isArray(Ae)||(ve=r(Ae))||De&&Ae&&typeof Ae.length=="number"){ve&&(Ae=ve);var te=0;return function(){return te>=Ae.length?{done:!0}:{done:!1,value:Ae[te++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function I(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function P(Ae){A.exports.defaults=Ae}A.exports={defaults:I(),getDefaults:I,changeDefaults:P};var D=/[&<>"']/,T=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,i={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(De){return i[De]};function l(Ae,De){if(De){if(D.test(Ae))return Ae.replace(T,d)}else if(R.test(Ae))return Ae.replace(w,d);return Ae}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(Ae){return Ae.replace(s,function(De,ve){return ve=ve.toLowerCase(),ve==="colon"?":":ve.charAt(0)==="#"?ve.charAt(1)==="x"?String.fromCharCode(parseInt(ve.substring(2),16)):String.fromCharCode(+ve.substring(1)):""})}var F=/(^|[^\[])\^/g;function S(Ae,De){Ae=Ae.source||Ae,De=De||"";var ve={replace:function(ne,ue){return ue=ue.source||ue,ue=ue.replace(F,"$1"),Ae=Ae.replace(ne,ue),ve},getRegex:function(){return new RegExp(Ae,De)}};return ve}var b=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Ae,De,ve){if(Ae){var te;try{te=decodeURIComponent(m(ve)).replace(b,"").toLowerCase()}catch{return null}if(te.indexOf("javascript:")===0||te.indexOf("vbscript:")===0||te.indexOf("data:")===0)return null}De&&!p.test(ve)&&(ve=u(De,ve));try{ve=encodeURI(ve).replace(/%25/g,"%")}catch{return null}return ve}var a={},M=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(Ae,De){a[" "+Ae]||(M.test(Ae)?a[" "+Ae]=Ae+"/":a[" "+Ae]=g(Ae,"/",!0)),Ae=a[" "+Ae];var ve=Ae.indexOf(":")===-1;return De.substring(0,2)==="//"?ve?De:Ae.replace(o,"$1")+De:De.charAt(0)==="/"?ve?De:Ae.replace(n,"$1")+De:Ae+De}var f={exec:function(){}};function c(Ae){for(var De=1,ve,te;De<arguments.length;De++){ve=arguments[De];for(te in ve)Object.prototype.hasOwnProperty.call(ve,te)&&(Ae[te]=ve[te])}return Ae}function h(Ae,De){var ve=Ae.replace(/\|/g,function(ue,me,Te){for(var He=!1,Le=me;--Le>=0&&Te[Le]==="\\";)He=!He;return He?"|":" |"}),te=ve.split(/ \|/),ne=0;if(te[0].trim()||te.shift(),te[te.length-1].trim()||te.pop(),te.length>De)te.splice(De);else for(;te.length<De;)te.push("");for(;ne<te.length;ne++)te[ne]=te[ne].trim().replace(/\\\|/g,"|");return te}function g(Ae,De,ve){var te=Ae.length;if(te===0)return"";for(var ne=0;ne<te;){var ue=Ae.charAt(te-ne-1);if(ue===De&&!ve)ne++;else if(ue!==De&&ve)ne++;else break}return Ae.substr(0,te-ne)}function E(Ae,De){if(Ae.indexOf(De[1])===-1)return-1;for(var ve=Ae.length,te=0,ne=0;ne<ve;ne++)if(Ae[ne]==="\\")ne++;else if(Ae[ne]===De[0])te++;else if(Ae[ne]===De[1]&&(te--,te<0))return ne;return-1}function v(Ae){Ae&&Ae.sanitize&&!Ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function k(Ae,De){if(De<1)return"";for(var ve="";De>1;)De&1&&(ve+=Ae),De>>=1,Ae+=Ae;return ve+Ae}var x={escape:l,unescape:m,edit:S,cleanUrl:C,resolveUrl:u,noopTest:f,merge:c,splitCells:h,rtrim:g,findClosingBracket:E,checkSanitizeDeprecation:v,repeatString:k},N=A.exports.defaults,y=x.rtrim,L=x.splitCells,W=x.escape,B=x.findClosingBracket;function $(Ae,De,ve,te){var ne=De.href,ue=De.title?W(De.title):null,me=Ae[1].replace(/\\([\[\]])/g,"$1");if(Ae[0].charAt(0)!=="!"){te.state.inLink=!0;var Te={type:"link",raw:ve,href:ne,title:ue,text:me,tokens:te.inlineTokens(me,[])};return te.state.inLink=!1,Te}else return{type:"image",raw:ve,href:ne,title:ue,text:W(me)}}function q(Ae,De){var ve=Ae.match(/^(\s+)(?:```)/);if(ve===null)return De;var te=ve[1];return De.split(`
`).map(function(ne){var ue=ne.match(/^\s+/);if(ue===null)return ne;var me=ue[0];return me.length>=te.length?ne.slice(te.length):ne}).join(`
`)}var ie=function(){function Ae(ve){this.options=ve||N}var De=Ae.prototype;return De.space=function(te){var ne=this.rules.block.newline.exec(te);if(ne)return ne[0].length>1?{type:"space",raw:ne[0]}:{raw:`
`}},De.code=function(te){var ne=this.rules.block.code.exec(te);if(ne){var ue=ne[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ne[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:y(ue,`
`)}}},De.fences=function(te){var ne=this.rules.block.fences.exec(te);if(ne){var ue=ne[0],me=q(ue,ne[3]||"");return{type:"code",raw:ue,lang:ne[2]?ne[2].trim():ne[2],text:me}}},De.heading=function(te){var ne=this.rules.block.heading.exec(te);if(ne){var ue=ne[2].trim();if(/#$/.test(ue)){var me=y(ue,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ue=me.trim())}var Te={type:"heading",raw:ne[0],depth:ne[1].length,text:ue,tokens:[]};return this.lexer.inline(Te.text,Te.tokens),Te}},De.hr=function(te){var ne=this.rules.block.hr.exec(te);if(ne)return{type:"hr",raw:ne[0]}},De.blockquote=function(te){var ne=this.rules.block.blockquote.exec(te);if(ne){var ue=ne[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ne[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},De.list=function(te){var ne=this.rules.block.list.exec(te);if(ne){var ue,me,Te,He,Le,Ge,ot,at,Ne,ce,he=ne[1].trim(),re=he.length>1,V={type:"list",raw:"",ordered:re,start:re?+he.slice(0,-1):"",loose:!1,items:[]};he=re?"\\d{1,9}\\"+he.slice(-1):"\\"+he,this.options.pedantic&&(he=re?he:"[*+-]");for(var we=new RegExp("^( {0,3}"+he+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");te&&!(this.rules.block.hr.test(te)||!(ne=we.exec(te)));){Ne=ne[2].split(`
`),this.options.pedantic?(He=2,ce=Ne[0].trimLeft()):(He=ne[2].search(/[^ ]/),He=ne[1].length+(He>4?1:He),ce=Ne[0].slice(He-ne[1].length)),Ge=!1,ue=ne[0],!Ne[0]&&/^ *$/.test(Ne[1])&&(ue=ne[1]+Ne.slice(0,2).join(`
`)+`
`,V.loose=!0,Ne=[]);var Re=new RegExp("^ {0,"+Math.min(3,He-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Le=1;Le<Ne.length;Le++){if(at=Ne[Le],this.options.pedantic&&(at=at.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),Re.test(at)){ue=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}if(!Ge){at.trim()||(Ge=!0),at.search(/[^ ]/)>=He?ce+=`
`+at.slice(He):ce+=`
`+at;continue}if(at.search(/[^ ]/)>=He||!at.trim()){ce+=`
`+at.slice(He);continue}else{ue=ne[1]+Ne.slice(0,Le).join(`
`)+`
`;break}}V.loose||(ot?V.loose=!0:/\n *\n *$/.test(ue)&&(ot=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(ce),me&&(Te=me[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),V.items.push({type:"list_item",raw:ue,task:!!me,checked:Te,loose:!1,text:ce}),V.raw+=ue,te=te.slice(ue.length)}V.items[V.items.length-1].raw=ue.trimRight(),V.items[V.items.length-1].text=ce.trimRight(),V.raw=V.raw.trimRight();var We=V.items.length;for(Le=0;Le<We;Le++)this.lexer.state.top=!1,V.items[Le].tokens=this.lexer.blockTokens(V.items[Le].text,[]),V.items[Le].tokens.some(function(ze){return ze.type==="space"})&&(V.loose=!0,V.items[Le].loose=!0);return V}},De.html=function(te){var ne=this.rules.block.html.exec(te);if(ne){var ue={type:"html",raw:ne[0],pre:!this.options.sanitizer&&(ne[1]==="pre"||ne[1]==="script"||ne[1]==="style"),text:ne[0]};return this.options.sanitize&&(ue.type="paragraph",ue.text=this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]),ue.tokens=[],this.lexer.inline(ue.text,ue.tokens)),ue}},De.def=function(te){var ne=this.rules.block.def.exec(te);if(ne){ne[3]&&(ne[3]=ne[3].substring(1,ne[3].length-1));var ue=ne[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:ne[0],href:ne[2],title:ne[3]}}},De.table=function(te){var ne=this.rules.block.table.exec(te);if(ne){var ue={type:"table",header:L(ne[1]).map(function(ot){return{text:ot}}),align:ne[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ne[3]?ne[3].replace(/\n$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=ne[0];var me=ue.align.length,Te,He,Le,Ge;for(Te=0;Te<me;Te++)/^ *-+: *$/.test(ue.align[Te])?ue.align[Te]="right":/^ *:-+: *$/.test(ue.align[Te])?ue.align[Te]="center":/^ *:-+ *$/.test(ue.align[Te])?ue.align[Te]="left":ue.align[Te]=null;for(me=ue.rows.length,Te=0;Te<me;Te++)ue.rows[Te]=L(ue.rows[Te],ue.header.length).map(function(ot){return{text:ot}});for(me=ue.header.length,He=0;He<me;He++)ue.header[He].tokens=[],this.lexer.inlineTokens(ue.header[He].text,ue.header[He].tokens);for(me=ue.rows.length,He=0;He<me;He++)for(Ge=ue.rows[He],Le=0;Le<Ge.length;Le++)Ge[Le].tokens=[],this.lexer.inlineTokens(Ge[Le].text,Ge[Le].tokens);return ue}}},De.lheading=function(te){var ne=this.rules.block.lheading.exec(te);if(ne){var ue={type:"heading",raw:ne[0],depth:ne[2].charAt(0)==="="?1:2,text:ne[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},De.paragraph=function(te){var ne=this.rules.block.paragraph.exec(te);if(ne){var ue={type:"paragraph",raw:ne[0],text:ne[1].charAt(ne[1].length-1)===`
`?ne[1].slice(0,-1):ne[1],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},De.text=function(te){var ne=this.rules.block.text.exec(te);if(ne){var ue={type:"text",raw:ne[0],text:ne[0],tokens:[]};return this.lexer.inline(ue.text,ue.tokens),ue}},De.escape=function(te){var ne=this.rules.inline.escape.exec(te);if(ne)return{type:"escape",raw:ne[0],text:W(ne[1])}},De.tag=function(te){var ne=this.rules.inline.tag.exec(te);if(ne)return!this.lexer.state.inLink&&/^<a /i.test(ne[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ne[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ne[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ne[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ne[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ne[0]):W(ne[0]):ne[0]}},De.link=function(te){var ne=this.rules.inline.link.exec(te);if(ne){var ue=ne[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var me=y(ue.slice(0,-1),"\\");if((ue.length-me.length)%2==0)return}else{var Te=B(ne[2],"()");if(Te>-1){var He=ne[0].indexOf("!")===0?5:4,Le=He+ne[1].length+Te;ne[2]=ne[2].substring(0,Te),ne[0]=ne[0].substring(0,Le).trim(),ne[3]=""}}var Ge=ne[2],ot="";if(this.options.pedantic){var at=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ge);at&&(Ge=at[1],ot=at[3])}else ot=ne[3]?ne[3].slice(1,-1):"";return Ge=Ge.trim(),/^</.test(Ge)&&(this.options.pedantic&&!/>$/.test(ue)?Ge=Ge.slice(1):Ge=Ge.slice(1,-1)),$(ne,{href:Ge&&Ge.replace(this.rules.inline._escapes,"$1"),title:ot&&ot.replace(this.rules.inline._escapes,"$1")},ne[0],this.lexer)}},De.reflink=function(te,ne){var ue;if((ue=this.rules.inline.reflink.exec(te))||(ue=this.rules.inline.nolink.exec(te))){var me=(ue[2]||ue[1]).replace(/\s+/g," ");if(me=ne[me.toLowerCase()],!me||!me.href){var Te=ue[0].charAt(0);return{type:"text",raw:Te,text:Te}}return $(ue,me,ue[0],this.lexer)}},De.emStrong=function(te,ne,ue){ue===void 0&&(ue="");var me=this.rules.inline.emStrong.lDelim.exec(te);if(!!me&&!(me[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=me[1]||me[2]||"";if(!Te||Te&&(ue===""||this.rules.inline.punctuation.exec(ue))){var He=me[0].length-1,Le,Ge,ot=He,at=0,Ne=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ne.lastIndex=0,ne=ne.slice(-1*te.length+He);(me=Ne.exec(ne))!=null;)if(Le=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Le){if(Ge=Le.length,me[3]||me[4]){ot+=Ge;continue}else if((me[5]||me[6])&&He%3&&!((He+Ge)%3)){at+=Ge;continue}if(ot-=Ge,!(ot>0)){if(Ge=Math.min(Ge,Ge+ot+at),Math.min(He,Ge)%2){var ce=te.slice(1,He+me.index+Ge);return{type:"em",raw:te.slice(0,He+me.index+Ge+1),text:ce,tokens:this.lexer.inlineTokens(ce,[])}}var he=te.slice(2,He+me.index+Ge-1);return{type:"strong",raw:te.slice(0,He+me.index+Ge+1),text:he,tokens:this.lexer.inlineTokens(he,[])}}}}}},De.codespan=function(te){var ne=this.rules.inline.code.exec(te);if(ne){var ue=ne[2].replace(/\n/g," "),me=/[^ ]/.test(ue),Te=/^ /.test(ue)&&/ $/.test(ue);return me&&Te&&(ue=ue.substring(1,ue.length-1)),ue=W(ue,!0),{type:"codespan",raw:ne[0],text:ue}}},De.br=function(te){var ne=this.rules.inline.br.exec(te);if(ne)return{type:"br",raw:ne[0]}},De.del=function(te){var ne=this.rules.inline.del.exec(te);if(ne)return{type:"del",raw:ne[0],text:ne[2],tokens:this.lexer.inlineTokens(ne[2],[])}},De.autolink=function(te,ne){var ue=this.rules.inline.autolink.exec(te);if(ue){var me,Te;return ue[2]==="@"?(me=W(this.options.mangle?ne(ue[1]):ue[1]),Te="mailto:"+me):(me=W(ue[1]),Te=me),{type:"link",raw:ue[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.url=function(te,ne){var ue;if(ue=this.rules.inline.url.exec(te)){var me,Te;if(ue[2]==="@")me=W(this.options.mangle?ne(ue[0]):ue[0]),Te="mailto:"+me;else{var He;do He=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(He!==ue[0]);me=W(ue[0]),ue[1]==="www."?Te="http://"+me:Te=me}return{type:"link",raw:ue[0],text:me,href:Te,tokens:[{type:"text",raw:me,text:me}]}}},De.inlineText=function(te,ne){var ue=this.rules.inline.text.exec(te);if(ue){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):W(ue[0]):ue[0]:me=W(this.options.smartypants?ne(ue[0]):ue[0]),{type:"text",raw:ue[0],text:me}}},Ae}(),se=x.noopTest,X=x.edit,ge=x.merge,be={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:se,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};be._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,be._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,be.def=X(be.def).replace("label",be._label).replace("title",be._title).getRegex(),be.bullet=/(?:[*+-]|\d{1,9}[.)])/,be.listItemStart=X(/^( *)(bull) */).replace("bull",be.bullet).getRegex(),be.list=X(be.list).replace(/bull/g,be.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+be.def.source+")").getRegex(),be._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",be._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,be.html=X(be.html,"i").replace("comment",be._comment).replace("tag",be._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),be.paragraph=X(be._paragraph).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.blockquote=X(be.blockquote).replace("paragraph",be.paragraph).getRegex(),be.normal=ge({},be),be.gfm=ge({},be.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),be.gfm.table=X(be.gfm.table).replace("hr",be.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",be._tag).getRegex(),be.pedantic=ge({},be.normal,{html:X(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",be._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:se,paragraph:X(be.normal._paragraph).replace("hr",be.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",be.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var pe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:se,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:se,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};pe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",pe.punctuation=X(pe.punctuation).replace(/punctuation/g,pe._punctuation).getRegex(),pe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,pe.escapedEmSt=/\\\*|\\_/g,pe._comment=X(be._comment).replace("(?:-->|$)","-->").getRegex(),pe.emStrong.lDelim=X(pe.emStrong.lDelim).replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimAst=X(pe.emStrong.rDelimAst,"g").replace(/punct/g,pe._punctuation).getRegex(),pe.emStrong.rDelimUnd=X(pe.emStrong.rDelimUnd,"g").replace(/punct/g,pe._punctuation).getRegex(),pe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,pe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,pe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,pe.autolink=X(pe.autolink).replace("scheme",pe._scheme).replace("email",pe._email).getRegex(),pe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,pe.tag=X(pe.tag).replace("comment",pe._comment).replace("attribute",pe._attribute).getRegex(),pe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,pe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,pe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,pe.link=X(pe.link).replace("label",pe._label).replace("href",pe._href).replace("title",pe._title).getRegex(),pe.reflink=X(pe.reflink).replace("label",pe._label).getRegex(),pe.reflinkSearch=X(pe.reflinkSearch,"g").replace("reflink",pe.reflink).replace("nolink",pe.nolink).getRegex(),pe.normal=ge({},pe),pe.pedantic=ge({},pe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:X(/^!?\[(label)\]\((.*?)\)/).replace("label",pe._label).getRegex(),reflink:X(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",pe._label).getRegex()}),pe.gfm=ge({},pe.normal,{escape:X(pe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),pe.gfm.url=X(pe.gfm.url,"i").replace("email",pe.gfm._extended_email).getRegex(),pe.breaks=ge({},pe.gfm,{br:X(pe.br).replace("{2,}","*").getRegex(),text:X(pe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var fe={block:be,inline:pe},oe=ie,Ee=A.exports.defaults,Pe=fe.block,Oe=fe.inline,je=x.repeatString;function st(Ae){return Ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function et(Ae){var De="",ve,te,ne=Ae.length;for(ve=0;ve<ne;ve++)te=Ae.charCodeAt(ve),Math.random()>.5&&(te="x"+te.toString(16)),De+="&#"+te+";";return De}var tt=function(){function Ae(ve){this.tokens=[],this.tokens.links=Object.create(null),this.options=ve||Ee,this.options.tokenizer=this.options.tokenizer||new oe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var te={block:Pe.normal,inline:Oe.normal};this.options.pedantic?(te.block=Pe.pedantic,te.inline=Oe.pedantic):this.options.gfm&&(te.block=Pe.gfm,this.options.breaks?te.inline=Oe.breaks:te.inline=Oe.gfm),this.tokenizer.rules=te}Ae.lex=function(te,ne){var ue=new Ae(ne);return ue.lex(te)},Ae.lexInline=function(te,ne){var ue=new Ae(ne);return ue.inlineTokens(te)};var De=Ae.prototype;return De.lex=function(te){te=te.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(te,this.tokens);for(var ne;ne=this.inlineQueue.shift();)this.inlineTokens(ne.src,ne.tokens);return this.tokens},De.blockTokens=function(te,ne){var ue=this;ne===void 0&&(ne=[]),this.options.pedantic&&(te=te.replace(/^ +$/gm,""));for(var me,Te,He,Le;te;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ot){return(me=ot.call({lexer:ue},te,ne))?(te=te.substring(me.raw.length),ne.push(me),!0):!1}))){if(me=this.tokenizer.space(te)){te=te.substring(me.raw.length),me.type&&ne.push(me);continue}if(me=this.tokenizer.code(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me);continue}if(me=this.tokenizer.fences(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.heading(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.hr(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.blockquote(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.list(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.html(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.def(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.lheading(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(He=te,this.options.extensions&&this.options.extensions.startBlock&&function(){var ot=1/0,at=te.slice(1),Ne=void 0;ue.options.extensions.startBlock.forEach(function(ce){Ne=ce.call({lexer:this},at),typeof Ne=="number"&&Ne>=0&&(ot=Math.min(ot,Ne))}),ot<1/0&&ot>=0&&(He=te.substring(0,ot+1))}(),this.state.top&&(me=this.tokenizer.paragraph(He))){Te=ne[ne.length-1],Le&&Te.type==="paragraph"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me),Le=He.length!==te.length,te=te.substring(me.raw.length);continue}if(me=this.tokenizer.text(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+me.raw,Te.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):ne.push(me);continue}if(te){var Ge="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return this.state.top=!0,ne},De.inline=function(te,ne){this.inlineQueue.push({src:te,tokens:ne})},De.inlineTokens=function(te,ne){var ue=this;ne===void 0&&(ne=[]);var me,Te,He,Le=te,Ge,ot,at;if(this.tokens.links){var Ne=Object.keys(this.tokens.links);if(Ne.length>0)for(;(Ge=this.tokenizer.rules.inline.reflinkSearch.exec(Le))!=null;)Ne.includes(Ge[0].slice(Ge[0].lastIndexOf("[")+1,-1))&&(Le=Le.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ge=this.tokenizer.rules.inline.blockSkip.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"["+je("a",Ge[0].length-2)+"]"+Le.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ge=this.tokenizer.rules.inline.escapedEmSt.exec(Le))!=null;)Le=Le.slice(0,Ge.index)+"++"+Le.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;te;)if(ot||(at=""),ot=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(me=he.call({lexer:ue},te,ne))?(te=te.substring(me.raw.length),ne.push(me),!0):!1}))){if(me=this.tokenizer.escape(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.tag(te)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(me=this.tokenizer.link(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.reflink(te,this.tokens.links)){te=te.substring(me.raw.length),Te=ne[ne.length-1],Te&&me.type==="text"&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(me=this.tokenizer.emStrong(te,Le,at)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.codespan(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.br(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.del(te)){te=te.substring(me.raw.length),ne.push(me);continue}if(me=this.tokenizer.autolink(te,et)){te=te.substring(me.raw.length),ne.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(te,et))){te=te.substring(me.raw.length),ne.push(me);continue}if(He=te,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,re=te.slice(1),V=void 0;ue.options.extensions.startInline.forEach(function(we){V=we.call({lexer:this},re),typeof V=="number"&&V>=0&&(he=Math.min(he,V))}),he<1/0&&he>=0&&(He=te.substring(0,he+1))}(),me=this.tokenizer.inlineText(He,st)){te=te.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(at=me.raw.slice(-1)),ot=!0,Te=ne[ne.length-1],Te&&Te.type==="text"?(Te.raw+=me.raw,Te.text+=me.text):ne.push(me);continue}if(te){var ce="Infinite loop on byte: "+te.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return ne},e(Ae,null,[{key:"rules",get:function(){return{block:Pe,inline:Oe}}}]),Ae}(),H=A.exports.defaults,K=x.cleanUrl,z=x.escape,j=function(){function Ae(ve){this.options=ve||H}var De=Ae.prototype;return De.code=function(te,ne,ue){var me=(ne||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(te,me);Te!=null&&Te!==te&&(ue=!0,te=Te)}return te=te.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+z(me,!0)+'">'+(ue?te:z(te,!0))+`</code></pre>
`:"<pre><code>"+(ue?te:z(te,!0))+`</code></pre>
`},De.blockquote=function(te){return`<blockquote>
`+te+`</blockquote>
`},De.html=function(te){return te},De.heading=function(te,ne,ue,me){return this.options.headerIds?"<h"+ne+' id="'+this.options.headerPrefix+me.slug(ue)+'">'+te+"</h"+ne+`>
`:"<h"+ne+">"+te+"</h"+ne+`>
`},De.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},De.list=function(te,ne,ue){var me=ne?"ol":"ul",Te=ne&&ue!==1?' start="'+ue+'"':"";return"<"+me+Te+`>
`+te+"</"+me+`>
`},De.listitem=function(te){return"<li>"+te+`</li>
`},De.checkbox=function(te){return"<input "+(te?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},De.paragraph=function(te){return"<p>"+te+`</p>
`},De.table=function(te,ne){return ne&&(ne="<tbody>"+ne+"</tbody>"),`<table>
<thead>
`+te+`</thead>
`+ne+`</table>
`},De.tablerow=function(te){return`<tr>
`+te+`</tr>
`},De.tablecell=function(te,ne){var ue=ne.header?"th":"td",me=ne.align?"<"+ue+' align="'+ne.align+'">':"<"+ue+">";return me+te+"</"+ue+`>
`},De.strong=function(te){return"<strong>"+te+"</strong>"},De.em=function(te){return"<em>"+te+"</em>"},De.codespan=function(te){return"<code>"+te+"</code>"},De.br=function(){return this.options.xhtml?"<br/>":"<br>"},De.del=function(te){return"<del>"+te+"</del>"},De.link=function(te,ne,ue){if(te=K(this.options.sanitize,this.options.baseUrl,te),te===null)return ue;var me='<a href="'+z(te)+'"';return ne&&(me+=' title="'+ne+'"'),me+=">"+ue+"</a>",me},De.image=function(te,ne,ue){if(te=K(this.options.sanitize,this.options.baseUrl,te),te===null)return ue;var me='<img src="'+te+'" alt="'+ue+'"';return ne&&(me+=' title="'+ne+'"'),me+=this.options.xhtml?"/>":">",me},De.text=function(te){return te},Ae}(),Y=function(){function Ae(){}var De=Ae.prototype;return De.strong=function(te){return te},De.em=function(te){return te},De.codespan=function(te){return te},De.del=function(te){return te},De.html=function(te){return te},De.text=function(te){return te},De.link=function(te,ne,ue){return""+ue},De.image=function(te,ne,ue){return""+ue},De.br=function(){return""},Ae}(),ae=function(){function Ae(){this.seen={}}var De=Ae.prototype;return De.serialize=function(te){return te.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},De.getNextSafeSlug=function(te,ne){var ue=te,me=0;if(this.seen.hasOwnProperty(ue)){me=this.seen[te];do me++,ue=te+"-"+me;while(this.seen.hasOwnProperty(ue))}return ne||(this.seen[te]=me,this.seen[ue]=0),ue},De.slug=function(te,ne){ne===void 0&&(ne={});var ue=this.serialize(te);return this.getNextSafeSlug(ue,ne.dryrun)},Ae}(),Se=j,xe=Y,Ve=ae,Qe=A.exports.defaults,nt=x.unescape,rt=function(){function Ae(ve){this.options=ve||Qe,this.options.renderer=this.options.renderer||new Se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new xe,this.slugger=new Ve}Ae.parse=function(te,ne){var ue=new Ae(ne);return ue.parse(te)},Ae.parseInline=function(te,ne){var ue=new Ae(ne);return ue.parseInline(te)};var De=Ae.prototype;return De.parse=function(te,ne){ne===void 0&&(ne=!0);var ue="",me,Te,He,Le,Ge,ot,at,Ne,ce,he,re,V,we,Re,We,ze,mt,Et,_t,dt=te.length;for(me=0;me<dt;me++){if(he=te[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(_t=this.options.extensions.renderers[he.type].call({parser:this},he),_t!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){ue+=_t||"";continue}switch(he.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(he.tokens),he.depth,nt(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(Ne="",at="",Le=he.header.length,Te=0;Te<Le;Te++)at+=this.renderer.tablecell(this.parseInline(he.header[Te].tokens),{header:!0,align:he.align[Te]});for(Ne+=this.renderer.tablerow(at),ce="",Le=he.rows.length,Te=0;Te<Le;Te++){for(ot=he.rows[Te],at="",Ge=ot.length,He=0;He<Ge;He++)at+=this.renderer.tablecell(this.parseInline(ot[He].tokens),{header:!1,align:he.align[He]});ce+=this.renderer.tablerow(at)}ue+=this.renderer.table(Ne,ce);continue}case"blockquote":{ce=this.parse(he.tokens),ue+=this.renderer.blockquote(ce);continue}case"list":{for(re=he.ordered,V=he.start,we=he.loose,Le=he.items.length,ce="",Te=0;Te<Le;Te++)We=he.items[Te],ze=We.checked,mt=We.task,Re="",We.task&&(Et=this.renderer.checkbox(ze),we?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Et+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Et+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Et}):Re+=Et),Re+=this.parse(We.tokens,we),ce+=this.renderer.listitem(Re,mt,ze);ue+=this.renderer.list(ce,re,V);continue}case"html":{ue+=this.renderer.html(he.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(ce=he.tokens?this.parseInline(he.tokens):he.text;me+1<dt&&te[me+1].type==="text";)he=te[++me],ce+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);ue+=ne?this.renderer.paragraph(ce):ce;continue}default:{var vt='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(vt);return}else throw new Error(vt)}}}return ue},De.parseInline=function(te,ne){ne=ne||this.renderer;var ue="",me,Te,He,Le=te.length;for(me=0;me<Le;me++){if(Te=te[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(He=this.options.extensions.renderers[Te.type].call({parser:this},Te),He!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){ue+=He||"";continue}switch(Te.type){case"escape":{ue+=ne.text(Te.text);break}case"html":{ue+=ne.html(Te.text);break}case"link":{ue+=ne.link(Te.href,Te.title,this.parseInline(Te.tokens,ne));break}case"image":{ue+=ne.image(Te.href,Te.title,Te.text);break}case"strong":{ue+=ne.strong(this.parseInline(Te.tokens,ne));break}case"em":{ue+=ne.em(this.parseInline(Te.tokens,ne));break}case"codespan":{ue+=ne.codespan(Te.text);break}case"br":{ue+=ne.br();break}case"del":{ue+=ne.del(this.parseInline(Te.tokens,ne));break}case"text":{ue+=ne.text(Te.text);break}default:{var Ge='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ge);return}else throw new Error(Ge)}}}return ue},Ae}(),Je=tt,Ze=rt,pt=ie,Fe=j,At=Y,G=ae,Q=x.merge,de=x.checkSanitizeDeprecation,Ue=x.escape,qe=A.exports.getDefaults,lt=A.exports.changeDefaults,ht=A.exports.defaults;function Ye(Ae,De,ve){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");if(typeof De=="function"&&(ve=De,De=null),De=Q({},Ye.defaults,De||{}),de(De),ve){var te=De.highlight,ne;try{ne=Je.lex(Ae,De)}catch(He){return ve(He)}var ue=function(Le){var Ge;if(!Le)try{De.walkTokens&&Ye.walkTokens(ne,De.walkTokens),Ge=Ze.parse(ne,De)}catch(ot){Le=ot}return De.highlight=te,Le?ve(Le):ve(null,Ge)};if(!te||te.length<3||(delete De.highlight,!ne.length))return ue();var me=0;Ye.walkTokens(ne,function(He){He.type==="code"&&(me++,setTimeout(function(){te(He.text,He.lang,function(Le,Ge){if(Le)return ue(Le);Ge!=null&&Ge!==He.text&&(He.text=Ge,He.escaped=!0),me--,me===0&&ue()})},0))}),me===0&&ue();return}try{var Te=Je.lex(Ae,De);return De.walkTokens&&Ye.walkTokens(Te,De.walkTokens),Ze.parse(Te,De)}catch(He){if(He.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(He.message+"",!0)+"</pre>";throw He}}Ye.options=Ye.setOptions=function(Ae){return Q(Ye.defaults,Ae),lt(Ye.defaults),Ye},Ye.getDefaults=qe,Ye.defaults=ht,Ye.use=function(){for(var Ae=this,De=arguments.length,ve=new Array(De),te=0;te<De;te++)ve[te]=arguments[te];var ne=Q.apply(void 0,[{}].concat(ve)),ue=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;ve.forEach(function(Te){if(Te.extensions&&(me=!0,Te.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var Ge=ue.renderers?ue.renderers[Le.name]:null;Ge?ue.renderers[Le.name]=function(){for(var ot=arguments.length,at=new Array(ot),Ne=0;Ne<ot;Ne++)at[Ne]=arguments[Ne];var ce=Le.renderer.apply(this,at);return ce===!1&&(ce=Ge.apply(this,at)),ce}:ue.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[Le.level]?ue[Le.level].unshift(Le.tokenizer):ue[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?ue.startBlock?ue.startBlock.push(Le.start):ue.startBlock=[Le.start]:Le.level==="inline"&&(ue.startInline?ue.startInline.push(Le.start):ue.startInline=[Le.start]))}Le.childTokens&&(ue.childTokens[Le.name]=Le.childTokens)})),Te.renderer&&function(){var Le=Ye.defaults.renderer||new Fe,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var he=arguments.length,re=new Array(he),V=0;V<he;V++)re[V]=arguments[V];var we=Te.renderer[Ne].apply(Le,re);return we===!1&&(we=ce.apply(Le,re)),we}};for(var ot in Te.renderer)Ge(ot);ne.renderer=Le}(),Te.tokenizer&&function(){var Le=Ye.defaults.tokenizer||new pt,Ge=function(Ne){var ce=Le[Ne];Le[Ne]=function(){for(var he=arguments.length,re=new Array(he),V=0;V<he;V++)re[V]=arguments[V];var we=Te.tokenizer[Ne].apply(Le,re);return we===!1&&(we=ce.apply(Le,re)),we}};for(var ot in Te.tokenizer)Ge(ot);ne.tokenizer=Le}(),Te.walkTokens){var He=Ye.defaults.walkTokens;ne.walkTokens=function(Le){Te.walkTokens.call(Ae,Le),He&&He(Le)}}me&&(ne.extensions=ue),Ye.setOptions(ne)})},Ye.walkTokens=function(Ae,De){for(var ve=function(){var me=ne.value;switch(De(me),me.type){case"table":{for(var Te=_(me.header),He;!(He=Te()).done;){var Le=He.value;Ye.walkTokens(Le.tokens,De)}for(var Ge=_(me.rows),ot;!(ot=Ge()).done;)for(var at=ot.value,Ne=_(at),ce;!(ce=Ne()).done;){var he=ce.value;Ye.walkTokens(he.tokens,De)}break}case"list":{Ye.walkTokens(me.items,De);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(re){Ye.walkTokens(me[re],De)}):me.tokens&&Ye.walkTokens(me.tokens,De)}},te=_(Ae),ne;!(ne=te()).done;)ve()},Ye.parseInline=function(Ae,De){if(typeof Ae=="undefined"||Ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ae)+", string expected");De=Q({},Ye.defaults,De||{}),de(De);try{var ve=Je.lexInline(Ae,De);return De.walkTokens&&Ye.walkTokens(ve,De.walkTokens),Ze.parseInline(ve,De)}catch(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,De.silent)return"<p>An error occurred:</p><pre>"+Ue(te.message+"",!0)+"</pre>";throw te}},Ye.Parser=Ze,Ye.parser=Ze.parse,Ye.Renderer=Fe,Ye.TextRenderer=At,Ye.Lexer=Je,Ye.lexer=Je.lex,Ye.Tokenizer=pt,Ye.Slugger=G,Ye.parse=Ye;var kt=Ye;return kt}),define(ye[100],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function r(P,D,T){return Math.min(Math.max(P,D),T)}e.clamp=r;function t(P,D){return(D+P%D)%D}e.rot=t;class _{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=_;class A{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=A;class I{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const T=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=T,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=I}),function(){function ee(_){const A=[];typeof _=="number"&&A.push("code/timeOrigin",_);function I(D){A.push(D,Date.now())}function P(){const D=[];for(let T=0;T<A.length;T+=2)D.push({name:A[T],startTime:A[T+1]});return D}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(_){performance.mark(_)},getMarks(){let _=performance.timeOrigin;typeof _!="number"&&(_=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(_)}];for(const I of performance.getEntriesByType("mark"))A.push({name:I.name,startTime:Math.round(_+I.startTime)});return A}};if(typeof process=="object"){const _=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(_)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function r(_){return _.MonacoPerformanceMarks||(_.MonacoPerformanceMarks=e()),_.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=r(t))}(),define(ye[74],_e([0,1,17]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var t;(function(w){w.text="text/plain",w.binary="application/octet-stream",w.unknown="application/unknown",w.markdown="text/markdown",w.latex="text/latex"})(t=e.Mimes||(e.Mimes={}));const _={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(w){const i=(0,r.extname)(w),d=_[i.toLowerCase()];return d!==void 0?d:P(w)}e.getMediaOrTextMime=I;function P(w){const i=(0,r.extname)(w);return A[i.toLowerCase()]}e.getMediaMime=P;function D(w){for(const i in A)if(A[i]===w)return i}e.getExtensionForMimeType=D;const T=/^(.+)\/(.+?)(;.+)?$/;function R(w,i){const d=T.exec(w);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:i?void 0:w}e.normalizeMimeType=R}),define(ye[101],_e([0,1,15,6]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function _(b){const p=b;return p?[p.on,p.pause,p.resume,p.destroy].every(C=>typeof C=="function"):!1}e.isReadableStream=_;function A(b){const p=b;return p?_(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean":!1}e.isReadableBufferedStream=A;function I(b,p){return new P(b,p)}e.newWriteableStream=I;class P{constructor(p,C){this.reducer=p,this.options=C,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(C=>this.pendingWritePromises.push(C))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(C=>C(p))}emitError(p){this.listeners.error.length===0?(0,r.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(C=>C(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,C){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(C),this.resume();break;case"end":this.listeners.end.push(C),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(C),this.state.flowing&&this.flowErrors();break}}removeListener(p,C){if(this.state.destroyed)return;let a;switch(p){case"data":a=this.listeners.data;break;case"end":a=this.listeners.end;break;case"error":a=this.listeners.error;break}if(a){const M=a.indexOf(C);M>=0&&a.splice(M,1)}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const C=[...this.pendingWritePromises];this.pendingWritePromises.length=0,C.forEach(a=>a())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(b,p){const C=[];let a;for(;(a=b.read())!==null;)C.push(a);return p(C)}e.consumeReadable=D;function T(b,p,C){const a=[];let M;for(;(M=b.read())!==null&&a.length<C;)a.push(M);return M===null&&a.length>0?p(a):{read:()=>{if(a.length>0)return a.shift();if(typeof M!="undefined"){const o=M;return M=void 0,o}return b.read()}}}e.peekReadable=T;function R(b,p){return new Promise((C,a)=>{const M=[];w(b,{onData:o=>{p&&M.push(o)},onError:o=>{p?a(o):C(void 0)},onEnd:()=>{C(p?p(M):void 0)}})})}e.consumeStream=R;function w(b,p){let C=!1;return b.on("error",a=>{C||p.onError(a)}),b.on("end",()=>{C||p.onEnd()}),b.on("data",a=>{C||p.onData(a)}),(0,t.toDisposable)(()=>C=!0)}e.listenStream=w;function i(b,p){return new Promise((C,a)=>{const M=new t.DisposableStore,o=[],n=c=>{if(o.push(c),o.length>p)return M.dispose(),b.pause(),C({stream:b,buffer:o,ended:!1})},u=c=>a(c),f=()=>C({stream:b,buffer:o,ended:!0});M.add((0,t.toDisposable)(()=>b.removeListener("error",u))),b.on("error",u),M.add((0,t.toDisposable)(()=>b.removeListener("end",f))),b.on("end",f),M.add((0,t.toDisposable)(()=>b.removeListener("data",n))),b.on("data",n)})}e.peekStream=i;function d(b,p){const C=I(p);return C.end(b),C}e.toStream=d;function l(){const b=I(()=>{throw new Error("not supported")});return b.end(),b}e.emptyStream=l;function s(b){let p=!1;return{read:()=>p?null:(p=!0,b)}}e.toReadable=s;function m(b,p,C){const a=I(C);return w(b,{onData:M=>a.write(p.data(M)),onError:M=>a.error(p.error?p.error(M):M),onEnd:()=>a.end()}),a}e.transform=m;function F(b,p,C){let a=!1;return{read:()=>{const M=p.read();return a?M:(a=!0,M!==null?C([b,M]):b)}}}e.prefixedReadable=F;function S(b,p,C){let a=!1;const M=I(C);return w(p,{onData:o=>a?M.write(o):(a=!0,M.write(C([b,o]))),onError:o=>M.error(o),onEnd:()=>{a||(a=!0,M.write(b)),M.end()}}),M}e.prefixedStream=S}),define(ye[21],_e([0,1,101]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let _,A;class I{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return t?new I(Buffer.allocUnsafe(h)):new I(new Uint8Array(h))}static wrap(h){return t&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new I(h)}static fromString(h,g){return!(g?.dontUseNodeBuffer||!1)&&t?new I(Buffer.from(h)):(_||(_=new TextEncoder),new I(_.encode(h)))}static fromByteArray(h){const g=I.alloc(h.length);for(let E=0,v=h.length;E<v;E++)g.buffer[E]=h[E];return g}static concat(h,g){if(typeof g=="undefined"){g=0;for(let k=0,x=h.length;k<x;k++)g+=h[k].byteLength}const E=I.alloc(g);let v=0;for(let k=0,x=h.length;k<x;k++){const N=h[k];E.set(N,v),v+=N.byteLength}return E}clone(){const h=I.alloc(this.byteLength);return h.set(this),h}toString(){return t?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(h,g){return new I(this.buffer.subarray(h,g))}set(h,g){if(h instanceof I)this.buffer.set(h.buffer,g);else if(h instanceof Uint8Array)this.buffer.set(h,g);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),g);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),g);else throw new Error("Unkown argument 'array'")}readUInt32BE(h){return T(this.buffer,h)}writeUInt32BE(h,g){R(this.buffer,h,g)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,g){i(this.buffer,h,g)}readUInt8(h){return d(this.buffer,h)}writeUInt8(h,g){l(this.buffer,h,g)}}e.VSBuffer=I;function P(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0}e.readUInt16LE=P;function D(c,h,g){c[g+0]=h&255,h=h>>>8,c[g+1]=h&255}e.writeUInt16LE=D;function T(c,h){return c[h]*2**24+c[h+1]*2**16+c[h+2]*2**8+c[h+3]}e.readUInt32BE=T;function R(c,h,g){c[g+3]=h,h=h>>>8,c[g+2]=h,h=h>>>8,c[g+1]=h,h=h>>>8,c[g]=h}e.writeUInt32BE=R;function w(c,h){return c[h+0]<<0>>>0|c[h+1]<<8>>>0|c[h+2]<<16>>>0|c[h+3]<<24>>>0}e.readUInt32LE=w;function i(c,h,g){c[g+0]=h&255,h=h>>>8,c[g+1]=h&255,h=h>>>8,c[g+2]=h&255,h=h>>>8,c[g+3]=h&255}e.writeUInt32LE=i;function d(c,h){return c[h]}e.readUInt8=d;function l(c,h,g){c[g]=h}e.writeUInt8=l;function s(c){return r.consumeReadable(c,h=>I.concat(h))}e.readableToBuffer=s;function m(c){return r.toReadable(c)}e.bufferToReadable=m;function F(c){return r.consumeStream(c,h=>I.concat(h))}e.streamToBuffer=F;async function S(c){return c.ended?I.concat(c.buffer):I.concat([...c.buffer,await F(c.stream)])}e.bufferedStreamToBuffer=S;function b(c){return r.toStream(c,h=>I.concat(h))}e.bufferToStream=b;function p(c){return r.transform(c,{data:h=>typeof h=="string"?I.fromString(h):I.wrap(h)},h=>I.concat(h))}e.streamToBufferReadableStream=p;function C(c){return r.newWriteableStream(h=>I.concat(h),c)}e.newWriteableBufferStream=C;function a(c,h){return r.prefixedReadable(c,h,g=>I.concat(g))}e.prefixedBufferReadable=a;function M(c,h){return r.prefixedStream(c,h,g=>I.concat(g))}e.prefixedBufferStream=M;function o(c){let h=0,g=0,E=0;const v=new Uint8Array(Math.floor(c.length/4*3)),k=N=>{switch(g){case 3:v[E++]=h|N,g=0;break;case 2:v[E++]=h|N>>>2,h=N<<6,g=3;break;case 1:v[E++]=h|N>>>4,h=N<<4,g=2;break;default:h=N<<2,g=1}};for(let N=0;N<c.length;N++){const y=c.charCodeAt(N);if(y>=65&&y<=90)k(y-65);else if(y>=97&&y<=122)k(y-97+26);else if(y>=48&&y<=57)k(y-48+52);else if(y===43||y===45)k(62);else if(y===47||y===95)k(63);else{if(y===61)break;throw new SyntaxError(`Unexpected base64 character ${c[N]}`)}}const x=E;for(;g>0;)k(0);return I.wrap(v).slice(0,x)}e.decodeBase64=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:c},h=!0,g=!1){const E=g?u:n;let v="";const k=c.byteLength%3;let x=0;for(;x<c.byteLength-k;x+=3){const N=c[x+0],y=c[x+1],L=c[x+2];v+=E[N>>>2],v+=E[(N<<4|y>>>4)&63],v+=E[(y<<2|L>>>6)&63],v+=E[L&63]}if(k===1){const N=c[x+0];v+=E[N>>>2],v+=E[N<<4&63],h&&(v+="==")}else if(k===2){const N=c[x+0],y=c[x+1];v+=E[N>>>2],v+=E[(N<<4|y>>>4)&63],v+=E[y<<2&63],h&&(v+="=")}return v}e.encodeBase64=f});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[22],_e([0,1,16,9]),function(ee,e,r,t){"use strict";var _,A,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(o,n,u){let f=o.get(n);return f===void 0&&(f=u,o.set(n,f)),f}e.getOrSet=P;function D(o){const n=[];return o.forEach((u,f)=>{n.push(`${f} => ${u}`)}),`Map(${o.size}) {${n.join(", ")}}`}e.mapToString=D;function T(o){const n=[];return o.forEach(u=>{n.push(u)}),`Set(${o.size}) {${n.join(", ")}}`}e.setToString=T;class R{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const u=n.charCodeAt(0),f=this._value.charCodeAt(this._pos);return u-f}value(){return this._value[this._pos]}}e.StringIterator=R;class w{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class i{constructor(n=!0,u=!0){this._splitOnBackslash=n,this._caseSensitive=u}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let u=n.length-1;u>=0;u--,this._valueLen--){const f=this._value.charCodeAt(u);if(!(f===47||this._splitOnBackslash&&f===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,t.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=i;var d;(function(o){o[o.Scheme=1]="Scheme",o[o.Authority=2]="Authority",o[o.Path=3]="Path",o[o.Query=4]="Query",o[o.Fragment=5]="Fragment"})(d||(d={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new i(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,t.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class s{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(o){o[o.Left=-1]="Left",o[o.Mid=0]="Mid",o[o.Right=1]="Right"})(m||(m={}));class F{constructor(n){this._iter=n}static forUris(n=()=>!1){return new F(new l(n))}static forPaths(n=!1){return new F(new i(void 0,!n))}static forStrings(){return new F(new R)}static forConfigKeys(){return new F(new w)}clear(){this._root=void 0}fill(n,u){if(u){const f=u.slice(0);(0,r.shuffle)(f);for(let c of f)this.set(c,n)}else{const f=n.slice(0);(0,r.shuffle)(f);for(let c of f)this.set(c[0],c[1])}}set(n,u){const f=this._iter.reset(n);let c;this._root||(this._root=new s,this._root.segment=f.value());const h=[];for(c=this._root;;){const E=f.cmp(c.segment);if(E>0)c.left||(c.left=new s,c.left.segment=f.value()),h.push([-1,c]),c=c.left;else if(E<0)c.right||(c.right=new s,c.right.segment=f.value()),h.push([1,c]),c=c.right;else if(f.hasNext())f.next(),c.mid||(c.mid=new s,c.mid.segment=f.value()),h.push([0,c]),c=c.mid;else break}const g=c.value;c.value=u,c.key=n;for(let E=h.length-1;E>=0;E--){const v=h[E][1];v.updateHeight();const k=v.balanceFactor();if(k<-1||k>1){const x=h[E][0],N=h[E+1][0];if(x===1&&N===1)h[E][1]=v.rotateLeft();else if(x===-1&&N===-1)h[E][1]=v.rotateRight();else if(x===1&&N===-1)v.right=h[E+1][1]=h[E+1][1].rotateRight(),h[E][1]=v.rotateLeft();else if(x===-1&&N===1)v.left=h[E+1][1]=h[E+1][1].rotateLeft(),h[E][1]=v.rotateRight();else throw new Error;if(E>0)switch(h[E-1][0]){case-1:h[E-1][1].left=h[E][1];break;case 1:h[E-1][1].right=h[E][1];break;case 0:h[E-1][1].mid=h[E][1];break}else this._root=h[0][1]}}return g}get(n){return this._getNode(n)?.value}_getNode(n){const u=this._iter.reset(n);let f=this._root;for(;f;){const c=u.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(u.hasNext())u.next(),f=f.mid;else break}return f}has(n){const u=this._getNode(n);return!(u?.value===void 0&&u?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,u){const f=this._iter.reset(n),c=[];let h=this._root;for(;h;){const g=f.cmp(h.segment);if(g>0)c.push([-1,h]),h=h.left;else if(g<0)c.push([1,h]),h=h.right;else if(f.hasNext())f.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(u?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this._min(h.right),{key:E,value:v,segment:k}=g;this._delete(g.key,!1),h.key=E,h.value=v,h.segment=k}else{const g=h.left??h.right;if(c.length>0){const[E,v]=c[c.length-1];switch(E){case-1:v.left=g;break;case 0:v.mid=g;break;case 1:v.right=g;break}}else this._root=g}for(let g=c.length-1;g>=0;g--){const E=c[g][1];E.updateHeight();const v=E.balanceFactor();if(v>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),c[g][1]=E.rotateLeft()):v<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),c[g][1]=E.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this._root=c[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const u=this._iter.reset(n);let f=this._root,c;for(;f;){const h=u.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(u.hasNext())u.next(),c=f.value||c,f=f.mid;else break}return f&&f.value||c}findSuperstr(n){const u=this._iter.reset(n);let f=this._root;for(;f;){const c=u.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(u.hasNext())u.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(n){for(const[u,f]of this)n(f,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){!n||(n.left&&(yield*this._entries(n.left)),n.value&&(yield[n.key,n.value]),n.mid&&(yield*this._entries(n.mid)),n.right&&(yield*this._entries(n.right)))}_isBalanced(){const n=u=>{if(!u)return!0;const f=u.balanceFactor();return f<-1||f>1?!1:n(u.left)&&n(u.right)};return n(this._root)}}e.TernarySearchTree=F;class S{constructor(n,u){this.uri=n,this.value=u}}class b{constructor(n,u){this[_]="ResourceMap",n instanceof b?(this.map=new Map(n.map),this.toKey=u??b.defaultToKey):(this.map=new Map,this.toKey=n??b.defaultToKey)}set(n,u){return this.map.set(this.toKey(n),new S(n,u)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,u){typeof u!="undefined"&&(n=n.bind(u));for(let[f,c]of this.map)n(c.value,c.uri,this)}*values(){for(let n of this.map.values())yield n.value}*keys(){for(let n of this.map.values())yield n.uri}*entries(){for(let n of this.map.values())yield[n.uri,n.value]}*[(_=Symbol.toStringTag,Symbol.iterator)](){for(let[,n]of this.map)yield[n.uri,n.value]}}e.ResourceMap=b,b.defaultToKey=o=>o.toString();var p;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class C{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,u=0){const f=this._map.get(n);if(!!f)return u!==0&&this.touch(f,u),f.value}set(n,u,f=0){let c=this._map.get(n);if(c)c.value=u,f!==0&&this.touch(c,f);else{switch(c={key:n,value:u,next:void 0,previous:void 0},f){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(n,c),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this._map.get(n);if(!!u)return this._map.delete(n),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,u){const f=this._state;let c=this._head;for(;c;){if(u?n.bind(u)(c.value,c.key,this):n(c.value,c.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const n=this,u=this._state;let f=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.key,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return c}values(){const n=this,u=this._state;let f=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:f.value,done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return c}entries(){const n=this,u=this._state;let f=this._head;const c={[Symbol.iterator](){return c},next(){if(n._state!==u)throw new Error("LinkedMap got modified during iteration.");if(f){const h={value:[f.key,f.value],done:!1};return f=f.next,h}else return{value:void 0,done:!0}}};return c}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this._head,f=this.size;for(;u&&f>n;)this._map.delete(u.key),u=u.next,f--;this._head=u,this._size=f,u&&(u.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const u=n.next,f=n.previous;if(!u||!f)throw new Error("Invalid list");u.previous=f,f.next=u}n.next=void 0,n.previous=void 0,this._state++}touch(n,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this._head)return;const f=n.next,c=n.previous;n===this._tail?(c.next=void 0,this._tail=c):(f.previous=c,c.next=f),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(u===2){if(n===this._tail)return;const f=n.next,c=n.previous;n===this._head?(f.previous=void 0,this._head=f):(f.previous=c,c.next=f),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((u,f)=>{n.push([f,u])}),n}fromJSON(n){this.clear();for(const[u,f]of n)this.set(u,f)}}e.LinkedMap=C;class a extends C{constructor(n,u=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class M{constructor(n){I.set(this,void 0),Xe(this,I,n,"f")}get size(){return Ie(this,I,"f").size}forEach(n,u){Ie(this,I,"f").forEach(n,u)}get(n){return Ie(this,I,"f").get(n)}has(n){return Ie(this,I,"f").has(n)}entries(){return Ie(this,I,"f").entries()}keys(){return Ie(this,I,"f").keys()}values(){return Ie(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return Ie(this,I,"f").entries()}}e.ReadonlyMapView=M}),define(ye[102],_e([0,1,22,9]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function _(...z){return function(j,Y){for(let ae=0,Se=z.length;ae<Se;ae++){const xe=z[ae](j,Y);if(xe)return xe}return null}}e.or=_,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(z,j,Y){if(!Y||Y.length<j.length)return null;let ae;return z?ae=t.startsWithIgnoreCase(Y,j):ae=Y.indexOf(j)===0,ae?j.length>0?[{start:0,end:j.length}]:[]:null}function I(z,j){const Y=j.toLowerCase().indexOf(z.toLowerCase());return Y===-1?null:[{start:Y,end:Y+z.length}]}e.matchesContiguousSubString=I;function P(z,j){return D(z.toLowerCase(),j.toLowerCase(),0,0)}e.matchesSubString=P;function D(z,j,Y,ae){if(Y===z.length)return[];if(ae===j.length)return null;if(z[Y]===j[ae]){let Se=null;return(Se=D(z,j,Y+1,ae+1))?F({start:ae,end:ae+1},Se):null}return D(z,j,Y,ae+1)}function T(z){return 97<=z&&z<=122}function R(z){return 65<=z&&z<=90}e.isUpper=R;function w(z){return 48<=z&&z<=57}function i(z){return z===32||z===9||z===10||z===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(z=>d.add(z.charCodeAt(0)));function l(z){return i(z)||d.has(z)}function s(z,j){return z===j||l(z)&&l(j)}function m(z){return T(z)||R(z)||w(z)}function F(z,j){return j.length===0?j=[z]:z.end===j[0].start?j[0].start=z.start:j.unshift(z),j}function S(z,j){for(let Y=j;Y<z.length;Y++){const ae=z.charCodeAt(Y);if(R(ae)||w(ae)||Y>0&&!m(z.charCodeAt(Y-1)))return Y}return z.length}function b(z,j,Y,ae){if(Y===z.length)return[];if(ae===j.length)return null;if(z[Y]!==j[ae].toLowerCase())return null;{let Se=null,xe=ae+1;for(Se=b(z,j,Y+1,ae+1);!Se&&(xe=S(j,xe))<j.length;)Se=b(z,j,Y+1,xe),xe++;return Se===null?null:F({start:ae,end:ae+1},Se)}}function p(z){let j=0,Y=0,ae=0,Se=0,xe=0;for(let Je=0;Je<z.length;Je++)xe=z.charCodeAt(Je),R(xe)&&j++,T(xe)&&Y++,m(xe)&&ae++,w(xe)&&Se++;const Ve=j/z.length,Qe=Y/z.length,nt=ae/z.length,rt=Se/z.length;return{upperPercent:Ve,lowerPercent:Qe,alphaPercent:nt,numericPercent:rt}}function C(z){const{upperPercent:j,lowerPercent:Y}=z;return Y===0&&j>.6}function a(z){const{upperPercent:j,lowerPercent:Y,alphaPercent:ae,numericPercent:Se}=z;return Y>.2&&j<.8&&ae>.6&&Se<.2}function M(z){let j=0,Y=0,ae=0,Se=0;for(let xe=0;xe<z.length;xe++)ae=z.charCodeAt(xe),R(ae)&&j++,T(ae)&&Y++,i(ae)&&Se++;return(j===0||Y===0)&&Se===0?z.length<=30:j<=5}function o(z,j){if(!j||(j=j.trim(),j.length===0)||!M(z)||j.length>60)return null;const Y=p(j);if(!a(Y)){if(!C(Y))return null;j=j.toLowerCase()}let ae=null,Se=0;for(z=z.toLowerCase();Se<j.length&&(ae=b(z,j,0,Se))===null;)Se=S(j,Se+1);return ae}e.matchesCamelCase=o;function n(z,j,Y=!1){if(!j||j.length===0)return null;let ae=null,Se=0;for(z=z.toLowerCase(),j=j.toLowerCase();Se<j.length&&(ae=u(z,j,0,Se,Y))===null;)Se=f(j,Se+1);return ae}e.matchesWords=n;function u(z,j,Y,ae,Se){if(Y===z.length)return[];if(ae===j.length)return null;if(s(z.charCodeAt(Y),j.charCodeAt(ae))){let xe=null,Ve=ae+1;if(xe=u(z,j,Y+1,ae+1,Se),!Se)for(;!xe&&(Ve=f(j,Ve))<j.length;)xe=u(z,j,Y+1,Ve,Se),Ve++;return xe===null?null:F({start:ae,end:ae+1},xe)}else return null}function f(z,j){for(let Y=j;Y<z.length;Y++)if(l(z.charCodeAt(Y))||Y>0&&l(z.charCodeAt(Y-1)))return Y;return z.length}const c=_(e.matchesPrefix,o,I),h=_(e.matchesPrefix,o,P),g=new r.LRUCache(1e4);function E(z,j,Y=!1){if(typeof z!="string"||typeof j!="string")return null;let ae=g.get(z);ae||(ae=new RegExp(t.convertSimple2RegExpPattern(z),"i"),g.set(z,ae));const Se=ae.exec(j);return Se?[{start:Se.index,end:Se.index+Se[0].length}]:Y?h(z,j):c(z,j)}e.matchesFuzzy=E;function v(z,j){const Y=Oe(z,z.toLowerCase(),0,j,j.toLowerCase(),0,!0);return Y?x(Y):null}e.matchesFuzzy2=v;function k(z,j,Y,ae,Se,xe){const Ve=Math.min(13,z.length);for(;Y<Ve;Y++){const Qe=Oe(z,j,Y,ae,Se,xe,!1);if(Qe)return Qe}return[0,xe]}e.anyScore=k;function x(z){if(typeof z=="undefined")return[];const j=[],Y=z[1];for(let ae=z.length-1;ae>1;ae--){const Se=z[ae]+Y,xe=j[j.length-1];xe&&xe.end===Se?xe.end=Se+1:j.push({start:Se,end:Se+1})}return j}e.createMatches=x;const N=128;function y(){const z=[],j=[];for(let Y=0;Y<=N;Y++)j[Y]=0;for(let Y=0;Y<=N;Y++)z.push(j.slice(0));return z}function L(z){const j=[];for(let Y=0;Y<=z;Y++)j[Y]=0;return j}const W=L(2*N),B=L(2*N),$=y(),q=y(),ie=y(),se=!1;function X(z,j,Y,ae,Se){function xe(Qe,nt,rt=" "){for(;Qe.length<nt;)Qe=rt+Qe;return Qe}let Ve=` |   |${ae.split("").map(Qe=>xe(Qe,3)).join("|")}
`;for(let Qe=0;Qe<=Y;Qe++)Qe===0?Ve+=" |":Ve+=`${j[Qe-1]}|`,Ve+=z[Qe].slice(0,Se+1).map(nt=>xe(nt.toString(),3)).join("|")+`
`;return Ve}function ge(z,j,Y,ae){z=z.substr(j),Y=Y.substr(ae),console.log(X(q,z,z.length,Y,Y.length)),console.log(X(ie,z,z.length,Y,Y.length)),console.log(X($,z,z.length,Y,Y.length))}function be(z,j){if(j<0||j>=z.length)return!1;const Y=z.codePointAt(j);switch(Y){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!t.isEmojiImprecise(Y)}}function pe(z,j){if(j<0||j>=z.length)return!1;switch(z.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function fe(z,j,Y){return j[z]!==Y[z]}function oe(z,j,Y,ae,Se,xe,Ve=!1){for(;j<Y&&Se<xe;)z[j]===ae[Se]&&(Ve&&(W[j]=Se),j+=1),Se+=1;return j===Y}e.isPatternInWord=oe;var Ee;(function(z){z[z.Diag=1]="Diag",z[z.Left=2]="Left",z[z.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var Pe;(function(z){z.Default=[-100,0];function j(Y){return!Y||Y.length===2&&Y[0]===-100&&Y[1]===0}z.isDefault=j})(Pe=e.FuzzyScore||(e.FuzzyScore={}));function Oe(z,j,Y,ae,Se,xe,Ve){const Qe=z.length>N?N:z.length,nt=ae.length>N?N:ae.length;if(Y>=Qe||xe>=nt||Qe-Y>nt-xe||!oe(j,Y,Qe,Se,xe,nt,!0))return;je(Qe,nt,Y,xe,j,Se);let rt=1,Je=1,Ze=Y,pt=xe;const Fe=[!1];for(rt=1,Ze=Y;Ze<Qe;rt++,Ze++){const Ue=W[Ze],qe=B[Ze],lt=Ze+1<Qe?B[Ze+1]:nt;for(Je=Ue-xe+1,pt=Ue;pt<lt;Je++,pt++){let ht=Number.MIN_SAFE_INTEGER,Ye=!1;pt<=qe&&(ht=st(z,j,Ze,Y,ae,Se,pt,nt,xe,$[rt-1][Je-1]===0,Fe));let kt=0;ht!==Number.MAX_SAFE_INTEGER&&(Ye=!0,kt=ht+q[rt-1][Je-1]);const Ae=pt>Ue,De=Ae?q[rt][Je-1]+($[rt][Je-1]>0?-5:0):0,ve=pt>Ue+1&&$[rt][Je-1]>0,te=ve?q[rt][Je-2]+($[rt][Je-2]>0?-5:0):0;if(ve&&(!Ae||te>=De)&&(!Ye||te>=kt))q[rt][Je]=te,ie[rt][Je]=3,$[rt][Je]=0;else if(Ae&&(!Ye||De>=kt))q[rt][Je]=De,ie[rt][Je]=2,$[rt][Je]=0;else if(Ye)q[rt][Je]=kt,ie[rt][Je]=1,$[rt][Je]=$[rt-1][Je-1]+1;else throw new Error("not possible")}}if(se&&ge(z,Y,ae,xe),!Fe[0]&&!Ve)return;rt--,Je--;const At=[q[rt][Je],xe];let G=0,Q=0;for(;rt>=1;){let Ue=Je;do{const qe=ie[rt][Ue];if(qe===3)Ue=Ue-2;else if(qe===2)Ue=Ue-1;else break}while(Ue>=1);G>1&&j[Y+rt-1]===Se[xe+Je-1]&&!fe(Ue+xe-1,ae,Se)&&G+1>$[rt][Ue]&&(Ue=Je),Ue===Je?G++:G=1,Q||(Q=Ue),rt--,Je=Ue-1,At.push(Je)}nt===Qe&&(At[0]+=2);const de=Q-Qe;return At[0]-=de,At}e.fuzzyScore=Oe;function je(z,j,Y,ae,Se,xe){let Ve=z-1,Qe=j-1;for(;Ve>=Y&&Qe>=ae;)Se[Ve]===xe[Qe]&&(B[Ve]=Qe,Ve--),Qe--}function st(z,j,Y,ae,Se,xe,Ve,Qe,nt,rt,Je){if(j[Y]!==xe[Ve])return Number.MIN_SAFE_INTEGER;let Ze=1,pt=!1;return Ve===Y-ae?Ze=z[Y]===Se[Ve]?7:5:fe(Ve,Se,xe)&&(Ve===0||!fe(Ve-1,Se,xe))?(Ze=z[Y]===Se[Ve]?7:5,pt=!0):be(xe,Ve)&&(Ve===0||!be(xe,Ve-1))?Ze=5:(be(xe,Ve-1)||pe(xe,Ve-1))&&(Ze=5,pt=!0),Ze>1&&Y===ae&&(Je[0]=!0),pt||(pt=fe(Ve,Se,xe)||be(xe,Ve-1)||pe(xe,Ve-1)),Y===ae?Ve>nt&&(Ze-=pt?3:5):rt?Ze+=pt?2:0:Ze+=pt?0:1,Ve+1===Qe&&(Ze-=pt?3:5),Ze}function et(z,j,Y,ae,Se,xe,Ve){return H(z,j,Y,ae,Se,xe,!0,Ve)}e.fuzzyScoreGracefulAggressive=et;function tt(z,j,Y,ae,Se,xe,Ve){return H(z,j,Y,ae,Se,xe,!1,Ve)}e.fuzzyScoreGraceful=tt;function H(z,j,Y,ae,Se,xe,Ve,Qe){let nt=Oe(z,j,Y,ae,Se,xe,Qe);if(nt&&!Ve)return nt;if(z.length>=3){const rt=Math.min(7,z.length-1);for(let Je=Y+1;Je<rt;Je++){const Ze=K(z,Je);if(Ze){const pt=Oe(Ze,Ze.toLowerCase(),Y,ae,Se,xe,Qe);pt&&(pt[0]-=3,(!nt||pt[0]>nt[0])&&(nt=pt))}}}return nt}function K(z,j){if(j+1>=z.length)return;const Y=z[j],ae=z[j+1];if(Y!==ae)return z.slice(0,j)+ae+Y+z.slice(j+2)}}),define(ye[103],_e([0,1,52,102,9]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(r.CSSIcon.iconNameCharacter),P=new RegExp(`(\\\\)?${A.source}`,"g");function D(m){return m.replace(P,(F,S)=>S?F:`\\${F}`)}e.escapeIcons=D;const T=new RegExp(`\\\\${A.source}`,"g");function R(m){return m.replace(T,F=>`\\${F}`)}e.markdownEscapeEscapedIcons=R;const w=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function i(m){return m.indexOf(e.iconStartMarker)===-1?m:m.replace(w,(F,S,b,p)=>b?F:S||p||"")}e.stripIcons=i;function d(m){const F=m.indexOf(e.iconStartMarker);return F===-1?{text:m}:l(m,F)}e.parseLabelWithIcons=d;function l(m,F){const S=[];let b="";function p(c){if(c){b+=c;for(const h of c)S.push(M)}}let C=-1,a="",M=0,o,n,u=F;const f=m.length;for(p(m.substr(0,F));u<f;)o=m[u],n=m[u+1],o===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(C=u,p(a),a=e.iconStartMarker,u++):o===")"&&C!==-1?(M+=u-C+1,C=-1,a=""):C!==-1?I.test(o)?a+=o:(p(a),C=-1,a=""):p(o),u++;return p(a),{text:b,iconOffsets:S}}function s(m,F,S=!1){const{text:b,iconOffsets:p}=F;if(!p||p.length===0)return(0,t.matchesFuzzy)(m,b,S);const C=(0,_.ltrim)(b," "),a=b.length-C.length,M=(0,t.matchesFuzzy)(m,C,S);if(M)for(const o of M){const n=p[o.start+a]+a;o.start+=n,o.end+=n}return M}e.matchesFuzzyIconAware=s}),define(ye[75],_e([0,1,15,103]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var _;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(_=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(d="",l=!1){if(this.value=d,typeof this.value!="string")throw(0,r.illegalArgument)("value");typeof l=="boolean"?(this.isTrusted=l,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=l.isTrusted??void 0,this.supportThemeIcons=l.supportThemeIcons??!1,this.supportHtml=l.supportHtml??!1)}appendText(d,l=0){return this.value+=T(this.supportThemeIcons?(0,t.escapeIcons)(d):d).replace(/([ \t]+)/g,(s,m)=>"&nbsp;".repeat(m.length)).replace(/\>/gm,"\\>").replace(/\n/g,l===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,l){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=l,this.value+="\n```\n",this}}e.MarkdownString=A;function I(i){return P(i)?!i.value:Array.isArray(i)?i.every(I):!0}e.isEmptyMarkdownString=I;function P(i){return i instanceof A?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function D(i,d){return i===d?!0:!i||!d?!1:i.value===d.value&&i.isTrusted===d.isTrusted&&i.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=D;function T(i){return i.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=T;function R(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=R;function w(i){const d=[],l=i.split("|").map(m=>m.trim());i=l[0];const s=l[1];if(s){const m=/height=(\d+)/.exec(s),F=/width=(\d+)/.exec(s),S=m?m[1]:"",b=F?F[1]:"",p=isFinite(parseInt(b)),C=isFinite(parseInt(S));p&&d.push(`width="${b}"`),C&&d.push(`height="${S}"`)}return{href:i,dimensions:d}}e.parseHrefAndDimensions=w}),define(ye[34],_e([0,1,9]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var t;(function(_){_[_.Ignore=0]="Ignore",_[_.Info=1]="Info",_[_.Warning=2]="Warning",_[_.Error=3]="Error"})(t||(t={})),function(_){const A="error",I="warning",P="warn",D="info",T="ignore";function R(i){return i?r.equalsIgnoreCase(A,i)?_.Error:r.equalsIgnoreCase(I,i)||r.equalsIgnoreCase(P,i)?_.Warning:r.equalsIgnoreCase(D,i)?_.Info:_.Ignore:_.Ignore}_.fromValue=R;function w(i){switch(i){case _.Error:return A;case _.Warning:return I;case _.Info:return D;default:return T}}_.toString=w}(t||(t={})),e.default=t}),define(ye[35],_e([0,1,17,23,9,10]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(u){return u===47||u===92}e.isPathSeparator=I;function P(u){return u.replace(/[\\/]/g,r.posix.sep)}e.toSlashes=P;function D(u){return u.indexOf("/")===-1&&(u=P(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=D;function T(u,f=r.posix.sep){if(!u)return"";const c=u.length,h=u.charCodeAt(0);if(I(h)){if(I(u.charCodeAt(1))&&!I(u.charCodeAt(2))){let E=3;const v=E;for(;E<c&&!I(u.charCodeAt(E));E++);if(v!==E&&!I(u.charCodeAt(E+1))){for(E+=1;E<c;E++)if(I(u.charCodeAt(E)))return u.slice(0,E+1).replace(/[\\/]/g,f)}}return f}else if(F(h)&&u.charCodeAt(1)===58)return I(u.charCodeAt(2))?u.slice(0,2)+f:u.slice(0,2);let g=u.indexOf("://");if(g!==-1){for(g+=3;g<c;g++)if(I(u.charCodeAt(g)))return u.slice(0,g+1)}return""}e.getRoot=T;function R(u){if(!t.isWindows||!u||u.length<5)return!1;let f=u.charCodeAt(0);if(f!==92||(f=u.charCodeAt(1),f!==92))return!1;let c=2;const h=c;for(;c<u.length&&(f=u.charCodeAt(c),f!==92);c++);return!(h===c||(f=u.charCodeAt(c+1),isNaN(f)||f===92))}e.isUNC=R;const w=/[\\/:\*\?"<>\|]/g,i=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function l(u,f=t.isWindows){const c=f?w:i;return!(!u||u.length===0||/^\s+$/.test(u)||(c.lastIndex=0,c.test(u))||f&&d.test(u)||u==="."||u===".."||f&&u[u.length-1]==="."||f&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=l;function s(u,f,c){const h=u===f;return!c||h?h:!u||!f?!1:(0,_.equalsIgnoreCase)(u,f)}e.isEqual=s;function m(u,f,c,h=r.sep){if(u===f)return!0;if(!u||!f||f.length>u.length)return!1;if(c){if(!(0,_.startsWithIgnoreCase)(u,f))return!1;if(f.length===u.length)return!0;let E=f.length;return f.charAt(f.length-1)===h&&E--,u.charAt(E)===h}return f.charAt(f.length-1)!==h&&(f+=h),u.indexOf(f)===0}e.isEqualOrParent=m;function F(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=F;function S(u,f){return t.isWindows&&u.endsWith(":")&&(u+=r.sep),(0,r.isAbsolute)(u)||(u=(0,r.join)(f,u)),u=(0,r.normalize)(u),t.isWindows?(u=(0,_.rtrim)(u,r.sep),u.endsWith(":")&&(u+=r.sep)):(u=(0,_.rtrim)(u,r.sep),u||(u=r.sep)),u}e.sanitizeFilePath=S;function b(u){const f=(0,r.normalize)(u);return t.isWindows?u.length>3?!1:p(f)&&(u.length===2||f.charCodeAt(2)===92):f===r.posix.sep}e.isRootOrDriveLetter=b;function p(u,f){return(f!==void 0?f:t.isWindows)?F(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function C(u){return p(u)?u[0]:void 0}e.getDriveLetter=C;function a(u,f,c){return f.length>u.length?-1:u===f?0:(c&&(u=u.toLowerCase(),f=f.toLowerCase()),u.indexOf(f))}e.indexOfPath=a;function M(u){const f=u.split(":");let c,h,g;for(const E of f){const v=Number(E);(0,A.isNumber)(v)?h===void 0?h=v:g===void 0&&(g=v):c=c?[c,E].join(":"):E}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:g!==void 0?g:h!==void 0?1:void 0}}e.parseLineAndColumnAware=M;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(u,f,c=8){let h="";for(let E=0;E<c;E++)h+=o.charAt(Math.floor(Math.random()*o.length));let g;return f?g=`${f}-${h}`:g=h,u?(0,r.join)(u,g):g}e.randomPath=n}),define(ye[55],_e([0,1,21,9,2]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(R){return JSON.stringify(R,D)}e.stringify=A;function I(R){let w=JSON.parse(R);return w=T(w),w}e.parse=I;var P;(function(R){R[R.Uri=1]="Uri",R[R.Regexp=2]="Regexp",R[R.ScmResource=3]="ScmResource",R[R.ScmResourceGroup=4]="ScmResourceGroup",R[R.ScmProvider=5]="ScmProvider",R[R.CommentController=6]="CommentController",R[R.CommentThread=7]="CommentThread",R[R.CommentThreadReply=8]="CommentThreadReply",R[R.CommentNode=9]="CommentNode",R[R.CommentThreadNode=10]="CommentThreadNode",R[R.TimelineActionContext=11]="TimelineActionContext",R[R.NotebookCellActionContext=12]="NotebookCellActionContext",R[R.TestItemContext=13]="TestItemContext",R[R.Date=14]="Date"})(P=e.MarshalledId||(e.MarshalledId={}));function D(R,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,t.regExpFlags)(w)}:w}function T(R,w=0){if(!R||w>200)return R;if(typeof R=="object"){switch(R.$mid){case 1:return _.URI.revive(R);case 2:return new RegExp(R.source,R.flags);case 14:return new Date(R.source)}if(R instanceof r.VSBuffer||R instanceof Uint8Array)return R;if(Array.isArray(R))for(let i=0;i<R.length;++i)R[i]=T(R[i],w+1);else for(const i in R)Object.hasOwnProperty.call(R,i)&&(R[i]=T(R[i],w+1))}return R}e.revive=T}),define(ye[11],_e([0,1,23,2]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var _;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp",P.vsls="vsls"})(_=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,T,R){this._hosts[D]=T,this._ports[D]=R}setConnectionToken(D,T){this._connectionTokens[D]=T}rewrite(D){if(this._delegate)return this._delegate(D);const T=D.authority;let R=this._hosts[T];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const w=this._ports[T],i=this._connectionTokens[T];let d=`path=${encodeURIComponent(D.path)}`;return typeof i=="string"&&(d+=`&tkn=${encodeURIComponent(i)}`),t.URI.from({scheme:r.isWeb?this._preferredWebSchema:_.vscodeRemoteResource,authority:`${R}:${w}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new A;class I{asBrowserUri(D,T){const R=this.toUri(D,T);return R.scheme===_.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===_.file&&(r.isNative||typeof r.globals.importScripts=="function"&&r.globals.origin===`${_.vscodeFileResource}://${I.FALLBACK_AUTHORITY}`)?R.with({scheme:_.vscodeFileResource,authority:R.authority||I.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(D,T){const R=this.toUri(D,T);return R.scheme===_.vscodeFileResource?R.with({scheme:_.file,authority:R.authority!==I.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(D,T){return t.URI.isUri(D)?D:t.URI.parse(T.toUrl(D))}}I.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new I}),define(ye[24],_e([0,1,35,11,17,23,9,2]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=D;class T{constructor(l){this._ignorePathCasing=l}compare(l,s,m=!1){return l===s?0:(0,I.compare)(this.getComparisonKey(l,m),this.getComparisonKey(s,m))}isEqual(l,s,m=!1){return l===s?!0:!l||!s?!1:this.getComparisonKey(l,m)===this.getComparisonKey(s,m)}getComparisonKey(l,s=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,s,m=!1){if(l.scheme===s.scheme){if(l.scheme===t.Schemas.file)return r.isEqualOrParent(D(l),D(s),this._ignorePathCasing(l))&&l.query===s.query&&(m||l.fragment===s.fragment);if((0,e.isEqualAuthority)(l.authority,s.authority))return r.isEqualOrParent(l.path,s.path,this._ignorePathCasing(l),"/")&&l.query===s.query&&(m||l.fragment===s.fragment)}return!1}joinPath(l,...s){return P.URI.joinPath(l,...s)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return _.posix.basename(l.path)}extname(l){return _.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let s;return l.scheme===t.Schemas.file?s=P.URI.file(_.dirname(D(l))).path:(s=_.posix.dirname(l.path),l.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),s="/")),l.with({path:s})}normalizePath(l){if(!l.path.length)return l;let s;return l.scheme===t.Schemas.file?s=P.URI.file(_.normalize(D(l))).path:s=_.posix.normalize(l.path),l.with({path:s})}relativePath(l,s){if(l.scheme!==s.scheme||!(0,e.isEqualAuthority)(l.authority,s.authority))return;if(l.scheme===t.Schemas.file){const S=_.relative(D(l),D(s));return A.isWindows?r.toSlashes(S):S}let m=l.path||"/",F=s.path||"/";if(this._ignorePathCasing(l)){let S=0;for(const b=Math.min(m.length,F.length);S<b&&!(m.charCodeAt(S)!==F.charCodeAt(S)&&m.charAt(S).toLowerCase()!==F.charAt(S).toLowerCase());S++);m=F.substr(0,S)+m.substr(S)}return _.posix.relative(m,F)}resolvePath(l,s){if(l.scheme===t.Schemas.file){const m=P.URI.file(_.resolve(D(l),s));return l.with({authority:m.authority,path:m.path})}return s=r.toPosixPath(s),l.with({path:_.posix.resolve(l.path,s)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,s){return l===s||l!==void 0&&s!==void 0&&(0,I.equalsIgnoreCase)(l,s)}hasTrailingPathSeparator(l,s=_.sep){if(l.scheme===t.Schemas.file){const m=D(l);return m.length>r.getRoot(m).length&&m[m.length-1]===s}else{const m=l.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,s=_.sep){return(0,e.hasTrailingPathSeparator)(l,s)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,s=_.sep){let m=!1;if(l.scheme===t.Schemas.file){const F=D(l);m=F!==void 0&&F.length===r.getRoot(F).length&&F[F.length-1]===s}else{s="/";const F=l.path;m=F.length===1&&F.charCodeAt(F.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(l,s)?l.with({path:l.path+"/"}):l}}e.ExtUri=T,e.extUri=new T(()=>!1),e.extUriBiasedIgnorePathCase=new T(d=>d.scheme===t.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new T(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(d,l){const s=[];for(let m=0;m<d.length;m++){const F=l(d[m]);d.some((S,b)=>b===m?!1:(0,e.isEqualOrParent)(F,l(S)))||s.push(d[m])}return s}e.distinctParents=R;var w;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function l(s){const m=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(b=>{const[p,C]=b.split(":");p&&C&&m.set(p,C)});const S=s.path.substring(0,s.path.indexOf(";"));return S&&m.set(d.META_DATA_MIME,S),m}d.parseMetaData=l})(w=e.DataUri||(e.DataUri={}));function i(d,l,s){if(l){let m=d.path;return m&&m[0]!==_.posix.sep&&(m=_.posix.sep+m),d.with({scheme:s,authority:l,path:m})}return d.with({scheme:s})}e.toLocalResource=i}),define(ye[13],_e([0,1,20,15,4,6,24,23]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=D;function T(fe){const oe=new r.CancellationTokenSource,Ee=fe(oe.token),Pe=new Promise((Oe,je)=>{const st=oe.token.onCancellationRequested(()=>{st.dispose(),oe.dispose(),je(new t.CancellationError)});Promise.resolve(Ee).then(et=>{st.dispose(),oe.dispose(),Oe(et)},et=>{st.dispose(),oe.dispose(),je(et)})});return new class{cancel(){oe.cancel()}then(Oe,je){return Pe.then(Oe,je)}catch(Oe){return this.then(void 0,Oe)}finally(Oe){return Pe.finally(Oe)}}}e.createCancelablePromise=T;function R(fe,oe,Ee){return new Promise((Pe,Oe)=>{const je=oe.onCancellationRequested(()=>{je.dispose(),Pe(Ee)});fe.then(Pe,Oe).finally(()=>je.dispose())})}e.raceCancellation=R;function w(fe,oe){return new Promise((Ee,Pe)=>{const Oe=oe.onCancellationRequested(()=>{Oe.dispose(),Pe(new t.CancellationError)});fe.then(Ee,Pe).finally(()=>Oe.dispose())})}e.raceCancellationError=w;async function i(fe){let oe=-1;const Ee=fe.map((Oe,je)=>Oe.then(st=>(oe=je,st))),Pe=await Promise.race(Ee);return fe.forEach((Oe,je)=>{je!==oe&&Oe.cancel()}),Pe}e.raceCancellablePromises=i;function d(fe,oe,Ee){let Pe;const Oe=setTimeout(()=>{Pe?.(void 0),Ee?.()},oe);return Promise.race([fe.finally(()=>clearTimeout(Oe)),new Promise(je=>Pe=je)])}e.raceTimeout=d;function l(fe){return new Promise((oe,Ee)=>{const Pe=fe();D(Pe)?Pe.then(oe,Ee):oe(Pe)})}e.asPromise=l;class s{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(oe){if(this.activePromise){if(this.queuedPromiseFactory=oe,!this.queuedPromise){const Ee=()=>{this.queuedPromise=null;const Pe=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Pe};this.queuedPromise=new Promise(Pe=>{this.activePromise.then(Ee,Ee).then(Pe)})}return new Promise((Ee,Pe)=>{this.queuedPromise.then(Ee,Pe)})}return this.activePromise=oe(),new Promise((Ee,Pe)=>{this.activePromise.then(Oe=>{this.activePromise=null,Ee(Oe)},Oe=>{this.activePromise=null,Pe(Oe)})})}}e.Throttler=s;class m{constructor(){this.current=Promise.resolve(null)}queue(oe){return this.current=this.current.then(()=>oe(),()=>oe())}}e.Sequencer=m;class F{constructor(){this.promiseMap=new Map}queue(oe,Ee){const Oe=(this.promiseMap.get(oe)??Promise.resolve()).catch(()=>{}).then(Ee).finally(()=>{this.promiseMap.get(oe)===Oe&&this.promiseMap.delete(oe)});return this.promiseMap.set(oe,Oe),Oe}}e.SequencerByKey=F;const S=(fe,oe)=>{let Ee=!0;const Pe=setTimeout(()=>{Ee=!1,oe()},fe);return{isTriggered:()=>Ee,dispose:()=>{clearTimeout(Pe),Ee=!1}}},b=fe=>{let oe=!0;return queueMicrotask(()=>{oe&&(oe=!1,fe())}),{isTriggered:()=>oe,dispose:()=>{oe=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(oe){this.defaultDelay=oe,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(oe,Ee=this.defaultDelay){this.task=oe,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Oe,je)=>{this.doResolve=Oe,this.doReject=je}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Oe=this.task;return this.task=null,Oe()}}));const Pe=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=Ee===e.MicrotaskDelay?b(Pe):S(Ee,Pe),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class C{constructor(oe){this.delayer=new p(oe),this.throttler=new s}trigger(oe,Ee){return this.delayer.trigger(()=>this.throttler.queue(oe),Ee)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class a{constructor(){this._isOpen=!1,this._promise=new Promise((oe,Ee)=>{this._completePromise=oe})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class M extends a{constructor(oe){super();this._timeout=setTimeout(()=>this.open(),oe)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=M;function o(fe,oe){return oe?new Promise((Ee,Pe)=>{const Oe=setTimeout(()=>{je.dispose(),Ee()},fe),je=oe.onCancellationRequested(()=>{clearTimeout(Oe),je.dispose(),Pe(new t.CancellationError)})}):T(Ee=>o(fe,Ee))}e.timeout=o;function n(fe,oe=0){const Ee=setTimeout(fe,oe);return(0,A.toDisposable)(()=>clearTimeout(Ee))}e.disposableTimeout=n;function u(fe){const oe=[];let Ee=0;const Pe=fe.length;function Oe(){return Ee<Pe?fe[Ee++]():null}function je(st){st!=null&&oe.push(st);const et=Oe();return et?et.then(je):Promise.resolve(oe)}return Promise.resolve(null).then(je)}e.sequence=u;function f(fe,oe=Pe=>!!Pe,Ee=null){let Pe=0;const Oe=fe.length,je=()=>{if(Pe>=Oe)return Promise.resolve(Ee);const st=fe[Pe++];return Promise.resolve(st()).then(tt=>oe(tt)?Promise.resolve(tt):je())};return je()}e.first=f;function c(fe,oe=Pe=>!!Pe,Ee=null){if(fe.length===0)return Promise.resolve(Ee);let Pe=fe.length;const Oe=()=>{Pe=-1;for(const je of fe)je.cancel?.()};return new Promise((je,st)=>{for(const et of fe)et.then(tt=>{--Pe>=0&&oe(tt)?(Oe(),je(tt)):Pe===0&&je(Ee)}).catch(tt=>{--Pe>=0&&(Oe(),st(tt))})})}e.firstParallel=c;class h{constructor(oe){this._size=0,this.maxDegreeOfParalellism=oe,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new _.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(oe){return this._size++,new Promise((Ee,Pe)=>{this.outstandingPromises.push({factory:oe,c:Ee,e:Pe}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const oe=this.outstandingPromises.shift();this.runningPromises++;const Ee=oe.factory();Ee.then(oe.c,oe.e),Ee.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class g extends h{constructor(){super(1)}}e.Queue=g;class E{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const oe=new ie;return this.drainers.add(oe),oe.p}isDrained(){for(const[,oe]of this.queues)if(oe.size>0)return!1;return!0}queueFor(oe,Ee=I.extUri){const Pe=Ee.getComparisonKey(oe);let Oe=this.queues.get(Pe);return Oe||(Oe=new g,_.Event.once(Oe.onFinished)(()=>{Oe?.dispose(),this.queues.delete(Pe),this.onDidQueueFinish()}),this.queues.set(Pe,Oe)),Oe}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const oe of this.drainers)oe.complete();this.drainers.clear()}dispose(){for(const[,oe]of this.queues)oe.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=E;class v{constructor(oe,Ee){this._token=-1,typeof oe=="function"&&typeof Ee=="number"&&this.setIfNotSet(oe,Ee)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(oe,Ee){this.cancel(),this._token=setTimeout(()=>{this._token=-1,oe()},Ee)}setIfNotSet(oe,Ee){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,oe()},Ee))}}e.TimeoutTimer=v;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(oe,Ee){this.cancel(),this._token=setInterval(()=>{oe()},Ee)}}e.IntervalTimer=k;class x{constructor(oe,Ee){this.timeoutToken=-1,this.runner=oe,this.timeout=Ee,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(oe=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,oe)}get delay(){return this.timeout}set delay(oe){this.timeout=oe}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=x;class N{constructor(oe,Ee){Ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Ee}ms is not a multiple of 1000ms.`),this.runner=oe,this.timeout=Ee,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(oe=this.timeout){oe%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(oe/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class y extends x{constructor(oe,Ee){super(oe,Ee);this.units=[]}work(oe){this.units.push(oe),this.isScheduled()||this.schedule()}doRun(){const oe=this.units;this.units=[],this.runner&&this.runner(oe)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=y;class L extends A.Disposable{constructor(oe,Ee){super();this.options=oe,this.handler=Ee,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(oe){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+oe.length>this.options.maxBufferedWork)return!1}else if(this.pending+oe.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...oe),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new x(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=L,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,P.setTimeout0)(()=>{if(oe)return;const Ee=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,Ee-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.runWhenIdle=(fe,oe)=>{const Ee=requestIdleCallback(fe,typeof oe=="number"?{timeout:oe}:void 0);let Pe=!1;return{dispose(){Pe||(Pe=!0,cancelIdleCallback(Ee))}}}}();class W{constructor(oe){this._didRun=!1,this._executor=()=>{try{this._value=oe()}catch(Ee){this._error=Ee}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=W;async function B(fe,oe,Ee){let Pe;for(let Oe=0;Oe<Ee;Oe++)try{return await fe()}catch(je){Pe=je,await o(oe)}throw Pe}e.retry=B;class ${hasPending(oe){return this._pending?typeof oe=="number"?this._pending.taskId===oe:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(oe,Ee,Pe){return this._pending={taskId:oe,cancel:()=>Pe?.(),promise:Ee},Ee.then(()=>this.donePending(oe),()=>this.donePending(oe)),Ee}donePending(oe){this._pending&&oe===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const oe=this._next;this._next=void 0,oe.run().then(oe.promiseResolve,oe.promiseReject)}}setNext(oe){if(this._next)this._next.run=oe;else{let Ee,Pe;const Oe=new Promise((je,st)=>{Ee=je,Pe=st});this._next={run:oe,promise:Oe,promiseResolve:Ee,promiseReject:Pe}}return this._next.promise}}e.TaskSequentializer=$;class q{constructor(oe,Ee=()=>Date.now()){this.interval=oe,this.nowFn=Ee,this.lastIncrementTime=0,this.value=0}increment(){const oe=this.nowFn();return oe-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=oe,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((oe,Ee)=>{this.completeCallback=oe,this.errorCallback=Ee})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(oe){return new Promise(Ee=>{this.completeCallback(oe),this.resolved=!0,Ee()})}error(oe){return new Promise(Ee=>{this.errorCallback(oe),this.rejected=!0,Ee()})}cancel(){new Promise(oe=>{this.errorCallback(new t.CancellationError),this.rejected=!0,oe()})}}e.DeferredPromise=ie;var se;(function(fe){async function oe(Pe){let Oe;const je=await Promise.all(Pe.map(st=>st.then(et=>et,et=>{Oe||(Oe=et)})));if(typeof Oe!="undefined")throw Oe;return je}fe.settled=oe;function Ee(Pe){return new Promise(async(Oe,je)=>{try{await Pe(Oe,je)}catch(st){je(st)}})}fe.withAsyncBody=Ee})(se=e.Promises||(e.Promises={}));var X;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(X||(X={}));class ge{constructor(oe){this._state=0,this._results=[],this._error=null,this._onStateChanged=new _.Emitter,queueMicrotask(async()=>{const Ee={emitOne:Pe=>this.emitOne(Pe),emitMany:Pe=>this.emitMany(Pe),reject:Pe=>this.reject(Pe)};try{await Promise.resolve(oe(Ee)),this.resolve()}catch(Pe){this.reject(Pe)}finally{Ee.emitOne=void 0,Ee.emitMany=void 0,Ee.reject=void 0}})}static fromArray(oe){return new ge(Ee=>{Ee.emitMany(oe)})}static fromPromise(oe){return new ge(async Ee=>{Ee.emitMany(await oe)})}static fromPromises(oe){return new ge(async Ee=>{await Promise.all(oe.map(async Pe=>Ee.emitOne(await Pe)))})}static merge(oe){return new ge(async Ee=>{await Promise.all(oe.map(async Pe=>{for await(const Oe of Pe)Ee.emitOne(Oe)}))})}[Symbol.asyncIterator](){let oe=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(oe<this._results.length)return{done:!1,value:this._results[oe++]};if(this._state===1)return{done:!0,value:void 0};await _.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(oe,Ee){return new ge(async Pe=>{for await(const Oe of oe)Pe.emitOne(Ee(Oe))})}map(oe){return ge.map(this,oe)}static filter(oe,Ee){return new ge(async Pe=>{for await(const Oe of oe)Ee(Oe)&&Pe.emitOne(Oe)})}filter(oe){return ge.filter(this,oe)}static coalesce(oe){return ge.filter(oe,Ee=>!!Ee)}coalesce(){return ge.coalesce(this)}static async toPromise(oe){const Ee=[];for await(const Pe of oe)Ee.push(Pe);return Ee}toPromise(){return ge.toPromise(this)}emitOne(oe){this._state===0&&(this._results.push(oe),this._onStateChanged.fire())}emitMany(oe){this._state===0&&(this._results=this._results.concat(oe),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(oe){this._state===0&&(this._state=2,this._error=oe,this._onStateChanged.fire())}}e.AsyncIterableObject=ge,ge.EMPTY=ge.fromArray([]);class be extends ge{constructor(oe,Ee){super(Ee);this._source=oe}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=be;function pe(fe){const oe=new r.CancellationTokenSource,Ee=fe(oe.token);return new be(oe,async Pe=>{const Oe=oe.token.onCancellationRequested(()=>{Oe.dispose(),oe.dispose(),Pe.reject(new t.CancellationError)});try{for await(const je of Ee){if(oe.token.isCancellationRequested)return;Pe.emitOne(je)}Oe.dispose(),oe.dispose()}catch(je){Oe.dispose(),oe.dispose(),Pe.reject(je)}})}e.createCancelableAsyncIterable=pe}),define(ye[104],_e([0,1,13,17]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const _=new r.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),A=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),I=new r.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(g,E,v=!1){const k=g||"",x=E||"",N=_.value.collator.compare(k,x);return _.value.collatorIsNumeric&&N===0&&k!==x?k<x?-1:1:N}e.compareFileNames=P;function D(g,E){const v=A.value.collator;return g=g||"",E=E||"",C(v,g,E)}e.compareFileNamesDefault=D;function T(g,E){const v=A.value.collator;return g=g||"",E=E||"",n(g,E)||C(v,g,E)}e.compareFileNamesUpper=T;function R(g,E){const v=A.value.collator;return g=g||"",E=E||"",o(g,E)||C(v,g,E)}e.compareFileNamesLower=R;function w(g,E){return g=g||"",E=E||"",g===E?0:g<E?-1:1}e.compareFileNamesUnicode=w;function i(g,E,v=!1){v||(g=g&&g.toLowerCase(),E=E&&E.toLowerCase());const[k,x]=b(g),[N,y]=b(E);return k!==N?k<N?-1:1:x===y?0:x<y?-1:1}e.noIntlCompareFileNames=i;function d(g,E){const[v,k]=b(g),[x,N]=b(E);let y=_.value.collator.compare(k,N);if(y===0){if(_.value.collatorIsNumeric&&k!==N)return k<N?-1:1;if(y=_.value.collator.compare(v,x),_.value.collatorIsNumeric&&y===0&&v!==x)return v<x?-1:1}return y}e.compareFileExtensions=d;function l(g,E){g=g||"",E=E||"";const v=p(g),k=p(E),x=A.value.collator,N=I.value.collator;return C(N,v,k)||C(x,g,E)}e.compareFileExtensionsDefault=l;function s(g,E){g=g||"",E=E||"";const v=p(g),k=p(E),x=A.value.collator,N=I.value.collator;return C(N,v,k)||n(g,E)||C(x,g,E)}e.compareFileExtensionsUpper=s;function m(g,E){g=g||"",E=E||"";const v=p(g),k=p(E),x=A.value.collator,N=I.value.collator;return C(N,v,k)||o(g,E)||C(x,g,E)}e.compareFileExtensionsLower=m;function F(g,E){g=g||"",E=E||"";const v=p(g).toLowerCase(),k=p(E).toLowerCase();return v!==k?v<k?-1:1:g!==E?g<E?-1:1:0}e.compareFileExtensionsUnicode=F;const S=/^(.*?)(\.([^.]*))?$/;function b(g,E=!1){const v=g?S.exec(g):[];let k=[v&&v[1]||"",v&&v[3]||""];return E&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function p(g){const E=g?S.exec(g):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function C(g,E,v){let k=g.compare(E,v);return k!==0?k:E.length!==v.length?E.length<v.length?-1:1:0}function a(g){const E=g.charAt(0);return E.toLocaleUpperCase()!==E}function M(g){const E=g.charAt(0);return E.toLocaleLowerCase()!==E}function o(g,E){return a(g)&&M(E)?-1:M(g)&&a(E)?1:0}function n(g,E){return M(g)&&a(E)?-1:a(g)&&M(E)?1:0}function u(g,E,v=!1){return v||(g=g&&g.toLowerCase(),E=E&&E.toLowerCase()),g===E?0:g<E?-1:1}function f(g,E,v=!1){const k=g.split(t.sep),x=E.split(t.sep),N=k.length-1,y=x.length-1;let L,W;for(let B=0;;B++){if(L=N===B,W=y===B,L&&W)return P(k[B],x[B],v);if(L)return-1;if(W)return 1;const $=u(k[B],x[B],v);if($!==0)return $}}e.comparePaths=f;function c(g,E,v){const k=g.toLowerCase(),x=E.toLowerCase(),N=h(g,E,v);if(N)return N;const y=k.endsWith(v),L=x.endsWith(v);if(y!==L)return y?-1:1;const W=P(k,x);return W!==0?W:k.localeCompare(x)}e.compareAnything=c;function h(g,E,v){const k=g.toLowerCase(),x=E.toLowerCase(),N=k.startsWith(v),y=x.startsWith(v);if(N!==y)return N?-1:1;if(N&&y){if(k.length<x.length)return-1;if(k.length>x.length)return 1}return 0}e.compareByPrefix=h}),define(ye[29],_e([0,1,13,35,22,17,9]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const D="[/\\\\]",T="[^/\\\\]",R=/\//g;function w(q){switch(q){case 0:return"";case 1:return`${T}*?`;default:return`(?:${D}|${T}+${D}|${D}${T}+)*?`}}function i(q,ie){if(!q)return[];const se=[];let X=!1,ge=!1,be="";for(const pe of q){switch(pe){case ie:if(!X&&!ge){se.push(be),be="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ge=!0;break;case"]":ge=!1;break}be+=pe}return be&&se.push(be),se}e.splitGlobAware=i;function d(q){if(!q)return"";let ie="";const se=i(q,e.GLOB_SPLIT);if(se.every(X=>X===e.GLOBSTAR))ie=".*";else{let X=!1;se.forEach((ge,be)=>{if(ge===e.GLOBSTAR){X||(ie+=w(2),X=!0);return}let pe=!1,fe="",oe=!1,Ee="";for(const Pe of ge){if(Pe!=="}"&&pe){fe+=Pe;continue}if(oe&&(Pe!=="]"||!Ee)){let Oe;Pe==="-"?Oe=Pe:(Pe==="^"||Pe==="!")&&!Ee?Oe="^":Pe===e.GLOB_SPLIT?Oe="":Oe=I.escapeRegExpCharacters(Pe),Ee+=Oe;continue}switch(Pe){case"{":pe=!0;continue;case"[":oe=!0;continue;case"}":{ie+=`(?:${i(fe,",").map(st=>d(st)).join("|")})`,pe=!1,fe="";break}case"]":ie+="["+Ee+"]",oe=!1,Ee="";break;case"?":ie+=T;continue;case"*":ie+=w(1);continue;default:ie+=I.escapeRegExpCharacters(Pe)}}be<se.length-1&&(se[be+1]!==e.GLOBSTAR||be+2<se.length)&&(ie+=D),X=!1})}return ie}const l=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,F=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,p=new _.LRUCache(1e4),C=function(){return!1},a=function(){return null};function M(q,ie){if(!q)return a;let se;typeof q!="string"?se=q.pattern:se=q,se=se.trim();const X=`${se}_${!!ie.trimForExclusions}`;let ge=p.get(X);if(ge)return o(ge,q);let be;if(l.test(se)){const pe=se.substr(4);ge=function(fe,oe){return typeof fe=="string"&&fe.endsWith(pe)?se:null}}else(be=s.exec(n(se,ie)))?ge=u(be[1],se):(ie.trimForExclusions?F:m).test(se)?ge=f(se,ie):(be=S.exec(n(se,ie)))?ge=c(be[1].substr(1),se,!0):(be=b.exec(n(se,ie)))?ge=c(be[1],se,!1):ge=h(se);return p.set(X,ge),o(ge,q)}function o(q,ie){return typeof ie=="string"?q:function(se,X){return t.isEqualOrParent(se,ie.base)?q(A.relative(ie.base,se),X):null}}function n(q,ie){return ie.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function u(q,ie){const se=`/${q}`,X=`\\${q}`,ge=function(pe,fe){return typeof pe!="string"?null:fe?fe===q?ie:null:pe===q||pe.endsWith(se)||pe.endsWith(X)?ie:null},be=[q];return ge.basenames=be,ge.patterns=[ie],ge.allBasenames=be,ge}function f(q,ie){const se=$(q.slice(1,-1).split(",").map(fe=>M(fe,ie)).filter(fe=>fe!==a),q),X=se.length;if(!X)return a;if(X===1)return se[0];const ge=function(fe,oe){for(let Ee=0,Pe=se.length;Ee<Pe;Ee++)if(se[Ee](fe,oe))return q;return null},be=se.find(fe=>!!fe.allBasenames);be&&(ge.allBasenames=be.allBasenames);const pe=se.reduce((fe,oe)=>oe.allPaths?fe.concat(oe.allPaths):fe,[]);return pe.length&&(ge.allPaths=pe),ge}function c(q,ie,se){const X=A.sep===A.posix.sep,ge=X?q:q.replace(R,A.sep),be=A.sep+ge,pe=A.posix.sep+q,fe=se?function(oe,Ee){return typeof oe=="string"&&(oe===ge||oe.endsWith(be)||!X&&(oe===q||oe.endsWith(pe)))?ie:null}:function(oe,Ee){return typeof oe=="string"&&(oe===ge||!X&&oe===q)?ie:null};return fe.allPaths=[(se?"*/":"./")+q],fe}function h(q){try{const ie=new RegExp(`^${d(q)}$`);return function(se){return ie.lastIndex=0,typeof se=="string"&&ie.test(se)?q:null}}catch{return a}}function g(q,ie,se){return!q||typeof ie!="string"?!1:E(q)(ie,void 0,se)}e.match=g;function E(q,ie={}){if(!q)return C;if(typeof q=="string"||N(q)){const se=M(q,ie);if(se===a)return C;const X=function(ge,be){return!!se(ge,be)};return se.allBasenames&&(X.allBasenames=se.allBasenames),se.allPaths&&(X.allPaths=se.allPaths),X}return W(q,ie)}e.parse=E;function v(q){if(!q)return;let ie;return se=>(ie||(ie=(q()||Promise.resolve([])).then(X=>X?x(X):{})),ie.then(X=>!!X[se]))}e.hasSiblingPromiseFn=v;function k(q){if(!q)return;let ie;return se=>{if(!ie){const X=q();ie=X?x(X):{}}return!!ie[se]}}e.hasSiblingFn=k;function x(q){const ie={};for(const se of q)ie[se]=!0;return ie}function N(q){const ie=q;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.isRelativePattern=N;function y(q){return q.allBasenames||[]}e.getBasenameTerms=y;function L(q){return q.allPaths||[]}e.getPathTerms=L;function W(q,ie){const se=$(Object.getOwnPropertyNames(q).map(fe=>B(fe,q[fe],ie)).filter(fe=>fe!==a)),X=se.length;if(!X)return a;if(!se.some(fe=>!!fe.requiresSiblings)){if(X===1)return se[0];const fe=function(Pe,Oe){for(let je=0,st=se.length;je<st;je++){const et=se[je](Pe,Oe);if(et)return et}return null},oe=se.find(Pe=>!!Pe.allBasenames);oe&&(fe.allBasenames=oe.allBasenames);const Ee=se.reduce((Pe,Oe)=>Oe.allPaths?Pe.concat(Oe.allPaths):Pe,[]);return Ee.length&&(fe.allPaths=Ee),fe}const ge=function(fe,oe,Ee){let Pe;for(let Oe=0,je=se.length;Oe<je;Oe++){const st=se[Oe];st.requiresSiblings&&Ee&&(oe||(oe=A.basename(fe)),Pe||(Pe=oe.substr(0,oe.length-A.extname(fe).length)));const et=st(fe,oe,Pe,Ee);if(et)return et}return null},be=se.find(fe=>!!fe.allBasenames);be&&(ge.allBasenames=be.allBasenames);const pe=se.reduce((fe,oe)=>oe.allPaths?fe.concat(oe.allPaths):fe,[]);return pe.length&&(ge.allPaths=pe),ge}function B(q,ie,se){if(ie===!1)return a;const X=M(q,se);if(X===a)return a;if(typeof ie=="boolean")return X;if(ie){const ge=ie.when;if(typeof ge=="string"){const be=(pe,fe,oe,Ee)=>{if(!Ee||!X(pe,fe))return null;const Pe=ge.replace("$(basename)",oe),Oe=Ee(Pe);return(0,r.isThenable)(Oe)?Oe.then(je=>je?q:null):Oe?q:null};return be.requiresSiblings=!0,be}}return X}function $(q,ie){const se=q.filter(fe=>!!fe.basenames);if(se.length<2)return q;const X=se.reduce((fe,oe)=>{const Ee=oe.basenames;return Ee?fe.concat(Ee):fe},[]);let ge;if(ie){ge=[];for(let fe=0,oe=X.length;fe<oe;fe++)ge.push(ie)}else ge=se.reduce((fe,oe)=>{const Ee=oe.patterns;return Ee?fe.concat(Ee):fe},[]);const be=function(fe,oe){if(typeof fe!="string")return null;if(!oe){let Pe;for(Pe=fe.length;Pe>0;Pe--){const Oe=fe.charCodeAt(Pe-1);if(Oe===47||Oe===92)break}oe=fe.substr(Pe)}const Ee=X.indexOf(oe);return Ee!==-1?ge[Ee]:null};be.basenames=X,be.patterns=ge,be.allBasenames=X;const pe=q.filter(fe=>!fe.basenames);return pe.push(be),pe}}),define(ye[76],_e([0,1,35,11,17,23,24,9,2]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function T(n,u,f){if(typeof n=="string"&&(n=D.URI.file(n)),f){const h=f.getWorkspaceFolder(n);if(h){const g=f.getWorkspace().folders.length>1;let E;if((0,I.isEqual)(h.uri,n)?E="":E=(0,I.relativePath)(h.uri,n),g){const v=h.name?h.name:(0,I.basename)(h.uri);E=E?v+" \u2022 "+E:v}return E}}if(n.scheme!==t.Schemas.file&&n.scheme!==t.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,r.hasDriveLetter)(n.fsPath))return(0,_.normalize)(w(n.fsPath));let c=(0,_.normalize)(n.fsPath);return!A.isWindows&&u?.userHome&&(c=d(c,u.userHome.fsPath)),c}e.getPathLabel=T;function R(n){if(!n)return;typeof n=="string"&&(n=D.URI.file(n));const u=(0,I.basename)(n)||(n.scheme===t.Schemas.file?n.fsPath:n.path);return A.isWindows&&(0,r.isRootOrDriveLetter)(u)?w(u):u}e.getBaseLabel=R;function w(n,u){return(0,r.hasDriveLetter)(n,u)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=w;let i=Object.create(null);function d(n,u){if(A.isWindows||!n||!u)return n;let f=i.original===u?i.normalized:void 0;return f||(f=`${(0,P.rtrim)(u,_.posix.sep)}${_.posix.sep}`,i={original:u,normalized:f}),(A.isLinux?n.startsWith(f):(0,P.startsWithIgnoreCase)(n,f))&&(n=`~/${n.substr(f.length)}`),n}e.tildify=d;function l(n,u){return n.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=l;const s="\u2026",m="\\\\",F="~";function S(n,u=_.sep){const f=new Array(n.length);let c=!1;for(let h=0;h<n.length;h++){let g=n[h];if(g===""){f[h]=`.${u}`;continue}if(!g){f[h]=g;continue}c=!0;let E="";g.indexOf(m)===0?(E=g.substr(0,g.indexOf(m)+m.length),g=g.substr(g.indexOf(m)+m.length)):g.indexOf(u)===0?(E=g.substr(0,g.indexOf(u)+u.length),g=g.substr(g.indexOf(u)+u.length)):g.indexOf(F)===0&&(E=g.substr(0,g.indexOf(F)+F.length),g=g.substr(g.indexOf(F)+F.length));const v=g.split(u);for(let k=1;c&&k<=v.length;k++)for(let x=v.length-k;c&&x>=0;x--){c=!1;let N=v.slice(x,x+k).join(u);for(let y=0;!c&&y<n.length;y++)if(y!==h&&n[y]&&n[y].indexOf(N)>-1){const L=x+k===v.length,W=x>0&&n[y].indexOf(u)>-1?u+N:N,B=n[y].endsWith(W);c=!L||B}if(!c){let y="";(v[0].endsWith(":")||E!=="")&&(x===1&&(x=0,k++,N=v[0]+u+N),x>0&&(y=v[0]+u),y=E+y),x>0&&(y=y+s+u),y=y+N,x+k<v.length&&(y=y+u+s),f[h]=y}}c&&(f[h]=g)}return f}e.shorten=S;var b;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(b||(b={}));function p(n,u=Object.create(null)){const f=[];let c=!1,h="";for(const g of n)if(g==="$"||c&&g==="{")h&&f.push({value:h,type:b.TEXT}),h="",c=!0;else if(g==="}"&&c){const E=u[h];if(typeof E=="string")E.length&&f.push({value:E,type:b.VARIABLE});else if(E){const v=f[f.length-1];(!v||v.type!==b.SEPARATOR)&&f.push({value:E.label,type:b.SEPARATOR})}h="",c=!1}else h+=g;return h&&!c&&f.push({value:h,type:b.TEXT}),f.filter((g,E)=>{if(g.type===b.SEPARATOR){const v=f[E-1],k=f[E+1];return[v,k].every(x=>x&&(x.type===b.VARIABLE||x.type===b.TEXT)&&x.value.length>0)}return!0}).map(g=>g.value).join("")}e.template=p;function C(n,u){return A.isMacintosh||u?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function a(n,u){return A.isMacintosh||u?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,f=>f==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function M(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=M;function o(n){const u=n.indexOf("/")!==-1?_.posix:_.win32,f=u.basename(n),c=u.dirname(n);return f.length?{name:f,parentPath:c}:{name:c,parentPath:""}}e.splitName=o}),define(ye[105],_e([0,1,2]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(R){return R.toJSON()}class _{constructor(w){this._uriTransformer=w}transformIncoming(w){const i=this._uriTransformer.transformIncoming(w);return i===w?w:t(r.URI.from(i))}transformOutgoing(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:t(r.URI.from(i))}transformOutgoingURI(w){const i=this._uriTransformer.transformOutgoing(w);return i===w?w:r.URI.from(i)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=_,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function A(R,w,i){if(!R||i>200)return null;if(typeof R=="object"){if(R instanceof r.URI)return w.transformOutgoing(R);for(let d in R)if(Object.hasOwnProperty.call(R,d)){const l=A(R[d],w,i+1);l!==null&&(R[d]=l)}}return null}function I(R,w){const i=A(R,w,0);return i===null?R:i}e.transformOutgoingURIs=I;function P(R,w,i,d){if(!R||d>200)return null;if(typeof R=="object"){if(R.$mid===1)return i?r.URI.revive(w.transformIncoming(R)):w.transformIncoming(R);for(let l in R)if(Object.hasOwnProperty.call(R,l)){const s=P(R[l],w,i,d+1);s!==null&&(R[l]=s)}}return null}function D(R,w){const i=P(R,w,!1,0);return i===null?R:i}e.transformIncomingURIs=D;function T(R,w){const i=P(R,w,!0,0);return i===null?R:i}e.transformAndReviveIncomingURIs=T}),define(ye[36],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return r.test(D)}e.isUUID=t;const _=new Uint8Array(16),A=[];for(let D=0;D<256;D++)A.push(D.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(D){for(let T=0;T<D.length;T++)D[T]=Math.floor(Math.random()*256);return D};function P(){I(_),_[6]=_[6]&15|64,_[8]=_[8]&63|128;let D=0,T="";return T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+="-",T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T+=A[_[D++]],T}e.generateUuid=P}),define(ye[106],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var r;(function(I){I[I.None=0]="None",I[I.Indent=1]="Indent",I[I.IndentOutdent=2]="IndentOutdent",I[I.Outdent=3]="Outdent"})(r=e.IndentAction||(e.IndentAction={}));class t{constructor(P){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=P.open,this.close=P.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(P.notIn))for(let D=0,T=P.notIn.length;D<T;D++)switch(P.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(P,D){if(P.getTokenCount()===0)return!0;const T=P.findTokenIndexAtOffset(D-2),R=P.getStandardTokenType(T);return this.isOK(R)}_findNeutralCharacterInRange(P,D){for(let T=P;T<=D;T++){const R=String.fromCharCode(T);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=t;class _{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)A(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),A(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),A(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),A(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&A(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=_;function A(I,P,D){I.has(P)?I.get(P).push(D):I.set(P,[D])}}),define(ye[56],_e([0,1,29,17]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function _(A,I,P,D){if(Array.isArray(A)){let T=0;for(const R of A){const w=_(R,I,P,D);if(w===10)return w;w>T&&(T=w)}return T}else{if(typeof A=="string")return D?A==="*"?5:A===P?10:0:0;if(A){const{language:T,pattern:R,scheme:w,hasAccessToAllModels:i}=A;if(!D&&!i)return 0;let d=0;if(w)if(w===I.scheme)d=10;else if(w==="*")d=5;else return 0;if(T)if(T===P)d=10;else if(T==="*")d=Math.max(d,5);else return 0;if(R){let l;if(typeof R=="string"?l=R:l={...R,base:(0,t.normalize)(R.base)},l===I.fsPath||(0,r.match)(l,I.fsPath))d=10;else return 0}return d}else return 0}}e.score=_}),define(ye[107],_e([0,1,4,6]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class _{constructor(){this._map=new Map,this._factories=new Map,this._onDidChange=new r.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(P){this._onDidChange.fire({changedLanguages:P,changedColorMap:!1})}register(P,D){return this._map.set(P,D),this.fire([P]),(0,t.toDisposable)(()=>{this._map.get(P)===D&&(this._map.delete(P),this.fire([P]))})}registerFactory(P,D){this._factories.get(P)?.dispose();const T=new A(this,P,D);return this._factories.set(P,T),(0,t.toDisposable)(()=>{const R=this._factories.get(P);!R||R!==T||(this._factories.delete(P),R.dispose())})}async getOrCreate(P){const D=this.get(P);if(D)return D;const T=this._factories.get(P);return!T||T.isResolved?null:(await T.resolve(),this.get(P))}get(P){return this._map.get(P)||null}isResolved(P){if(this.get(P))return!0;const T=this._factories.get(P);return!!(!T||T.isResolved)}setColorMap(P){this._colorMap=P,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistry=_;class A extends t.Disposable{constructor(P,D,T){super();this._registry=P,this._languageId=D,this._factory=T,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}get isResolved(){return this._isResolved}dispose(){this._isDisposed=!0,super.dispose()}async resolve(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise}async _create(){const P=await Promise.resolve(this._factory.createTokenizationSupport());this._isResolved=!0,P&&!this._isDisposed&&this._register(this._registry.register(this._languageId,P))}}}),define(ye[77],_e([0,1,21,23]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var _;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(_||(_={}));function A(w){for(let i=0,d=w.length;i<d;i+=4){const l=w[i+0],s=w[i+1],m=w[i+2],F=w[i+3];w[i+0]=F,w[i+1]=m,w[i+2]=s,w[i+3]=l}}function I(w){const i=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return t.isLittleEndian()||A(i),r.VSBuffer.wrap(i)}function P(w){const i=w.buffer;if(t.isLittleEndian()||A(i),i.byteOffset%4==0)return new Uint32Array(i.buffer,i.byteOffset,i.length/4);{const d=new Uint8Array(i.byteLength);return d.set(i),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function D(w){const i=new Uint32Array(T(w));let d=0;if(i[d++]=w.id,w.type==="full")i[d++]=1,i[d++]=w.data.length,i.set(w.data,d),d+=w.data.length;else{i[d++]=2,i[d++]=w.deltas.length;for(const l of w.deltas)i[d++]=l.start,i[d++]=l.deleteCount,l.data?(i[d++]=l.data.length,i.set(l.data,d),d+=l.data.length):i[d++]=0}return I(i)}e.encodeSemanticTokensDto=D;function T(w){let i=0;if(i+=1+1,w.type==="full")i+=1+w.data.length;else{i+=1,i+=(1+1+1)*w.deltas.length;for(const d of w.deltas)d.data&&(i+=d.data.length)}return i}function R(w){const i=P(w);let d=0;const l=i[d++];if(i[d++]===1){const S=i[d++],b=i.subarray(d,d+S);return d+=S,{id:l,type:"full",data:b}}const m=i[d++],F=[];for(let S=0;S<m;S++){const b=i[d++],p=i[d++],C=i[d++];let a;C>0&&(a=i.subarray(d,d+C),d+=C),F[S]={start:b,deleteCount:p,data:a}}return{id:l,type:"delta",deltas:F}}e.decodeSemanticTokensDto=R}),define(ye[108],_e([18,19]),function(ee,e){return ee.create("vs/base/common/date",e)}),define(ye[109],_e([0,1,108]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,_=t*60,A=_*24,I=A*7,P=A*30,D=A*365;function T(w,i,d){typeof w!="number"&&(w=w.getTime());const l=Math.round((new Date().getTime()-w)/1e3);if(l<-30)return(0,r.localize)(0,null,T(new Date().getTime()+l*1e3,!1));if(l<30)return(0,r.localize)(1,null);let s;return l<t?(s=l,i?s===1?d?(0,r.localize)(2,null,s):(0,r.localize)(3,null,s):d?(0,r.localize)(4,null,s):(0,r.localize)(5,null,s):s===1?d?(0,r.localize)(6,null,s):(0,r.localize)(7,null,s):d?(0,r.localize)(8,null,s):(0,r.localize)(9,null,s)):l<_?(s=Math.floor(l/t),i?s===1?d?(0,r.localize)(10,null,s):(0,r.localize)(11,null,s):d?(0,r.localize)(12,null,s):(0,r.localize)(13,null,s):s===1?d?(0,r.localize)(14,null,s):(0,r.localize)(15,null,s):d?(0,r.localize)(16,null,s):(0,r.localize)(17,null,s)):l<A?(s=Math.floor(l/_),i?s===1?d?(0,r.localize)(18,null,s):(0,r.localize)(19,null,s):d?(0,r.localize)(20,null,s):(0,r.localize)(21,null,s):s===1?d?(0,r.localize)(22,null,s):(0,r.localize)(23,null,s):d?(0,r.localize)(24,null,s):(0,r.localize)(25,null,s)):l<I?(s=Math.floor(l/A),i?s===1?(0,r.localize)(26,null,s):(0,r.localize)(27,null,s):s===1?(0,r.localize)(28,null,s):(0,r.localize)(29,null,s)):l<P?(s=Math.floor(l/I),i?s===1?d?(0,r.localize)(30,null,s):(0,r.localize)(31,null,s):d?(0,r.localize)(32,null,s):(0,r.localize)(33,null,s):s===1?d?(0,r.localize)(34,null,s):(0,r.localize)(35,null,s):d?(0,r.localize)(36,null,s):(0,r.localize)(37,null,s)):l<D?(s=Math.floor(l/P),i?s===1?d?(0,r.localize)(38,null,s):(0,r.localize)(39,null,s):d?(0,r.localize)(40,null,s):(0,r.localize)(41,null,s):s===1?d?(0,r.localize)(42,null,s):(0,r.localize)(43,null,s):d?(0,r.localize)(44,null,s):(0,r.localize)(45,null,s)):(s=Math.floor(l/D),i?s===1?d?(0,r.localize)(46,null,s):(0,r.localize)(47,null,s):d?(0,r.localize)(48,null,s):(0,r.localize)(49,null,s):s===1?d?(0,r.localize)(50,null,s):(0,r.localize)(51,null,s):d?(0,r.localize)(52,null,s):(0,r.localize)(53,null,s))}e.fromNow=T;function R(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(ye[110],_e([18,19]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(ye[43],_e([0,1,16,10,110]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(T,R){return R&&(T.stack||T.stacktrace)?_.localize(0,null,P(T),I(T.stack)||I(T.stacktrace)):P(T)}function I(T){return Array.isArray(T)?T.join(`
`):T}function P(T){return typeof T.code=="string"&&typeof T.errno=="number"&&typeof T.syscall=="string"?_.localize(1,null,T.message):T.message||_.localize(2,null)}function D(T=null,R=!1){if(!T)return _.localize(3,null);if(Array.isArray(T)){const w=r.coalesce(T),i=D(w[0],R);return w.length>1?_.localize(4,null,i,w.length):i}if(t.isString(T))return T;if(T.detail){const w=T.detail;if(w.error)return A(w.error,R);if(w.exception)return A(w.exception,R)}return T.stack?A(T,R):T.message?T.message:_.localize(5,null)}e.toErrorMessage=D}),define(ye[111],_e([18,19]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(ye[112],_e([0,1,111,23,113,16,27]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var P;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(P=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=D;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class R{constructor(Q,de,Ue,qe){this.id=Q,this.name=de,this.defaultValue=Ue,this.schema=qe}applyUpdate(Q,de){return i(Q,de)}compute(Q,de,Ue){return Ue}}class w{constructor(Q,de){this.newValue=Q,this.didChange=de}}e.ApplyUpdateResult=w;function i(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new w(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Ue=Array.isArray(G)&&Array.isArray(Q)&&A.equals(G,Q);return new w(Q,Ue)}let de=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const qe=i(G[Ue],Q[Ue]);qe.didChange&&(G[Ue]=qe.newValue,de=!0)}return new w(G,de)}class d{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,de){return i(Q,de)}validate(Q){return this.defaultValue}}class l{constructor(Q,de,Ue,qe){this.id=Q,this.name=de,this.defaultValue=Ue,this.schema=qe}applyUpdate(Q,de){return i(Q,de)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,de,Ue){return Ue}}function s(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=s;class m extends l{constructor(Q,de,Ue,qe=void 0){typeof qe!="undefined"&&(qe.type="boolean",qe.default=Ue);super(Q,de,Ue,qe)}validate(Q){return s(Q,this.defaultValue)}}function F(G,Q,de,Ue){if(typeof G=="undefined")return Q;let qe=parseInt(G,10);return isNaN(qe)?Q:(qe=Math.max(de,qe),qe=Math.min(Ue,qe),qe|0)}e.clampedInt=F;class S extends l{constructor(Q,de,Ue,qe,lt,ht=void 0){typeof ht!="undefined"&&(ht.type="integer",ht.default=Ue,ht.minimum=qe,ht.maximum=lt);super(Q,de,Ue,ht);this.minimum=qe,this.maximum=lt}static clampedInt(Q,de,Ue,qe){return F(Q,de,Ue,qe)}validate(Q){return S.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class b extends l{constructor(Q,de,Ue,qe,lt){typeof lt!="undefined"&&(lt.type="number",lt.default=Ue);super(Q,de,Ue,lt);this.validationFn=qe}static clamp(Q,de,Ue){return Q<de?de:Q>Ue?Ue:Q}static float(Q,de){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return de;const Ue=parseFloat(Q);return isNaN(Ue)?de:Ue}validate(Q){return this.validationFn(b.float(Q,this.defaultValue))}}class p extends l{static string(Q,de){return typeof Q!="string"?de:Q}constructor(Q,de,Ue,qe=void 0){typeof qe!="undefined"&&(qe.type="string",qe.default=Ue);super(Q,de,Ue,qe)}validate(Q){return p.string(Q,this.defaultValue)}}function C(G,Q,de){return typeof G!="string"||de.indexOf(G)===-1?Q:G}e.stringSet=C;class a extends l{constructor(Q,de,Ue,qe,lt=void 0){typeof lt!="undefined"&&(lt.type="string",lt.enum=qe,lt.default=Ue);super(Q,de,Ue,lt);this._allowedValues=qe}validate(Q){return C(Q,this.defaultValue,this._allowedValues)}}class M extends R{constructor(Q,de,Ue,qe,lt,ht,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=lt,Ye.default=qe);super(Q,de,Ue,Ye);this._allowedValues=lt,this._convert=ht}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function o(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class n extends R{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[r.localize(0,null),r.localize(1,null),r.localize(2,null)],default:"auto",description:r.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,de,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class u extends R{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:r.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:r.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertSpace:s(de.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(de.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(f=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function c(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var h;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(h=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function g(G){switch(G){case h.Line:return"line";case h.Block:return"block";case h.Underline:return"underline";case h.LineThin:return"line-thin";case h.BlockOutline:return"block-outline";case h.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=g;function E(G){switch(G){case"line":return h.Line;case"block":return h.Block;case"underline":return h.Underline;case"line-thin":return h.LineThin;case"block-outline":return h.BlockOutline;case"underline-thin":return h.UnderlineThin}}class v extends d{constructor(){super(128)}compute(Q,de,Ue){const qe=["monaco-editor"];return de.get(33)&&qe.push(de.get(33)),Q.extraEditorClassName&&qe.push(Q.extraEditorClassName),de.get(66)==="default"?qe.push("mouse-default"):de.get(66)==="copy"&&qe.push("mouse-copy"),de.get(100)&&qe.push("showUnused"),de.get(126)&&qe.push("showDeprecated"),qe.join(" ")}}class k extends m{constructor(){super(32,"emptySelectionClipboard",!0,{description:r.localize(6,null)})}compute(Q,de,Ue){return Ue&&Q.emptySelectionClipboard}}class x extends R{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:r.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[r.localize(8,null),r.localize(9,null),r.localize(10,null)],description:r.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[r.localize(12,null),r.localize(13,null),r.localize(14,null)],description:r.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:r.localize(16,null),included:t.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:r.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:r.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{cursorMoveOnType:s(de.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":C(de.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":C(de.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(de.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(de.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(de.loop,this.defaultValue.loop)}}}class N extends R{constructor(){super(45,"fontLigatures",N.OFF,{anyOf:[{type:"boolean",description:r.localize(19,null)},{type:"string",description:r.localize(20,null)}],description:r.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?N.OFF:Q==="true"?N.ON:Q:Boolean(Q)?N.ON:N.OFF}}e.EditorFontLigatures=N,N.OFF='"liga" off, "calt" off',N.ON='"liga" on, "calt" on';class y extends d{constructor(){super(44)}compute(Q,de,Ue){return Q.fontInfo}}class L extends l{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:r.localize(22,null)})}validate(Q){const de=b.float(Q,this.defaultValue);return de===0?e.EDITOR_FONT_DEFAULTS.fontSize:b.clamp(de,6,100)}compute(Q,de,Ue){return Q.fontInfo.fontSize}}class W extends R{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:W.MINIMUM_VALUE,maximum:W.MAXIMUM_VALUE,errorMessage:r.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:W.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:r.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(S.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,W.MINIMUM_VALUE,W.MAXIMUM_VALUE))}}W.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],W.MINIMUM_VALUE=1,W.MAXIMUM_VALUE=1e3;class B extends R{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},de={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[r.localize(25,null),r.localize(26,null),r.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:r.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:r.localize(29,null),...de},"editor.gotoLocation.multipleTypeDefinitions":{description:r.localize(30,null),...de},"editor.gotoLocation.multipleDeclarations":{description:r.localize(31,null),...de},"editor.gotoLocation.multipleImplementations":{description:r.localize(32,null),...de},"editor.gotoLocation.multipleReferences":{description:r.localize(33,null),...de},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:r.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:r.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:r.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:r.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:r.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{multiple:C(de.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:de.multipleDefinitions??C(de.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:de.multipleTypeDefinitions??C(de.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:de.multipleDeclarations??C(de.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:de.multipleImplementations??C(de.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:de.multipleReferences??C(de.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(de.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(de.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:p.string(de.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(de.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(de.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class $ extends R{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:r.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:r.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:r.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:r.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),delay:S.clampedInt(de.delay,this.defaultValue.delay,0,1e4),sticky:s(de.sticky,this.defaultValue.sticky),above:s(de.above,this.defaultValue.above)}}}var q;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class ie extends d{constructor(){super(131)}compute(Q,de,Ue){return ie.computeLayout(de,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const de=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?de-1:0,qe=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),lt=Math.floor(Q.viewLineCount/qe);return{typicalViewportLineCount:de,extraLinesBeyondLastLine:Ue,desiredRatio:qe,minimapLineCount:lt}}static _computeMinimapLayout(Q,de){const Ue=Q.outerWidth,qe=Q.outerHeight,lt=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:qe};const ht=de.stableMinimapLayoutInput,Ye=ht&&Q.outerHeight===ht.outerHeight&&Q.lineHeight===ht.lineHeight&&Q.typicalHalfwidthCharacterWidth===ht.typicalHalfwidthCharacterWidth&&Q.pixelRatio===ht.pixelRatio&&Q.scrollBeyondLastLine===ht.scrollBeyondLastLine&&Q.minimap.enabled===ht.minimap.enabled&&Q.minimap.side===ht.minimap.side&&Q.minimap.size===ht.minimap.size&&Q.minimap.showSlider===ht.minimap.showSlider&&Q.minimap.renderCharacters===ht.minimap.renderCharacters&&Q.minimap.maxColumn===ht.minimap.maxColumn&&Q.minimap.scale===ht.minimap.scale&&Q.verticalScrollbarWidth===ht.verticalScrollbarWidth&&Q.isViewportWrapping===ht.isViewportWrapping,kt=Q.lineHeight,Ae=Q.typicalHalfwidthCharacterWidth,De=Q.scrollBeyondLastLine,ve=Q.minimap.renderCharacters;let te=lt>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const ne=Q.minimap.maxColumn,ue=Q.minimap.size,me=Q.minimap.side,Te=Q.verticalScrollbarWidth,He=Q.viewLineCount,Le=Q.remainingWidth,Ge=Q.isViewportWrapping,ot=ve?2:3;let at=Math.floor(lt*qe);const Ne=at/lt;let ce=!1,he=!1,re=ot*te,V=te/lt,we=1;if(ue==="fill"||ue==="fit"){const{typicalViewportLineCount:dt,extraLinesBeyondLastLine:vt,desiredRatio:bt,minimapLineCount:xt}=ie.computeContainedMinimapLineCount({viewLineCount:He,scrollBeyondLastLine:De,height:qe,lineHeight:kt,pixelRatio:lt});if(He/xt>1)ce=!0,he=!0,te=1,re=1,V=te/lt;else{let Mt=!1,Dt=te+1;if(ue==="fit"){const St=Math.ceil((He+vt)*re);Ge&&Ye&&Le<=de.stableFitRemainingWidth?(Mt=!0,Dt=de.stableFitMaxMinimapScale):Mt=St>at}if(ue==="fill"||Mt){ce=!0;const St=te;re=Math.min(kt*lt,Math.max(1,Math.floor(1/bt))),Ge&&Ye&&Le<=de.stableFitRemainingWidth&&(Dt=de.stableFitMaxMinimapScale),te=Math.min(Dt,Math.max(1,Math.floor(re/ot))),te>St&&(we=Math.min(2,te/St)),V=te/lt/we,at=Math.ceil(Math.max(dt,He+vt)*re),Ge?(de.stableMinimapLayoutInput=Q,de.stableFitRemainingWidth=Le,de.stableFitMaxMinimapScale=te):(de.stableMinimapLayoutInput=null,de.stableFitRemainingWidth=0)}}}const Re=Math.floor(ne*V),We=Math.min(Re,Math.max(0,Math.floor((Le-Te-2)*V/(Ae+V)))+e.MINIMAP_GUTTER_WIDTH);let ze=Math.floor(lt*We);const mt=ze/lt;ze=Math.floor(ze*we);const Et=ve?1:2,_t=me==="left"?0:Ue-We-Te;return{renderMinimap:Et,minimapLeft:_t,minimapWidth:We,minimapHeightIsEditorHeight:ce,minimapIsSampling:he,minimapScale:te,minimapLineHeight:re,minimapCanvasInnerWidth:ze,minimapCanvasInnerHeight:at,minimapCanvasOuterWidth:mt,minimapCanvasOuterHeight:Ne}}static computeLayout(Q,de){const Ue=de.outerWidth|0,qe=de.outerHeight|0,lt=de.lineHeight|0,ht=de.lineNumbersDigitCount|0,Ye=de.typicalHalfwidthCharacterWidth,kt=de.maxDigitWidth,Ae=de.pixelRatio,De=de.viewLineCount,ve=Q.get(123),te=ve==="inherit"?Q.get(122):ve,ne=te==="inherit"?Q.get(118):te,ue=Q.get(121),me=Q.get(2),Te=de.isDominatedByLongLines,He=Q.get(50),Le=Q.get(60).renderType!==0,Ge=Q.get(61),ot=Q.get(94),at=Q.get(65),Ne=Q.get(92),ce=Ne.verticalScrollbarSize,he=Ne.verticalHasArrows,re=Ne.arrowSize,V=Ne.horizontalScrollbarSize,we=Q.get(58),Re=Q.get(37);let We;if(typeof we=="string"&&/^\d+(\.\d+)?ch$/.test(we)){const wt=parseFloat(we.substr(0,we.length-2));We=S.clampedInt(wt*Ye,0,0,1e3)}else We=S.clampedInt(we,0,0,1e3);Re&&(We+=16);let ze=0;if(Le){const wt=Math.max(ht,Ge);ze=Math.round(wt*kt)}let mt=0;He&&(mt=lt);let Et=0,_t=Et+mt,dt=_t+ze,vt=dt+We;const bt=Ue-mt-ze-We;let xt=!1,It=!1,Mt=-1;me!==2&&(te==="inherit"&&Te?(xt=!0,It=!0):ne==="on"||ne==="bounded"?It=!0:ne==="wordWrapColumn"&&(Mt=ue));const Dt=ie._computeMinimapLayout({outerWidth:Ue,outerHeight:qe,lineHeight:lt,typicalHalfwidthCharacterWidth:Ye,pixelRatio:Ae,scrollBeyondLastLine:ot,minimap:at,verticalScrollbarWidth:ce,viewLineCount:De,remainingWidth:bt,isViewportWrapping:It},de.memory||new T);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(Et+=Dt.minimapWidth,_t+=Dt.minimapWidth,dt+=Dt.minimapWidth,vt+=Dt.minimapWidth);const St=bt-Dt.minimapWidth,Qt=Math.max(1,Math.floor((St-ce-2)/Ye)),Vt=he?re:0;return It&&(Mt=Math.max(1,Qt),ne==="bounded"&&(Mt=Math.min(Mt,ue))),{width:Ue,height:qe,glyphMarginLeft:Et,glyphMarginWidth:mt,lineNumbersLeft:_t,lineNumbersWidth:ze,decorationsLeft:dt,decorationsWidth:We,contentLeft:vt,contentWidth:St,minimap:Dt,viewportColumn:Qt,isWordWrapMinified:xt,isViewportWrapping:It,wrappingColumn:Mt,verticalScrollbarWidth:ce,horizontalScrollbarHeight:V,overviewRuler:{top:Vt,width:ce,height:qe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=ie;class se extends R{constructor(){const Q={enabled:!0};super(57,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:r.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}class X extends R{constructor(){const Q={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:r.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:r.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),fontSize:S.clampedInt(de.fontSize,this.defaultValue.fontSize,0,100),fontFamily:p.string(de.fontFamily,this.defaultValue.fontFamily)}}}class ge extends b{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>b.clamp(Q,0,150),{markdownDescription:r.localize(47,null)})}compute(Q,de,Ue){return Q.fontInfo.lineHeight}}class be extends R{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:r.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[r.localize(49,null),r.localize(50,null),r.localize(51,null)],default:Q.size,description:r.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:r.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:r.localize(54,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:r.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:r.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:r.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),size:C(de.size,this.defaultValue.size,["proportional","fill","fit"]),side:C(de.side,this.defaultValue.side,["right","left"]),showSlider:C(de.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(de.renderCharacters,this.defaultValue.renderCharacters),scale:S.clampedInt(de.scale,1,1,3),maxColumn:S.clampedInt(de.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(G){return G==="ctrlCmd"?t.isMacintosh?"metaKey":"ctrlKey":"altKey"}class fe extends R{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:r.localize(59,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{top:S.clampedInt(de.top,0,0,1e3),bottom:S.clampedInt(de.bottom,0,0,1e3)}}}class oe extends R{constructor(){const Q={enabled:!0,cycle:!1};super(76,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:r.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:r.localize(61,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),cycle:s(de.cycle,this.defaultValue.cycle)}}}class Ee extends d{constructor(){super(129)}compute(Q,de,Ue){return Q.pixelRatio}}class Pe extends R{constructor(){const Q={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",Q,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:Q.strings,description:r.localize(62,null)},comments:{type:"boolean",default:Q.comments,description:r.localize(63,null)},other:{type:"boolean",default:Q.other,description:r.localize(64,null)}}}],default:Q,description:r.localize(65,null)});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean")return Q;if(Q&&typeof Q=="object"){const de=Q,Ue={other:s(de.other,this.defaultValue.other),comments:s(de.comments,this.defaultValue.comments),strings:s(de.strings,this.defaultValue.strings)};return Ue.other&&Ue.comments&&Ue.strings?!0:!Ue.other&&!Ue.comments&&!Ue.strings?!1:Ue}return this.defaultValue}}var Oe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Oe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class je extends R{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[r.localize(66,null),r.localize(67,null),r.localize(68,null),r.localize(69,null)],default:"on",description:r.localize(70,null)})}validate(Q){let de=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(de=4,Ue=Q):Q==="interval"?de=3:Q==="relative"?de=2:Q==="on"?de=1:de=0),{renderType:de,renderFn:Ue}}}function st(G){const Q=G.get(87);return Q==="editable"?G.get(81):Q!=="on"}e.filterValidationDecorations=st;class et extends R{constructor(){const Q=[],de={type:"number",description:r.localize(71,null)};super(91,"rulers",Q,{type:"array",items:{anyOf:[de,{type:["object"],properties:{column:de,color:{type:"string",description:r.localize(72,null),format:"color-hex"}}}]},default:Q,description:r.localize(73,null)})}validate(Q){if(Array.isArray(Q)){const de=[];for(let Ue of Q)if(typeof Ue=="number")de.push({column:S.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const qe=Ue;de.push({column:S.clampedInt(qe.column,0,0,1e4),color:qe.color})}return de.sort((Ue,qe)=>Ue.column-qe.column),de}return this.defaultValue}}function tt(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class H extends R{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(74,null),r.localize(75,null),r.localize(76,null)],default:"auto",description:r.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[r.localize(78,null),r.localize(79,null),r.localize(80,null)],default:"auto",description:r.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:r.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:r.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:r.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q,Ue=S.clampedInt(de.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),qe=S.clampedInt(de.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:S.clampedInt(de.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:tt(de.vertical,this.defaultValue.vertical),horizontal:tt(de.horizontal,this.defaultValue.horizontal),useShadows:s(de.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(de.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(de.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(de.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(de.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:S.clampedInt(de.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:qe,verticalSliderSize:S.clampedInt(de.verticalSliderSize,qe,0,1e3),scrollByPage:s(de.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends R{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:r.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:r.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:r.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:r.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:r.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:r.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:r.localize(91,null)}})}applyUpdate(Q,de){let Ue=!1;de.allowedCharacters&&(I.equals(Q.allowedCharacters,de.allowedCharacters)||(Q={...Q,allowedCharacters:de.allowedCharacters},Ue=!0)),de.allowedLocales&&(I.equals(Q.allowedLocales,de.allowedLocales)||(Q={...Q,allowedLocales:de.allowedLocales},Ue=!0));const qe=super.applyUpdate(Q,de);return Ue?new w(qe.newValue,!0):qe}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{nonBasicASCII:ae(de.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(de.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(de.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ae(de.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ae(de.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,de){if(typeof Q!="object"||!Q)return de;const Ue={};for(const[qe,lt]of Object.entries(Q))lt===!0&&(Ue[qe]=!0);return Ue}}class z extends R{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:r.localize(92,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{enabled:s(de.enabled,this.defaultValue.enabled),mode:C(de.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class j extends R{constructor(){const Q={enabled:e.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,description:r.localize(93,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:s(Q.enabled,this.defaultValue.enabled)}}}class Y extends R{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(94,null),r.localize(95,null),r.localize(96,null)],default:Q.bracketPairs,description:r.localize(97,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[r.localize(98,null),r.localize(99,null),r.localize(100,null)],default:Q.bracketPairsHorizontal,description:r.localize(101,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:r.localize(102,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:r.localize(103,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:Q.highlightActiveIndentation,description:r.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{bracketPairs:ae(de.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(de.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(de.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(de.indentation,this.defaultValue.indentation),highlightActiveIndentation:s(de.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ae(G,Q,de){const Ue=de.indexOf(G);return Ue===-1?Q:de[Ue]}class Se extends R{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[r.localize(105,null),r.localize(106,null)],default:Q.insertMode,description:r.localize(107,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:r.localize(108,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:r.localize(109,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:r.localize(110,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:r.localize(111,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:r.localize(112,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:r.localize(113,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:r.localize(114,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:r.localize(115,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:r.localize(116,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:r.localize(117,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:r.localize(118,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:r.localize(119,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:r.localize(120,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:r.localize(121,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:r.localize(122,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:r.localize(123,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:r.localize(124,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:r.localize(125,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:r.localize(126,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:r.localize(127,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:r.localize(128,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:r.localize(129,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:r.localize(130,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:r.localize(131,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:r.localize(132,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:r.localize(133,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:r.localize(134,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:r.localize(135,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:r.localize(136,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:r.localize(137,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:r.localize(138,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:r.localize(139,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:r.localize(140,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:r.localize(141,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:r.localize(142,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:r.localize(143,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:r.localize(144,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:r.localize(145,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:r.localize(146,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const de=Q;return{insertMode:C(de.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(de.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(de.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(de.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(de.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:s(de.showIcons,this.defaultValue.showIcons),showStatusBar:s(de.showStatusBar,this.defaultValue.showStatusBar),preview:s(de.preview,this.defaultValue.preview),previewMode:C(de.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(de.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(de.showMethods,this.defaultValue.showMethods),showFunctions:s(de.showFunctions,this.defaultValue.showFunctions),showConstructors:s(de.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(de.showDeprecated,this.defaultValue.showDeprecated),showFields:s(de.showFields,this.defaultValue.showFields),showVariables:s(de.showVariables,this.defaultValue.showVariables),showClasses:s(de.showClasses,this.defaultValue.showClasses),showStructs:s(de.showStructs,this.defaultValue.showStructs),showInterfaces:s(de.showInterfaces,this.defaultValue.showInterfaces),showModules:s(de.showModules,this.defaultValue.showModules),showProperties:s(de.showProperties,this.defaultValue.showProperties),showEvents:s(de.showEvents,this.defaultValue.showEvents),showOperators:s(de.showOperators,this.defaultValue.showOperators),showUnits:s(de.showUnits,this.defaultValue.showUnits),showValues:s(de.showValues,this.defaultValue.showValues),showConstants:s(de.showConstants,this.defaultValue.showConstants),showEnums:s(de.showEnums,this.defaultValue.showEnums),showEnumMembers:s(de.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(de.showKeywords,this.defaultValue.showKeywords),showWords:s(de.showWords,this.defaultValue.showWords),showColors:s(de.showColors,this.defaultValue.showColors),showFiles:s(de.showFiles,this.defaultValue.showFiles),showReferences:s(de.showReferences,this.defaultValue.showReferences),showFolders:s(de.showFolders,this.defaultValue.showFolders),showTypeParameters:s(de.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(de.showSnippets,this.defaultValue.showSnippets),showUsers:s(de.showUsers,this.defaultValue.showUsers),showIssues:s(de.showIssues,this.defaultValue.showIssues)}}}class xe extends R{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:r.localize(147,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Ve extends d{constructor(){super(130)}compute(Q,de,Ue){return de.get(81)?!0:Q.tabFocusMode}}var Qe;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Qe=e.WrappingIndent||(e.WrappingIndent={}));function nt(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class rt extends d{constructor(){super(132)}compute(Q,de,Ue){const qe=de.get(131);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:qe.isWordWrapMinified,isViewportWrapping:qe.isViewportWrapping,wrappingColumn:qe.wrappingColumn}}}const Je="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",pt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:t.isMacintosh?Ze:t.isLinux?pt:Je,fontWeight:"normal",fontSize:t.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function Fe(G){return e.editorOptionsRegistry[G.id]=G,G}var At;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.emptySelectionClipboard=32]="emptySelectionClipboard",G[G.extraEditorClassName=33]="extraEditorClassName",G[G.fastScrollSensitivity=34]="fastScrollSensitivity",G[G.find=35]="find",G[G.fixedOverflowWidgets=36]="fixedOverflowWidgets",G[G.folding=37]="folding",G[G.foldingStrategy=38]="foldingStrategy",G[G.foldingHighlight=39]="foldingHighlight",G[G.foldingImportsByDefault=40]="foldingImportsByDefault",G[G.foldingMaximumRegions=41]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=43]="fontFamily",G[G.fontInfo=44]="fontInfo",G[G.fontLigatures=45]="fontLigatures",G[G.fontSize=46]="fontSize",G[G.fontWeight=47]="fontWeight",G[G.formatOnPaste=48]="formatOnPaste",G[G.formatOnType=49]="formatOnType",G[G.glyphMargin=50]="glyphMargin",G[G.gotoLocation=51]="gotoLocation",G[G.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",G[G.hover=53]="hover",G[G.inDiffEditor=54]="inDiffEditor",G[G.inlineSuggest=55]="inlineSuggest",G[G.letterSpacing=56]="letterSpacing",G[G.lightbulb=57]="lightbulb",G[G.lineDecorationsWidth=58]="lineDecorationsWidth",G[G.lineHeight=59]="lineHeight",G[G.lineNumbers=60]="lineNumbers",G[G.lineNumbersMinChars=61]="lineNumbersMinChars",G[G.linkedEditing=62]="linkedEditing",G[G.links=63]="links",G[G.matchBrackets=64]="matchBrackets",G[G.minimap=65]="minimap",G[G.mouseStyle=66]="mouseStyle",G[G.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=68]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",G[G.multiCursorModifier=70]="multiCursorModifier",G[G.multiCursorPaste=71]="multiCursorPaste",G[G.occurrencesHighlight=72]="occurrencesHighlight",G[G.overviewRulerBorder=73]="overviewRulerBorder",G[G.overviewRulerLanes=74]="overviewRulerLanes",G[G.padding=75]="padding",G[G.parameterHints=76]="parameterHints",G[G.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",G[G.quickSuggestions=79]="quickSuggestions",G[G.quickSuggestionsDelay=80]="quickSuggestionsDelay",G[G.readOnly=81]="readOnly",G[G.renameOnType=82]="renameOnType",G[G.renderControlCharacters=83]="renderControlCharacters",G[G.renderFinalNewline=84]="renderFinalNewline",G[G.renderLineHighlight=85]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=87]="renderValidationDecorations",G[G.renderWhitespace=88]="renderWhitespace",G[G.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",G[G.roundedSelection=90]="roundedSelection",G[G.rulers=91]="rulers",G[G.scrollbar=92]="scrollbar",G[G.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=94]="scrollBeyondLastLine",G[G.scrollPredominantAxis=95]="scrollPredominantAxis",G[G.selectionClipboard=96]="selectionClipboard",G[G.selectionHighlight=97]="selectionHighlight",G[G.selectOnLineNumbers=98]="selectOnLineNumbers",G[G.showFoldingControls=99]="showFoldingControls",G[G.showUnused=100]="showUnused",G[G.snippetSuggestions=101]="snippetSuggestions",G[G.smartSelect=102]="smartSelect",G[G.smoothScrolling=103]="smoothScrolling",G[G.stickyTabStops=104]="stickyTabStops",G[G.stopRenderingLineAfter=105]="stopRenderingLineAfter",G[G.suggest=106]="suggest",G[G.suggestFontSize=107]="suggestFontSize",G[G.suggestLineHeight=108]="suggestLineHeight",G[G.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",G[G.suggestSelection=110]="suggestSelection",G[G.tabCompletion=111]="tabCompletion",G[G.tabIndex=112]="tabIndex",G[G.unicodeHighlighting=113]="unicodeHighlighting",G[G.unusualLineTerminators=114]="unusualLineTerminators",G[G.useShadowDOM=115]="useShadowDOM",G[G.useTabStops=116]="useTabStops",G[G.wordSeparators=117]="wordSeparators",G[G.wordWrap=118]="wordWrap",G[G.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=121]="wordWrapColumn",G[G.wordWrapOverride1=122]="wordWrapOverride1",G[G.wordWrapOverride2=123]="wordWrapOverride2",G[G.wrappingIndent=124]="wrappingIndent",G[G.wrappingStrategy=125]="wrappingStrategy",G[G.showDeprecated=126]="showDeprecated",G[G.inlayHints=127]="inlayHints",G[G.editorClassName=128]="editorClassName",G[G.pixelRatio=129]="pixelRatio",G[G.tabFocusMode=130]="tabFocusMode",G[G.layoutInfo=131]="layoutInfo",G[G.wrappingInfo=132]="wrappingInfo"})(At=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:r.localize(148,null)})),acceptSuggestionOnEnter:Fe(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",r.localize(149,null),""],markdownDescription:r.localize(150,null)})),accessibilitySupport:Fe(new n),accessibilityPageSize:Fe(new S(3,"accessibilityPageSize",10,1,1073741824,{description:r.localize(151,null)})),ariaLabel:Fe(new p(4,"ariaLabel",r.localize(152,null))),autoClosingBrackets:Fe(new a(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(153,null),r.localize(154,null),""],description:r.localize(155,null)})),autoClosingDelete:Fe(new a(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",r.localize(156,null),""],description:r.localize(157,null)})),autoClosingOvertype:Fe(new a(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",r.localize(158,null),""],description:r.localize(159,null)})),autoClosingQuotes:Fe(new a(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",r.localize(160,null),r.localize(161,null),""],description:r.localize(162,null)})),autoIndent:Fe(new M(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[r.localize(163,null),r.localize(164,null),r.localize(165,null),r.localize(166,null),r.localize(167,null)],description:r.localize(168,null)})),automaticLayout:Fe(new m(10,"automaticLayout",!1)),autoSurround:Fe(new a(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[r.localize(169,null),r.localize(170,null),r.localize(171,null),""],description:r.localize(172,null)})),bracketPairColorization:Fe(new j),bracketPairGuides:Fe(new Y),stickyTabStops:Fe(new m(104,"stickyTabStops",!1,{description:r.localize(173,null)})),codeLens:Fe(new m(14,"codeLens",!0,{description:r.localize(174,null)})),codeLensFontFamily:Fe(new p(15,"codeLensFontFamily","",{description:r.localize(175,null)})),codeLensFontSize:Fe(new S(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:r.localize(176,null)})),colorDecorators:Fe(new m(17,"colorDecorators",!0,{description:r.localize(177,null)})),columnSelection:Fe(new m(18,"columnSelection",!1,{description:r.localize(178,null)})),comments:Fe(new u),contextmenu:Fe(new m(20,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new m(21,"copyWithSyntaxHighlighting",!0,{description:r.localize(179,null)})),cursorBlinking:Fe(new M(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],c,{description:r.localize(180,null)})),cursorSmoothCaretAnimation:Fe(new m(23,"cursorSmoothCaretAnimation",!1,{description:r.localize(181,null)})),cursorStyle:Fe(new M(24,"cursorStyle",h.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],E,{description:r.localize(182,null)})),cursorSurroundingLines:Fe(new S(25,"cursorSurroundingLines",0,0,1073741824,{description:r.localize(183,null)})),cursorSurroundingLinesStyle:Fe(new a(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[r.localize(184,null),r.localize(185,null)],description:r.localize(186,null)})),cursorWidth:Fe(new S(27,"cursorWidth",0,0,1073741824,{markdownDescription:r.localize(187,null)})),disableLayerHinting:Fe(new m(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new m(29,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new m(30,"domReadOnly",!1)),dragAndDrop:Fe(new m(31,"dragAndDrop",!0,{description:r.localize(188,null)})),emptySelectionClipboard:Fe(new k),extraEditorClassName:Fe(new p(33,"extraEditorClassName","")),fastScrollSensitivity:Fe(new b(34,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:r.localize(189,null)})),find:Fe(new x),fixedOverflowWidgets:Fe(new m(36,"fixedOverflowWidgets",!1)),folding:Fe(new m(37,"folding",!0,{description:r.localize(190,null)})),foldingStrategy:Fe(new a(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[r.localize(191,null),r.localize(192,null)],description:r.localize(193,null)})),foldingHighlight:Fe(new m(39,"foldingHighlight",!0,{description:r.localize(194,null)})),foldingImportsByDefault:Fe(new m(40,"foldingImportsByDefault",!1,{description:r.localize(195,null)})),foldingMaximumRegions:Fe(new S(41,"foldingMaximumRegions",5e3,10,65e3,{description:r.localize(196,null)})),unfoldOnClickAfterEndOfLine:Fe(new m(42,"unfoldOnClickAfterEndOfLine",!1,{description:r.localize(197,null)})),fontFamily:Fe(new p(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:r.localize(198,null)})),fontInfo:Fe(new y),fontLigatures2:Fe(new N),fontSize:Fe(new L),fontWeight:Fe(new W),formatOnPaste:Fe(new m(48,"formatOnPaste",!1,{description:r.localize(199,null)})),formatOnType:Fe(new m(49,"formatOnType",!1,{description:r.localize(200,null)})),glyphMargin:Fe(new m(50,"glyphMargin",!0,{description:r.localize(201,null)})),gotoLocation:Fe(new B),hideCursorInOverviewRuler:Fe(new m(52,"hideCursorInOverviewRuler",!1,{description:r.localize(202,null)})),hover:Fe(new $),inDiffEditor:Fe(new m(54,"inDiffEditor",!1)),letterSpacing:Fe(new b(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>b.clamp(G,-5,20),{description:r.localize(203,null)})),lightbulb:Fe(new se),lineDecorationsWidth:Fe(new l(58,"lineDecorationsWidth",10)),lineHeight:Fe(new ge),lineNumbers:Fe(new je),lineNumbersMinChars:Fe(new S(61,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new m(62,"linkedEditing",!1,{description:r.localize(204,null)})),links:Fe(new m(63,"links",!0,{description:r.localize(205,null)})),matchBrackets:Fe(new a(64,"matchBrackets","always",["always","near","never"],{description:r.localize(206,null)})),minimap:Fe(new be),mouseStyle:Fe(new a(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new b(67,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:r.localize(207,null)})),mouseWheelZoom:Fe(new m(68,"mouseWheelZoom",!1,{markdownDescription:r.localize(208,null)})),multiCursorMergeOverlapping:Fe(new m(69,"multiCursorMergeOverlapping",!0,{description:r.localize(209,null)})),multiCursorModifier:Fe(new M(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[r.localize(210,null),r.localize(211,null)],markdownDescription:r.localize(212,null)})),multiCursorPaste:Fe(new a(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[r.localize(213,null),r.localize(214,null)],markdownDescription:r.localize(215,null)})),occurrencesHighlight:Fe(new m(72,"occurrencesHighlight",!0,{description:r.localize(216,null)})),overviewRulerBorder:Fe(new m(73,"overviewRulerBorder",!0,{description:r.localize(217,null)})),overviewRulerLanes:Fe(new S(74,"overviewRulerLanes",3,0,3)),padding:Fe(new fe),parameterHints:Fe(new oe),peekWidgetDefaultFocus:Fe(new a(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[r.localize(218,null),r.localize(219,null)],description:r.localize(220,null)})),definitionLinkOpensInPeek:Fe(new m(78,"definitionLinkOpensInPeek",!1,{description:r.localize(221,null)})),quickSuggestions:Fe(new Pe),quickSuggestionsDelay:Fe(new S(80,"quickSuggestionsDelay",10,0,1073741824,{description:r.localize(222,null)})),readOnly:Fe(new m(81,"readOnly",!1)),renameOnType:Fe(new m(82,"renameOnType",!1,{description:r.localize(223,null),markdownDeprecationMessage:r.localize(224,null)})),renderControlCharacters:Fe(new m(83,"renderControlCharacters",!0,{description:r.localize(225,null),restricted:!0})),renderFinalNewline:Fe(new m(84,"renderFinalNewline",!0,{description:r.localize(226,null)})),renderLineHighlight:Fe(new a(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",r.localize(227,null)],description:r.localize(228,null)})),renderLineHighlightOnlyWhenFocus:Fe(new m(86,"renderLineHighlightOnlyWhenFocus",!1,{description:r.localize(229,null)})),renderValidationDecorations:Fe(new a(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new a(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",r.localize(230,null),r.localize(231,null),r.localize(232,null),""],description:r.localize(233,null)})),revealHorizontalRightPadding:Fe(new S(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Fe(new m(90,"roundedSelection",!0,{description:r.localize(234,null)})),rulers:Fe(new et),scrollbar:Fe(new H),scrollBeyondLastColumn:Fe(new S(93,"scrollBeyondLastColumn",5,0,1073741824,{description:r.localize(235,null)})),scrollBeyondLastLine:Fe(new m(94,"scrollBeyondLastLine",!0,{description:r.localize(236,null)})),scrollPredominantAxis:Fe(new m(95,"scrollPredominantAxis",!0,{description:r.localize(237,null)})),selectionClipboard:Fe(new m(96,"selectionClipboard",!0,{description:r.localize(238,null),included:t.isLinux})),selectionHighlight:Fe(new m(97,"selectionHighlight",!0,{description:r.localize(239,null)})),selectOnLineNumbers:Fe(new m(98,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new a(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[r.localize(240,null),r.localize(241,null)],description:r.localize(242,null)})),showUnused:Fe(new m(100,"showUnused",!0,{description:r.localize(243,null)})),showDeprecated:Fe(new m(126,"showDeprecated",!0,{description:r.localize(244,null)})),inlayHints:Fe(new X),snippetSuggestions:Fe(new a(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[r.localize(245,null),r.localize(246,null),r.localize(247,null),r.localize(248,null)],description:r.localize(249,null)})),smartSelect:Fe(new xe),smoothScrolling:Fe(new m(103,"smoothScrolling",!1,{description:r.localize(250,null)})),stopRenderingLineAfter:Fe(new S(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new Se),inlineSuggest:Fe(new z),suggestFontSize:Fe(new S(107,"suggestFontSize",0,0,1e3,{markdownDescription:r.localize(251,null)})),suggestLineHeight:Fe(new S(108,"suggestLineHeight",0,0,1e3,{markdownDescription:r.localize(252,null)})),suggestOnTriggerCharacters:Fe(new m(109,"suggestOnTriggerCharacters",!0,{description:r.localize(253,null)})),suggestSelection:Fe(new a(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[r.localize(254,null),r.localize(255,null),r.localize(256,null)],description:r.localize(257,null)})),tabCompletion:Fe(new a(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[r.localize(258,null),r.localize(259,null),r.localize(260,null)],description:r.localize(261,null)})),tabIndex:Fe(new S(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new K),unusualLineTerminators:Fe(new a(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[r.localize(262,null),r.localize(263,null),r.localize(264,null)],description:r.localize(265,null)})),useShadowDOM:Fe(new m(115,"useShadowDOM",!0)),useTabStops:Fe(new m(116,"useTabStops",!0,{description:r.localize(266,null)})),wordSeparators:Fe(new p(117,"wordSeparators",_.USUAL_WORD_SEPARATORS,{description:r.localize(267,null)})),wordWrap:Fe(new a(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[r.localize(268,null),r.localize(269,null),r.localize(270,null),r.localize(271,null)],description:r.localize(272,null)})),wordWrapBreakAfterCharacters:Fe(new p(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new p(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new S(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:r.localize(273,null)})),wordWrapOverride1:Fe(new a(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new a(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Fe(new M(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],nt,{enumDescriptions:[r.localize(274,null),r.localize(275,null),r.localize(276,null),r.localize(277,null)],description:r.localize(278,null)})),wrappingStrategy:Fe(new a(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[r.localize(279,null),r.localize(280,null)],description:r.localize(281,null)})),editorClassName:Fe(new v),pixelRatio:Fe(new Ee),tabFocusMode:Fe(new Ve),layoutInfo:Fe(new ie),wrappingInfo:Fe(new rt)}}),define(ye[114],_e([18,19]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[115],_e([18,19]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[116],_e([18,19]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(ye[117],_e([18,19]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(ye[118],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[119],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[120],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[121],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[122],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[123],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[124],_e([18,19]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[125],_e([18,19]),function(ee,e){return ee.create("vs/workbench/common/editor",e)}),define(ye[126],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[127],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ye[128],_e([18,19]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ye[129],_e([18,19]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[130],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var r;(function(I){I[I.ACTIVATE=1]="ACTIVATE",I[I.RESTORE=2]="RESTORE",I[I.PRESERVE=3]="PRESERVE"})(r=e.EditorActivation||(e.EditorActivation={}));var t;(function(I){I[I.PICK=0]="PICK",I[I.DISABLED=1]="DISABLED",I[I.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(t=e.EditorResolution||(e.EditorResolution={}));var _;(function(I){I[I.API=0]="API",I[I.USER=1]="USER"})(_=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(I){I[I.Center=0]="Center",I[I.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",I[I.NearTop=2]="NearTop",I[I.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ye[131],_e([0,1,115]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const t=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,_=/^-(\d{4})(\d{2})(\d{2})$/;function A(i){return i=i.trim(),i==="*"||t.test(i)}e.isValidVersionStr=A;function I(i){if(!A(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=i.match(t);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=I;function P(i){if(!i)return null;let d=i.majorBase,l=i.majorMustEqual,s=i.minorBase,m=i.minorMustEqual,F=i.patchBase,S=i.patchMustEqual;i.hasCaret&&(d===0||(m=!1),S=!1);let b=0;if(i.preRelease){const p=_.exec(i.preRelease);if(p){const[,C,a,M]=p;b=Date.UTC(Number(C),Number(a)-1,Number(M))}}return{majorBase:d,majorMustEqual:l,minorBase:s,minorMustEqual:m,patchBase:F,patchMustEqual:S,isMinimum:i.hasGreaterEquals,notBefore:b}}e.normalizeVersion=P;function D(i,d,l){let s;typeof i=="string"?s=P(I(i)):s=i;let m;d instanceof Date?m=d.getTime():typeof d=="string"&&(m=new Date(d).getTime());let F;if(typeof l=="string"?F=P(I(l)):F=l,!s||!F)return!1;let S=s.majorBase,b=s.minorBase,p=s.patchBase,C=F.majorBase,a=F.minorBase,M=F.patchBase,o=F.notBefore,n=F.majorMustEqual,u=F.minorMustEqual,f=F.patchMustEqual;return F.isMinimum?S>C?!0:S<C?!1:b>a?!0:b<a||m&&m<o?!1:p>=M:(S===1&&C===0&&(!n||!u||!f)&&(C=1,a=0,M=0,n=!0,u=!1,f=!1),S<C?!1:S>C?!n:b<a?!1:b>a?!u:p<M?!1:p>M?!f:!(m&&m<o))}e.isValidVersion=D;function T(i,d,l,s){return l.isBuiltin||typeof l.main=="undefined"?!0:w(i,d,l.engines.vscode,s)}e.isValidExtensionVersion=T;function R(i,d,l){return i==="*"||w(d,l,i)}e.isEngineValid=R;function w(i,d,l,s=[]){let m=P(I(l));if(!m)return s.push(r.localize(0,null,l)),!1;if(m.majorBase===0){if(!m.majorMustEqual||!m.minorMustEqual)return s.push(r.localize(1,null,l)),!1}else if(!m.majorMustEqual)return s.push(r.localize(2,null,l)),!1;return D(i,d,m)?!0:(s.push(r.localize(3,null,i,l)),!1)}}),define(ye[78],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class r{constructor(_,A=[],I=!1){this.ctor=_,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.SyncDescriptor=r}),define(ye[44],_e([0,1,78]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function _(I,P,D){P instanceof r.SyncDescriptor||(P=new r.SyncDescriptor(P,[],D)),t.push([I,P])}e.registerSingleton=_;function A(){return t}e.getSingletonServiceDescriptors=A}),define(ye[132],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class r{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=r;class t{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let I of this._nodes.values())I.outgoing.size===0&&A.push(I);return A}insertEdge(A,I){const P=this.lookupOrInsertNode(A),D=this.lookupOrInsertNode(I);P.outgoing.set(this._hashFn(I),D),D.incoming.set(this._hashFn(A),P)}removeNode(A){const I=this._hashFn(A);this._nodes.delete(I);for(let P of this._nodes.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(A){const I=this._hashFn(A);let P=this._nodes.get(I);return P||(P=new r(A),this._nodes.set(I,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[I,P]of this._nodes)A.push(`${I}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,I]of this._nodes){const P=new Set([A]),D=this._findCycle(I,P);if(D)return D}}_findCycle(A,I){for(let[P,D]of A.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const T=this._findCycle(D,I);if(T)return T;I.delete(P)}}}e.Graph=t}),define(ye[3],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var r;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(D){return D[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(r=e._util||(e._util={})),e.IInstantiationService=_("instantiationService");function t(I,P,D,T){P[r.DI_TARGET]===P?P[r.DI_DEPENDENCIES].push({id:I,index:D,optional:T}):(P[r.DI_DEPENDENCIES]=[{id:I,index:D,optional:T}],P[r.DI_TARGET]=P)}function _(I){if(r.serviceIds.has(I))return r.serviceIds.get(I);const P=function(D,T,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(P,D,R,!1)};return P.toString=()=>I,r.serviceIds.set(I,P),P}e.createDecorator=_;function A(I){return I}e.refineServiceDecorator=A}),define(ye[133],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,r.createDecorator)("modelService");function t(_){return!_.isTooLargeForSyncing()&&!_.isForSimpleWidget}e.shouldSynchronizeModel=t}),define(ye[134],_e([0,1,4,6,56,133]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRegistry=void 0;function I(D){return typeof D=="string"?!1:Array.isArray(D)?D.every(I):!!D.exclusive}class P{constructor(){this._clock=0,this._entries=[],this._onDidChange=new r.Emitter}get onDidChange(){return this._onDidChange.event}register(T,R){let w={selector:T,provider:R,_score:-1,_time:this._clock++};return this._entries.push(w),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,t.toDisposable)(()=>{if(w){const i=this._entries.indexOf(w);i>=0&&(this._entries.splice(i,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),w=void 0)}})}has(T){return this.all(T).length>0}all(T){if(!T)return[];this._updateScores(T);const R=[];for(let w of this._entries)w._score>0&&R.push(w.provider);return R}ordered(T){const R=[];return this._orderedForEach(T,w=>R.push(w.provider)),R}orderedGroups(T){const R=[];let w,i;return this._orderedForEach(T,d=>{w&&i===d._score?w.push(d.provider):(i=d._score,w=[d.provider],R.push(w))}),R}_orderedForEach(T,R){if(!!T){this._updateScores(T);for(const w of this._entries)w._score>0&&R(w)}}_updateScores(T){const R={uri:T.uri.toString(),language:T.getLanguageId()};if(!(this._lastCandidate&&this._lastCandidate.language===R.language&&this._lastCandidate.uri===R.uri)){this._lastCandidate=R;for(let w of this._entries)if(w._score=(0,_.score)(w.selector,T.uri,T.getLanguageId(),(0,A.shouldSynchronizeModel)(T)),I(w.selector)&&w._score>0){for(let i of this._entries)i._score=0;w._score=1e3;break}this._entries.sort(P._compareByScoreAndTime)}}static _compareByScoreAndTime(T,R){return T._score<R._score?1:T._score>R._score?-1:T._time<R._time?1:T._time>R._time?-1:0}}e.LanguageFeatureRegistry=P}),define(ye[57],_e([0,1,2,58,134,107,52]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));var D;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(D=e.FontStyle||(e.FontStyle={}));var T;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(T=e.ColorId||(e.ColorId={}));var R;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(R=e.StandardTokenType||(e.StandardTokenType={}));var w;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=15360]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=1024]="ITALIC_MASK",v[v.BOLD_MASK=2048]="BOLD_MASK",v[v.UNDERLINE_MASK=4096]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=8192]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=10]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(w=e.MetadataConsts||(e.MetadataConsts={}));class i{static getLanguageId(k){return(k&255)>>>0}static getTokenType(k){return(k&768)>>>8}static getFontStyle(k){return(k&15360)>>>10}static getForeground(k){return(k&8372224)>>>14}static getBackground(k){return(k&4286578688)>>>23}static getClassNameFromMetadata(k){const x=this.getForeground(k);let N="mtk"+x;const y=this.getFontStyle(k);return y&1&&(N+=" mtki"),y&2&&(N+=" mtkb"),y&4&&(N+=" mtku"),y&8&&(N+=" mtks"),N}static getInlineStyleFromMetadata(k,x){const N=this.getForeground(k),y=this.getFontStyle(k);let L=`color: ${x[N]};`;y&1&&(L+="font-style: italic;"),y&2&&(L+="font-weight: bold;");let W="";return y&4&&(W+=" underline"),y&8&&(W+=" line-through"),W&&(L+=`text-decoration:${W};`),L}static getPresentationFromMetadata(k){const x=this.getForeground(k),N=this.getFontStyle(k);return{foreground:x,italic:Boolean(N&1),bold:Boolean(N&2),underline:Boolean(N&4),strikethrough:Boolean(N&8)}}}e.TokenMetadata=i;var d;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(d=e.CompletionItemKind||(e.CompletionItemKind={}));var l;(function(v){const k=new Map;k.set(0,I.Codicon.symbolMethod),k.set(1,I.Codicon.symbolFunction),k.set(2,I.Codicon.symbolConstructor),k.set(3,I.Codicon.symbolField),k.set(4,I.Codicon.symbolVariable),k.set(5,I.Codicon.symbolClass),k.set(6,I.Codicon.symbolStruct),k.set(7,I.Codicon.symbolInterface),k.set(8,I.Codicon.symbolModule),k.set(9,I.Codicon.symbolProperty),k.set(10,I.Codicon.symbolEvent),k.set(11,I.Codicon.symbolOperator),k.set(12,I.Codicon.symbolUnit),k.set(13,I.Codicon.symbolValue),k.set(15,I.Codicon.symbolEnum),k.set(14,I.Codicon.symbolConstant),k.set(15,I.Codicon.symbolEnum),k.set(16,I.Codicon.symbolEnumMember),k.set(17,I.Codicon.symbolKeyword),k.set(27,I.Codicon.symbolSnippet),k.set(18,I.Codicon.symbolText),k.set(19,I.Codicon.symbolColor),k.set(20,I.Codicon.symbolFile),k.set(21,I.Codicon.symbolReference),k.set(22,I.Codicon.symbolCustomColor),k.set(23,I.Codicon.symbolFolder),k.set(24,I.Codicon.symbolTypeParameter),k.set(25,I.Codicon.account),k.set(26,I.Codicon.issues);function x(L){let W=k.get(L);return W||(console.info("No codicon found for CompletionItemKind "+L),W=I.Codicon.symbolProperty),W}v.toIcon=x;const N=new Map;N.set("method",0),N.set("function",1),N.set("constructor",2),N.set("field",3),N.set("variable",4),N.set("class",5),N.set("struct",6),N.set("interface",7),N.set("module",8),N.set("property",9),N.set("event",10),N.set("operator",11),N.set("unit",12),N.set("value",13),N.set("constant",14),N.set("enum",15),N.set("enum-member",16),N.set("enumMember",16),N.set("keyword",17),N.set("snippet",27),N.set("text",18),N.set("color",19),N.set("file",20),N.set("reference",21),N.set("customcolor",22),N.set("folder",23),N.set("type-parameter",24),N.set("typeParameter",24),N.set("account",25),N.set("issue",26);function y(L,W){let B=N.get(L);return typeof B=="undefined"&&!W&&(B=9),B}v.fromString=y})(l=e.CompletionItemKinds||(e.CompletionItemKinds={}));var s;(function(v){v[v.Deprecated=1]="Deprecated"})(s=e.CompletionItemTag||(e.CompletionItemTag={}));var m;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(m=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var F;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(F=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var S;(function(v){v[v.Automatic=0]="Automatic",v[v.Explicit=1]="Explicit"})(S=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var b;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(b=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var p;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(p=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var C;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(C=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function a(v){return v&&r.URI.isUri(v.uri)&&t.Range.isIRange(v.range)&&(t.Range.isIRange(v.originSelectionRange)||t.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=a;var M;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(M=e.SymbolKind||(e.SymbolKind={}));var o;(function(v){v[v.Deprecated=1]="Deprecated"})(o=e.SymbolTag||(e.SymbolTag={}));var n;(function(v){const k=new Map;k.set(0,I.Codicon.symbolFile),k.set(1,I.Codicon.symbolModule),k.set(2,I.Codicon.symbolNamespace),k.set(3,I.Codicon.symbolPackage),k.set(4,I.Codicon.symbolClass),k.set(5,I.Codicon.symbolMethod),k.set(6,I.Codicon.symbolProperty),k.set(7,I.Codicon.symbolField),k.set(8,I.Codicon.symbolConstructor),k.set(9,I.Codicon.symbolEnum),k.set(10,I.Codicon.symbolInterface),k.set(11,I.Codicon.symbolFunction),k.set(12,I.Codicon.symbolVariable),k.set(13,I.Codicon.symbolConstant),k.set(14,I.Codicon.symbolString),k.set(15,I.Codicon.symbolNumber),k.set(16,I.Codicon.symbolBoolean),k.set(17,I.Codicon.symbolArray),k.set(18,I.Codicon.symbolObject),k.set(19,I.Codicon.symbolKey),k.set(20,I.Codicon.symbolNull),k.set(21,I.Codicon.symbolEnumMember),k.set(22,I.Codicon.symbolStruct),k.set(23,I.Codicon.symbolEvent),k.set(24,I.Codicon.symbolOperator),k.set(25,I.Codicon.symbolTypeParameter);function x(N){let y=k.get(N);return y||(console.info("No codicon found for SymbolKind "+N),y=I.Codicon.symbolProperty),y}v.toIcon=x})(n=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(k){this.value=k}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var f;(function(v){function k(x){return!x||typeof x!="object"?!1:typeof x.id=="string"&&typeof x.title=="string"}v.is=k})(f=e.Command||(e.Command={}));var c;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(c=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var g;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(g=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new _.LanguageFeatureRegistry,e.RenameProviderRegistry=new _.LanguageFeatureRegistry,e.CompletionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new _.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new _.LanguageFeatureRegistry,e.HoverProviderRegistry=new _.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new _.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new _.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new _.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new _.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new _.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new _.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new _.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new _.LanguageFeatureRegistry,e.LinkProviderRegistry=new _.LanguageFeatureRegistry,e.ColorProviderRegistry=new _.LanguageFeatureRegistry,e.SelectionRangeRegistry=new _.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new _.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistry;var E;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(E=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[79],_e([0,1,10,2,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationOverrides=A;function I(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||r.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=I;var P;(function(m){m[m.USER=1]="USER",m[m.USER_LOCAL=2]="USER_LOCAL",m[m.USER_REMOTE=3]="USER_REMOTE",m[m.WORKSPACE=4]="WORKSPACE",m[m.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",m[m.DEFAULT=6]="DEFAULT",m[m.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(m){switch(m){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function T(m,F){const S=Object.create(null);for(let b in m)R(S,b,m[b],F);return S}e.toValuesTree=T;function R(m,F,S,b){const p=F.split("."),C=p.pop();let a=m;for(let M=0;M<p.length;M++){let o=p[M],n=a[o];switch(typeof n){case"undefined":n=a[o]=Object.create(null);break;case"object":break;default:b(`Ignoring ${F} as ${p.slice(0,M+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[C]=S}catch{b(`Ignoring ${F} as ${p.join(".")} is ${JSON.stringify(a)}`)}else b(`Ignoring ${F} as ${p.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=R;function w(m,F){const S=F.split(".");i(m,S)}e.removeFromValueTree=w;function i(m,F){const S=F.shift();if(F.length===0){delete m[S];return}if(Object.keys(m).indexOf(S)!==-1){const b=m[S];typeof b=="object"&&!Array.isArray(b)&&(i(b,F),Object.keys(b).length===0&&delete m[S])}}function d(m,F,S){function b(a,M){let o=a;for(const n of M){if(typeof o!="object"||o===null)return;o=o[n]}return o}const p=F.split("."),C=b(m,p);return typeof C=="undefined"?S:C}e.getConfigurationValue=d;function l(m,F,S){Object.keys(F).forEach(b=>{b!=="__proto__"&&(b in m?r.isObject(m[b])&&r.isObject(F[b])?l(m[b],F[b],S):S&&(m[b]=F[b]):m[b]=F[b])})}e.merge=l;function s(m,F,S){const b=m.inspect(F),p=m.inspect(S);return typeof b.userValue!="undefined"||typeof b.workspaceValue!="undefined"||typeof b.workspaceFolderValue!="undefined"?b.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:b.defaultValue}e.getMigratedSettingValue=s}),define(ye[45],_e([0,1,23,9,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=r.userAgent||"";const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",r.isMacintosh),I.set("isLinux",r.isLinux),I.set("isWindows",r.isWindows),I.set("isWeb",r.isWeb),I.set("isMacNative",r.isMacintosh&&!r.isWeb),I.set("isEdge",A.indexOf("Edg/")>=0),I.set("isFirefox",A.indexOf("Firefox")>=0),I.set("isChrome",A.indexOf("Chrome")>=0),I.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var D;(function(N){N[N.False=0]="False",N[N.True=1]="True",N[N.Defined=2]="Defined",N[N.Not=3]="Not",N[N.Equals=4]="Equals",N[N.NotEquals=5]="NotEquals",N[N.And=6]="And",N[N.Regex=7]="Regex",N[N.NotRegex=8]="NotRegex",N[N.Or=9]="Or",N[N.In=10]="In",N[N.NotIn=11]="NotIn",N[N.Greater=12]="Greater",N[N.GreaterEquals=13]="GreaterEquals",N[N.Smaller=14]="Smaller",N[N.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class T{static false(){return i.INSTANCE}static true(){return d.INSTANCE}static has(y){return l.create(y)}static equals(y,L){return s.create(y,L)}static notEquals(y,L){return S.create(y,L)}static regex(y,L){return n.create(y,L)}static in(y,L){return m.create(y,L)}static not(y){return b.create(y)}static and(...y){return c.create(y,null)}static or(...y){return h.create(y,null,!0)}static greater(y,L){return C.create(y,L)}static greaterEquals(y,L){return a.create(y,L)}static smaller(y,L){return M.create(y,L)}static smallerEquals(y,L){return o.create(y,L)}static deserialize(y,L=!1){if(!!y)return this._deserializeOrExpression(y,L)}static _deserializeOrExpression(y,L){let W=y.split("||");return h.create(W.map(B=>this._deserializeAndExpression(B,L)),null,!0)}static _deserializeAndExpression(y,L){let W=y.split("&&");return c.create(W.map(B=>this._deserializeOne(B,L)),null)}static _deserializeOne(y,L){if(y=y.trim(),y.indexOf("!=")>=0){let W=y.split("!=");return S.create(W[0].trim(),this._deserializeValue(W[1],L))}if(y.indexOf("==")>=0){let W=y.split("==");return s.create(W[0].trim(),this._deserializeValue(W[1],L))}if(y.indexOf("=~")>=0){let W=y.split("=~");return n.create(W[0].trim(),this._deserializeRegexValue(W[1],L))}if(y.indexOf(" in ")>=0){let W=y.split(" in ");return m.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(y)){const W=y.split(">=");return a.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(y)){const W=y.split(">");return C.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(y)){const W=y.split("<=");return o.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(y)){const W=y.split("<");return M.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(y)?b.create(y.substr(1).trim()):l.create(y)}static _deserializeValue(y,L){if(y=y.trim(),y==="true")return!0;if(y==="false")return!1;let W=/^'([^']*)'$/.exec(y);return W?W[1].trim():y}static _deserializeRegexValue(y,L){if((0,t.isFalsyOrWhitespace)(y)){if(L)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=y.indexOf("/"),B=y.lastIndexOf("/");if(W===B||W<0){if(L)throw new Error(`bad regexp-value '${y}', missing /-enclosure`);return console.warn(`bad regexp-value '${y}', missing /-enclosure`),null}let $=y.slice(W+1,B),q=y[B+1]==="i"?"i":"";try{return new RegExp($,q)}catch(ie){if(L)throw new Error(`bad regexp-value '${y}', parse error: ${ie}`);return console.warn(`bad regexp-value '${y}', parse error: ${ie}`),null}}}e.ContextKeyExpr=T;function R(N,y){const L=N?N.substituteConstants():void 0,W=y?y.substituteConstants():void 0;return!L&&!W?!0:!L||!W?!1:L.equals(W)}e.expressionsAreEqualWithConstantSubstitution=R;function w(N,y){return N.cmp(y)}class i{constructor(){this.type=0}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!1}serialize(){return"false"}keys(){return[]}map(y){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=i,i.INSTANCE=new i;class d{constructor(){this.type=1}cmp(y){return this.type-y.type}equals(y){return y.type===this.type}substituteConstants(){return this}evaluate(y){return!0}serialize(){return"true"}keys(){return[]}map(y){return this}negate(){return i.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class l{constructor(y,L){this.key=y,this.negated=L,this.type=2}static create(y,L=null){const W=I.get(y);return typeof W=="boolean"?W?d.INSTANCE:i.INSTANCE:new l(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=I.get(this.key);return typeof y=="boolean"?y?d.INSTANCE:i.INSTANCE:this}evaluate(y){return!!y.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(y){return y.mapDefined(this.key)}negate(){return this.negated||(this.negated=b.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=l;class s{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=4}static create(y,L,W=null){if(typeof L=="boolean")return L?l.create(y,W):b.create(y,W);const B=I.get(y);return typeof B=="boolean"?L===(B?"true":"false")?d.INSTANCE:i.INSTANCE:new s(y,L,W)}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=I.get(this.key);if(typeof y=="boolean"){const L=y?"true":"false";return this.value===L?d.INSTANCE:i.INSTANCE}return this}evaluate(y){return y.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(y){return y.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=S.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class m{constructor(y,L){this.key=y,this.valueKey=L,this.type=10,this.negated=null}static create(y,L){return new m(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.valueKey,y.key,y.valueKey)}equals(y){return y.type===this.type?this.key===y.key&&this.valueKey===y.valueKey:!1}substituteConstants(){return this}evaluate(y){const L=y.getValue(this.valueKey),W=y.getValue(this.key);return Array.isArray(L)?L.indexOf(W)>=0:typeof W=="string"&&typeof L=="object"&&L!==null?P.call(L,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(y){return y.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=F.create(this)),this.negated}}e.ContextKeyInExpr=m;class F{constructor(y){this._actual=y,this.type=11}static create(y){return new F(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new F(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotInExpr=F;class S{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=5}static create(y,L,W=null){if(typeof L=="boolean")return L?b.create(y,W):l.create(y,W);const B=I.get(y);return typeof B=="boolean"?L===(B?"true":"false")?i.INSTANCE:d.INSTANCE:new S(y,L,W)}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){const y=I.get(this.key);if(typeof y=="boolean"){const L=y?"true":"false";return this.value===L?i.INSTANCE:d.INSTANCE}return this}evaluate(y){return y.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(y){return y.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=S;class b{constructor(y,L){this.key=y,this.negated=L,this.type=3}static create(y,L=null){const W=I.get(y);return typeof W=="boolean"?W?i.INSTANCE:d.INSTANCE:new b(y,L)}cmp(y){return y.type!==this.type?this.type-y.type:E(this.key,y.key)}equals(y){return y.type===this.type?this.key===y.key:!1}substituteConstants(){const y=I.get(this.key);return typeof y=="boolean"?y?i.INSTANCE:d.INSTANCE:this}evaluate(y){return!y.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(y){return y.mapNot(this.key)}negate(){return this.negated||(this.negated=l.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=b;function p(N,y){if(typeof N=="string"){const L=parseFloat(N);isNaN(L)||(N=L)}return typeof N=="string"||typeof N=="number"?y(N):i.INSTANCE}class C{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=12}static create(y,L,W=null){return p(L,B=>new C(y,B,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=o.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=C;class a{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=13}static create(y,L,W=null){return p(L,B=>new a(y,B,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(y){return y.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=M.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=a;class M{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=14}static create(y,L,W=null){return p(L,B=>new M(y,B,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=M;class o{constructor(y,L,W){this.key=y,this.value=L,this.negated=W,this.type=15}static create(y,L,W=null){return p(L,B=>new o(y,B,W))}cmp(y){return y.type!==this.type?this.type-y.type:v(this.key,this.value,y.key,y.value)}equals(y){return y.type===this.type?this.key===y.key&&this.value===y.value:!1}substituteConstants(){return this}evaluate(y){return typeof this.value=="string"?!1:parseFloat(y.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(y){return y.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=C.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=o;class n{constructor(y,L){this.key=y,this.regexp=L,this.type=7,this.negated=null}static create(y,L){return new n(y,L)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.key<y.key)return-1;if(this.key>y.key)return 1;const L=this.regexp?this.regexp.source:"",W=y.regexp?y.regexp.source:"";return L<W?-1:L>W?1:0}equals(y){if(y.type===this.type){const L=this.regexp?this.regexp.source:"",W=y.regexp?y.regexp.source:"";return this.key===y.key&&L===W}return!1}substituteConstants(){return this}evaluate(y){let L=y.getValue(this.key);return this.regexp?this.regexp.test(L):!1}serialize(){const y=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${y}`}keys(){return[this.key]}map(y){return y.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=u.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class u{constructor(y){this._actual=y,this.type=8}static create(y){return new u(y)}cmp(y){return y.type!==this.type?this.type-y.type:this._actual.cmp(y._actual)}equals(y){return y.type===this.type?this._actual.equals(y._actual):!1}substituteConstants(){return this}evaluate(y){return!this._actual.evaluate(y)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(y){return new u(this._actual.map(y))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;function f(N){let y=null;for(let L=0,W=N.length;L<W;L++){const B=N[L].substituteConstants();if(N[L]!==B&&y===null){y=[];for(let $=0;$<L;$++)y[$]=N[$]}y!==null&&(y[L]=B)}return y===null?N:y}class c{constructor(y,L){this.expr=y,this.negated=L,this.type=6}static create(y,L){return c._normalizeArr(y,L)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let L=0,W=this.expr.length;L<W;L++){const B=w(this.expr[L],y.expr[L]);if(B!==0)return B}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let L=0,W=this.expr.length;L<W;L++)if(!this.expr[L].equals(y.expr[L]))return!1;return!0}return!1}substituteConstants(){const y=f(this.expr);return y===this.expr?this:c.create(y,this.negated)}evaluate(y){for(let L=0,W=this.expr.length;L<W;L++)if(!this.expr[L].evaluate(y))return!1;return!0}static _normalizeArr(y,L){const W=[];let B=!1;for(const $ of y)if(!!$){if($.type===1){B=!0;continue}if($.type===0)return i.INSTANCE;if($.type===6){W.push(...$.expr);continue}W.push($)}if(W.length===0&&B)return d.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(w);for(let $=1;$<W.length;$++)W[$-1].equals(W[$])&&(W.splice($,1),$--);if(W.length===1)return W[0];for(;W.length>1;){const $=W[W.length-1];if($.type!==9)break;W.pop();const q=W.pop(),ie=W.length===0,se=h.create($.expr.map(X=>c.create([X,q],null)),null,ie);se&&(W.push(se),W.sort(w))}return W.length===1?W[0]:new c(W,L)}}serialize(){return this.expr.map(y=>y.serialize()).join(" && ")}keys(){const y=[];for(let L of this.expr)y.push(...L.keys());return y}map(y){return new c(this.expr.map(L=>L.map(y)),null)}negate(){if(!this.negated){const y=[];for(let L of this.expr)y.push(L.negate());this.negated=h.create(y,this,!0)}return this.negated}}class h{constructor(y,L){this.expr=y,this.negated=L,this.type=9}static create(y,L,W){return h._normalizeArr(y,L,W)}cmp(y){if(y.type!==this.type)return this.type-y.type;if(this.expr.length<y.expr.length)return-1;if(this.expr.length>y.expr.length)return 1;for(let L=0,W=this.expr.length;L<W;L++){const B=w(this.expr[L],y.expr[L]);if(B!==0)return B}return 0}equals(y){if(y.type===this.type){if(this.expr.length!==y.expr.length)return!1;for(let L=0,W=this.expr.length;L<W;L++)if(!this.expr[L].equals(y.expr[L]))return!1;return!0}return!1}substituteConstants(){const y=f(this.expr);return y===this.expr?this:h.create(y,this.negated,!1)}evaluate(y){for(let L=0,W=this.expr.length;L<W;L++)if(this.expr[L].evaluate(y))return!0;return!1}static _normalizeArr(y,L,W){let B=[],$=!1;if(y){for(let q=0,ie=y.length;q<ie;q++){const se=y[q];if(!!se){if(se.type===0){$=!0;continue}if(se.type===1)return d.INSTANCE;if(se.type===9){B=B.concat(se.expr);continue}B.push(se)}}if(B.length===0&&$)return i.INSTANCE;B.sort(w)}if(B.length!==0){if(B.length===1)return B[0];for(let q=1;q<B.length;q++)B[q-1].equals(B[q])&&(B.splice(q,1),q--);if(B.length===1)return B[0];if(W){for(let q=0;q<B.length;q++)for(let ie=q+1;ie<B.length;ie++)k(B[q],B[ie])&&(B.splice(ie,1),ie--);if(B.length===1)return B[0]}return new h(B,L)}}serialize(){return this.expr.map(y=>y.serialize()).join(" || ")}keys(){const y=[];for(let L of this.expr)y.push(...L.keys());return y}map(y){return new h(this.expr.map(L=>L.map(y)),null)}negate(){if(!this.negated){let y=[];for(let L of this.expr)y.push(L.negate());for(;y.length>1;){const L=y.shift(),W=y.shift(),B=[];for(const q of x(L))for(const ie of x(W))B.push(c.create([q,ie],null));const $=y.length===0;y.unshift(h.create(B,null,$))}this.negated=y[0]}return this.negated}}class g extends l{constructor(y,L,W){super(y,null);this._defaultValue=L,typeof W=="object"?g._info.push({...W,key:y}):W!==!0&&g._info.push({key:y,description:W,type:L!=null?typeof L:void 0})}static all(){return g._info.values()}bindTo(y){return y.createKey(this.key,this._defaultValue)}getValue(y){return y.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(y){return s.create(this.key,y)}notEqualsTo(y){return S.create(this.key,y)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,_.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function E(N,y){return N<y?-1:N>y?1:0}function v(N,y,L,W){return N<L?-1:N>L?1:y<W?-1:y>W?1:0}function k(N,y){if(y.type===6&&N.type!==9&&N.type!==6){for(const B of y.expr)if(N.equals(B))return!0}const L=N.negate(),W=x(L).concat(x(y));W.sort(w);for(let B=0;B<W.length;B++){const q=W[B].negate();for(let ie=B+1;ie<W.length;ie++){const se=W[ie];if(q.equals(se))return!0}}return!1}e.implies=k;function x(N){return N.type===9?N.expr:[N]}}),define(ye[135],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,r.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,r.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[46],_e([0,1,22,17,9,10,2,116,3]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function T(B){return B.create===!0}e.isFileOpenForWriteOptions=T;var R;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var w;(function(B){B[B.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var i;(function(B){B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead"})(i=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(B){return!!(B.capabilities&2)}e.hasReadWriteCapability=d;function l(B){return!!(B.capabilities&8)}e.hasFileFolderCopyCapability=l;function s(B){return!!(B.capabilities&4)}e.hasOpenReadWriteCloseCapability=s;function m(B){return!!(B.capabilities&16)}e.hasFileReadStreamCapability=m;function F(B){return d(B)?!!(B.capabilities&16384):!1}e.hasFileAtomicReadCapability=F;var S;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(S=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor($,q){super($);this.code=q}}e.FileSystemProviderError=b;function p(B,$){const q=new b(B.toString(),$);return a(q,$),q}e.createFileSystemProviderError=p;function C(B){return B||p((0,P.localize)(0,null),S.Unknown)}e.ensureFileSystemProviderError=C;function a(B,$){return B.name=$?`${$} (FileSystemError)`:"FileSystemError",B}e.markAsFileSystemProviderError=a;function M(B){if(!B)return S.Unknown;if(B instanceof b)return B.code;const $=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!$)return S.Unknown;switch($[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileExceedsMemoryLimit:return S.FileExceedsMemoryLimit;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}e.toFileSystemProviderErrorCode=M;function o(B){if(B instanceof g)return B.fileOperationResult;switch(M(B)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 10;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileExceedsMemoryLimit:return 9;case S.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var n;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class u{constructor($,q,ie){this.resource=$,this.operation=q,this.target=ie}isOperation($){return this.operation===$}}e.FileOperationEvent=u;var f;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class c{constructor($,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=$;const ie=new Map;for(const se of $){const X=ie.get(se.type);switch(X?X.push([se.resource,se]):ie.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,X]of ie)switch(se){case 1:this.added=r.TernarySearchTree.forUris(()=>q),this.added.fill(X);break;case 0:this.updated=r.TernarySearchTree.forUris(()=>q),this.updated.fill(X);break;case 2:this.deleted=r.TernarySearchTree.forUris(()=>q),this.deleted.fill(X);break}}contains($,...q){return this.doContains($,{includeChildren:!1},...q)}affects($,...q){return this.doContains($,{includeChildren:!0},...q)}doContains($,q,...ie){if(!$)return!1;const se=ie.length>0;return!!((!se||ie.includes(1))&&(this.added?.get($)||q.includeChildren&&this.added?.findSuperstr($))||(!se||ie.includes(0))&&(this.updated?.get($)||q.includeChildren&&this.updated?.findSuperstr($))||(!se||ie.includes(2))&&(this.deleted?.findSubstr($)||q.includeChildren&&this.deleted?.findSuperstr($)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=c;function h(B,$,q){return!B||!$||B===$||$.length>B.length?!1:($.charAt($.length-1)!==t.sep&&($+=t.sep),q?(0,_.startsWithIgnoreCase)(B,$):B.indexOf($)===0)}e.isParent=h;class g extends Error{constructor($,q,ie){super($);this.fileOperationResult=q,this.options=ie}}e.FileOperationError=g;class E extends g{constructor($,q,ie){super($,2,ie);this.stat=q}}e.NotModifiedSinceFileOperationError=E;var v;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",B[B.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(v=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var k;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(k=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function x(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.etag=x;async function N(B,$){if(!$.hasProvider(I.URI.from({scheme:B.scheme})))return new Promise(q=>{const ie=$.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===B.scheme&&se.added&&(ie.dispose(),q())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class y{static formatSize($){return(0,A.isNumber)($)||($=0),$<y.KB?(0,P.localize)(1,null,$.toFixed(0)):$<y.MB?(0,P.localize)(2,null,($/y.KB).toFixed(2)):$<y.GB?(0,P.localize)(3,null,($/y.MB).toFixed(2)):$<y.TB?(0,P.localize)(4,null,($/y.GB).toFixed(2)):(0,P.localize)(5,null,($/y.TB).toFixed(2))}}e.ByteSize=y,y.KB=1024,y.MB=y.KB*y.KB,y.GB=y.MB*y.KB,y.TB=y.GB*y.KB;var L;(function(B){B[B.IA32=0]="IA32",B[B.OTHER=1]="OTHER"})(L=e.Arch||(e.Arch={}));function W(B){return{maxFileSize:B===0?300*y.MB:16*y.GB,maxHeapSize:B===0?700*y.MB:2*700*y.MB}}e.getPlatformLimits=W}),define(ye[59],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class r{constructor(..._){this._entries=new Map;for(let[A,I]of _)this.set(A,I)}set(_,A){const I=this._entries.get(_);return this._entries.set(_,A),I}has(_){return this._entries.has(_)}get(_){return this._entries.get(_)}}e.ServiceCollection=r}),define(ye[136],_e([0,1,13,15,78,132,3,59]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class T extends Error{constructor(l){super("cyclic dependency between services");this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class R{constructor(l=new P.ServiceCollection,s=!1,m){this._activeInstantiations=new Set,this._services=l,this._strict=s,this._parent=m,this._services.set(I.IInstantiationService,this)}createChild(l){return new R(l,this._strict,this)}invokeFunction(l,...s){let m=i.traceInvocation(l),F=!1;try{return l({get:b=>{if(F)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(b,m);if(!p)throw new Error(`[invokeFunction] unknown service '${b}'`);return p}},...s)}finally{F=!0,m.stop()}}createInstance(l,...s){let m,F;return l instanceof _.SyncDescriptor?(m=i.traceCreation(l.ctor),F=this._createInstance(l.ctor,l.staticArguments.concat(s),m)):(m=i.traceCreation(l),F=this._createInstance(l,s,m)),m.stop(),F}_createInstance(l,s=[],m){let F=I._util.getServiceDependencies(l).sort((p,C)=>p.index-C.index),S=[];for(const p of F){let C=this._getOrCreateServiceInstance(p.id,m);if(!C&&this._strict&&!p.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${p.id}.`);S.push(C)}let b=F.length>0?F[0].index:s.length;if(s.length!==b){console.warn(`[createInstance] First service dependency of ${l.name} at position ${b+1} conflicts with ${s.length} static arguments`);let p=b-s.length;p>0?s=s.concat(new Array(p)):s=s.slice(0,b)}return new l(...[...s,...S])}_setServiceInstance(l,s){if(this._services.get(l)instanceof _.SyncDescriptor)this._services.set(l,s);else if(this._parent)this._parent._setServiceInstance(l,s);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let s=this._services.get(l);return!s&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):s}_getOrCreateServiceInstance(l,s){let m=this._getServiceInstanceOrDescriptor(l);return m instanceof _.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,m,s.branch(l,!0)):(s.branch(l,!1),m)}_safeCreateAndCacheServiceInstance(l,s,m){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,s,m)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,s,m){const F=new A.Graph(p=>p.id.toString());let S=0;const b=[{id:l,desc:s,_trace:m}];for(;b.length;){const p=b.pop();if(F.lookupOrInsertNode(p),S++>1e3)throw new T(F);for(let C of I._util.getServiceDependencies(p.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(C.id);if(!a&&!C.optional&&console.warn(`[createInstance] ${l} depends on ${C.id} which is NOT registered.`),a instanceof _.SyncDescriptor){const M={id:C.id,desc:a,_trace:p._trace.branch(C.id,!0)};F.insertEdge(p,M),b.push(M)}}}for(;;){const p=F.roots();if(p.length===0){if(!F.isEmpty())throw new T(F);break}for(const{data:C}of p){if(this._getServiceInstanceOrDescriptor(C.id)instanceof _.SyncDescriptor){const M=this._createServiceInstanceWithOwner(C.id,C.desc.ctor,C.desc.staticArguments,C.desc.supportsDelayedInstantiation,C._trace);this._setServiceInstance(C.id,M)}F.removeNode(C)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,s,m=[],F,S){if(this._services.get(l)instanceof _.SyncDescriptor)return this._createServiceInstance(s,m,F,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,s,m,F,S);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}_createServiceInstance(l,s=[],m,F){if(m){const S=new r.IdleValue(()=>this._createInstance(l,s,F));return new Proxy(Object.create(null),{get(b,p){if(p in b)return b[p];let C=S.value,a=C[p];return typeof a!="function"||(a=a.bind(C),b[p]=a),a},set(b,p,C){return S.value[p]=C,!0}})}else return this._createInstance(l,s,F)}}e.InstantiationService=R;var w;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(w||(w={}));class i{constructor(l,s){this.type=l,this.name=s,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new i(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):i._None}static traceCreation(l){return D?new i(0,l.name):i._None}branch(l,s){let m=new i(2,l.toString());return this._dep.push([l,s,m]),m}stop(){let l=Date.now()-this._start;i._totals+=l;let s=!1;function m(S,b){let p=[],C=new Array(S+1).join("	");for(const[a,M,o]of b._dep)if(M&&o){s=!0,p.push(`${C}CREATES -> ${a}`);let n=m(S+1,o);n&&p.push(n)}else p.push(`${C}uses -> ${a}`);return p.join(`
`)}let F=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${i._totals.toFixed(2)}ms)`];(l>2||s)&&console.log(F.join(`
`))}}e.Trace=i,i._None=new class extends i{constructor(){super(-1,null)}stop(){}branch(){return this}},i._totals=0}),define(ye[12],_e([0,1,43,4,6,23,3]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function P(){return new Date().toISOString()}var D;(function(M){M[M.Trace=0]="Trace",M[M.Debug=1]="Debug",M[M.Info=2]="Info",M[M.Warning=3]="Warning",M[M.Error=4]="Error",M[M.Critical=5]="Critical",M[M.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function T(M,o,n){switch(o){case D.Trace:M.trace(n);break;case D.Debug:M.debug(n);break;case D.Info:M.info(n);break;case D.Warning:M.warn(n);break;case D.Error:M.error(n);break;case D.Critical:M.critical(n);break;default:throw new Error("Invalid log level")}}e.log=T;function R(M){let o="";for(let n=0;n<M.length;n++){let u=M[n];if(typeof u=="object")try{u=JSON.stringify(u)}catch{}o+=(n>0?" ":"")+u}return o}e.format=R;class w extends _.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(o){this.level!==o&&(this.level=o,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class i extends w{constructor(o){super();this.logAlways=o}checkLogLevel(o){return this.logAlways||this.getLevel()<=o}trace(o,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,R([o,...n]))}debug(o,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,R([o,...n]))}info(o,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,R([o,...n]))}warn(o,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,R([o,...n]))}error(o,...n){if(this.checkLogLevel(D.Error))if(o instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=o.stack,this.log(D.Error,R(u))}else this.log(D.Error,R([o,...n]))}critical(o,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,R([o,...n]))}flush(){}}e.AbstractMessageLogger=i;class d extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o),this.useColors=!A.isWindows}trace(o,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...n):console.log(`[main ${P()}]`,o,...n))}debug(o,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...n):console.log(`[main ${P()}]`,o,...n))}info(o,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,o,...n):console.log(`[main ${P()}]`,o,...n))}warn(o,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,o,...n):console.warn(`[main ${P()}]`,o,...n))}error(o,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,o,...n):console.error(`[main ${P()}]`,o,...n))}critical(o,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,o,...n):console.error(`[main ${P()}]`,o,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=d;class l extends w{constructor(o=e.DEFAULT_LOG_LEVEL){super();this.setLevel(o)}trace(o,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",o,...n)}debug(o,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",o,...n)}info(o,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",o,...n)}warn(o,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",o,...n)}error(o,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",o,...n)}critical(o,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",o,...n)}dispose(){}flush(){}}e.ConsoleLogger=l;class s extends w{constructor(o,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=o,this.setLevel(n)}trace(o,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(o),...n])}debug(o,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(o),...n])}info(o,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(o),...n])}warn(o,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(o),...n])}error(o,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(o),...n])}critical(o,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(o),...n])}extractMessage(o){return typeof o=="string"?o:(0,r.toErrorMessage)(o,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=s;class m extends w{constructor(o){super();this.logServices=o,o.length&&this.setLevel(o[0].getLevel())}setLevel(o){for(const n of this.logServices)n.setLevel(o);super.setLevel(o)}trace(o,...n){for(const u of this.logServices)u.trace(o,...n)}debug(o,...n){for(const u of this.logServices)u.debug(o,...n)}info(o,...n){for(const u of this.logServices)u.info(o,...n)}warn(o,...n){for(const u of this.logServices)u.warn(o,...n)}error(o,...n){for(const u of this.logServices)u.error(o,...n)}critical(o,...n){for(const u of this.logServices)u.critical(o,...n)}flush(){for(const o of this.logServices)o.flush()}dispose(){for(const o of this.logServices)o.dispose()}}e.MultiplexLogService=m;class F extends _.Disposable{constructor(o){super();this.logger=o,this._register(o)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(o){this.logger.setLevel(o)}getLevel(){return this.logger.getLevel()}trace(o,...n){this.logger.trace(o,...n)}debug(o,...n){this.logger.debug(o,...n)}info(o,...n){this.logger.info(o,...n)}warn(o,...n){this.logger.warn(o,...n)}error(o,...n){this.logger.error(o,...n)}critical(o,...n){this.logger.critical(o,...n)}flush(){this.logger.flush()}}e.LogService=F;class S extends _.Disposable{constructor(o,n){super();this.logLevel=o,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(f=>f.setLevel(u))}))}getLogger(o){return this.loggers.get(o.toString())}createLogger(o,n){let u=this.loggers.get(o.toString());return u||(u=this.doCreateLogger(o,n?.always?D.Trace:this.logLevel,n),this.loggers.set(o.toString(),u),n?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(o=>o.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class b{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(o){}getLevel(){return D.Info}trace(o,...n){}debug(o,...n){}info(o,...n){}warn(o,...n){}error(o,...n){}critical(o,...n){}dispose(){}flush(){}}e.NullLogService=b;function p(M){if(M.verbose)return D.Trace;if(typeof M.logLevel=="string"){const o=C(M.logLevel.toLowerCase());if(o!==void 0)return o}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function C(M){switch(M){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=C;function a(M){switch(M){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(ye[80],_e([0,1,34,117,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var I;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function T(l,s){return s-l}D.compare=T;const R=Object.create(null);R[D.Error]=(0,t.localize)(0,null),R[D.Warning]=(0,t.localize)(1,null),R[D.Info]=(0,t.localize)(2,null);function w(l){return R[l]||""}D.toString=w;function i(l){switch(l){case r.default.Error:return D.Error;case r.default.Warning:return D.Warning;case r.default.Info:return D.Info;case r.default.Ignore:return D.Hint}}D.fromSeverity=i;function d(l){switch(l){case D.Error:return r.default.Error;case D.Warning:return r.default.Warning;case D.Info:return r.default.Info;case D.Hint:return r.default.Ignore}}D.toSeverity=d}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(D){const T="";function R(i){return w(i,!0)}D.makeKey=R;function w(i,d){let l=[T];return i.source?l.push(i.source.replace("\xA6","\\\xA6")):l.push(T),i.code?typeof i.code=="string"?l.push(i.code.replace("\xA6","\\\xA6")):l.push(i.code.value.replace("\xA6","\\\xA6")):l.push(T),i.severity!==void 0&&i.severity!==null?l.push(I.toString(i.severity)):l.push(T),i.message&&d?l.push(i.message.replace("\xA6","\\\xA6")):l.push(T),i.startLineNumber!==void 0&&i.startLineNumber!==null?l.push(i.startLineNumber.toString()):l.push(T),i.startColumn!==void 0&&i.startColumn!==null?l.push(i.startColumn.toString()):l.push(T),i.endLineNumber!==void 0&&i.endLineNumber!==null?l.push(i.endLineNumber.toString()):l.push(T),i.endColumn!==void 0&&i.endColumn!==null?l.push(i.endColumn.toString()):l.push(T),l.push(T),l.join("\xA6")}D.makeKeyOptionalMessage=w})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,_.createDecorator)("markerService")}),define(ye[137],_e([0,1,4,34,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=t.default,e.INotificationService=(0,_.createDecorator)("notificationService");var A;(function(T){T[T.WORKSPACE=0]="WORKSPACE",T[T.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(T){T[T.OFF=0]="OFF",T[T.SILENT=1]="SILENT",T[T.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new D,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=P;class D{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=D}),define(ye[138],_e([0,1,6,9,2,3]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return r.Disposable.None},registerValidator(){return r.Disposable.None},registerExternalUriResolver(){return r.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return r.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function I(D,T){return _.URI.isUri(D)?(0,t.equalsIgnoreCase)(D.scheme,T):(0,t.startsWithIgnoreCase)(D,T+":")}e.matchesScheme=I;function P(D,...T){return T.some(R=>I(D,R))}e.matchesSomeScheme=P});var Be=this&&this.__decorate||function(ee,e,r,t){var _=arguments.length,A=_<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,r):t,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ee,e,r,t);else for(var P=ee.length-1;P>=0;P--)(I=ee[P])&&(A=(_<3?I(A):_>3?I(e,r,A):I(e,r))||A);return _>3&&A&&Object.defineProperty(e,r,A),A},$e=this&&this.__param||function(ee,e){return function(r,t){e(r,t,ee)}};define(ye[139],_e([0,1,13,20,6,3]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var I;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(I=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(w){this.callback=w}get value(){return this._value}report(w){this._value=w,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=class extends _.Disposable{constructor(w,i){super();this.deferred=new r.DeferredPromise,i.withProgress(w,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,_.toDisposable)(()=>this.deferred.complete()))}report(w){this.reporter?this.reporter.report(w):this.lastStep=w}};D=Be([$e(1,e.IProgressService)],D),e.UnmanagedProgress=D;class T extends _.Disposable{constructor(w){super();this.progressIndicator=w,this.currentOperationId=0,this.currentOperationDisposables=this._register(new _.DisposableStore)}start(w){this.stop();const i=++this.currentOperationId,d=new t.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{i===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},w),this.currentOperationDisposables.add((0,_.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,_.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,_.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:i,token:d.token,stop:()=>this.doStop(i),isCurrent:()=>this.currentOperationId===i}}stop(){this.doStop(this.currentOperationId)}doStop(w){this.currentOperationId===w&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=T,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(ye[37],_e([0,1,42,10]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class _{constructor(){this.data=new Map}add(I,P){r.ok(t.isString(I)),r.ok(t.isObject(P)),r.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,P)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new _}),define(ye[140],_e([0,1,4,37]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function _(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,T){this.schemasById[_(D)]=T,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new A;t.Registry.add(e.Extensions.JSONContribution,I)}),define(ye[81],_e([0,1,16,4,10,114,140,37]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const R=P.Registry.as(I.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(C,a=!0){this.registerConfigurations([C],a)}registerConfigurations(C,a=!0){const M=this.doRegisterConfigurations(C,a);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:M})}deregisterConfigurations(C){const a=this.doDeregisterConfigurations(C);R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:C,remove:a}){const M=[];M.push(...this.doDeregisterConfigurations(a)),M.push(...this.doRegisterConfigurations(C,!1)),R.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,r.distinct)(M)})}registerDefaultConfigurations(C){const a=[],M=[];for(const{overrides:o,source:n}of C)for(const u in o)if(a.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const f={...this.configurationDefaultsOverrides.get(u)?.value||{},...o[u]};this.configurationDefaultsOverrides.set(u,{source:n,value:f});const c={type:"object",default:f,description:A.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:f,source:_.isString(n)?void 0:n};M.push(...l(u)),this.configurationProperties[u]=c,this.defaultLanguageConfigurationOverridesNode.properties[u]=c}else{this.configurationDefaultsOverrides.set(u,{value:o[u],source:n});const f=this.configurationProperties[u];f&&(this.updatePropertyDefaultValue(u,f),this.updateSchema(u,f))}this.registerOverrideIdentifiers(M),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(C){const a=[];for(const{overrides:M,source:o}of C)for(const n in M){const u=this.configurationDefaultsOverrides.get(n),f=_.isString(o)?o:o?.id,c=_.isString(u?.source)?u?.source:u?.source?.id;if(f===c)if(a.push(n),this.configurationDefaultsOverrides.delete(n),e.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const h=this.configurationProperties[n];h&&(this.updatePropertyDefaultValue(n,h),this.updateSchema(n,h))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...C){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(C){for(const a of C)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(C,a){const M=[];return C.forEach(o=>{M.push(...this.validateAndRegisterProperties(o,a,o.extensionInfo,o.restrictedProperties)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),M}doDeregisterConfigurations(C){const a=[],M=o=>{if(o.properties)for(const n in o.properties)a.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,o.properties[n]);o.allOf&&o.allOf.forEach(n=>M(n))};for(const o of C){M(o);const n=this.configurationContributors.indexOf(o);n!==-1&&this.configurationContributors.splice(n,1)}return a}validateAndRegisterProperties(C,a=!0,M,o,n=3){n=_.isUndefinedOrNull(C.scope)?n:C.scope;let u=[],f=C.properties;if(f)for(let h in f){if(a&&S(h)){delete f[h];continue}const g=f[h];if(g.source=M,g.defaultDefaultValue=f[h].default,this.updatePropertyDefaultValue(h,g),e.OVERRIDE_PROPERTY_REGEX.test(h)?g.scope=void 0:(g.scope=_.isUndefinedOrNull(g.scope)?n:g.scope,g.restricted=_.isUndefinedOrNull(g.restricted)?!!o?.includes(h):g.restricted),f[h].hasOwnProperty("included")&&!f[h].included){this.excludedConfigurationProperties[h]=f[h],delete f[h];continue}else this.configurationProperties[h]=f[h];!f[h].deprecationMessage&&f[h].markdownDeprecationMessage&&(f[h].deprecationMessage=f[h].markdownDeprecationMessage),u.push(h)}let c=C.allOf;if(c)for(let h of c)u.push(...this.validateAndRegisterProperties(h,a,M,o,n));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(C){const a=M=>{let o=M.properties;if(o)for(const u in o)this.updateSchema(u,o[u]);let n=M.allOf;n&&n.forEach(a)};a(C)}updateSchema(C,a){switch(e.allSettings.properties[C]=a,a.scope){case 1:e.applicationSettings.properties[C]=a;break;case 2:e.machineSettings.properties[C]=a;break;case 6:e.machineOverridableSettings.properties[C]=a;break;case 3:e.windowSettings.properties[C]=a;break;case 4:e.resourceSettings.properties[C]=a;break;case 5:e.resourceSettings.properties[C]=a,this.resourceLanguageSettingsSchema.properties[C]=a;break}}removeFromSchema(C,a){switch(delete e.allSettings.properties[C],a.scope){case 1:delete e.applicationSettings.properties[C];break;case 2:delete e.machineSettings.properties[C];break;case 6:delete e.machineOverridableSettings.properties[C];break;case 3:delete e.windowSettings.properties[C];break;case 4:case 5:delete e.resourceSettings.properties[C],delete this.resourceLanguageSettingsSchema.properties[C];break}}updateOverridePropertyPatternKey(){for(const C of this.overrideIdentifiers.values()){const a=`[${C}]`,M={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,M),e.allSettings.properties[a]=M,e.applicationSettings.properties[a]=M,e.machineSettings.properties[a]=M,e.machineOverridableSettings.properties[a]=M,e.windowSettings.properties[a]=M,e.resourceSettings.properties[a]=M}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const C={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=C,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(C,a){const M=this.configurationDefaultsOverrides.get(C);let o=M?.value,n=M?.source;_.isUndefined(o)&&(o=a.defaultDefaultValue,n=void 0),_.isUndefined(o)&&(o=m(a.type)),a.default=o,a.defaultValueSource=n}}const i="\\[([^\\]]+)\\]",d=new RegExp(i,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${i})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(p){const C=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let a=d.exec(p);for(;a?.length;){const M=a[1].trim();M&&C.push(M),a=d.exec(p)}}return(0,r.distinct)(C)}e.overrideIdentifiersFromKey=l;function s(p){return p.reduce((C,a)=>`${C}[${a}]`,"")}e.keyFromOverrideIdentifiers=s;function m(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const F=new w;P.Registry.add(e.Extensions.Configuration,F);function S(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?A.localize(7,null,p):F.getConfigurationProperties()[p]!==void 0?A.localize(8,null,p):null:A.localize(6,null)}e.validateProperty=S;function b(){const p=[],C=F.getConfigurationProperties();for(const a of Object.keys(C))p.push([a,C[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=b}),define(ye[141],_e([0,1,16,4,99,6,22,27,10,2,79,81,37]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(o={},n=[],u=[]){this._contents=o,this._keys=n,this._overrides=u,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(o){return o?(0,R.getConfigurationValue)(this.contents,o):this.contents}getOverrideValue(o,n){const u=this.getContentsForOverrideIdentifer(n);return u?o?(0,R.getConfigurationValue)(u,o):u:void 0}getKeysForOverrideIdentifier(o){const n=[];for(const u of this.overrides)u.identifiers.includes(o)&&n.push(...u.keys);return r.distinct(n)}getAllOverrideIdentifiers(){const o=[];for(const n of this.overrides)o.push(...n.identifiers);return r.distinct(o)}override(o){let n=this.overrideConfigurations.get(o);return n||(n=this.createOverrideConfigurationModel(o),this.overrideConfigurations.set(o,n)),n}merge(...o){const n=P.deepClone(this.contents),u=P.deepClone(this.overrides),f=[...this.keys];for(const c of o){this.mergeContents(n,c.contents);for(const h of c.overrides){const[g]=u.filter(E=>r.equals(E.identifiers,h.identifiers));g?(this.mergeContents(g.contents,h.contents),g.keys.push(...h.keys),g.keys=r.distinct(g.keys)):u.push(P.deepClone(h))}for(const h of c.keys)f.indexOf(h)===-1&&f.push(h)}return new d(n,f,u)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(o){const n=this.getContentsForOverrideIdentifer(o);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let u={};for(const f of r.distinct([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[f],h=n[f];h&&(typeof c=="object"&&typeof h=="object"?(c=P.deepClone(c),this.mergeContents(c,h)):c=h),u[f]=c}return new d(u,this.keys,this.overrides)}mergeContents(o,n){for(const u of Object.keys(n)){if(u in o&&D.isObject(o[u])&&D.isObject(n[u])){this.mergeContents(o[u],n[u]);continue}o[u]=P.deepClone(n[u])}}checkAndFreeze(o){return this.isFrozen&&!Object.isFrozen(o)?P.deepFreeze(o):o}getContentsForOverrideIdentifer(o){let n=null,u=null;const f=c=>{c&&(u?this.mergeContents(u,c):u=P.deepClone(c))};for(const c of this.overrides)r.equals(c.identifiers,[o])?n=c.contents:c.identifiers.includes(o)&&f(c.contents);return f(n),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(o,n){this.addKey(o),(0,R.addToValueTree)(this.contents,o,n,u=>{throw new Error(u)})}removeValue(o){this.removeKey(o)&&(0,R.removeFromValueTree)(this.contents,o)}addKey(o){let n=this.keys.length;for(let u=0;u<n;u++)o.indexOf(this.keys[u])===0&&(n=u);this.keys.splice(n,1,o)}removeKey(o){let n=this.keys.indexOf(o);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=d;class l extends d{constructor(o={}){const n=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(n),f=Object.create(null),c=[];for(const h in n){const g=o[h],E=g!==void 0?g:n[h].default;(0,R.addToValueTree)(f,h,E,v=>console.error(`Conflict in default settings: ${v}`))}for(const h of Object.keys(f))w.OVERRIDE_PROPERTY_REGEX.test(h)&&c.push({identifiers:(0,w.overrideIdentifiersFromKey)(h),keys:Object.keys(f[h]),contents:(0,R.toValuesTree)(f[h],g=>console.error(`Conflict in default settings file: ${g}`))});super(f,u,c)}}e.DefaultConfigurationModel=l;class s{constructor(o){this._name=o,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(o,n){if(!D.isUndefinedOrNull(o)){const u=this.doParseContent(o);this.parseRaw(u,n)}}reparse(o){this._raw&&this.parseRaw(this._raw,o)}parseRaw(o,n){this._raw=o;const{contents:u,keys:f,overrides:c,restricted:h}=this.doParseRaw(o,n);this._configurationModel=new d(u,f,c),this._restrictedConfigurations=h||[]}doParseContent(o){let n={},u=null,f=[],c=[],h=[];function g(v){Array.isArray(f)?f.push(v):u!==null&&(f[u]=v)}let E={onObjectBegin:()=>{let v={};g(v),c.push(f),f=v,u=null},onObjectProperty:v=>{u=v},onObjectEnd:()=>{f=c.pop()},onArrayBegin:()=>{let v=[];g(v),c.push(f),f=v,u=null},onArrayEnd:()=>{f=c.pop()},onLiteralValue:g,onError:(v,k,x)=>{h.push({error:v,offset:k,length:x})}};if(o)try{_.visit(o,E),n=f[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(o,n){const u=i.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),f=this.filter(o,u,!0,n);o=f.raw;const c=(0,R.toValuesTree)(o,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),h=Object.keys(o),g=this.toOverrides(o,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:c,keys:h,overrides:g,restricted:f.restricted}}filter(o,n,u,f){if(!f?.scopes&&!f?.skipRestricted)return{raw:o,restricted:[]};const c={},h=[];for(let g in o)if(w.OVERRIDE_PROPERTY_REGEX.test(g)&&u){const E=this.filter(o[g],n,!1,f);c[g]=E.raw,h.push(...E.restricted)}else{const E=n[g],v=E?typeof E.scope!="undefined"?E.scope:3:void 0;E?.restricted&&h.push(g),(v===void 0||f.scopes===void 0||f.scopes.includes(v))&&(f.skipRestricted&&E?.restricted||(c[g]=o[g]))}return{raw:c,restricted:h}}toOverrides(o,n){const u=[];for(const f of Object.keys(o))if(w.OVERRIDE_PROPERTY_REGEX.test(f)){const c={};for(const h in o[f])c[h]=o[f][h];u.push({identifiers:(0,w.overrideIdentifiersFromKey)(f),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,n)})}return u}}e.ConfigurationModelParser=s;class m extends A.Disposable{constructor(o,n,u,f){super();this.userSettingsResource=o,this.scopes=n,this.fileService=f,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new s(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const o=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(o.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=m;class F{constructor(o,n,u=new d,f=new d,c=new I.ResourceMap,h=new d,g=new I.ResourceMap,E=!0){this._defaultConfiguration=o,this._localUserConfiguration=n,this._remoteUserConfiguration=u,this._workspaceConfiguration=f,this._folderConfigurations=c,this._memoryConfiguration=h,this._memoryConfigurationByResource=g,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(o,n,u){return this.getConsolidateConfigurationModel(n,u).getValue(o)}updateValue(o,n,u={}){let f;u.resource?(f=this._memoryConfigurationByResource.get(u.resource),f||(f=new d,this._memoryConfigurationByResource.set(u.resource,f))):f=this._memoryConfiguration,n===void 0?f.removeValue(o):f.setValue(o,n),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(o,n,u){const f=this.getConsolidateConfigurationModel(n,u),c=this.getFolderConfigurationModelForResource(n.resource,u),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,g=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._defaultConfiguration.freeze().getValue(o),E=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.userConfiguration.freeze().getValue(o),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.localUserConfiguration.freeze().getValue(o),k=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this.remoteUserConfiguration.freeze().getValue(o),x=u?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(o):this._workspaceConfiguration.freeze().getValue(o):void 0,N=c?n.overrideIdentifier?c.freeze().override(n.overrideIdentifier).getValue(o):c.freeze().getValue(o):void 0,y=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(o):h.getValue(o),L=f.getValue(o),W=r.distinct(r.flatten(f.overrides.map(B=>B.identifiers))).filter(B=>f.getOverrideValue(o,B)!==void 0);return{defaultValue:g,userValue:E,userLocalValue:v,userRemoteValue:k,workspaceValue:x,workspaceFolderValue:N,memoryValue:y,value:L,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspace:x!==void 0?{value:this._workspaceConfiguration.freeze().getValue(o),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(o),override:n.overrideIdentifier?c?.freeze().getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,memory:y!==void 0?{value:h.getValue(o),override:n.overrideIdentifier?h.getOverrideValue(o,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(o){const n=this.getFolderConfigurationModelForResource(void 0,o);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(o){this._defaultConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(o){this._localUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(o){this._remoteUserConfiguration=o,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(o){this._workspaceConfiguration=o,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(o,n){this._folderConfigurations.set(o,n),this._foldersConsolidatedConfigurations.delete(o)}deleteFolderConfiguration(o){this.folderConfigurations.delete(o),this._foldersConsolidatedConfigurations.delete(o)}compareAndUpdateDefaultConfiguration(o,n){const u=[];if(!n){const{added:f,updated:c,removed:h}=C(this._defaultConfiguration,o);n=[...f,...c,...h]}for(const f of n)for(const c of(0,w.overrideIdentifiersFromKey)(f)){const h=this._defaultConfiguration.getKeysForOverrideIdentifier(c),g=o.getKeysForOverrideIdentifier(c),E=[...g.filter(v=>h.indexOf(v)===-1),...h.filter(v=>g.indexOf(v)===-1),...h.filter(v=>!P.equals(this._defaultConfiguration.override(c).getValue(v),o.override(c).getValue(v)))];u.push([c,E])}return this.updateDefaultConfiguration(o),{keys:n,overrides:u}}compareAndUpdateLocalUserConfiguration(o){const{added:n,updated:u,removed:f,overrides:c}=C(this.localUserConfiguration,o),h=[...n,...u,...f];return h.length&&this.updateLocalUserConfiguration(o),{keys:h,overrides:c}}compareAndUpdateRemoteUserConfiguration(o){const{added:n,updated:u,removed:f,overrides:c}=C(this.remoteUserConfiguration,o);let h=[...n,...u,...f];return h.length&&this.updateRemoteUserConfiguration(o),{keys:h,overrides:c}}compareAndUpdateWorkspaceConfiguration(o){const{added:n,updated:u,removed:f,overrides:c}=C(this.workspaceConfiguration,o);let h=[...n,...u,...f];return h.length&&this.updateWorkspaceConfiguration(o),{keys:h,overrides:c}}compareAndUpdateFolderConfiguration(o,n){const u=this.folderConfigurations.get(o),{added:f,updated:c,removed:h,overrides:g}=C(u,n);let E=[...f,...c,...h];return(E.length||!u)&&this.updateFolderConfiguration(o,n),{keys:E,overrides:g}}compareAndDeleteFolderConfiguration(o){const n=this.folderConfigurations.get(o);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:u,updated:f,removed:c,overrides:h}=C(n,void 0);return{keys:[...u,...f,...c],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(o,n){let u=this.getConsolidatedConfigurationModelForResource(o,n);return o.overrideIdentifier?u.override(o.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:o},n){let u=this.getWorkspaceConsolidatedConfiguration();if(n&&o){const f=n.getFolder(o);f&&(u=this.getFolderConsolidatedConfiguration(f.uri)||u);const c=this._memoryConfigurationByResource.get(o);c&&(u=u.merge(c))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(o){let n=this._foldersConsolidatedConfigurations.get(o);if(!n){const u=this.getWorkspaceConsolidatedConfiguration(),f=this._folderConfigurations.get(o);f?(n=u.merge(f),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(o,n)):n=u}return n}getFolderConfigurationModelForResource(o,n){if(n&&o){const u=n.getFolder(o);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((o,n)=>{const{contents:u,overrides:f,keys:c}=this._folderConfigurations.get(n);return o.push([n,{contents:u,overrides:f,keys:c}]),o},[])}}allKeys(){const o=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>o.add(n)),this.userConfiguration.freeze().keys.forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(u=>o.add(u))),[...o.values()]}allOverrideIdentifiers(){const o=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>o.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(u=>o.add(u))),[...o.values()]}getAllKeysForOverrideIdentifier(o){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(o).forEach(u=>n.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(u=>n.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(o).forEach(u=>n.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(o).forEach(f=>n.add(f))),[...n.values()]}static parse(o){const n=this.parseConfigurationModel(o.defaults),u=this.parseConfigurationModel(o.user),f=this.parseConfigurationModel(o.workspace),c=o.folders.reduce((h,g)=>(h.set(T.URI.revive(g[0]),this.parseConfigurationModel(g[1])),h),new I.ResourceMap);return new F(n,u,new d,f,c,new d,new I.ResourceMap,!1)}static parseConfigurationModel(o){return new d(o.contents,o.keys,o.overrides).freeze()}}e.Configuration=F;function S(...M){if(M.length===0)return{keys:[],overrides:[]};if(M.length===1)return M[0];const o=new Set,n=new Map;for(const f of M)f.keys.forEach(c=>o.add(c)),f.overrides.forEach(([c,h])=>{const g=(0,I.getOrSet)(n,c,new Set);h.forEach(E=>g.add(E))});const u=[];return n.forEach((f,c)=>u.push([c,[...f.values()]])),{keys:[...o.values()],overrides:u}}e.mergeChanges=S;class b{constructor(o,n,u,f){this.change=o,this.previous=n,this.currentConfiguraiton=u,this.currentWorkspace=f,this._previousConfiguration=void 0;const c=new Set;o.keys.forEach(g=>c.add(g)),o.overrides.forEach(([,g])=>g.forEach(E=>c.add(E))),this.affectedKeys=[...c.values()];const h=new d;this.affectedKeys.forEach(g=>h.setValue(g,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=F.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(o,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,o)){if(n){const u=this.previousConfiguration?this.previousConfiguration.getValue(o,n,this.previous?.workspace):void 0,f=this.currentConfiguraiton.getValue(o,n,this.currentWorkspace);return!P.equals(u,f)}return!0}return!1}doesAffectedKeysTreeContains(o,n){let u=(0,R.toValuesTree)({[n]:!0},()=>{}),f;for(;typeof u=="object"&&(f=Object.keys(u)[0]);){if(o=o[f],!o)return!1;u=u[f]}return!0}}e.ConfigurationChangeEvent=b;class p extends b{constructor(o,n,u,f){super({keys:o.allKeys(),overrides:[]},void 0,o,n);this.source=u,this.sourceConfig=f}}e.AllKeysConfigurationChangeEvent=p;function C(M,o){const{added:n,removed:u,updated:f}=a(o,M),c=[],h=M?.getAllOverrideIdentifiers()||[],g=o?.getAllOverrideIdentifiers()||[];if(o){const E=g.filter(v=>!h.includes(v));for(const v of E)c.push([v,o.getKeysForOverrideIdentifier(v)])}if(M){const E=h.filter(v=>!g.includes(v));for(const v of E)c.push([v,M.getKeysForOverrideIdentifier(v)])}if(o&&M){for(const E of h)if(g.includes(E)){const v=a({contents:M.getOverrideValue(void 0,E)||{},keys:M.getKeysForOverrideIdentifier(E)},{contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)});c.push([E,[...v.added,...v.removed,...v.updated]])}}return{added:n,removed:u,updated:f,overrides:c}}function a(M,o){const n=M?o?M.keys.filter(c=>o.keys.indexOf(c)===-1):[...M.keys]:[],u=o?M?o.keys.filter(c=>M.keys.indexOf(c)===-1):[...o.keys]:[],f=[];if(M&&o){for(const c of o.keys)if(M.keys.indexOf(c)!==-1){const h=(0,R.getConfigurationValue)(o.contents,c),g=(0,R.getConfigurationValue)(M.contents,c);P.equals(h,g)||f.push(c)}}return{added:n,removed:u,updated:f}}}),define(ye[82],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,r.createDecorator)("remoteAuthorityResolverService");var t;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(t=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class _ extends Error{constructor(I,P=t.Unknown,D){super(I);this._message=I,this._code=P,this._detail=D,this.isHandled=P===t.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype)}static isTemporarilyNotAvailable(I){return I instanceof _&&I._code===t.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof _&&I._code===t.NoResolverFound}static isHandled(I){return I instanceof _&&I.isHandled}}e.RemoteAuthorityResolverError=_}),define(ye[60],_e([0,1,11]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function t(T){return T.scheme===r.Schemas.vscodeRemote?T.authority:void 0}e.getRemoteAuthority=t;function _(T){if(!T)return;const R=T.indexOf("+");return R<0?T:T.substr(0,R)}e.getRemoteName=_;function A(T){return T.scheme!==r.Schemas.file&&T.scheme!==r.Schemas.vscodeRemote}e.isVirtualResource=A;function I(T){if(T.folders.length)return T.folders.every(R=>A(R.uri))?T.folders[0].uri:void 0;if(T.configuration&&A(T.configuration))return T.configuration}e.getVirtualWorkspaceLocation=I;function P(T){return I(T)?.scheme}e.getVirtualWorkspaceScheme=P;function D(T){return I(T)!==void 0}e.isVirtualWorkspace=D}),define(ye[25],_e([0,1,9,3,60]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function A(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkspaceSupportTypeMessage=A;function I(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=I,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));class D{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,l){if(typeof d=="undefined"||d===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof d=="string"||typeof l=="string"){let s=typeof d=="string"?d:d.value,m=typeof l=="string"?l:l.value;return r.equalsIgnoreCase(s,m)}return d._lower===l._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.ExtensionIdentifier=D;function T(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=T;function R(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=R;function w(i,d){if(d){const l=`onResolveRemoteAuthority:${(0,_.getRemoteName)(d)}`;return i.activationEvents?.indexOf(l)!==-1}return!1}e.isResolverExtension=w,e.IBuiltinExtensionsScannerService=(0,t.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[142],_e([0,1,9,25]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function _(l,s){return l.uuid&&s.uuid?l.uuid===s.uuid:l.id===s.id?!0:(0,r.compareIgnoreCase)(l.id,s.id)===0}e.areSameExtensions=_;class A{constructor(s,m){this.version=m,this.id=s.id,this.uuid=s.uuid}key(){return`${this.id}-${this.version}`}equals(s){return s instanceof A?_(this,s)&&this.version===s.version:!1}}e.ExtensionIdentifierWithVersion=A;function I(l,s){return`${l}.${s}`}e.getExtensionId=I;function P(l){return l.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function D(l,s){return P(I(l,s))}e.getGalleryExtensionId=D;function T(l,s){const m=[],F=S=>{for(const b of m)if(b.some(p=>_(s(p),s(S))))return b;return null};for(const S of l){const b=F(S);b?b.push(S):m.push([S])}return m}e.groupByExtension=T;function R(l){return{id:l.identifier.id,name:l.manifest.name,galleryId:null,publisherId:l.publisherId,publisherName:l.manifest.publisher,publisherDisplayName:l.publisherDisplayName,dependencies:l.manifest.extensionDependencies&&l.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=R;function w(l){return{id:l.identifier.id,name:l.name,galleryId:l.identifier.uuid,publisherId:l.publisherId,publisherName:l.publisher,publisherDisplayName:l.publisherDisplayName,isPreReleaseVersion:l.properties.isPreReleaseVersion,dependencies:!!(l.properties.dependencies&&l.properties.dependencies.length>0),...l.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new t.ExtensionIdentifier("pprice.better-merge");function i(l){const s=new Set;if(l.malicious)for(const m of l.malicious)s.add(m.id);return s}e.getMaliciousExtensionsSet=i;function d(l,s){const m=[],F=s.manifest.extensionDependencies?.slice(0)??[];for(;F.length;){const S=F.shift();if(S&&m.every(b=>!_(b.identifier,{id:S}))){const b=l.filter(p=>_(p.identifier,{id:S}));b.length===1&&(m.push(b[0]),F.push(...b[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}e.getExtensionDependencies=d}),define(ye[143],_e([0,1,4,23,3,12]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,_.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,_.createDecorator)("sharedTunnelsService");var I;(function(l){l.Http="http",l.Https="https"})(I=e.TunnelProtocol||(e.TunnelProtocol={}));var P;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(P=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function T(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!s)return{address:s[1],port:+s[2]}}e.extractLocalHostUriMetaDataForPortMapping=T,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=w;function i(l,s){return s?s!==1&&l<1024:!t.isWindows&&l<1024}e.isPortPrivileged=i;let d=class{constructor(s){this.logService=s,this._onTunnelOpened=new r.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new r.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new r.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(s){return this._tunnelProvider=s,s?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this._canElevate=s.elevation,this._privacyOptions=s.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const s=[],m=Array.from(this._tunnels.values());for(let F of m){const S=Array.from(F.values());for(let b of S){const p=await b.value;p&&s.push(p)}}return s}async dispose(){for(const s of this._tunnels.values()){for(const{value:m}of s.values())await m.then(F=>F?.dispose());s.clear()}this._tunnels.clear()}openTunnel(s,m,F,S,b=!1,p=P.Private,C){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${F} on local port ${S}.`),!s)return;m||(m="localhost");const a=this.retainOrCreateTunnel(s,m,F,S,b,p,C);return a?a.then(M=>{if(!M){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,F);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.makeTunnel(M);return(M.tunnelRemoteHost!==m||M.tunnelRemotePort!==F)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(o),o}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const m=this._tunnels.get(s.tunnelRemoteHost);if(m){const F=m.get(s.tunnelRemotePort);F&&(F.refcount--,await this.tryDisposeTunnel(s.tunnelRemoteHost,s.tunnelRemotePort,F))}}}}async tryDisposeTunnel(s,m,F){if(F.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${m}.`);const S=F.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(s)&&this._tunnels.get(s).delete(m),S}}async closeTunnel(s,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${m} `);const F=this._tunnels.get(s);if(F&&F.has(m)){const S=F.get(m);S.refcount=0,await this.tryDisposeTunnel(s,m,S)}}addTunnelToMap(s,m,F){this._tunnels.has(s)||this._tunnels.set(s,new Map),this._tunnels.get(s).set(m,{refcount:1,value:F})}async removeEmptyTunnelFromMap(s,m){const F=this._tunnels.get(s);F&&(await F.get(m)||F.delete(m),F.size===0&&this._tunnels.delete(s))}getTunnelFromMap(s,m){let F=[s];R(s)?(F.push(...e.LOCALHOST_ADDRESSES),F.push(...e.ALL_INTERFACES_ADDRESSES)):w(s)&&F.push(...e.ALL_INTERFACES_ADDRESSES);const S=F.map(b=>this._tunnels.get(b));for(const b of S){const p=b?.get(m);if(p)return p}}canTunnel(s){return!!T(s)}createWithProvider(s,m,F,S,b,p,C){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${F} on local port ${S}.`);const M={elevationRequired:b?i(S===void 0?F:S):!1},o={remoteAddress:{host:m,port:F},localAddressPort:S,privacy:p,public:p!==P.Private,protocol:C},n=s.forwardPort(o,M);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),n&&this.addTunnelToMap(m,F,n),n}};d=Be([$e(0,A.ILogService)],d),e.AbstractTunnelService=d}),define(ye[144],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class r{constructor(_){this._callback=_,this._terminalBufferMap=new Map}dispose(){for(const _ of this._terminalBufferMap.values())_.dispose()}startBuffering(_,A,I=5){let P;return P=A(D=>{const T=typeof D=="string"?D:D.data;let R=this._terminalBufferMap.get(_);if(R){R.data.push(T);return}const w=setTimeout(()=>this.flushBuffer(_),I);R={data:[T],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(_),P.dispose()}},this._terminalBufferMap.set(_,R)}),P}stopBuffering(_){const A=this._terminalBufferMap.get(_);A&&A.dispose()}flushBuffer(_){const A=this._terminalBufferMap.get(_);A&&(this._terminalBufferMap.delete(_),this._callback(_,A.data.join("")))}}e.TerminalDataBufferer=r}),define(ye[145],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var r;(function(t){t.DARK="dark",t.LIGHT="light",t.HIGH_CONTRAST="hc"})(r=e.ColorScheme||(e.ColorScheme={}))}),define(ye[61],_e([0,1,52,4,6,3,37,145]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var D;(function(m){function F(S){return S&&typeof S=="object"&&typeof S.id=="string"}m.isThemeColor=F})(D=e.ThemeColor||(e.ThemeColor={}));function T(m){return{id:m}}e.themeColorFromId=T;var R;(function(m){function F(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||D.isThemeColor(n.color))}m.isThemeIcon=F;const S=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function b(n){const u=S.exec(n);if(!u)return;let[,f]=u;return{id:f}}m.fromString=b;function p(n){return{id:n}}m.fromId=p;function C(n,u){let f=n.id;const c=f.lastIndexOf("~");return c!==-1&&(f=f.substring(0,c)),u&&(f=`${f}~${u}`),{id:f}}m.modify=C;function a(n){const u=n.id.lastIndexOf("~");if(u!==-1)return n.id.substring(u+1)}m.getModifier=a;function M(n,u){return n.id===u.id&&n.color?.id===u.color?.id}m.isEqual=M;function o(n,u){return{id:n.id,color:u?T(u):void 0}}m.asThemeIcon=o,m.asClassNameArray=r.CSSIcon.asClassNameArray,m.asClassName=r.CSSIcon.asClassName,m.asCSSSelector=r.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function w(m){switch(m){case P.ColorScheme.DARK:return"vs-dark";case P.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class i{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(F){return this.themingParticipants.push(F),this.onThemingParticipantAddedEmitter.fire(F),(0,_.toDisposable)(()=>{const S=this.themingParticipants.indexOf(F);this.themingParticipants.splice(S,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new i;I.Registry.add(e.Extensions.ThemingContribution,d);function l(m){return d.onColorThemeChange(m)}e.registerThemingParticipant=l;class s extends _.Disposable{constructor(F){super();this.themeService=F,this.theme=F.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(S=>this.onThemeChange(S)))}onThemeChange(F){this.theme=F,this.updateStyles()}updateStyles(){}getColor(F,S){let b=this.theme.getColor(F);return b&&S&&(b=S(b,this.theme)),b?b.toString():null}}e.Themable=s}),define(ye[47],_e([0,1,22,24,2,3]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var I;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function P(i){const d=i;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=P;function D(i){const d=i;return!!(d&&typeof d=="object"&&_.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=D;class T{constructor(d,l,s,m,F){this._id=d,this._transient=s,this._configuration=m,this._ignorePathCasing=F,this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(d){this._id=d.id,this._configuration=d.configuration,this._transient=d.transient,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=r.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=T;class R{constructor(d,l){this.raw=l,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,t.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=R;function w(i){return new R({uri:i,index:0,name:(0,t.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=w}),define(ye[62],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class r{constructor(_){this.id=_,this._data=new Map,this._idPool=1}add(_){const A=this._idPool++;return this._data.set(A,_),this.logDebugInfo(),A}get(_,A){return this._data.has(_)?this._data.get(_)[A]:void 0}delete(_){this._data.delete(_),this.logDebugInfo()}logDebugInfo(){!r.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=r,r.enableDebugLogging=!1}),define(ye[30],_e([0,1,11,24,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(r.Schemas)),this._providerInfo=new Map,this.extUri=new t.ExtUri(P=>{const D=this._providerInfo.get(P.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(P,D){D===null?this._providerInfo.delete(P.scheme):this._providerInfo.set(P.scheme,D)}isFreeScheme(P){return!this._providerInfo.has(P)&&!this._systemSchemes.has(P)}getCapabilities(P){return this._providerInfo.get(P)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,_.createDecorator)("IExtHostFileSystemInfo")}),define(ye[28],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,r.createDecorator)("IExtHostInitDataService")}),define(ye[146],_e([0,1,13]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class t{constructor(I,P,D){this._deferredPromises=new Map,this._id=I,this._shared=P,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(T=>(this._value=T,this)),this._storageListener=this._storage.onDidChangeStorage(T=>{T.shared===this._shared&&T.key===this._id&&(this._value=T.value)}),this._scheduler=new r.RunOnceScheduler(()=>{const T=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of T.values())R.complete()}catch(R){for(const w of T.values())w.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,I])=>I!==void 0).map(([I])=>I)}get whenReady(){return this._init}get(I,P){let D=this._value[I];return typeof D=="undefined"&&(D=P),D}update(I,P){this._value[I]=P;let D=this._deferredPromises.get(I);if(D!==void 0)return D.p;const T=new r.DeferredPromise;return this._deferredPromises.set(I,T),this._scheduler.isScheduled()||this._scheduler.schedule(),T.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=t;class _ extends t{constructor(I,P){super(I.identifier.value,!0,P);this._extension=I}setKeysForSync(I){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},I)}}e.ExtensionGlobalMemento=_}),define(ye[147],_e([0,1,4,2,12]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(P,D){this._logService=P,this._notebooksAndEditors=D,this._onDidChangeNotebookDocumentMetadata=new r.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new r.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,D,T){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptModelChanged(D.value,T)}$acceptDirtyStateChanged(P,D){this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P)).acceptDirty(D)}$acceptModelSaved(P){const D=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));this._onDidSaveNotebookDocument.fire(D.apiNotebook)}$acceptDocumentPropertiesChanged(P,D){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,D);const T=this._notebooksAndEditors.getNotebookDocument(t.URI.revive(P));T.acceptDocumentPropertiesChanged(D),D.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:T.apiNotebook})}};A=Be([$e(0,_.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(ye[14],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,r.createDecorator)("IExtHostRpcService");class t{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=t});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[148],_e([0,1,25,4]),function(ee,e,r,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(P,D){_.set(this,void 0),this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._id=r.ExtensionIdentifier.toKey(P.identifier),Xe(this,_,D,"f"),Ie(this,_,"f").onDidChangePassword(T=>{T.extensionId===this._id&&this._onDidChange.fire({key:T.key})})}get(P){return Ie(this,_,"f").get(this._id,P)}store(P,D){return Ie(this,_,"f").store(this._id,P,D)}delete(P){return Ie(this,_,"f").delete(this._id,P)}}e.ExtensionSecrets=A,_=new WeakMap}),define(ye[83],_e([0,1,3,4]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class _{constructor(){this._onDidChangeTelemetryEnabled=new t.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(I){this._enabled=I}$onDidChangeTelemetryEnabled(I){this._enabled=I,this._onDidChangeTelemetryEnabled.fire(I)}}e.ExtHostTelemetry=_,e.IExtHostTelemetry=(0,r.createDecorator)("IExtHostTelemetry")}),define(ye[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var r;(function(S){S[S.Upsert=0]="Upsert",S[S.RemoveChild=1]="RemoveChild",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp",S[S.Bulk=4]="Bulk"})(r=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const t=new WeakMap,_=(S,b)=>{const p={controllerId:b};return t.set(S,p),p};e.createPrivateApiFor=_;const A=S=>t.get(S);e.getPrivateApiFor=A;const I=(S,b,p,C)=>{let a=p;return{enumerable:!0,configurable:!1,get(){return a},set(M){if(!C(a,M)){const o=a;a=M,S.listener?.({op:3,key:b,value:M,previous:o})}}}},P=(S,b)=>S===b,D={range:(S,b)=>S===b?!0:!S||!b?!1:S.isEqual(b),label:P,description:P,busy:P,error:P,canResolveChildren:P,tags:(S,b)=>!(S.length!==b.length||S.some(p=>!b.find(C=>p.id===C.id)))},T=Object.keys(D),R=(S,b)=>({range:I(S,"range",void 0,D.range),label:I(S,"label",b,D.label),description:I(S,"description",void 0,D.description),canResolveChildren:I(S,"canResolveChildren",!1,D.canResolveChildren),busy:I(S,"busy",!1,D.busy),error:I(S,"error",void 0,D.error),tags:I(S,"tags",[],D.tags)}),w=(S,b)=>{const p=new Map;for(const C of T)D[C](S[C],b[C])||p.set(C,b[C]);return p};e.diffTestItems=w;class i extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=i;class d extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class l extends Error{constructor(b,p,C){super(`TestItem with ID "${b}" is from controller "${p}" and cannot be added as a child of an item from controller "${C}".`)}}e.MixedTestItemController=l;const s=S=>{const b=(0,e.getPrivateApiFor)(S);let p=new Map;return{get size(){return p.size},forEach(C,a){for(const M of p.values())C.call(a,M,this)},replace(C){const a=new Map,M=new Set(p.keys()),o={op:4,ops:[]};for(const n of C){if(!(n instanceof m))throw new d(n.id);const u=(0,e.getPrivateApiFor)(n).controllerId;if(u!==b.controllerId)throw new l(n.id,u,b.controllerId);if(a.has(n.id))throw new i(n.id);a.set(n.id,n),M.delete(n.id),o.ops.push({op:0,item:n})}for(const n of M.keys())o.ops.push({op:1,id:n});b.listener?.(o),p=a},add(C){if(!(C instanceof m))throw new d(C.id);p.set(C.id,C),b.listener?.({op:0,item:C})},delete(C){p.delete(C)&&b.listener?.({op:1,id:C})},get(C){return p.get(C)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class m{constructor(b,p,C,a){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const M=(0,e.createPrivateApiFor)(this,b);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return M.parent instanceof F?void 0:M.parent}},children:{value:s(this),enumerable:!0,writable:!1},...R(M,C)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=m;class F extends m{constructor(b,p){super(b,b,p,void 0)}}e.TestItemRootImpl=F}),define(ye[63],_e([0,1,3,143,4,14]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var I;(function(D){function T(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?t.TunnelPrivacyId.Public:t.TunnelPrivacyId.Private),protocol:w.protocol}}D.fromApiTunnel=T;function R(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==t.TunnelPrivacyId.ConstantPrivate&&w.privacy!==t.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}D.fromServiceTunnel=R})(I=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,r.createDecorator)("IExtHostTunnelService");let P=class{constructor(T){this.onDidChangeTunnels=new _.Emitter().event}async $applyCandidateFilter(T){return T}async openTunnel(T,R){}async getTunnels(){return[]}async setTunnelFactory(T){return{dispose:()=>{}}}registerPortsAttributesProvider(T,R){return{dispose:()=>{}}}async $providePortAttributes(T,R,w,i,d){return[]}async $forwardPort(T,R){}async $closeTunnel(T){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};P=Be([$e(0,A.IExtHostRpcService)],P),e.ExtHostTunnelService=P});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[7],_e([0,1,16,15,75,22,74,9,10,2,36,46,82]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i){"use strict";var d,l,s,m,F,S,b,p,C,a,M,o,n,u,f,c,h,g,E,v;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeDataTransfer=e.TreeDataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function k(U){function O(){return Reflect.construct(U,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(U,"name")),Object.setPrototypeOf(O,U),Object.setPrototypeOf(O.prototype,U.prototype),O}let x=F=class{constructor(O){d.set(this,void 0),Xe(this,d,O,"f")}static from(...O){let Z=O;return new F(function(){if(Z){for(const Ce of Z)Ce&&typeof Ce.dispose=="function"&&Ce.dispose();Z=void 0}})}dispose(){typeof Ie(this,d,"f")=="function"&&(Ie(this,d,"f").call(this),Xe(this,d,void 0,"f"))}};d=new WeakMap,x=F=Be([k],x),e.Disposable=x;let N=S=class{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("line must be non-negative");if(Z<0)throw(0,t.illegalArgument)("character must be non-negative");this._line=O,this._character=Z}static Min(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let Ce=1;Ce<O.length;Ce++){const Ke=O[Ce];Ke.isBefore(Z)&&(Z=Ke)}return Z}static Max(...O){if(O.length===0)throw new TypeError;let Z=O[0];for(let Ce=1;Ce<O.length;Ce++){const Ke=O[Ce];Ke.isAfter(Z)&&(Z=Ke)}return Z}static isPosition(O){if(!O)return!1;if(O instanceof S)return!0;let{line:Z,character:Ce}=O;return typeof Z=="number"&&typeof Ce=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,Z=0){if(O===null||Z===null)throw(0,t.illegalArgument)();let Ce;return typeof O=="undefined"?Ce=0:typeof O=="number"?Ce=O:(Ce=typeof O.lineDelta=="number"?O.lineDelta:0,Z=typeof O.characterDelta=="number"?O.characterDelta:0),Ce===0&&Z===0?this:new S(this.line+Ce,this.character+Z)}with(O,Z=this.character){if(O===null||Z===null)throw(0,t.illegalArgument)();let Ce;return typeof O=="undefined"?Ce=this.line:typeof O=="number"?Ce=O:(Ce=typeof O.line=="number"?O.line:this.line,Z=typeof O.character=="number"?O.character:this.character),Ce===this.line&&Z===this.character?this:new S(Ce,Z)}toJSON(){return{line:this.line,character:this.character}}};N=S=Be([k],N),e.Position=N;let y=b=class{constructor(O,Z,Ce,Ke){let it,ct;if(typeof O=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new N(O,Z),ct=new N(Ce,Ke)):O instanceof N&&Z instanceof N&&(it=O,ct=Z),!it||!ct)throw new Error("Invalid arguments");it.isBefore(ct)?(this._start=it,this._end=ct):(this._start=ct,this._end=it)}static isRange(O){return O instanceof b?!0:O?N.isPosition(O.start)&&N.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof b?this.contains(O._start)&&this.contains(O._end):O instanceof N?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const Z=N.Max(O.start,this._start),Ce=N.Min(O.end,this._end);if(!Z.isAfter(Ce))return new b(Z,Ce)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const Z=N.Min(O.start,this._start),Ce=N.Max(O.end,this.end);return new b(Z,Ce)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,Z=this.end){if(O===null||Z===null)throw(0,t.illegalArgument)();let Ce;return O?N.isPosition(O)?Ce=O:(Ce=O.start||this.start,Z=O.end||this.end):Ce=this.start,Ce.isEqual(this._start)&&Z.isEqual(this.end)?this:new b(Ce,Z)}toJSON(){return[this.start,this.end]}};y=b=Be([k],y),e.Range=y;let L=p=class extends y{constructor(O,Z,Ce,Ke){let it,ct;if(typeof O=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"?(it=new N(O,Z),ct=new N(Ce,Ke)):O instanceof N&&Z instanceof N&&(it=O,ct=Z),!it||!ct)throw new Error("Invalid arguments");super(it,ct);this._anchor=it,this._active=ct}static isSelection(O){return O instanceof p?!0:O?y.isRange(O)&&N.isPosition(O.anchor)&&N.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};L=p=Be([k],L),e.Selection=L;class W{constructor(O,Z,Ce){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("host");if(typeof Z!="number"||Z===0||Math.round(Z)!==Z)throw(0,t.illegalArgument)("port");if(typeof Ce!="undefined"&&(typeof Ce!="string"||Ce.length===0||!/^[0-9A-Za-z\-]+$/.test(Ce)))throw(0,t.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(Z),this.connectionToken=Ce}}e.ResolvedAuthority=W;class B extends Error{constructor(O,Z=i.RemoteAuthorityResolverErrorCode.Unknown,Ce){super(O);this._message=O,this._code=Z,this._detail=Ce,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,B.prototype)}static NotAvailable(O,Z){return new B(O,i.RemoteAuthorityResolverErrorCode.NotAvailable,Z)}static TemporarilyNotAvailable(O){return new B(O,i.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=B;var $;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})($=e.EndOfLine||(e.EndOfLine={}));var q;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(q=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ie=C=class{constructor(O,Z){this._range=O,this._newText=Z}static isTextEdit(O){return O instanceof C?!0:O?y.isRange(O)&&typeof O.newText=="string":!1}static replace(O,Z){return new C(O,Z)}static insert(O,Z){return C.replace(new y(O,O),Z)}static delete(O){return C.replace(O,"")}static setEndOfLine(O){const Z=new C(new y(new N(0,0),new N(0,0)),"");return Z.newEol=O,Z}get range(){return this._range}set range(O){if(O&&!y.isRange(O))throw(0,t.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,t.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,t.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ie=C=Be([k],ie),e.TextEdit=ie;var se;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace"})(se=e.FileEditType||(e.FileEditType={}));let X=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,Z,Ce,Ke){this._edits.push({_type:1,from:O,to:Z,options:Ce,metadata:Ke})}createFile(O,Z,Ce){this._edits.push({_type:1,from:void 0,to:O,options:Z,metadata:Ce})}deleteFile(O,Z,Ce){this._edits.push({_type:1,from:O,to:void 0,options:Z,metadata:Ce})}replaceNotebookMetadata(O,Z,Ce){this._edits.push({_type:3,metadata:Ce,uri:O,edit:{editType:5,metadata:Z},notebookMetadata:Z})}replaceNotebookCells(O,Z,Ce,Ke,it){let ct,ft,Pt=[],Ft;if(Ht.isNotebookRange(Z)&&Ut.isNotebookCellDataArray(Ce)&&!Ut.isNotebookCellDataArray(Ke)?(ct=Z.start,ft=Z.end,Pt=Ce,Ft=Ke):typeof Z=="number"&&typeof Ce=="number"&&Ut.isNotebookCellDataArray(Ke)&&(ct=Z,ft=Ce,Pt=Ke,Ft=it),ct===void 0||ft===void 0)throw new Error("Invalid arguments");(ct!==ft||Pt.length>0)&&this._edits.push({_type:5,uri:O,index:ct,count:ft-ct,cells:Pt,metadata:Ft})}replaceNotebookCellMetadata(O,Z,Ce,Ke){this._edits.push({_type:3,metadata:Ke,uri:O,edit:{editType:8,index:Z,metadata:Ce}})}replace(O,Z,Ce,Ke){this._edits.push({_type:2,uri:O,edit:new ie(Z,Ce),metadata:Ke})}insert(O,Z,Ce,Ke){this.replace(O,new y(Z,Z),Ce,Ke)}delete(O,Z,Ce){this.replace(O,Z,"",Ce)}has(O){return this._edits.some(Z=>Z._type===2&&Z.uri.toString()===O.toString())}set(O,Z){if(Z)for(const Ce of Z)Ce&&this._edits.push({_type:2,uri:O,edit:Ce});else{for(let Ce=0;Ce<this._edits.length;Ce++){const Ke=this._edits[Ce];Ke._type===2&&Ke.uri.toString()===O.toString()&&(this._edits[Ce]=void 0)}(0,r.coalesceInPlace)(this._edits)}}get(O){const Z=[];for(let Ce of this._edits)Ce._type===2&&Ce.uri.toString()===O.toString()&&Z.push(Ce.edit);return Z}entries(){const O=new A.ResourceMap;for(let Z of this._edits)if(Z._type===2){let Ce=O.get(Z.uri);Ce||(Ce=[Z.uri,[]],O.set(Z.uri,Ce)),Ce[1].push(Z.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};X=Be([k],X),e.WorkspaceEdit=X;let ge=a=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof a?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=a._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,Z=this._tabstop++){if(typeof O=="function"){const Ce=new a;Ce._tabstop=this._tabstop,O(Ce),this._tabstop=Ce._tabstop,O=Ce.value}else O=a._escape(O);return this.value+="${",this.value+=Z,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,Z=this._tabstop++){const Ce=O.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=Z,this.value+="|",this.value+=Ce,this.value+="|}",this}appendVariable(O,Z){if(typeof Z=="function"){const Ce=new a;Ce._tabstop=this._tabstop,Z(Ce),this._tabstop=Ce._tabstop,Z=Ce.value}else typeof Z=="string"&&(Z=Z.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,Z&&(this.value+=":",this.value+=Z),this.value+="}",this}};ge=a=Be([k],ge),e.SnippetString=ge;var be;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(be=e.DiagnosticTag||(e.DiagnosticTag={}));var pe;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(pe=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let fe=M=class{constructor(O,Z){if(this.uri=O,Z)if(Z instanceof y)this.range=Z;else if(Z instanceof N)this.range=new y(Z,Z);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof M?!0:O?y.isRange(O.range)&&T.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};fe=M=Be([k],fe),e.Location=fe;let oe=class{constructor(O,Z){this.location=O,this.message=Z}static is(O){return O?typeof O.message=="string"&&O.location&&y.isRange(O.location.range)&&T.URI.isUri(O.location.uri):!1}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.location.range.isEqual(Z.location.range)&&O.location.uri.toString()===Z.location.uri.toString()}};oe=Be([k],oe),e.DiagnosticRelatedInformation=oe;let Ee=class{constructor(O,Z,Ce=pe.Error){if(!y.isRange(O))throw new TypeError("range must be set");if(!Z)throw new TypeError("message must be set");this.range=O,this.message=Z,this.severity=Ce}toJSON(){return{severity:pe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,Z){return O===Z?!0:!O||!Z?!1:O.message===Z.message&&O.severity===Z.severity&&O.code===Z.code&&O.severity===Z.severity&&O.source===Z.source&&O.range.isEqual(Z.range)&&(0,r.equals)(O.tags,Z.tags)&&(0,r.equals)(O.relatedInformation,Z.relatedInformation,oe.isEqual)}};Ee=Be([k],Ee),e.Diagnostic=Ee;let Pe=class{constructor(O,Z){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=Z}};Pe=Be([k],Pe),e.Hover=Pe;var Oe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(Oe=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let je=class{constructor(O,Z=Oe.Text){this.range=O,this.kind=Z}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};je=Be([k],je),e.DocumentHighlight=je;var st;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(st=e.SymbolKind||(e.SymbolKind={}));var et;(function(U){U[U.Deprecated=1]="Deprecated"})(et=e.SymbolTag||(e.SymbolTag={}));let tt=o=class{constructor(O,Z,Ce,Ke,it){this.name=O,this.kind=Z,this.containerName=it,typeof Ce=="string"&&(this.containerName=Ce),Ke instanceof fe?this.location=Ke:Ce instanceof y&&(this.location=new fe(Ke,Ce)),o.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:st[this.kind],location:this.location,containerName:this.containerName}}};tt=o=Be([k],tt),e.SymbolInformation=tt;let H=n=class{constructor(O,Z,Ce,Ke,it){this.name=O,this.detail=Z,this.kind=Ce,this.range=Ke,this.selectionRange=it,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};H=n=Be([k],H),e.DocumentSymbol=H;var K;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(K=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let z=class{constructor(O,Z){this.title=O,this.kind=Z}};z=Be([k],z),e.CodeAction=z;let j=u=class{constructor(O){this.value=O}append(O){return new u(this.value?this.value+u.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+u.sep)}};j.sep=".",j=u=Be([k],j),e.CodeActionKind=j,j.Empty=new j(""),j.QuickFix=j.Empty.append("quickfix"),j.Refactor=j.Empty.append("refactor"),j.RefactorExtract=j.Refactor.append("extract"),j.RefactorInline=j.Refactor.append("inline"),j.RefactorRewrite=j.Refactor.append("rewrite"),j.Source=j.Empty.append("source"),j.SourceOrganizeImports=j.Source.append("organizeImports"),j.SourceFixAll=j.Source.append("fixAll");let Y=class{constructor(O,Z){if(this.range=O,this.parent=Z,Z&&!Z.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Y=Be([k],Y),e.SelectionRange=Y;class ae{constructor(O,Z,Ce,Ke,it,ct){this.kind=O,this.name=Z,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.CallHierarchyItem=ae;class Se{constructor(O,Z){this.fromRanges=Z,this.from=O}}e.CallHierarchyIncomingCall=Se;class xe{constructor(O,Z){this.fromRanges=Z,this.to=O}}e.CallHierarchyOutgoingCall=xe;var Ve;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Qe=class{constructor(O,Z){this.range=O,this.command=Z}get isResolved(){return!!this.command}};Qe=Be([k],Qe),e.CodeLens=Qe;let nt=f=class{constructor(O,Z=!1){l.set(this,void 0),Xe(this,l,new _.MarkdownString(O,{supportThemeIcons:Z}),"f")}static isMarkdownString(O){return O instanceof f?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ie(this,l,"f").value}set value(O){Ie(this,l,"f").value=O}get isTrusted(){return Ie(this,l,"f").isTrusted}set isTrusted(O){Ie(this,l,"f").isTrusted=O}get supportThemeIcons(){return Ie(this,l,"f").supportThemeIcons}set supportThemeIcons(O){Ie(this,l,"f").supportThemeIcons=O}get supportHtml(){return Ie(this,l,"f").supportHtml}set supportHtml(O){Ie(this,l,"f").supportHtml=O}appendText(O){return Ie(this,l,"f").appendText(O),this}appendMarkdown(O){return Ie(this,l,"f").appendMarkdown(O),this}appendCodeblock(O,Z){return Ie(this,l,"f").appendCodeblock(Z??"",O),this}};l=new WeakMap,nt=f=Be([k],nt),e.MarkdownString=nt;let rt=class{constructor(O,Z){this.label=O,this.documentation=Z}};rt=Be([k],rt),e.ParameterInformation=rt;let Je=class{constructor(O,Z){this.label=O,this.documentation=Z,this.parameters=[]}};Je=Be([k],Je),e.SignatureInformation=Je;let Ze=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ze=Be([k],Ze),e.SignatureHelp=Ze;var pt;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(pt=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(U){U[U.Other=0]="Other",U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let At=class{constructor(O){this.label=O}toString(){return this.label}};At=Be([k],At),e.InlayHintLabelPart=At;let G=class{constructor(O,Z,Ce){this.label=O,this.position=Z,this.kind=Ce}};G=Be([k],G),e.InlayHint=G;var Q;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var de;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(de=e.CompletionItemKind||(e.CompletionItemKind={}));var Ue;(function(U){U[U.Deprecated=1]="Deprecated"})(Ue=e.CompletionItemTag||(e.CompletionItemTag={}));let qe=class{constructor(O,Z){this.label=O,this.kind=Z}toJSON(){return{label:this.label,kind:this.kind&&de[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};qe=Be([k],qe),e.CompletionItem=qe;let lt=class{constructor(O=[],Z=!1){this.items=O,this.isIncomplete=Z}};lt=Be([k],lt),e.CompletionList=lt;let ht=class{constructor(O,Z,Ce){this.text=O,this.range=Z,this.command=Ce}};ht=Be([k],ht),e.InlineSuggestion=ht;let Ye=class{constructor(O){this.items=O}};Ye=Be([k],Ye),e.InlineSuggestions=Ye;var kt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(kt=e.ViewColumn||(e.ViewColumn={}));var Ae;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ae=e.StatusBarAlignment||(e.StatusBarAlignment={}));var De;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(De=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ve;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var te;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(te=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ne;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ue;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(ue=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var me;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(me=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(U){function O(Z){switch(Z){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=O}(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Te=class{constructor(O,Z){if(Z&&!T.URI.isUri(Z))throw(0,t.illegalArgument)("target");if(!y.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.target=Z}};Te=Be([k],Te),e.DocumentLink=Te;let He=class{constructor(O,Z,Ce,Ke){this.red=O,this.green=Z,this.blue=Ce,this.alpha=Ke}};He=Be([k],He),e.Color=He;let Le=class{constructor(O,Z){if(Z&&!(Z instanceof He))throw(0,t.illegalArgument)("color");if(!y.isRange(O)||O.isEmpty)throw(0,t.illegalArgument)("range");this.range=O,this.color=Z}};Le=Be([k],Le),e.ColorInformation=Le;let Ge=class{constructor(O){if(!O||typeof O!="string")throw(0,t.illegalArgument)("label");this.label=O}};Ge=Be([k],Ge),e.ColorPresentation=Ge;var ot;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ot=e.ColorFormat||(e.ColorFormat={}));var at;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(at=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Ne{constructor(O,Z,Ce){if(this.startIndex=O,this.length=Z,this.tooltip=Ce,typeof O!="number"||O<0)throw(0,t.illegalArgument)("startIndex");if(typeof Z!="number"||Z<1)throw(0,t.illegalArgument)("length");if(Ce!==void 0&&typeof Ce!="string")throw(0,t.illegalArgument)("tooltip")}}e.TerminalLink=Ne;var ce;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(ce=e.TerminalLocation||(e.TerminalLocation={}));class he{constructor(O){this.options=O,typeof O!="object"&&(0,t.illegalArgument)("options")}}e.TerminalProfile=he;var re;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(re=e.TaskRevealKind||(e.TaskRevealKind={}));var V;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(V=e.TaskPanelKind||(e.TaskPanelKind={}));let we=c=class{constructor(O,Z){if(this.label=Z,typeof O!="string"||typeof Z!="string")throw(0,t.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return c.Clean;case"build":return c.Build;case"rebuild":return c.Rebuild;case"test":return c.Test;default:return}}get id(){return this._id}};we.Clean=new c("clean","Clean"),we.Build=new c("build","Build"),we.Rebuild=new c("rebuild","Rebuild"),we.Test=new c("test","Test"),we=c=Be([k],we),e.TaskGroup=we;function Re(U){let O="";for(let Z=0;Z<U.length;Z++)O+=U[Z].replace(/,/g,",,")+",";return O}let We=class{constructor(O,Z,Ce){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._args=[],this._process=O,Z!==void 0&&(Array.isArray(Z)?(this._args=Z,this._options=Ce):this._options=Z)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,t.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let Z of this._args)O.push(Z);return Re(O)}};We=Be([k],We),e.ProcessExecution=We;let ze=class{constructor(O,Z,Ce){if(this._args=[],Array.isArray(Z)){if(!O)throw(0,t.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O,this._args=Z,this._options=Ce}else{if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O,this._options=Z}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,t.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,t.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let Z of this._args)O.push(typeof Z=="string"?Z:Z.value);return Re(O)}};ze=Be([k],ze),e.ShellExecution=ze;var mt;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(mt=e.ShellQuoting||(e.ShellQuoting={}));var Et;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Et=e.TaskScope||(e.TaskScope={}));class _t{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=_t;let dt=h=class{constructor(O,Z,Ce,Ke,it,ct){this.__deprecated=!1,this._definition=this.definition=O;let ft;typeof Z=="string"?(this._name=this.name=Z,this._source=this.source=Ce,this.execution=Ke,ft=it,this.__deprecated=!0):Z===Et.Global||Z===Et.Workspace?(this.target=Z,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct):(this.target=Z,this._name=this.name=Ce,this._source=this.source=Ke,this.execution=it,ft=ct),typeof ft=="string"?(this._problemMatchers=[ft],this._hasDefinedMatchers=!0):Array.isArray(ft)?(this._problemMatchers=ft,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof We?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof ze?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof _t?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,t.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,t.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const Z=this._definition.type;(h.EmptyType===Z||h.ProcessType===Z||h.ShellType===Z||h.ExtensionCallbackType===Z)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,t.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};dt.ExtensionCallbackType="customExecution",dt.ProcessType="process",dt.ShellType="shell",dt.EmptyType="$empty",dt=h=Be([k],dt),e.Task=dt;var vt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(vt=e.ProgressLocation||(e.ProgressLocation={}));let bt=class{constructor(O,Z=xt.None){this.collapsibleState=Z,T.URI.isUri(O)?this.resourceUri=O:this.label=O}};bt=Be([k],bt),e.TreeItem=bt;var xt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(xt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let It=class{constructor(O){this._value=O}async asString(){return JSON.stringify(this._value)}};It=Be([k],It),e.TreeDataTransferItem=It;let Mt=class{constructor(){this._items=new Map}get(O){return this._items.get(O)}set(O,Z){this._items.set(O,Z)}forEach(O){this._items.forEach(O)}};Mt=Be([k],Mt),e.TreeDataTransfer=Mt;let Dt=class{constructor(O,Z){this.id=O,this.color=Z}};Dt=Be([k],Dt),e.ThemeIcon=Dt,Dt.File=new Dt("file"),Dt.Folder=new Dt("folder");let St=class{constructor(O){this.id=O}};St=Be([k],St),e.ThemeColor=St;var Qt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Qt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Vt=class{constructor(O,Z){if(typeof O!="string"&&(!O||!T.URI.isUri(O)&&!T.URI.isUri(O.uri)))throw(0,t.illegalArgument)("base");if(typeof Z!="string")throw(0,t.illegalArgument)("pattern");typeof O=="string"?this.baseUri=T.URI.file(O):T.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=Z}get base(){return this._base}set base(O){this._base=O,this._baseUri=T.URI.file(O)}get baseUri(){return this._baseUri}set baseUri(O){this._baseUri=O,this._base=O.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};Vt=Be([k],Vt),e.RelativePattern=Vt;let wt=class{constructor(O,Z,Ce,Ke){this.enabled=typeof O=="boolean"?O:!0,typeof Z=="string"&&(this.condition=Z),typeof Ce=="string"&&(this.hitCondition=Ce),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};wt=Be([k],wt),e.Breakpoint=wt;let Yt=class extends wt{constructor(O,Z,Ce,Ke,it){super(Z,Ce,Ke,it);if(O===null)throw(0,t.illegalArgument)("location");this.location=O}};Yt=Be([k],Yt),e.SourceBreakpoint=Yt;let qt=class extends wt{constructor(O,Z,Ce,Ke,it){super(Z,Ce,Ke,it);this.functionName=O}};qt=Be([k],qt),e.FunctionBreakpoint=qt;let Xt=class extends wt{constructor(O,Z,Ce,Ke,it,ct,ft){super(Ke,it,ct,ft);if(!Z)throw(0,t.illegalArgument)("dataId");this.label=O,this.dataId=Z,this.canPersist=Ce}};Xt=Be([k],Xt),e.DataBreakpoint=Xt;let ai=class{constructor(O,Z,Ce){this.command=O,this.args=Z||[],this.options=Ce}};ai=Be([k],ai),e.DebugAdapterExecutable=ai;let Rt=class{constructor(O,Z){this.port=O,this.host=Z}};Rt=Be([k],Rt),e.DebugAdapterServer=Rt;let Jt=class{constructor(O){this.path=O}};Jt=Be([k],Jt),e.DebugAdapterNamedPipeServer=Jt;let li=class{constructor(O){this.implementation=O}};li=Be([k],li),e.DebugAdapterInlineImplementation=li;let jt=class{constructor(O,Z){this.range=O,this.expression=Z}};jt=Be([k],jt),e.EvaluatableExpression=jt;var Zt;(function(U){U[U.Automatic=0]="Automatic",U[U.Explicit=1]="Explicit"})(Zt=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let gt=class{constructor(O,Z){this.range=O,this.text=Z}};gt=Be([k],gt),e.InlineValueText=gt;let ci=class{constructor(O,Z,Ce=!0){this.range=O,this.variableName=Z,this.caseSensitiveLookup=Ce}};ci=Be([k],ci),e.InlineValueVariableLookup=ci;let Lt=class{constructor(O,Z){this.range=O,this.expression=Z}};Lt=Be([k],Lt),e.InlineValueEvaluatableExpression=Lt;let $t=class{constructor(O,Z){this.frameId=O,this.stoppedLocation=Z}};$t=Be([k],$t),e.InlineValueContext=$t;var vi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(vi=e.FileChangeType||(e.FileChangeType={}));let ui=g=class extends Error{constructor(O,Z=w.FileSystemProviderErrorCode.Unknown,Ce){super(T.URI.isUri(O)?O.toString(!0):O);this.code=Ce?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,Z),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Ce=="function"&&Error.captureStackTrace(this,Ce)}static FileExists(O){return new g(O,w.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(O){return new g(O,w.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(O){return new g(O,w.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(O){return new g(O,w.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(O){return new g(O,w.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(O){return new g(O,w.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}};ui=g=Be([k],ui),e.FileSystemError=ui;let ei=class{constructor(O,Z,Ce){this.start=O,this.end=Z,this.kind=Ce}};ei=Be([k],ei),e.FoldingRange=ei;var Ci;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ci=e.FoldingRangeKind||(e.FoldingRangeKind={}));var bi;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(bi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var ti;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ti=e.CommentMode||(e.CommentMode={}));class Di{constructor(O,Z=[]){this.tokenTypes=O,this.tokenModifiers=Z}}e.SemanticTokensLegend=Di;function di(U){return typeof U=="undefined"||(0,D.isStringArray)(U)}class Gt{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let Z=0,Ce=O.tokenTypes.length;Z<Ce;Z++)this._tokenTypeStrToInt.set(O.tokenTypes[Z],Z);for(let Z=0,Ce=O.tokenModifiers.length;Z<Ce;Z++)this._tokenModifierStrToInt.set(O.tokenModifiers[Z],Z)}}push(O,Z,Ce,Ke,it){if(typeof O=="number"&&typeof Z=="number"&&typeof Ce=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it=="undefined"))return typeof it=="undefined"&&(it=0),this._pushEncoded(O,Z,Ce,Ke,it);if(y.isRange(O)&&typeof Z=="string"&&di(Ce))return this._push(O,Z,Ce);throw(0,t.illegalArgument)()}_push(O,Z,Ce){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(Z))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,it=O.start.character,ct=O.end.character-O.start.character,ft=this._tokenTypeStrToInt.get(Z);let Pt=0;if(Ce)for(const Ft of Ce){if(!this._tokenModifierStrToInt.has(Ft))throw new Error("`tokenModifier` is not in the provided legend");const Nt=this._tokenModifierStrToInt.get(Ft);Pt|=1<<Nt>>>0}this._pushEncoded(Ke,it,ct,ft,Pt)}_pushEncoded(O,Z,Ce,Ke,it){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&Z<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Pt=this._data.length/5|0;let Ft=0,Nt=0;for(let Bt=0;Bt<Pt;Bt++){let zt=this._data[5*Bt],gi=this._data[5*Bt+1];zt===0?(zt=Ft,gi+=Nt):zt+=Ft,this._data[5*Bt]=zt,this._data[5*Bt+1]=gi,Ft=zt,Nt=gi}}let ct=O,ft=Z;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ct-=this._prevLine,ct===0&&(ft-=this._prevChar)),this._data[this._dataLen++]=ct,this._data[this._dataLen++]=ft,this._data[this._dataLen++]=Ce,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=it,this._prevLine=O,this._prevChar=Z}static _sortAndDeltaEncode(O){let Z=[];const Ce=O.length/5|0;for(let ft=0;ft<Ce;ft++)Z[ft]=ft;Z.sort((ft,Pt)=>{const Ft=O[5*ft],Nt=O[5*Pt];if(Ft===Nt){const Bt=O[5*ft+1],zt=O[5*Pt+1];return Bt-zt}return Ft-Nt});const Ke=new Uint32Array(O.length);let it=0,ct=0;for(let ft=0;ft<Ce;ft++){const Pt=5*Z[ft],Ft=O[Pt+0],Nt=O[Pt+1],Bt=O[Pt+2],zt=O[Pt+3],gi=O[Pt+4],Wi=Ft-it,Ji=Wi===0?Nt-ct:Nt,pi=5*ft;Ke[pi+0]=Wi,Ke[pi+1]=Ji,Ke[pi+2]=Bt,Ke[pi+3]=zt,Ke[pi+4]=gi,it=Ft,ct=Nt}return Ke}build(O){return this._dataIsSortedAndDeltaEncoded?new hi(new Uint32Array(this._data),O):new hi(Gt._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Gt;class hi{constructor(O,Z){this.resultId=Z,this.data=O}}e.SemanticTokens=hi;class ki{constructor(O,Z,Ce){this.start=O,this.deleteCount=Z,this.data=Ce}}e.SemanticTokensEdit=ki;class Kt{constructor(O,Z){this.resultId=Z,this.edits=O}}e.SemanticTokensEdits=Kt;var Ii;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Ii=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Pi;(function(U){U[U.Initial=1]="Initial",U[U.Dynamic=2]="Dynamic"})(Pi=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let ii=class{constructor(){}};ii.Back={iconPath:new Dt("arrow-left")},ii=Be([k],ii),e.QuickInputButtons=ii;var Ti;(function(U){U[U.Separator=-1]="Separator",U[U.Default=1]="Default"})(Ti=e.QuickPickItemKind||(e.QuickPickItemKind={}));var fi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(fi=e.ExtensionKind||(e.ExtensionKind={}));class wi{constructor(O,Z,Ce){this.badge=O,this.tooltip=Z,this.color=Ce}static validate(O){if(O.badge){let Z=(0,P.nextCharLength)(O.badge,0);if(Z<O.badge.length&&(Z+=(0,P.nextCharLength)(O.badge,Z)),O.badge.length>Z)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=wi;let ni=class{constructor(O){this.kind=O}};ni=Be([k],ni),e.ColorTheme=ni;var Me;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast"})(Me=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(O,Z){if(O<0)throw(0,t.illegalArgument)("start must be positive");if(Z<0)throw(0,t.illegalArgument)("end must be positive");O<=Z?(this._start=O,this._end=Z):(this._start=Z,this._end=O)}static isNotebookRange(O){return O instanceof Ht?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let Z=this._start,Ce=this._end;return O.start!==void 0&&(Z=O.start),O.end!==void 0&&(Ce=O.end),Z===this._start&&Ce===this._end?this:new Ht(Z,Ce)}}e.NotebookRange=Ht;class Ut{constructor(O,Z,Ce,Ke,it,ct,ft){this.kind=O,this.value=Z,this.languageId=Ce,this.mime=Ke,this.outputs=it??[],this.metadata=ct,this.executionSummary=ft,Ut.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(Z=>Ut.isNotebookCellData(Z))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Ut;class yt{constructor(O){this.cells=O}}e.NotebookData=yt;class Ot{constructor(O,Z){this.data=O,this.mime=Z;const Ce=(0,I.normalizeMimeType)(Z,!0);if(!Ce)throw new Error(`INVALID mime type: ${Z}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ce}static isNotebookCellOutputItem(O){return O instanceof Ot?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const Z={name:O.name,message:O.message,stack:O.stack};return Ot.json(Z,"application/vnd.code.notebook.error")}static stdout(O){return Ot.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Ot.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,Z="application/octet-stream"){return new Ot(O,Z)}static text(O,Z=I.Mimes.text){const Ce=Ie(Ot,s,"f",m).encode(String(O));return new Ot(Ce,Z)}static json(O,Z="application/json"){const Ce=JSON.stringify(O,void 0,"	");return Ot.text(Ce,Z)}}e.NotebookCellOutputItem=Ot,s=Ot,m={value:new TextEncoder};class ri{constructor(O,Z,Ce){this.items=ri.ensureUniqueMimeTypes(O,!0),typeof Z=="string"?(this.id=Z,this.metadata=Ce):(this.id=(0,R.generateUuid)(),this.metadata=Z??Ce)}static isNotebookCellOutput(O){return O instanceof ri?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&(0,D.isArray)(O.items)}static ensureUniqueMimeTypes(O,Z=!1){const Ce=new Set,Ke=new Set;for(let it=0;it<O.length;it++){const ct=O[it],ft=(0,I.normalizeMimeType)(ct.mime);if(!Ce.has(ft)){Ce.add(ft);continue}Ke.add(it),Z&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?O:O.filter((it,ct)=>!Ke.has(ct))}}e.NotebookCellOutput=ri;var Ei;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ei=e.NotebookCellKind||(e.NotebookCellKind={}));var yi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(yi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ai;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(Ai=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ri;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Ri=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Fi{constructor(O,Z){this.text=O,this.alignment=Z}}e.NotebookCellStatusBarItem=Fi;var Mi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(Mi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class _i{constructor(O,Z=[]){this.uri=O,this.provides=(0,r.asArray)(Z)}}e.NotebookRendererScript=_i;let mi=class{constructor(O,Z){this.label=O,this.timestamp=Z}};mi=Be([k],mi),e.TimelineItem=mi;var Oi;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(Oi=e.ExtensionMode||(e.ExtensionMode={}));var Li;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(Li=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class xi{constructor(O,Z){this.ranges=O,this.wordPattern=Z}}e.LinkedEditingRanges=xi;class J{constructor(O,Z){this._port=O,this._autoForwardAction=Z}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=J;var le;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(le=e.TestResultState||(e.TestResultState={}));var ke;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(ke=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ut=class{constructor(O=void 0,Z=void 0,Ce=void 0){this.include=O,this.exclude=Z,this.profile=Ce}};ut=Be([k],ut),e.TestRunRequest=ut;let Ct=E=class{constructor(O){this.message=O}static diff(O,Z,Ce){const Ke=new E(O);return Ke.expectedOutput=Z,Ke.actualOutput=Ce,Ke}};Ct=E=Be([k],Ct),e.TestMessage=Ct;let Tt=class{constructor(O){this.id=O}};Tt=Be([k],Tt),e.TestTag=Tt;let oi=class{constructor(O,Z){this.covered=O,this.total=Z}};oi=Be([k],oi),e.CoveredCount=oi;let Ui=v=class{constructor(O,Z,Ce,Ke){this.uri=O,this.statementCoverage=Z,this.branchCoverage=Ce,this.functionCoverage=Ke}static fromDetails(O,Z){const Ce=new oi(0,0),Ke=new oi(0,0),it=new oi(0,0);for(const ft of Z)if("branches"in ft){Ce.total+=1,Ce.covered+=ft.executionCount>0?1:0;for(const Pt of ft.branches)Ke.total+=1,Ke.covered+=Pt.executionCount>0?1:0}else it.total+=1,it.covered+=ft.executionCount>0?1:0;const ct=new v(O,Ce,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return ct.detailedCoverage=Z,ct}};Ui=v=Be([k],Ui),e.FileCoverage=Ui;let Bi=class{constructor(O,Z,Ce=[]){this.executionCount=O,this.location=Z,this.branches=Ce}};Bi=Be([k],Bi),e.StatementCoverage=Bi;let $i=class{constructor(O,Z){this.executionCount=O,this.location=Z}};$i=Be([k],$i),e.BranchCoverage=$i;let Hi=class{constructor(O,Z){this.executionCount=O,this.location=Z}};Hi=Be([k],Hi),e.FunctionCoverage=Hi;var Ki;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Ki=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Qi;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Qi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Yi;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(Yi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Xi{constructor(O,Z,Ce,Ke,it,ct){this.kind=O,this.name=Z,this.detail=Ce,this.uri=Ke,this.range=it,this.selectionRange=ct}}e.TypeHierarchyItem=Xi}),define(ye[84],_e([0,1,42,11,9,223,113,7,16]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const T=new Map;function R(l,s){s?T.set(l,s):T.delete(l)}e.setWordDefinitionFor=R;function w(l){return T.get(l)}e.getWordDefinitionFor=w;class i extends A.MirrorTextModel{constructor(s,m,F,S,b,p,C,a){super(m,F,S,b);this._proxy=s,this._languageId=p,this._isDirty=C,this._notebook=a,this._isDisposed=!1}dispose(){(0,r.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(s){return(0,D.equals)(this._lines,s)}get document(){if(!this._document){const s=this;this._document={get uri(){return s._uri},get fileName(){return s._uri.fsPath},get isUntitled(){return s._uri.scheme===t.Schemas.untitled},get languageId(){return s._languageId},get version(){return s._versionId},get isClosed(){return s._isDisposed},get isDirty(){return s._isDirty},get notebook(){return s._notebook},save(){return s._save()},getText(m){return m?s._getTextInRange(m):s.getText()},get eol(){return s._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return s._lines.length},lineAt(m){return s._lineAt(m)},offsetAt(m){return s._offsetAt(m)},positionAt(m){return s._positionAt(m)},validateRange(m){return s._validateRange(m)},validatePosition(m){return s._validatePosition(m)},getWordRangeAtPosition(m,F){return s._getWordRangeAtPosition(m,F)}}}return Object.freeze(this._document)}_acceptLanguageId(s){(0,r.ok)(!this._isDisposed),this._languageId=s}_acceptIsDirty(s){(0,r.ok)(!this._isDisposed),this._isDirty=s}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(s){const m=this._validateRange(s);if(m.isEmpty)return"";if(m.isSingleLine)return this._lines[m.start.line].substring(m.start.character,m.end.character);const F=this._eol,S=m.start.line,b=m.end.line,p=[];p.push(this._lines[S].substring(m.start.character));for(let C=S+1;C<b;C++)p.push(this._lines[C]);return p.push(this._lines[b].substring(0,m.end.character)),p.join(F)}_lineAt(s){let m;if(s instanceof P.Position?m=s.line:typeof s=="number"&&(m=s),typeof m!="number"||m<0||m>=this._lines.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new d(m,this._lines[m],m===this._lines.length-1)}_offsetAt(s){return s=this._validatePosition(s),this._ensureLineStarts(),this._lineStarts.getPrefixSum(s.line-1)+s.character}_positionAt(s){s=Math.floor(s),s=Math.max(0,s),this._ensureLineStarts();const m=this._lineStarts.getIndexOf(s),F=this._lines[m.index].length;return new P.Position(m.index,Math.min(m.remainder,F))}_validateRange(s){if(!(s instanceof P.Range))throw new Error("Invalid argument");const m=this._validatePosition(s.start),F=this._validatePosition(s.end);return m===s.start&&F===s.end?s:new P.Range(m.line,m.character,F.line,F.character)}_validatePosition(s){if(!(s instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return s.with(0,0);let{line:m,character:F}=s,S=!1;if(m<0)m=0,F=0,S=!0;else if(m>=this._lines.length)m=this._lines.length-1,F=this._lines[m].length,S=!0;else{const b=this._lines[m].length;F<0?(F=0,S=!0):F>b&&(F=b,S=!0)}return S?new P.Position(m,F):s}_getWordRangeAtPosition(s,m){const F=this._validatePosition(s);if(!m)m=w(this._languageId);else if((0,_.regExpLeadsToEndlessLoop)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const S=(0,I.getWordAtText)(F.character+1,(0,I.ensureValidWordDefinition)(m),this._lines[F.line],0);if(S)return new P.Range(F.line,S.startColumn-1,F.line,S.endColumn-1)}}e.ExtHostDocumentData=i;class d{constructor(s,m,F){this._line=s,this._text=m,this._isLastLine=F}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(ye[149],_e([0,1,7,4,224,6,56,22,2,36]),function(ee,e,r,t,_,A,I,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class R{constructor(i,d,l,s){this._notebook=l,this._selector=s,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,T.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(F=>{const S=this._cellUris.get(F.document.uri);S!==void 0&&(this._cellLengths.setValue(S,this._cells[S].document.getText().length+1),this._cellLines.setValue(S,this._cells[S].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const m=F=>{F===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(i.onDidChangeNotebookCells(F=>m(F.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const i=[],d=[];for(const l of this._notebook.getCells())l.kind===r.NotebookCellKind.Code&&(!this._selector||(0,I.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),i.push(l.document.getText().length+1),d.push(l.document.lineCount));this._cellLengths=new _.PrefixSumComputer(new Uint32Array(i)),this._cellLines=new _.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(i){if(!i){let S="";for(const b of this._cells)S+=b.document.getText()+`
`;return S=S.slice(0,-1),S}if(i.isEmpty)return"";const d=this.locationAt(i.start),l=this.locationAt(i.end),s=this._cellUris.get(d.uri),m=this._cellUris.get(l.uri);if(s===void 0||m===void 0)return"";if(s===m)return this._cells[s].document.getText(new r.Range(d.range.start,l.range.end));const F=[this._cells[s].document.getText(new r.Range(d.range.start,new r.Position(this._cells[s].document.lineCount,0)))];for(let S=s+1;S<m;S++)F.push(this._cells[S].document.getText());return F.push(this._cells[m].document.getText(new r.Range(new r.Position(0,0),l.range.end))),F.join(`
`)}offsetAt(i){const d=this._cellLines.getIndexOf(i.line),l=this._cellLengths.getPrefixSum(d.index-1),s=this._cells[d.index].document.offsetAt(i.with(d.remainder));return l+s}positionAt(i){if(typeof i=="number"){const l=this._cellLengths.getIndexOf(i),s=this._cellLines.getPrefixSum(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(s)}const d=this._cellUris.get(i.uri);if(d!==void 0){const l=this._cellLines.getPrefixSum(d-1);return new r.Position(l+i.range.start.line,i.range.start.character)}return new r.Position(0,0)}locationAt(i){r.Range.isRange(i)||(i=new r.Range(i,i));const d=this._cellLines.getIndexOf(i.start.line);let l=d;i.isEmpty||(l=this._cellLines.getIndexOf(i.end.line));const s=new r.Position(d.remainder,i.start.character),m=new r.Position(l.remainder,i.end.character),F=new r.Range(s,m),S=this._cells[d.index];return new r.Location(S.document.uri,S.document.validateRange(F))}contains(i){return this._cellUris.has(i)}validateRange(i){const d=this.validatePosition(i.start),l=this.validatePosition(i.end);return i.with(d,l)}validatePosition(i){const d=this._cellLines.getIndexOf(i.line),l=new r.Position(d.remainder,i.character),s=this._cells[d.index].document.validatePosition(l),m=this._cellLines.getPrefixSum(d.index-1);return new r.Position(m+s.line,s.character)}}e.ExtHostNotebookConcatDocument=R}),define(ye[150],_e([0,1,7,14,4]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(P){this._actual=new r.ColorTheme(r.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new _.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let D=P==="light"?r.ColorThemeKind.Light:P==="dark"?r.ColorThemeKind.Dark:r.ColorThemeKind.HighContrast;this._actual=new r.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([$e(0,t.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(ye[64],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,r.createDecorator)("IURITransformerService");class t{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=I=>I,this.transformOutgoing=I=>I,this.transformOutgoingURI=I=>I,this.transformOutgoingScheme=I=>I)}}e.URITransformerService=t}),define(ye[151],_e([0,1,21]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class t{constructor(){this.buffers=[]}add(D){let T=this.buffers.indexOf(D);return T<0&&(T=this.buffers.length,this.buffers.push(D)),T}}function _(P,D){if(D.serializeBuffersForPostMessage){const T=new t,R=(d,l)=>{if(l instanceof ArrayBuffer){const s=T.add(l);return{$$vscode_array_buffer_reference$$:!0,index:s}}else if(ArrayBuffer.isView(l)){const s=A(l);if(s){const m=T.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:m,view:{type:s,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},w=JSON.stringify(P,R),i=T.buffers.map(d=>{const l=new Uint8Array(d);return r.VSBuffer.wrap(l)});return{message:w,buffers:i}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=_;function A(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function I(P,D){const T=D.map(i=>{const d=new ArrayBuffer(i.byteLength);return new Uint8Array(d).set(i.buffer),d}),R=D.length?(i,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const l=d,{index:s}=l,m=T[s];if(l.view)switch(l.view.type){case 1:return new Int8Array(m,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return d}:void 0;return{message:JSON.parse(P,R),arrayBuffers:T}}e.deserializeWebviewMessage=I}),define(ye[152],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var r;(function(t){function _(I){const P=new Map;return I.types.forEach((D,T)=>{P.set(D,{asString:async()=>I.items[T].asString})}),P}t.toITreeDataTransfer=_;async function A(I){const P={types:[],items:[]},D=Array.from(I.entries());for(const T of D)P.types.push(T[0]),P.items.push({asString:await T[1].asString()});return P}t.toTreeDataTransferDTO=A})(r=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(ye[65],_e([0,1,11,2]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function _(P,D){return P.scheme===r.Schemas.http||P.scheme===r.Schemas.https?P:(D&&D.authority&&D.isRemote&&P.scheme===r.Schemas.file&&(P=t.URI.from({scheme:r.Schemas.vscodeRemote,authority:D.authority,path:P.path})),t.URI.from({scheme:r.Schemas.https,authority:`${P.scheme}+${A(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=_;function A(P){return P.replace(/./g,D=>{const T=D.charCodeAt(0);return T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57?D:"-"+T.toString(16).padStart(4,"0")})}function I(P){return P.replace(/-([0-9a-f]{4})/g,(D,T)=>String.fromCharCode(parseInt(T,16)))}e.decodeAuthority=I}),define(ye[153],_e([0,1,4,6,65]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(P,D,T){this._proxy=P,this._editors=D,this._initData=T,this._handlePool=0,this._disposables=new t.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const R=D.getVisibleTextEditors();for(const w of this._insets.values())R.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,D,T,R,w){let i;for(const b of this._editors.getVisibleTextEditors(!0))if(b.value===P){i=b;break}if(!i)throw new Error("not a visible editor");const d=this,l=this._handlePool++,s=new r.Emitter,m=new r.Emitter,F=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(b){return(0,_.asWebviewUri)(b,d._initData.remote)}get cspSource(){return _.webviewGenericCspSource}set options(b){this._options=b,d._proxy.$setOptions(l,b)}get options(){return this._options}set html(b){this._html=b,d._proxy.$setHtml(l,b)}get html(){return this._html}get onDidReceiveMessage(){return s.event}postMessage(b){return d._proxy.$postMessage(l,b)}},S=new class{constructor(){this.editor=P,this.line=D,this.height=T,this.webview=F,this.onDidDispose=m.event}dispose(){d._insets.has(l)&&(d._insets.delete(l),d._proxy.$disposeEditorInset(l),m.fire(),m.dispose(),s.dispose())}};return this._proxy.$createEditorInset(l,i.id,i.value.document.uri,D+1,T,R||{},w.identifier,w.extensionLocation),this._insets.set(l,{editor:P,inset:S,onDidReceiveMessage:s}),S}$onDidDispose(P){const D=this._insets.get(P);D&&D.inset.dispose()}$onDidReceiveMessage(P,D){const T=this._insets.get(P);T&&T.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=A}),define(ye[154],_e([0,1,125,10,2,6,3,45,37,46,16,11]),function(ee,e,r,t,_,A,I,P,D,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.EditorTabsVisibleContext=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLockedContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.SideBySideEditorActiveContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanSplitInGroupContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.ActiveEditorDirtyContext=new P.RawContextKey("activeEditorIsDirty",!1,(0,r.localize)(2,null)),e.ActiveEditorPinnedContext=new P.RawContextKey("activeEditorIsNotPreview",!1,(0,r.localize)(3,null)),e.ActiveEditorStickyContext=new P.RawContextKey("activeEditorIsPinned",!1,(0,r.localize)(4,null)),e.ActiveEditorReadonlyContext=new P.RawContextKey("activeEditorIsReadonly",!1,(0,r.localize)(5,null)),e.ActiveEditorCanRevertContext=new P.RawContextKey("activeEditorCanRevert",!1,(0,r.localize)(6,null)),e.ActiveEditorCanSplitInGroupContext=new P.RawContextKey("activeEditorCanSplitInGroup",!0),e.ActiveEditorContext=new P.RawContextKey("activeEditor",null,{type:"string",description:(0,r.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new P.RawContextKey("activeEditorAvailableEditorIds","",(0,r.localize)(8,null)),e.TextCompareEditorVisibleContext=new P.RawContextKey("textCompareEditorVisible",!1,(0,r.localize)(9,null)),e.TextCompareEditorActiveContext=new P.RawContextKey("textCompareEditorActive",!1,(0,r.localize)(10,null)),e.SideBySideEditorActiveContext=new P.RawContextKey("sideBySideEditorActive",!1,(0,r.localize)(11,null)),e.EditorGroupEditorsCountContext=new P.RawContextKey("groupEditorsCount",0,(0,r.localize)(12,null)),e.ActiveEditorGroupEmptyContext=new P.RawContextKey("activeEditorGroupEmpty",!1,(0,r.localize)(13,null)),e.ActiveEditorGroupIndexContext=new P.RawContextKey("activeEditorGroupIndex",0,(0,r.localize)(14,null)),e.ActiveEditorGroupLastContext=new P.RawContextKey("activeEditorGroupLast",!1,(0,r.localize)(15,null)),e.ActiveEditorGroupLockedContext=new P.RawContextKey("activeEditorGroupLocked",!1,(0,r.localize)(16,null)),e.MultipleEditorGroupsContext=new P.RawContextKey("multipleEditorGroups",!1,(0,r.localize)(17,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new P.RawContextKey("editorIsOpen",!1,(0,r.localize)(18,null)),e.InEditorZenModeContext=new P.RawContextKey("inZenMode",!1,(0,r.localize)(19,null)),e.IsCenteredLayoutContext=new P.RawContextKey("isCenteredLayout",!1,(0,r.localize)(20,null)),e.SplitEditorsVertically=new P.RawContextKey("splitEditorsVertically",!1,(0,r.localize)(21,null)),e.EditorAreaVisibleContext=new P.RawContextKey("editorAreaVisible",!0,(0,r.localize)(22,null)),e.EditorTabsVisibleContext=new P.RawContextKey("editorTabsVisible",!0,(0,r.localize)(23,null)),e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function i(y,L,W){for(const B of W.visibleEditorPanes)if(B.group.id===L&&y.matches(B.input))return B.getViewState()}e.findViewStateForEditor=i;function d(y){if(C(y))return!1;const L=y;return _.URI.isUri(L?.resource)}e.isResourceEditorInput=d;function l(y){if(C(y))return!1;const L=y;return L?.original!==void 0&&L.modified!==void 0}e.isResourceDiffEditorInput=l;function s(y){if(C(y)||l(y))return!1;const L=y;return L?.primary!==void 0&&L.secondary!==void 0}e.isResourceSideBySideEditorInput=s;function m(y){if(C(y))return!1;const L=y;return L?L.resource===void 0||L.resource.scheme===w.Schemas.untitled||L.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=m;var F;(function(y){y[y.SHORT=0]="SHORT",y[y.MEDIUM=1]="MEDIUM",y[y.LONG=2]="LONG"})(F=e.Verbosity||(e.Verbosity={}));var S;(function(y){y[y.EXPLICIT=1]="EXPLICIT",y[y.AUTO=2]="AUTO",y[y.FOCUS_CHANGE=3]="FOCUS_CHANGE",y[y.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(S=e.SaveReason||(e.SaveReason={}));var b;(function(y){y[y.None=0]="None",y[y.Readonly=2]="Readonly",y[y.Untitled=4]="Untitled",y[y.Singleton=8]="Singleton",y[y.RequiresTrust=16]="RequiresTrust",y[y.CanSplitInGroup=32]="CanSplitInGroup",y[y.ForceDescription=64]="ForceDescription"})(b=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class p extends A.Disposable{}e.AbstractEditorInput=p;function C(y){return y instanceof p}e.isEditorInput=C;function a(y){const L=y;return _.URI.isUri(L?.preferredResource)}function M(y){const L=y;return C(L?.primary)&&C(L?.secondary)}e.isSideBySideEditorInput=M;function o(y){const L=y;return C(L?.modified)&&C(L?.original)}e.isDiffEditorInput=o;function n(y){return C(y?.editor)}e.isEditorInputWithOptions=n;function u(y){const L=y;return n(y)&&L?.group!==void 0}e.isEditorInputWithOptionsAndGroup=u;function f(y){const L=y;return typeof L?.groupId=="number"&&C(L.editor)}e.isEditorIdentifier=f;var c;(function(y){y[y.UNKNOWN=0]="UNKNOWN",y[y.REPLACE=1]="REPLACE",y[y.MOVE=2]="MOVE",y[y.UNPIN=3]="UNPIN"})(c=e.EditorCloseContext||(e.EditorCloseContext={}));var h;(function(y){y[y.GROUP_ACTIVE=0]="GROUP_ACTIVE",y[y.GROUP_INDEX=1]="GROUP_INDEX",y[y.GROUP_LOCKED=2]="GROUP_LOCKED",y[y.EDITOR_OPEN=3]="EDITOR_OPEN",y[y.EDITOR_CLOSE=4]="EDITOR_CLOSE",y[y.EDITOR_MOVE=5]="EDITOR_MOVE",y[y.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",y[y.EDITOR_LABEL=7]="EDITOR_LABEL",y[y.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",y[y.EDITOR_PIN=9]="EDITOR_PIN",y[y.EDITOR_STICKY=10]="EDITOR_STICKY",y[y.EDITOR_DIRTY=11]="EDITOR_DIRTY",y[y.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(h=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var g;(function(y){y[y.PRIMARY=1]="PRIMARY",y[y.SECONDARY=2]="SECONDARY",y[y.BOTH=3]="BOTH",y[y.ANY=4]="ANY"})(g=e.SideBySideEditor||(e.SideBySideEditor={}));class E{getOriginalUri(L,W){if(!L)return;if(W?.supportSideBySide){const{primary:$,secondary:q}=this.getSideEditors(L);if($&&q){if(W?.supportSideBySide===g.BOTH)return{primary:this.getOriginalUri($,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(q,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===g.ANY)return this.getOriginalUri($,{filterByScheme:W.filterByScheme})??this.getOriginalUri(q,{filterByScheme:W.filterByScheme});L=W.supportSideBySide===g.PRIMARY?$:q}}if(l(L)||s(L))return;const B=a(L)?L.preferredResource:L.resource;return!B||!W||!W.filterByScheme?B:this.filterUri(B,W.filterByScheme)}getSideEditors(L){return M(L)||s(L)?{primary:L.primary,secondary:L.secondary}:o(L)||l(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,W){if(!L)return;if(W?.supportSideBySide){const{primary:$,secondary:q}=this.getSideEditors(L);if($&&q){if(W?.supportSideBySide===g.BOTH)return{primary:this.getCanonicalUri($,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(q,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===g.ANY)return this.getCanonicalUri($,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(q,{filterByScheme:W.filterByScheme});L=W.supportSideBySide===g.PRIMARY?$:q}}if(l(L)||s(L))return;const B=L.resource;return!B||!W||!W.filterByScheme?B:this.filterUri(B,W.filterByScheme)}filterUri(L,W){if(Array.isArray(W)){if(W.some(B=>L.scheme===B))return L}else if(W===L.scheme)return L}}e.EditorResourceAccessor=new E;var v;(function(y){y[y.LEFT=0]="LEFT",y[y.RIGHT=1]="RIGHT"})(v=e.CloseDirection||(e.CloseDirection={}));class k{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(L){const W=this.instantiationService=L.get(I.IInstantiationService);for(const[B,$]of this.editorSerializerConstructors)this.createEditorSerializer(B,$,W);this.editorSerializerConstructors.clear()}createEditorSerializer(L,W,B){const $=B.createInstance(W);this.editorSerializerInstances.set(L,$)}registerFileEditorFactory(L){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=L}getFileEditorFactory(){return(0,t.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(L,W){if(this.editorSerializerConstructors.has(L)||this.editorSerializerInstances.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.instantiationService?this.createEditorSerializer(L,W,this.instantiationService):this.editorSerializerConstructors.set(L,W),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(L),this.editorSerializerInstances.delete(L)})}getEditorSerializer(L){return this.editorSerializerInstances.get(typeof L=="string"?L:L.typeId)}}D.Registry.add(e.EditorExtensions.EditorFactory,new k);async function x(y,L){if(!y||!y.length)return[];const W=await Promise.all(y.map(async B=>{const $=_.URI.revive(B.fileUri);if(!$||!await L.canHandleResource($))return;let ie=B.exists,se=B.type;if(typeof ie!="boolean"||typeof se!="number")try{se=(await L.resolve($)).isDirectory?T.FileType.Directory:T.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&B.openOnlyIfExists||se===T.FileType.Directory)return;const X={selection:ie?B.selection:void 0,pinned:!0,override:B.editorOverrideId};let ge;return ie?ge={resource:$,options:X}:ge={resource:$,options:X,forceUntitled:!0},ge}));return(0,R.coalesce)(W)}e.pathsToEditors=x;var N;(function(y){y[y.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",y[y.SEQUENTIAL=1]="SEQUENTIAL"})(N=e.EditorsOrder||(e.EditorsOrder={}))}),define(ye[155],_e([0,1,4,13,126]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new r.Emitter,this._onExit=new r.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,D,T,R){const w={command:P};if(D&&Object.keys(D).length>0&&(w.arguments=D),this.internalSend("request",w),typeof R=="number"){const i=setTimeout(()=>{clearTimeout(i);const d=this.pendingRequests.get(w.seq);if(d){this.pendingRequests.delete(w.seq);const l={type:"response",seq:0,request_seq:w.seq,success:!1,command:P,message:(0,_.localize)(0,null,R,P)};d(l)}},R)}return T&&this.pendingRequests.set(w.seq,T),w.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,D){return P.type!=="event"||D.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await(0,t.timeout)(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":{const D=P,T=this.pendingRequests.get(D.request_seq);T&&(this.pendingRequests.delete(D.request_seq),T(D));break}}}}internalSend(P,D){D.type=P,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((D,T)=>P.set(T,D)),await(0,t.timeout)(500),P.forEach((D,T)=>{D({type:"response",seq:0,request_seq:T,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(T)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(ye[156],_e([0,1,9,2,17,27,11]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function D(o,n,u){return o.replace(P,function(f,c){return n&&c.length>0&&c[0]!=="_"?f:u&&u.hasOwnProperty(c)?u[c]:f})}e.formatPII=D;function T(o){const n={};for(const u of Object.keys(o))u.startsWith("!")||(n[u]=o[u]);return n}e.filterExceptionsFromTelemetry=T;function R(o){return o.configuration.request==="attach"&&!w(o)&&(!o.parentSession||R(o.parentSession))}e.isSessionAttach=R;function w(o){let n=o.configuration.type;if(!!n)return n==="vslsShare"&&(n=o.configuration.adapterProxy.configuration.type),(0,r.equalsIgnoreCase)(n,"extensionhost")||(0,r.equalsIgnoreCase)(n,"pwa-extensionhost")?o:o.parentSession?w(o.parentSession):void 0}e.getExtensionHostDebugSession=w;function i(o){return o.type&&(o.label||o.program||o.runtime)}e.isDebuggerMainContribution=i;function d(o,n,u){let f,c=0;const h=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=h.exec(o);){const E=g.index+1,v=E+g[0].length;if(E<=n&&v>=u){f=g[0],c=E;break}}if(f){const E=/\w+/g;let v=null;for(;(v=E.exec(f))&&!(v.index+1+c+v[0].length>=u););v&&(f=f.substring(0,E.lastIndex))}return f?{start:c,end:c+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function s(o){return!!(o&&o.match(l))}e.isUri=s;function m(o){if(typeof o.path=="string"&&!(typeof o.sourceReference=="number"&&o.sourceReference>0)){if(s(o.path))return t.URI.parse(o.path);if((0,_.isAbsolute)(o.path))return t.URI.file(o.path)}return o.path}function F(o){if(typeof o.path=="object"){const n=t.URI.revive(o.path);if(n)return n.scheme===I.Schemas.file?n.fsPath:n.toString()}return o.path}function S(o,n){const u=n?m:F,f=(0,A.deepClone)(o);return p(f,(c,h)=>{c&&h&&(h.path=u(h))}),f}e.convertToDAPaths=S;function b(o,n){const u=n?m:F,f=(0,A.deepClone)(o);return p(f,(c,h)=>{!c&&h&&(h.path=u(h))}),f}e.convertToVSCPaths=b;function p(o,n){switch(o.type){case"event":{const u=o;switch(u.event){case"output":n(!1,u.body.source);break;case"loadedSource":n(!1,u.body.source);break;case"breakpoint":n(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=o;switch(u.command){case"setBreakpoints":n(!0,u.arguments.source);break;case"breakpointLocations":n(!0,u.arguments.source);break;case"source":n(!0,u.arguments.source);break;case"gotoTargets":n(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(f=>n(!1,f));break;default:break}break}case"response":{const u=o;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(f=>n(!1,f.source));break;case"loadedSources":u.body.sources.forEach(f=>n(!1,f));break;case"scopes":u.body.scopes.forEach(f=>n(!1,f.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(f=>n(!1,f.source));break;case"setBreakpoints":u.body.breakpoints.forEach(f=>n(!1,f.source));break;default:break}break}}}function C(o){return o.filter(n=>!n.presentation?.hidden).sort((n,u)=>n.presentation?u.presentation?n.presentation.group?u.presentation.group?n.presentation.group!==u.presentation.group?n.presentation.group.localeCompare(u.presentation.group):a(n.presentation.order,u.presentation.order):-1:u.presentation.group?1:a(n.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=C;function a(o,n){return typeof o!="number"?typeof n!="number"?0:1:typeof n!="number"?-1:o-n}async function M(o,n){const u=o.getValue("debug.saveBeforeStart",{overrideIdentifier:n.activeTextEditorLanguageId});if(u!=="none"&&(await n.saveAll(),u==="allEditorsInActiveGroup")){const f=n.activeEditorPane;f&&f.input.resource?.scheme===I.Schemas.untitled&&await n.save({editor:f.input,groupId:f.group.id})}await o.reloadConfiguration()}e.saveAllBeforeDebugStart=M}),define(ye[85],_e([0,1,29,157,74,11,17,23,45]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var T;(function(E){E[E.Markup=1]="Markup",E[E.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",_.Mimes.latex,_.Mimes.markdown,"image/png","image/jpeg",_.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[_.Mimes.latex,_.Mimes.markdown,"application/json",_.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var R;(function(E){E[E.Running=1]="Running",E[E.Idle=2]="Idle"})(R=e.NotebookRunState||(e.NotebookRunState={}));var w;(function(E){E[E.Pending=2]="Pending",E[E.Executing=3]="Executing"})(w=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var i;(function(E){E[E.WithHardKernelDependency=0]="WithHardKernelDependency",E[E.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",E[E.Pure=2]="Pure",E[E.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var d;(function(E){E.Always="always",E.Never="never",E.Optional="optional"})(d=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var l;(function(E){E[E.ModelChange=1]="ModelChange",E[E.Move=2]="Move",E[E.ChangeLanguage=5]="ChangeLanguage",E[E.Initialize=6]="Initialize",E[E.ChangeCellMetadata=7]="ChangeCellMetadata",E[E.Output=8]="Output",E[E.OutputItem=9]="OutputItem",E[E.ChangeCellContent=10]="ChangeCellContent",E[E.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",E[E.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",E[E.ChangeCellMime=13]="ChangeCellMime",E[E.Unknown=100]="Unknown"})(l=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var s;(function(E){E[E.Handle=0]="Handle",E[E.Index=1]="Index"})(s=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(E){E[E.Replace=1]="Replace",E[E.Output=2]="Output",E[E.Metadata=3]="Metadata",E[E.CellLanguage=4]="CellLanguage",E[E.DocumentMetadata=5]="DocumentMetadata",E[E.Move=6]="Move",E[E.OutputItems=7]="OutputItems",E[E.PartialMetadata=8]="PartialMetadata",E[E.PartialInternalMetadata=9]="PartialInternalMetadata"})(m=e.CellEditType||(e.CellEditType={}));var F;(function(E){E.scheme=A.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function k(B,$){return B.with({scheme:E.scheme,fragment:`ch${$.toString().padStart(7,"0")}${B.scheme!==A.Schemas.file?B.scheme:""}`})}E.generate=k;function x(B){if(B.scheme!==E.scheme)return;const $=v.exec(B.fragment);return $?{handle:Number($[1]),notebook:B.with({scheme:B.fragment.substring($[0].length)||A.Schemas.file,fragment:null})}:void 0}E.parse=x;function N(B,$,q){return B.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`ch${$.toString().padStart(7,"0")},${q??""},${B.scheme!==A.Schemas.file?B.scheme:""}`})}E.generateCellOutputUri=N;function y(B){if(B.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const $=/^ch(\d{7,})\,([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!$)return;const q=Number($[1]),ie=$[2]&&$[2]!==""?$[2]:void 0,se=$[3];return{handle:q,outputId:ie,notebook:B.with({scheme:se||A.Schemas.file,fragment:null})}}E.parseCellOutputUri=y;function L(B,$,q){return B.with({scheme:q,fragment:`ch${$.toString().padStart(7,"0")}${B.scheme!==A.Schemas.file?B.scheme:""}`})}E.generateCellUri=L;function W(B,$){if(B.scheme!==$)return;const q=v.exec(B.fragment);return q?{handle:Number(q[1]),notebook:B.with({scheme:B.fragment.substring(q[0].length)||A.Schemas.file,fragment:null})}:void 0}E.parseCellUri=W})(F=e.CellUri||(e.CellUri={}));const S=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.latex,{alwaysSecure:!0,supportedByCore:!0}],[_.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(E){return S.get(E)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function p(E){return S.get(E)?.supportedByCore??!1}e.mimeTypeSupportedByCore=p;function C(E){return S.get(E)?.mergeable??!1}e.mimeTypeIsMergeable=C;const a=E=>P.isWindows?E.replace(/\//g,"\\"):E;class M{constructor(v=[],k=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=k,this.order=[...new Set(v)].map(x=>({pattern:x,matches:r.parse(a(x))}))}sort(v){const k=new Map(t.Iterable.map(v,N=>[N,a(N)]));let x=[];for(const{matches:N}of this.order)for(const[y,L]of k)if(N(L)){x.push(y),k.delete(y);break}return k.size&&(x=x.concat([...k.keys()].sort((N,y)=>this.defaultOrder.indexOf(N)-this.defaultOrder.indexOf(y)))),x}prioritize(v,k){const x=this.findIndex(v);if(x===-1){this.order.unshift({pattern:v,matches:r.parse(a(v))});return}const N=new Set(k.map(L=>this.findIndex(L,x)));N.delete(-1);const y=Array.from(N).sort();this.order.splice(x+1,0,...y.map(L=>this.order[L]));for(let L=y.length-1;L>=0;L--)this.order.splice(y[L],1)}toArray(){return this.order.map(v=>v.pattern)}findIndex(v,k=this.order.length){const x=a(v);for(let N=0;N<k;N++)if(this.order[N].matches(x))return N;return-1}}e.MimeTypeDisplayOrder=M;function o(E,v,k,x=(N,y)=>N===y){const N=[];function y(B,$,q){if($===0&&q.length===0)return;const ie=N[N.length-1];ie&&ie.start+ie.deleteCount===B?(ie.deleteCount+=$,ie.toInsert.push(...q)):N.push({start:B,deleteCount:$,toInsert:q})}let L=0,W=0;for(;;){if(L===E.length){y(L,0,v.slice(W));break}if(W===v.length){y(L,E.length-L,[]);break}const B=E[L],$=v[W];if(x(B,$)){L+=1,W+=1;continue}k($)?(y(L,1,[]),L+=1):(y(L,0,[$]),W+=1)}return N}e.diff=o,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(E){E.default="default",E.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(E){const v=E;return!!((typeof v.include=="string"||r.isRelativePattern(v.include))&&(typeof v.exclude=="string"||r.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=u;function f(E,v,k){if(Array.isArray(E.viewType)&&E.viewType.indexOf(v)>=0||E.viewType===v)return!0;if(E.filenamePattern){const x=u(E.filenamePattern)?E.filenamePattern.include:E.filenamePattern,N=u(E.filenamePattern)?E.filenamePattern.exclude:void 0;if(r.match(x,(0,I.basename)(k.fsPath).toLowerCase()))return!(N&&r.match(N,(0,I.basename)(k.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=f;class c{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let k=0;k<this.textModel.cells.length;k++)v[k]=this.textModel.cells[k].getHashValue();return v}}e.CellSequence=c,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var h;(function(E){E[E.Left=1]="Left",E[E.Right=2]="Right"})(h=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class g{static create(v){return`${g._prefix}${v}`}static parse(v){if(v.startsWith(g._prefix))return v.substring(g._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=g,g._prefix="notebook/"}),define(ye[158],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var t;(function(_){_[_.Output=1]="Output",_[_.OutputItems=2]="OutputItems",_[_.ExecutionState=3]="ExecutionState"})(t=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,r.createDecorator)("INotebookExecutionService")}),define(ye[159],_e([0,1,3,45]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new t.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new t.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new t.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,r.createDecorator)(e.OUTPUT_SERVICE_ID);var _;(function(A){A[A.Append=1]="Append",A[A.Replace=2]="Replace",A[A.Clear=3]="Clear"})(_=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(ye[160],_e([0,1,128,3,45]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new _.RawContextKey("customExecutionSupported",!0,r.localize(0,null)),e.ShellExecutionSupportedContext=new _.RawContextKey("shellExecutionSupported",!1,r.localize(1,null)),e.ProcessExecutionSupportedContext=new _.RawContextKey("processExecutionSupported",!1,r.localize(2,null)),e.ITaskService=(0,t.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ye[161],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function r(_){return[..._.entries()]}e.serializeEnvironmentVariableCollection=r;function t(_){return new Map(_)}e.deserializeEnvironmentVariableCollection=t}),define(ye[86],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var r;(function(w){w[w.Unset=0]="Unset",w[w.Queued=1]="Queued",w[w.Running=2]="Running",w[w.Passed=3]="Passed",w[w.Failed=4]="Failed",w[w.Skipped=5]="Skipped",w[w.Errored=6]="Errored"})(r=e.TestResultState||(e.TestResultState={}));var t;(function(w){w[w.Run=2]="Run",w[w.Debug=4]="Debug",w[w.Coverage=8]="Coverage",w[w.HasNonDefaultProfile=16]="HasNonDefaultProfile",w[w.HasConfigurable=32]="HasConfigurable"})(t=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var _;(function(w){w[w.Error=0]="Error",w[w.Info=1]="Info"})(_=e.TestMessageType||(e.TestMessageType={}));var A;(function(w){w[w.NotExpandable=0]="NotExpandable",w[w.Expandable=1]="Expandable",w[w.BusyExpanding=2]="BusyExpanding",w[w.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(w,i)=>{i.expand!==void 0&&(w.expand=i.expand),i.item!==void 0&&(w.item=w.item?Object.assign(w.item,i.item):i.item)};e.applyTestItemUpdate=I;var P;(function(w){w[w.Function=0]="Function",w[w.Statement=1]="Statement"})(P=e.DetailType||(e.DetailType={}));var D;(function(w){w[w.Add=0]="Add",w[w.Update=1]="Update",w[w.Remove=2]="Remove",w[w.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",w[w.Retire=4]="Retire",w[w.AddTag=5]="AddTag",w[w.RemoveTag=6]="RemoveTag"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));class T{add(i){}update(i){}remove(i,d){}complete(){}}e.IncrementalChangeCollector=T;class R{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(i){const d=this.createChangeCollector();for(const l of i)switch(l[0]){case 0:{const s=l[1];if(s.parent){if(this.items.has(s.parent)){const m=this.items.get(s.parent);m.children.add(s.item.extId);const F=this.createItem(s,m);this.items.set(s.item.extId,F),d.add(F)}}else{const m=this.createItem(s);this.roots.add(m),this.items.set(s.item.extId,m),d.add(m)}s.expand===2&&this.busyControllerCount++;break}case 1:{const s=l[1],m=this.items.get(s.extId);if(!m)break;s.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,s.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,s),d.update(m);break}case 2:{const s=this.items.get(l[1]);if(!s)break;s.parent?this.items.get(s.parent).children.delete(s.item.extId):this.roots.delete(s);const m=[[l[1]]];for(;m.length;)for(const F of m.pop()){const S=this.items.get(F);S&&(m.push(S.children),this.items.delete(F),d.remove(S,S!==s),S.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(l[1]);break;case 3:this.updatePendingRoots(l[1]);break;case 5:this._tags.set(l[1].id,l[1]);break;case 6:this._tags.delete(l[1]);break}d.complete()}retireTest(i){}updatePendingRoots(i){this.pendingRootCount+=i}createChangeCollector(){return new T}}e.AbstractIncrementalTestCollection=R}),define(ye[66],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(A){A.Delimiter="\0"})(r=e.TestIdPathParts||(e.TestIdPathParts={}));var t;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(t=e.TestPosition||(e.TestPosition={}));class _{constructor(I,P=I.length){if(this.path=I,this.viewEnd=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(I,P,D=I.parent){if(I.id===P)return new _([P]);let T=[I.id];for(let R=D;R&&R.id!==P;R=R.parent)T.push(R.id);return T.push(P),new _(T.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new _(I.split("\0"))}static join(I,P){return new _([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static compare(I,P){return I===P?0:P.startsWith(I+"\0")?2:I.startsWith(P+"\0")?3:1}get parentId(){return this.viewEnd>1?new _(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let I=1;I<=this.viewEnd;I++)yield new _(this.path,I)}compare(I){if(typeof I=="string")return _.compare(this.toString(),I);for(let P=0;P<I.viewEnd&&P<this.viewEnd;P++)if(I.path[P]!==this.path[P])return 1;return I.viewEnd>this.viewEnd?2:I.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let I=1;I<this.viewEnd;I++)this.stringifed+="\0",this.stringifed+=this.path[I]}return this.stringifed}}e.TestId=_}),define(ye[162],_e([0,1,17,87,10,27,23,76,129]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class T{constructor(w,i,d){this._contributedVariables=new Map,this._context=w,this._labelService=i,d&&(this._envVariablesPromise=d.then(l=>this.prepareEnv(l)))}prepareEnv(w){if(I.isWindows){const i=Object.create(null);return Object.keys(w).forEach(d=>{i[d.toLowerCase()]=w[d]}),i}return w}resolveWithEnvironment(w,i,d){return this.recursiveResolve(this.prepareEnv(w),i?i.uri:void 0,d)}async resolveAsync(w,i){return this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,i)}async resolveAnyBase(w,i,d,l){const s=A.deepClone(i);return I.isWindows&&s.windows?Object.keys(s.windows).forEach(m=>s[m]=s.windows[m]):I.isMacintosh&&s.osx?Object.keys(s.osx).forEach(m=>s[m]=s.osx[m]):I.isLinux&&s.linux&&Object.keys(s.linux).forEach(m=>s[m]=s.linux[m]),delete s.windows,delete s.osx,delete s.linux,this.recursiveResolve(await this._envVariablesPromise,w?w.uri:void 0,s,d,l)}async resolveAnyAsync(w,i,d){return this.resolveAnyBase(w,i,d)}async resolveAnyMap(w,i,d){const l=new Map;return{newConfig:await this.resolveAnyBase(w,i,d,l),resolvedVariables:l}}resolveWithInteractionReplace(w,i,d,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,i,d,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,i){if(this._contributedVariables.has(w))throw new Error("Variable "+w+" is contributed twice.");this._contributedVariables.set(w,i)}recursiveResolve(w,i,d,l,s){if(_.isString(d))return this.resolveString(w,i,d,l,s);if(_.isArray(d))return d.map(m=>this.recursiveResolve(w,i,m,l,s));if(_.isObject(d)){let m=Object.create(null);return Object.keys(d).forEach(F=>{const S=this.resolveString(w,i,F,l,s);m[S]=this.recursiveResolve(w,i,d[F],l,s)}),m}return d}resolveString(w,i,d,l,s){return d.replace(T.VARIABLE_REGEXP,(F,S)=>{if(S.includes(T.VARIABLE_LHS))return F;let b=this.evaluateSingleVariable(w,F,S,i,l);return s&&s.set(S,b),b!==F&&_.isString(b)&&b.match(T.VARIABLE_REGEXP)&&(b=this.resolveString(w,i,b,l,s)),b})}fsPath(w){return this._labelService?this._labelService.getUriLabel(w,{noPrefix:!0}):w.fsPath}evaluateSingleVariable(w,i,d,l,s){let m;const F=d.split(":");F.length>1&&(d=F[0],m=F[1]);const S=()=>{const C=this._context.getFilePath();if(C)return C;throw new Error((0,D.localize)(0,null,i))},b=()=>{const C=S();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,D.localize)(1,null,i,r.basename(C)))},p=()=>{if(m){const C=this._context.getFolderUri(m);if(C)return C;throw new Error((0,D.localize)(2,null,i,m))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,i)):new Error((0,D.localize)(4,null,i))};switch(d){case"env":if(m){if(w){const C=w[I.isWindows?m.toLowerCase():m];if(_.isString(C))return C}return""}throw new Error((0,D.localize)(5,null,i));case"config":if(m){const C=this._context.getConfigurationValue(l,m);if(_.isUndefinedOrNull(C))throw new Error((0,D.localize)(6,null,i,m));if(_.isObject(C))throw new Error((0,D.localize)(7,null,i,m));return C}throw new Error((0,D.localize)(8,null,i));case"command":return this.resolveFromMap(i,m,s,"command");case"input":return this.resolveFromMap(i,m,s,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return l||m?(0,P.normalizeDriveLetter)(this.fsPath(p())):t.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return r.basename(this.fsPath(p()));case"lineNumber":{const C=this._context.getLineNumber();if(C)return C;throw new Error((0,D.localize)(9,null,i))}case"selectedText":{const C=this._context.getSelectedText();if(C)return C;throw new Error((0,D.localize)(10,null,i))}case"file":return S();case"fileWorkspaceFolder":return b();case"relativeFile":return l||m?r.relative(this.fsPath(p()),S()):S();case"relativeFileDirname":{const C=r.dirname(S());if(l||m){const a=r.relative(this.fsPath(p()),C);return a.length===0?".":a}return C}case"fileDirname":return r.dirname(S());case"fileExtname":return r.extname(S());case"fileBasename":return r.basename(S());case"fileBasenameNoExtension":{const C=r.basename(S());return C.slice(0,C.length-r.extname(C).length)}case"fileDirnameBasename":return r.basename(r.dirname(S()));case"execPath":{const C=this._context.getExecPath();return C||i}case"execInstallFolder":{const C=this._context.getAppRoot();return C||i}case"pathSeparator":return r.sep;default:try{const C=m?`${d}:${m}`:d;return this.resolveFromMap(i,C,s,void 0)}catch{return i}}}}resolveFromMap(w,i,d,l){if(i&&d){const s=l===void 0?d[i]:d[l+":"+i];if(typeof s=="string")return s;throw new Error((0,D.localize)(11,null,w))}return w}}e.AbstractVariableResolverService=T,T.VARIABLE_LHS="${",T.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ye[88],_e([0,1,3,154]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,r.createDecorator)("editorGroupsService");var _;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(_=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var I;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(I=e.GroupLocation||(e.GroupLocation={}));var P;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function T(l){const s=l;return(0,t.isEditorInput)(s?.editor)&&(0,t.isEditorInput)(s?.replacement)}e.isEditorReplacement=T;var R;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var w;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(w=e.OpenEditorContext||(e.OpenEditorContext={}));function i(l){const s=l;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}e.isEditorGroup=i;function d(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(ye[163],_e([0,1,3,88]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,r.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function _(A){const I=A;return typeof A=="number"||(0,t.isEditorGroup)(I)}e.isPreferredGroup=_}),define(ye[8],_e([0,1,16,21,75,225,55,27,10,2,58,57,130,80,48,85,66,163,7]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var b;(function(ce){function he(V){const{selectionStartLineNumber:we,selectionStartColumn:Re,positionLineNumber:We,positionColumn:ze}=V,mt=new S.Position(we-1,Re-1),Et=new S.Position(We-1,ze-1);return new S.Selection(mt,Et)}ce.to=he;function re(V){const{anchor:we,active:Re}=V;return{selectionStartLineNumber:we.line+1,selectionStartColumn:we.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ce.from=re})(b=e.Selection||(e.Selection={}));var p;(function(ce){function he(V){if(!V)return;const{start:we,end:Re}=V;return{startLineNumber:we.line+1,startColumn:we.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ce.from=he;function re(V){if(!V)return;const{startLineNumber:we,startColumn:Re,endLineNumber:We,endColumn:ze}=V;return new S.Range(we-1,Re-1,We-1,ze-1)}ce.to=re})(p=e.Range||(e.Range={}));var C;(function(ce){function he(re){switch(re){case 1:return S.StandardTokenType.Comment;case 0:return S.StandardTokenType.Other;case 3:return S.StandardTokenType.RegEx;case 2:return S.StandardTokenType.String}}ce.to=he})(C=e.TokenType||(e.TokenType={}));var a;(function(ce){function he(V){return new S.Position(V.lineNumber-1,V.column-1)}ce.to=he;function re(V){return{lineNumber:V.line+1,column:V.character+1}}ce.from=re})(a=e.Position||(e.Position={}));var M;(function(ce){function he(we,Re){return(0,r.coalesce)((0,r.asArray)(we).map(We=>re(We,Re)))}ce.from=he;function re(we,Re){if(typeof we=="string")return{$serialized:!0,language:we};if(we)return{$serialized:!0,language:we.language,scheme:V(we.scheme,Re),pattern:de.from(we.pattern)??void 0,exclusive:we.exclusive}}function V(we,Re){return Re&&typeof we=="string"?Re.transformOutgoingScheme(we):we}})(M=e.DocumentSelector||(e.DocumentSelector={}));var o;(function(ce){function he(V){switch(V){case S.DiagnosticTag.Unnecessary:return 1;case S.DiagnosticTag.Deprecated:return 2}}ce.from=he;function re(V){switch(V){case 1:return S.DiagnosticTag.Unnecessary;case 2:return S.DiagnosticTag.Deprecated;default:return}}ce.to=re})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var n;(function(ce){function he(V){let we;return V.code&&((0,D.isString)(V.code)||(0,D.isNumber)(V.code)?we=String(V.code):we={value:String(V.code.value),target:V.code.target}),{...p.from(V.range),message:V.message,source:V.source,code:we,severity:f.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(u.from),tags:Array.isArray(V.tags)?(0,r.coalesce)(V.tags.map(o.from)):void 0}}ce.from=he;function re(V){const we=new S.Diagnostic(p.to(V),V.message,f.to(V.severity));return we.source=V.source,we.code=(0,D.isString)(V.code)?V.code:V.code?.value,we.relatedInformation=V.relatedInformation&&V.relatedInformation.map(u.to),we.tags=V.tags&&(0,r.coalesce)(V.tags.map(o.to)),we}ce.to=re})(n=e.Diagnostic||(e.Diagnostic={}));var u;(function(ce){function he(V){return{...p.from(V.location.range),message:V.message,resource:V.location.uri}}ce.from=he;function re(V){return new S.DiagnosticRelatedInformation(new S.Location(V.resource,p.to(V)),V.message)}ce.to=re})(u=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(ce){function he(V){switch(V){case S.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case S.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case S.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case S.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ce.from=he;function re(V){switch(V){case d.MarkerSeverity.Info:return S.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return S.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return S.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return S.DiagnosticSeverity.Hint;default:return S.DiagnosticSeverity.Error}}ce.to=re})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var c;(function(ce){function he(V){return typeof V=="number"&&V>=S.ViewColumn.One?V-1:V===S.ViewColumn.Beside?F.SIDE_GROUP:F.ACTIVE_GROUP}ce.from=he;function re(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ce.to=re})(c=e.ViewColumn||(e.ViewColumn={}));function h(ce){return typeof ce.range!="undefined"}function g(ce){return ce.length===0?!0:!!h(ce[0])}e.isDecorationOptionsArr=g;var E;(function(ce){function he(ze){return ze.map(ce.from)}ce.fromMany=he;function re(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function V(ze){let mt;if(re(ze)){const{language:vt,value:bt}=ze;mt={value:"```"+vt+`
`+bt+"\n```\n"}}else S.MarkdownString.isMarkdownString(ze)?mt={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml}:typeof ze=="string"?mt={value:ze}:mt={value:""};const Et=Object.create(null);mt.uris=Et;const _t=vt=>{try{let bt=T.URI.parse(vt,!0);bt=bt.with({query:we(bt.query,Et)}),Et[vt]=bt}catch{}return""},dt=new A.Renderer;return dt.link=_t,dt.image=vt=>_t(_.parseHrefAndDimensions(vt).href),A(mt.value,{renderer:dt}),mt}ce.from=V;function we(ze,mt){if(!ze)return ze;let Et;try{Et=(0,I.parse)(ze)}catch{}if(!Et)return ze;let _t=!1;return Et=(0,P.cloneAndChange)(Et,dt=>{if(T.URI.isUri(dt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return mt[vt]=dt,_t=!0,vt}else return}),_t?JSON.stringify(Et):ze}function Re(ze){const mt=new S.MarkdownString(ze.value,ze.supportThemeIcons);return mt.isTrusted=ze.isTrusted,mt.supportHtml=ze.supportHtml,mt}ce.to=Re;function We(ze){if(!!ze)return typeof ze=="string"?ze:ce.from(ze)}ce.fromStrict=We})(E=e.MarkdownString||(e.MarkdownString={}));function v(ce){return g(ce)?ce.map(he=>({range:p.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?E.fromMany(he.hoverMessage):he.hoverMessage?E.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):ce.map(he=>({range:p.from(he)}))}e.fromRangeOrRangeWithMessage=v;function k(ce){return typeof ce=="undefined"?ce:typeof ce=="string"?T.URI.file(ce):ce}e.pathOrURIToURI=k;var x;(function(ce){function he(re){return typeof re=="undefined"?re:{contentText:re.contentText,contentIconPath:re.contentIconPath?k(re.contentIconPath):void 0,border:re.border,borderColor:re.borderColor,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,color:re.color,backgroundColor:re.backgroundColor,margin:re.margin,width:re.width,height:re.height}}ce.from=he})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(ce){function he(re){return typeof re=="undefined"?re:{backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?k(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?x.from(re.before):void 0,after:re.after?x.from(re.after):void 0}}ce.from=he})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var y;(function(ce){function he(re){if(typeof re=="undefined")return re;switch(re){case S.DecorationRangeBehavior.OpenOpen:return 0;case S.DecorationRangeBehavior.ClosedClosed:return 1;case S.DecorationRangeBehavior.OpenClosed:return 2;case S.DecorationRangeBehavior.ClosedOpen:return 3}}ce.from=he})(y=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ce){function he(re){return{isWholeLine:re.isWholeLine,rangeBehavior:re.rangeBehavior?y.from(re.rangeBehavior):void 0,overviewRulerLane:re.overviewRulerLane,light:re.light?N.from(re.light):void 0,dark:re.dark?N.from(re.dark):void 0,backgroundColor:re.backgroundColor,outline:re.outline,outlineColor:re.outlineColor,outlineStyle:re.outlineStyle,outlineWidth:re.outlineWidth,border:re.border,borderColor:re.borderColor,borderRadius:re.borderRadius,borderSpacing:re.borderSpacing,borderStyle:re.borderStyle,borderWidth:re.borderWidth,fontStyle:re.fontStyle,fontWeight:re.fontWeight,textDecoration:re.textDecoration,cursor:re.cursor,color:re.color,opacity:re.opacity,letterSpacing:re.letterSpacing,gutterIconPath:re.gutterIconPath?k(re.gutterIconPath):void 0,gutterIconSize:re.gutterIconSize,overviewRulerColor:re.overviewRulerColor,before:re.before?x.from(re.before):void 0,after:re.after?x.from(re.after):void 0}}ce.from=he})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var W;(function(ce){function he(V){return{text:V.newText,eol:V.newEol&&pt.from(V.newEol),range:p.from(V.range)}}ce.from=he;function re(V){const we=new S.TextEdit(p.to(V.range),V.text);return we.newEol=typeof V.eol=="undefined"?void 0:pt.to(V.eol),we}ce.to=re})(W=e.TextEdit||(e.TextEdit={}));var B;(function(ce){function he(V,we,Re){const We={edits:[]};if(V instanceof S.WorkspaceEdit)for(let ze of V._allEntries())if(ze._type===1)We.edits.push({_type:1,oldUri:ze.from,newUri:ze.to,options:ze.options,metadata:ze.metadata});else if(ze._type===2){const mt=we?.getDocument(ze.uri);We.edits.push({_type:2,resource:ze.uri,edit:W.from(ze.edit),modelVersionId:mt?.version,metadata:ze.metadata})}else ze._type===3?We.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,edit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Re?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version}):ze._type===5&&We.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,notebookVersionId:Re?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version,edit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(kt.from)}});return We}ce.from=he;function re(V){const we=new S.WorkspaceEdit;for(const Re of V.edits)Re.edit?we.replace(T.URI.revive(Re.resource),p.to(Re.edit.range),Re.edit.text):we.renameFile(T.URI.revive(Re.oldUri),T.URI.revive(Re.newUri),Re.options);return we}ce.to=re})(B=e.WorkspaceEdit||(e.WorkspaceEdit={}));var $;(function(ce){const he=Object.create(null);he[S.SymbolKind.File]=0,he[S.SymbolKind.Module]=1,he[S.SymbolKind.Namespace]=2,he[S.SymbolKind.Package]=3,he[S.SymbolKind.Class]=4,he[S.SymbolKind.Method]=5,he[S.SymbolKind.Property]=6,he[S.SymbolKind.Field]=7,he[S.SymbolKind.Constructor]=8,he[S.SymbolKind.Enum]=9,he[S.SymbolKind.Interface]=10,he[S.SymbolKind.Function]=11,he[S.SymbolKind.Variable]=12,he[S.SymbolKind.Constant]=13,he[S.SymbolKind.String]=14,he[S.SymbolKind.Number]=15,he[S.SymbolKind.Boolean]=16,he[S.SymbolKind.Array]=17,he[S.SymbolKind.Object]=18,he[S.SymbolKind.Key]=19,he[S.SymbolKind.Null]=20,he[S.SymbolKind.EnumMember]=21,he[S.SymbolKind.Struct]=22,he[S.SymbolKind.Event]=23,he[S.SymbolKind.Operator]=24,he[S.SymbolKind.TypeParameter]=25;function re(we){return typeof he[we]=="number"?he[we]:6}ce.from=re;function V(we){for(const Re in he)if(he[Re]===we)return Number(Re);return S.SymbolKind.Property}ce.to=V})($=e.SymbolKind||(e.SymbolKind={}));var q;(function(ce){function he(V){switch(V){case S.SymbolTag.Deprecated:return 1}}ce.from=he;function re(V){switch(V){case 1:return S.SymbolTag.Deprecated}}ce.to=re})(q=e.SymbolTag||(e.SymbolTag={}));var ie;(function(ce){function he(V){return{name:V.name,kind:$.from(V.kind),tags:V.tags&&V.tags.map(q.from),containerName:V.containerName,location:pe.from(V.location)}}ce.from=he;function re(V){const we=new S.SymbolInformation(V.name,$.to(V.kind),V.containerName,pe.to(V.location));return we.tags=V.tags&&V.tags.map(q.to),we}ce.to=re})(ie=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var se;(function(ce){function he(V){const we={name:V.name||"!!MISSING: name!!",detail:V.detail,range:p.from(V.range),selectionRange:p.from(V.selectionRange),kind:$.from(V.kind),tags:V.tags?.map(q.from)??[]};return V.children&&(we.children=V.children.map(he)),we}ce.from=he;function re(V){const we=new S.DocumentSymbol(V.name,V.detail,$.to(V.kind),p.to(V.range),p.to(V.selectionRange));return(0,r.isNonEmptyArray)(V.tags)&&(we.tags=V.tags.map(q.to)),V.children&&(we.children=V.children.map(re)),we}ce.to=re})(se=e.DocumentSymbol||(e.DocumentSymbol={}));var X;(function(ce){function he(V){const we=new S.CallHierarchyItem($.to(V.kind),V.name,V.detail||"",T.URI.revive(V.uri),p.to(V.range),p.to(V.selectionRange));return we._sessionId=V._sessionId,we._itemId=V._itemId,we}ce.to=he;function re(V,we,Re){if(we=we??V._sessionId,Re=Re??V._itemId,we===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Re,name:V.name,detail:V.detail,kind:$.from(V.kind),uri:V.uri,range:p.from(V.range),selectionRange:p.from(V.selectionRange),tags:V.tags?.map(q.from)}}ce.from=re})(X=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ge;(function(ce){function he(re){return new S.CallHierarchyIncomingCall(X.to(re.from),re.fromRanges.map(V=>p.to(V)))}ce.to=he})(ge=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var be;(function(ce){function he(re){return new S.CallHierarchyOutgoingCall(X.to(re.to),re.fromRanges.map(V=>p.to(V)))}ce.to=he})(be=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var pe;(function(ce){function he(V){return{range:V.range&&p.from(V.range),uri:V.uri}}ce.from=he;function re(V){return new S.Location(T.URI.revive(V.uri),p.to(V.range))}ce.to=re})(pe=e.location||(e.location={}));var fe;(function(ce){function he(V){const we=V,Re=V;return{originSelectionRange:we.originSelectionRange?p.from(we.originSelectionRange):void 0,uri:we.targetUri?we.targetUri:Re.uri,range:p.from(we.targetRange?we.targetRange:Re.range),targetSelectionRange:we.targetSelectionRange?p.from(we.targetSelectionRange):void 0}}ce.from=he;function re(V){return{targetUri:T.URI.revive(V.uri),targetRange:p.to(V.range),targetSelectionRange:V.targetSelectionRange?p.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?p.to(V.originSelectionRange):void 0}}ce.to=re})(fe=e.DefinitionLink||(e.DefinitionLink={}));var oe;(function(ce){function he(V){return{range:p.from(V.range),contents:E.fromMany(V.contents)}}ce.from=he;function re(V){return new S.Hover(V.contents.map(E.to),p.to(V.range))}ce.to=re})(oe=e.Hover||(e.Hover={}));var Ee;(function(ce){function he(V){return{range:p.from(V.range),expression:V.expression}}ce.from=he;function re(V){return new S.EvaluatableExpression(p.to(V.range),V.expression)}ce.to=re})(Ee=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Pe;(function(ce){function he(V){if(V instanceof S.InlineValueText)return{type:"text",range:p.from(V.range),text:V.text};if(V instanceof S.InlineValueVariableLookup)return{type:"variable",range:p.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof S.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ce.from=he;function re(V){switch(V.type){case"text":return{range:p.to(V.range),text:V.text};case"variable":return{range:p.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:p.to(V.range),expression:V.expression}}}ce.to=re})(Pe=e.InlineValue||(e.InlineValue={}));var Oe;(function(ce){function he(V){return{frameId:V.frameId,stoppedLocation:p.from(V.stoppedLocation)}}ce.from=he;function re(V){return new S.InlineValueContext(V.frameId,p.to(V.stoppedLocation))}ce.to=re})(Oe=e.InlineValueContext||(e.InlineValueContext={}));var je;(function(ce){function he(V){return{range:p.from(V.range),kind:V.kind}}ce.from=he;function re(V){return new S.DocumentHighlight(p.to(V.range),V.kind)}ce.to=re})(je=e.DocumentHighlight||(e.DocumentHighlight={}));var st;(function(ce){function he(re){switch(re){case 1:return S.CompletionTriggerKind.TriggerCharacter;case 2:return S.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return S.CompletionTriggerKind.Invoke}}ce.to=he})(st=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var et;(function(ce){function he(re){return{triggerKind:st.to(re.triggerKind),triggerCharacter:re.triggerCharacter}}ce.to=he})(et=e.CompletionContext||(e.CompletionContext={}));var tt;(function(ce){function he(V){switch(V){case S.CompletionItemTag.Deprecated:return 1}}ce.from=he;function re(V){switch(V){case 1:return S.CompletionItemTag.Deprecated}}ce.to=re})(tt=e.CompletionItemTag||(e.CompletionItemTag={}));var H;(function(ce){const he=new Map([[S.CompletionItemKind.Method,0],[S.CompletionItemKind.Function,1],[S.CompletionItemKind.Constructor,2],[S.CompletionItemKind.Field,3],[S.CompletionItemKind.Variable,4],[S.CompletionItemKind.Class,5],[S.CompletionItemKind.Interface,7],[S.CompletionItemKind.Struct,6],[S.CompletionItemKind.Module,8],[S.CompletionItemKind.Property,9],[S.CompletionItemKind.Unit,12],[S.CompletionItemKind.Value,13],[S.CompletionItemKind.Constant,14],[S.CompletionItemKind.Enum,15],[S.CompletionItemKind.EnumMember,16],[S.CompletionItemKind.Keyword,17],[S.CompletionItemKind.Snippet,27],[S.CompletionItemKind.Text,18],[S.CompletionItemKind.Color,19],[S.CompletionItemKind.File,20],[S.CompletionItemKind.Reference,21],[S.CompletionItemKind.Folder,23],[S.CompletionItemKind.Event,10],[S.CompletionItemKind.Operator,11],[S.CompletionItemKind.TypeParameter,24],[S.CompletionItemKind.Issue,26],[S.CompletionItemKind.User,25]]);function re(Re){return he.get(Re)??9}ce.from=re;const V=new Map([[0,S.CompletionItemKind.Method],[1,S.CompletionItemKind.Function],[2,S.CompletionItemKind.Constructor],[3,S.CompletionItemKind.Field],[4,S.CompletionItemKind.Variable],[5,S.CompletionItemKind.Class],[7,S.CompletionItemKind.Interface],[6,S.CompletionItemKind.Struct],[8,S.CompletionItemKind.Module],[9,S.CompletionItemKind.Property],[12,S.CompletionItemKind.Unit],[13,S.CompletionItemKind.Value],[14,S.CompletionItemKind.Constant],[15,S.CompletionItemKind.Enum],[16,S.CompletionItemKind.EnumMember],[17,S.CompletionItemKind.Keyword],[27,S.CompletionItemKind.Snippet],[18,S.CompletionItemKind.Text],[19,S.CompletionItemKind.Color],[20,S.CompletionItemKind.File],[21,S.CompletionItemKind.Reference],[23,S.CompletionItemKind.Folder],[10,S.CompletionItemKind.Event],[11,S.CompletionItemKind.Operator],[24,S.CompletionItemKind.TypeParameter],[25,S.CompletionItemKind.User],[26,S.CompletionItemKind.Issue]]);function we(Re){return V.get(Re)??S.CompletionItemKind.Property}ce.to=we})(H=e.CompletionItemKind||(e.CompletionItemKind={}));var K;(function(ce){function he(re,V){const we=new S.CompletionItem(re.label);return we.insertText=re.insertText,we.kind=H.to(re.kind),we.tags=re.tags?.map(tt.to),we.detail=re.detail,we.documentation=_.isMarkdownString(re.documentation)?E.to(re.documentation):re.documentation,we.sortText=re.sortText,we.filterText=re.filterText,we.preselect=re.preselect,we.commitCharacters=re.commitCharacters,R.Range.isIRange(re.range)?we.range=p.to(re.range):typeof re.range=="object"&&(we.range={inserting:p.to(re.range.insert),replacing:p.to(re.range.replace)}),we.keepWhitespace=typeof re.insertTextRules=="undefined"?!1:Boolean(re.insertTextRules&1),typeof re.insertTextRules!="undefined"&&re.insertTextRules&4?we.insertText=new S.SnippetString(re.insertText):(we.insertText=re.insertText,we.textEdit=we.range instanceof S.Range?new S.TextEdit(we.range,we.insertText):void 0),re.additionalTextEdits&&re.additionalTextEdits.length>0&&(we.additionalTextEdits=re.additionalTextEdits.map(Re=>W.to(Re))),we.command=V&&re.command?V.fromInternal(re.command):void 0,we}ce.to=he})(K=e.CompletionItem||(e.CompletionItem={}));var z;(function(ce){function he(V){return{label:V.label,documentation:V.documentation?E.fromStrict(V.documentation):void 0}}ce.from=he;function re(V){return{label:V.label,documentation:_.isMarkdownString(V.documentation)?E.to(V.documentation):V.documentation}}ce.to=re})(z=e.ParameterInformation||(e.ParameterInformation={}));var j;(function(ce){function he(V){return{label:V.label,documentation:V.documentation?E.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map(z.from):[],activeParameter:V.activeParameter}}ce.from=he;function re(V){return{label:V.label,documentation:_.isMarkdownString(V.documentation)?E.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map(z.to):[],activeParameter:V.activeParameter}}ce.to=re})(j=e.SignatureInformation||(e.SignatureInformation={}));var Y;(function(ce){function he(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(j.from):[]}}ce.from=he;function re(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(j.to):[]}}ce.to=re})(Y=e.SignatureHelp||(e.SignatureHelp={}));var ae;(function(ce){function he(re,V){const we=new S.InlayHint(typeof V.label=="string"?V.label:V.label.map(Se.to.bind(void 0,re)),a.to(V.position),xe.to(V.kind));return we.tooltip=_.isMarkdownString(V.tooltip)?E.to(V.tooltip):V.tooltip,we.whitespaceAfter=V.whitespaceAfter,we.whitespaceBefore=V.whitespaceBefore,we}ce.to=he})(ae=e.InlayHint||(e.InlayHint={}));var Se;(function(ce){function he(re,V){const we=new S.InlayHintLabelPart(V.label);return we.collapsible=V.collapsible,w.Command.is(V.action)?we.action=re.fromInternal(V.action):V.action&&(we.action=pe.to(V.action)),we}ce.to=he})(Se=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var xe;(function(ce){function he(V){return V}ce.from=he;function re(V){return V}ce.to=re})(xe=e.InlayHintKind||(e.InlayHintKind={}));var Ve;(function(ce){function he(V){return{range:p.from(V.range),url:V.target,tooltip:V.tooltip}}ce.from=he;function re(V){let we;if(V.url)try{we=typeof V.url=="string"?T.URI.parse(V.url,!0):T.URI.revive(V.url)}catch{}return new S.DocumentLink(p.to(V.range),we)}ce.to=re})(Ve=e.DocumentLink||(e.DocumentLink={}));var Qe;(function(ce){function he(V){const we=new S.ColorPresentation(V.label);return V.textEdit&&(we.textEdit=W.to(V.textEdit)),V.additionalTextEdits&&(we.additionalTextEdits=V.additionalTextEdits.map(Re=>W.to(Re))),we}ce.to=he;function re(V){return{label:V.label,textEdit:V.textEdit?W.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(we=>W.from(we)):void 0}}ce.from=re})(Qe=e.ColorPresentation||(e.ColorPresentation={}));var nt;(function(ce){function he(V){return new S.Color(V[0],V[1],V[2],V[3])}ce.to=he;function re(V){return[V.red,V.green,V.blue,V.alpha]}ce.from=re})(nt=e.Color||(e.Color={}));var rt;(function(ce){function he(V){return{range:p.from(V.range)}}ce.from=he;function re(V){return new S.SelectionRange(p.to(V.range))}ce.to=re})(rt=e.SelectionRange||(e.SelectionRange={}));var Je;(function(ce){function he(re){switch(re){case 2:return S.TextDocumentSaveReason.AfterDelay;case 1:return S.TextDocumentSaveReason.Manual;case 3:case 4:return S.TextDocumentSaveReason.FocusOut}}ce.to=he})(Je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(ce){function he(V){switch(V){case S.TextEditorLineNumbersStyle.Off:return 0;case S.TextEditorLineNumbersStyle.Relative:return 2;case S.TextEditorLineNumbersStyle.On:default:return 1}}ce.from=he;function re(V){switch(V){case 0:return S.TextEditorLineNumbersStyle.Off;case 2:return S.TextEditorLineNumbersStyle.Relative;case 1:default:return S.TextEditorLineNumbersStyle.On}}ce.to=re})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var pt;(function(ce){function he(V){if(V===S.EndOfLine.CRLF)return 1;if(V===S.EndOfLine.LF)return 0}ce.from=he;function re(V){if(V===1)return S.EndOfLine.CRLF;if(V===0)return S.EndOfLine.LF}ce.to=re})(pt=e.EndOfLine||(e.EndOfLine={}));var Fe;(function(ce){function he(re){if(typeof re=="object")return re.viewId;switch(re){case S.ProgressLocation.SourceControl:return 3;case S.ProgressLocation.Window:return 10;case S.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ce.from=he})(Fe=e.ProgressLocation||(e.ProgressLocation={}));var At;(function(ce){function he(re){const V={start:re.start+1,end:re.end+1};return re.kind&&(V.kind=G.from(re.kind)),V}ce.from=he})(At=e.FoldingRange||(e.FoldingRange={}));var G;(function(ce){function he(re){if(re)switch(re){case S.FoldingRangeKind.Comment:return w.FoldingRangeKind.Comment;case S.FoldingRangeKind.Imports:return w.FoldingRangeKind.Imports;case S.FoldingRangeKind.Region:return w.FoldingRangeKind.Region}}ce.from=he})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(ce){function he(re){if(re)return{pinned:typeof re.preview=="boolean"?!re.preview:void 0,inactive:re.background,preserveFocus:re.preserveFocus,selection:typeof re.selection=="object"?p.from(re.selection):void 0,override:typeof re.override=="boolean"?i.EditorResolution.DISABLED:void 0}}ce.from=he})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var de;(function(ce){function he(Re){return Re instanceof S.RelativePattern?Re.toJSON():typeof Re=="string"?Re:re(Re)||V(Re)?new S.RelativePattern(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ce.from=he;function re(Re){const We=Re;return We?T.URI.isUri(We.baseUri)&&typeof We.pattern=="string":!1}function V(Re){const We=Re;return We?typeof We.base=="string"&&typeof We.pattern=="string":!1}function we(Re){return typeof Re=="string"?Re:new S.RelativePattern(T.URI.revive(Re.baseUri),Re.pattern)}ce.to=we})(de=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(ce){function he(re){if(re){if(Array.isArray(re))return re.map(he);if(typeof re=="string")return re;{const V=re;return{language:V.language,scheme:V.scheme,pattern:de.from(V.pattern),exclusive:V.exclusive}}}else return}ce.from=he})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var qe;(function(ce){function he(V){return{start:V.start,end:V.end}}ce.from=he;function re(V){return new S.NotebookRange(V.start,V.end)}ce.to=re})(qe=e.NotebookRange||(e.NotebookRange={}));var lt;(function(ce){function he(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ce.to=he;function re(V){return{lastRunSuccess:V.success,runStartTime:V.timing?.startTime,runEndTime:V.timing?.endTime,executionOrder:V.executionOrder}}ce.from=re})(lt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ht;(function(ce){function he(V){switch(V){case S.NotebookCellKind.Markup:return s.CellKind.Markup;case S.NotebookCellKind.Code:default:return s.CellKind.Code}}ce.from=he;function re(V){switch(V){case s.CellKind.Markup:return S.NotebookCellKind.Markup;case s.CellKind.Code:default:return S.NotebookCellKind.Code}}ce.to=re})(ht=e.NotebookCellKind||(e.NotebookCellKind={}));var Ye;(function(ce){function he(V){const we={metadata:V.metadata??Object.create(null),cells:[]};for(let Re of V.cells)S.NotebookCellData.validate(Re),we.cells.push(kt.from(Re));return we}ce.from=he;function re(V){const we=new S.NotebookData(V.cells.map(kt.to));return(0,D.isEmptyObject)(V.metadata)||(we.metadata=V.metadata),we}ce.to=re})(Ye=e.NotebookData||(e.NotebookData={}));var kt;(function(ce){function he(V){return{cellKind:ht.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:lt.from(V.executionSummary??{}),outputs:V.outputs?V.outputs.map(De.from):[]}}ce.from=he;function re(V){return new S.NotebookCellData(ht.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(De.to):void 0,V.metadata,V.internalMetadata?lt.to(V.internalMetadata):void 0)}ce.to=re})(kt=e.NotebookCellData||(e.NotebookCellData={}));var Ae;(function(ce){function he(V){return{mime:V.mime,valueBytes:t.VSBuffer.wrap(V.data)}}ce.from=he;function re(V){return new S.NotebookCellOutputItem(V.valueBytes.buffer,V.mime)}ce.to=re})(Ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var De;(function(ce){function he(V){return{outputId:V.id,items:V.items.map(Ae.from),metadata:V.metadata}}ce.from=he;function re(V){const we=V.items.map(Ae.to);return new S.NotebookCellOutput(we,V.outputId,V.metadata)}ce.to=re})(De=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ve;(function(ce){function he(we){return V(we)?{include:(0,D.withNullAsUndefined)(de.from(we.include)),exclude:(0,D.withNullAsUndefined)(de.from(we.exclude))}:(0,D.withNullAsUndefined)(de.from(we))}ce.from=he;function re(we){return V(we)?{include:de.to(we.include),exclude:de.to(we.exclude)}:de.to(we)}ce.to=re;function V(we){const Re=we;return Re?!!Re.include&&!!Re.exclude:!1}})(ve=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var te;(function(ce){function he(re){return{backgroundColor:re.backgroundColor,borderColor:re.borderColor,top:re.top?x.from(re.top):void 0}}ce.from=he})(te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ne;(function(ce){function he(re,V,we){const Re=typeof re.command=="string"?{title:"",command:re.command}:re.command;return{alignment:re.alignment===S.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Re,we),text:re.text,tooltip:re.tooltip,accessibilityInformation:re.accessibilityInformation,priority:re.priority}}ce.from=he})(ne=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ue;(function(ce){function he(re){return{transientOutputs:re?.transientOutputs??!1,transientCellMetadata:re?.transientCellMetadata??{},transientDocumentMetadata:re?.transientDocumentMetadata??{}}}ce.from=he})(ue=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var me;(function(ce){function he(V){return{uri:V.uri,provides:V.provides}}ce.from=he;function re(V){return new S.NotebookRendererScript(T.URI.revive(V.uri),V.provides)}ce.to=re})(me=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Te;(function(ce){function he(V){return{message:E.fromStrict(V.message)||"",type:0,expected:V.expectedOutput,actual:V.actualOutput,location:V.location?pe.from(V.location):void 0}}ce.from=he;function re(V){const we=new S.TestMessage(typeof V.message=="string"?V.message:E.to(V.message));return we.actualOutput=V.actual,we.expectedOutput=V.expected,we.location=V.location?pe.to(V.location):void 0,we}ce.to=re})(Te=e.TestMessage||(e.TestMessage={}));var He;(function(ce){let he;(function(re){re.Delimiter="\0"})(he||(he={})),ce.namespace=(re,V)=>re+"\0"+V,ce.denamespace=re=>{const V=re.indexOf("\0");return{ctrlId:re.slice(0,V),tagId:re.slice(V+1)}}})(He=e.TestTag||(e.TestTag={}));var Le;(function(ce){function he(Re){const We=(0,l.getPrivateApiFor)(Re).controllerId;return{extId:m.TestId.fromExtHostTestItem(Re,We).toString(),label:Re.label,uri:Re.uri,tags:Re.tags.map(ze=>He.namespace(We,ze.id)),range:p.from(Re.range)||null,description:Re.description||null,error:Re.error&&E.fromStrict(Re.error)||null}}ce.from=he;function re(Re){return{parent:void 0,error:void 0,id:m.TestId.fromString(Re.extId).localId,label:Re.label,uri:T.URI.revive(Re.uri),tags:(Re.tags||[]).map(We=>{const{tagId:ze}=He.denamespace(We);return new S.TestTag(ze)}),range:p.to(Re.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Re.description||void 0}}ce.toPlain=re;function V(Re){const We=m.TestId.fromString(Re.extId),ze=new l.TestItemImpl(We.controllerId,We.localId,Re.label,T.URI.revive(Re.uri));return ze.range=p.to(Re.range||void 0),ze.description=Re.description||void 0,ze}function we(Re){let We;for(const ze of Re.tests){const mt=V(ze.item);(0,l.getPrivateApiFor)(mt).parent=We,We=mt}return We}ce.toItemFromContext=we})(Le=e.TestItem||(e.TestItem={})),function(ce){function he(V){return{id:V.id}}ce.from=he;function re(V){return new S.TestTag(V.id)}ce.to=re}(He=e.TestTag||(e.TestTag={}));var Ge;(function(ce){const he=(V,we)=>{const Re={...Le.toPlain(V.item),parent:void 0,taskStates:V.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(ze=>ze.type===0).map(Te.to)})),children:V.children.map(We=>we.get(We)).filter(D.isDefined).map(We=>he(We,we))};for(const We of Re.children)We.parent=Re;return Re};function re(V){const we=[],Re=new Map;for(const We of V.items)Re.set(We.item.extId,We),V.request.targets.some(ze=>ze.controllerId===We.controllerId&&ze.testIds.includes(We.item.extId))&&we.push(We);return{completedAt:V.completedAt,results:we.map(We=>he(We,Re))}}ce.to=re})(Ge=e.TestResults||(e.TestResults={}));var ot;(function(ce){function he(Re){return{covered:Re.covered,total:Re.covered}}function re(Re){return"line"in Re?a.from(Re):p.from(Re)}function V(Re){return"branches"in Re?{count:Re.executionCount,location:re(Re.location),type:1,branches:Re.branches.length?Re.branches.map(We=>({count:We.executionCount,location:We.location&&re(We.location)})):void 0}:{type:0,count:Re.executionCount,location:re(Re.location)}}ce.fromDetailed=V;function we(Re){return{uri:Re.uri,statement:he(Re.statementCoverage),branch:Re.branchCoverage&&he(Re.branchCoverage),function:Re.functionCoverage&&he(Re.functionCoverage),details:Re.detailedCoverage?.map(V)}}ce.fromFile=we})(ot=e.TestCoverage||(e.TestCoverage={}));var at;(function(ce){function he(re){switch(re){case 1:return S.CodeActionTriggerKind.Invoke;case 2:return S.CodeActionTriggerKind.Automatic}}ce.to=he})(at=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ne;(function(ce){function he(V){const we=new S.TypeHierarchyItem($.to(V.kind),V.name,V.detail||"",T.URI.revive(V.uri),p.to(V.range),p.to(V.selectionRange));return we._sessionId=V._sessionId,we._itemId=V._itemId,we}ce.to=he;function re(V,we,Re){if(we=we??V._sessionId,Re=Re??V._itemId,we===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:we,_itemId:Re,kind:$.from(V.kind),name:V.name,detail:V.detail??"",uri:V.uri,range:p.from(V.range),selectionRange:p.from(V.selectionRange),tags:V.tags?.map(q.from)}}ce.from=re})(Ne=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(ye[164],_e([0,1,2,15,7,8,226]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(T,R,w,i={timeout:1500,errors:3}){this._logService=T,this._documents=R,this._mainThreadBulkEdits=w,this._thresholds=i,this._callbacks=new I.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(T){return(R,w,i)=>{const l={dispose:this._callbacks.push([R,w,T])};return Array.isArray(i)&&i.push(l),l}}async $participateInSave(T,R){const w=r.URI.revive(T);let i=!1;const d=setTimeout(()=>i=!0,this._thresholds.timeout),l=[];try{for(let s of[...this._callbacks]){if(i)break;const m=this._documents.getDocument(w),F=await this._deliverEventAsyncAndBlameBadListeners(s,{document:m,reason:A.TextDocumentSaveReason.to(R)});l.push(F)}}finally{clearTimeout(d)}return l}_deliverEventAsyncAndBlameBadListeners([T,R,w],i){const d=this._badListeners.get(T);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(w,T,R,i).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const s=this._badListeners.get(T);this._badListeners.set(T,s?s+1:1),typeof s=="number"&&s>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(T,R,w,i){const d=[],l=Date.now(),{document:s,reason:m}=i,{version:F}=s,S=Object.freeze({document:s,reason:m,waitUntil(b){if(Object.isFrozen(d))throw(0,t.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(b))}});try{R.apply(w,[S])}catch(b){return Promise.reject(b)}return Object.freeze(d),new Promise((b,p)=>{const C=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(C),b(a)}).catch(a=>{clearTimeout(C),p(a)})}).then(b=>{const p={edits:[]};for(const C of b)if(Array.isArray(C)&&C.every(a=>a instanceof _.TextEdit))for(const{newText:a,newEol:M,range:o}of C)p.edits.push({_type:2,resource:s.uri,edit:{range:o&&A.Range.from(o),text:a,eol:M&&A.EndOfLine.from(M)}});if(p.edits.length!==0)return F===s.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(ye[165],_e([0,1,11,27,2,8,85]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(w,i,d,l){this.start=w,this.deletedCount=i,this.deletedItems=d,this.items=l}static asApiEvents(w){return w.map(i=>({start:i.start,deletedCount:i.deletedCount,deletedItems:i.deletedItems,items:i.items.map(d=>d.apiCell)}))}}class D{constructor(w,i,d){this.notebook=w,this._extHostDocument=i,this._cellData=d,this.handle=d.handle,this.uri=_.URI.revive(d.uri),this.cellKind=d.cellKind,this._outputs=d.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=d.internalMetadata??{},this._metadata=Object.freeze(d.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(d.internalMetadata??{}))}static asModelAddData(w,i){return{EOL:i.eol,lines:i.source,languageId:i.language,uri:i.uri,isDirty:!1,versionId:1,notebook:w}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const w=this,i=this._extHostDocument.getDocument(this.uri);if(!i)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:i.document,get mime(){return w._mime},set mime(d){w._mime=d},get outputs(){return w._outputs.slice(0)},get metadata(){return w._metadata},get executionSummary(){return w._previousResult}})}return this._apiCell}setOutputs(w){this._outputs=w.map(A.NotebookCellOutput.to)}setOutputItems(w,i,d){const l=d.map(A.NotebookCellOutputItem.to),s=this._outputs.find(m=>m.id===w);s&&(i||(s.items.length=0),s.items.push(...l))}setMetadata(w){this._metadata=Object.freeze(w)}setInternalMetadata(w){this._internalMetadata=w,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=D;class T{constructor(w,i,d,l,s,m){this._proxy=w,this._textDocumentsAndEditors=i,this._textDocuments=d,this._emitter=l,this.uri=s,this.handle=T._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=m.viewType,this._metadata=Object.freeze(m.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,m.cells]],!0),this._versionId=m.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const w=this;this._notebook={get uri(){return w.uri},get version(){return w._versionId},get notebookType(){return w._notebookType},get isDirty(){return w._isDirty},get isUntitled(){return w.uri.scheme===r.Schemas.untitled},get isClosed(){return w._disposed},get metadata(){return w._metadata},get cellCount(){return w._cells.length},cellAt(i){return i=w._validateIndex(i),w._cells[i].apiCell},getCells(i){return(i?w._getCells(i):w._cells).map(l=>l.apiCell)},save(){return w._save()}}}return this._notebook}updateBackup(w){this._backup?.delete(),this._backup=w}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(w){w.metadata&&(this._metadata=Object.freeze({...this._metadata,...w.metadata}))}acceptDirty(w){this._isDirty=w}acceptModelChanged(w,i){this._versionId=w.versionId,this._isDirty=i;for(const d of w.rawEvents)d.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(d.changes,!1):d.kind===I.NotebookCellsChangeType.Move?this._moveCell(d.index,d.newIdx):d.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(d.index,d.outputs):d.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(d.index,d.outputId,d.append,d.outputItems):d.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(d.index,d.language):d.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(d.index,d.mime):d.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(d.index,d.metadata):d.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(d.index,d.internalMetadata)}_validateIndex(w){return w=w|0,w<0?0:w>=this._cells.length?this._cells.length-1:w}_validateRange(w){let i=w.start|0,d=w.end|0;return i<0&&(i=0),d>this._cells.length&&(d=this._cells.length),w.with({start:i,end:d})}_getCells(w){w=this._validateRange(w);const i=[];for(let d=w.start;d<w.end;d++)i.push(this._cells[d]);return i}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(w,i){if(this._disposed)return;const d=[],l=[],s=[];w.reverse().forEach(m=>{const S=m[2].map(C=>{const a=new D(this,this._textDocumentsAndEditors,C);return i||l.push(D.asModelAddData(this.apiNotebook,C)),a}),b=new P(m[0],m[1],[],S),p=this._cells.splice(m[0],m[1],...S);for(const C of p)s.push(C.uri),b.deletedItems.push(C.apiCell);d.push(b)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:s}),i||this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(d)}))}_moveCell(w,i){const d=this._cells.splice(w,1);this._cells.splice(i,0,...d);const l=[new P(w,1,d.map(s=>s.apiCell),[]),new P(i,0,[],d)];this._emitter.emitModelChange((0,t.deepFreeze)({document:this.apiNotebook,changes:P.asApiEvents(l)}))}_setCellOutputs(w,i){const d=this._cells[w];d.setOutputs(i),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[d.apiCell]}))}_setCellOutputItems(w,i,d,l){const s=this._cells[w];s.setOutputItems(i,d,l),this._emitter.emitCellOutputsChange((0,t.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_changeCellLanguage(w,i){const d=this._cells[w];d.apiCell.document.languageId!==i&&this._textDocuments.$acceptModelLanguageChanged(d.uri,i)}_changeCellMime(w,i){const d=this._cells[w];d.apiCell.mime=i}_changeCellMetadata(w,i){const d=this._cells[w],l=d.apiCell.metadata;d.setMetadata(i);const s=d.apiCell.metadata;(0,t.equals)(l,s)||this._emitter.emitCellMetadataChange((0,t.deepFreeze)({document:this.apiNotebook,cell:d.apiCell}))}_changeCellInternalMetadata(w,i){this._cells[w].setInternalMetadata(i)}getCellFromApiCell(w){return this._cells.find(i=>i.apiCell===w)}getCellFromIndex(w){return this._cells[w]}getCell(w){return this._cells.find(i=>i.handle===w)}getCellIndex(w){return this._cells.indexOf(w)}}e.ExtHostNotebookDocument=T,T._handlePool=0}),define(ye[89],_e([0,1,7,8,15]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,T){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:T})}replaceCells(D,T,R){this._throwIfFinalized(),!(D===T&&R.length===0)&&this._collectedEdits.push({editType:1,index:D,count:T-D,cells:R.map(t.NotebookCellData.from)})}}class I{constructor(D,T,R,w,i,d){this.id=D,this._proxy=T,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=i,this._visibleRanges=w,this._viewColumn=d}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(T){if(!Array.isArray(T)||!T.every(r.NotebookRange.isNotebookRange))throw(0,_.illegalArgument)("selections");D._selections=T,D._trySetSelections(T)},get visibleRanges(){return D._visibleRanges},revealRange(T,R){D._proxy.$tryRevealRange(D.id,t.NotebookRange.from(T),R??r.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(T){const R=new A(this.document.version);return T(R),D._applyEdit(R.finalize())},setDecorations(T,R){return D.setDecorations(T,R)}},I.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(t.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const T=[];let R=-1;for(let w=0;w<D.cellEdits.length;w++){if(R<0){T.push(D.cellEdits[w]),R++;continue}const d=T[R],l=D.cellEdits[w];if(d.editType===1&&l.editType===1&&d.index===l.index){d.cells.push(...D.cellEdits[w].cells),d.count+=D.cellEdits[w].count;continue}T.push(D.cellEdits[w]),R++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,T)}setDecorations(D,T){if(!(T.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return T.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,t.NotebookRange.from(T),D.key)}}e.ExtHostNotebookEditor=I,I.apiEditorsToExtHost=new WeakMap}),define(ye[166],_e([0,1,8,139,120,20,53,15]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(i){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=i}async withProgress(i,d,l){const s=this._handles++,{title:m,location:F,cancellable:S}=d,b={label:(0,_.localize)(0,null,i.displayName||i.name),id:i.identifier.value};return this._proxy.$startProgress(s,{location:r.ProgressLocation.from(F),title:m,source:b,cancellable:S},i.isUnderDevelopment?void 0:i.identifier.value).catch(P.onUnexpectedExternalError),this._withProgress(s,l,!!S)}_withProgress(i,d,l){let s;l&&(s=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(i,s));const m=S=>{this._proxy.$progressEnd(S),this._mapHandleToCancellationSource.delete(S),s&&s.dispose()};let F;try{F=d(new R(this._proxy,i),l&&s?s.token:A.CancellationToken.None)}catch(S){throw m(i),S}return F.then(S=>m(i),S=>m(i)),F}$acceptProgressCanceled(i){const d=this._mapHandleToCancellationSource.get(i);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(i))}}e.ExtHostProgress=D;function T(w,i){return w.message=i.message,typeof i.increment=="number"&&(typeof w.increment=="number"?w.increment+=i.increment:w.increment=i.increment),w}class R extends t.Progress{constructor(i,d){super(l=>this.throttledReport(l));this._proxy=i,this._handle=d}throttledReport(i){this._proxy.$progressReport(this._handle,i)}}Be([(0,I.throttle)(100,(w,i)=>T(w,i),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(ye[90],_e([0,1,42,15,54,8,7]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(i,d,l){const s=P._Keys.nextId();i.$registerTextEditorDecorationType(d.identifier,s,A.DecorationRenderOptions.from(l)),this.value=Object.freeze({key:s,dispose(){i.$removeTextEditorDecorationType(s)}})}}e.TextEditorDecorationType=P,P._Keys=new _.IdGenerator("TextEditorDecorationType");class D{constructor(i,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=i,this._documentVersionId=i.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(i,d){this._throwIfFinalized();let l=null;if(i instanceof I.Position)l=new I.Range(i,i);else if(i instanceof I.Range)l=i;else throw new Error("Unrecognized location");this._pushEdit(l,d,!1)}insert(i,d){this._throwIfFinalized(),this._pushEdit(new I.Range(i,i),d,!0)}delete(i){this._throwIfFinalized();let d=null;if(i instanceof I.Range)d=i;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(i,d,l){const s=this._document.validateRange(i);this._collectedEdits.push({range:s,text:d,forceMoveMarkers:l})}setEndOfLine(i){if(this._throwIfFinalized(),i!==I.EndOfLine.LF&&i!==I.EndOfLine.CRLF)throw(0,t.illegalArgument)("endOfLine");this._setEndOfLine=i}}e.TextEditorEdit=D;class T{constructor(i,d,l,s){this._proxy=i,this._id=d,this._accept(l),this._logService=s;const m=this;this.value={get tabSize(){return m._tabSize},set tabSize(F){m._setTabSize(F)},get insertSpaces(){return m._insertSpaces},set insertSpaces(F){m._setInsertSpaces(F)},get cursorStyle(){return m._cursorStyle},set cursorStyle(F){m._setCursorStyle(F)},get lineNumbers(){return m._lineNumbers},set lineNumbers(F){m._setLineNumbers(F)}}}_accept(i){this._tabSize=i.tabSize,this._insertSpaces=i.insertSpaces,this._cursorStyle=i.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(i.lineNumbers)}_validateTabSize(i){if(i==="auto")return"auto";if(typeof i=="number"){const d=Math.floor(i);return d>0?d:null}if(typeof i=="string"){const d=parseInt(i,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(i){const d=this._validateTabSize(i);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(i){return i==="auto"?"auto":i==="false"?!1:Boolean(i)}_setInsertSpaces(i){const d=this._validateInsertSpaces(i);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(i){this._cursorStyle!==i&&(this._cursorStyle=i,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:i})))}_setLineNumbers(i){this._lineNumbers!==i&&(this._lineNumbers=i,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(i)})))}assign(i){const d={};let l=!1;if(typeof i.tabSize!="undefined"){const s=this._validateTabSize(i.tabSize);s==="auto"?(l=!0,d.tabSize=s):typeof s=="number"&&this._tabSize!==s&&(this._tabSize=s,l=!0,d.tabSize=s)}if(typeof i.insertSpaces!="undefined"){const s=this._validateInsertSpaces(i.insertSpaces);s==="auto"?(l=!0,d.insertSpaces=s):this._insertSpaces!==s&&(this._insertSpaces=s,l=!0,d.insertSpaces=s)}typeof i.cursorStyle!="undefined"&&this._cursorStyle!==i.cursorStyle&&(this._cursorStyle=i.cursorStyle,l=!0,d.cursorStyle=i.cursorStyle),typeof i.lineNumbers!="undefined"&&this._lineNumbers!==i.lineNumbers&&(this._lineNumbers=i.lineNumbers,l=!0,d.lineNumbers=A.TextEditorLineNumbersStyle.from(i.lineNumbers)),l&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,d))}_warnOnError(i,d){d.catch(l=>{this._logService.warn(`ExtHostTextEditorOptions '${i}' failed:'`),this._logService.warn(l)})}}e.ExtHostTextEditorOptions=T;class R{constructor(i,d,l,s,m,F,S,b){this.id=i,this._proxy=d,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=m,this._options=new T(this._proxy,this.id,F,l),this._visibleRanges=S,this._viewColumn=b;const p=this;this.value=Object.freeze({get document(){return s.getValue()},set document(C){throw(0,t.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(C){if(!(C instanceof I.Selection))throw(0,t.illegalArgument)("selection");p._selections=[C],p._trySetSelection()},get selections(){return p._selections},set selections(C){if(!Array.isArray(C)||C.some(a=>!(a instanceof I.Selection)))throw(0,t.illegalArgument)("selections");p._selections=C,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(C){throw(0,t.readonly)("visibleRanges")},get options(){return p._options.value},set options(C){p._disposed||p._options.assign(C)},get viewColumn(){return p._viewColumn},set viewColumn(C){throw(0,t.readonly)("viewColumn")},edit(C,a={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const M=new D(s.getValue(),a);return C(M),p._applyEdit(M)},insertSnippet(C,a,M={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let o;if(!a||Array.isArray(a)&&a.length===0)o=p._selections.map(n=>A.Range.from(n));else if(a instanceof I.Position){const{lineNumber:n,column:u}=A.Position.from(a);o=[{startLineNumber:n,startColumn:u,endLineNumber:n,endColumn:u}]}else if(a instanceof I.Range)o=[A.Range.from(a)];else{o=[];for(const n of a)if(n instanceof I.Range)o.push(A.Range.from(n));else{const{lineNumber:u,column:f}=A.Position.from(n);o.push({startLineNumber:u,startColumn:f,endLineNumber:u,endColumn:f})}}return d.$tryInsertSnippet(i,C.value,o,M)},setDecorations(C,a){const M=a.length===0;M&&!p._hasDecorationsForKey.has(C.key)||(M?p._hasDecorationsForKey.delete(C.key):p._hasDecorationsForKey.add(C.key),p._runOnProxy(()=>{if(A.isDecorationOptionsArr(a))return d.$trySetDecorations(i,C.key,A.fromRangeOrRangeWithMessage(a));{const o=new Array(4*a.length);for(let n=0,u=a.length;n<u;n++){const f=a[n];o[4*n]=f.start.line+1,o[4*n+1]=f.start.character+1,o[4*n+2]=f.end.line+1,o[4*n+3]=f.end.character+1}return d.$trySetDecorationsFast(i,C.key,o)}}))},revealRange(C,a){p._runOnProxy(()=>d.$tryRevealRange(i,A.Range.from(C),a||I.TextEditorRevealType.Default))},show(C){d.$tryShowEditor(i,A.ViewColumn.from(C))},hide(){d.$tryHideEditor(i)}})}dispose(){(0,r.ok)(!this._disposed),this._disposed=!0}_acceptOptions(i){(0,r.ok)(!this._disposed),this._options._accept(i)}_acceptVisibleRanges(i){(0,r.ok)(!this._disposed),this._visibleRanges=i}_acceptViewColumn(i){(0,r.ok)(!this._disposed),this._viewColumn=i}_acceptSelections(i){(0,r.ok)(!this._disposed),this._selections=i}async _trySetSelection(){const i=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,i)),this.value}_applyEdit(i){const d=i.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const l=d.edits.map(m=>m.range);l.sort((m,F)=>m.end.line===F.end.line?m.end.character===F.end.character?m.start.line===F.start.line?m.start.character-F.start.character:m.start.line-F.start.line:m.end.character-F.end.character:m.end.line-F.end.line);for(let m=0,F=l.length-1;m<F;m++){const S=l[m].end;if(l[m+1].start.isBefore(S))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=d.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,s,{setEndOfLine:typeof d.setEndOfLine=="number"?A.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(i){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):i().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=R}),define(ye[167],_e([0,1,13,4,6,10,48,8,86,66]),function(ee,e,r,t,_,A,I,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class R extends _.Disposable{constructor(i){super();this.controllerId=i,this.debounceSendDiff=this._register(new r.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new t.Emitter),this.root=new I.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(i){this._resolveHandler=i;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const i=this.diff;return this.diff=[],i}pushDiff(i){const d=this.diff[this.diff.length-1];if(d&&i[0]===1){if(d[0]===1&&d[1].extId===i[1].extId){(0,D.applyTestItemUpdate)(d[1],i[1]);return}if(d[0]===0&&d[1].item.extId===i[1].extId){(0,D.applyTestItemUpdate)(d[1],i[1]);return}}this.diff.push(i),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(i,d){const l=this.tree.get(i);if(!!l){if((l.expandLevels===void 0||d>l.expandLevels)&&(l.expandLevels=d),l.expand===1){const s=this.resolveChildren(l);return s.isOpen()?this.expandChildren(l,d-1):s.wait().then(()=>this.expandChildren(l,d-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,d-1)):this.expandChildren(l,d-1)}}dispose(){for(const i of this.tree.values())(0,I.getPrivateApiFor)(i.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(i,d){switch(d.op){case 2:this.pushDiff([4,i.fullId.toString()]);break;case 1:this.removeItem(T.TestId.joinToString(i.fullId,d.id));break;case 0:this.upsertItem(d.item,i);break;case 4:for(const l of d.ops)this.onTestItemEvent(i,l);break;case 3:{const{key:l,value:s,previous:m}=d,F=i.fullId.toString();switch(l){case"canResolveChildren":this.updateExpandability(i);break;case"tags":this.diffTagRefs(s,m,F);break;case"range":this.pushDiff([1,{extId:F,item:{range:P.Range.from(s)}}]);break;case"error":this.pushDiff([1,{extId:F,item:{error:P.MarkdownString.fromStrict(s)||null}}]);break;default:this.pushDiff([1,{extId:F,item:{[l]:s??null}}]);break}break}default:(0,A.assertNever)(d)}}upsertItem(i,d){if(!(i instanceof I.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${i.id} did not`);const l=T.TestId.fromExtHostTestItem(i,this.root.id,d?.actual),s=(0,I.getPrivateApiFor)(i);s.parent&&s.parent!==d?.actual&&s.parent.children.delete(i.id);let m=this.tree.get(l.toString());if(!m){m={fullId:l,actual:i,parent:d?l.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},i.tags.forEach(this.incrementTagRefs,this),this.tree.set(m.fullId.toString(),m),this.setItemParent(i,d),this.pushDiff([0,{parent:m.parent&&m.parent.toString(),controllerId:this.controllerId,expand:m.expand,item:P.TestItem.from(i)}]),this.connectItemAndChildren(i,m,d);return}if(m.actual===i){this.connectItem(i,m,d);return}const F=m.actual.children,S=m.actual,b=(0,I.diffTestItems)(S,i);(0,I.getPrivateApiFor)(S).listener=void 0,m.actual=i,m.expand=0;for(const[p,C]of b)this.onTestItemEvent(m,{op:3,key:p,value:C,previous:S[p]});this.connectItemAndChildren(i,m,d);for(const p of F)i.children.get(p.id)||this.removeItem(T.TestId.joinToString(l,p.id))}diffTagRefs(i,d,l){const s=new Set(d.map(m=>m.id));for(const m of i)s.delete(m.id)||this.incrementTagRefs(m);this.pushDiff([1,{extId:l,item:{tags:i.map(m=>P.TestTag.namespace(this.controllerId,m.id))}}]),s.forEach(this.decrementTagRefs,this)}incrementTagRefs(i){const d=this.tags.get(i.id);d?d.refCount++:(this.tags.set(i.id,{refCount:1}),this.pushDiff([5,{id:P.TestTag.namespace(this.controllerId,i.id),ctrlLabel:this.root.label}]))}decrementTagRefs(i){const d=this.tags.get(i);d&&!--d.refCount&&(this.tags.delete(i),this.pushDiff([6,P.TestTag.namespace(this.controllerId,i)]))}setItemParent(i,d){(0,I.getPrivateApiFor)(i).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(i,d,l){this.setItemParent(i,l);const s=(0,I.getPrivateApiFor)(i);s.parent=l?.actual,s.listener=m=>this.onTestItemEvent(d,m),this.updateExpandability(d)}connectItemAndChildren(i,d,l){this.connectItem(i,d,l);for(const s of i.children)this.upsertItem(s,d)}updateExpandability(i){let d;this._resolveHandler?i.resolveBarrier?d=i.resolveBarrier.isOpen()?3:2:d=i.actual.canResolveChildren?1:0:d=0,d!==i.expand&&(i.expand=d,this.pushDiff([1,{extId:i.fullId.toString(),expand:d}]),d===1&&i.expandLevels!==void 0&&this.resolveChildren(i))}expandChildren(i,d){if(d<0)return;const l=[];for(const s of i.actual.children){const m=this.expand(T.TestId.joinToString(i.fullId,s.id),d);(0,r.isThenable)(m)&&l.push(m)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this._resolveHandler){const m=new r.Barrier;return m.open(),m}i.expand=2,this.pushExpandStateUpdate(i);const d=i.resolveBarrier=new r.Barrier,l=m=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),i.actual!==this.root&&(i.actual.error=m.stack||m.message||String(m))};let s;try{s=this._resolveHandler(i.actual===this.root?void 0:i.actual)}catch(m){l(m)}return(0,r.isThenable)(s)?s.catch(l).then(()=>{d.open(),this.updateExpandability(i)}):(d.open(),this.updateExpandability(i)),i.resolveBarrier}pushExpandStateUpdate(i){this.pushDiff([1,{extId:i.fullId.toString(),expand:i.expand}])}removeItem(i){const d=this.tree.get(i);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,i]);const l=[d];for(;l.length;){const s=l.pop();if(!!s){(0,I.getPrivateApiFor)(s.actual).listener=void 0;for(const m of s.actual.tags)this.decrementTagRefs(m.id);this.tree.delete(s.fullId.toString());for(const m of s.actual.children)l.push(this.tree.get(T.TestId.joinToString(s.fullId,m.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.diffOpEmitter.fire(i)}}e.SingleUseTestCollection=R}),define(ye[168],_e([0,1,3,135]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,r.refineServiceDecorator)(t.IEnvironmentService)}),define(ye[169],_e([0,1,25,4,17]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(R){this.removedDueToLooping=R}}e.DeltaExtensionsResult=A;class I{constructor(R){this._onDidChange=new t.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=R,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const R of this._extensionDescriptions){if(this._extensionsMap.has(r.ExtensionIdentifier.toKey(R.identifier))){console.error("Extension `"+R.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(r.ExtensionIdentifier.toKey(R.identifier),R),this._extensionsArr.push(R),Array.isArray(R.activationEvents))for(let w of R.activationEvents)w==="onUri"&&(w=`onUri:${r.ExtensionIdentifier.toKey(R.identifier)}`),this._activationMap.has(w)||this._activationMap.set(w,[]),this._activationMap.get(w).push(R)}}keepOnly(R){const w=new Set;R.forEach(i=>w.add(r.ExtensionIdentifier.toKey(i))),this._extensionDescriptions=this._extensionDescriptions.filter(i=>w.has(r.ExtensionIdentifier.toKey(i.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(R,w){R.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(R));const i=I._findLoopingExtensions(this._extensionDescriptions);if(w=w.concat(i.map(d=>d.identifier)),w.length>0){const d=new Set;w.forEach(l=>d.add(r.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!d.has(r.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(i)}static _findLoopingExtensions(R){const w=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(m){this._nodesSet.has(m)||(this._nodesSet.add(m),this._nodesArr.push(m))}addArc(m,F){this.addNode(m),this.addNode(F),this._arcs.has(m)?this._arcs.get(m).push(F):this._arcs.set(m,[F])}getArcs(m){return this._arcs.has(m)?this._arcs.get(m):[]}hasOnlyGoodArcs(m,F){const S=w.getArcs(m);for(let b=0;b<S.length;b++)if(!F.has(S[b]))return!1;return!0}getNodes(){return this._nodesArr}};let i=new Map;for(let m of R){const F=r.ExtensionIdentifier.toKey(m.identifier);if(i.set(F,m),m.extensionDependencies)for(let S of m.extensionDependencies){const b=r.ExtensionIdentifier.toKey(S);w.addArc(F,b)}}let d=new Set;w.getNodes().filter(m=>w.getArcs(m).length===0).forEach(m=>d.add(m));let l=w.getNodes().filter(m=>!d.has(m)),s;do{s=!1;for(let m=0;m<l.length;m++){const F=l[m];w.hasOnlyGoodArcs(F,d)&&(l.splice(m,1),m--,d.add(F),s=!0)}}while(s);return l.map(m=>i.get(m))}containsActivationEvent(R){return this._activationMap.has(R)}containsExtension(R){return this._extensionsMap.has(r.ExtensionIdentifier.toKey(R))}getExtensionDescriptionsForActivationEvent(R){const w=this._activationMap.get(R);return w?w.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(R){const w=this._extensionsMap.get(r.ExtensionIdentifier.toKey(R));return w||void 0}}e.ExtensionDescriptionRegistry=I;var P;(function(T){T[T.Builtin=0]="Builtin",T[T.User=1]="User",T[T.Dev=2]="Dev"})(P||(P={}));function D(T,R){const w=T.isBuiltin?0:T.isUnderDevelopment?2:1,i=R.isBuiltin?0:R.isUnderDevelopment?2:1;if(w!==i)return w-i;const d=_.posix.basename(T.extensionLocation.path),l=_.posix.basename(R.extensionLocation.path);return d<l?-1:d>l?1:0}}),define(ye[170],_e([0,1,21]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var t;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(t=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var _;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(_=e.MessageType||(e.MessageType={}));function A(P){const D=r.VSBuffer.alloc(1);switch(P){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=A;function I(P,D){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=I}),define(ye[26],_e([0,1,4,2,3,25,142]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:t.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,_.createDecorator)("extensionService");var P;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(P=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class T{constructor(C){this.dependency=C}}e.MissingExtensionDependency=T;var R;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(R=e.ExtensionHostKind||(e.ExtensionHostKind={}));function w(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=w;function i(p,C){return p.enabledApiProposals?p.enabledApiProposals.includes(C):!1}e.isProposedApiEnabled=i;function d(p,C){if(!i(p,C))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=d;class l{constructor(C,a,M,o){this.codeLoadingTime=C,this.activateCallTime=a,this.activateResolvedTime=M,this.activationReason=o}}e.ActivationTimes=l;class s{constructor(C,a){this.description=C,this.value=a}}e.ExtensionPointContribution=s,e.ExtensionHostLogFileName="exthost";var m;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(m=e.ActivationKind||(e.ActivationKind={}));function F(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=F;function S(p,C){return{identifier:new A.ExtensionIdentifier((0,I.getExtensionId)(p.manifest.publisher,p.manifest.name)),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!C,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=S;class b{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None}activateByEvent(C){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(C){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(C,a){return Promise.resolve()}_onWillActivateExtension(C){}_onDidActivateExtension(C,a,M,o,n){}_onDidActivateExtensionError(C,a){}_onExtensionRuntimeError(C,a){}_onExtensionHostExit(C){}}e.NullExtensionService=b}),define(ye[171],_e([0,1,15,25,26,12]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const I=Promise.resolve(void 0);class P{constructor(s,m,F,S){this.startup=s,this.codeLoadingTime=m,this.activateCallTime=F,this.activateResolvedTime=S}}e.ExtensionActivationTimes=P,P.NONE=new P(!1,-1,-1,-1);class D{constructor(s){this._startup=s,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(s,m){return s===-1||m===-1?-1:m-s}build(){return new P(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class T{constructor(s,m,F,S,b,p){this.activationFailed=s,this.activationFailedError=m,this.activationTimes=F,this.module=S,this.exports=b,this.subscriptions=p}}e.ActivatedExtension=T;class R extends T{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class w extends T{constructor(){super(!1,null,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=w;class i extends T{constructor(s){super(!0,s,P.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=i;let d=class{constructor(s,m,F,S,b){this._logService=b,this._isDisposed=!1,this._registry=s,this._resolvedExtensionsSet=new Set,m.forEach(p=>this._resolvedExtensionsSet.add(t.ExtensionIdentifier.toKey(p))),this._hostExtensionsMap=new Map,F.forEach(p=>this._hostExtensionsMap.set(t.ExtensionIdentifier.toKey(p),p)),this._host=S,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(s){const m=t.ExtensionIdentifier.toKey(s);return this._activatedExtensions.has(m)}getActivatedExtension(s){const m=t.ExtensionIdentifier.toKey(s),F=this._activatedExtensions.get(m);if(!F)throw new Error("Extension `"+s.value+"` is not known or not activated");return F}activateByEvent(s,m){if(this._alreadyActivatedEvents[s])return I;const F=this._registry.getExtensionDescriptionsForActivationEvent(s);return this._activateExtensions(F.map(S=>({id:S.identifier,reason:{startup:m,extensionId:S.identifier,activationEvent:s}}))).then(()=>{this._alreadyActivatedEvents[s]=!0})}activateById(s,m){const F=this._registry.getExtensionDescription(s);if(!F)throw new Error("Extension `"+s+"` is not known");return this._activateExtensions([{id:F.identifier,reason:m}])}_handleActivateRequest(s,m,F){if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(s.id))){m[t.ExtensionIdentifier.toKey(s.id)]=s;return}const S=this._registry.getExtensionDescription(s.id);if(!S){const C=new Error(`Cannot activate unknown extension '${s.id.value}'`);this._host.onExtensionActivationError(s.id,C,new _.MissingExtensionDependency(s.id.value)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(s.id),new i(C));return}const b=typeof S.extensionDependencies=="undefined"?[]:S.extensionDependencies;let p=!0;for(let C=0,a=b.length;C<a;C++){const M=b[C];if(this._resolvedExtensionsSet.has(t.ExtensionIdentifier.toKey(M)))continue;const o=this._activatedExtensions.get(t.ExtensionIdentifier.toKey(M));if(o&&!o.activationFailed)continue;if(o&&o.activationFailed){const c=S.displayName||S.identifier.value,h=this._registry.getExtensionDescription(M),g=h&&h.displayName||M,E=new Error(`Cannot activate the '${c}' extension because its dependency '${g}' failed to activate`);E.detail=o.activationFailedError,this._host.onExtensionActivationError(S.identifier,E,null),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(S.identifier),new i(E));return}if(this._hostExtensionsMap.has(t.ExtensionIdentifier.toKey(M))){p=!1,m[t.ExtensionIdentifier.toKey(M)]={id:this._hostExtensionsMap.get(t.ExtensionIdentifier.toKey(M)),reason:s.reason};continue}const n=this._registry.getExtensionDescription(M);if(n){if(!n.main&&!n.browser)continue;p=!1,m[t.ExtensionIdentifier.toKey(M)]={id:n.identifier,reason:s.reason};continue}const u=S.displayName||S.identifier.value,f=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${M}'`);this._host.onExtensionActivationError(S.identifier,f,new _.MissingExtensionDependency(M)),this._activatedExtensions.set(t.ExtensionIdentifier.toKey(S.identifier),new i(f));return}p?m[t.ExtensionIdentifier.toKey(S.identifier)]=s:F.push(s)}_activateExtensions(s){if(s.length===0||(s=s.filter(b=>!this._activatedExtensions.has(t.ExtensionIdentifier.toKey(b.id))),s.length===0))return Promise.resolve(void 0);const m=Object.create(null),F=[];for(let b=0,p=s.length;b<p;b++)this._handleActivateRequest(s[b],m,F);for(let b=0,p=F.length;b<p;b++){const C=t.ExtensionIdentifier.toKey(F[b].id);m[C]&&delete m[C]}const S=Object.keys(m).map(b=>m[b]);return F.length===0?Promise.all(S.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(S).then(b=>this._activateExtensions(F))}_activateExtension(s,m){const F=t.ExtensionIdentifier.toKey(s);if(this._activatedExtensions.has(F))return Promise.resolve(void 0);const S=this._activatingExtensions.get(F);if(S)return S;const b=this._host.actualActivateExtension(s,m).then(void 0,p=>{const C=new Error;return p&&p.name&&(C.name=p.name),p&&p.message?C.message=`Activating extension '${s.value}' failed: ${p.message}.`:C.message=`Activating extension '${s.value}' failed: ${p}.`,p&&p.stack&&(C.stack=p.stack),this._isDisposed&&r.isCancellationError(p)?new i(p):(this._host.onExtensionActivationError(s,C,null),this._logService.error(`Activating extension ${s.value} failed due to an error:`),this._logService.error(p),new i(p))}).then(p=>{this._activatedExtensions.set(F,p),this._activatingExtensions.delete(F)});return this._activatingExtensions.set(F,b),b}};d=Be([$e(4,A.ILogService)],d),e.ExtensionsActivator=d}),define(ye[172],_e([0,1,12,28,26]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=class extends r.LogService{constructor(P,D){super(P.createLogger(D.logFile,{name:_.ExtensionHostLogFileName}))}};A=Be([$e(0,r.ILoggerService),$e(1,t.IExtHostInitDataService)],A),e.ExtHostLogService=A}),define(ye[173],_e([0,1,15]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class t{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,I)=>{this._actualOk=A,this._actualErr=I,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,r.onUnexpectedError)(A))}then(A,I){return this._ensureActual().then(A,I)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=t}),define(ye[38],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class r{constructor(T,R){this._proxyIdentifierBrand=void 0,this.isMain=T,this.sid=R,this.nid=++r.count}}e.ProxyIdentifier=r,r.count=0;const t=[];function _(D){const T=new r(!0,D);return t[T.nid]=T,T}e.createMainContextProxyIdentifier=_;function A(D){const T=new r(!1,D);return t[T.nid]=T,T}e.createExtHostContextProxyIdentifier=A;function I(D){return t[D].sid}e.getStringIdentifierForProxy=I;class P{constructor(T){this.value=T}}e.SerializableObjectWithBuffers=P}),define(ye[5],_e([0,1,55,2,38]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var I;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(b){b[b.Editable=0]="Editable",b[b.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(b){b[b.Int8Array=1]="Int8Array",b[b.Uint8Array=2]="Uint8Array",b[b.Uint8ClampedArray=3]="Uint8ClampedArray",b[b.Int16Array=4]="Int16Array",b[b.Uint16Array=5]="Uint16Array",b[b.Int32Array=6]="Int32Array",b[b.Uint32Array=7]="Uint32Array",b[b.Float32Array=8]="Float32Array",b[b.Float64Array=9]="Float64Array",b[b.BigInt64Array=10]="BigInt64Array",b[b.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var T;(function(b){b[b.Text=1]="Text",b[b.Error=2]="Error",b[b.Rich=3]="Rich"})(T=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(b){b[b.Default=0]="Default",b[b.InCenter=1]="InCenter",b[b.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",b[b.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var w;(function(b){b[b.None=0]="None",b[b.Process=1]="Process",b[b.Output=2]="Output"})(w=e.CandidatePortSource||(e.CandidatePortSource={}));var i;(function(b){b.name="$ident";function p(a,M){return Object.defineProperty(a,b.name,{value:M,enumerable:!0}),a}b.mixin=p;function C(a){return a[b.name]}b.of=C})(i=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(p){return p._id=d._n++,p}}e.IdObject=d,d._n=0;var l;(function(b){b.label="a",b.kind="b",b.detail="c",b.documentation="d",b.sortText="e",b.filterText="f",b.preselect="g",b.insertText="h",b.insertTextRules="i",b.range="j",b.commitCharacters="k",b.additionalTextEdits="l",b.command="m",b.kindModifier="n"})(l=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(b){b.defaultRanges="a",b.completions="b",b.isIncomplete="c",b.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(b){b[b.File=1]="File",b[b.Text=2]="Text",b[b.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function F(b){if(b&&b.edits)for(const p of b.edits)typeof p.resource=="object"?p.resource=t.URI.revive(p.resource):(p.newUri=t.URI.revive(p.newUri),p.oldUri=t.URI.revive(p.oldUri)),p.metadata&&p.metadata.iconPath&&(p.metadata=(0,r.revive)(p.metadata));return b}e.reviveWorkspaceEditDto=F;var S;(function(b){b[b.Workspace=0]="Workspace",b[b.TextDocument=1]="TextDocument"})(S=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,_.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,_.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,_.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,_.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,_.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,_.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,_.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,_.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,_.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,_.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,_.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,_.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,_.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,_.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,_.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,_.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,_.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,_.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,_.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,_.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,_.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,_.createMainContextProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,_.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,_.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,_.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,_.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,_.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,_.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,_.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,_.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,_.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,_.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,_.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,_.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,_.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,_.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,_.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,_.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,_.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,_.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,_.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,_.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,_.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,_.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,_.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,_.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,_.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,_.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,_.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,_.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,_.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,_.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,_.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,_.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,_.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,_.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,_.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,_.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,_.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,_.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,_.createExtHostContextProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,_.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,_.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,_.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,_.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,_.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,_.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,_.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,_.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,_.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,_.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,_.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,_.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,_.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,_.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,_.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,_.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,_.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,_.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,_.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,_.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,_.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,_.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,_.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,_.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,_.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,_.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ye[67],_e([0,1,5,4,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(P){this._onDidChangePassword=new t.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(r.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,D){return this._proxy.$getPassword(P,D)}store(P,D,T){return this._proxy.$setPassword(P,D,T)}delete(P,D){return this._proxy.$deletePassword(P,D)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,_.createDecorator)("IExtHostSecretState")}),define(ye[68],_e([0,1,3,12,5,14]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,r.createDecorator)("IExtHostApiDeprecationService");let I=class{constructor(D,T){this._extHostLogService=T,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(_.MainContext.MainThreadTelemetry)}report(D,T,R){const w=this.getUsageKey(D,T);this._reportedUsages.has(w)||(this._reportedUsages.add(w),T.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:T.identifier.value,apiId:D}))}getUsageKey(D,T){return`${D}-${T.identifier.value}`}};I=Be([$e(0,A.IExtHostRpcService),$e(1,t.ILogService)],I),e.ExtHostApiDeprecationService=I,e.NullApiDeprecationService=Object.freeze(new class{report(P,D,T){}})}),define(ye[174],_e([0,1,4,5,7,25]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class I{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new r.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(t.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,T,R,w={}){const i=A.ExtensionIdentifier.toKey(D.identifier),d=this._inFlightRequests.get(i)||[],l=[...R].sort().join(" ");let s=d.find(m=>m.scopes===l);if(s)return s.result;{const m=this._getSession(D,i,T,R,w);s={scopes:l,result:m},d.push(s),this._inFlightRequests.set(i,d);try{await m}finally{const F=d.findIndex(S=>S.scopes===l);F>-1&&(d.splice(F),this._inFlightRequests.set(i,d))}return m}}async _getSession(D,T,R,w,i={}){await this._proxy.$ensureProvider(R);const d=D.displayName||D.name;return this._proxy.$getSession(R,w,T,d,i)}async removeSession(D,T){const R=this._authenticationProviders.get(D);return R?R.provider.removeSession(T):this._proxy.$removeSession(D,T)}registerAuthenticationProvider(D,T,R,w){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:T,provider:R,options:w??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===D)||this._providers.push({id:D,label:T});const i=R.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(D,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,T,w?.supportsMultipleAccounts??!1),new _.Disposable(()=>{i.dispose(),this._authenticationProviders.delete(D);const d=this._providers.findIndex(l=>l.id===D);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.createSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.removeSession(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,T){const R=this._authenticationProviders.get(D);if(R)return Promise.resolve(R.provider.getSessions(T));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,T){return this._onDidChangeSessions.fire({provider:{id:D,label:T}}),Promise.resolve()}}e.ExtHostAuthentication=I}),define(ye[175],_e([0,1,5,14,8]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(P,D){this._extHostDocumentsAndEditors=D,this._proxy=P.getProxy(r.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const D=_.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};A=Be([$e(0,t.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(ye[176],_e([0,1,5]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class t{constructor(A){const I=A.getProxy(r.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return I.$readText()},writeText(P){return I.$writeText(P)}})}}e.ExtHostClipboard=t});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[39],_e([0,1,10,7,8,27,5,16,12,55,58,227,2,6,3,14,48,21,38,43]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let C=class{constructor(f,c){p.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Xe(this,p,f.getProxy(I.MainContext.MainThreadCommands),"f"),this._logService=c,this.converter=new a(this,h=>{const g=this._apiCommands.get(h);return g?.result===o.Void?g:void 0},c),this._argumentProcessors=[{processArgument(h){return(0,T.revive)(h)}},{processArgument(h){return(0,A.cloneAndChange)(h,function(g){if(R.Range.isIRange(g))return _.Range.to(g);if(w.Position.isIPosition(g))return _.Position.to(g);if(R.Range.isIRange(g.range)&&i.URI.isUri(g.uri))return _.location.to(g);if(g instanceof F.VSBuffer)return g.buffer.buffer;if(!Array.isArray(g))return g})}}]}registerArgumentProcessor(f){this._argumentProcessors.push(f)}registerApiCommand(f){const c=this.registerCommand(!1,f.id,async(...h)=>{const g=f.args.map((v,k)=>{if(!v.validate(h[k]))throw new Error(`Invalid argument '${v.name}' when running '${f.id}', received: ${h[k]}`);return v.convert(h[k])}),E=await this.executeCommand(f.internalId,...g);return f.result.convert(E,h,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this._apiCommands.set(f.id,f),new t.Disposable(()=>{c.dispose(),this._apiCommands.delete(f.id)})}registerCommand(f,c,h,g,E,v){if(this._logService.trace("ExtHostCommands#registerCommand",c),!c.trim().length)throw new Error("invalid id");if(this._commands.has(c))throw new Error(`command '${c}' already exists`);return this._commands.set(c,{callback:h,thisArg:g,description:E,extension:v}),f&&Ie(this,p,"f").$registerCommand(c),new t.Disposable(()=>{this._commands.delete(c)&&f&&Ie(this,p,"f").$unregisterCommand(c)})}executeCommand(f,...c){return this._logService.trace("ExtHostCommands#executeCommand",f),this._doExecuteCommand(f,c,!0)}async _doExecuteCommand(f,c,h){if(this._commands.has(f))return this._executeContributedCommand(f,c,!1);{let g=!1;const E=(0,A.cloneAndChange)(c,function(v){if(v instanceof t.Position)return _.Position.from(v);if(v instanceof t.Range)return _.Range.from(v);if(v instanceof t.Location)return _.location.from(v);if(t.NotebookRange.isNotebookRange(v))return _.NotebookRange.from(v);if(v instanceof ArrayBuffer)return g=!0,F.VSBuffer.wrap(new Uint8Array(v));if(v instanceof Uint8Array)return g=!0,F.VSBuffer.wrap(v);if(!Array.isArray(v))return v});try{const v=await Ie(this,p,"f").$executeCommand(f,g?new S.SerializableObjectWithBuffers(E):E,h);return(0,T.revive)(v)}catch(v){if(v instanceof Error&&v.message==="$executeCommand:retry")return this._doExecuteCommand(f,c,!1);throw v}}}async _executeContributedCommand(f,c,h){const g=this._commands.get(f);if(!g)throw new Error("Unknown command");let{callback:E,thisArg:v,description:k}=g;if(k)for(let x=0;x<k.args.length;x++)try{(0,r.validateConstraint)(c[x],k.args[x].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${k.args[x].name}' - ${k.args[x].description}`)}try{return await E.apply(v,c)}catch(x){if(f===this.converter.delegatingCommandId){const N=this.converter.getActualCommand(...c);N&&(f=N.command)}throw this._logService.error(x,f,g.extension?.identifier),h?new class extends Error{constructor(){super((0,b.toErrorMessage)(x));this.id=f,this.source=g.extension?.displayName??g.extension?.name}}:x}}$executeContributedCommand(f,...c){return this._logService.trace("ExtHostCommands#$executeContributedCommand",f),this._commands.has(f)?(c=c.map(h=>this._argumentProcessors.reduce((g,E)=>E.processArgument(g),h)),this._executeContributedCommand(f,c,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this._logService.trace("ExtHostCommands#getCommands",f),Ie(this,p,"f").$getCommands().then(c=>(f&&(c=c.filter(h=>h[0]!=="_")),c))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(let[c,h]of this._commands){let{description:g}=h;g&&(f[c]=g)}return Promise.resolve(f)}};p=new WeakMap,C=Be([$e(0,s.IExtHostRpcService),$e(1,D.ILogService)],C),e.ExtHostCommands=C,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class a{constructor(f,c,h){this._commands=f,this._lookupApiCommand=c,this._logService=h,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(f,c){if(!f)return;const h={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return h;const g=this._lookupApiCommand(f.command);if(g)h.id=g.internalId,h.arguments=g.args.map((E,v)=>E.convert(f.arguments&&f.arguments[v]));else if((0,P.isNonEmptyArray)(f.arguments)){const E=++this._cachIdPool;this._cache.set(E,f),c.add((0,d.toDisposable)(()=>{this._cache.delete(E),this._logService.trace("CommandsConverter#DISPOSE",E)})),h.$ident=E,h.id=this.delegatingCommandId,h.arguments=[E],this._logService.trace("CommandsConverter#CREATE",f.command,E)}return h}fromInternal(f){const c=I.ObjectIdentifier.of(f);return typeof c=="number"?this._cache.get(c):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this._cache.get(f[0])}_executeConvertedCommand(...f){const c=this.getActualCommand(...f);return this._logService.trace("CommandsConverter#EXECUTE",f[0],c?c.command:"MISSING"),c?this._commands.executeCommand(c.command,...c.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class M{constructor(f,c,h,g){this.name=f,this.description=c,this.validate=h,this.convert=g}optional(){return new M(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,c){return new M(f??this.name,c??this.description,this.validate,this.convert)}}e.ApiCommandArgument=M,M.Uri=new M("uri","Uri of a text document",u=>i.URI.isUri(u),u=>u),M.Position=new M("position","A position in a text document",u=>t.Position.isPosition(u),_.Position.from),M.Range=new M("range","A range in a text document",u=>t.Range.isRange(u),_.Range.from),M.Selection=new M("selection","A selection in a text document",u=>t.Selection.isSelection(u),_.Selection.from),M.Number=new M("number","",u=>typeof u=="number",u=>u),M.String=new M("string","",u=>typeof u=="string",u=>u),M.CallHierarchyItem=new M("item","A call hierarchy item",u=>u instanceof t.CallHierarchyItem,_.CallHierarchyItem.from),M.TypeHierarchyItem=new M("item","A type hierarchy item",u=>u instanceof t.TypeHierarchyItem,_.TypeHierarchyItem.from),M.TestItem=new M("testItem","A VS Code TestItem",u=>u instanceof m.TestItemImpl,_.TestItem.from);class o{constructor(f,c){this.description=f,this.convert=c}}e.ApiCommandResult=o,o.Void=new o("no result",u=>u);class n{constructor(f,c,h,g,E){this.id=f,this.internalId=c,this.description=h,this.args=g,this.result=E}}e.ApiCommand=n}),define(ye[177],_e([0,1,8,7,57,39,16,77]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const D=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",R(r.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,d)=>{if((0,I.isFalsyOrEmpty)(i))return;class l extends t.SymbolInformation{static to(m){const F=new l(m.name,r.SymbolKind.to(m.kind),m.containerName||"",new t.Location(d[0],r.Range.to(m.range)));return F.detail=m.detail,F.range=F.location.range,F.selectionRange=r.Range.to(m.selectionRange),F.children=m.children?m.children.map(l.to):[],F}}return i.map(l.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new A.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",R(r.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",w)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",R(r.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",R(r.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(d=>t.Position.isPosition(d)),i=>i.map(r.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(d=>{let l;for(const s of d.reverse())l=new t.SelectionRange(r.Range.to(s),l);return l}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(r.WorkspaceSymbol.to))),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",i=>i.map(r.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(!!i)return{range:r.Range.to(i.range),placeholder:i.text}})),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(!!i){if(i.rejectReason)throw new Error(i.rejectReason);return r.WorkspaceEdit.to(i)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(r.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,P.decodeSemanticTokensDto)(i);if(d.type==="full")return new t.SemanticTokens(d.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range.optional()],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(!!i)return new t.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,P.decodeSemanticTokensDto)(i);if(d.type==="full")return new t.SemanticTokens(d.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,d,l)=>{if(!i)return new t.CompletionList([]);const s=i.suggestions.map(m=>r.CompletionItem.to(m,l));return new t.CompletionList(s,i.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return r.SignatureHelp.to(i)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,d,l)=>R(s=>new t.CodeLens(r.Range.to(s.range),s.command&&l.fromInternal(s.command)))(i))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>t.Range.isRange(i),i=>t.Selection.isSelection(i)?r.Selection.from(i):r.Range.from(i)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,d,l)=>R(s=>{if(s._isSynthetic){if(!s.command)throw new Error("Synthetic code actions must have a command");return l.fromInternal(s.command)}else{const m=new t.CodeAction(s.title,s.kind?new t.CodeActionKind(s.kind):void 0);return s.edit&&(m.edit=r.WorkspaceEdit.to(s.edit)),s.command&&(m.command=l.fromInternal(s.command)),m.isPreferred=s.isPreferred,m}})(i))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(d=>new t.ColorInformation(r.Range.to(d.range),r.Color.to(d.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",i=>i instanceof t.Color,r.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:r.Range.from(i.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(r.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,d,l)=>i.map(r.InlayHint.to.bind(void 0,l)))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",R(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(d=>r.NotebookExclusiveDocumentPattern.to(d))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(r.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[r.ViewColumn.from(i),void 0]:[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[r.ViewColumn.from(i.viewColumn),r.TextEditorOpenOptions.from(i)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",i=>i.map(r.TypeHierarchyItem.to))),new A.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[A.ApiCommandArgument.TestItem],A.ApiCommandResult.Void)];class T{static register(d){D.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=T;function R(i){return d=>{if(Array.isArray(d))return d.map(i)}}function w(i){if(!Array.isArray(i))return;const d=[];for(const l of i)_.isLocationLink(l)?d.push(r.DefinitionLink.to(l)):d.push(r.location.to(l));return d}}),define(ye[178],_e([0,1,13,53,4,6,2,57,25,8,7,26,5]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function d(l,s,m){const F=l.getProxy(i.MainContext.MainThreadComments);class S{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const f=this._commentControllers.get(u.handle);return f||u}else if(u&&u.$mid===7){const f=this._commentControllers.get(u.commentControlHandle);if(!f)return u;const c=f.getCommentThread(u.commentThreadHandle);return c||u}else if(u&&u.$mid===8){const f=this._commentControllers.get(u.thread.commentControlHandle);if(!f)return u;const c=f.getCommentThread(u.thread.commentThreadHandle);return c?{thread:c,text:u.text}:u}else if(u&&u.$mid===9){const f=this._commentControllers.get(u.thread.commentControlHandle);if(!f)return u;const c=f.getCommentThread(u.thread.commentThreadHandle);if(!c)return u;let h=u.commentUniqueId,g=c.getCommentByUniqueId(h);return g||u}else if(u&&u.$mid===10){const f=this._commentControllers.get(u.thread.commentControlHandle);if(!f)return u;const c=f.getCommentThread(u.thread.commentThreadHandle);if(!c)return u;let h=u.text,g=u.commentUniqueId,E=c.getCommentByUniqueId(g);return E?(E.body=h,E):u}return u}})}createCommentController(u,f,c){const h=S.handlePool++,g=new p(u,h,f,c);this._commentControllers.set(g.handle,g);const E=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(u.identifier))||[];return E.push(g),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(u.identifier),E),g.value}$createCommentThreadTemplate(u,f,c){const h=this._commentControllers.get(u);!h||h.$createCommentThreadTemplate(f,c)}async $updateCommentThreadTemplate(u,f,c){const h=this._commentControllers.get(u);!h||h.$updateCommentThreadTemplate(f,c)}$deleteCommentThread(u,f){const c=this._commentControllers.get(u);c&&c.$deleteCommentThread(f)}$provideCommentingRanges(u,f,c){const h=this._commentControllers.get(u);if(!h||!h.commentingRangeProvider)return Promise.resolve(void 0);const g=m.getDocument(I.URI.revive(f));return(0,r.asPromise)(()=>h.commentingRangeProvider.provideCommentingRanges(g,c)).then(E=>E?E.map(v=>T.Range.from(v)):void 0)}$toggleReaction(u,f,c,h,g){const E=this._commentControllers.get(u);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,r.asPromise)(()=>{const v=E.getCommentThread(f);if(v){const k=v.getCommentByUniqueId(h.uniqueIdInThread);if(E!==void 0&&k&&E.reactionHandler)return E.reactionHandler(k,M(g))}return Promise.resolve(void 0)})}dispose(){}}S.handlePool=0;class b{constructor(u,f,c,h,g,E,v){this._commentControllerHandle=f,this._id=c,this._uri=h,this._range=g,this._comments=E,this.extensionDescription=v,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new _.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${u}.${this.handle}`),F.$createCommentThread(f,this.handle,this._id,this._uri,T.Range.from(this._range),v.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this._localDisposables.push({dispose:()=>{F.$deleteCommentThread(f,this.handle)}});const k=this;this.value={get uri(){return k.uri},get range(){return k.range},set range(x){k.range=x},get comments(){return k.comments},set comments(x){k.comments=x},get collapsibleState(){return k.collapsibleState},set collapsibleState(x){k.collapsibleState=x},get canReply(){return k.canReply},set canReply(x){k.canReply=x},get contextValue(){return k.contextValue},set contextValue(x){k.contextValue=x},get label(){return k.label},set label(x){k.label=x},dispose:()=>{k.dispose()}}}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const u=c=>Object.prototype.hasOwnProperty.call(this.modifications,c),f={};u("range")&&(f.range=T.Range.from(this._range)),u("label")&&(f.label=this.label),u("contextValue")&&(f.contextValue=this.contextValue??null),u("comments")&&(f.comments=this._comments.map(c=>C(this,c,this._commentsMap))),u("collapsibleState")&&(f.collapseState=o(this._collapseState)),u("canReply")&&(f.canReply=this.canReply),this.modifications={},F.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(u){for(let f of this._commentsMap){let c=f[0],h=f[1];if(u===h)return c}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose())}}b._handlePool=0,Be([(0,t.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class p{constructor(u,f,c,h){this._extension=u,this._handle=f,this._id=c,this._label=h,this._threads=new Map,F.$registerCommentController(this.handle,c,h);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(E){g.options=E},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(E){g.commentingRangeProvider=E},get reactionHandler(){return g.reactionHandler},set reactionHandler(E){g.reactionHandler=E},createCommentThread(E,v,k){return g.createCommentThread(E,v,k).value},dispose:()=>{g.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{F.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(u){this._commentingRangeProvider=u,F.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,F.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,F.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,f,c,h){if(typeof u=="string"){const g=new b(this.id,this.handle,u,f,c,h,this._extension);return this._threads.set(g.handle,g),g}else{const g=new b(this.id,this.handle,void 0,u,f,c,this._extension);return this._threads.set(g.handle,g),g}}$createCommentThreadTemplate(u,f){const c=new b(this.id,this.handle,void 0,I.URI.revive(u),T.Range.to(f),[],this._extension);return c.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(c.handle,c),c}$updateCommentThreadTemplate(u,f){let c=this._threads.get(u);c&&(c.range=T.Range.to(f))}$deleteCommentThread(u){let f=this._threads.get(u);f&&f.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._localDisposables.forEach(u=>u.dispose())}}function C(n,u,f){let c=f.get(u);c||(c=++n.commentHandle,f.set(u,c));const h=u.author&&u.author.iconPath?u.author.iconPath.toString():void 0;u.detail&&(0,w.checkProposedApiEnabled)(n.extensionDescription,"commentTimestamp");let g;return u.detail&&typeof u.detail!="string"?g={source:u.detail,$mid:14}:g=u.detail,{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:c,body:T.MarkdownString.from(u.body),userName:u.author.name,userIconPath:h,label:u.label,commentReactions:u.reactions?u.reactions.map(E=>a(E)):void 0,detail:g}}function a(n){return{label:n.label,iconPath:n.iconPath?T.pathOrURIToURI(n.iconPath):void 0,count:n.count,hasReacted:n.authorHasReacted}}function M(n){return{label:n.label||"",count:n.count||0,iconPath:n.iconPath?I.URI.revive(n.iconPath):"",authorHasReacted:n.hasReacted||!1}}function o(n){if(n!==void 0)switch(n){case R.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}return new S}e.createExtHostComments=d}),define(ye[91],_e([0,1,2,5,7,3,14,12,16,9,17]),function(ee,e,r,t,_,A,I,P,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let w=class Si{constructor(d,l){this._logService=l,this._provider=new Map,this._proxy=d.getProxy(t.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,l){const s=Si._handlePool++;this._provider.set(s,{provider:d,extensionId:l}),this._proxy.$registerDecorationProvider(s,l.value);const m=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(F=>{if(!F){this._proxy.$onDidChange(s,null);return}let S=(0,D.asArray)(F);if(S.length<=Si._maxEventSize){this._proxy.$onDidChange(s,S);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,S.length);const b=S.map(a=>({uri:a,rank:(0,T.count)(a.path,"/")})),p=(0,D.groupBy)(b,(a,M)=>a.rank-M.rank||(0,T.compare)(a.uri.path,M.uri.path));let C=[];e:for(let a of p){let M;for(let o of a){let n=(0,R.dirname)(o.uri.path);if(M!==n&&(M=n,C.push(o.uri)>=Si._maxEventSize))break e}}this._proxy.$onDidChange(s,C)});return new _.Disposable(()=>{m?.dispose(),this._proxy.$unregisterDecorationProvider(s),this._provider.delete(s)})}async $provideDecorations(d,l,s){if(!this._provider.has(d))return Object.create(null);const m=Object.create(null),{provider:F,extensionId:S}=this._provider.get(d);return await Promise.all(l.map(async b=>{try{const{uri:p,id:C}=b,a=await Promise.resolve(F.provideFileDecoration(r.URI.revive(p),s));if(!a)return;try{_.FileDecoration.validate(a),m[C]=[a.propagate,a.tooltip,a.badge,a.color]}catch(M){this._logService.warn(`INVALID decoration from extension '${S.value}': ${M}`)}}catch(p){this._logService.error(p)}})),m}};w._handlePool=0,w._maxEventSize=250,w=Be([$e(0,I.IExtHostRpcService),$e(1,P.ILogService)],w),e.ExtHostDecorations=w,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[179],_e([0,1,118,80,2,5,7,8,4,12,22,30]),function(ee,e,r,t,_,A,I,P,D,T,R,w){"use strict";var i,d,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class s{constructor(S,b,p,C,a,M){this._name=S,this._owner=b,this._maxDiagnosticsPerFile=p,i.set(this,void 0),d.set(this,void 0),l.set(this,void 0),this._isDisposed=!1,Xe(this,l,new R.ResourceMap(o=>C.getComparisonKey(o)),"f"),Xe(this,i,a,"f"),Xe(this,d,M,"f")}dispose(){this._isDisposed||(Ie(this,d,"f").fire([...Ie(this,l,"f").keys()]),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner),Ie(this,l,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(S,b){if(!S){this.clear();return}this._checkDisposed();let p=[];if(_.URI.isUri(S)){if(!b){this.delete(S);return}Ie(this,l,"f").set(S,b.slice()),p=[S]}else if(Array.isArray(S)){p=[];let a;S=[...S].sort(s._compareIndexedTuplesByUri);for(const M of S){const[o,n]=M;if((!a||o.toString()!==a.toString())&&(a&&Ie(this,l,"f").get(a).length===0&&Ie(this,l,"f").delete(a),a=o,p.push(o),Ie(this,l,"f").set(o,[])),n){const u=Ie(this,l,"f").get(o);u&&u.push(...n)}else{const u=Ie(this,l,"f").get(o);u&&(u.length=0)}}}if(Ie(this,d,"f").fire(p),!Ie(this,i,"f"))return;const C=[];for(let a of p){let M=[];const o=Ie(this,l,"f").get(a);if(o)if(o.length>this._maxDiagnosticsPerFile){M=[];const n=[I.DiagnosticSeverity.Error,I.DiagnosticSeverity.Warning,I.DiagnosticSeverity.Information,I.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(let f of o)if(f.severity===n[u]&&M.push(P.Diagnostic.from(f))===this._maxDiagnosticsPerFile)break e;M.push({severity:t.MarkerSeverity.Info,message:(0,r.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:M[M.length-1].startLineNumber,startColumn:M[M.length-1].startColumn,endLineNumber:M[M.length-1].endLineNumber,endColumn:M[M.length-1].endColumn})}else M=o.map(n=>P.Diagnostic.from(n));C.push([a,M])}Ie(this,i,"f").$changeMany(this._owner,C)}delete(S){this._checkDisposed(),Ie(this,d,"f").fire([S]),Ie(this,l,"f").delete(S),Ie(this,i,"f")&&Ie(this,i,"f").$changeMany(this._owner,[[S,void 0]])}clear(){this._checkDisposed(),Ie(this,d,"f").fire([...Ie(this,l,"f").keys()]),Ie(this,l,"f").clear(),Ie(this,i,"f")&&Ie(this,i,"f").$clear(this._owner)}forEach(S,b){this._checkDisposed();for(let p of Ie(this,l,"f").keys())S.apply(b,[p,this.get(p),this])}get(S){this._checkDisposed();const b=Ie(this,l,"f").get(S);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(S){return this._checkDisposed(),Array.isArray(Ie(this,l,"f").get(S))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(S,b){return S[0].toString()<b[0].toString()?-1:S[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=s,i=new WeakMap,d=new WeakMap,l=new WeakMap;let m=class si{constructor(S,b,p){this._logService=b,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:C=>C.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,si._mapper),this._proxy=S.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(S){const b=new R.ResourceMap;for(const p of S)b.set(p,p);return{uris:Object.freeze(Array.from(b.values()))}}createDiagnosticCollection(S,b){const{_collections:p,_proxy:C,_onDidChangeDiagnostics:a,_logService:M,_fileSystemInfoService:o}=this,n=new class{$changeMany(c,h){C.$changeMany(c,h),M.trace("[DiagnosticCollection] change many (extension, owner, uris)",S.value,c,h.length===0?"CLEARING":h)}$clear(c){C.$clear(c),M.trace("[DiagnosticCollection] remove all (extension, owner)",S.value,c)}dispose(){C.dispose()}};let u;if(!b)b="_generated_diagnostic_collection_name_#"+si._idPool++,u=b;else if(!p.has(b))u=b;else{this._logService.warn(`DiagnosticCollection with name '${b}' does already exist.`);do u=b+si._idPool++;while(p.has(u))}return new class extends s{constructor(){super(b,u,si._maxDiagnosticsPerFile,o.extUri,n,a);p.set(u,this)}dispose(){super.dispose(),p.delete(u)}}}getDiagnostics(S){if(S)return this._getDiagnostics(S);{const b=new Map,p=[];for(const C of this._collections.values())C.forEach((a,M)=>{let o=b.get(a.toString());typeof o=="undefined"&&(o=p.length,b.set(a.toString(),o),p.push([a,[]])),p[o][1]=p[o][1].concat(...M)});return p}}_getDiagnostics(S){let b=[];for(let p of this._collections.values())p.has(S)&&(b=b.concat(p.get(S)));return b}$acceptMarkersChange(S){if(!this._mirrorCollection){const b="_generated_mirror",p=new s(b,b,si._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(b,p),this._mirrorCollection=p}for(const[b,p]of S)this._mirrorCollection.set(_.URI.revive(b),p.map(P.Diagnostic.to))}};m._idPool=0,m._maxDiagnosticsPerFile=1e3,m=Be([$e(1,T.ILogService),$e(2,w.IExtHostFileSystemInfo)],m),e.ExtHostDiagnostics=m}),define(ye[180],_e([0,1,2,5]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class _{constructor(I){this._proxy=I.getProxy(t.MainContext.MainThreadDialogs)}showOpenDialog(I){return this._proxy.$showOpenDialog(I).then(P=>P?P.map(D=>r.URI.revive(D)):void 0)}showSaveDialog(I){return this._proxy.$showSaveDialog(I).then(P=>P?r.URI.revive(P):void 0)}}e.ExtHostDialogs=_}),define(ye[181],_e([0,1,15,2,7,5,11,20,9]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class T{constructor(w,i,d){this._documentsAndEditors=i,this._logService=d,this._documentContentProviders=new Map,this._proxy=w.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,i){if(Object.keys(I.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const d=T._handlePool++;this._documentContentProviders.set(d,i),this._proxy.$registerTextContentProvider(d,w);let l;return typeof i.onDidChange=="function"&&(l=i.onDidChange(s=>{if(s.scheme!==w){this._logService.warn(`Provider for scheme '${w}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(s)&&this.$provideTextDocumentContent(d,s).then(m=>{if(!m&&typeof m!="string")return;const F=this._documentsAndEditors.getDocument(s);if(!F)return;const S=(0,D.splitLines)(m);if(!F.equalLines(S))return this._proxy.$onVirtualDocumentChange(s,m)},r.onUnexpectedError)})),new _.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(w,i){const d=this._documentContentProviders.get(w);return d?Promise.resolve(d.provideTextDocumentContent(t.URI.revive(i),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${i.scheme}`))}}e.ExtHostDocumentContentProvider=T,T._handlePool=0}),define(ye[182],_e([0,1,4,6,2,5,84,8,10,27,7]),function(ee,e,r,t,_,A,I,P,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(d,l){this._onDidAddDocument=new r.Emitter,this._onDidRemoveDocument=new r.Emitter,this._onDidChangeDocument=new r.Emitter,this._onDidSaveDocument=new r.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new t.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=l,this._documentsAndEditors.onDidRemoveDocuments(s=>{for(const m of s)this._onDidRemoveDocument.fire(m.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(s=>{for(const m of s)this._onDidAddDocument.fire(m.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const l=this._documentsAndEditors.getDocument(d);if(l)return l}getDocument(d){const l=this.getDocumentData(d);if(!l?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return l.document}ensureDocumentData(d){const l=this._documentsAndEditors.getDocument(d);if(l)return Promise.resolve(l);let s=this._documentLoader.get(d.toString());return s||(s=this._proxy.$tryOpenDocument(d).then(m=>{this._documentLoader.delete(d.toString());const F=_.URI.revive(m);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(F))},m=>(this._documentLoader.delete(d.toString()),Promise.reject(m))),this._documentLoader.set(d.toString(),s)),s}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(l=>_.URI.revive(l))}$acceptModelLanguageChanged(d,l){const s=_.URI.revive(d),m=this._documentsAndEditors.getDocument(s);if(!m)throw new Error("unknown document");this._onDidRemoveDocument.fire(m.document),m._acceptLanguageId(l),this._onDidAddDocument.fire(m.document)}$acceptModelSaved(d){const l=_.URI.revive(d),s=this._documentsAndEditors.getDocument(l);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(s.document)}$acceptDirtyStateChanged(d,l){const s=_.URI.revive(d),m=this._documentsAndEditors.getDocument(s);if(!m)throw new Error("unknown document");m._acceptIsDirty(l),this._onDidChangeDocument.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,l,s){const m=_.URI.revive(d),F=this._documentsAndEditors.getDocument(m);if(!F)throw new Error("unknown document");F._acceptIsDirty(s),F.onEvents(l);let S;l.isUndoing?S=R.TextDocumentChangeReason.Undo:l.isRedoing&&(S=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,T.deepFreeze)({document:F.document,contentChanges:l.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:S}))}setWordDefinitionFor(d,l){(0,I.setWordDefinitionFor)(d,l)}}e.ExtHostDocuments=w}),define(ye[49],_e([0,1,42,4,6,2,3,5,84,14,90,8,12,22,11,157,228]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class F{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let S=class{constructor(p,C){this._extHostRpc=p,this._logService=C,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new t.Emitter,this._onDidRemoveDocuments=new t.Emitter,this._onDidChangeVisibleTextEditors=new t.Emitter,this._onDidChangeActiveTextEditor=new t.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const C=[],a=[],M=[];if(p.removedDocuments)for(const o of p.removedDocuments){const n=A.URI.revive(o),u=this._documents.get(n);u?.unref()&&(this._documents.delete(n),C.push(u.value))}if(p.addedDocuments)for(const o of p.addedDocuments){const n=A.URI.revive(o.uri);let u=this._documents.get(n);if(u&&n.scheme!==l.Schemas.vscodeNotebookCell&&n.scheme!==l.Schemas.vscodeInteractiveInput)throw new Error(`document '${n} already exists!'`);u||(u=new F(new D.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,o.lines,o.EOL,o.versionId,o.languageId,o.isDirty,o.notebook)),this._documents.set(n,u),a.push(u.value)),u.ref()}if(p.removedEditors)for(const o of p.removedEditors){const n=this._editors.get(o);this._editors.delete(o),n&&M.push(n)}if(p.addedEditors)for(const o of p.addedEditors){const n=A.URI.revive(o.documentUri);r.ok(this._documents.has(n),`document '${n}' does not exist`),r.ok(!this._editors.has(o.id),`editor '${o.id}' already exists!`);const u=this._documents.get(n).value,f=new R.ExtHostTextEditor(o.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new m.Lazy(()=>u.document),o.selections.map(w.Selection.to),o.options,o.visibleRanges.map(c=>w.Range.to(c)),typeof o.editorPosition=="number"?w.ViewColumn.to(o.editorPosition):void 0);this._editors.set(o.id,f)}p.newActiveEditor!==void 0&&(r.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,_.dispose)(C),(0,_.dispose)(M),p.removedDocuments&&this._onDidRemoveDocuments.fire(C),p.addedDocuments&&this._onDidAddDocuments.fire(a),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(o=>o.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return s.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const C=this._editors.get(this._activeEditorId);return p?C:C?.value}allEditors(){return[...this._editors.values()]}};S=Be([$e(0,T.IExtHostRpcService),$e(1,i.ILogService)],S),e.ExtHostDocumentsAndEditors=S,e.IExtHostDocumentsAndEditors=(0,I.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[69],_e([0,1,8,5,2,4,3,14,13]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,I.createDecorator)("IExtHostEditorTabs");let T=class{constructor(w){this._onDidChangeTabs=new A.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._onDidChangeActiveTab=new A.Emitter,this.onDidChangeActiveTab=this._onDidChangeActiveTab.event,this._tabs=[],this._proxy=w.getProxy(t.MainContext.MainThreadEditorTabs)}get tabs(){return this._tabs}get activeTab(){return this._activeTab}$acceptEditorTabs(w){let i=-1;this._tabs=w.map((l,s)=>(l.isActive&&(i=s),Object.freeze({label:l.label,viewColumn:r.ViewColumn.to(l.viewColumn),index:s,resource:_.URI.revive(l.resource),additionalResourcesAndViewIds:l.additionalResourcesAndViewIds.map(({resource:m,viewId:F})=>({resource:_.URI.revive(m),viewId:F})),viewId:l.editorId,isActive:l.isActive,move:async(m,F)=>{this._proxy.$moveTab(l,m,r.ViewColumn.from(F)),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)},close:async()=>{await this._proxy.$closeTab(l),await(0,D.raceTimeout)(A.Event.toPromise(this._onDidChangeTabs.event),1e3)}}))),this._tabs=this._tabs.sort((l,s)=>l.viewColumn===s.viewColumn?l.index-s.index:l.viewColumn-s.viewColumn);const d=this._activeTab;this._activeTab=i===-1?void 0:this._tabs[i],this._activeTab!==d&&this._onDidChangeActiveTab.fire(this._activeTab),this._onDidChangeTabs.fire(this._tabs)}};T=Be([$e(0,P.IExtHostRpcService)],T),e.ExtHostEditorTabs=T}),define(ye[183],_e([0,1,2,5,6,7,8,229,9,21,26]),function(ee,e,r,t,_,A,I,P,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this._schemes=[]}add(l){this._stateMachine=void 0,this._schemes.push(l)}delete(l){const s=this._schemes.indexOf(l);s>=0&&(this._schemes.splice(s,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const l=this._schemes.sort(),s=[];let m,F,S=14,b=14;for(const p of l){let C=m?(0,D.commonPrefixLength)(m,p):0;for(C===0?F=1:F=b;C<p.length;C++)C+1===p.length?(S=b,b=9):b+=1,s.push([F,p.toUpperCase().charCodeAt(C),b]),s.push([F,p.toLowerCase().charCodeAt(C),b]),F=b;m=p,b=S}s.push([9,58,10]),s.push([10,47,12]),this._stateMachine=new P.StateMachine(s)}}provideDocumentLinks(l){this._initStateMachine();const s=[],m=P.LinkComputer.computeLinks({getLineContent(F){return l.lineAt(F-1).text},getLineCount(){return l.lineCount}},this._stateMachine);for(const F of m){const S=I.DocumentLink.to(F);S.target&&s.push(S)}return s}}class i{constructor(l,s){this._extHostLanguageFeatures=s,this._linkProvider=new w,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=l.getProxy(t.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(l,s,m,F={}){if(this._registeredSchemes.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(l,"*",this._linkProvider));const S=this._handlePool++;this._linkProvider.add(s),this._registeredSchemes.add(s),this._fsProvider.set(S,m);let b=2;F.isCaseSensitive&&(b+=1024),F.isReadonly&&(b+=2048),typeof m.copy=="function"&&(b+=8),typeof m.open=="function"&&typeof m.close=="function"&&typeof m.read=="function"&&typeof m.write=="function"&&((0,R.checkProposedApiEnabled)(l,"fsChunks"),b+=4),this._proxy.$registerFileSystemProvider(S,s,b).catch(C=>{console.error(`FAILED to register filesystem provider of ${l.identifier.value}-extension for the scheme ${s}`),console.error(C)});const p=m.onDidChangeFile(C=>{const a=[];for(const M of C){let{uri:o,type:n}=M;if(o.scheme!==s)continue;let u;switch(n){case A.FileChangeType.Changed:u=0;break;case A.FileChangeType.Created:u=1;break;case A.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:o,type:u})}this._proxy.$onFileSystemChange(S,a)});return(0,_.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(s),this._registeredSchemes.delete(s),this._fsProvider.delete(S),this._proxy.$unregisterProvider(S)})}static _asIStat(l){const{type:s,ctime:m,mtime:F,size:S,permissions:b}=l;return{type:s,ctime:m,mtime:F,size:S,permissions:b}}$stat(l,s){return Promise.resolve(this._getFsProvider(l).stat(r.URI.revive(s))).then(m=>i._asIStat(m))}$readdir(l,s){return Promise.resolve(this._getFsProvider(l).readDirectory(r.URI.revive(s)))}$readFile(l,s){return Promise.resolve(this._getFsProvider(l).readFile(r.URI.revive(s))).then(m=>T.VSBuffer.wrap(m))}$writeFile(l,s,m,F){return Promise.resolve(this._getFsProvider(l).writeFile(r.URI.revive(s),m.buffer,F))}$delete(l,s,m){return Promise.resolve(this._getFsProvider(l).delete(r.URI.revive(s),m))}$rename(l,s,m,F){return Promise.resolve(this._getFsProvider(l).rename(r.URI.revive(s),r.URI.revive(m),F))}$copy(l,s,m,F){const S=this._getFsProvider(l);if(!S.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(S.copy(r.URI.revive(s),r.URI.revive(m),F))}$mkdir(l,s){return Promise.resolve(this._getFsProvider(l).createDirectory(r.URI.revive(s)))}$watch(l,s,m,F){const S=this._getFsProvider(l).watch(r.URI.revive(m),F);this._watches.set(s,S)}$unwatch(l,s){const m=this._watches.get(s);m&&(m.dispose(),this._watches.delete(s))}$open(l,s,m){const F=this._getFsProvider(l);if(!F.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(F.open(r.URI.revive(s),m))}$close(l,s){const m=this._getFsProvider(l);if(!m.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(m.close(s))}$read(l,s,m,F){const S=this._getFsProvider(l);if(!S.read)throw new Error('FileSystemProvider does not implement "read"');const b=T.VSBuffer.alloc(F);return Promise.resolve(S.read(s,m,b.buffer,0,F)).then(p=>b.slice(0,p))}$write(l,s,m,F){const S=this._getFsProvider(l);if(!S.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(S.write(s,m,F.buffer,0,F.byteLength))}_getFsProvider(l){const s=this._fsProvider.get(l);if(!s){const m=new Error;throw m.name="ENOPRO",m.message="no provider",m}return s}}e.ExtHostFileSystem=i}),define(ye[50],_e([0,1,5,46,7,21,3,14,30,6]),function(ee,e,r,t,_,A,I,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Wt{constructor(i,d){this._fileSystemProvider=new Map,this._proxy=i.getProxy(r.MainContext.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(s){try{const m=l._fileSystemProvider.get(s.scheme);if(!m)return await l._proxy.$stat(s);await l._proxy.$ensureActivation(s.scheme);const F=await m.stat(s);return{type:F.type,ctime:F.ctime,mtime:F.mtime,size:F.size,permissions:F.permissions}}catch(m){Wt._handleError(m)}},async readDirectory(s){try{const m=l._fileSystemProvider.get(s.scheme);return m?(await l._proxy.$ensureActivation(s.scheme),(await m.readDirectory(s)).slice()):await l._proxy.$readdir(s)}catch(m){return Wt._handleError(m)}},async createDirectory(s){try{return await l._proxy.$mkdir(s)}catch(m){return Wt._handleError(m)}},async readFile(s){try{const m=l._fileSystemProvider.get(s.scheme);return m?(await l._proxy.$ensureActivation(s.scheme),(await m.readFile(s)).slice()):(await l._proxy.$readFile(s)).buffer}catch(m){return Wt._handleError(m)}},async writeFile(s,m){try{return await l._proxy.$writeFile(s,A.VSBuffer.wrap(m))}catch(F){return Wt._handleError(F)}},async delete(s,m){try{const F=l._fileSystemProvider.get(s.scheme);return F?(await l._proxy.$ensureActivation(s.scheme),await F.delete(s,{recursive:!1,...m})):await l._proxy.$delete(s,{recursive:!1,useTrash:!1,...m})}catch(F){return Wt._handleError(F)}},async rename(s,m,F){try{return await l._proxy.$rename(s,m,{overwrite:!1,...F})}catch(S){return Wt._handleError(S)}},async copy(s,m,F){try{return await l._proxy.$copy(s,m,{overwrite:!1,...F})}catch(S){return Wt._handleError(S)}},isWritableFileSystem(s){const m=d.getCapabilities(s);if(typeof m=="number")return!(m&2048)}})}static _handleError(i){if(i instanceof _.FileSystemError)throw i;if(!(i instanceof Error))throw new _.FileSystemError(String(i));if(i.name==="ENOPRO")throw _.FileSystemError.Unavailable(i.message);switch(i.name){case t.FileSystemProviderErrorCode.FileExists:throw _.FileSystemError.FileExists(i.message);case t.FileSystemProviderErrorCode.FileNotFound:throw _.FileSystemError.FileNotFound(i.message);case t.FileSystemProviderErrorCode.FileNotADirectory:throw _.FileSystemError.FileNotADirectory(i.message);case t.FileSystemProviderErrorCode.FileIsADirectory:throw _.FileSystemError.FileIsADirectory(i.message);case t.FileSystemProviderErrorCode.NoPermissions:throw _.FileSystemError.NoPermissions(i.message);case t.FileSystemProviderErrorCode.Unavailable:throw _.FileSystemError.Unavailable(i.message);default:throw new _.FileSystemError(i.message,i.name)}}addFileSystemProvider(i,d){return this._fileSystemProvider.set(i,d),(0,T.toDisposable)(()=>this._fileSystemProvider.delete(i))}};R=Be([$e(0,P.IExtHostRpcService),$e(1,D.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,I.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[184],_e([0,1,4,29,2,5,8,7]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(w,i,d,l,s,m,F,S){this._onDidCreate=new r.Emitter,this._onDidChange=new r.Emitter,this._onDidDelete=new r.Emitter;const b=this.ensureWatching(w,d,s);this._config=0,m&&(this._config+=1),F&&(this._config+=2),S&&(this._config+=4);const p=(0,t.parse)(s),C=typeof s=="string",a=l(M=>{if(!m)for(let o of M.created){const n=_.URI.revive(o);p(n.fsPath)&&(!C||i.getWorkspaceFolder(n))&&this._onDidCreate.fire(n)}if(!F)for(let o of M.changed){const n=_.URI.revive(o);p(n.fsPath)&&(!C||i.getWorkspaceFolder(n))&&this._onDidChange.fire(n)}if(!S)for(let o of M.deleted){const n=_.URI.revive(o);p(n.fsPath)&&(!C||i.getWorkspaceFolder(n))&&this._onDidDelete.fire(n)}});this._disposable=P.Disposable.from(b,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(w,i,d){let l=P.Disposable.from();if(typeof d=="string")return l;const s=w.getProxy(A.MainContext.MainThreadFileSystem);let m=!1;(d.pattern.includes(t.GLOBSTAR)||d.pattern.includes(t.GLOB_SPLIT))&&(m=!0);const F=Math.random();return s.$watch(i.identifier.value,F,d.baseUri,{recursive:m,excludes:[]}),P.Disposable.from({dispose:()=>s.$unwatch(F)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class T{constructor(w,i,d){this._mainContext=w,this._logService=i,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new r.Emitter,this._onDidRenameFile=new r.Emitter,this._onDidCreateFile=new r.Emitter,this._onDidDeleteFile=new r.Emitter,this._onWillRenameFile=new r.AsyncEmitter,this._onWillCreateFile=new r.AsyncEmitter,this._onWillDeleteFile=new r.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(w,i,d,l,s,m){return new D(this._mainContext,w,i,this._onFileSystemEvent.event,I.GlobPattern.from(d),l,s,m)}$onFileEvent(w){this._onFileSystemEvent.fire(w)}$onDidRunFileOperation(w,i){switch(w){case 2:this._onDidRenameFile.fire(Object.freeze({files:i.map(d=>({oldUri:_.URI.revive(d.source),newUri:_.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:i.map(d=>_.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:i.map(d=>_.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(w){return this._createWillExecuteEvent(w,this._onWillRenameFile)}getOnWillCreateFileEvent(w){return this._createWillExecuteEvent(w,this._onWillCreateFile)}getOnWillDeleteFileEvent(w){return this._createWillExecuteEvent(w,this._onWillDeleteFile)}_createWillExecuteEvent(w,i){return(d,l,s)=>{const m=function(S){d.call(l,S)};return m.extension=w,i.event(m,void 0,s)}}async $onWillRunFileOperation(w,i,d,l){switch(w){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:i.map(s=>({oldUri:_.URI.revive(s.source),newUri:_.URI.revive(s.target)}))},d,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:i.map(s=>_.URI.revive(s.target))},d,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:i.map(s=>_.URI.revive(s.target))},d,l)}}async _fireWillEvent(w,i,d,l){const s=new Set,m=[];if(await w.fireAsync(i,l,async(S,b)=>{const p=Date.now(),C=await Promise.resolve(S);C instanceof P.WorkspaceEdit&&(m.push(C),s.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-p>d&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),l.isCancellationRequested||m.length===0)return;const F={edits:[]};for(let S of m){let{edits:b}=I.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);F.edits=F.edits.concat(b)}return{edit:F,extensionNames:Array.from(s)}}}e.ExtHostFileSystemEventService=T}),define(ye[185],_e([0,1,2,39]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class _{constructor(I,P,D,T){this._extHostNotebooks=P,this._textDocumentsAndEditors=D,this._commands=T;const R=new t.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new t.ApiCommandArgument("showOptions","Show Options",w=>!0,w=>w),new t.ApiCommandArgument("resource","Interactive resource Uri",w=>!0,w=>w),new t.ApiCommandArgument("controllerId","Notebook controller Id",w=>!0,w=>w),new t.ApiCommandArgument("title","Interactive editor title",w=>!0,w=>w)],new t.ApiCommandResult("Notebook and input URI",w=>{if(w.notebookEditorId!==void 0){const i=this._extHostNotebooks.getEditorById(w.notebookEditorId);return{notebookUri:r.URI.revive(w.notebookUri),inputUri:r.URI.revive(w.inputUri),notebookEditor:i.apiEditor}}return{notebookUri:r.URI.revive(w.notebookUri),inputUri:r.URI.revive(w.inputUri)}}));this._commands.registerApiCommand(R)}$willAddInteractiveDocument(I,P,D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:D,uri:I,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(r.URI.revive(T))?.apiNotebook}]})}$willRemoveInteractiveDocument(I,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[I]})}}e.ExtHostInteractive=_}),define(ye[186],_e([0,1,6,5]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class _{constructor(I){this._handlePool=0,this._proxy=I.getProxy(t.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(I){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,I),(0,r.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=_}),define(ye[187],_e([0,1,2,27,8,7,5,9,58,16,10,230,20,6,77,54,62,188,15,4,13]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class C{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentSymbols(H,K){const z=this._documents.getDocument(H),j=await this._provider.provideDocumentSymbols(z,K);if(!(0,T.isFalsyOrEmpty)(j))return j[0]instanceof A.DocumentSymbol?j.map(_.DocumentSymbol.from):C._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(H){H=H.slice(0).sort((j,Y)=>{let ae=j.location.range.start.compareTo(Y.location.range.start);return ae===0&&(ae=Y.location.range.end.compareTo(j.location.range.end)),ae});const K=[],z=[];for(const j of H){const Y={name:j.name||"!!MISSING: name!!",kind:_.SymbolKind.from(j.kind),tags:j.tags?.map(_.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:_.Range.from(j.location.range),selectionRange:_.Range.from(j.location.range),children:[]};for(;;){if(z.length===0){z.push(Y),K.push(Y);break}const ae=z[z.length-1];if(D.Range.containsRange(ae.range,Y.range)&&!D.Range.equalsRange(ae.range,Y.range)){ae.children&&ae.children.push(Y),z.push(Y);break}z.pop()}}return K}}class a{constructor(H,K,z){this._documents=H,this._commands=K,this._provider=z,this._cache=new m.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,K){const z=this._documents.getDocument(H),j=await this._provider.provideCodeLenses(z,K);if(!j||K.isCancellationRequested)return;const Y=this._cache.add(j),ae=new d.DisposableStore;this._disposables.set(Y,ae);const Se={cacheId:Y,lenses:[]};for(let xe=0;xe<j.length;xe++)Se.lenses.push({cacheId:[Y,xe],range:_.Range.from(j[xe].range),command:this._commands.toInternal(j[xe].command,ae)});return Se}async resolveCodeLens(H,K){const z=H.cacheId&&this._cache.get(...H.cacheId);if(!z)return;let j;if(typeof this._provider.resolveCodeLens!="function"||z.isResolved?j=z:j=await this._provider.resolveCodeLens(z,K),j||(j=z),K.isCancellationRequested)return;const Y=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!Y)return H.command=this._commands.toInternal(j.command??a._badCmd,Y),H}releaseCodeLenses(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function M(tt){return Array.isArray(tt)?tt.map(_.DefinitionLink.from):tt?[_.DefinitionLink.from(tt)]:[]}class o{constructor(H,K){this._documents=H,this._provider=K}async provideDefinition(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideDefinition(j,Y,z);return M(ae)}}class n{constructor(H,K){this._documents=H,this._provider=K}async provideDeclaration(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideDeclaration(j,Y,z);return M(ae)}}class u{constructor(H,K){this._documents=H,this._provider=K}async provideImplementation(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideImplementation(j,Y,z);return M(ae)}}class f{constructor(H,K){this._documents=H,this._provider=K}async provideTypeDefinition(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideTypeDefinition(j,Y,z);return M(ae)}}class c{constructor(H,K){this._documents=H,this._provider=K}async provideHover(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideHover(j,Y,z);if(!(!ae||(0,T.isFalsyOrEmpty)(ae.contents)))return ae.range||(ae.range=j.getWordRangeAtPosition(Y)),ae.range||(ae.range=new A.Range(Y,Y)),_.Hover.from(ae)}}class h{constructor(H,K){this._documents=H,this._provider=K}async provideEvaluatableExpression(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideEvaluatableExpression(j,Y,z);if(ae)return _.EvaluatableExpression.from(ae)}}class g{constructor(H,K){this._documents=H,this._provider=K}async provideInlineValues(H,K,z,j){const Y=this._documents.getDocument(H),ae=await this._provider.provideInlineValues(Y,_.Range.to(K),_.InlineValueContext.to(z),j);if(Array.isArray(ae))return ae.map(Se=>_.InlineValue.from(Se))}}class E{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentHighlights(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideDocumentHighlights(j,Y,z);if(Array.isArray(ae))return ae.map(_.DocumentHighlight.from)}}class v{constructor(H,K){this._documents=H,this._provider=K}async provideLinkedEditingRanges(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.provideLinkedEditingRanges(j,Y,z);if(ae&&Array.isArray(ae.ranges))return{ranges:(0,T.coalesce)(ae.ranges.map(_.Range.from)),wordPattern:ae.wordPattern}}}class k{constructor(H,K){this._documents=H,this._provider=K}async provideReferences(H,K,z,j){const Y=this._documents.getDocument(H),ae=_.Position.to(K),Se=await this._provider.provideReferences(Y,ae,z,j);if(Array.isArray(Se))return Se.map(_.location.from)}}class x{constructor(H,K,z,j,Y,ae,Se){this._documents=H,this._commands=K,this._diagnostics=z,this._provider=j,this._logService=Y,this._extension=ae,this._apiDeprecation=Se,this._cache=new m.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(H,K,z,j){const Y=this._documents.getDocument(H),ae=w.Selection.isISelection(K)?_.Selection.to(K):_.Range.to(K),Se=[];for(const Je of this._diagnostics.getDiagnostics(H))if(ae.intersection(Je.range)&&Se.push(Je)>x._maxCodeActionsPerFile)break;const xe={diagnostics:Se,only:z.only?new A.CodeActionKind(z.only):void 0,triggerKind:_.CodeActionTriggerKind.to(z.trigger)},Ve=await this._provider.provideCodeActions(Y,ae,xe,j);if(!(0,T.isNonEmptyArray)(Ve)||j.isCancellationRequested)return;const Qe=this._cache.add(Ve),nt=new d.DisposableStore;this._disposables.set(Qe,nt);const rt=[];for(let Je=0;Je<Ve.length;Je++){const Ze=Ve[Je];!Ze||(x._isCommand(Ze)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:Ze.title,command:this._commands.toInternal(Ze,nt)})):(xe.only&&(Ze.kind?xe.only.contains(Ze.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${xe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[Qe,Je],title:Ze.title,command:Ze.command&&this._commands.toInternal(Ze.command,nt),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(_.Diagnostic.from),edit:Ze.edit&&_.WorkspaceEdit.from(Ze.edit),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})))}return{cacheId:Qe,actions:rt}}async resolveCodeAction(H,K){const[z,j]=H,Y=this._cache.get(z,j);if(!Y||x._isCommand(Y)||!this._provider.resolveCodeAction)return;const ae=await this._provider.resolveCodeAction(Y,K)??Y;return ae?.edit?_.WorkspaceEdit.from(ae.edit):void 0}releaseCodeActions(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}x._maxCodeActionsPerFile=1e3;class N{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentFormattingEdits(H,K,z){const j=this._documents.getDocument(H),Y=await this._provider.provideDocumentFormattingEdits(j,K,z);if(Array.isArray(Y))return Y.map(_.TextEdit.from)}}class y{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeFormattingEdits(H,K,z,j){const Y=this._documents.getDocument(H),ae=_.Range.to(K),Se=await this._provider.provideDocumentRangeFormattingEdits(Y,ae,z,j);if(Array.isArray(Se))return Se.map(_.TextEdit.from)}}class L{constructor(H,K){this._documents=H,this._provider=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(H,K,z,j,Y){const ae=this._documents.getDocument(H),Se=_.Position.to(K),xe=await this._provider.provideOnTypeFormattingEdits(ae,Se,z,j,Y);if(Array.isArray(xe))return xe.map(_.TextEdit.from)}}class W{constructor(H,K){this._provider=H,this._logService=K,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(H,K){const z=I.IdObject.mixin({symbols:[]}),j=await this._provider.provideWorkspaceSymbols(H,K);if((0,T.isNonEmptyArray)(j))for(const Y of j){if(!Y)continue;if(!Y.name){this._logService.warn("INVALID SymbolInformation, lacks name",Y);continue}const ae=I.IdObject.mixin(_.WorkspaceSymbol.from(Y));this._symbolCache.set(ae._id,Y),z.symbols.push(ae)}return z.symbols.length>0&&this._resultCache.set(z._id,[z.symbols[0]._id,z.symbols[z.symbols.length-1]._id]),z}async resolveWorkspaceSymbol(H,K){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const z=this._symbolCache.get(H._id);if(z){const j=await this._provider.resolveWorkspaceSymbol(z,K);return j&&(0,t.mixin)(H,_.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(H){const K=this._resultCache.get(H);if(K){for(let[z,j]=K;z<=j;z++)this._symbolCache.delete(z);this._resultCache.delete(H)}}}class B{constructor(H,K,z){this._documents=H,this._provider=K,this._logService=z}static supportsResolving(H){return typeof H.prepareRename=="function"}async provideRenameEdits(H,K,z,j){const Y=this._documents.getDocument(H),ae=_.Position.to(K);try{const Se=await this._provider.provideRenameEdits(Y,ae,z,j);return Se?_.WorkspaceEdit.from(Se):void 0}catch(Se){const xe=B._asMessage(Se);return xe?{rejectReason:xe,edits:void 0}:Promise.reject(Se)}}async resolveRenameLocation(H,K,z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(H),Y=_.Position.to(K);try{const ae=await this._provider.prepareRename(j,Y,z);let Se,xe;if(A.Range.isRange(ae)?(Se=ae,xe=j.getText(ae)):(0,R.isObject)(ae)&&(Se=ae.range,xe=ae.placeholder),!Se||!xe)return;if(Se.start.line>Y.line||Se.end.line<Y.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:_.Range.from(Se),text:xe}}catch(ae){const Se=B._asMessage(ae);return Se?{rejectReason:Se,range:void 0,text:void 0}:Promise.reject(ae)}}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class ${constructor(H,K){this.resultId=H,this.tokens=K}}class q{constructor(H,K){this._documents=H,this._provider=K,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(H,K,z){const j=this._documents.getDocument(H),Y=K!==0?this._previousResults.get(K):null;let ae=typeof Y?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,Y.resultId,z):await this._provider.provideDocumentSemanticTokens(j,z);return Y&&this._previousResults.delete(K),ae?(ae=q._fixProvidedSemanticTokens(ae),this._send(q._convertToEdits(Y,ae),ae)):null}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return q._isSemanticTokens(H)?q._isCorrectSemanticTokens(H)?H:new A.SemanticTokens(new Uint32Array(H.data),H.resultId):q._isSemanticTokensEdits(H)?q._isCorrectSemanticTokensEdits(H)?H:new A.SemanticTokensEdits(H.edits.map(K=>new A.SemanticTokensEdit(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const K of H.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,K){if(!q._isSemanticTokens(K)||!H||!H.tokens)return K;const z=H.tokens,j=z.length,Y=K.data,ae=Y.length;let Se=0;const xe=Math.min(j,ae);for(;Se<xe&&z[Se]===Y[Se];)Se++;if(Se===j&&Se===ae)return new A.SemanticTokensEdits([],K.resultId);let Ve=0;const Qe=xe-Se;for(;Ve<Qe&&z[j-Ve-1]===Y[ae-Ve-1];)Ve++;return new A.SemanticTokensEdits([{start:Se,deleteCount:j-Se-Ve,data:Y.subarray(Se,ae-Ve)}],K.resultId)}_send(H,K){if(q._isSemanticTokens(H)){const z=this._nextResultId++;return this._previousResults.set(z,new $(H.resultId,H.data)),(0,l.encodeSemanticTokensDto)({id:z,type:"full",data:H.data})}if(q._isSemanticTokensEdits(H)){const z=this._nextResultId++;return q._isSemanticTokens(K)?this._previousResults.set(z,new $(K.resultId,K.data)):this._previousResults.set(z,new $(H.resultId)),(0,l.encodeSemanticTokensDto)({id:z,type:"delta",deltas:(H.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=q;class ie{constructor(H,K){this._documents=H,this._provider=K}async provideDocumentRangeSemanticTokens(H,K,z){const j=this._documents.getDocument(H),Y=await this._provider.provideDocumentRangeSemanticTokens(j,_.Range.to(K),z);return Y?this._send(Y):null}_send(H){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=ie;class se{constructor(H,K,z,j,Y){this._documents=H,this._commands=K,this._provider=z,this._apiDeprecation=j,this._extension=Y,this._cache=new m.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,K,z,j){const Y=this._documents.getDocument(H),ae=_.Position.to(K),Se=Y.getWordRangeAtPosition(ae)||new A.Range(ae,ae),xe=Se.with({end:ae}),Ve=new F.StopWatch(!0),Qe=await this._provider.provideCompletionItems(Y,ae,j,_.CompletionContext.to(z));if(!Qe||j.isCancellationRequested)return;const nt=Array.isArray(Qe)?new A.CompletionList(Qe):Qe,rt=se.supportsResolving(this._provider)?this._cache.add(nt.items):this._cache.add([]),Je=new d.DisposableStore;this._disposables.set(rt,Je);const Ze=[],pt={x:rt,b:Ze,a:{replace:_.Range.from(Se),insert:_.Range.from(xe)},c:nt.isIncomplete||void 0,d:Ve.elapsed()};for(let Fe=0;Fe<nt.items.length;Fe++){const At=nt.items[Fe],G=this._convertCompletionItem(At,[rt,Fe],xe,Se);Ze.push(G)}return pt}async resolveCompletionItem(H,K){if(typeof this._provider.resolveCompletionItem!="function")return;const z=this._cache.get(...H);if(!z)return;const j=await this._provider.resolveCompletionItem(z,K);if(!!j)return this._convertCompletionItem(j,H)}releaseCompletionItems(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,K,z,j){const Y=this._disposables.get(K[0]);if(!Y)throw Error("DisposableStore is missing...");const ae={x:K,a:H.label,b:H.kind!==void 0?_.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(_.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:_.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(_.TextEdit.from),m:this._commands.toInternal(H.command,Y)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=H.textEdit.newText):typeof H.insertText=="string"?ae.h=H.insertText:H.insertText instanceof A.SnippetString&&(ae.h=H.insertText.value,ae.i|=4);let Se;return H.textEdit?Se=H.textEdit.range:H.range&&(Se=H.range),A.Range.isRange(Se)?ae.j=_.Range.from(Se):Se&&(!z?.isEqual(Se.inserting)||!j?.isEqual(Se.replacing))&&(ae.j={insert:_.Range.from(Se.inserting),replace:_.Range.from(Se.replacing)}),ae}}class X{constructor(H,K,z){this._documents=H,this._provider=K,this._commands=z,this._cache=new m.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,K,z,j){const Y=this._documents.getDocument(H),ae=_.Position.to(K),Se=await this._provider.provideInlineCompletionItems(Y,ae,{selectedCompletionInfo:z.selectedSuggestionInfo?{range:_.Range.to(z.selectedSuggestionInfo.range),text:z.selectedSuggestionInfo.text,isSnippetText:z.selectedSuggestionInfo.isSnippetText,completionKind:_.CompletionItemKind.to(z.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:z.triggerKind},j);if(!Se||j.isCancellationRequested)return;const xe=(0,R.isArray)(Se)?{items:Se}:Se,Ve=this._cache.add(xe.items);let Qe;return{pid:Ve,items:xe.items.map((nt,rt)=>{let Je;return nt.command&&(Qe||(Qe=new d.DisposableStore,this._disposables.set(Ve,Qe)),Je=this._commands.toInternal(nt.command,Qe)),{text:nt.text,range:nt.range?_.Range.from(nt.range):void 0,command:Je,idx:rt}})}}disposeCompletions(H){this._cache.delete(H);const K=this._disposables.get(H);K&&K.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,K){const z=this._cache.get(H,K);z&&ge.get(this._provider).fireOnDidShowCompletionItem({completionItem:z})}}class ge{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let K=ge.map.get(H);return K||(K=new ge,ge.map.set(H,K)),K}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=ge,ge.map=new WeakMap;class be{constructor(H,K){this._documents=H,this._provider=K,this._cache=new m.Cache("SignatureHelp")}async provideSignatureHelp(H,K,z,j){const Y=this._documents.getDocument(H),ae=_.Position.to(K),Se=this.reviveContext(z),xe=await this._provider.provideSignatureHelp(Y,ae,j,Se);if(xe){const Ve=this._cache.add([xe]);return{..._.SignatureHelp.from(xe),id:Ve}}}reviveContext(H){let K;if(H.activeSignatureHelp){const z=_.SignatureHelp.to(H.activeSignatureHelp),j=this._cache.get(H.activeSignatureHelp.id,0);j?(K=j,K.activeSignature=z.activeSignature,K.activeParameter=z.activeParameter):K=z}return{...H,activeSignatureHelp:K}}releaseSignatureHelp(H){this._cache.delete(H)}}class pe{constructor(H,K,z,j,Y){this._documents=H,this._commands=K,this._provider=z,this._logService=j,this._extension=Y,this._cache=new m.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(H,K,z){const j=this._documents.getDocument(H),Y=_.Range.to(K),ae=await this._provider.provideInlayHints(j,Y,z);if(!Array.isArray(ae)||ae.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${K}`);return}if(z.isCancellationRequested)return;const Se=this._cache.add(ae);this._disposables.set(Se,new d.DisposableStore);const xe={hints:[],cacheId:Se};for(let Ve=0;Ve<ae.length;Ve++)this._isValidInlayHint(ae[Ve],Y)&&xe.hints.push(this._convertInlayHint(ae[Ve],[Se,Ve]));return this._logService.trace(`[InlayHints] ${xe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${K}`),xe}async resolveInlayHint(H,K){if(typeof this._provider.resolveInlayHint!="function")return;const z=this._cache.get(...H);if(!z)return;const j=await this._provider.resolveInlayHint(z,K);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,H)}releaseHints(H){this._disposables.get(H)?.dispose(),this._disposables.delete(H),this._cache.delete(H)}_isValidInlayHint(H,K){return H.label.length===0||Array.isArray(H.label)&&H.label.every(z=>z.label.length===0)?(console.log("INVALID inlay hint, empty label",H),!1):!(K&&!K.contains(H.position))}_convertInlayHint(H,K){const z=this._disposables.get(K[0]);if(!z)throw Error("DisposableStore is missing...");const j={label:"",cacheId:K,tooltip:H.tooltip&&_.MarkdownString.from(H.tooltip),position:_.Position.from(H.position),kind:_.InlayHintKind.from(H.kind??A.InlayHintKind.Other),whitespaceBefore:H.whitespaceBefore,whitespaceAfter:H.whitespaceAfter};return typeof H.label=="string"?j.label=H.label:j.label=H.label.map(Y=>{let ae={label:Y.label};return ae.collapsible=Y.collapsible,A.Location.isLocation(Y.action)?ae.action=_.location.from(Y.action):Y.action&&(ae.action=this._commands.toInternal(Y.action,z)),ae}),j}}class fe{constructor(H,K){this._documents=H,this._provider=K,this._cache=new m.Cache("DocumentLink")}async provideLinks(H,K){const z=this._documents.getDocument(H),j=await this._provider.provideDocumentLinks(z,K);if(!(!Array.isArray(j)||j.length===0)&&!K.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(fe._validateLink).map(_.DocumentLink.from)};{const Y=this._cache.add(j),ae={links:[],id:Y};for(let Se=0;Se<j.length;Se++){if(!fe._validateLink(j[Se]))continue;const xe=_.DocumentLink.from(j[Se]);xe.cacheId=[Y,Se],ae.links.push(xe)}return ae}}}static _validateLink(H){return H.target&&H.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(H,K){if(typeof this._provider.resolveDocumentLink!="function")return;const z=this._cache.get(...H);if(!z)return;const j=await this._provider.resolveDocumentLink(z,K);if(!(!j||!fe._validateLink(j)))return _.DocumentLink.from(j)}releaseLinks(H){this._cache.delete(H)}}class oe{constructor(H,K){this._documents=H,this._provider=K}async provideColors(H,K){const z=this._documents.getDocument(H),j=await this._provider.provideDocumentColors(z,K);return Array.isArray(j)?j.map(ae=>({color:_.Color.from(ae.color),range:_.Range.from(ae.range)})):[]}async provideColorPresentations(H,K,z){const j=this._documents.getDocument(H),Y=_.Range.to(K.range),ae=_.Color.to(K.color),Se=await this._provider.provideColorPresentations(ae,{document:j,range:Y},z);if(!!Array.isArray(Se))return Se.map(_.ColorPresentation.from)}}class Ee{constructor(H,K){this._documents=H,this._provider=K}async provideFoldingRanges(H,K,z){const j=this._documents.getDocument(H),Y=await this._provider.provideFoldingRanges(j,K,z);if(!!Array.isArray(Y))return Y.map(_.FoldingRange.from)}}class Pe{constructor(H,K,z){this._documents=H,this._provider=K,this._logService=z}async provideSelectionRanges(H,K,z){const j=this._documents.getDocument(H),Y=K.map(_.Position.to),ae=await this._provider.provideSelectionRanges(j,Y,z);if(!(0,T.isNonEmptyArray)(ae))return[];if(ae.length!==Y.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Se=[];for(let xe=0;xe<Y.length;xe++){const Ve=[];Se.push(Ve);let Qe=Y[xe],nt=ae[xe];for(;;){if(!nt.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ve.push(_.SelectionRange.from(nt)),!nt.parent)break;Qe=nt.range,nt=nt.parent}}return Se}}class Oe{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.prepareCallHierarchy(j,Y,z);if(!ae)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ae)?ae.map(xe=>this._cacheAndConvertItem(Se,xe)):[this._cacheAndConvertItem(Se,ae)]}async provideCallsTo(H,K,z){const j=this._itemFromCache(H,K);if(!j)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyIncomingCalls(j,z);if(!!Y)return Y.map(ae=>({from:this._cacheAndConvertItem(H,ae.from),fromRanges:ae.fromRanges.map(Se=>_.Range.from(Se))}))}async provideCallsFrom(H,K,z){const j=this._itemFromCache(H,K);if(!j)throw new Error("missing call hierarchy item");const Y=await this._provider.provideCallHierarchyOutgoingCalls(j,z);if(!!Y)return Y.map(ae=>({to:this._cacheAndConvertItem(H,ae.to),fromRanges:ae.fromRanges.map(Se=>_.Range.from(Se))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const z=this._cache.get(H),j=_.CallHierarchyItem.from(K,H,z.size.toString(36));return z.set(j._itemId,K),j}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class je{constructor(H,K){this._documents=H,this._provider=K,this._idPool=new s.IdGenerator(""),this._cache=new Map}async prepareSession(H,K,z){const j=this._documents.getDocument(H),Y=_.Position.to(K),ae=await this._provider.prepareTypeHierarchy(j,Y,z);if(!ae)return;const Se=this._idPool.nextId();return this._cache.set(Se,new Map),Array.isArray(ae)?ae.map(xe=>this._cacheAndConvertItem(Se,xe)):[this._cacheAndConvertItem(Se,ae)]}async provideSupertypes(H,K,z){const j=this._itemFromCache(H,K);if(!j)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySupertypes(j,z);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(H,ae))}async provideSubtypes(H,K,z){const j=this._itemFromCache(H,K);if(!j)throw new Error("missing type hierarchy item");const Y=await this._provider.provideTypeHierarchySubtypes(j,z);if(!!Y)return Y.map(ae=>this._cacheAndConvertItem(H,ae))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,K){const z=this._cache.get(H),j=_.TypeHierarchyItem.from(K,H,z.size.toString(36));return z.set(j._itemId,K),j}_itemFromCache(H,K){return this._cache.get(H)?.get(K)}}class st{constructor(H,K){this.adapter=H,this.extension=K}}class et{constructor(H,K,z,j,Y,ae,Se){this._adapter=new Map,this._uriTransformer=K,this._proxy=H.getProxy(I.MainContext.MainThreadLanguageFeatures),this._documents=z,this._commands=j,this._diagnostics=Y,this._logService=ae,this._apiDeprecation=Se}_transformDocumentSelector(H){return _.DocumentSelector.from(H,this._uriTransformer)}_createDisposable(H){return new A.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return et._handlePool++}async _withAdapter(H,K,z,j,Y){const ae=this._adapter.get(H);if(!ae||!(ae.adapter instanceof K))return j;const Se=Date.now();this._logService.trace(`[${ae.extension.identifier.value}] INVOKE provider '${K.name}'`);const xe=z(ae.adapter,ae.extension);return Promise.resolve(xe).catch(Ve=>{(0,S.isCancellationError)(Ve)||(this._logService.error(`[${ae.extension.identifier.value}] provider FAILED`),this._logService.error(Ve))}).finally(()=>{this._logService.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Se}ms`)}),i.CancellationToken.isCancellationToken(Y)?(0,p.raceCancellationError)(xe,Y):xe}_addNewAdapter(H,K){const z=this._nextHandle();return this._adapter.set(z,new st(H,K)),z}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,K,z,j){const Y=this._addNewAdapter(new C(this._documents,z),H),ae=j&&j.label||et._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(Y,this._transformDocumentSelector(K),ae),this._createDisposable(Y)}$provideDocumentSymbols(H,K,z){return this._withAdapter(H,C,j=>j.provideDocumentSymbols(r.URI.revive(K),z),void 0)}registerCodeLensProvider(H,K,z){const j=this._nextHandle(),Y=typeof z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new st(new a(this._documents,this._commands.converter,z),H)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(K),Y);let ae=this._createDisposable(j);if(Y!==void 0){const Se=z.onDidChangeCodeLenses(xe=>this._proxy.$emitCodeLensEvent(Y));ae=A.Disposable.from(ae,Se)}return ae}$provideCodeLenses(H,K,z){return this._withAdapter(H,a,j=>j.provideCodeLenses(r.URI.revive(K),z),void 0)}$resolveCodeLens(H,K,z){return this._withAdapter(H,a,j=>j.resolveCodeLens(K,z),void 0)}$releaseCodeLenses(H,K){this._withAdapter(H,a,z=>Promise.resolve(z.releaseCodeLenses(K)),void 0)}registerDefinitionProvider(H,K,z){const j=this._addNewAdapter(new o(this._documents,z),H);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDefinition(H,K,z,j){return this._withAdapter(H,o,Y=>Y.provideDefinition(r.URI.revive(K),z,j),[])}registerDeclarationProvider(H,K,z){const j=this._addNewAdapter(new n(this._documents,z),H);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDeclaration(H,K,z,j){return this._withAdapter(H,n,Y=>Y.provideDeclaration(r.URI.revive(K),z,j),[])}registerImplementationProvider(H,K,z){const j=this._addNewAdapter(new u(this._documents,z),H);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideImplementation(H,K,z,j){return this._withAdapter(H,u,Y=>Y.provideImplementation(r.URI.revive(K),z,j),[])}registerTypeDefinitionProvider(H,K,z){const j=this._addNewAdapter(new f(this._documents,z),H);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideTypeDefinition(H,K,z,j){return this._withAdapter(H,f,Y=>Y.provideTypeDefinition(r.URI.revive(K),z,j),[])}registerHoverProvider(H,K,z,j){const Y=this._addNewAdapter(new c(this._documents,z),H);return this._proxy.$registerHoverProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideHover(H,K,z,j){return this._withAdapter(H,c,Y=>Y.provideHover(r.URI.revive(K),z,j),void 0)}registerEvaluatableExpressionProvider(H,K,z,j){const Y=this._addNewAdapter(new h(this._documents,z),H);return this._proxy.$registerEvaluatableExpressionProvider(Y,this._transformDocumentSelector(K)),this._createDisposable(Y)}$provideEvaluatableExpression(H,K,z,j){return this._withAdapter(H,h,Y=>Y.provideEvaluatableExpression(r.URI.revive(K),z,j),void 0)}registerInlineValuesProvider(H,K,z,j){const Y=typeof z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ae=this._addNewAdapter(new g(this._documents,z),H);this._proxy.$registerInlineValuesProvider(ae,this._transformDocumentSelector(K),Y);let Se=this._createDisposable(ae);if(Y!==void 0){const xe=z.onDidChangeInlineValues(Ve=>this._proxy.$emitInlineValuesEvent(Y));Se=A.Disposable.from(Se,xe)}return Se}$provideInlineValues(H,K,z,j,Y){return this._withAdapter(H,g,ae=>ae.provideInlineValues(r.URI.revive(K),z,j,Y),void 0)}registerDocumentHighlightProvider(H,K,z){const j=this._addNewAdapter(new E(this._documents,z),H);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDocumentHighlights(H,K,z,j){return this._withAdapter(H,E,Y=>Y.provideDocumentHighlights(r.URI.revive(K),z,j),void 0)}registerLinkedEditingRangeProvider(H,K,z){const j=this._addNewAdapter(new v(this._documents,z),H);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideLinkedEditingRanges(H,K,z,j){return this._withAdapter(H,v,async Y=>{const ae=await Y.provideLinkedEditingRanges(r.URI.revive(K),z,j);if(ae)return{ranges:ae.ranges,wordPattern:ae.wordPattern?et._serializeRegExp(ae.wordPattern):void 0}},void 0)}registerReferenceProvider(H,K,z){const j=this._addNewAdapter(new k(this._documents,z),H);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideReferences(H,K,z,j,Y){return this._withAdapter(H,k,ae=>ae.provideReferences(r.URI.revive(K),z,j,Y),void 0)}registerCodeActionProvider(H,K,z,j){const Y=new d.DisposableStore,ae=this._addNewAdapter(new x(this._documents,this._commands.converter,this._diagnostics,z,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(ae,this._transformDocumentSelector(K),{providedKinds:j?.providedCodeActionKinds?.map(Se=>Se.value),documentation:j?.documentation?.map(Se=>({kind:Se.kind.value,command:this._commands.converter.toInternal(Se.command,Y)}))},et._extLabel(H),Boolean(z.resolveCodeAction)),Y.add(this._createDisposable(ae)),Y}$provideCodeActions(H,K,z,j,Y){return this._withAdapter(H,x,ae=>ae.provideCodeActions(r.URI.revive(K),z,j,Y),void 0)}$resolveCodeAction(H,K,z){return this._withAdapter(H,x,j=>j.resolveCodeAction(K,z),void 0)}$releaseCodeActions(H,K){this._withAdapter(H,x,z=>Promise.resolve(z.releaseCodeActions(K)),void 0)}registerDocumentFormattingEditProvider(H,K,z){const j=this._addNewAdapter(new N(this._documents,z),H);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(j)}$provideDocumentFormattingEdits(H,K,z,j){return this._withAdapter(H,N,Y=>Y.provideDocumentFormattingEdits(r.URI.revive(K),z,j),void 0)}registerDocumentRangeFormattingEditProvider(H,K,z){const j=this._addNewAdapter(new y(this._documents,z),H);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(K),H.identifier,H.displayName||H.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(H,K,z,j,Y){return this._withAdapter(H,y,ae=>ae.provideDocumentRangeFormattingEdits(r.URI.revive(K),z,j,Y),void 0)}registerOnTypeFormattingEditProvider(H,K,z,j){const Y=this._addNewAdapter(new L(this._documents,z),H);return this._proxy.$registerOnTypeFormattingSupport(Y,this._transformDocumentSelector(K),j,H.identifier),this._createDisposable(Y)}$provideOnTypeFormattingEdits(H,K,z,j,Y,ae){return this._withAdapter(H,L,Se=>Se.provideOnTypeFormattingEdits(r.URI.revive(K),z,j,Y,ae),void 0)}registerWorkspaceSymbolProvider(H,K){const z=this._addNewAdapter(new W(K,this._logService),H);return this._proxy.$registerNavigateTypeSupport(z,typeof K.resolveWorkspaceSymbol=="function"),this._createDisposable(z)}$provideWorkspaceSymbols(H,K,z){return this._withAdapter(H,W,j=>j.provideWorkspaceSymbols(K,z),{symbols:[]})}$resolveWorkspaceSymbol(H,K,z){return this._withAdapter(H,W,j=>j.resolveWorkspaceSymbol(K,z),void 0)}$releaseWorkspaceSymbols(H,K){this._withAdapter(H,W,z=>z.releaseWorkspaceSymbols(K),void 0)}registerRenameProvider(H,K,z){const j=this._addNewAdapter(new B(this._documents,z,this._logService),H);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(K),B.supportsResolving(z)),this._createDisposable(j)}$provideRenameEdits(H,K,z,j,Y){return this._withAdapter(H,B,ae=>ae.provideRenameEdits(r.URI.revive(K),z,j,Y),void 0)}$resolveRenameLocation(H,K,z,j){return this._withAdapter(H,B,Y=>Y.resolveRenameLocation(r.URI.revive(K),z,j),void 0)}registerDocumentSemanticTokensProvider(H,K,z,j){const Y=this._addNewAdapter(new q(this._documents,z),H),ae=typeof z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(Y,this._transformDocumentSelector(K),j,ae);let Se=this._createDisposable(Y);if(ae){const xe=z.onDidChangeSemanticTokens(Ve=>this._proxy.$emitDocumentSemanticTokensEvent(ae));Se=A.Disposable.from(Se,xe)}return Se}$provideDocumentSemanticTokens(H,K,z,j){return this._withAdapter(H,q,Y=>Y.provideDocumentSemanticTokens(r.URI.revive(K),z,j),null)}$releaseDocumentSemanticTokens(H,K){this._withAdapter(H,q,z=>z.releaseDocumentSemanticColoring(K),void 0)}registerDocumentRangeSemanticTokensProvider(H,K,z,j){const Y=this._addNewAdapter(new ie(this._documents,z),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(Y,this._transformDocumentSelector(K),j),this._createDisposable(Y)}$provideDocumentRangeSemanticTokens(H,K,z,j){return this._withAdapter(H,ie,Y=>Y.provideDocumentRangeSemanticTokens(r.URI.revive(K),z,j),null)}registerCompletionItemProvider(H,K,z,j){const Y=this._addNewAdapter(new se(this._documents,this._commands.converter,z,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(Y,this._transformDocumentSelector(K),j,se.supportsResolving(z),`${H.identifier.value}(${j.join("")})`),this._createDisposable(Y)}$provideCompletionItems(H,K,z,j,Y){return this._withAdapter(H,se,ae=>ae.provideCompletionItems(r.URI.revive(K),z,j,Y),void 0,Y)}$resolveCompletionItem(H,K,z){return this._withAdapter(H,se,j=>j.resolveCompletionItem(K,z),void 0,z)}$releaseCompletionItems(H,K){this._withAdapter(H,se,z=>z.releaseCompletionItems(K),void 0)}registerInlineCompletionsProvider(H,K,z){const j=this._addNewAdapter(new X(this._documents,z,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideInlineCompletions(H,K,z,j,Y){return this._withAdapter(H,X,ae=>ae.provideInlineCompletions(r.URI.revive(K),z,j,Y),void 0)}$handleInlineCompletionDidShow(H,K,z){this._withAdapter(H,X,async j=>{j.handleDidShowCompletionItem(K,z)},void 0)}$freeInlineCompletionsList(H,K){this._withAdapter(H,X,async z=>{z.disposeCompletions(K)},void 0)}registerSignatureHelpProvider(H,K,z,j){const Y=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ae=this._addNewAdapter(new be(this._documents,z),H);return this._proxy.$registerSignatureHelpProvider(ae,this._transformDocumentSelector(K),Y),this._createDisposable(ae)}$provideSignatureHelp(H,K,z,j,Y){return this._withAdapter(H,be,ae=>ae.provideSignatureHelp(r.URI.revive(K),z,j,Y),void 0)}$releaseSignatureHelp(H,K){this._withAdapter(H,be,z=>z.releaseSignatureHelp(K),void 0)}registerInlayHintsProvider(H,K,z){const j=typeof z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,Y=this._addNewAdapter(new pe(this._documents,this._commands.converter,z,this._logService,H),H);this._proxy.$registerInlayHintsProvider(Y,this._transformDocumentSelector(K),typeof z.resolveInlayHint=="function",j);let ae=this._createDisposable(Y);if(j!==void 0){const Se=z.onDidChangeInlayHints(xe=>this._proxy.$emitInlayHintsEvent(j));ae=A.Disposable.from(ae,Se)}return ae}$provideInlayHints(H,K,z,j){return this._withAdapter(H,pe,Y=>Y.provideInlayHints(r.URI.revive(K),z,j),void 0,j)}$resolveInlayHint(H,K,z){return this._withAdapter(H,pe,j=>j.resolveInlayHint(K,z),void 0,z)}$releaseInlayHints(H,K){this._withAdapter(H,pe,z=>z.releaseHints(K),void 0)}registerDocumentLinkProvider(H,K,z){const j=this._addNewAdapter(new fe(this._documents,z),H);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(K),typeof z.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(H,K,z){return this._withAdapter(H,fe,j=>j.provideLinks(r.URI.revive(K),z),void 0)}$resolveDocumentLink(H,K,z){return this._withAdapter(H,fe,j=>j.resolveLink(K,z),void 0)}$releaseDocumentLinks(H,K){this._withAdapter(H,fe,z=>z.releaseLinks(K),void 0)}registerColorProvider(H,K,z){const j=this._addNewAdapter(new oe(this._documents,z),H);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideDocumentColors(H,K,z){return this._withAdapter(H,oe,j=>j.provideColors(r.URI.revive(K),z),[])}$provideColorPresentations(H,K,z,j){return this._withAdapter(H,oe,Y=>Y.provideColorPresentations(r.URI.revive(K),z,j),void 0)}registerFoldingRangeProvider(H,K,z){const j=this._nextHandle(),Y=typeof z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new st(new Ee(this._documents,z),H)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(K),Y);let ae=this._createDisposable(j);if(Y!==void 0){const Se=z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(Y));ae=A.Disposable.from(ae,Se)}return ae}$provideFoldingRanges(H,K,z,j){return this._withAdapter(H,Ee,Y=>Y.provideFoldingRanges(r.URI.revive(K),z,j),void 0)}registerSelectionRangeProvider(H,K,z){const j=this._addNewAdapter(new Pe(this._documents,z,this._logService),H);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$provideSelectionRanges(H,K,z,j){return this._withAdapter(H,Pe,Y=>Y.provideSelectionRanges(r.URI.revive(K),z,j),[])}registerCallHierarchyProvider(H,K,z){const j=this._addNewAdapter(new Oe(this._documents,z),H);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$prepareCallHierarchy(H,K,z,j){return this._withAdapter(H,Oe,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),z,j)),void 0)}$provideCallHierarchyIncomingCalls(H,K,z,j){return this._withAdapter(H,Oe,Y=>Y.provideCallsTo(K,z,j),void 0)}$provideCallHierarchyOutgoingCalls(H,K,z,j){return this._withAdapter(H,Oe,Y=>Y.provideCallsFrom(K,z,j),void 0)}$releaseCallHierarchy(H,K){this._withAdapter(H,Oe,z=>Promise.resolve(z.releaseSession(K)),void 0)}registerTypeHierarchyProvider(H,K,z){const j=this._addNewAdapter(new je(this._documents,z),H);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(K)),this._createDisposable(j)}$prepareTypeHierarchy(H,K,z,j){return this._withAdapter(H,je,Y=>Promise.resolve(Y.prepareSession(r.URI.revive(K),z,j)),void 0)}$provideTypeHierarchySupertypes(H,K,z,j){return this._withAdapter(H,je,Y=>Y.provideSupertypes(K,z,j),void 0)}$provideTypeHierarchySubtypes(H,K,z,j){return this._withAdapter(H,je,Y=>Y.provideSubtypes(K,z,j),void 0)}$releaseTypeHierarchy(H,K){this._withAdapter(H,je,z=>Promise.resolve(z.releaseSession(K)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,P.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:et._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:et._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?et._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?et._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:et._serializeRegExp(H.beforeText),afterText:H.afterText?et._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?et._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(et._serializeOnEnterRule)}setLanguageConfiguration(H,K,z){let{wordPattern:j}=z;if(j&&(0,P.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(K,j):this._documents.setWordDefinitionFor(K,void 0),z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const Y=this._nextHandle(),ae={comments:z.comments,brackets:z.brackets,wordPattern:z.wordPattern?et._serializeRegExp(z.wordPattern):void 0,indentationRules:z.indentationRules?et._serializeIndentationRule(z.indentationRules):void 0,onEnterRules:z.onEnterRules?et._serializeOnEnterRules(z.onEnterRules):void 0,__electricCharacterSupport:z.__electricCharacterSupport,__characterPairSupport:z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(Y,K,ae),this._createDisposable(Y)}$setWordDefinitions(H){for(const K of H)this._documents.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.ExtHostLanguageFeatures=et,et._handlePool=0}),define(ye[189],_e([0,1,5,8,7,34,13,6]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(R,w,i,d){this._documents=w,this._commands=i,this._uriTransformer=d,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(r.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,w){await this._proxy.$changeLanguage(R,w);const i=this._documents.getDocumentData(R);if(!i)throw new Error(`document '${R.toString}' NOT found`);return i.document}async tokenAtPosition(R,w){const i=R.version,d=t.Position.from(w),l=await this._proxy.$tokensAtPosition(R.uri,d),s={type:_.StandardTokenType.Other,range:R.getWordRangeAtPosition(w)??new _.Range(w.line,w.character,w.line,w.character)};if(!l)return s;const m={range:t.Range.to(l.range),type:t.TokenType.to(l.type)};return!m.range.contains(w)||i!==R.version?s:m}createLanguageStatusItem(R,w,i){const d=this._handlePool++,l=this._proxy,s=this._ids,m=`${R.identifier.value}/${w}`;if(s.has(m))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);s.add(m);const F={selector:i,id:w,name:R.displayName??R.name,severity:_.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let S,b=new P.DisposableStore;const p=()=>{S?.dispose(),S=(0,I.disposableTimeout)(()=>{b.clear(),this._proxy.$setLanguageStatus(d,{id:m,name:F.name??R.displayName??R.name,source:R.displayName??R.name,selector:t.DocumentSelector.from(F.selector,this._uriTransformer),label:F.text,detail:F.detail??"",severity:F.severity===_.LanguageStatusSeverity.Error?A.default.Error:F.severity===_.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:F.command&&this._commands.toInternal(F.command,b),accessibilityInfo:F.accessibilityInformation,busy:F.busy})},0)},C={dispose(){b.dispose(),S?.dispose(),l.$removeLanguageStatus(d),s.delete(m)},get id(){return F.id},get name(){return F.name},set name(a){F.name=a,p()},get selector(){return F.selector},set selector(a){F.selector=a,p()},get text(){return F.text},set text(a){F.text=a,p()},get detail(){return F.detail},set detail(a){F.detail=a,p()},get severity(){return F.severity},set severity(a){F.severity=a,p()},get accessibilityInformation(){return F.accessibilityInformation},set accessibilityInformation(a){F.accessibilityInformation=a,p()},get command(){return F.command},set command(a){F.command=a,p()},get busy(){return F.busy},set busy(a){F.busy=a,p()}};return p(),C}}e.ExtHostLanguages=D}),define(ye[190],_e([0,1,12,5,28,14,4]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let P=class extends r.AbstractLoggerService{constructor(R,w){const i=new I.Emitter;super(w.logLevel,i.event);this._proxy=R.getProxy(t.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(i)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,w,i){return new D(this._proxy,R,w,i)}};P=Be([$e(0,A.IExtHostRpcService),$e(1,_.IExtHostInitDataService)],P),e.ExtHostLoggerService=P;class D extends r.AbstractMessageLogger{constructor(R,w,i,d){super(d?.always);this.proxy=R,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(i),this.proxy.$createLogger(w,d).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,w){const i=[[R,w]];this.isLoggerCreated?this.doLog(i):this.buffer.push(...i)}doLog(R){this.proxy.$log(this.file,R)}}}),define(ye[191],_e([0,1,5,12,26]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(P){return P&&P.title}let I=class{constructor(D,T){this._logService=T,this._proxy=D.getProxy(r.MainContext.MainThreadMessageService)}showMessage(D,T,R,w,i){const d={source:{identifier:D.identifier,label:D.displayName||D.name}};let l;typeof w=="string"||A(w)?l=[w,...i]:(d.modal=w?.modal,d.useCustom=w?.useCustom,d.detail=w?.detail,l=i),d.useCustom&&(0,_.checkProposedApiEnabled)(D,"resolvers");const s=[];for(let m=0;m<l.length;m++){const F=l[m];if(typeof F=="string")s.push({title:F,handle:m,isCloseAffordance:!1});else if(typeof F=="object"){let{title:S,isCloseAffordance:b}=F;s.push({title:S,isCloseAffordance:!!b,handle:m})}else this._logService.warn("Invalid message item:",F)}return this._proxy.$showMessage(T,R,d,s).then(m=>{if(typeof m=="number")return l[m]})}};I=Be([$e(1,t.ILogService)],I),e.ExtHostMessageService=I}),define(ye[192],_e([0,1,21,4,92,6,22,9,10,2,62,5,8,7,38,165,89]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class F{constructor(b,p,C,a,M){this._textDocumentsAndEditors=C,this._textDocuments=a,this._extensionStoragePaths=M,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new I.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new t.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new t.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new t.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new t.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new t.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new t.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new t.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=b.getProxy(w.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=b.getProxy(w.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=b.getProxy(w.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===12){const n=o.notebookEditor?.notebookUri,u=o.cell.handle,c=this._documents.get(n)?.getCell(u);if(c)return c.apiCell}return o}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(b=>b.apiEditor)}getEditorById(b){const p=this._editors.get(b);if(!p)throw new Error(`unknown text editor: ${b}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(b){for(const[p,C]of this._editors)if(C.apiEditor===b)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(b,p){const C=this._documents.get(b);if(!C&&!p)throw new Error(`NO notebook document for '${b}'`);return C}_getProviderData(b){const p=this._notebookContentProviders.get(b);if(!p)throw new Error(`NO provider for '${b}'`);return p}registerNotebookContentProvider(b,p,C,a,M){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:b,provider:C});let o;return C.onDidChangeNotebookContentOptions&&(o=C.onDidChangeNotebookContentOptions(()=>{const n=i.NotebookDocumentContentOptions.from(C.options);this._notebookProxy.$updateNotebookProviderOptions(p,n)})),this._notebookProxy.$registerNotebookProvider({id:b.identifier,location:b.extensionLocation},p,i.NotebookDocumentContentOptions.from(a),F._convertNotebookRegistrationData(b,M)),new d.Disposable(()=>{o?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(b,p){if(!p)return;const C=p.filenamePattern.map(a=>i.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(p.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:p.displayName,filenamePattern:C,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,p,C){const a=F._notebookStatusBarItemProviderHandlePool++,M=typeof C.onDidChangeCellStatusBarItems=="function"?F._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,C),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,M,p);let o;return M!==void 0&&(o=C.onDidChangeCellStatusBarItems(n=>this._notebookProxy.$emitCellStatusBarEvent(M))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,M),o&&o.dispose()})}async createNotebookDocument(b){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:b.viewType,content:b.content&&i.NotebookData.from(b.content)});return T.URI.revive(p)}async openNotebookDocument(b){const p=this._documents.get(b);if(p)return p.apiNotebook;const C=await this._notebookDocumentsProxy.$tryOpenNotebook(b),a=this._documents.get(T.URI.revive(C));return(0,D.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(b,p){T.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let C;typeof p=="object"?C={position:i.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(i.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:C={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(b.uri,b.notebookType,C),M=a&&this._editors.get(a)?.apiEditor;if(M)return M;throw a?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,p,C,a){const M=this._notebookStatusBarItemProviders.get(b),o=T.URI.revive(p),n=this._documents.get(o);if(!n||!M)return;const u=n.getCellFromIndex(C);if(!u)return;const f=await M.provideCellStatusBarItems(u.apiCell,a);if(!f)return;const c=new A.DisposableStore,h=this._statusBarCache.add([c]),E=(Array.isArray(f)?f:[f]).map(v=>i.NotebookStatusBarItem.from(v,this._commandsConverter,c));return{cacheId:h,items:E}}$releaseNotebookCellStatusBarItems(b){this._statusBarCache.delete(b)}registerNotebookSerializer(b,p,C,a,M){if((0,P.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const o=this._handlePool++;return this._notebookSerializer.set(o,C),this._notebookProxy.$registerNotebookSerializer(o,{id:b.identifier,location:b.extensionLocation},p,i.NotebookDocumentContentOptions.from(a),F._convertNotebookRegistrationData(b,M)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(o)})}async $dataToNotebook(b,p,C){const a=this._notebookSerializer.get(b);if(!a)throw new Error("NO serializer found");const M=await a.deserializeNotebook(p.buffer,C);return new l.SerializableObjectWithBuffers(i.NotebookData.from(M))}async $notebookToData(b,p,C){const a=this._notebookSerializer.get(b);if(!a)throw new Error("NO serializer found");const M=await a.serializeNotebook(i.NotebookData.to(p.value),C);return r.VSBuffer.wrap(M)}async $openNotebook(b,p,C,a,M){const{provider:o}=this._getProviderData(b),n=await o.openNotebook(T.URI.revive(p),{backupId:C,untitledDocumentData:a?.buffer},M);return new l.SerializableObjectWithBuffers({metadata:n.metadata??Object.create(null),cells:n.cells.map(i.NotebookCellData.from)})}async $saveNotebook(b,p,C){const a=this.getNotebookDocument(T.URI.revive(p)),{provider:M}=this._getProviderData(b);return await M.saveNotebook(a.apiNotebook,C),!0}async $saveNotebookAs(b,p,C,a){const M=this.getNotebookDocument(T.URI.revive(p)),{provider:o}=this._getProviderData(b);return await o.saveNotebookAs(T.URI.revive(C),M.apiNotebook,a),!0}async $backupNotebook(b,p,C){const a=this.getNotebookDocument(T.URI.revive(p)),M=this._getProviderData(b),o=this._extensionStoragePaths.workspaceValue(M.extension)??this._extensionStoragePaths.globalValue(M.extension),n=String((0,_.hash)([a.uri.toString(),this._backupIdPool++])),u=T.URI.joinPath(o,n),f=await M.provider.backupNotebook(a.apiNotebook,{destination:u},C);return a.updateBackup(f),f.id}_createExtHostEditor(b,p,C){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const a=new m.ExtHostNotebookEditor(p,this._notebookEditorsProxy,b,C.visibleRanges.map(i.NotebookRange.to),C.selections.map(i.NotebookRange.to),typeof C.viewColumn=="number"?i.ViewColumn.to(C.viewColumn):void 0);this._editors.set(p,a)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const C of b.value.removedDocuments){const a=T.URI.revive(C),M=this._documents.get(a);M&&(M.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:M.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(M.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===a.toString()&&this._editors.delete(o.id)}if(b.value.addedDocuments){const C=[];for(const a of b.value.addedDocuments){const M=T.URI.revive(a.uri);if(this._documents.has(M))throw new Error(`adding EXISTING notebook ${M} `);const o=this,n=new s.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){o._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){o._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){o._onDidChangeCellMetadata.fire(u)}},M,a);C.push(...a.cells.map(u=>s.ExtHostCell.asModelAddData(n.apiNotebook,u))),this._documents.get(M)?.dispose(),this._documents.set(M,n),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this._onDidOpenNotebookDocument.fire(n.apiNotebook)}}if(b.value.addedEditors)for(const C of b.value.addedEditors){if(this._editors.has(C.id))return;const a=T.URI.revive(C.documentUri),M=this._documents.get(a);M&&this._createExtHostEditor(M,C.id,C)}const p=[];if(b.value.removedEditors)for(const C of b.value.removedEditors){const a=this._editors.get(C);a&&(this._editors.delete(C),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),p.push(a))}if(b.value.visibleEditors){this._visibleNotebookEditors=b.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const C=new Set;this._visibleNotebookEditors.forEach(a=>C.add(a.id));for(const a of this._editors.values()){const M=C.has(a.id);a._acceptVisibility(M)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this._activeNotebookEditor=void 0:b.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=F,F._notebookStatusBarItemProviderHandlePool=0}),define(ye[193],_e([0,1,4,54,12,5,14,8]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(w,i){const d=D._Keys.nextId();w.$registerNotebookEditorDecorationType(d,P.NotebookDecorationRenderOptions.from(i)),this.value={key:d,dispose(){w.$removeNotebookEditorDecorationType(d)}}}}D._Keys=new t.IdGenerator("NotebookEditorDecorationType");let T=class{constructor(w,i,d){this._logService=w,this._extHostRpc=i,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new r.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new r.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(w){return new D(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),w).value}$acceptEditorPropertiesChanged(w,i){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,i);const d=this._notebooksAndEditors.getEditorById(w);i.visibleRanges&&d._acceptVisibleRanges(i.visibleRanges.ranges.map(P.NotebookRange.to)),i.selections&&d._acceptSelections(i.selections.selections.map(P.NotebookRange.to)),i.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),i.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const i in w)this._notebooksAndEditors.getEditorById(i)._acceptViewColumn(P.ViewColumn.to(w[i]))}};T=Be([$e(0,_.ILogService),$e(1,I.IExtHostRpcService)],T),e.ExtHostNotebookEditors=T}),define(ye[194],_e([0,1,16,13,20,4,6,22,2,25,12,5,39,8,7,65,158,26,38]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(o,n,u,f,c){this._initData=n,this._extHostNotebook=u,this._commands=f,this._logService=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new A.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=o.getProxy(w.MainContext.MainThreadNotebookKernels);const h=new i.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new i.ApiCommandArgument("options","Select kernel options",g=>!0,g=>{if(g&&"notebookEditor"in g&&"id"in g){const E=this._extHostNotebook.getIdByEditor(g.notebookEditor);return{id:g.id,extension:g.extension,notebookEditorId:E}}else if(g&&"notebookEditor"in g){const E=this._extHostNotebook.getIdByEditor(g.notebookEditor);if(E===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${g.notebookEditor.document.uri.toString()}`);return{notebookEditorId:E}}return g})],i.ApiCommandResult.Void);this._commands.registerApiCommand(h)}createNotebookController(o,n,u,f,c,h){for(const X of this._kernelData.values())if(X.controller.id===n&&T.ExtensionIdentifier.equals(o.identifier,X.extensionId))throw new Error(`notebook controller with id '${n}' ALREADY exist`);const g=this._handlePool++,E=this;this._logService.trace(`NotebookController[${g}], CREATED by ${o.identifier.value}, ${n}`);const v=()=>console.warn(`NO execute handler from notebook controller '${L.id}' of extension: '${o.identifier}'`);let k=!1;const x=new I.DisposableStore,N=new A.Emitter,y=new A.Emitter,L={id:`${o.identifier.value}/${n}`,notebookType:u,extensionId:o.identifier,extensionLocation:o.extensionLocation,label:f||o.identifier.value,preloads:h?h.map(d.NotebookRendererScript.from):[]};let W=c??v,B;this._proxy.$addKernel(g,L).catch(X=>{console.log(X),k=!0});let $=0;const q=()=>{if(k)return;const X=++$;Promise.resolve().then(()=>{X===$&&this._proxy.$updateKernel(g,L)})},ie=new P.ResourceMap,se={get id(){return n},get notebookType(){return L.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return L.label},set label(X){L.label=X??o.displayName??o.name,q()},get detail(){return L.detail??""},set detail(X){L.detail=X,q()},get description(){return L.description??""},set description(X){L.description=X,q()},get kind(){return(0,F.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind??""},set kind(X){(0,F.checkProposedApiEnabled)(o,"notebookControllerKind"),L.kind=X,q()},get supportedLanguages(){return L.supportedLanguages},set supportedLanguages(X){L.supportedLanguages=X,q()},get supportsExecutionOrder(){return L.supportsExecutionOrder??!1},set supportsExecutionOrder(X){L.supportsExecutionOrder=X,q()},get rendererScripts(){return L.preloads?L.preloads.map(d.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(X){W=X??v},get interruptHandler(){return B},set interruptHandler(X){B=X,L.supportsInterrupt=Boolean(X),q()},createNotebookCellExecution(X){if(k)throw new Error("notebook controller is DISPOSED");if(!ie.has(X.notebook.uri))throw E._logService.trace(`NotebookController[${g}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ie.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.notebook.uri.toString()}`);return E._createNotebookCellExecution(X)},dispose:()=>{k||(this._logService.trace(`NotebookController[${g}], DISPOSED`),k=!0,this._kernelData.delete(g),x.dispose(),N.dispose(),y.dispose(),this._proxy.$removeKernel(g))},updateNotebookAffinity(X,ge){E._proxy.$updateNotebookPriority(g,X.uri,ge)},onDidReceiveMessage:y.event,postMessage(X,ge){return(0,F.checkProposedApiEnabled)(o,"notebookMessaging"),E._proxy.$postMessage(g,ge&&E._extHostNotebook.getIdByEditor(ge),X)},asWebviewUri(X){return(0,F.checkProposedApiEnabled)(o,"notebookMessaging"),(0,s.asWebviewUri)(X,E._initData.remote)}};return this._kernelData.set(g,{extensionId:o.identifier,controller:se,onDidReceiveMessage:y,onDidChangeSelection:N,associatedNotebooks:ie}),se}$acceptNotebookAssociation(o,n,u){const f=this._kernelData.get(o);if(f){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));u?f.associatedNotebooks.set(c.uri,!0):f.associatedNotebooks.delete(c.uri),this._logService.trace(`NotebookController[${o}] ASSOCIATE notebook`,c.uri.toString(),u),f.onDidChangeSelection.fire({selected:u,notebook:c.apiNotebook})}}async $executeCells(o,n,u){const f=this._kernelData.get(o);if(!f)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(n)),h=[];for(const g of u){const E=c.getCell(g);E&&h.push(E.apiCell)}try{this._logService.trace(`NotebookController[${o}] EXECUTE cells`,c.uri.toString(),h.length),await f.controller.executeHandler.call(f.controller,h,c.apiNotebook,f.controller)}catch(g){this._logService.error(`NotebookController[${o}] execute cells FAILED`,g),console.error(g)}}async $cancelCells(o,n,u){const f=this._kernelData.get(o);if(!f)return;const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(n));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,c.apiNotebook);else for(const h of u){const g=c.getCell(h);g&&this._activeExecutions.get(g.uri)?.cancel()}}$acceptKernelMessageFromRenderer(o,n,u){const f=this._kernelData.get(o);if(!f)return;const c=this._extHostNotebook.getEditorById(n);f.onDidReceiveMessage.fire(Object.freeze({editor:c.apiEditor,message:u}))}$cellExecutionChanged(o,n,u){const c=this._extHostNotebook.getNotebookDocument(D.URI.revive(o)).getCell(n);c&&this._onDidChangeCellExecutionState.fire({cell:c.apiCell,state:u??l.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(o){if(o.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this._extHostNotebook.getNotebookDocument(o.notebook.uri).getCellFromApiCell(o);if(!u)throw new Error("invalid cell");if(this._activeExecutions.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const f=new C(u.notebook,u,this._proxy);this._activeExecutions.set(u.uri,f);const c=f.onDidChangeState(()=>{f.state===p.Resolved&&(f.dispose(),c.dispose(),this._activeExecutions.delete(u.uri))});return f.asApiObject()}};b=Be([$e(4,R.ILogService)],b),e.ExtHostNotebookKernels=b;var p;(function(M){M[M.Init=0]="Init",M[M.Started=1]="Started",M[M.Resolved=2]="Resolved"})(p||(p={}));class C extends I.Disposable{constructor(o,n,u){super();this._document=o,this._cell=n,this._proxy=u,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new _.CancellationTokenSource),this._collector=new a(10,f=>this.update(f)),this._executionOrder=n.internalMetadata.executionOrder,this._proxy.$addExecution(this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(o){await this._collector.addItem(o)}async update(o){const n=Array.isArray(o)?o:[o];return this._proxy.$updateExecutions(new S.SerializableObjectWithBuffers(n))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(o){let n=this._cell;if(o&&(n=this._document.getCellFromApiCell(o)),!n)throw new Error("INVALID cell");return n.handle}validateAndConvertOutputs(o){return o.map(n=>{const u=l.NotebookCellOutput.ensureUniqueMimeTypes(n.items,!0);return u===n.items?d.NotebookCellOutput.from(n):d.NotebookCellOutput.from({items:u,id:n.id,metadata:n.metadata})})}async updateOutputs(o,n,u){const f=this.cellIndexToHandle(n),c=this.validateAndConvertOutputs((0,r.asArray)(o));return this.updateSoon({editType:m.CellExecutionUpdateType.Output,uri:this._document.uri,cellHandle:f,append:u,outputs:c})}async updateOutputItems(o,n,u){return o=l.NotebookCellOutput.ensureUniqueMimeTypes((0,r.asArray)(o),!0),this.updateSoon({editType:m.CellExecutionUpdateType.OutputItems,uri:this._document.uri,cellHandle:this._cell.handle,items:o.map(d.NotebookCellOutputItem.from),outputId:n.id,append:u})}asApiObject(){const o=this;return Object.freeze({get token(){return o._tokenSource.token},get cell(){return o._cell.apiCell},get executionOrder(){return o._executionOrder},set executionOrder(u){o._executionOrder=u,o.update([{editType:m.CellExecutionUpdateType.ExecutionState,uri:o._document.uri,cellHandle:o._cell.handle,executionOrder:o._executionOrder}])},start(u){if(o._state===p.Resolved||o._state===p.Started)throw new Error("Cannot call start again");o._state=p.Started,o._onDidChangeState.fire(),o.update({editType:m.CellExecutionUpdateType.ExecutionState,uri:o._document.uri,cellHandle:o._cell.handle,runStartTime:u})},end(u,f){if(o._state===p.Resolved)throw new Error("Cannot call resolve twice");o._state=p.Resolved,o._onDidChangeState.fire(),o._collector.flush(),o._proxy.$completeExecution(o._document.uri,o._cell.handle,new S.SerializableObjectWithBuffers({uri:o._document.uri,cellHandle:o._cell.handle,runEndTime:f,lastRunSuccess:u}))},clearOutput(u){return o.verifyStateForOutput(),o.updateOutputs([],u,!1)},appendOutput(u,f){return o.verifyStateForOutput(),o.updateOutputs(u,f,!0)},replaceOutput(u,f){return o.verifyStateForOutput(),o.updateOutputs(u,f,!1)},appendOutputItems(u,f){return o.verifyStateForOutput(),o.updateOutputItems(u,f,!0)},replaceOutputItems(u,f){return o.verifyStateForOutput(),o.updateOutputItems(u,f,!1)}})}}class a{constructor(o,n){this.delay=o,this.callback=n,this.batch=[],this.startedTimer=Date.now()}addItem(o){return this.batch.push(o),this.currentDeferred||(this.currentDeferred=new t.DeferredPromise,this.startedTimer=Date.now(),(0,t.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const o=this.currentDeferred;this.currentDeferred=void 0;const n=this.batch;return this.batch=[],this.callback(n).finally(()=>o.complete())}}}),define(ye[195],_e([0,1,4,5,89,26]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class I{constructor(D,T){this._extHostNotebook=T,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(t.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,T,R){const w=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(T)?.fire({editor:w.apiEditor,message:R})}createRendererMessaging(D,T){if(!D.contributes?.notebookRenderer?.some(d=>d.id===T))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${T})`);const R=(0,A.isProposedApiEnabled)(D,"notebookEditor"),w=new WeakMap;return{onDidReceiveMessage:(d,l,s)=>{const m=R?d:F=>{const S={};w.set(S,F.editor),d({editor:S,message:F.message})};return this.getOrCreateEmitterFor(T).event(m,l,s)},postMessage:(d,l)=>{_.ExtHostNotebookEditor.apiEditorsToExtHost.has(d)&&([d,l]=[l,d]);const s=R?l:w.get(l),m=s&&_.ExtHostNotebookEditor.apiEditorsToExtHost.get(s);return this.proxy.$postMessage(m?.id,T,d)}}}getOrCreateEmitterFor(D){let T=this._rendererMessageEmitters.get(D);return T||(T=new r.Emitter({onLastListenerRemove:()=>{T?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,T),T)}}e.ExtHostNotebookRenderers=I}),define(ye[93],_e([0,1,5,6,3,14,12,159,50,28,30,109,21]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class d extends t.Disposable{constructor(m,F,S,b){super();this.id=m,this.name=F,this.logger=S,this.proxy=b,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(m){this.append(m+`
`)}append(m){this.write(m),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Append))}clear(){const m=this.offset;this.logger.flush(),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Clear,m)}replace(m){const F=this.offset;this.write(m),this.proxy.$update(this.id,P.OutputChannelUpdateMode.Replace,F),this.visible&&this.logger.flush()}show(m,F){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof m=="boolean"?m:F))}hide(){this.proxy.$close(this.id)}write(m){this.offset+=i.VSBuffer.fromString(m).byteLength,this.logger.info(m)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=d;let l=class{constructor(m,F,S,b,p){this.extHostFileSystem=S,this.extHostFileSystemInfo=b,this.loggerService=p,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=m.getProxy(r.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(F.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(m){this.visibleChannelId=m;for(const[F,S]of this.channels)S.visible=F===this.visibleChannelId}createOutputChannel(m,F){if(m=m.trim(),!m)throw new Error("illegal argument `name`. must not be falsy");const S=this.doCreateOutputChannel(m,F);return S.then(b=>{this.channels.set(b.id,b),b.visible=b.id===this.visibleChannelId}),this.createExtHostOutputChannel(m,S)}async doCreateOutputChannel(m,F){const S=await this.createOutputDirectory(),b=this.extHostFileSystemInfo.extUri.joinPath(S,`${this.namePool++}-${m.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.loggerService.createLogger(b,{always:!0,donotRotate:!0,donotUseFormatters:!0}),C=await this.proxy.$register(m,!1,b,F.identifier.value);return new d(C,m,p,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(m,F){let S=!1;const b=()=>{if(S)throw new Error("Channel has been closed")};return{get name(){return m},append(p){b(),F.then(C=>C.append(p))},appendLine(p){b(),F.then(C=>C.appendLine(p))},clear(){b(),F.then(p=>p.clear())},replace(p){b(),F.then(C=>C.replace(p))},show(p,C){b(),F.then(a=>a.show(p,C))},hide(){b(),F.then(p=>p.hide())},dispose(){S=!0,F.then(p=>p.dispose())}}}};l=Be([$e(0,A.IExtHostRpcService),$e(1,T.IExtHostInitDataService),$e(2,D.IExtHostConsumerFileSystem),$e(3,R.IExtHostFileSystemInfo),$e(4,I.ILoggerService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(ye[196],_e([0,1,13,20,4,6,5,2,7,15,16,34,61,26]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(s,m,F){const S=s.getProxy(I.MainContext.MainThreadQuickOpen);class b{constructor(c,h){this._sessions=new Map,this._instances=0,this._workspace=c,this._commands=h}showQuickPick(c,h,g=t.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(c),v=++this._instances,k=S.$show(v,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},g),x={},N=k.then(()=>x);return Promise.race([N,E]).then(y=>{if(y!==x)return E.then(L=>{const W=[];for(let B=0;B<L.length;B++){const $=L[B];typeof $=="string"?W.push({label:$,handle:B}):$.kind===D.QuickPickItemKind.Separator?W.push({type:"separator",label:$.label}):W.push({label:$.label,description:$.description,detail:$.detail,picked:$.picked,alwaysShow:$.alwaysShow,handle:B})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{h.onDidSelectItem(L[B])}),S.$setItems(v,W),k.then(B=>{if(typeof B=="number")return L[B];if(Array.isArray(B))return B.map($=>L[$])})})}).then(void 0,y=>{if(!(0,T.isCancellationError)(y))return S.$setError(v,y),Promise.reject(y)})}$onItemSelected(c){this._onDidSelectItem&&this._onDidSelectItem(c)}showInput(c,h=t.CancellationToken.None){return this._validateInput=c?c.validateInput:void 0,S.$input(c,typeof this._validateInput=="function",h).then(void 0,g=>{if(!(0,T.isCancellationError)(g))return Promise.reject(g)})}$validateInput(c){return this._validateInput?(0,r.asPromise)(()=>this._validateInput(c)):Promise.resolve(void 0)}async showWorkspaceFolderPick(c,h=t.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!g)return;const E=await this._workspace.getWorkspaceFolders2();if(!!E)return E.find(v=>v.uri.toString()===g.uri.toString())}createQuickPick(c){const h=new n(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(c){const h=new u(c,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}$onDidChangeValue(c,h){const g=this._sessions.get(c);g&&g._fireDidChangeValue(h)}$onDidAccept(c){const h=this._sessions.get(c);h&&h._fireDidAccept()}$onDidChangeActive(c,h){const g=this._sessions.get(c);g instanceof n&&g._fireDidChangeActive(h)}$onDidChangeSelection(c,h){const g=this._sessions.get(c);g instanceof n&&g._fireDidChangeSelection(h)}$onDidTriggerButton(c,h){const g=this._sessions.get(c);g&&g._fireDidTriggerButton(h)}$onDidTriggerItemButton(c,h,g){const E=this._sessions.get(c);E instanceof n&&E._fireDidTriggerItemButton(h,g)}$onDidHide(c){const h=this._sessions.get(c);h&&h._fireDidHide()}}class p{constructor(c,h){this._extensionId=c,this._onDidDispose=h,this._id=n._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new _.Emitter,this._onDidChangeValueEmitter=new _.Emitter,this._onDidTriggerButtonEmitter=new _.Emitter,this._onDidHideEmitter=new _.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(c){this._title=c,this.update({title:c})}get step(){return this._steps}set step(c){this._steps=c,this.update({step:c})}get totalSteps(){return this._totalSteps}set totalSteps(c){this._totalSteps=c,this.update({totalSteps:c})}get enabled(){return this._enabled}set enabled(c){this._enabled=c,this.update({enabled:c})}get busy(){return this._busy}set busy(c){this._busy=c,this.update({busy:c})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(c){this._ignoreFocusOut=c,this.update({ignoreFocusOut:c})}get value(){return this._value}set value(c){this._value=c,this.update({value:c})}get placeholder(){return this._placeholder}set placeholder(c){this._placeholder=c,this.update({placeholder:c})}get buttons(){return this._buttons}set buttons(c){this._buttons=c.slice(),this._handlesToButtons.clear(),c.forEach((h,g)=>{const E=h===D.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(E,h)}),this.update({buttons:c.map((h,g)=>({...o(h),tooltip:h.tooltip,handle:h===D.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(c){this._value=c,this._onDidChangeValueEmitter.fire(c)}_fireDidTriggerButton(c){const h=this._handlesToButtons.get(c);h&&this._onDidTriggerButtonEmitter.fire(h)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),S.$dispose(this._id))}update(c){if(!this._disposed){for(const h of Object.keys(c)){const g=c[h];this._pendingUpdate[h]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){S.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function C(f){if(f instanceof D.ThemeIcon)return{id:f.id};const c=M(f),h=a(f);return{dark:typeof c=="string"?P.URI.file(c):c,light:typeof h=="string"?P.URI.file(h):h}}function a(f){return typeof f=="object"&&"light"in f?f.light:f}function M(f){return typeof f=="object"&&"dark"in f?f.dark:f}function o(f){const c=C(f.iconPath);let h,g;return"id"in c?g=i.ThemeIcon.asClassName(c):h=c,{iconPath:h,iconClass:g}}class n extends p{constructor(c,h){super(c.identifier,h);this.extension=c,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new _.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new _.Emitter,this._onDidTriggerItemButtonEmitter=new _.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(c){c.some(g=>g.kind!==void 0)&&(0,d.checkProposedApiEnabled)(this.extension,"quickPickSeparators"),this._items=c.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),c.forEach((g,E)=>{this._handlesToItems.set(E,g),this._itemsToHandles.set(g,E)});const h=[];for(let g=0;g<c.length;g++){const E=c[g];E.kind===D.QuickPickItemKind.Separator?h.push({type:"separator",label:E.label}):h.push({handle:g,label:E.label,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,buttons:E.buttons?.map((v,k)=>({...o(v),tooltip:v.tooltip,handle:k}))})}this.update({items:h})}get canSelectMany(){return this._canSelectMany}set canSelectMany(c){this._canSelectMany=c,this.update({canSelectMany:c})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(c){this._matchOnDescription=c,this.update({matchOnDescription:c})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(c){this._matchOnDetail=c,this.update({matchOnDetail:c})}get sortByLabel(){return this._sortByLabel}set sortByLabel(c){this._sortByLabel=c,this.update({sortByLabel:c})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(c){this._keepScrollPosition=c,this.update({keepScrollPosition:c})}get activeItems(){return this._activeItems}set activeItems(c){this._activeItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({activeItems:this._activeItems.map(h=>this._itemsToHandles.get(h))})}get selectedItems(){return this._selectedItems}set selectedItems(c){this._selectedItems=c.filter(h=>this._itemsToHandles.has(h)),this.update({selectedItems:this._selectedItems.map(h=>this._itemsToHandles.get(h))})}_fireDidChangeActive(c){const h=(0,R.coalesce)(c.map(g=>this._handlesToItems.get(g)));this._activeItems=h,this._onDidChangeActiveEmitter.fire(h)}_fireDidChangeSelection(c){const h=(0,R.coalesce)(c.map(g=>this._handlesToItems.get(g)));this._selectedItems=h,this._onDidChangeSelectionEmitter.fire(h)}_fireDidTriggerItemButton(c,h){const g=this._handlesToItems.get(c);if(!g||!g.buttons||!g.buttons.length)return;const E=g.buttons[h];E&&this._onDidTriggerItemButtonEmitter.fire({button:E,item:g})}}class u extends p{constructor(c,h){super(c,h);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(c){this._password=c,this.update({password:c})}get prompt(){return this._prompt}set prompt(c){this._prompt=c,this.update({prompt:c})}get validationMessage(){return this._validationMessage}set validationMessage(c){this._validationMessage=c,this.update({validationMessage:c,severity:c?w.default.Error:w.default.Ignore})}}return new b(m,F)}e.createExtHostQuickOpen=l});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[197],_e([0,1,2,4,53,6,13,5,16,104,12,25,61,8,26]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l){"use strict";var s,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function F(h){if(h)return typeof h.iconPath=="string"?r.URI.file(h.iconPath):r.URI.isUri(h.iconPath)||i.ThemeIcon.isThemeIcon(h.iconPath)?h.iconPath:void 0}function S(h,g){if(!h.iconPath&&!g.iconPath)return 0;if(h.iconPath){if(!g.iconPath)return 1}else return-1;const E=typeof h.iconPath=="string"?h.iconPath:r.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id,v=typeof g.iconPath=="string"?g.iconPath:r.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,T.comparePaths)(E,v)}function b(h,g){let E=0;if(h.strikeThrough!==g.strikeThrough)return h.strikeThrough?1:-1;if(h.faded!==g.faded)return h.faded?1:-1;if(h.tooltip!==g.tooltip)return(h.tooltip||"").localeCompare(g.tooltip||"");if(E=S(h,g),E!==0)return E;if(h.light&&g.light)E=S(h.light,g.light);else{if(h.light)return 1;if(g.light)return-1}if(E!==0)return E;if(h.dark&&g.dark)E=S(h.dark,g.dark);else{if(h.dark)return 1;if(g.dark)return-1}return E}function p(h,g){if(h.command!==g.command)return h.command<g.command?-1:1;if(h.title!==g.title)return h.title<g.title?-1:1;if(h.tooltip!==g.tooltip){if(h.tooltip!==void 0&&g.tooltip!==void 0)return h.tooltip<g.tooltip?-1:1;if(h.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(h.arguments===g.arguments)return 0;if(h.arguments)if(g.arguments){if(h.arguments.length!==g.arguments.length)return h.arguments.length-g.arguments.length}else return 1;else return-1;for(let E=0;E<h.arguments.length;E++){const v=h.arguments[E],k=g.arguments[E];if(v!==k)return v<k?-1:1}return 0}function C(h,g){let E=(0,T.comparePaths)(h.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(E!==0)return E;if(h.command&&g.command)E=p(h.command,g.command);else{if(h.command)return 1;if(g.command)return-1}if(E!==0)return E;if(h.decorations&&g.decorations)E=b(h.decorations,g.decorations);else{if(h.decorations)return 1;if(g.decorations)return-1}return E}function a(h,g){for(let E=0;E<h.length;E++)if(h[E]!==g[E])return!1;return!0}function M(h,g){return h.command===g.command&&h.title===g.title&&h.tooltip===g.tooltip&&(h.arguments&&g.arguments?a(h.arguments,g.arguments):h.arguments===g.arguments)}function o(h,g){return(0,D.equals)(h,g,M)}class n{constructor(g,E,v){this._extension=g,this._sourceControlHandle=v,s.set(this,void 0),this._value="",this._onDidChange=new t.Emitter,this._placeholder="",this._visible=!0,Xe(this,s,E,"f")}get value(){return this._value}set value(g){g=g??"",Ie(this,s,"f").$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){Ie(this,s,"f").$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(g){if((0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,Ie(this,s,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,Ie(this,s,"f").$setInputBoxVisibility(this._sourceControlHandle,g))}showValidationMessage(g,E){(0,l.checkProposedApiEnabled)(this._extension,"scmValidation"),Ie(this,s,"f").$showValidationMessage(this._sourceControlHandle,g,E)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=n,s=new WeakMap;class u{constructor(g,E,v,k,x){this._proxy=g,this._commands=E,this._sourceControlHandle=v,this._id=k,this._label=x,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new t.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,E){const v=this._resourceStatesCommandsMap.get(g);return v?(0,I.asPromise)(()=>this._commands.executeCommand(v.command,...v.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(C),v=(0,D.sortedDiff)(this._resourceSnapshot,g,C).map(N=>{const y=N.toInsert.map(L=>{const W=this._resourceHandlePool++;this._resourceStatesMap.set(W,L);const B=L.resourceUri;let $;if(L.command)if(L.command.command==="vscode.open"||L.command.command==="vscode.diff"){const Ee=new A.DisposableStore;$=this._commands.converter.toInternal(L.command,Ee),this._resourceStatesDisposablesMap.set(W,Ee)}else this._resourceStatesCommandsMap.set(W,L.command);const q=F(L.decorations),ie=L.decorations&&F(L.decorations.light)||q,se=L.decorations&&F(L.decorations.dark)||q,X=[ie,se],ge=L.decorations&&L.decorations.tooltip||"",be=L.decorations&&!!L.decorations.strikeThrough,pe=L.decorations&&!!L.decorations.faded,fe=L.contextValue||"";return{rawResource:[W,B,X,ge,be,pe,fe,$],handle:W}});return{start:N.start,deleteCount:N.deleteCount,toInsert:y}}),k=v.map(({start:N,deleteCount:y,toInsert:L})=>[N,y,L.map(W=>W.rawResource)]),x=v.reverse();for(const{start:N,deleteCount:y,toInsert:L}of x){const W=L.map($=>$.handle),B=this._handlesSnapshot.splice(N,y,...W);for(const $ of B)this._resourceStatesMap.delete($),this._resourceStatesCommandsMap.delete($),this._resourceStatesDisposablesMap.get($)?.dispose(),this._resourceStatesDisposablesMap.delete($)}return this._resourceSnapshot=g,k}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class f{constructor(g,E,v,k,x,N){this._extension=g,this._commands=v,this._id=k,this._label=x,this._rootUri=N,m.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new A.MutableDisposable,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new t.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=f._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Xe(this,m,E,"f"),this._inputBox=new n(g,Ie(this,m,"f"),this.handle),Ie(this,m,"f").$registerSourceControl(this.handle,k,x,N)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,Ie(this,m,"f").$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,Ie(this,m,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,Ie(this,m,"f").$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=g;const E=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);Ie(this,m,"f").$updateSourceControl(this.handle,{acceptInputCommand:E})}get actionButton(){return(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(g){(0,l.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new A.DisposableStore,this._actionButton=g;const E=g!==void 0?this._commands.converter.toInternal(this._actionButton,this._actionButtonDisposables.value):void 0;Ie(this,m,"f").$updateSourceControl(this.handle,{actionButton:E??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&o(this._statusBarCommands,g))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=g;const E=(g||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));Ie(this,m,"f").$updateSourceControl(this.handle,{statusBarCommands:E})}get selected(){return this._selected}createResourceGroup(g,E){const v=new u(Ie(this,m,"f"),this._commands,this.handle,g,E),k=t.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,k),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const g=[],E=[];for(const[v,k]of this.createdResourceGroups){k.dispose();const x=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});t.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),x.dispose(),this._groups.delete(v.handle),Ie(this,m,"f").$unregisterGroup(this.handle,v.handle)}),g.push([v.handle,v.id,v.label,v.features]);const N=v._takeResourceStateSnapshot();N.length>0&&E.push([v.handle,N]),this._groups.set(v.handle,v)}Ie(this,m,"f").$registerGroups(this.handle,g,E),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(E=>{const v=E._takeResourceStateSnapshot();v.length!==0&&g.push([E.handle,v])}),g.length>0&&Ie(this,m,"f").$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),Ie(this,m,"f").$unregisterSourceControl(this.handle)}}m=new WeakMap,f._handlePool=0,Be([(0,_.debounce)(100)],f.prototype,"eventuallyAddResourceGroups",null),Be([(0,_.debounce)(100)],f.prototype,"eventuallyUpdateResourceStates",null);let c=class Vi{constructor(g,E,v){this._commands=E,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new t.Emitter,this._proxy=g.getProxy(P.MainContext.MainThreadSCM),this._telemetry=g.getProxy(P.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===3){const x=this._sourceControls.get(k.sourceControlHandle);if(!x)return k;const N=x.getResourceGroup(k.groupHandle);return N?N.getResourceState(k.handle):k}else if(k&&k.$mid===4){const x=this._sourceControls.get(k.sourceControlHandle);return x?x.getResourceGroup(k.groupHandle):k}else if(k&&k.$mid===5){const x=this._sourceControls.get(k.handle);return x||k}return k}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,E,v,k){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,E,v,k),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const x=Vi._handlePool++,N=new f(g,this._proxy,this._commands,E,v,k);this._sourceControls.set(x,N);const y=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(g.identifier))||[];return y.push(N),this._sourceControlsByExtension.set(w.ExtensionIdentifier.toKey(g.identifier),y),N}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const E=this._sourceControlsByExtension.get(w.ExtensionIdentifier.toKey(g.identifier)),v=E&&E[E.length-1];return v&&v.inputBox}$provideOriginalResource(g,E,v){const k=r.URI.revive(E);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,k.toString());const x=this._sourceControls.get(g);return!x||!x.quickDiffProvider||!x.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,I.asPromise)(()=>x.quickDiffProvider.provideOriginalResource(k,v)).then(N=>N||null)}$onInputBoxValueChange(g,E){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const v=this._sourceControls.get(g);return v&&v.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(g,E,v,k){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,E,v);const x=this._sourceControls.get(g);if(!x)return Promise.resolve(void 0);const N=x.getResourceGroup(E);return N?N.$executeResourceCommand(v,k):Promise.resolve(void 0)}$validateInput(g,E,v){this.logService.trace("ExtHostSCM#$validateInput",g);const k=this._sourceControls.get(g);return!k||!k.inputBox.validateInput?Promise.resolve(void 0):(0,I.asPromise)(()=>k.inputBox.validateInput(E,v)).then(x=>{if(!x)return Promise.resolve(void 0);const N=d.MarkdownString.fromStrict(x.message);return N?Promise.resolve([N,x.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};c._handlePool=0,c=Be([$e(2,R.ILogService)],c),e.ExtHostSCM=c});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[198],_e([0,1,7,5,121,6,8,10]),function(ee,e,r,t,_,A,I,P){"use strict";var D,T;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(l,s,m,F,S=r.StatusBarAlignment.Left,b){D.set(this,void 0),T.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,Xe(this,D,l,"f"),Xe(this,T,s,"f"),this._entryId=R.ID_GEN++,this._extension=m,this._id=F,this._alignment=S,this._priority=this.validatePriority(b)}validatePriority(l){if(!!(0,P.isNumber)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(l){this._text=l,this.update()}set name(l){this._name=l,this.update()}set tooltip(l){this._tooltip=l,this.update()}set color(l){this._color=l,this.update()}set backgroundColor(l){l&&!R.ALLOWED_BACKGROUND_COLORS.has(l.id)&&(l=void 0),this._backgroundColor=l,this.update()}set command(l){this._command?.fromApi!==l&&(this._internalCommandRegistration.clear(),typeof l=="string"?this._command={fromApi:l,internal:Ie(this,T,"f").toInternal({title:"",command:l},this._internalCommandRegistration)}:l?this._command={fromApi:l,internal:Ie(this,T,"f").toInternal(l,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(l){this._accessibilityInformation=l,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ie(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let l;this._extension?this._id?l=`${this._extension.identifier.value}.${this._id}`:l=this._extension.identifier.value:l=this._id;let s;this._name?s=this._name:s=(0,_.localize)(0,null,this._extension.displayName||this._extension.name);let m=this._color;this._backgroundColor&&(m=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const F=this._tooltip?I.MarkdownString.fromStrict(this._tooltip):void 0;Ie(this,D,"f").$setEntry(this._entryId,l,s,this._text,F,this._command?.internal,m,this._backgroundColor,this._alignment===r.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,D=new WeakMap,T=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new r.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(l){this._messages=[],this._item=l.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,_.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(l){const s={message:l};return this._messages.unshift(s),this._update(),new r.Disposable(()=>{const m=this._messages.indexOf(s);m>=0&&(this._messages.splice(m,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(l,s){this._proxy=l.getProxy(t.MainContext.MainThreadStatusBar),this._commands=s,this._statusMessage=new w(this)}createStatusBarEntry(l,s,m,F){return new R(this._proxy,this._commands,l,s,m,F)}setStatusBarMessage(l,s){const m=this._statusMessage.setMessage(l);let F;return typeof s=="number"?F=setTimeout(()=>m.dispose(),s):typeof s!="undefined"&&s.then(()=>m.dispose(),()=>m.dispose()),new r.Disposable(()=>{m.dispose(),clearTimeout(F)})}}e.ExtHostStatusBar=i}),define(ye[70],_e([0,1,5,4,3]),function(ee,e,r,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(P){this._onDidChangeStorage=new t.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(r.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this._proxy.$registerExtensionStorageKeysToSync(P,D)}initializeExtensionStorage(P,D,T){return this._proxy.$initializeExtensionStorage(P,D).then(R=>R||T)}setValue(P,D,T){return this._proxy.$setValue(P,D,T)}$acceptValue(P,D,T){this._onDidChangeStorage.fire({shared:P,key:D,value:T})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,_.createDecorator)("IExtHostStorage")}),define(ye[71],_e([0,1,3,28,12,50,2]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,r.createDecorator)("IExtensionStoragePaths");let P=class{constructor(T,R,w){this._logService=R,this._extHostFileSystem=w,this._workspace=T.workspace??void 0,this._environment=T.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(i=>this._value=i)}async _getWorkspaceStorageURI(T){return I.URI.joinPath(this._environment.workspaceStorageHome,T)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const T=this._workspace.id,R=await this._getWorkspaceStorageURI(T);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(I.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:I.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(w){this._logService.error("[ExtHostStorage]",w);return}}workspaceValue(T){if(this._value)return I.URI.joinPath(this._value,T.identifier.value)}globalValue(T){return I.URI.joinPath(this._environment.globalStorageHome,T.identifier.value.toLowerCase())}onWillDeactivateAll(){}};P=Be([$e(0,t.IExtHostInitDataService),$e(1,_.ILogService),$e(2,A.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(ye[40],_e([0,1,4,5,3,2,14,6,7,122,15,161,20,36,144,61,10,13]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,_.createDecorator)("IExtHostTerminalService");class S{constructor(f,c,h,g){this._proxy=f,this._id=c,this._creationOptions=h,this._name=g,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(v=>this._pidPromiseComplete=v);const E=this;this.value={get name(){return E._name||""},get processId(){return E._pidPromise},get creationOptions(){return E._creationOptions},get exitStatus(){return E._exitStatus},get state(){return E._state},sendText(v,k=!0){E._checkDisposed(),E._proxy.$sendText(E._id,v,k)},show(v){E._checkDisposed(),E._proxy.$show(E._id,v)},hide(){E._checkDisposed(),E._proxy.$hide(E._id)},dispose(){E._disposed||(E._disposed=!0,E._proxy.$dispose(E._id))},get dimensions(){if(!(E._cols===void 0||E._rows===void 0))return{columns:E._cols,rows:E._rows}}}}async create(f,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,m.withNullAsUndefined)(f.shellPath),shellArgs:(0,m.withNullAsUndefined)(f.shellArgs),cwd:(0,m.withNullAsUndefined)(f.cwd),env:(0,m.withNullAsUndefined)(f.env),icon:(0,m.withNullAsUndefined)(o(f.iconPath)),color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,m.withNullAsUndefined)(f.message),strictEnv:(0,m.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,m.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,m.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,m.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(f.location,c?.resolvedExtHostIdentifier),disablePersistence:(0,m.withNullAsUndefined)(f.disablePersistence)})}async createExtensionTerminal(f,c,h,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:h,color:s.ThemeColor.isThemeColor(g)?g.id:void 0,location:this._serializeParentTerminal(f,c),disablePersistence:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(f,c){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in f?{viewColumn:f.viewColumn,preserveFocus:f.preserveFocus}:void 0:f}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,c){return f===this._cols&&c===this._rows||f===0||c===0?!1:(this._cols=f,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=S;class b{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new r.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new r.Emitter,this._onDidChangeProperty=new r.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new r.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput?.(f)}resize(f,c){this._pty.setDimensions?.({columns:f,rows:c})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(f||void 0),f&&this._pty.setDimensions?.(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let p=1,C=class extends P.Disposable{constructor(f,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new r.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new r.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new r.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new r.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new r.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(t.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new r.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[h,g]of this._terminalProcesses)g.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,c){const h=new S(this._proxy,(0,d.generateUuid)(),f,f.name),g=new b(f.pty);return h.createExtensionTerminal(f.location,this._serializeParentTerminal(f,c).resolvedExtHostIdentifier,o(f.iconPath),n(f.color)).then(E=>{const v=this._setupExtHostProcessListeners(E,g);this._terminalProcessDisposables[E]=v}),this._terminals.push(h),h.value}_serializeParentTerminal(f,c){if(c=c||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const h=f.location.parentTerminal;if(h){const g=this._terminals.find(E=>E.value===h);g&&(c.resolvedExtHostIdentifier=g._id)}}else f.location&&typeof f.location!="object"?c.location=f.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(f,c){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const g=new b(c),E=this._setupExtHostProcessListeners(f,g);this._terminalProcessDisposables[f]=E}async $acceptActiveTerminalChanged(f){const c=this._activeTerminal;if(f===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const h=this._getTerminalById(f);h&&(this._activeTerminal=h,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,c){const h=this._getTerminalById(f);h&&this._onDidWriteTerminalData.fire({terminal:h.value,data:c})}async $acceptTerminalDimensions(f,c,h){const g=this._getTerminalById(f);g&&g.setDimensions(c,h)&&this._onDidChangeTerminalDimensions.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(f,c,h){this._terminalProcesses.get(f)?.resize(c,h)}async $acceptTerminalTitleChange(f,c){const h=this._getTerminalById(f);h&&(h.name=c)}async $acceptTerminalClosed(f,c){const h=this._getTerminalObjectIndexById(this._terminals,f);if(h!==null){const g=this._terminals.splice(h,1)[0];g.setExitCode(c),this._onDidCloseTerminal.fire(g.value)}}$acceptTerminalOpened(f,c,h,g){if(c){const k=this._getTerminalObjectIndexById(this._terminals,c);if(k!==null){this._terminals[k]._id=f,this._onDidOpenTerminal.fire(this.terminals[k]),this._terminals[k].isOpen=!0;return}}const E={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:A.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},v=new S(this._proxy,f,E,h);this._terminals.push(v),this._onDidOpenTerminal.fire(v.value),v.isOpen=!0}async $acceptTerminalProcessId(f,c){const h=this._getTerminalById(f);h&&h._setProcessId(c)}async $startExtensionTerminal(f,c){const h=this._getTerminalById(f);if(!h)return{message:(0,T.localize)(0,null,f)};h.isOpen||await new Promise(E=>{const v=this.onDidOpenTerminal(async k=>{k===h.value&&(v.dispose(),E())})});const g=this._terminalProcesses.get(f);g?g.startSendingEvents(c):this._extensionTerminalAwaitingStart[f]={initialDimensions:c}}_setupExtHostProcessListeners(f,c){const h=new P.DisposableStore;h.add(c.onProcessReady(E=>this._proxy.$sendProcessReady(f,E.pid,E.cwd))),h.add(c.onDidChangeProperty(E=>this._proxy.$sendProcessProperty(f,E))),this._bufferer.startBuffering(f,c.onProcessData),h.add(c.onProcessExit(E=>this._onProcessExit(f,E))),this._terminalProcesses.set(f,c);const g=this._extensionTerminalAwaitingStart[f];return g&&c instanceof b&&(c.startSendingEvents(g.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),h}$acceptProcessAckDataEvent(f,c){this._terminalProcesses.get(f)?.acknowledgeDataEvent(c)}$acceptProcessInput(f,c){this._terminalProcesses.get(f)?.input(c)}$acceptTerminalInteraction(f){const c=this._getTerminalById(f);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(f,c,h){try{this._terminalProcesses.get(f)?.resize(c,h)}catch(g){if(g.code!=="EPIPE"&&g.code!=="ERR_IPC_CHANNEL_CLOSED")throw g}}$acceptProcessShutdown(f,c){this._terminalProcesses.get(f)?.shutdown(c)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(f,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(c=>this._proxy.$sendProcessProperty(f,{type:"cwd",value:c}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,c,h){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,h),this._proxy.$registerProfileProvider(c,f.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(f,c){const h=new i.CancellationTokenSource().token;let g=await this._profileProviders.get(f)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(g&&!("options"in g)&&(g={options:g}),!g||!("options"in g))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in g.options){this.createExtensionTerminal(g.options,c);return}this.createTerminalFromOptions(g.options,c)}}async $provideLinks(f,c){const h=this._getTerminalById(f);if(!h)return[];this._terminalLinkCache.delete(f);const g=this._terminalLinkCancellationSource.get(f);g&&g.dispose(!0);const E=new i.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,E);const v=[],k={terminal:h.value,line:c},x=[];for(const L of this._linkProviders)x.push(F.Promises.withAsyncBody(async W=>{E.token.onCancellationRequested(()=>W({provider:L,links:[]}));const B=await L.provideTerminalLinks(k,E.token)||[];E.token.isCancellationRequested||W({provider:L,links:B})}));const N=await Promise.all(x);if(E.token.isCancellationRequested)return[];const y=new Map;for(const L of N)L&&L.links.length>0&&v.push(...L.links.map(W=>{const B={id:p++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return y.set(B.id,{provider:L.provider,link:W}),B}));return this._terminalLinkCache.set(f,y),v}$activateLink(f,c){const h=this._terminalLinkCache.get(f)?.get(c);!h||h.provider.handleTerminalLink(h.link)}_onProcessExit(f,c){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const h=this._terminalProcessDisposables[f];h&&(h.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,c)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,c){const h=this._getTerminalObjectIndexById(f,c);return h!==null?f[h]:null}_getTerminalObjectIndexById(f,c){let h=null;return f.some((g,E)=>g._id===c?(h=E,!0):!1),h}getEnvironmentVariableCollection(f){let c=this._environmentVariableCollections.get(f.identifier.value);return c||(c=new a,this._setEnvironmentVariableCollection(f.identifier.value,c)),c}_syncEnvironmentVariableCollection(f,c){const h=(0,w.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(f,c.persistent,h.length===0?void 0:h)}$initEnvironmentVariableCollections(f){f.forEach(c=>{const h=c[0],g=new a(c[1]);this._setEnvironmentVariableCollection(h,g)})}$acceptDefaultProfile(f,c){this._defaultProfile=f,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(f,c){this._environmentVariableCollections.set(f,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,c)})}};C=Be([$e(1,I.IExtHostRpcService)],C),e.BaseExtHostTerminalService=C;class a{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new r.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,c){this._setIfDiffers(f,{value:c,type:D.EnvironmentVariableMutatorType.Replace})}append(f,c){this._setIfDiffers(f,{value:c,type:D.EnvironmentVariableMutatorType.Append})}prepend(f,c){this._setIfDiffers(f,{value:c,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,c){const h=this.map.get(f);(!h||h.value!==c.value||h.type!==c.type)&&(this.map.set(f,c),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,c){this.map.forEach((h,g)=>f.call(c,g,h,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let M=class extends C{constructor(f){super(!1,f)}createTerminal(f,c,h){throw new R.NotSupportedError}createTerminalFromOptions(f,c){throw new R.NotSupportedError}};M=Be([$e(0,I.IExtHostRpcService)],M),e.WorkerExtHostTerminalService=M;function o(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function n(u){return s.ThemeColor.isThemeColor(u)?u:void 0}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[199],_e([0,1,16,21,20,4,231,92,6,27,10,36,5,14,48,8,7,167,86,66]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let C=class{constructor(k,x){this.resultsChangedEmitter=new A.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=k.getProxy(i.MainContext.MainThreadTesting),this.observer=new h(this.proxy),this.runTracker=new M(this.proxy),x.registerArgumentProcessor({processArgument:N=>N?.$mid===13?s.TestItem.toItemFromContext(N):N})}createTestController(k,x,N){if(this.controllers.has(k))throw new Error(`Attempt to insert a duplicate controller with ID "${k}"`);const y=new D.DisposableStore,L=y.add(new F.SingleUseTestCollection(k));L.root.label=x;const W=new Map,B=this.proxy,$={items:L.root.children,get label(){return x},set label(ie){x=ie,L.root.label=ie,B.$updateController(k,{label:x})},get refreshHandler(){return N},set refreshHandler(ie){N=ie,B.$updateController(k,{canRefresh:!!ie})},get id(){return k},createRunProfile:(ie,se,X,ge,be)=>{let pe=(0,P.hash)(ie);for(;W.has(pe);)pe++;const fe=new g(this.proxy,k,pe,ie,se,X,ge,be);return W.set(pe,fe),fe},createTestItem(ie,se,X){return new l.TestItemImpl(k,ie,se,X)},createTestRun:(ie,se,X=!0)=>this.runTracker.createTestRun(k,L,ie,se,X),set resolveHandler(ie){L.resolveHandler=ie},get resolveHandler(){return L.resolveHandler},dispose:()=>{y.dispose()}};B.$registerTestController(k,x,!!N),y.add((0,D.toDisposable)(()=>B.$unregisterTestController(k)));const q={controller:$,collection:L,profiles:W};return this.controllers.set(k,q),y.add((0,D.toDisposable)(()=>this.controllers.delete(k))),y.add(L.onDidGenerateDiff(ie=>B.$publishDiff(k,ie))),$}createTestObserver(){return this.observer.checkout()}async runTests(k,x=_.CancellationToken.None){const N=o(k);if(!N)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const y=this.controllers.get(N.controllerId);if(!y)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:k.include?.map(L=>L.id)??[y.collection.root.id],profileGroup:E[N.kind],profileId:N.profileId,controllerId:N.controllerId}],exclude:k.exclude?.map(L=>L.id)},x)}$provideFileCoverage(k,x,N){return(0,r.mapFind)(this.runTracker.trackers,L=>L.id===k?L.getCoverage(x):void 0)?.provideFileCoverage(N)??Promise.resolve([])}$resolveFileCoverage(k,x,N,y){return(0,r.mapFind)(this.runTracker.trackers,W=>W.id===k?W.getCoverage(x):void 0)?.resolveFileCoverage(N,y)??Promise.resolve([])}$configureRunProfile(k,x){this.controllers.get(k)?.profiles.get(x)?.configureHandler?.()}async $refreshTests(k,x){await this.controllers.get(k)?.controller.refreshHandler?.(x)}$publishTestResults(k){this.results=Object.freeze(k.map(x=>(0,T.deepFreeze)(s.TestResults.to(x))).concat(this.results).sort((x,N)=>N.completedAt-x.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(k,x){const N=this.controllers.get(b.TestId.fromString(k).controllerId)?.collection;N&&(await N.expand(k,x<0?1/0:x),N.flushDiff())}$acceptDiff(k){this.observer.applyDiff(k)}async $runControllerTests(k,x){const N=this.controllers.get(k.controllerId);if(!N)return;const{collection:y,profiles:L}=N,W=L.get(k.profileId);if(!W)return;const B=k.testIds.map(se=>y.tree.get(se)).filter(R.isDefined),$=k.excludeExtIds.map(se=>N.collection.tree.get(se)).filter(R.isDefined).filter(se=>B.some(X=>X.fullId.compare(se.fullId)===2));if(!B.length)return;const q=new m.TestRunRequest(B.some(se=>se.actual instanceof l.TestItemRootImpl)?void 0:B.map(se=>se.actual),$.map(se=>se.actual),W),ie=this.runTracker.prepareForMainThreadTestRun(q,n.fromInternal(k,N.collection),x);try{await W.runHandler(q,x)}finally{ie.isRunning&&!x.isCancellationRequested&&await A.Event.toPromise(ie.onEnd),ie.dispose()}}$cancelExtensionTestRun(k){k===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(k)}};C=Be([$e(0,d.IExtHostRpcService)],C),e.ExtHostTesting=C;class a extends D.Disposable{constructor(k,x,N){super();this.dto=k,this.proxy=x,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new _.CancellationTokenSource(N)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:y}of this.tasks.values())y.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(k){return this.tasks.get(k)?.coverage}createRun(k){const x=this.dto.id,N=this.dto.controllerId,y=(0,w.generateUuid)(),L=new u(this.proxy,x,y),W=ie=>(se,...X)=>{if($){console.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(se)||(this.ensureTestIsKnown(se),ie(se,...X))},B=(ie,se)=>{const X=se instanceof Array?se.map(s.TestMessage.from):[s.TestMessage.from(se)];if(ie.uri&&ie.range){const ge={range:s.Range.from(ie.range),uri:ie.uri};for(const be of X)be.location=be.location||ge}this.proxy.$appendTestMessagesInRun(x,y,b.TestId.fromExtHostTestItem(ie,N).toString(),X)};let $=!1;const q={isPersisted:this.dto.isPersisted,token:this.cts.token,name:k,get coverageProvider(){return L.coverageProvider},set coverageProvider(ie){L.coverageProvider=ie},enqueued:W(ie=>{this.proxy.$updateTestStateInRun(x,y,b.TestId.fromExtHostTestItem(ie,N).toString(),1)}),skipped:W(ie=>{this.proxy.$updateTestStateInRun(x,y,b.TestId.fromExtHostTestItem(ie,N).toString(),5)}),started:W(ie=>{this.proxy.$updateTestStateInRun(x,y,b.TestId.fromExtHostTestItem(ie,N).toString(),2)}),errored:W((ie,se,X)=>{B(ie,se),this.proxy.$updateTestStateInRun(x,y,b.TestId.fromExtHostTestItem(ie,N).toString(),6,X)}),failed:W((ie,se,X)=>{B(ie,se),this.proxy.$updateTestStateInRun(x,y,b.TestId.fromExtHostTestItem(ie,N).toString(),4,X)}),passed:W((ie,se)=>{this.proxy.$updateTestStateInRun(x,y,b.TestId.fromExtHostTestItem(ie,this.dto.controllerId).toString(),3,se)}),appendOutput:(ie,se,X)=>{$||(X&&(this.dto.isIncluded(X)?this.ensureTestIsKnown(X):X=void 0),this.proxy.$appendOutputToRun(x,y,t.VSBuffer.fromString(ie),se&&s.location.from(se),X&&b.TestId.fromExtHostTestItem(X,N).toString()))},end:()=>{$||($=!0,this.proxy.$finishedTestRunTask(x,y),this.tasks.delete(y),this.isRunning||this.dispose())}};return this.tasks.set(y,{run:q,coverage:L}),this.proxy.$startedTestRunTask(x,{id:y,name:k,running:!0}),q}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(k){if(!(k instanceof l.TestItemImpl))throw new l.InvalidTestItemError(k.id);if(this.sharedTestIds.has(b.TestId.fromExtHostTestItem(k,this.dto.controllerId).toString()))return;const x=[],N=this.dto.colllection.root;for(;;){const y=s.TestItem.from(k);if(x.unshift(y),this.sharedTestIds.has(y.extId)||(this.sharedTestIds.add(y.extId),k===N))break;k=k.parent||N}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,x)}}class M{constructor(k){this.proxy=k,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(k,x,N){return this.getTracker(k,x,N)}cancelRunById(k){for(const x of this.tracked.values())if(x.id===k){x.dispose();return}}cancelAllRuns(){for(const k of this.tracked.values())k.dispose()}createTestRun(k,x,N,y,L){const W=this.tracked.get(N);if(W)return W.createRun(y);const B=n.fromPublic(k,x,N,L),$=o(N);this.proxy.$startedExtensionTestRun({controllerId:k,profile:$&&{group:E[$.kind],id:$.profileId},exclude:N.exclude?.map(ie=>ie.id)??[],id:B.id,include:N.include?.map(ie=>ie.id)??[x.root.id],persist:L});const q=this.getTracker(N,B);return q.onEnd(()=>this.proxy.$finishedExtensionTestRun(B.id)),q.createRun(y)}getTracker(k,x,N){const y=new a(x,this.proxy,N);return this.tracked.set(k,y),y.onEnd(()=>this.tracked.delete(k)),y}}e.TestRunCoordinator=M;const o=v=>{if(!!v.profile){if(!(v.profile instanceof g))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return v.profile}};class n{constructor(k,x,N,y,L,W){this.controllerId=k,this.id=x,this.isPersisted=L,this.colllection=W,this.includePrefix=N.map(B=>B+"\0"),this.excludePrefix=y.map(B=>B+"\0")}static fromPublic(k,x,N,y){return new n(k,(0,w.generateUuid)(),N.include?.map(L=>b.TestId.fromExtHostTestItem(L,k).toString())??[k],N.exclude?.map(L=>b.TestId.fromExtHostTestItem(L,k).toString())??[],y,x)}static fromInternal(k,x){return new n(k.controllerId,k.runId,k.testIds,k.excludeExtIds,!0,x)}isIncluded(k){const x=b.TestId.fromExtHostTestItem(k,this.controllerId).toString()+"\0";for(const N of this.excludePrefix)if(x===N||x.startsWith(N))return!1;for(const N of this.includePrefix)if(x===N||x.startsWith(N))return!0;return!1}}e.TestRunDto=n;class u{constructor(k,x,N){this.proxy=k,this.runId=x,this.taskId=N}set coverageProvider(k){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!k||(this._coverageProvider=k,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(k){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(k))());try{return(await this.fileCoverage)?.map(s.TestCoverage.fromFile)??[]}catch(x){throw this.fileCoverage=void 0,x}}async resolveFileCoverage(k,x){const N=await this.fileCoverage;let y=N?.[k];return!this._coverageProvider||!N||!y?[]:(y.detailedCoverage||(y=N[k]=await this._coverageProvider.resolveFileCoverage?.(y,x)??y),y.detailedCoverage?.map(s.TestCoverage.fromDetailed)??[])}}class f extends S.IncrementalChangeCollector{constructor(k){super();this.emitter=k,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(k){this.added.add(k)}update(k){Object.assign(k.revived,s.TestItem.toPlain(k.item)),this.added.has(k)||this.updated.add(k)}remove(k){if(this.added.has(k)){this.added.delete(k);return}if(this.updated.delete(k),k.parent&&this.alreadyRemoved.has(k.parent)){this.alreadyRemoved.add(k.item.extId);return}this.removed.add(k)}getChangeEvent(){const{added:k,updated:x,removed:N}=this;return{get added(){return[...k].map(y=>y.revived)},get updated(){return[...x].map(y=>y.revived)},get removed(){return[...N].map(y=>y.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class c extends S.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(k){return this.items.get(k)}getMirroredTestDataByReference(k){return this.items.get(k.id)}createItem(k,x){return{...k,revived:s.TestItem.toPlain(k.item),depth:x?x.depth+1:0,children:new Set}}createChangeCollector(){return new f(this.changeEmitter)}}e.MirroredTestCollection=c;class h{constructor(k){this.proxy=k}checkout(){this.current||(this.current=this.createObserverData());const k=this.current;return k.observers++,{onDidChangeTest:k.tests.onDidChangeTests,get tests(){return[...k.tests.rootTests].map(x=>x.revived)},dispose:(0,I.once)(()=>{--k.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(k){return this.current?.tests.getMirroredTestDataByReference(k)}applyDiff(k){this.current?.tests.apply(k)}createObserverData(){const k=new c;return this.proxy.$subscribeToDiffs(),{observers:0,tests:k}}}class g{constructor(k,x,N,y,L,W,B=!1,$=void 0){this.controllerId=x,this.profileId=N,this._label=y,this.kind=L,this.runHandler=W,this._isDefault=B,this._tag=$,p.set(this,void 0),Xe(this,p,k,"f");const q=E[L];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${L}`);Ie(this,p,"f").$publishTestRunProfile({profileId:N,controllerId:x,tag:$?s.TestTag.namespace(this.controllerId,$.id):null,label:y,group:q,isDefault:B,hasConfigurationHandler:!1})}get label(){return this._label}set label(k){k!==this._label&&(this._label=k,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:k}))}get isDefault(){return this._isDefault}set isDefault(k){k!==this._isDefault&&(this._isDefault=k,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:k}))}get tag(){return this._tag}set tag(k){k?.id!==this._tag?.id&&(this._tag=k,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:k?s.TestTag.namespace(this.controllerId,k.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(k){k!==this._configureHandler&&(this._configureHandler=k,Ie(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!k}))}dispose(){Ie(this,p,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=g,p=new WeakMap;const E={[m.TestRunProfileKind.Coverage]:8,[m.TestRunProfileKind.Debug]:4,[m.TestRunProfileKind.Run]:2}}),define(ye[200],_e([0,1,4,16,5,90,8,7]),function(ee,e,r,t,_,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(R,w){this._extHostDocumentsAndEditors=w,this._onDidChangeTextEditorSelection=new r.Emitter,this._onDidChangeTextEditorOptions=new r.Emitter,this._onDidChangeTextEditorVisibleRanges=new r.Emitter,this._onDidChangeTextEditorViewColumn=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(_.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(i=>this._onDidChangeVisibleTextEditors.fire(i)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(i=>this._onDidChangeActiveTextEditor.fire(i))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const w=this._extHostDocumentsAndEditors.allEditors();return R?w:w.map(i=>i.value)}async showTextDocument(R,w,i){let d;typeof w=="number"?d={position:I.ViewColumn.from(w),preserveFocus:i}:typeof w=="object"?d={position:I.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selection:typeof w.selection=="object"?I.Range.from(w.selection):void 0,pinned:typeof w.preview=="boolean"?!w.preview:void 0}:d={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(R.uri,d),s=l&&this._extHostDocumentsAndEditors.getEditor(l);if(s)return s.value;throw l?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,w){return new A.TextEditorDecorationType(this._proxy,R,w).value}$acceptEditorPropertiesChanged(R,w){const i=this._extHostDocumentsAndEditors.getEditor(R);if(!i)throw new Error("unknown text editor");if(w.options&&i._acceptOptions(w.options),w.selections){const d=w.selections.selections.map(I.Selection.to);i._acceptSelections(d)}if(w.visibleRanges){const d=t.coalesce(w.visibleRanges.map(I.Range.to));i._acceptVisibleRanges(d)}if(w.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i.value,options:{...w.options,lineNumbers:I.TextEditorLineNumbersStyle.to(w.options.lineNumbers)}}),w.selections){const d=P.TextEditorSelectionChangeKind.fromValue(w.selections.source),l=w.selections.selections.map(I.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i.value,selections:l,kind:d})}if(w.visibleRanges){const d=t.coalesce(w.visibleRanges.map(I.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i.value,visibleRanges:d})}}$acceptEditorPositionData(R){for(const w in R){const i=this._extHostDocumentsAndEditors.getEditor(w);if(!i)throw new Error("Unknown text editor");const d=I.ViewColumn.to(R[w]);i.value.viewColumn!==d&&(i._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:i.value,viewColumn:d}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=D}),define(ye[201],_e([0,1,2,3,5,6,7]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,t.createDecorator)("IExtHostTimeline");class P{constructor(R,w){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=R.getProxy(_.MainContext.MainThreadTimeline),w.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===11){const d=i.uri===void 0?void 0:r.URI.revive(i.uri);return this._itemsBySourceAndUriMap.get(i.source)?.get(D(d))?.get(i.handle)}return i}})}async $getTimeline(R,w,i,d,l){return this._providers.get(R)?.provideTimeline(r.URI.revive(w),i,d,l)}registerTimelineProvider(R,w,i,d){const l=new A.DisposableStore,s=this.convertTimelineItem(w.id,d,l).bind(this);let m;w.onDidChange&&(m=w.onDidChange(S=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...S,id:w.id}),this));const F=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...w,scheme:R,onDidChange:void 0,async provideTimeline(S,b,p,C){C?.resetCache&&(l.clear(),F.get(w.id)?.clear());const a=await w.provideTimeline(S,b,p);if(a==null)return;const M=s(S,C);return{...a,source:w.id,items:a.items.map(M)}},dispose(){for(const S of F.values())S.get(w.id)?.clear();m?.dispose(),l.dispose()}})}convertTimelineItem(R,w,i){return(d,l)=>{let s;if(l?.cacheResults){let m=this._itemsBySourceAndUriMap.get(R);m===void 0&&(m=new Map,this._itemsBySourceAndUriMap.set(R,m));const F=D(d);s=m.get(F),s===void 0&&(s=new Map,m.set(F,s))}return m=>{const{iconPath:F,...S}=m,b=`${R}|${m.id??m.timestamp}`;s?.set(b,m);let p,C,a;return m.iconPath&&(F instanceof I.ThemeIcon?a={id:F.id,color:F.color}:r.URI.isUri(F)?(p=F,C=F):{light:p,dark:C}=F),{...S,id:S.id??void 0,handle:b,source:R,command:m.command?w.toInternal(m.command,i):void 0,icon:p,iconDark:C,themeIcon:a,accessibilityInformation:m.accessibilityInformation}}}}registerTimelineProviderCore(R){if(this._providers.get(R.id))throw new Error(`Timeline Provider ${R.id} already exists.`);return this._proxy.$registerTimelineProvider({id:R.id,label:R.label,scheme:R.scheme}),this._providers.set(R.id,R),(0,A.toDisposable)(()=>{for(const i of this._itemsBySourceAndUriMap.values())i.get(R.id)?.clear();this._providers.delete(R.id),this._proxy.$unregisterTimelineProvider(R.id),R.dispose()})}}e.ExtHostTimeline=P;function D(T){return T?.toString()}}),define(ye[202],_e([0,1,6,11,2,5]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class I{constructor(D){this._openers=new Map,this._proxy=D.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,T,R,w){if(this._openers.has(T))throw new Error(`Opener with id '${T}' already registered`);const i=w.schemes.find(d=>!I.supportedSchemes.has(d));if(i)throw new Error(`Scheme '${i}' is not supported. Only http and https are currently supported.`);return this._openers.set(T,R),this._proxy.$registerUriOpener(T,w.schemes,D,w.label),(0,r.toDisposable)(()=>{this._openers.delete(T),this._proxy.$unregisterUriOpener(T)})}async $canOpenUri(D,T,R){const w=this._openers.get(D);if(!w)throw new Error(`Unknown opener with id: ${D}`);const i=_.URI.revive(T);return w.canOpenExternalUri(i,R)}async $openUri(D,T,R){const w=this._openers.get(D);if(!w)throw new Error(`Unknown opener id: '${D}'`);return w.openExternalUri(_.URI.revive(T.resolvedUri),{sourceUri:_.URI.revive(T.sourceUri)},R)}}e.ExtHostUriOpeners=I,I.supportedSchemes=new Set([t.Schemas.http,t.Schemas.https])}),define(ye[203],_e([0,1,5,2,6,15,25]),function(ee,e,r,t,_,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(T){this.handles=new Set,this.handlers=new Map,this._proxy=T.getProxy(r.MainContext.MainThreadUrls)}registerUriHandler(T,R){if(this.handles.has(I.ExtensionIdentifier.toKey(T)))throw new Error(`Protocol handler already registered for extension ${T}`);const w=P.HandlePool++;return this.handles.add(I.ExtensionIdentifier.toKey(T)),this.handlers.set(w,R),this._proxy.$registerUriHandler(w,T),(0,_.toDisposable)(()=>{this.handles.delete(I.ExtensionIdentifier.toKey(T)),this.handlers.delete(w),this._proxy.$unregisterUriHandler(w)})}$handleExternalUri(T,R){const w=this.handlers.get(T);if(!w)return Promise.resolve(void 0);try{w.handleUri(t.URI.revive(R))}catch(i){(0,A.onUnexpectedError)(i)}return Promise.resolve(void 0)}async createAppUri(T){return t.URI.revive(await this._proxy.$createAppUri(T))}}e.ExtHostUrls=P,P.HandlePool=0});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[51],_e([0,1,4,11,2,131,151,65,5]),function(ee,e,r,t,_,A,I,P,D){"use strict";var T,R,w,i,d,l,s,m,F,S,b,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class C{constructor(h,g,E,v,k,x,N){T.set(this,void 0),R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),d.set(this,void 0),l.set(this,void 0),s.set(this,""),m.set(this,void 0),F.set(this,!1),S.set(this,!1),b.set(this,!1),this._onMessageEmitter=new r.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new r.Emitter),this._onDidDispose=Ie(this,p,"f").event,Xe(this,T,h,"f"),Xe(this,R,g,"f"),Xe(this,m,E,"f"),Xe(this,i,v,"f"),Xe(this,d,k,"f"),Xe(this,l,x,"f"),Xe(this,b,a(x),"f"),Xe(this,w,N,"f")}dispose(){Xe(this,F,!0,"f"),Ie(this,p,"f").fire(),Ie(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(h){return Xe(this,S,!0,"f"),(0,P.asWebviewUri)(h,Ie(this,i,"f").remote)}get cspSource(){const h=Ie(this,l,"f").extensionLocation;if(h.scheme===t.Schemas.https||h.scheme===t.Schemas.http){let g=h.toString();return g.endsWith("/")||(g+="/"),g+" "+P.webviewGenericCspSource}return P.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ie(this,s,"f")}set html(h){this.assertNotDisposed(),Ie(this,s,"f")!==h&&(Xe(this,s,h,"f"),!Ie(this,S,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(h)&&(Xe(this,S,!0,"f"),Ie(this,w,"f").report("Webview vscode-resource: uris",Ie(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ie(this,R,"f").$setHtml(Ie(this,T,"f"),h))}get options(){return this.assertNotDisposed(),Ie(this,m,"f")}set options(h){this.assertNotDisposed(),Ie(this,R,"f").$setOptions(Ie(this,T,"f"),n(Ie(this,l,"f"),Ie(this,d,"f"),h)),Xe(this,m,h,"f")}async postMessage(h){if(Ie(this,F,"f"))return!1;const g=(0,I.serializeWebviewMessage)(h,{serializeBuffersForPostMessage:Ie(this,b,"f")});return Ie(this,R,"f").$postMessage(Ie(this,T,"f"),g.message,...g.buffers)}assertNotDisposed(){if(Ie(this,F,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=C,T=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,d=new WeakMap,l=new WeakMap,s=new WeakMap,m=new WeakMap,F=new WeakMap,S=new WeakMap,b=new WeakMap,p=new WeakMap;function a(c){try{const h=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!h&&h.majorBase>=1&&h.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class M{constructor(h,g,E,v,k){this.initData=g,this.workspace=E,this._logService=v,this._deprecationService=k,this._webviews=new Map,this._webviewProxy=h.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(h,g,E){const v=this.getWebview(h);if(v){const{message:k}=(0,I.deserializeWebviewMessage)(g,E.value);v._onMessageEmitter.fire(k)}}$onMissingCsp(h,g){this._logService.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(h,g,E){const v=new C(h,this._webviewProxy,u(g),this.initData,this.workspace,E,this._deprecationService);return this._webviews.set(h,v),v._onDidDispose(()=>{this._webviews.delete(h)}),v}deleteWebview(h){this._webviews.delete(h)}getWebview(h){return this._webviews.get(h)}}e.ExtHostWebviews=M;function o(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=o;function n(c,h,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||f(c,h)}}e.serializeWebviewOptions=n;function u(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(h=>_.URI.from(h))}}e.reviveOptions=u;function f(c,h){return[...(h?.getWorkspaceFolders()||[]).map(g=>g.uri),c.extensionLocation]}}),define(ye[204],_e([0,1,20,92,6,11,24,2,8,51,62,5,7]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(a,M){this.document=a,this._storagePath=M,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,M){await this.getEdit(a).undo(),M||this.disposeBackup()}async redo(a,M){await this.getEdit(a).redo(),M||this.disposeBackup()}disposeEdits(a){for(const M of a)this._edits.delete(M)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=p(this.document.uri)+this._backupCounter++;return(0,I.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const M=this._edits.get(a,0);if(!M)throw new Error("No edit found");return M}}class l{constructor(){this._documents=new Map}get(a,M){return this._documents.get(this.key(a,M))}add(a,M,o){const n=this.key(a,M.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${a} resource:${M.uri}`);const u=new d(M,o);return this._documents.set(n,u),u}delete(a,M){const o=this.key(a,M.uri);this._documents.delete(o)}key(a,M){return`${a}@@@${M}`}}var s;(function(C){C[C.Text=0]="Text",C[C.Custom=1]="Custom"})(s||(s={}));class m{constructor(){this._providers=new Map}addTextProvider(a,M,o){return this.add(0,a,M,o)}addCustomProvider(a,M,o){return this.add(1,a,M,o)}get(a){return this._providers.get(a)}add(a,M,o,n){if(this._providers.has(M))throw new Error(`Provider for viewType:${M} already registered`);return this._providers.set(M,{type:a,extension:o,provider:n}),new i.Disposable(()=>this._providers.delete(M))}}class F{constructor(a,M,o,n,u){this._extHostDocuments=M,this._extensionStoragePaths=o,this._extHostWebview=n,this._extHostWebviewPanels=u,this._editorProviders=new m,this._documents=new l,this._proxy=a.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,M,o,n){const u=new _.DisposableStore;return S(o)?(u.add(this._editorProviders.addTextProvider(M,a,o)),this._proxy.$registerTextEditorProvider((0,T.toExtensionData)(a),M,n.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,T.shouldSerializeBuffersForPostMessage)(a))):(u.add(this._editorProviders.addCustomProvider(M,a,o)),this.supportEditing(o)&&u.add(o.onDidChangeCustomDocument(f=>{const c=this.getCustomDocumentEntry(M,f.document.uri);if(b(f)){const h=c.addEdit(f);this._proxy.$onDidEdit(f.document.uri,M,h,f.label)}else this._proxy.$onContentChange(f.document.uri,M)})),this._proxy.$registerCustomEditorProvider((0,T.toExtensionData)(a),M,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,(0,T.shouldSerializeBuffersForPostMessage)(a))),i.Disposable.from(u,new i.Disposable(()=>{this._proxy.$unregisterEditorProvider(M)}))}async $createCustomDocument(a,M,o,n,u){const f=this._editorProviders.get(M);if(!f)throw new Error(`No provider found for '${M}'`);if(f.type!==1)throw new Error(`Invalid provide type for '${M}'`);const c=P.URI.revive(a),h=await f.provider.openCustomDocument(c,{backupId:o,untitledDocumentData:n?.buffer},u);let g;return this.supportEditing(f.provider)&&this._extensionStoragePaths&&(g=this._extensionStoragePaths.workspaceValue(f.extension)??this._extensionStoragePaths.globalValue(f.extension)),this._documents.add(M,h,g),{editable:this.supportEditing(f.provider)}}async $disposeCustomDocument(a,M){const o=this._editorProviders.get(M);if(!o)throw new Error(`No provider found for '${M}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${M}'`);const n=P.URI.revive(a),{document:u}=this.getCustomDocumentEntry(M,n);this._documents.delete(M,u),u.dispose()}async $resolveWebviewEditor(a,M,o,n,u,f){const c=this._editorProviders.get(o);if(!c)throw new Error(`No provider found for '${o}'`);const h=D.ViewColumn.to(u),g=this._extHostWebview.createNewWebview(M,n.webviewOptions,c.extension),E=this._extHostWebviewPanels.createNewWebviewPanel(M,o,n.title,h,n.panelOptions,g),v=P.URI.revive(a);switch(c.type){case 1:{const{document:k}=this.getCustomDocumentEntry(o,v);return c.provider.resolveCustomEditor(k,E,f)}case 0:{const k=this._extHostDocuments.getDocument(v);return c.provider.resolveCustomTextEditor(k,E,f)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,M,o){this.getCustomDocumentEntry(M,a).disposeEdits(o)}async $onMoveCustomEditor(a,M,o){const n=this._editorProviders.get(o);if(!n)throw new Error(`No provider found for '${o}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const u=this._extHostWebviewPanels.getWebviewPanel(a);if(!u)throw new Error("No webview found");const f=P.URI.revive(M),c=this._extHostDocuments.getDocument(f);await n.provider.moveCustomTextEditor(c,u,r.CancellationToken.None)}async $undo(a,M,o,n){return this.getCustomDocumentEntry(M,a).undo(o,n)}async $redo(a,M,o,n){return this.getCustomDocumentEntry(M,a).redo(o,n)}async $revert(a,M,o){const n=this.getCustomDocumentEntry(M,a);await this.getCustomEditorProvider(M).revertCustomDocument(n.document,o),n.disposeBackup()}async $onSave(a,M,o){const n=this.getCustomDocumentEntry(M,a);await this.getCustomEditorProvider(M).saveCustomDocument(n.document,o),n.disposeBackup()}async $onSaveAs(a,M,o,n){const u=this.getCustomDocumentEntry(M,a);return this.getCustomEditorProvider(M).saveCustomDocumentAs(u.document,P.URI.revive(o),n)}async $backup(a,M,o){const n=this.getCustomDocumentEntry(M,a),f=await this.getCustomEditorProvider(M).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},o);return n.updateBackup(f),f.id}getCustomDocumentEntry(a,M){const o=this._documents.get(a,P.URI.revive(M));if(!o)throw new Error("No custom document found");return o}getCustomEditorProvider(a){const o=this._editorProviders.get(a)?.provider;if(!o||!this.supportEditing(o))throw new Error("Custom document is not editable");return o}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=F;function S(C){return typeof C.resolveCustomTextEditor=="function"}function b(C){return typeof C.undo=="function"&&typeof C.redo=="function"}function p(C){const a=C.scheme===A.Schemas.file||C.scheme===A.Schemas.untitled?C.fsPath:C.toString();return(0,t.hash)(a)+""}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[205],_e([0,1,4,6,2,36,8,51,5,7]),function(ee,e,r,t,_,A,I,P,D,T){"use strict";var R,w,i,d,l,s,m,F,S,b,p,C,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class M extends t.Disposable{constructor(f,c,h,g,E,v,k){super();R.set(this,void 0),w.set(this,void 0),i.set(this,void 0),d.set(this,void 0),l.set(this,void 0),s.set(this,void 0),m.set(this,void 0),F.set(this,void 0),S.set(this,!0),b.set(this,!0),p.set(this,!1),C.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,C,"f").event,a.set(this,this._register(new r.Emitter)),this.onDidChangeViewState=Ie(this,a,"f").event,Xe(this,R,f,"f"),Xe(this,w,c,"f"),Xe(this,i,h,"f"),Xe(this,l,v,"f"),Xe(this,F,E,"f"),Xe(this,s,g,"f"),Xe(this,d,k,"f")}dispose(){Ie(this,p,"f")||(Xe(this,p,!0,"f"),Ie(this,C,"f").fire(),Ie(this,w,"f").$disposeWebview(Ie(this,R,"f")),Ie(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ie(this,d,"f")}get viewType(){return this.assertNotDisposed(),Ie(this,i,"f")}get title(){return this.assertNotDisposed(),Ie(this,s,"f")}set title(f){this.assertNotDisposed(),Ie(this,s,"f")!==f&&(Xe(this,s,f,"f"),Ie(this,w,"f").$setTitle(Ie(this,R,"f"),f))}get iconPath(){return this.assertNotDisposed(),Ie(this,m,"f")}set iconPath(f){this.assertNotDisposed(),Ie(this,m,"f")!==f&&(Xe(this,m,f,"f"),Ie(this,w,"f").$setIconPath(Ie(this,R,"f"),_.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return Ie(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ie(this,F,"f")=="number"&&Ie(this,F,"f")<0))return Ie(this,F,"f")}get active(){return this.assertNotDisposed(),Ie(this,b,"f")}get visible(){return this.assertNotDisposed(),Ie(this,S,"f")}_updateViewState(f){Ie(this,p,"f")||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(Xe(this,b,f.active,"f"),Xe(this,S,f.visible,"f"),Xe(this,F,f.viewColumn,"f"),Ie(this,a,"f").fire({webviewPanel:this}))}reveal(f,c){this.assertNotDisposed(),Ie(this,w,"f").$reveal(Ie(this,R,"f"),{viewColumn:f?I.ViewColumn.from(f):void 0,preserveFocus:!!c})}assertNotDisposed(){if(Ie(this,p,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,w=new WeakMap,i=new WeakMap,d=new WeakMap,l=new WeakMap,s=new WeakMap,m=new WeakMap,F=new WeakMap,S=new WeakMap,b=new WeakMap,p=new WeakMap,C=new WeakMap,a=new WeakMap;class o{constructor(f,c,h){this.webviews=c,this.workspace=h,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=f.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(f,c,h,g,E={}){const v=typeof g=="object"?g.viewColumn:g,k={viewColumn:I.ViewColumn.from(v),preserveFocus:typeof g=="object"&&!!g.preserveFocus},x=(0,P.shouldSerializeBuffersForPostMessage)(f),N=o.newHandle();this._proxy.$createWebviewPanel((0,P.toExtensionData)(f),N,c,{title:h,panelOptions:n(E),webviewOptions:(0,P.serializeWebviewOptions)(f,this.workspace,E),serializeBuffersForPostMessage:x},k);const y=this.webviews.createNewWebview(N,E,f);return this.createNewWebviewPanel(N,c,h,v,E,y)}$onDidChangeWebviewPanelViewStates(f){const c=Object.keys(f);c.sort((h,g)=>{const E=f[h],v=f[g];return E.active?1:v.active?-1:+E.visible-+v.visible});for(const h of c){const g=this.getWebviewPanel(h);if(!g)continue;const E=f[h];g._updateViewState({active:E.active,visible:E.visible,viewColumn:I.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this._webviewPanels.delete(f),this.webviews.deleteWebview(f)}registerWebviewPanelSerializer(f,c,h){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:h,extension:f}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(f)}),new T.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(f,c,h,g){const E=this._serializers.get(c);if(!E)throw new Error(`No serializer found for '${c}'`);const{serializer:v,extension:k}=E,x=this.webviews.createNewWebview(f,h.webviewOptions,k),N=this.createNewWebviewPanel(f,c,h.title,g,h.panelOptions,x);await v.deserializeWebviewPanel(N,h.state)}createNewWebviewPanel(f,c,h,g,E,v){const k=new M(f,this._proxy,c,h,g,E,v);return this._webviewPanels.set(f,k),k}getWebviewPanel(f){return this._webviewPanels.get(f)}}e.ExtHostWebviewPanels=o;function n(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[206],_e([0,1,4,6,51,5,7]),function(ee,e,r,t,_,A,I){"use strict";var P,D,T,R,w,i,d,l,s,m;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class F extends t.Disposable{constructor(p,C,a,M,o,n){super();P.set(this,void 0),D.set(this,void 0),T.set(this,void 0),R.set(this,void 0),w.set(this,!1),i.set(this,void 0),d.set(this,void 0),l.set(this,void 0),s.set(this,this._register(new r.Emitter)),this.onDidChangeVisibility=Ie(this,s,"f").event,m.set(this,this._register(new r.Emitter)),this.onDidDispose=Ie(this,m,"f").event,Xe(this,T,a,"f"),Xe(this,d,M,"f"),Xe(this,P,p,"f"),Xe(this,D,C,"f"),Xe(this,R,o,"f"),Xe(this,i,n,"f")}dispose(){Ie(this,w,"f")||(Xe(this,w,!0,"f"),Ie(this,m,"f").fire(),Ie(this,R,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ie(this,d,"f")}set title(p){this.assertNotDisposed(),Ie(this,d,"f")!==p&&(Xe(this,d,p,"f"),Ie(this,D,"f").$setWebviewViewTitle(Ie(this,P,"f"),p))}get description(){return this.assertNotDisposed(),Ie(this,l,"f")}set description(p){this.assertNotDisposed(),Ie(this,l,"f")!==p&&(Xe(this,l,p,"f"),Ie(this,D,"f").$setWebviewViewDescription(Ie(this,P,"f"),p))}get visible(){return Ie(this,i,"f")}get webview(){return Ie(this,R,"f")}get viewType(){return Ie(this,T,"f")}_setVisible(p){p===Ie(this,i,"f")||Ie(this,w,"f")||(Xe(this,i,p,"f"),Ie(this,s,"f").fire())}show(p){this.assertNotDisposed(),Ie(this,D,"f").$show(Ie(this,P,"f"),!!p)}assertNotDisposed(){if(Ie(this,w,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,D=new WeakMap,T=new WeakMap,R=new WeakMap,w=new WeakMap,i=new WeakMap,d=new WeakMap,l=new WeakMap,s=new WeakMap,m=new WeakMap;class S{constructor(p,C){this._extHostWebview=C,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,C,a,M){if(this._viewProviders.has(C))throw new Error(`View provider for '${C}' already registered`);return this._viewProviders.set(C,{provider:a,extension:p}),this._proxy.$registerWebviewViewProvider((0,_.toExtensionData)(p),C,{retainContextWhenHidden:M?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new I.Disposable(()=>{this._viewProviders.delete(C),this._proxy.$unregisterWebviewViewProvider(C)})}async $resolveWebviewView(p,C,a,M,o){const n=this._viewProviders.get(C);if(!n)throw new Error(`No view provider found for '${C}'`);const{provider:u,extension:f}=n,c=this._extHostWebview.createNewWebview(p,{},f),h=new F(p,this._proxy,C,a,c,!0);this._webviewViews.set(p,h),await u.resolveWebviewView(h,{state:M},o)}async $onDidChangeWebviewViewVisibility(p,C){this.getWebviewView(p)._setVisible(C)}async $disposeWebviewView(p){const C=this.getWebviewView(p);this._webviewViews.delete(p),C.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const C=this._webviewViews.get(p);if(!C)throw new Error("No webview found");return C}}e.ExtHostWebviewViews=S}),define(ye[94],_e([0,1,4,5,2,11,9,3,14]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let T=class ji{constructor(w){this._onDidChangeWindowState=new r.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=w.getProxy(t.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(i=>this.$onDidChangeWindowFocus(i))}get state(){return this._state}$onDidChangeWindowFocus(w){w!==this._state.focused&&(this._state={...this._state,focused:w},this._onDidChangeWindowState.fire(this._state))}openUri(w,i){let d;if(typeof w=="string"){d=w;try{w=_.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,I.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this._proxy.$openUri(w,d,i)}async asExternalUri(w,i){if((0,I.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(w,i);return _.URI.from(d)}};T.InitialState={focused:!0},T=Be([$e(0,D.IExtHostRpcService)],T),e.ExtHostWindow=T,e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(ye[207],_e([0,1,13,21,20,15,4,6,105,173,38]),function(ee,e,r,t,_,A,I,P,D,T,R){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function i(E,v){try{return JSON.stringify(E,v)}catch{return"null"}}const d="$$ref$$",l={[d]:-1};class s{constructor(v,k){this.jsonString=v,this.referencedBuffers=k}}function m(E,v=null,k=!1){const x=[];return{jsonString:(k?i:JSON.stringify)(E,(y,L)=>{if(typeof L=="undefined")return l;if(typeof L=="object"){if(L instanceof t.VSBuffer){const W=x.push(L)-1;return{[d]:W}}if(v)return v(y,L)}return L}),referencedBuffers:x}}e.stringifyJsonWithBufferRefs=m;function F(E,v,k){return JSON.parse(E,(x,N)=>{if(N){const y=N[d];if(typeof y=="number")return v[y];if(k&&N.$mid===1)return k.transformIncoming(N)}return N})}e.parseJsonAndRestoreBufferRefs=F;function S(E,v){return JSON.stringify(E,v)}function b(E){return E?(v,k)=>k&&k.$mid===1?E.transformOutgoing(k):k:null}var p;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var C;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(C=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},M=Symbol.for("rpcProtocol"),o=Symbol.for("rpcProxy");class n extends P.Disposable{constructor(v,k=null,x=null){super();this[w]=!0,this._onDidChangeResponsiveState=this._register(new I.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=v,this._logger=k,this._uriTransformer=x,this._uriReplacer=b(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let N=0,y=R.ProxyIdentifier.count;N<y;N++)this._locals[N]=null,this._proxies[N]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new r.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(N=>this._receiveOneMessage(N))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(v=>{this._pendingRPCReplies[v].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(v){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(v){this._unresponsiveTime=Date.now()+n.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(v){this._responsiveState!==v&&(this._responsiveState=v,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(v){return this._uriTransformer?(0,D.transformIncomingURIs)(v,this._uriTransformer):v}getProxy(v){const{nid:k,sid:x}=v;return this._proxies[k]||(this._proxies[k]=this._createProxy(k,x)),this._proxies[k]}_createProxy(v,k){let x={get:(N,y)=>(typeof y=="string"&&!N[y]&&y.charCodeAt(0)===36&&(N[y]=(...L)=>this._remoteCall(v,y,L)),y===o?k:N[y])};return new Proxy(Object.create(null),x)}set(v,k){return this._locals[v.nid]=k,k}assertRegistered(v){for(let k=0,x=v.length;k<x;k++){const N=v[k];if(!this._locals[N.nid])throw new Error(`Missing actor ${N.sid} (isMain: ${N.isMain})`)}}_receiveOneMessage(v){if(this._isDisposed)return;const k=v.byteLength,x=u.read(v,0),N=x.readUInt8(),y=x.readUInt32();switch(N){case 1:case 2:{let{rpcId:L,method:W,args:B}=c.deserializeRequestJSONArgs(x);this._uriTransformer&&(B=(0,D.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(k,y,L,W,B,N===2);break}case 3:case 4:{let{rpcId:L,method:W,args:B}=c.deserializeRequestMixedArgs(x);this._uriTransformer&&(B=(0,D.transformIncomingURIs)(B,this._uriTransformer)),this._receiveRequest(k,y,L,W,B,N===4);break}case 5:{this._logger&&this._logger.logIncoming(k,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(k,y);break}case 7:{this._receiveReply(k,y,void 0);break}case 9:{let L=c.deserializeReplyOKJSON(x);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReply(k,y,L);break}case 10:{const L=c.deserializeReplyOKJSONWithBuffers(x,this._uriTransformer);this._receiveReply(k,y,L);break}case 8:{let L=c.deserializeReplyOKVSBuffer(x);this._receiveReply(k,y,L);break}case 11:{let L=c.deserializeReplyErrError(x);this._uriTransformer&&(L=(0,D.transformIncomingURIs)(L,this._uriTransformer)),this._receiveReplyErr(k,y,L);break}case 12:{this._receiveReplyErr(k,y,void 0);break}default:console.error("received unexpected message"),console.error(v)}}_receiveRequest(v,k,x,N,y,L){this._logger&&this._logger.logIncoming(v,k,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(x)}.${N}(`,y);const W=String(k);let B,$;if(L){const ie=new _.CancellationTokenSource;y.push(ie.token),B=this._invokeHandler(x,N,y),$=()=>ie.cancel()}else B=this._invokeHandler(x,N,y),$=a;this._cancelInvokedHandlers[W]=$;const q=c.serializeAcknowledged(k);this._logger&&this._logger.logOutgoing(q.byteLength,k,1,"ack"),this._protocol.send(q),B.then(ie=>{delete this._cancelInvokedHandlers[W];const se=c.serializeReplyOK(k,ie,this._uriReplacer);this._logger&&this._logger.logOutgoing(se.byteLength,k,1,"reply:",ie),this._protocol.send(se)},ie=>{delete this._cancelInvokedHandlers[W];const se=c.serializeReplyErr(k,ie);this._logger&&this._logger.logOutgoing(se.byteLength,k,1,"replyErr:",ie),this._protocol.send(se)})}_receiveCancel(v,k){this._logger&&this._logger.logIncoming(v,k,1,"receiveCancel");const x=String(k);this._cancelInvokedHandlers[x]&&this._cancelInvokedHandlers[x]()}_receiveReply(v,k,x){this._logger&&this._logger.logIncoming(v,k,0,"receiveReply:",x);const N=String(k);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const y=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N],y.resolveOk(x)}_receiveReplyErr(v,k,x){this._logger&&this._logger.logIncoming(v,k,0,"receiveReplyErr:",x);const N=String(k);if(!this._pendingRPCReplies.hasOwnProperty(N))return;const y=this._pendingRPCReplies[N];delete this._pendingRPCReplies[N];let L;x&&(x.$isError?(L=new Error,L.name=x.name,L.message=x.message,L.stack=x.stack):L=x),y.resolveErr(L)}_invokeHandler(v,k,x){try{return Promise.resolve(this._doInvokeHandler(v,k,x))}catch(N){return Promise.reject(N)}}_doInvokeHandler(v,k,x){const N=this._locals[v];if(!N)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(v));let y=N[k];if(typeof y!="function")throw new Error("Unknown method "+k+" on actor "+(0,R.getStringIdentifierForProxy)(v));return y.apply(N,x)}_remoteCall(v,k,x){if(this._isDisposed)return Promise.reject(A.canceled());let N=null;if(x.length>0&&_.CancellationToken.isCancellationToken(x[x.length-1])&&(N=x.pop()),N&&N.isCancellationRequested)return Promise.reject(A.canceled());const y=c.serializeRequestArguments(x,this._uriReplacer),L=++this._lastMessageId,W=String(L),B=new T.LazyPromise;N&&N.onCancellationRequested(()=>{const q=c.serializeCancel(L);this._logger&&this._logger.logOutgoing(q.byteLength,L,0,"cancel"),this._protocol.send(c.serializeCancel(L))}),this._pendingRPCReplies[W]=B,this._onWillSendRequest(L);const $=c.serializeRequest(L,v,k,y,!!N);return this._logger&&this._logger.logOutgoing($.byteLength,L,0,`request: ${(0,R.getStringIdentifierForProxy)(v)}.${k}(`,x),this._protocol.send($),B}}e.RPCProtocol=n,w=M,n.UNRESPONSIVE_TIME=3*1e3;class u{constructor(v,k){this._buff=v,this._offset=k}static alloc(v,k,x){let N=new u(t.VSBuffer.alloc(x+1+4),0);return N.writeUInt8(v),N.writeUInt32(k),N}static read(v,k){return new u(v,k)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(v){this._buff.writeUInt8(v,this._offset),this._offset+=1}readUInt8(){const v=this._buff.readUInt8(this._offset);return this._offset+=1,v}writeUInt32(v){this._buff.writeUInt32BE(v,this._offset),this._offset+=4}readUInt32(){const v=this._buff.readUInt32BE(this._offset);return this._offset+=4,v}static sizeShortString(v){return 1+v.byteLength}writeShortString(v){this._buff.writeUInt8(v.byteLength,this._offset),this._offset+=1,this._buff.set(v,this._offset),this._offset+=v.byteLength}readShortString(){const v=this._buff.readUInt8(this._offset);this._offset+=1;const x=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,x}static sizeLongString(v){return 4+v.byteLength}writeLongString(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readLongString(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const x=this._buff.slice(this._offset,this._offset+v).toString();return this._offset+=v,x}writeBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}static sizeVSBuffer(v){return 4+v.byteLength}writeVSBuffer(v){this._buff.writeUInt32BE(v.byteLength,this._offset),this._offset+=4,this._buff.set(v,this._offset),this._offset+=v.byteLength}readVSBuffer(){const v=this._buff.readUInt32BE(this._offset);this._offset+=4;const k=this._buff.slice(this._offset,this._offset+v);return this._offset+=v,k}static sizeMixedArray(v){let k=0;k+=1;for(let x=0,N=v.length;x<N;x++){const y=v[x];switch(k+=1,y.type){case 1:k+=this.sizeLongString(y.value);break;case 2:k+=this.sizeVSBuffer(y.value);break;case 3:k+=this.sizeUInt32,k+=this.sizeLongString(y.value);for(let L=0;L<y.buffers.length;++L)k+=this.sizeVSBuffer(y.buffers[L]);break;case 4:break}}return k}writeMixedArray(v){this._buff.writeUInt8(v.length,this._offset),this._offset+=1;for(let k=0,x=v.length;k<x;k++){const N=v[k];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let y=0;y<N.buffers.length;++y)this.writeBuffer(N.buffers[y]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const v=this._buff.readUInt8(this._offset);this._offset+=1;let k=new Array(v);for(let x=0;x<v;x++)switch(this.readUInt8()){case 1:k[x]=this.readLongString();break;case 2:k[x]=this.readVSBuffer();break;case 3:{const y=this.readUInt32(),L=this.readLongString(),W=[];for(let B=0;B<y;++B)W.push(this.readVSBuffer());k[x]=new R.SerializableObjectWithBuffers(F(L,W,null));break}case 4:k[x]=void 0;break}return k}}u.sizeUInt32=4;var f;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(f||(f={}));class c{static _useMixedArgSerialization(v){for(let k=0,x=v.length;k<x;k++)if(v[k]instanceof t.VSBuffer||v[k]instanceof R.SerializableObjectWithBuffers||typeof v[k]=="undefined")return!0;return!1}static serializeRequestArguments(v,k){if(this._useMixedArgSerialization(v)){const x=[];for(let N=0,y=v.length;N<y;N++){const L=v[N];if(L instanceof t.VSBuffer)x[N]={type:2,value:L};else if(typeof L=="undefined")x[N]={type:4};else if(L instanceof R.SerializableObjectWithBuffers){const{jsonString:W,referencedBuffers:B}=m(L.value,k);x[N]={type:3,value:t.VSBuffer.fromString(W),buffers:B}}else x[N]={type:1,value:t.VSBuffer.fromString(S(L,k))}}return{type:1,args:x}}return{type:0,args:S(v,k)}}static serializeRequest(v,k,x,N,y){switch(N.type){case 0:return this._requestJSONArgs(v,k,x,N.args,y);case 1:return this._requestMixedArgs(v,k,x,N.args,y)}}static _requestJSONArgs(v,k,x,N,y){const L=t.VSBuffer.fromString(x),W=t.VSBuffer.fromString(N);let B=0;B+=u.sizeUInt8(),B+=u.sizeShortString(L),B+=u.sizeLongString(W);let $=u.alloc(y?2:1,v,B);return $.writeUInt8(k),$.writeShortString(L),$.writeLongString(W),$.buffer}static deserializeRequestJSONArgs(v){const k=v.readUInt8(),x=v.readShortString(),N=v.readLongString();return{rpcId:k,method:x,args:JSON.parse(N)}}static _requestMixedArgs(v,k,x,N,y){const L=t.VSBuffer.fromString(x);let W=0;W+=u.sizeUInt8(),W+=u.sizeShortString(L),W+=u.sizeMixedArray(N);let B=u.alloc(y?4:3,v,W);return B.writeUInt8(k),B.writeShortString(L),B.writeMixedArray(N),B.buffer}static deserializeRequestMixedArgs(v){const k=v.readUInt8(),x=v.readShortString(),N=v.readMixedArray(),y=new Array(N.length);for(let L=0,W=N.length;L<W;L++){const B=N[L];typeof B=="string"?y[L]=JSON.parse(B):y[L]=B}return{rpcId:k,method:x,args:y}}static serializeAcknowledged(v){return u.alloc(5,v,0).buffer}static serializeCancel(v){return u.alloc(6,v,0).buffer}static serializeReplyOK(v,k,x){if(typeof k=="undefined")return this._serializeReplyOKEmpty(v);if(k instanceof t.VSBuffer)return this._serializeReplyOKVSBuffer(v,k);if(k instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:y}=m(k.value,x,!0);return this._serializeReplyOKJSONWithBuffers(v,N,y)}else return this._serializeReplyOKJSON(v,i(k,x))}static _serializeReplyOKEmpty(v){return u.alloc(7,v,0).buffer}static _serializeReplyOKVSBuffer(v,k){let x=0;x+=u.sizeVSBuffer(k);let N=u.alloc(8,v,x);return N.writeVSBuffer(k),N.buffer}static deserializeReplyOKVSBuffer(v){return v.readVSBuffer()}static _serializeReplyOKJSON(v,k){const x=t.VSBuffer.fromString(k);let N=0;N+=u.sizeLongString(x);let y=u.alloc(9,v,N);return y.writeLongString(x),y.buffer}static _serializeReplyOKJSONWithBuffers(v,k,x){const N=t.VSBuffer.fromString(k);let y=0;y+=u.sizeUInt32,y+=u.sizeLongString(N);for(const W of x)y+=u.sizeVSBuffer(W);let L=u.alloc(10,v,y);L.writeUInt32(x.length),L.writeLongString(N);for(const W of x)L.writeBuffer(W);return L.buffer}static deserializeReplyOKJSON(v){const k=v.readLongString();return JSON.parse(k)}static deserializeReplyOKJSONWithBuffers(v,k){const x=v.readUInt32(),N=v.readLongString(),y=[];for(let L=0;L<x;++L)y.push(v.readVSBuffer());return new R.SerializableObjectWithBuffers(F(N,y,k))}static serializeReplyErr(v,k){return k?this._serializeReplyErrEror(v,k):this._serializeReplyErrEmpty(v)}static _serializeReplyErrEror(v,k){const x=t.VSBuffer.fromString(i(A.transformErrorForSerialization(k),null));let N=0;N+=u.sizeLongString(x);let y=u.alloc(11,v,N);return y.writeLongString(x),y.buffer}static deserializeReplyErrError(v){const k=v.readLongString();return JSON.parse(k)}static _serializeReplyErrEmpty(v){return u.alloc(12,v,0).buffer}}var h;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var g;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(g||(g={}))}),define(ye[208],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const r=function(A){const I=P=>{self.removeEventListener("message",I);const D=P.data;Object.defineProperties(self,{postMessage:{value(T,R){D.postMessage(T,R)}},onmessage:{get(){return D.onmessage},set(T){D.onmessage=T}}}),D.addEventListener("message",T=>{self.dispatchEvent(new MessageEvent("message",{data:T.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",I)}.toString();class t extends EventTarget{constructor(A,I,P){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${r})('${I}'))`,T=new Blob([D],{type:"application/javascript"}),R=URL.createObjectURL(T),w=new MessageChannel,i=R,d={type:"_newWorker",id:i,port:w.port2,url:R,options:P};A(d,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{const l={type:"_terminateWorker",id:i};w.port1.postMessage(l),URL.revokeObjectURL(R),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(l){w.port1.onmessage=l}},onmessageerror:{get(){return w.port1.onmessageerror},set(l){w.port1.onmessageerror=l}}}),w.port1.addEventListener("messageerror",l=>{const s=new MessageEvent("messageerror",{data:l.data});this.dispatchEvent(s)}),w.port1.addEventListener("message",l=>{const s=new MessageEvent("message",{data:l.data});this.dispatchEvent(s)}),w.port1.start()}}e.NestedWorker=t}),define(ye[209],_e([0,1,3]),function(ee,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,r.createDecorator)("remoteAgentService")}),define(ye[210],_e([0,1,35,11,17,23,24,2,3,60,47,168,209]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let d=class qi{constructor(s,m,F,S){this.localUserHome=s,this.remoteAgentService=m,this.environmentService=F,this.contextService=S,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||A.OS)(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=b?.userHome||s})()}hasValidBasename(s,m,F){return typeof m=="string"||typeof m=="undefined"?this.resolveOS.then(S=>this.doHasValidBasename(s,S,m)):this.doHasValidBasename(s,m,F)}doHasValidBasename(s,m,F){return s.scheme===t.Schemas.file||s.scheme===t.Schemas.vscodeRemote?(0,r.isValidBasename)(F??(0,I.basename)(s),m===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(s,m){if(s.remoteAuthority)return t.Schemas.vscodeRemote;const F=(0,T.getVirtualWorkspaceScheme)(m.getWorkspace());if(F)return F;const S=m.getWorkspace().folders[0];if(S)return S.uri.scheme;const b=m.getWorkspace().configuration;return b?b.scheme:t.Schemas.file}async userHome(s){return s?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(s=>s===1?_.win32:_.posix)}async fileURI(s){let m="";if(await this.resolveOS===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const S=s.indexOf("/",2);S===-1?(m=s.substring(2),s="/"):(m=s.substring(2,S),s=s.substring(S)||"/")}return P.URI.from({scheme:t.Schemas.file,authority:m,path:s,query:"",fragment:""})}};d=Be([$e(1,i.IRemoteAgentService),$e(2,w.IWorkbenchEnvironmentService),$e(3,R.IWorkspaceContextService)],d),e.AbstractPathService=d}),define(ye[95],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class r{constructor(I,P){this.line=I,this.character=P}isBefore(I){return!1}isBeforeOrEqual(I){return!1}isAfter(I){return!1}isAfterOrEqual(I){return!1}isEqual(I){return!1}compareTo(I){return 0}translate(I,P){return new r(0,0)}with(I){return new r(0,0)}}e.Position=r;class t{constructor(I,P,D,T){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(I,P),this.end=new r(D,T)}contains(I){return!1}isEqual(I){return!1}intersection(I){}union(I){return new t(0,0,0,0)}with(I){return new t(0,0,0,0)}}e.Range=t;var _;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(_=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[41],_e([0,1,16,29,27,35,9,3,17,15,95,10]),function(ee,e,r,t,_,A,I,P,D,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const i="\u27EA ",d=" characters skipped \u27EB",l=(i.length+d.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var s;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(s=e.SearchProviderType||(e.SearchProviderType={}));var m;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(m=e.QueryType||(e.QueryType={}));function F(q){return!!q.preview}e.resultIsMatch=F;function S(q){return!!q.resource}e.isFileMatch=S;function b(q){return!!q.message}e.isProgressMessage=b;var p;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class C{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=C;class a{constructor(ie,se,X){this.ranges=se;const ge=Array.isArray(se)?se:[se];if(X&&X.matchLines===1&&M(ge)){ie=(0,I.getNLines)(ie,X.matchLines);let be="",pe=0,fe=0;const oe=Math.floor(X.charsPerLine/5),Ee=[];for(const Pe of ge){const Oe=Math.max(Pe.startColumn-oe,0),je=Pe.startColumn+X.charsPerLine;if(Oe>fe+oe+l){const st=i+(Oe-fe)+d;be+=st+ie.slice(Oe,je),pe+=Oe-(fe+st.length)}else be+=ie.slice(fe,je);Ee.push(new n(0,Pe.startColumn-pe,Pe.endColumn-pe)),fe=je}this.preview={text:be,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const be=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ie,matches:(0,r.mapArrayOrNot)(se,pe=>new o(pe.startLineNumber-be,pe.startColumn,pe.endLineNumber-be,pe.endColumn))}}}}e.TextSearchMatch=a;function M(q){const ie=q[0].startLineNumber;for(const se of q)if(se.startLineNumber!==ie||se.endLineNumber!==ie)return!1;return!0}class o{constructor(ie,se,X,ge){this.startLineNumber=ie,this.startColumn=se,this.endLineNumber=X,this.endColumn=ge}}e.SearchRange=o;class n extends o{constructor(ie,se,X){super(ie,se,ie,X)}}e.OneLineRange=n;var u;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function f(q,ie=!0){const se=q&&q.files&&q.files.exclude,X=ie&&q&&q.search&&q.search.exclude;if(!se&&!X)return;if(!se||!X)return se||X;let ge=Object.create(null);return ge=_.mixin(ge,_.deepClone(se)),ge=_.mixin(ge,_.deepClone(X),!0),ge}e.getExcludes=f;function c(q,ie){return q.excludePattern&&t.match(q.excludePattern,ie)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&t.match(q.includePattern,ie)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(se=>{const X=se.folder.fsPath;if(A.isEqualOrParent(ie,X)){const ge=D.relative(X,ie);return!se.includePattern||!!t.match(se.includePattern,ge)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var h;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(h=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(ie,se){super(ie);this.code=se}}e.SearchError=g;function E(q){const ie=q.message;if((0,T.isCancellationError)(q))return new g(ie,h.canceled);try{const se=JSON.parse(ie);return new g(se.message,se.code)}catch{return new g(ie,h.other)}}e.deserializeSearchError=E;function v(q){const ie={message:q.message,code:q.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=v;function k(q){return q.type==="error"?!0:q.type==="success"}e.isSerializedSearchComplete=k;function x(q){return q.type==="success"}e.isSerializedSearchSuccess=x;function N(q){return!!q.path}e.isSerializedFileMatch=N;function y(q,ie){const se=q.searchPath?q.searchPath:q.relativePath;return(0,I.fuzzyContains)(se,ie)}e.isFilePatternMatch=y;class L{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=L;function W(q,ie){const se={...q||{},...ie||{}};return Object.keys(se).filter(X=>{const ge=se[X];return typeof ge=="boolean"&&ge})}e.resolvePatternsForProvider=W;class B{constructor(ie,se){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...se.excludePattern||{}},this._parsedExcludeExpression=t.parse(this._excludeExpression);let X=ie.includePattern;se.includePattern&&(X?X={...X,...se.includePattern}:X=se.includePattern),X&&(this._parsedIncludeExpression=t.parse(X))}matchesExcludesSync(ie,se,X){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,se,X))}includedInQuerySync(ie,se,X){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,se,X)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,se,X))}includedInQuery(ie,se,X){const ge=this._parsedExcludeExpression(ie,se,X),be=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,se,X):!0;return(0,w.isPromise)(ge)?ge.then(pe=>pe?!1:be()):be()}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=B;function $(q){for(const ie in q)if(typeof q[ie]!="boolean")return!0;return!1}}),define(ye[31],_e([0,1,16,13,20,4,22,11,100,24,9,10,2,124,3,12,137,47,30,28,14,8,7,41,5]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b,p,C,a,M,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function n(k,x,N){return new T.ExtUri(y=>h(y,N)).isEqual(k,x)}function u(k,x,N){return n(k.uri,x.uri,N)?0:(0,R.compare)(k.uri.toString(),x.uri.toString())}function f(k,x,N){return k.index!==x.index?k.index<x.index?-1:1:n(k.uri,x.uri,N)?(0,R.compare)(k.name,x.name):(0,R.compare)(k.uri.toString(),x.uri.toString())}function c(k,x,N,y){const L=k.slice(0).sort((B,$)=>N(B,$,y)),W=x.slice(0).sort((B,$)=>N(B,$,y));return(0,r.delta)(L,W,(B,$)=>N(B,$,y))}function h(k,x){const N=x.getCapabilities(k.scheme);return!(N&&N&1024)}class g extends F.Workspace{constructor(x,N,y,L,W,B,$){super(x,y.map(q=>new F.WorkspaceFolder(q)),L,W,$);this._name=N,this._isUntitled=B,this._workspaceFolders=[],this._structure=I.TernarySearchTree.forUris($),y.forEach(q=>{this._workspaceFolders.push(q),this._structure.set(q.uri,q)})}static toExtHostWorkspace(x,N,y,L){if(!x)return{workspace:null,added:[],removed:[]};const{id:W,name:B,folders:$,configuration:q,transient:ie,isUntitled:se}=x,X=[],ge=N;N?$.forEach((oe,Ee)=>{const Pe=i.URI.revive(oe.uri),Oe=g._findFolder(y||N,Pe,L);Oe?(Oe.name=oe.name,Oe.index=oe.index,X.push(Oe)):X.push({uri:Pe,name:oe.name,index:Ee})}):X.push(...$.map(({uri:oe,name:Ee,index:Pe})=>({uri:i.URI.revive(oe),name:Ee,index:Pe}))),X.sort((oe,Ee)=>oe.index<Ee.index?-1:1);const be=new g(W,B,X,!!ie,q?i.URI.revive(q):null,!!se,oe=>h(oe,L)),{added:pe,removed:fe}=c(ge?ge.workspaceFolders:[],be.workspaceFolders,u,L);return{workspace:be,added:pe,removed:fe}}static _findFolder(x,N,y){for(let L=0;L<x.folders.length;L++){const W=x.workspaceFolders[L];if(n(W.uri,N,y))return W}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,N){return N&&this._structure.get(x)&&(x=(0,T.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let E=class{constructor(x,N,y,L){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=L,this._extHostFileSystemInfo=y,this._requestIdProvider=new D.Counter,this._barrier=new t.Barrier,this._proxy=x.getProxy(o.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(o.MainContext.MainThreadMessageService);const W=N.workspace;this._confirmedWorkspace=W?new g(W.id,W.name,[],!!W.transient,W.configuration?i.URI.revive(W.configuration):null,!!W.isUntitled,B=>h(B,y)):void 0}$initializeWorkspace(x,N){this._trusted=N,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?i.URI.from({scheme:P.Schemas.untitled,path:(0,T.basename)((0,T.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,N,y,...L){const W=[];if(Array.isArray(L)&&L.forEach(se=>{i.URI.isUri(se.uri)&&!W.some(X=>n(X.uri,se.uri,this._extHostFileSystemInfo))&&W.push({uri:se.uri,name:se.name||(0,T.basenameOrAuthority)(se.uri)})}),this._unconfirmedWorkspace||[N,y].some(se=>typeof se!="number"||se<0)||y===0&&W.length===0)return!1;const B=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(N+y>B.length)return!1;const $=B.slice(0);$.splice(N,y,...W.map(se=>({uri:se.uri,name:se.name||(0,T.basenameOrAuthority)(se.uri),index:void 0})));for(let se=0;se<$.length;se++){const X=$[se];if($.some((ge,be)=>be!==se&&n(X.uri,ge.uri,this._extHostFileSystemInfo)))return!1}$.forEach((se,X)=>se.index=X);const{added:q,removed:ie}=c(B,$,f,this._extHostFileSystemInfo);if(q.length===0&&ie.length===0)return!1;if(this._proxy){const se=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(se,N,y,W).then(void 0,X=>{this._unconfirmedWorkspace=void 0;const ge={source:{identifier:x.identifier,label:x.displayName||x.name}};this._messageService.$showMessage(m.Severity.Error,(0,d.localize)(0,null,se,X.toString()),ge,[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(x,N){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,N)}async getWorkspaceFolder2(x,N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,N)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!this._actualWorkspace)return;const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}getRelativePath(x,N){let y,L="";if(typeof x=="string"?(y=i.URI.file(x),L=x):typeof x!="undefined"&&(y=x,L=x.fsPath),!y)return L;const W=this.getWorkspaceFolder(y,!0);if(!W)return L;typeof N=="undefined"&&this._actualWorkspace&&(N=this._actualWorkspace.folders.length>1);let B=(0,T.relativePath)(W.uri,y);return N&&W.name&&(B=`${W.name}/${B}`),B}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=g.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:N,added:y,removed:L}=g.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=N||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:y,removed:L}))}findFiles(x,N,y,L,W=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${L.value}, entryPoint: findFiles`);let B;if(N===null?B=!1:N&&(typeof N=="string"?B=N:B=N.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:q}=v(C.GlobPattern.from(x));return this._proxy.$startFileSearch((0,w.withUndefinedAsNull)($),(0,w.withUndefinedAsNull)(q),(0,w.withUndefinedAsNull)(B),(0,w.withUndefinedAsNull)(y),W).then(ie=>Array.isArray(ie)?ie.map(se=>i.URI.revive(se)):[])}async findTextInFiles(x,N,y,L,W=_.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${L.value}, entryPoint: findTextInFiles`);const B=this._requestIdProvider.getNext(),$=typeof N.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:N.previewOptions,{includePattern:q,folder:ie}=v(C.GlobPattern.from(N.include)),se=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,X={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!0,fileEncoding:N.encoding,maxResults:N.maxResults,previewOptions:$,afterContext:N.afterContext,beforeContext:N.beforeContext,includePattern:q,excludePattern:se},ge=!1;if(this._activeSearchCallbacks[B]=be=>{if(ge)return;const pe=i.URI.revive(be.resource);be.results.forEach(fe=>{(0,M.resultIsMatch)(fe)?y({uri:pe,preview:{text:fe.preview.text,matches:(0,r.mapArrayOrNot)(fe.preview.matches,oe=>new a.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))},ranges:(0,r.mapArrayOrNot)(fe.ranges,oe=>new a.Range(oe.startLineNumber,oe.startColumn,oe.endLineNumber,oe.endColumn))}):y({uri:pe,text:fe.text,lineNumber:fe.lineNumber})})},W.isCancellationRequested)return{};try{const be=await this._proxy.$startTextSearch(x,(0,w.withUndefinedAsNull)(ie),X,B,W);return delete this._activeSearchCallbacks[B],be||{}}catch(be){throw delete this._activeSearchCallbacks[B],be}}$handleTextSearchResult(x,N){this._activeSearchCallbacks[N]&&this._activeSearchCallbacks[N](x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};E=Be([$e(0,p.IExtHostRpcService),$e(1,b.IExtHostInitDataService),$e(2,S.IExtHostFileSystemInfo),$e(3,s.ILogService)],E),e.ExtHostWorkspace=E,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function v(k){let x,N;return k&&(typeof k=="string"?x=k:(x=k.pattern,N=i.URI.revive(k.baseUri))),{includePattern:x,folder:N}}}),define(ye[32],_e([0,1,27,4,31,5,7,141,81,10,13,3,14,12,2]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function s(M,o){if(o){const n=o.split(".");let u=M;for(let f=0;u&&f<n.length;f++)u=u[n[f]];return u}}function m(M){return M instanceof l.URI}function F(M){return M&&M.uri instanceof l.URI&&M.languageId&&typeof M.languageId=="string"}function S(M){return M&&!M.uri&&M.languageId&&typeof M.languageId=="string"}function b(M){return M&&M.uri instanceof l.URI&&(!M.name||typeof M.name=="string")&&(!M.index||typeof M.index=="number")}function p(M){if(m(M))return{resource:M};if(F(M))return{resource:M.uri,overrideIdentifier:M.languageId};if(S(M))return{overrideIdentifier:M.languageId};if(b(M))return{resource:M.uri};if(M===null)return{resource:null}}let C=class{constructor(o,n,u){this._proxy=o.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=u,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(o=>this._actual)}$initializeConfiguration(o){this._actual=new a(this._proxy,this._extHostWorkspace,o,this._logService),this._barrier.open()}$acceptConfigurationChanged(o,n){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(o,n))}};C=Be([$e(0,i.IExtHostRpcService),$e(1,_.IExtHostWorkspace),$e(2,d.ILogService)],C),e.ExtHostConfiguration=C;class a{constructor(o,n,u,f){this._onDidChangeConfiguration=new t.Emitter,this._proxy=o,this._logService=f,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(o,n){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,u))}getConfiguration(o,n,u){const f=p(n)||{},c=this._toReadonlyValue(o?s(this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace),o):this._configuration.getValue(void 0,f,this._extHostWorkspace.workspace));o&&this._validateConfigurationAccess(o,f,u?.identifier);function h(E){if(E==null)return null;if(typeof E=="boolean")return E?1:4;switch(E){case I.ConfigurationTarget.Global:return 1;case I.ConfigurationTarget.Workspace:return 4;case I.ConfigurationTarget.WorkspaceFolder:return 5}}const g={has(E){return typeof s(c,E)!="undefined"},get:(E,v)=>{this._validateConfigurationAccess(o?`${o}.${E}`:E,f,u?.identifier);let k=s(c,E);if(typeof k=="undefined")k=v;else{let x;const N=(y,L)=>{let W;const B=()=>{x=x||(0,r.deepClone)(c),W=W||s(x,L)};return(0,T.isObject)(y)?new Proxy(y,{get:($,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return B(),()=>W;if(x)return W=W||s(x,L),W[q];const ie=$[q];return typeof q=="string"?N(ie,`${L}.${q}`):ie},set:($,q,ie)=>(B(),W&&(W[q]=ie),!0),deleteProperty:($,q)=>(B(),W&&delete W[q],!0),defineProperty:($,q,ie)=>(B(),W&&Object.defineProperty(W,q,ie),!0)}):y};k=N(k,E)}return k},update:(E,v,k,x)=>{E=o?`${o}.${E}`:E;const N=h(k);return v!==void 0?this._proxy.$updateConfigurationOption(N,E,v,f,x):this._proxy.$removeConfigurationOption(N,E,f,x)},inspect:E=>{E=o?`${o}.${E}`:E;const v=(0,r.deepClone)(this._configuration.inspect(E,f,this._extHostWorkspace.workspace));if(v)return{key:E,defaultValue:v.default?.value,globalValue:v.user?.value,workspaceValue:v.workspace?.value,workspaceFolderValue:v.workspaceFolder?.value,defaultLanguageValue:v.default?.override,globalLanguageValue:v.user?.override,workspaceLanguageValue:v.workspace?.override,workspaceFolderLanguageValue:v.workspaceFolder?.override,languageIds:v.overrideIdentifiers}}};return typeof c=="object"&&(0,r.mixin)(g,c,!1),Object.freeze(g)}_toReadonlyValue(o){const n=u=>(0,T.isObject)(u)?new Proxy(u,{get:(f,c)=>n(f[c]),set:(f,c,h)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(f,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(f,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return n(o)}_validateConfigurationAccess(o,n,u){const f=D.OVERRIDE_PROPERTY_REGEX.test(o)?4:this._configurationScopes.get(o),c=u?`[${u.value}] `:"";if(f===4){typeof n?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${o}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){n?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${o}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(o,n){const u=new P.ConfigurationChangeEvent(o,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(f,c)=>u.affectsConfiguration(f,p(c))})}_toMap(o){return o.reduce((n,u)=>(n.set(u[0],u[1]),n),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[96],_e([0,1,2,13,4,5,7,31,49,32,20,40,14,28,3,11,23,12,68,160,15]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b,p){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(L){function W($){if($!=null)return $}L.from=W;function B($){if($!=null)return $}L.to=B})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var M;(function(L){function W($){if($!=null)return $}L.from=W;function B($){if($!=null)return $}L.to=B})(M=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(L){function W($){if($!=null)return $}L.from=W;function B($){if($!=null)return $}L.to=B})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(L){function W(q){if(q){const ie=q;return ie&&!!ie.process}else return!1}L.is=W;function B(q){if(q==null)return;const ie={process:q.process,args:q.args};return q.options&&(ie.options=o.from(q.options)),ie}L.from=B;function $(q){if(q!=null)return new I.ProcessExecution(q.process,q.args,q.options)}L.to=$})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(L){function W($){if($!=null)return $}L.from=W;function B($){if($!=null)return $}L.to=B})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var f;(function(L){function W(q){if(q){const ie=q;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}L.is=W;function B(q){if(q==null)return;const ie={};return q.commandLine!==void 0?ie.commandLine=q.commandLine:(ie.command=q.command,ie.args=q.args),q.options&&(ie.options=u.from(q.options)),ie}L.from=B;function $(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new I.ShellExecution(q.commandLine,q.options):new I.ShellExecution(q.command,q.args?q.args:[],q.options)}L.to=$})(f=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function(L){function W(q){if(q){let ie=q;return ie&&ie.customExecution==="customExecution"}else return!1}L.is=W;function B(q){return{customExecution:"customExecution"}}L.from=B;function $(q,ie){return ie.get(q)}L.to=$})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var h;(function(L){function W(B,$){let q;return B.scope!==void 0&&typeof B.scope!="number"?q=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===I.TaskScope.Workspace&&$&&$.workspaceFile?q=$.workspaceFile:q=b.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:q}}L.from=W})(h=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function(L){function W(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}L.from=W})(g=e.TaskGroupDTO||(e.TaskGroupDTO={}));var E;(function(L){function W(q,ie){if(q==null)return[];const se=[];for(let X of q){const ge=B(X,ie);ge&&se.push(ge)}return se}L.fromMany=W;function B(q,ie){if(q==null)return;let se;q.execution instanceof I.ProcessExecution?se=n.from(q.execution):q.execution instanceof I.ShellExecution?se=f.from(q.execution):q.execution&&q.execution instanceof I.CustomExecution&&(se=c.from(q.execution));const X=a.from(q.definition);let ge;return q.scope?typeof q.scope=="number"?ge=q.scope:ge=q.scope.uri:ge=I.TaskScope.Workspace,!X||!ge?void 0:{_id:q._id,definition:X,name:q.name,source:{extensionId:ie.identifier.value,label:q.source,scope:ge},execution:se,isBackground:q.isBackground,group:g.from(q.group),presentationOptions:M.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}L.from=B;async function $(q,ie,se){if(q==null)return;let X;n.is(q.execution)?X=n.to(q.execution):f.is(q.execution)?X=f.to(q.execution):c.is(q.execution)&&(X=c.to(q._id,se));const ge=a.to(q.definition);let be;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?be=q.source.scope:be=await ie.resolveWorkspaceFolder(r.URI.revive(q.source.scope)):be=I.TaskScope.Workspace),!ge||!be)return;const pe=new I.Task(ge,be,q.name,q.source.label,X,q.problemMatchers);return q.isBackground!==void 0&&(pe.isBackground=q.isBackground),q.group!==void 0&&(pe.group=I.TaskGroup.from(q.group._id),pe.group&&q.group.isDefault&&(pe.group=new I.TaskGroup(pe.group.id,pe.group.label),q.group.isDefault&&(pe.group.isDefault=q.group.isDefault))),q.presentationOptions&&(pe.presentationOptions=M.to(q.presentationOptions)),q._id&&(pe._id=q._id),q.detail&&(pe.detail=q.detail),pe}L.to=$})(E=e.TaskDTO||(e.TaskDTO={}));var v;(function(L){function W($){return $}L.from=W;function B($){if(!!$)return Object.assign(Object.create(null),$)}L.to=B})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class k{constructor(W,B,$){this._id=B,this._task=$,C.set(this,void 0),Xe(this,C,W,"f")}get task(){return this._task}terminate(){Ie(this,C,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}C=new WeakMap;var x;(function(L){function W(B){return{id:B._id,task:void 0}}L.from=W})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let N=class{constructor(W,B,$,q,ie,se,X,ge){this._onDidExecuteTask=new _.Emitter,this._onDidTerminateTask=new _.Emitter,this._onDidTaskProcessStarted=new _.Emitter,this._onDidTaskProcessEnded=new _.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=q,this._configurationService=ie,this._terminalService=se,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=X,this._deprecationService=ge,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,B,$){if(!$)return new I.Disposable(()=>{});const q=this.nextHandle();return this._handlers.set(q,{type:B,provider:$,extension:W}),this._proxy.$registerTaskProvider(q,B),new I.Disposable(()=>{this._handlers.delete(q),this._proxy.$unregisterTaskProvider(q)})}registerTaskSystem(W,B){this._proxy.$registerTaskSystem(W,B)}fetchTasks(W){return this._proxy.$fetchTasks(v.from(W)).then(async B=>{const $=[];for(let q of B){const ie=await E.to(q,this._workspaceProvider,this._providedCustomExecutions2);ie&&$.push(ie)}return $})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(B=>W.push(B)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,B,$){const q=this._providedCustomExecutions2.get(W.id);q&&(this._activeCustomExecutions2.set(W.id,q),this._terminalService.attachPtyToTerminal(B,await q.callback($))),this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const B=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:B})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const B=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:B,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const B=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:B,exitCode:W.exitCode})}$provideTasks(W,B){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));const q=[],ie=(0,t.asPromise)(()=>$.provider.provideTasks(R.CancellationToken.None)).then(se=>this.provideTasksInternal(B,q,$,se));return new Promise(se=>{ie.then(X=>{Promise.all(q).then(()=>{se(X)})})})}async $resolveTask(W,B){const $=this._handlers.get(W);if(!$)return Promise.reject(new Error("no handler found"));if(B.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${$.type}].`);const q=await E.to(B,this._workspaceProvider,this._providedCustomExecutions2);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const ie=await $.provider.resolveTask(q,R.CancellationToken.None);if(!ie)return;this.checkDeprecation(ie,$);const se=E.from(ie,$.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(se.execution)&&await this.addCustomExecution(se,ie,!0),await this.resolveTaskInternal(se)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,B,$){const q=await this._proxy.$createTaskId(W);!$&&!this._providedCustomExecutions2.has(q)&&(this._notProvidedCustomExecutions.add(q),this._activeCustomExecutions2.set(q,B.execution)),this._providedCustomExecutions2.set(q,B.execution)}async getTaskExecution(W,B){if(typeof W=="string"){const ie=this._taskExecutionPromises.get(W);if(!ie)throw new Error("Unexpected: The specified task is missing an execution");return ie}let $=this._taskExecutionPromises.get(W.id);if($)return $;const q=new Promise((ie,se)=>{function X(ge,be,pe){pe?ie(new k(ge,be.id,pe)):se("Unexpected: Task does not exist.")}B?X(this,W,B):E.to(W.task,this._workspaceProvider,this._providedCustomExecutions2).then(ge=>X(this,W,ge))});return this._taskExecutionPromises.set(W.id,q),q.then(ie=>(this._taskExecutions.set(W.id,ie),ie),ie=>Promise.reject(ie))}checkDeprecation(W,B){W._deprecated&&this._deprecationService.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let $=this._notProvidedCustomExecutions.values(),q=$.next();for(;!q.done;)!this._activeCustomExecutions2.has(q.value)&&this._lastStartedTask!==q.value&&(this._providedCustomExecutions2.delete(q.value),this._notProvidedCustomExecutions.delete(q.value)),q=$.next()}};N=Be([$e(0,i.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,F.ILogService),$e(7,S.IExtHostApiDeprecationService)],N),e.ExtHostTaskBase=N;let y=class extends N{constructor(W,B,$,q,ie,se,X,ge){super(W,B,$,q,ie,se,X,ge);this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:m.PlatformToString(0)})}async executeTask(W,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const $=E.from(B,W);if($===void 0)throw new Error("Task is not valid");if(c.is($.execution))await this.addCustomExecution($,B,!1);else throw new p.NotSupportedError;const q=await this.getTaskExecution(await this._proxy.$getTaskExecution($),B);return this._proxy.$executeTask($).catch(ie=>{throw new Error(ie)}),q}provideTasksInternal(W,B,$,q){const ie=[];if(q)for(let se of q){this.checkDeprecation(se,$),(!se.definition||!W[se.definition.type])&&this._logService.warn(`The task [${se.source}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`);const X=E.from(se,$.extension);X&&c.is(X.execution)?(ie.push(X),B.push(this.addCustomExecution(X,se,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:$.extension}}async resolveTaskInternal(W){if(c.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,B,$){}};y=Be([$e(0,i.IExtHostRpcService),$e(1,d.IExtHostInitDataService),$e(2,P.IExtHostWorkspace),$e(3,D.IExtHostDocumentsAndEditors),$e(4,T.IExtHostConfiguration),$e(5,w.IExtHostTerminalService),$e(6,F.ILogService),$e(7,S.IExtHostApiDeprecationService)],y),e.WorkerExtHostTask=y,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(ye[211],_e([0,1,16,73,29,76,22,11,17,24,9,10,2,232,127,79,47,88,210,41]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let p=class{constructor(h,g,E,v){this.configurationService=h,this.workspaceContextService=g,this.editorGroupsService=E,this.pathService=v}text(h,g,E={}){h=this.getContentPattern(h,E);const v=this.configurationService.getValue(),k=g&&g.some(N=>!this.configurationService.getValue({resource:N}).search.useRipgrep);return{...this.commonQuery(g?.map(m.toWorkspaceFolder),E),type:2,contentPattern:h,previewOptions:E.previewOptions,maxFileSize:E.maxFileSize,usePCRE2:v.search.usePCRE2||k||!1,beforeContext:E.beforeContext,afterContext:E.afterContext,userDisabledExcludesAndIgnoreFiles:E.disregardExcludeSettings&&E.disregardIgnoreFiles}}getContentPattern(h,g){const E=this.configurationService.getValue();h.isRegExp&&(h.pattern=h.pattern.replace(/\r?\n/g,"\\n"));const v={...h,wordSeparators:E.editor.wordSeparators};return this.isCaseSensitive(h,g)&&(v.isCaseSensitive=!0),this.isMultiline(h)&&(v.isMultiline=!0),v}file(h,g={}){return{...this.commonQuery(h,g),type:1,filePattern:g.filePattern?g.filePattern.trim():g.filePattern,exists:g.exists,sortByScore:g.sortByScore,cacheKey:g.cacheKey}}handleIncludeExclude(h,g){return h?(h=Array.isArray(h)?h.map(n):n(h),g?this.parseSearchPaths(h):{pattern:a(...Array.isArray(h)?h:[h])}):{}}commonQuery(h=[],g={}){const E=this.handleIncludeExclude(g.includePattern,g.expandPatterns),v=this.handleIncludeExclude(g.excludePattern,g.expandPatterns),k=h.length>1,x=(E.searchPaths&&E.searchPaths.length?E.searchPaths.map(L=>this.getFolderQueryForSearchPath(L,g,v)):h.map(L=>this.getFolderQueryForRoot(L,g,v,k))).filter(L=>!!L),N={_reason:g._reason,folderQueries:x,usingSearchPaths:!!(E.searchPaths&&E.searchPaths.length),extraFileResources:g.extraFileResources,excludePattern:v.pattern,includePattern:E.pattern,onlyOpenEditors:g.onlyOpenEditors,maxResults:g.maxResults};if(g.onlyOpenEditors){const W=r.coalesce(r.flatten(this.editorGroupsService.groups.map($=>$.editors.map(q=>q.resource)))).filter($=>(0,b.pathIncludedInQuery)(N,$.fsPath)),B=this.commonQueryFromFileList(W);return{...N,...B}}const y=g.extraFileResources&&g.extraFileResources.filter(L=>(0,b.pathIncludedInQuery)(N,L.fsPath));return N.extraFileResources=y&&y.length?y:void 0,N}commonQueryFromFileList(h){const g=[],E=new I.ResourceMap,v={};let k=!1;return h.forEach(x=>{if(x.scheme===P.Schemas.walkThrough)return;if((0,T.isAbsolutePath)(x)){const y=this.workspaceContextService.getWorkspaceFolder(x)?.uri??x.with({path:D.dirname(x.fsPath)});let L=E.get(y);L||(k=!0,L={folder:y,includePattern:{}},g.push(L),E.set(y,L));const W=D.relative(y.fsPath,x.fsPath);(0,w.assertIsDefined)(L.includePattern)[W.replace(/\\/g,"/")]=!0}else x.fsPath&&(k=!0,v[x.fsPath]=!0)}),{folderQueries:g,includePattern:v,usingSearchPaths:!0,excludePattern:k?void 0:{"**/*":!0}}}isCaseSensitive(h,g){if(g.isSmartCase){if(h.isRegExp){if(R.containsUppercaseCharacter(h.pattern,!0))return!0}else if(R.containsUppercaseCharacter(h.pattern))return!0}return!!h.isCaseSensitive}isMultiline(h){return h.isMultiline||h.isRegExp&&(0,d.isMultilineRegexSource)(h.pattern)||h.pattern.indexOf(`
`)>=0?!0:!!h.isMultiline}parseSearchPaths(h){const g=B=>D.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),v=(Array.isArray(h)?h:M(h)).map(B=>{const $=this.pathService.resolvedUserHome;return $?(0,A.untildify)(B,$.scheme===P.Schemas.file?$.fsPath:$.path):B}),k=t.groupBy(v,B=>g(B)?"searchPaths":"exprSegments"),x=(k.exprSegments||[]).map(B=>R.rtrim(B,"/")).map(B=>R.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),o(B))),N={},y=this.expandSearchPathPatterns(k.searchPaths||[]);y&&y.length&&(N.searchPaths=y);const L=r.flatten(x),W=a(...L);return W&&(N.pattern=W),N}getExcludesForFolder(h,g){return g.disregardExcludeSettings?void 0:(0,b.getExcludes)(h,!g.disregardSearchExcludeSettings)}expandSearchPathPatterns(h){if(!h||!h.length)return[];const g=r.flatten(h.map(v=>{let{pathPortion:k,globPortion:x}=C(v);x&&(x=u(x));const N=this.expandOneSearchPath(k);return r.flatten(N.map(y=>this.resolveOneSearchPathPattern(y,x)))})),E=new Map;return g.forEach(v=>{const k=v.searchPath.toString(),x=E.get(k);x?v.pattern&&(x.pattern=x.pattern||{},x.pattern[v.pattern]=!0):E.set(k,{searchPath:v.searchPath,pattern:v.pattern?a(v.pattern):void 0})}),Array.from(E.values())}expandOneSearchPath(h){if(D.isAbsolute(h)){const g=this.workspaceContextService.getWorkspace().folders;return g[0]&&g[0].uri.scheme!==P.Schemas.file?[{searchPath:g[0].uri.with({path:h})}]:[{searchPath:i.URI.file(D.normalize(h))}]}if(this.workspaceContextService.getWorkbenchState()===2){const g=this.workspaceContextService.getWorkspace().folders[0].uri;if(h=n(h),h.startsWith("../")||h===".."){const v=D.posix.resolve(g.path,h);return[{searchPath:g.with({path:v})}]}const E=u(h);return[{searchPath:g,pattern:E}]}else{if(h==="./"||h===".\\")return[];{const g=h.replace(/^\.[\/\\]/,""),v=this.workspaceContextService.getWorkspace().folders.map(k=>{const x=g.match(new RegExp(`^${R.escapeRegExpCharacters(k.name)}(?:/(.*)|$)`));return x?{match:x,folder:k}:null}).filter(w.isDefined);if(v.length)return v.map(k=>{const x=k.match[1];return{searchPath:k.folder.uri,pattern:x&&u(x)}});{const k=h.match(/\.[\/\\](.+)[\/\\]?/),x=k?k[1]:h,N=l.localize(0,null,x);throw new Error(N)}}}}resolveOneSearchPathPattern(h,g){const E=h.pattern&&g?`${h.pattern}/${g}`:h.pattern||g,v=[{searchPath:h.searchPath,pattern:E}];return E&&!E.endsWith("**")&&v.push({searchPath:h.searchPath,pattern:E+"/**"}),v}getFolderQueryForSearchPath(h,g,E){const v=this.getFolderQueryForRoot((0,m.toWorkspaceFolder)(h.searchPath),g,E,!1);return v?{...v,includePattern:h.pattern}:null}getFolderQueryForRoot(h,g,E,v){let k;const x=i.URI.isUri(h)?h:h.uri;if(E.searchPaths){const B=E.searchPaths.filter($=>(0,T.isEqual)($.searchPath,x))[0];if(B&&!B.pattern)return null;B&&(k=B.pattern)}const N=this.configurationService.getValue({resource:x}),L={...this.getExcludesForFolder(N,g)||{},...k||{}},W=i.URI.isUri(h)?(0,T.basename)(h):h.name;return{folder:x,folderName:v?W:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:N.files&&N.files.encoding,disregardIgnoreFiles:typeof g.disregardIgnoreFiles=="boolean"?g.disregardIgnoreFiles:!N.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof g.disregardGlobalIgnoreFiles=="boolean"?g.disregardGlobalIgnoreFiles:!N.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof g.disregardParentIgnoreFiles=="boolean"?g.disregardParentIgnoreFiles:!N.search.useParentIgnoreFiles,ignoreSymlinks:typeof g.ignoreSymlinks=="boolean"?g.ignoreSymlinks:!N.search.followSymlinks}}};p=Be([$e(0,s.IConfigurationService),$e(1,m.IWorkspaceContextService),$e(2,F.IEditorGroupsService),$e(3,S.IPathService)],p),e.QueryBuilder=p;function C(c){const h=c.match(/[\*\{\}\(\)\[\]\?]/);if(h){const g=h.index,E=c.substr(0,g).match(/[/|\\][^/\\]*$/);if(E){let v=c.substr(0,E.index);return v.match(/[/\\]/)||(v+="/"),{pathPortion:v,globPortion:c.substr((E.index||0)+1)}}}return{pathPortion:c}}function a(...c){return c.length?c.reduce((h,g)=>(h[g]=!0,h),Object.create(null)):void 0}function M(c){return _.splitGlobAware(c,",").map(h=>h.trim()).filter(h=>!!h.length)}function o(c){return[`**/${c}/**`,`**/${c}`].map(g=>g.replace(/\*\*\/\*\*/g,"**"))}function n(c){return c.replace(/\\/g,"/")}function u(c){return n(c).replace(/^\.\//,"").replace(/\/+$/g,"")}function f(c,h){c=r.distinct(c,v=>v.toString());const g=[],E=h.getWorkspace();return c&&c.forEach(v=>{let k;if(h.getWorkbenchState()===2)k=(0,T.relativePath)(E.folders[0].uri,v),k&&k!=="."&&(k="./"+k);else{const x=h.getWorkspaceFolder(v);if(x){const N=x.name;if(E.folders.filter(L=>L.name===N).length===1){const L=(0,T.relativePath)(x.uri,v);L===""?k=`./${x.name}`:k=`./${x.name}/${L}`}else k=v.fsPath}}k&&g.push(k)}),g}e.resolveResourcesForSearchIncludes=f}),define(ye[212],_e([0,1,24,2,20,15,3,211,41,47]),function(ee,e,r,t,_,A,I,P,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function w(s,m){const F=m.activationEvents;if(!F)return Promise.resolve(void 0);const S=[],b=[];for(const n of F)if(/^workspaceContains:/.test(n)){const u=n.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||s.forceUsingSearch?b.push(u):S.push(u)}if(S.length===0&&b.length===0)return Promise.resolve(void 0);let p;const C=new Promise((n,u)=>{p=n}),a=n=>p({activationEvent:n}),M=Promise.all(S.map(n=>i(s,n,a))).then(()=>{}),o=d(s,m.identifier,b,a);return Promise.all([M,o]).then(()=>{p(void 0)}),C}e.checkActivateWorkspaceContainsExtension=w;async function i(s,m,F){for(const S of s.folders)if(await s.exists(r.joinPath(t.URI.revive(S),m))){F(`workspaceContains:${m}`);return}}async function d(s,m,F,S){if(F.length===0)return Promise.resolve(void 0);const b=new _.CancellationTokenSource,p=s.checkExists(s.folders,F,b.token),C=setTimeout(async()=>{b.cancel(),s.logService.info(`Not activating extension '${m.value}': Timed out while searching for 'workspaceContains' pattern ${F.join(",")}`)},R);let a=!1;try{a=await p}catch(M){A.isCancellationError(M)||A.onUnexpectedError(M)}b.dispose(),clearTimeout(C),a&&S(`workspaceContains:${F.join(",")}`)}function l(s,m,F,S){const b=s.get(I.IInstantiationService),p=s.get(D.ISearchService),a=b.createInstance(P.QueryBuilder).file(m.map(M=>(0,T.toWorkspaceFolder)(t.URI.revive(M))),{_reason:"checkExists",includePattern:F,exists:!0});return p.fileSearch(a,S).then(M=>!!M.limitHit,M=>A.isCancellationError(M)?!1:Promise.reject(M))}e.checkGlobFileExists=l});var Xe=this&&this.__classPrivateFieldSet||function(ee,e,r,t,_){if(t==="m")throw new TypeError("Private method is not writable");if(t==="a"&&!_)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!_:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return t==="a"?_.call(ee,r):_?_.value=r:e.set(ee,r),r},Ie=this&&this.__classPrivateFieldGet||function(ee,e,r,t){if(r==="a"&&!t)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!t:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?t:r==="a"?t.call(ee):t?t.value:e.get(ee)};define(ye[33],_e([0,1,119,17,72,24,13,6,22,2,12,5,32,171,70,31,26,169,15,25,21,146,7,82,3,28,71,14,59,63,40,4,212,67,148,11]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b,p,C,a,M,o,n,u,f,c,h,g,E,v,k,x,N){"use strict";var y,L,W;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,o.createDecorator)("IHostUtils");let B=class Gi extends P.Disposable{constructor(X,ge,be,pe,fe,oe,Ee,Pe,Oe,je){super();this._onDidChangeRemoteConnectionData=this._register(new E.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ge,this._extHostContext=be,this._initData=Ee,this._extHostWorkspace=pe,this._extHostConfiguration=fe,this._logService=oe,this._extHostTunnelService=Oe,this._extHostTerminalService=je,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(w.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(w.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(w.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new I.Barrier,this._readyToStartExtensionHost=new I.Barrier,this._readyToRunExtensions=new I.Barrier,this._eagerExtensionsActivated=new I.Barrier,this._registry=new F.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new k.ExtHostSecretState(this._extHostContext),this._storagePath=Pe,this._instaService=X.createChild(new c.ServiceCollection([l.IExtHostStorage,this._storage],[k.IExtHostSecretState,this._secretState]));const st=new Set;this._initData.hostExtensions.forEach(et=>st.add(b.ExtensionIdentifier.toKey(et))),this._activator=this._register(new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(et,tt,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(et,S.transformErrorForSerialization(tt),H)},actualActivateExtension:async(et,tt)=>{if(st.has(b.ExtensionIdentifier.toKey(et)))return await this._mainThreadExtensionsProxy.$activateExtension(et,tt),new d.HostExtension;const H=this._registry.getExtensionDescription(et);return this._activateExtension(H,tt)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),_.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(X){S.onUnexpectedError(X)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let X=[];try{X=this._registry.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this._deactivate(fe))}catch{}await Promise.all(X)}isActivated(X){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(X):!1}_activateByEvent(X,ge){return this._activator.activateByEvent(X,ge)}_activateById(X,ge){return this._activator.activateById(X,ge)}activateByIdWithErrors(X,ge){return this._activateById(X,ge).then(()=>{const be=this._activator.getActivatedExtension(X);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(X=>this._registry)}getExtensionExports(X){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(X).exports:null}async _realPathExtensionUri(X){if(X.scheme!==N.Schemas.file)return X;const ge=await this._hostUtils.realpath(X.fsPath);return T.URI.file(ge)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const X=D.TernarySearchTree.forUris(ge=>A.extUriBiasedIgnorePathCase.ignorePathCasing(ge));for(const ge of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ge)){const be=await this._realPathExtensionUri(ge.extensionLocation);X.set(be,ge)}return X})()),this._extensionPathIndex}_deactivate(X){let ge=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(X))return ge;const be=this._activator.getActivatedExtension(X);if(!be)return ge;try{typeof be.module.deactivate=="function"&&(ge=Promise.resolve(be.module.deactivate()).then(void 0,pe=>(this._logService.error(pe),Promise.resolve(void 0))))}catch(pe){this._logService.error(`An error occurred when deactivating the extension '${X.value}':`),this._logService.error(pe)}try{(0,P.dispose)(be.subscriptions)}catch(pe){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this._logService.error(pe)}return ge}async _activateExtension(X,ge){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(X.identifier),this._doActivateExtension(X,ge).then(be=>{const pe=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(X.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,ge),this._logExtensionActivationTimes(X,ge,"success",pe),be},be=>{throw this._logExtensionActivationTimes(X,ge,"failure"),be})}_logExtensionActivationTimes(X,ge,be,pe){const fe=$(X,ge);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...fe,...pe||{},outcome:be})}_doActivateExtension(X,ge){const be=$(X,ge);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const pe=this._getEntryPoint(X);if(!pe)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${ge.startup}, activationEvent: '${ge.activationEvent}'${X.identifier.value!==ge.extensionId.value?`, root cause: ${ge.extensionId.value}`:""}`),this._logService.flush();const fe=new d.ExtensionActivationTimesBuilder(ge.startup);return Promise.all([this._loadCommonJSModule(X.identifier,(0,A.joinPath)(X.extensionLocation,pe),fe),this._loadExtensionContext(X)]).then(oe=>(_.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Gi._callActivate(this._logService,X.identifier,oe[0],oe[1],fe))).then(oe=>(_.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),oe))}_loadExtensionContext(X){const ge=new C.ExtensionGlobalMemento(X,this._storage),be=new C.ExtensionMemento(X.identifier.value,!1,this._storage),pe=new x.ExtensionSecrets(X,this._secretState),fe=X.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,oe=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([ge.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Ee=this;let Pe,Oe;const je=(0,m.isProposedApiEnabled)(X,"ipc")?this._initData.messagePorts?.get(b.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:ge,workspaceState:be,secrets:pe,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(st){return t.join(X.extensionLocation.fsPath,st)},get storagePath(){return Ee._storagePath.workspaceValue(X)?.fsPath},get globalStoragePath(){return Ee._storagePath.globalValue(X).fsPath},get logPath(){return t.join(Ee._initData.logsLocation.fsPath,X.identifier.value)},get logUri(){return T.URI.joinPath(Ee._initData.logsLocation,X.identifier.value)},get storageUri(){return Ee._storagePath.workspaceValue(X)},get globalStorageUri(){return Ee._storagePath.globalValue(X)},get extensionMode(){return fe},get extension(){return Pe===void 0&&(Pe=new q(Ee,X.identifier,X,oe)),Pe},get extensionRuntime(){return(0,m.checkProposedApiEnabled)(X,"extensionRuntime"),Ee.extensionRuntime},get environmentVariableCollection(){return Ee._extHostTerminalService.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!Oe){if(!je)return;const st=E.Event.buffer(E.Event.fromDOMEventEmitter(je,"message",et=>et.data));je.start(),Oe={onDidReceiveMessage:st,postMessage:je.postMessage.bind(je)}}return Oe}})})}static _callActivate(X,ge,be,pe,fe){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(X,ge,be,pe,fe).then(oe=>new d.ActivatedExtension(!1,null,fe.build(),be,oe,pe.subscriptions))}static _callActivateOptional(X,ge,be,pe,fe){if(typeof be.activate=="function")try{fe.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${ge.value}`);const oe=typeof global=="object"?global:self,Ee=be.activate.apply(oe,[pe]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(Ee).then(Pe=>(fe.activateResolveStop(),Pe))}catch(oe){return Promise.reject(oe)}else return Promise.resolve(be)}_activateOneStartupFinished(X,ge){this._activateById(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:ge}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(_.getMarks());for(const X of this._registry.getAllExtensionDescriptions())if(X.activationEvents)for(const ge of X.activationEvents)ge==="onStartupFinished"&&this._activateOneStartupFinished(X,ge)}_handleEagerExtensions(){const X=this._activateByEvent("*",!0).then(void 0,fe=>{this._logService.error(fe)});this._register(this._extHostWorkspace.onDidChangeWorkspace(fe=>this._handleWorkspaceContainsEagerExtensions(fe.added)));const ge=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(ge),pe=Promise.all([X,be]).then(()=>{});return Promise.race([pe,(0,I.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),pe}_handleWorkspaceContainsEagerExtensions(X){return X.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ge=>this._handleWorkspaceContainsEagerExtension(X,ge))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(X,ge){if(this.isActivated(ge.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,pe={logService:this._logService,folders:X.map(oe=>oe.uri),forceUsingSearch:be,exists:oe=>this._hostUtils.exists(oe.fsPath),checkExists:(oe,Ee,Pe)=>this._mainThreadWorkspaceProxy.$checkExists(oe,Ee,Pe)},fe=await(0,v.checkActivateWorkspaceContainsExtension)(pe,ge);if(!!fe)return this._activateById(ge.identifier,{startup:!0,extensionId:ge.identifier,activationEvent:fe.activationEvent}).then(void 0,oe=>this._logService.error(oe))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(X){throw console.error(X),X}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:ge}=this._initData.environment;if(!X||!ge)throw new Error(r.localize(0,null));const be=await this._loadCommonJSModule(null,ge,new d.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(r.localize(1,null,ge.toString()));return new Promise((pe,fe)=>{const oe=(Oe,je)=>{Oe?fe(Oe):pe(typeof je=="number"&&je>0?1:0)},Ee=(0,A.originalFSPath)(ge),Pe=be.run(Ee,oe);Pe&&Pe.then&&Pe.then(()=>{pe(0)}).catch(Oe=>{fe(Oe instanceof Error&&Oe.stack?Oe.stack:String(Oe))})})}async $extensionTestsExit(X){this._logService.info(`Extension host terminating: test runner requested exit with code ${X}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${X}`),this._logService.flush(),this._hostUtils.exit(X)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,ge){return this._resolvers[X]=ge,(0,P.toDisposable)(()=>{delete this._resolvers[X]})}async _activateAndGetResolver(X){const ge=X.indexOf("+");if(ge===-1)throw new Error("Not an authority that can be resolved!");const be=X.substr(0,ge);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(X,ge){this._logService.info(`$resolveAuthority invoked for authority (${ie(X)})`);const{authorityPrefix:be,resolver:pe}=await this._activateAndGetResolver(X);if(!pe)return{type:"error",error:{code:M.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(pe)),_.mark(`code/extHost/willResolveAuthority/${be}`);const fe=await pe.resolve(X,{resolveAttempt:ge});_.mark(`code/extHost/didResolveAuthorityOK/${be}`);const oe={authority:X,host:fe.host,port:fe.port,connectionToken:fe.connectionToken},Ee={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:oe,options:Ee,tunnelInformation:{environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures}}}}catch(fe){if(_.mark(`code/extHost/didResolveAuthorityError/${be}`),fe instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe}}async $getCanonicalURI(X,ge){this._logService.info(`$getCanonicalURI invoked for authority (${ie(X)})`);const{authorityPrefix:be,resolver:pe}=await this._activateAndGetResolver(X);if(!pe)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${be}`);const fe=T.URI.revive(ge);if(typeof pe.getCanonicalURI=="undefined")return fe;const oe=await(0,I.asPromise)(()=>pe.getCanonicalURI(fe));return oe||fe}$startExtensionHost(X){return this._registry.keepOnly(X),this._startExtensionHost()}$activateByEvent(X,ge){return ge===1?this._activateByEvent(X,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(X,!1))}async $activate(X,ge){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(X)?(await this._activateById(X,ge),!0):!1}async $deltaExtensions(X,ge){X.forEach(pe=>pe.extensionLocation=T.URI.revive(pe.extensionLocation));const be=await this.getExtensionPathIndex();return await Promise.all(ge.map(async pe=>{const fe=this._registry.getExtensionDescription(pe);fe&&be.delete(await this._realPathExtensionUri(fe.extensionLocation))})),await Promise.all(X.map(async pe=>{const fe=await this._realPathExtensionUri(pe.extensionLocation);be.set(fe,pe)})),this._registry.deltaExtensions(X,ge),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){let ge=p.VSBuffer.alloc(X),be=Math.random()%256;for(let pe=0;pe<X;pe++)ge.writeUInt8(be,pe);return ge}async $updateRemoteConnectionData(X){this._remoteConnectionData=X,this._onDidChangeRemoteConnectionData.fire()}};B=Be([$e(0,o.IInstantiationService),$e(1,e.IHostUtils),$e(2,f.IExtHostRpcService),$e(3,s.IExtHostWorkspace),$e(4,i.IExtHostConfiguration),$e(5,R.ILogService),$e(6,n.IExtHostInitDataService),$e(7,u.IExtensionStoragePaths),$e(8,h.IExtHostTunnelService),$e(9,g.IExtHostTerminalService)],B),e.AbstractExtHostExtensionService=B;function $(se,X){return{id:se.identifier.value,name:se.name,extensionVersion:se.version,publisherDisplayName:se.publisher,activationEvents:se.activationEvents?se.activationEvents.join(","):null,isBuiltin:se.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,o.createDecorator)("IExtHostExtensionService");class q{constructor(X,ge,be,pe){y.set(this,void 0),L.set(this,void 0),W.set(this,void 0),Xe(this,y,X,"f"),Xe(this,L,ge,"f"),Xe(this,W,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=t.normalize((0,A.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=pe}get isActive(){return Ie(this,y,"f").isActivated(Ie(this,W,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ie(this,y,"f").getExtensionExports(Ie(this,W,"f"))}activate(){return Ie(this,y,"f").activateByIdWithErrors(Ie(this,W,"f"),{startup:!1,extensionId:Ie(this,L,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=q,y=new WeakMap,L=new WeakMap,W=new WeakMap;function ie(se){const X=se.indexOf("+");return X===-1?se:se.substring(0,X)}}),define(ye[97],_e([0,1,17,2,4,13,5,7,155,31,33,49,162,32,156,14,3,10,87,69]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,m.createDecorator)("IExtHostDebugService");let p=class{constructor(c,h,g,E,v,k){this._workspaceService=h,this._extensionService=g,this._editorsService=E,this._configurationService=v,this._editorTabs=k,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new _.Emitter,this._onDidTerminateDebugSession=new _.Emitter,this._onDidChangeActiveDebugSession=new _.Emitter,this._onDidReceiveDebugSessionCustomEvent=new _.Emitter,this._debugServiceProxy=c.getProxy(I.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new _.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(x=>{x.onDidChange(N=>{this.registerAllDebugTypes(x)}),this.registerAllDebugTypes(x)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,h){const g=c;if(typeof g.sourceReference=="number"&&g.sourceReference>0){let E=`debug:${encodeURIComponent(g.path||"")}`,v="?";return h&&(E+=`${v}session=${encodeURIComponent(h.id)}`,v="&"),E+=`${v}ref=${g.sourceReference}`,t.URI.parse(E)}else{if(g.path)return t.URI.file(g.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const h=[];for(const g of c.getAllExtensionDescriptions())if(g.contributes){const E=g.contributes.debuggers;if(E&&E.length>0)for(const v of E)(0,l.isDebuggerMainContribution)(v)&&h.push(v.type)}this._debugServiceProxy.$registerDebugTypes(h)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(h=>c.push(h)),c}addBreakpoints(c){this.startBreakpoints();const h=c.filter(v=>{const k=v.id;return this._breakpoints.has(k)?!1:(this._breakpoints.set(k,v),!0)});this.fireBreakpointChanges(h,[],[]);const g=[],E=new Map;for(const v of h)if(v instanceof P.SourceBreakpoint){let k=E.get(v.location.uri.toString());k||(k={type:"sourceMulti",uri:v.location.uri,lines:[]},E.set(v.location.uri.toString(),k),g.push(k)),k.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof P.FunctionBreakpoint&&g.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(g)}removeBreakpoints(c){this.startBreakpoints();const h=c.filter(k=>this._breakpoints.delete(k.id));this.fireBreakpointChanges([],h,[]);const g=h.filter(k=>k instanceof P.SourceBreakpoint).map(k=>k.id),E=h.filter(k=>k instanceof P.FunctionBreakpoint).map(k=>k.id),v=h.filter(k=>k instanceof P.DataBreakpoint).map(k=>k.id);return this._debugServiceProxy.$unregisterBreakpoints(g,E,v)}startDebugging(c,h,g){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,h,{parentSessionID:g.parentSession?g.parentSession.id:void 0,lifecycleManagedByParent:g.lifecycleManagedByParent,repl:g.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:g.noDebug,compact:g.compact,debugUI:g.debugUI,suppressSaveBeforeStart:g.suppressSaveBeforeStart})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,h,g){if(!h)return new P.Disposable(()=>{});const E=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:E,provider:h}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,g,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,E),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==h),this._debugServiceProxy.$unregisterDebugConfigurationProvider(E)})}registerDebugAdapterDescriptorFactory(c,h,g){if(!g)return new P.Disposable(()=>{});if(!this.definesDebugType(c,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.getAdapterDescriptorFactoryByType(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const E=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:h,handle:E,factory:g}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(h,E),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==g),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(E)})}registerDebugAdapterTrackerFactory(c,h){if(!h)return new P.Disposable(()=>{});const g=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:g,factory:h}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(E=>E.factory!==h)})}async $runInTerminal(c,h){return Promise.resolve(void 0)}async $substituteVariables(c,h){if(!this._variableResolver){const[v,k]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,k)}let g;const E=await this.getFolder(c);return E&&(g={uri:E.uri,name:E.name,index:E.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(g,h)}createDebugAdapter(c,h){if(c.type==="implementation")return new n(c.implementation)}createSignService(){}async $startDASession(c,h){const g=this,E=await this.getSession(h);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(E.type),E).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}' (extension might have failed to activate)`);const k=this.convertToDto(v),x=this.createDebugAdapter(k,E);if(!x)throw new Error(`Couldn't create a debug adapter for type '${E.type}'.`);const N=x;return this._debugAdapters.set(c,N),this.getDebugAdapterTrackers(E).then(y=>(y&&this._debugAdaptersTrackers.set(c,y),N.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const W=L,B={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(W.arguments.value);B.body={signature:$},N.sendResponse(B)}else throw new Error("no signer")}catch($){B.success=!1,B.message=$.message,N.sendResponse(B)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(L),L=(0,l.convertToVSCPaths)(L,!0),g._debugServiceProxy.$acceptDAMessage(c,L)}),N.onError(L=>{y&&y.onError&&y.onError(L),this._debugServiceProxy.$acceptDAError(c,L.name,L.message,L.stack)}),N.onExit(L=>{y&&y.onExit&&y.onExit((0,F.withNullAsUndefined)(L),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,F.withNullAsUndefined)(L),void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),N.startSession()))})}$sendDAMessage(c,h){h=(0,l.convertToDAPaths)(h,!1);const g=this._debugAdaptersTrackers.get(c);g&&g.onWillReceiveMessage&&g.onWillReceiveMessage(h);const E=this._debugAdapters.get(c);E&&E.sendMessage(h)}$stopDASession(c){const h=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),h&&h.onWillStopSession&&h.onWillStopSession();const g=this._debugAdapters.get(c);return this._debugAdapters.delete(c),g?g.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const h=[],g=[],E=[];if(c.added)for(const v of c.added){const k=v.id;if(k&&!this._breakpoints.has(k)){let x;if(v.type==="function")x=new P.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")x=new P.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const N=t.URI.revive(v.uri);x=new P.SourceBreakpoint(new P.Location(N,new P.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}x._id=k,this._breakpoints.set(k,x),h.push(x)}}if(c.removed)for(const v of c.removed){const k=this._breakpoints.get(v);k&&(this._breakpoints.delete(v),g.push(k))}if(c.changed){for(const v of c.changed)if(v.id){const k=this._breakpoints.get(v.id);if(k){if(k instanceof P.FunctionBreakpoint&&v.type==="function"){const x=k;x.enabled=v.enabled,x.condition=v.condition,x.hitCondition=v.hitCondition,x.logMessage=v.logMessage,x.functionName=v.functionName}else if(k instanceof P.SourceBreakpoint&&v.type==="source"){const x=k;x.enabled=v.enabled,x.condition=v.condition,x.hitCondition=v.hitCondition,x.logMessage=v.logMessage,x.location=new P.Location(t.URI.revive(v.uri),new P.Position(v.line,v.character))}E.push(k)}}}this.fireBreakpointChanges(h,g,E)}$provideDebugConfigurations(c,h,g){return(0,A.asPromise)(async()=>{const E=this.getConfigProviderByHandle(c);if(!E)throw new Error("no DebugConfigurationProvider found");if(!E.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(h);return E.provideDebugConfigurations(v,g)}).then(E=>{if(!E)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return E})}$resolveDebugConfiguration(c,h,g,E){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.getFolder(h);return v.resolveDebugConfiguration(k,g,E)})}$resolveDebugConfigurationWithSubstitutedVariables(c,h,g,E){return(0,A.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.getFolder(h);return v.resolveDebugConfigurationWithSubstitutedVariables(k,g,E)})}async $provideDebugAdapter(c,h){const g=this.getAdapterDescriptorFactoryByHandle(c);if(!g)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const E=await this.getSession(h);return this.getAdapterDescriptor(g,E).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${E.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(c){const h=await this.getSession(c);this._onDidStartDebugSession.fire(h)}async $acceptDebugSessionTerminated(c){const h=await this.getSession(c);h&&(this._onDidTerminateDebugSession.fire(h),this._debugSessions.delete(h.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,h){const g=await this.getSession(c);g&&g._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(c,h){const E={session:await this.getSession(c),event:h.event,body:h.body};this._onDidReceiveDebugSessionCustomEvent.fire(E)}convertToDto(c){if(c instanceof P.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof P.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const h=this._adapterFactories.filter(g=>g.type===c);if(h.length>0)return h[0].factory}getAdapterDescriptorFactoryByHandle(c){const h=this._adapterFactories.filter(g=>g.handle===c);if(h.length>0)return h[0].factory}getConfigProviderByHandle(c){const h=this._configProviders.filter(g=>g.handle===c);if(h.length>0)return h[0].provider}definesDebugType(c,h){if(c.contributes){const g=c.contributes.debuggers;if(g&&g.length>0){for(const E of g)if(E.label&&E.type&&E.type===h)return!0}}return!1}getDebugAdapterTrackers(c){const g=c.configuration.type,E=this._trackerFactories.filter(v=>v.type===g||v.type==="*").map(v=>(0,A.asPromise)(()=>v.factory.createDebugAdapterTracker(c)).then(k=>k,k=>null));return Promise.race([Promise.all(E).then(v=>{const k=v.filter(x=>!!x);if(k.length>0)return new o(k)}),new Promise((v,k)=>{const x=setTimeout(()=>{clearTimeout(x),k(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(c,h){const g=h.configuration.debugServer;if(typeof g=="number")return Promise.resolve(new P.DebugAdapterServer(g));if(c){const v=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>c.createDebugAdapterDescriptor(h,this.daExecutableFromPackage(h,v))).then(k=>{if(k)return k})}const E=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(h,E))}daExecutableFromPackage(c,h){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,h,g){(c.length>0||h.length>0||g.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:h,changed:g}))}async getSession(c){if(c)if(typeof c=="string"){const h=this._debugSessions.get(c);if(h)return h}else{let h=this._debugSessions.get(c.id);if(!h){const g=await this.getFolder(c.folderUri),E=c.parent?this._debugSessions.get(c.parent):void 0;h=new C(this._debugServiceProxy,c.id,c.type,c.name,g,c.configuration,E),this._debugSessions.set(h.id,h),this._debugServiceProxy.$sessionCached(h.id)}return h}throw new Error("cannot find session")}getFolder(c){if(c){const h=t.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};p=Be([$e(0,s.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,w.IExtHostDocumentsAndEditors),$e(4,d.IExtHostConfiguration),$e(5,b.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class C{constructor(c,h,g,E,v,k,x){this._debugServiceProxy=c,this._id=h,this._type=g,this._name=E,this._workspaceFolder=v,this._configuration=k,this._parentSession=x}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}get parentSession(){return this._parentSession}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,h){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,h)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=C;class a{constructor(c){this.value=Object.freeze({append(h){c.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.ExtHostDebugConsole=a;class M extends i.AbstractVariableResolverService{constructor(c,h,g,E,v){function k(){if(h){const x=h.activeEditor();if(x)return x.document.uri;const N=E.tabs.filter(y=>y.isActive);if(N.length>0){const y=N[0].resource;return y&&(y.primary||y.secondary)?y.primary??y.secondary:N[0].resource}}}super({getFolderUri:x=>{const N=c.filter(y=>y.name===x);if(N&&N.length>0)return N[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(x,N)=>g.getConfiguration(void 0,x).get(N),getAppRoot:()=>S.cwd(),getExecPath:()=>S.env.VSCODE_EXEC_PATH,getFilePath:()=>{const x=k();if(x)return r.normalize(x.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const x=k();if(x){const N=v.getWorkspaceFolder(x);if(N)return r.normalize(N.uri.fsPath)}}},getSelectedText:()=>{if(h){const x=h.activeEditor();if(x&&!x.selection.isEmpty)return x.document.getText(x.selection)}},getLineNumber:()=>{if(h){const x=h.activeEditor();if(x)return String(x.selection.end.line+1)}}},void 0,Promise.resolve(S.env))}}e.ExtHostVariableResolverService=M;class o{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(h=>h.onError?h.onError(c):void 0)}onExit(c,h){this.trackers.forEach(g=>g.onExit?g.onExit(c,h):void 0)}}class n extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends p{constructor(c,h,g,E,v,k){super(c,h,g,E,v,k)}createVariableResolver(c,h,g){return new M(c,h,g,this._editorTabs)}};u=Be([$e(0,s.IExtHostRpcService),$e(1,T.IExtHostWorkspace),$e(2,R.IExtHostExtensionService),$e(3,w.IExtHostDocumentsAndEditors),$e(4,d.IExtHostConfiguration),$e(5,b.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(ye[213],_e([0,1,72,2,5,32,26,25,14,28,3,33,87,12,9]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let s=class{constructor(C,a,M,o,n,u,f){this._apiFactory=C,this._extensionRegistry=a,this._instaService=M,this._extHostConfiguration=o,this._extHostExtensionService=n,this._initData=u,this._logService=f,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),r.mark("code/extHost/willWaitForConfig");const C=await this._extHostConfiguration.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new F(this._apiFactory,a,this._extensionRegistry,C,this._logService)),this.register(this._instaService.createInstance(S,a)),this.register(this._instaService.createInstance(m)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,a,this._initData.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(let a of C.nodeModuleName)this._factories.set(a,C);else this._factories.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this._alternatives.push(a=>C.alternativeModuleName(a))}};s=Be([$e(2,R.IInstantiationService),$e(3,A.IExtHostConfiguration),$e(4,w.IExtHostExtensionService),$e(5,T.IExtHostInitDataService),$e(6,d.ILogService)],s),e.RequireInterceptor=s;let m=class zi{constructor(C){if(C.environment.appRoot&&zi.aliased.size){const a=(0,l.escapeRegExpCharacters)(this.forceForwardSlashes(C.environment.appRoot.fsPath)),M="[a-z0-9_.-]",o=`@${M}+\\/${M}+|${M}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${n}\\/)(${o})(.*)$`,"i")}}alternativeModuleName(C){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(C));if(!a)return;const[,M,o,n]=a,u=zi.aliased.get(o);if(u!==void 0)return console.warn(`${o} as been renamed to ${u}, please update your imports`),M+u+n}forceForwardSlashes(C){return C.replace(/\\/g,"/")}};m.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"]]),m=Be([$e(0,T.IExtHostInitDataService)],m);class F{constructor(C,a,M,o,n){this._apiFactory=C,this._extensionPaths=a,this._extensionRegistry=M,this._configProvider=o,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(C,a){const M=this._extensionPaths.findSubstr(a);if(M){let o=this._extApiImpl.get(P.ExtensionIdentifier.toKey(M.identifier));return o||(o=this._apiFactory(M,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(M.identifier),o)),o}if(!this._defaultApiImpl){let o="";this._extensionPaths.forEach((n,u)=>o+=`	${u} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${o}`),this._defaultApiImpl=this._apiFactory(I.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let S=class{constructor(C,a,M){this._extensionPaths=C,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(_.MainContext.MainThreadTelemetry);const{environment:o}=M,n=a.getProxy(_.MainContext.MainThreadKeytar);if(o.appRoot){let u=o.appRoot.fsPath;i.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,f)=>n.$getPassword(u,f),setPassword:(u,f,c)=>n.$setPassword(u,f,c),deletePassword:(u,f)=>n.$deletePassword(u,f),findPassword:u=>n.$findPassword(u),findCredentials(u){return n.$findCredentials(u)}}}load(C,a){const M=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:M?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(C){const a=C.length;if(a<=7||!this.alternativeNames)return;const M=a-7;if((C.charAt(M)==="/"||C.charAt(M)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.alternativeNames.has(C)))return"keytar"}};S=Be([$e(1,D.IExtHostRpcService),$e(2,T.IExtHostInitDataService)],S);let b=class{constructor(C,a,M){this._extensionPaths=C,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=M.getProxy(_.MainContext.MainThreadTelemetry);const o=M.getProxy(_.MainContext.MainThreadWindow);this._impl=(n,u)=>{const f=t.URI.parse(n);return u?this.callOriginal(n,u):f.scheme==="http"||f.scheme==="https"?o.$openUri(f,n,{allowTunneling:!0}):f.scheme==="mailto"||f.scheme===this._appUriScheme?o.$openUri(f,n,{}):this.callOriginal(n,u)}}load(C,a,M){const o=this._extensionPaths.findSubstr(a);return o&&(this._extensionId=o.identifier.value,this.sendShimmingTelemetry()),this._original=M(C),this._impl}callOriginal(C,a){return this.sendNoForwardTelemetry(),this._original(C,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Be([$e(2,D.IExtHostRpcService)],b)}),define(ye[214],_e([0,1,13,15,72,6,2,5,207,12,44,59,28,136,14,64,33,40]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class S{constructor(p,C,a,M,o){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new D.RPCProtocol(p,null,M),C=S._transform(C,this._rpcProtocol);const n=new w.ServiceCollection(...(0,R.getSingletonServiceDescriptors)());n.set(i.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:o}),n.set(l.IExtHostRpcService,new l.ExtHostRpcService(this._rpcProtocol)),n.set(s.IURITransformerService,new s.URITransformerService(M)),n.set(m.IHostUtils,a);const u=new d.InstantiationService(n,!0);this._disposables.add(u.invokeFunction(g=>g.get(F.IExtHostTerminalService))),this._disposables.add(u.invokeFunction(g=>g.get(m.IExtHostExtensionService))),this._logService=u.invokeFunction(g=>g.get(T.ILogService)),_.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",C),this._extensionService=u.invokeFunction(g=>g.get(m.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const f=new WeakMap;this._extensionService.getExtensionPathIndex().then(g=>{Error.prepareStackTrace=(E,v)=>{let k="",x,N;for(const y of v)k+=`
	at ${y.toString()}`,N=y.getFileName(),!x&&N&&(x=g.findSubstr(I.URI.file(N)));return f.set(E,x),`${E.name||"Error"}: ${E.message||""}${k}`}});const c=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),h=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);t.setUnexpectedErrorHandler(g=>{const E=t.transformErrorForSerialization(g),v=f.get(g);v?c.$onExtensionRuntimeError(v.identifier,E):h.$onUnexpectedError(E)})}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),t.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const C=this._extensionService.deactivateAll();Promise.race([(0,r.timeout)(5e3),C]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,C){p.extensions.forEach(M=>M.extensionLocation=I.URI.revive(C.transformIncomingURIs(M.extensionLocation))),p.environment.appRoot=I.URI.revive(C.transformIncomingURIs(p.environment.appRoot));const a=p.environment.extensionDevelopmentLocationURI;return a&&(p.environment.extensionDevelopmentLocationURI=a.map(M=>I.URI.revive(C.transformIncomingURIs(M)))),p.environment.extensionTestsLocationURI=I.URI.revive(C.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=I.URI.revive(C.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=I.URI.revive(C.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=I.URI.revive(C.transformIncomingURIs(p.logsLocation)),p.logFile=I.URI.revive(C.transformIncomingURIs(p.logFile)),p.workspace=C.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=S}),define(ye[215],_e([0,1,17,20,43,29,24,188,41]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class T{constructor(i,d,l){this.config=i,this.provider=d,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=i.filePattern,this.includePattern=i.includePattern&&A.parse(i.includePattern),this.maxResults=i.maxResults||void 0,this.exists=i.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=i.excludePattern&&A.parse(i.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(i=>i.cancel()),this.activeCancellationTokens=new Set}search(i){const d=this.config.folderQueries||[];return new Promise((l,s)=>{const m=F=>{this.resultCount++,i(F)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(F=>{const S=F.toString(),b=r.basename(S);this.globalExcludePattern&&this.globalExcludePattern(S,b)||this.matchFile(m,{base:F,basename:b})}),Promise.all(d.map(F=>this.searchInFolder(F,m))).then(F=>{l({limitHit:this.isLimitHit,stats:F[0]||void 0})},F=>{s(new Error((0,_.toErrorMessage)(F)))})})}async searchInFolder(i,d){const l=new t.CancellationTokenSource,s=this.getSearchOptionsForFolder(i),m=this.initDirectoryTree(),F=new D.QueryGlobTester(this.config,i),S=!F.hasSiblingExcludeClauses();let b;try{this.activeCancellationTokens.add(l),b=P.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,l.token),C=b.elapsed(),a=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(M=>{const o=r.posix.relative(i.folder.path,M.path);if(S){const n=r.basename(M.path);this.matchFile(d,{base:i.folder,relativePath:o,basename:n});return}this.addDirectoryEntries(m,i.folder,o,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(m,F,d),{providerTime:C,postProcessTime:a.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(i){const d=(0,D.resolvePatternsForProvider)(this.config.includePattern,i.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,i.excludePattern);return{folder:i.folder,excludes:l,includes:d,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries({pathToEntries:i},d,l,s){if(l===this.filePattern){const F=r.basename(this.filePattern);this.matchFile(s,{base:d,relativePath:this.filePattern,basename:F})}function m(F){const S=r.basename(F),b=r.dirname(F);let p=i[b];p||(p=i[b]=[],m(b)),p.push({base:d,relativePath:F,basename:S})}m(l)}matchDirectoryTree({rootEntries:i,pathToEntries:d},l,s){const m=this,F=this.filePattern;function S(b){const p=A.hasSiblingFn(()=>b.map(C=>C.basename));for(let C=0,a=b.length;C<a;C++){const M=b[C],{relativePath:o,basename:n}=M;if(l.matchesExcludesSync(o,n,F!==n?p:void 0))continue;const u=d[o];if(u)S(u);else{if(o===F)continue;m.matchFile(s,M)}if(m.isLimitHit)break}}S(i)}matchFile(i,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||i(d))}}class R{constructor(){this.sessions=new Map}fileSearch(i,d,l,s){const m=this.getSessionTokenSource(i.cacheKey),F=new T(i,d,m&&m.token);let S=0;const b=p=>{S+=p.length,l(p.map(C=>this.rawMatchToSearchItem(C)))};return this.doSearch(F,R.BATCH_SIZE,b,s).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:S,detailStats:p.stats}}))}clearCache(i){const d=this.getSessionTokenSource(i);d&&d.cancel()}getSessionTokenSource(i){if(!!i)return this.sessions.has(i)||this.sessions.set(i,new t.CancellationTokenSource),this.sessions.get(i)}rawMatchToSearchItem(i){return i.relativePath?{resource:I.joinPath(i.base,i.relativePath)}:{resource:i.base}}doSearch(i,d,l,s){s.onCancellationRequested(()=>{i.cancel()});const m=S=>{S&&(F.push(S),d>0&&F.length>=d&&(l(F),F=[]))};let F=[];return i.search(m).then(S=>(F.length&&l(F),S),S=>(F.length&&l(F),Promise.reject(S)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(ye[216],_e([0,1,16,20,43,29,11,17,24,10,2,41]),function(ee,e,r,t,_,A,I,P,D,T,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class i{constructor(b,p,C,a){this.query=b,this.provider=p,this.fileUtils=C,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(b,p){const C=this.query.folderQueries||[],a=new t.CancellationTokenSource;return p.onCancellationRequested(()=>a.cancel()),new Promise((M,o)=>{this.collector=new l(b);let n=!1;const u=(f,c)=>{if(!n&&!this.isLimitHit){const h=this.resultSize(f);m(f)&&typeof this.query.maxResults=="number"&&this.resultCount+h>this.query.maxResults&&(this.isLimitHit=!0,n=!0,a.cancel(),f=this.trimResultToSize(f,this.query.maxResults-this.resultCount));const g=this.resultSize(f);this.resultCount+=g,(g>0||!m(f))&&this.collector.add(f,c)}};Promise.all(C.map((f,c)=>this.searchInFolder(f,h=>u(h,c),a.token))).then(f=>{a.dispose(),this.collector.flush();const c=f.some(h=>!!h&&!!h.limitHit);M({limitHit:this.isLimitHit||c,messages:(0,r.flatten)(f.map(h=>h?.message?(0,T.isArray)(h.message)?h.message:[h.message]:[])),stats:{type:this.processType}})},f=>{a.dispose();const c=(0,_.toErrorMessage)(f);o(new Error(c))})})}resultSize(b){return m(b)?Array.isArray(b.ranges)?b.ranges.length:1:0}trimResultToSize(b,p){const C=Array.isArray(b.ranges)?b.ranges:[b.ranges],a=Array.isArray(b.preview.matches)?b.preview.matches:[b.preview.matches];return{ranges:C.slice(0,p),preview:{matches:a.slice(0,p),text:b.preview.text},uri:b.uri}}async searchInFolder(b,p,C){const a=new w.QueryGlobTester(this.query,b),M=[],o={report:f=>{if(!this.validateProviderResult(f))return;const c=b.folder.scheme===I.Schemas.file?A.hasSiblingPromiseFn(()=>this.fileUtils.readdir(D.dirname(f.uri))):void 0,h=D.relativePath(b.folder,f.uri);if(h){const g=a.includedInQuery(h,P.basename(h),c);(0,T.isPromise)(g)?M.push(g.then(E=>{E&&p(f)})):g&&p(f)}}},n=this.getSearchOptionsForFolder(b),u=await this.provider.provideTextSearchResults(d(this.query.contentPattern),n,o,C);return M.length&&await Promise.all(M),u}validateProviderResult(b){if(m(b)){if(Array.isArray(b.ranges)){if(!Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(b.preview.matches.length!==b.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(b.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(b){const p=(0,w.resolvePatternsForProvider)(this.query.includePattern,b.includePattern),C=(0,w.resolvePatternsForProvider)(this.query.excludePattern,b.excludePattern),a={folder:R.URI.from(b.folder),excludes:C,includes:p,useIgnoreFiles:!b.disregardIgnoreFiles,useGlobalIgnoreFiles:!b.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!b.disregardParentIgnoreFiles,followSymlinks:!b.ignoreSymlinks,encoding:b.fileEncoding&&this.fileUtils.toCanonicalName(b.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=i;function d(S){return{isCaseSensitive:S.isCaseSensitive||!1,isRegExp:S.isRegExp||!1,isWordMatch:S.isWordMatch||!1,isMultiline:S.isMultiline||!1,pattern:S.pattern}}class l{constructor(b){this._onResult=b,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new F(512,p=>this.sendItems(p))}add(b,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,b.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:b.uri,results:[]}),this._currentFileMatch.results.push(s(b))}pushToCollector(){const b=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,b)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(b){this._onResult(b)}}e.TextSearchResultsCollector=l;function s(S){return m(S)?{preview:{matches:(0,r.mapArrayOrNot)(S.preview.matches,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character})),text:S.preview.text},ranges:(0,r.mapArrayOrNot)(S.ranges,b=>({startLineNumber:b.start.line,startColumn:b.start.character,endLineNumber:b.end.line,endColumn:b.end.character}))}:{text:S.text,lineNumber:S.lineNumber}}function m(S){return!!S.preview}e.extensionResultIsMatch=m;class F{constructor(b,p){this.maxBatchSize=b,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(b,p){!b||this.addItemToBatch(b,p)}addItems(b,p){!b||this.addItemsToBatch(b,p)}addItemToBatch(b,p){this.batch.push(b),this.batchSize+=p,this.onUpdate()}addItemsToBatch(b,p){this.batch=this.batch.concat(b),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<F.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},F.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=F,F.TIMEOUT=4e3,F.START_BATCH_AFTER_COUNT=50}),define(ye[98],_e([0,1,6,5,3,215,14,64,12,2,216]),function(ee,e,r,t,_,A,I,P,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,_.createDecorator)("IExtHostSearch");let w=class{constructor(s,m,F){this.extHostRpc=s,this._uriTransformer=m,this._logService=F,this._proxy=this.extHostRpc.getProxy(t.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(s){return this._uriTransformer.transformOutgoingScheme(s)}registerTextSearchProvider(s,m){if(this._textSearchUsedSchemes.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this._textSearchUsedSchemes.add(s);const F=this._handlePool++;return this._textSearchProvider.set(F,m),this._proxy.$registerTextSearchProvider(F,this._transformScheme(s)),(0,r.toDisposable)(()=>{this._textSearchUsedSchemes.delete(s),this._textSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}registerFileSearchProvider(s,m){if(this._fileSearchUsedSchemes.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this._fileSearchUsedSchemes.add(s);const F=this._handlePool++;return this._fileSearchProvider.set(F,m),this._proxy.$registerFileSearchProvider(F,this._transformScheme(s)),(0,r.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(s),this._fileSearchProvider.delete(F),this._proxy.$unregisterProvider(F)})}$provideFileSearchResults(s,m,F,S){const b=i(F),p=this._fileSearchProvider.get(s);if(p)return this._fileSearchManager.fileSearch(b,p,C=>{this._proxy.$handleFileMatch(s,m,C.map(a=>a.resource))},S);throw new Error("unknown provider: "+s)}$clearCache(s){return this._fileSearchManager.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,m,F,S){const b=this._textSearchProvider.get(s);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${s}`);const p=i(F);return this.createTextSearchManager(p,b).search(a=>this._proxy.$handleTextMatch(s,m,a),S)}$enableExtensionHostSearch(){}createTextSearchManager(s,m){return new R.TextSearchManager(s,m,{readdir:F=>Promise.resolve([]),toCanonicalName:F=>F},"textSearchProvider")}};w=Be([$e(0,I.IExtHostRpcService),$e(1,P.IURITransformerService),$e(2,D.ILogService)],w),e.ExtHostSearch=w;function i(l){return{...l,folderQueries:l.folderQueries&&l.folderQueries.map(d),extraFileResources:l.extraFileResources&&l.extraFileResources.map(s=>T.URI.revive(s))}}e.reviveQuery=i;function d(l){return{...l,folder:T.URI.revive(l.folder)}}}),define(ye[217],_e([0,1,44,93,31,91,32,39,49,40,96,97,98,70,63,68,94,50,30,67,83,69,190,12,172]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b,p,C,a,M,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(M.ILoggerService,a.ExtHostLoggerService),(0,r.registerSingleton)(M.ILogService,o.ExtHostLogService),(0,r.registerSingleton)(s.IExtHostApiDeprecationService,s.ExtHostApiDeprecationService),(0,r.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands),(0,r.registerSingleton)(I.IExtHostConfiguration,I.ExtHostConfiguration),(0,r.registerSingleton)(F.IExtHostConsumerFileSystem,F.ExtHostConsumerFileSystem),(0,r.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService),(0,r.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,r.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,r.registerSingleton)(S.IExtHostFileSystemInfo,S.ExtHostFileSystemInfo),(0,r.registerSingleton)(t.IExtHostOutputService,t.ExtHostOutputService),(0,r.registerSingleton)(i.IExtHostSearch,i.ExtHostSearch),(0,r.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,r.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,r.registerSingleton)(T.IExtHostTerminalService,T.WorkerExtHostTerminalService),(0,r.registerSingleton)(l.IExtHostTunnelService,l.ExtHostTunnelService),(0,r.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,r.registerSingleton)(_.IExtHostWorkspace,_.ExtHostWorkspace),(0,r.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState),(0,r.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,r.registerSingleton)(C.IExtHostEditorTabs,C.ExtHostEditorTabs)}),define(ye[218],_e([0,1,44,3]),function(ee,e,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeViewsDragAndDropService=e.ITreeViewsDragAndDropService=void 0,e.ITreeViewsDragAndDropService=(0,t.createDecorator)("treeViewsDragAndDropService");class _{constructor(){this._dragOperations=new Map}removeDragOperationTransfer(I){if(I&&this._dragOperations.has(I)){const P=this._dragOperations.get(I);return this._dragOperations.delete(I),P}}addDragOperationTransfer(I,P){this._dragOperations.set(I,P)}}e.TreeViewsDragAndDropService=_,(0,r.registerSingleton)(e.ITreeViewsDragAndDropService,_)}),define(ye[219],_e([0,1,123,24,2,4,6,13,7,10,16,8,20,152,218]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function s(S,b){if((0,T.isString)(S))return{label:S};if(S&&typeof S=="object"&&typeof S.label=="string"){let p;return Array.isArray(S.highlights)&&(p=S.highlights.filter(C=>C.length===2&&typeof C[0]=="number"&&typeof C[1]=="number"),p=p.length?p:void 0),{label:S.label,highlights:p}}}class m{constructor(b,p,C){this._proxy=b,this.commands=p,this.logService=C,this.treeViews=new Map,this.treeDragAndDropService=new l.TreeViewsDragAndDropService;function a(M){return M&&M.$treeViewId&&M.$treeItemHandle}p.registerArgumentProcessor({processArgument:M=>a(M)?this.convertArgument(M):Array.isArray(M)&&M.length>0?M.map(o=>a(o)?this.convertArgument(o):o):M})}registerTreeDataProvider(b,p,C){const a=this.createTreeView(b,{treeDataProvider:p},C);return{dispose:()=>a.dispose()}}createTreeView(b,p,C){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=p.dragAndDropController?.supportedMimeTypes,M=!!p.dragAndDropController?.handleDrag,o=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,dragAndDropMimeTypes:a,hasHandleDrag:M}),n=this.createExtHostTreeView(b,p,C);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(u){n.message=u},get title(){return n.title},set title(u){n.title=u},get description(){return n.description},set description(u){n.description=u},reveal:(u,f)=>n.reveal(u,f),dispose:async()=>{await o,this.treeViews.delete(b),n.dispose()}}}$getChildren(b,p){const C=this.treeViews.get(b);return C?C.getChildren(p):Promise.reject(new Error((0,r.localize)(0,null,b)))}async $handleDrop(b,p,C,a,M,o){const n=this.treeViews.get(b);if(!n)return Promise.reject(new Error((0,r.localize)(1,null,b)));const u=d.TreeDataTransferConverter.toITreeDataTransfer(p);return M===b&&o&&await this.addAdditionalTransferItems(u,n,o,a),n.onDrop(u,C)}async addAdditionalTransferItems(b,p,C,a){const M=this.treeDragAndDropService.removeDragOperationTransfer(a);let o;if(M)o=await M;else if(a&&p.handleDrag){const n=p.handleDrag(C);this.treeDragAndDropService.addDragOperationTransfer(a,n),o=await n}return o&&o.forEach((n,u)=>{n&&b.set(u,n)}),b}async $handleDrag(b,p,C){const a=this.treeViews.get(b);if(!a)return Promise.reject(new Error((0,r.localize)(2,null,b)));const M=await this.addAdditionalTransferItems(new Map,a,p,C);if(!!M)return d.TreeDataTransferConverter.toTreeDataTransferDTO(M)}async $hasResolve(b){const p=this.treeViews.get(b);if(!p)throw new Error((0,r.localize)(3,null,b));return p.hasResolve}$resolve(b,p,C){const a=this.treeViews.get(b);if(!a)throw new Error((0,r.localize)(4,null,b));return a.resolveTreeItem(p,C)}$setExpanded(b,p,C){const a=this.treeViews.get(b);if(!a)throw new Error((0,r.localize)(5,null,b));a.setExpanded(p,C)}$setSelection(b,p){const C=this.treeViews.get(b);if(!C)throw new Error((0,r.localize)(6,null,b));C.setSelection(p)}$setVisible(b,p){const C=this.treeViews.get(b);if(!C)throw new Error((0,r.localize)(7,null,b));C.setVisible(p)}createExtHostTreeView(b,p,C){const a=new F(b,p,this._proxy,this.commands.converter,this.logService,C);return this.treeViews.set(b,a),a}convertArgument(b){const p=this.treeViews.get(b.$treeViewId);return p?p.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=m;class F extends I.Disposable{constructor(b,p,C,a,M,o){super();if(this.viewId=b,this.proxy=C,this.commands=a,this.logService=M,this.extension=o,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new i.CancellationTokenSource,o.contributes&&o.contributes.views)for(const f in o.contributes.views)for(const c of o.contributes.views[f])c.id===b&&(this._title=c.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(f=>this._onDidChangeData.fire({message:!1,element:f}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(f=>this._onDidChangeData.fire({message:!1,element:f})));let n,u;this._register(A.Event.debounce(this._onDidChangeData.event,(f,c)=>(f||(f={message:!1,elements:[]}),c.element!==!1&&(n||(n=new Promise(h=>u=h),this.refreshPromise=this.refreshPromise.then(()=>n)),Array.isArray(c.element)?f.elements.push(...c.element):f.elements.push(c.element)),c.message&&(f.message=!0),f),200,!0)(({message:f,elements:c})=>{c.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=u;return n=null,this.refresh(c).then(()=>h())})),f&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!(0,T.isUndefinedOrNull)(b))}async getChildren(b){const p=b?this.getExtensionElement(b):void 0;if(b&&!p)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);let C=this.getChildrenNodes(b);return C||(C=await this.fetchChildrenNodes(p)),C?C.map(a=>a.item):void 0}getExtensionElement(b){return this.elements.get(b)}reveal(b,p){p=p||{select:!0,focus:!1};const C=(0,T.isUndefinedOrNull)(p.select)?!0:p.select,a=(0,T.isUndefinedOrNull)(p.focus)?!1:p.focus,M=(0,T.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(o=>this.resolveTreeNode(b,o[o.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:o.map(u=>u.item)},{select:C,focus:a,expand:M})),o=>this.logService.error(o)):this.proxy.$reveal(this.viewId,void 0,{select:C,focus:a,expand:M})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,p){const C=this.getExtensionElement(b);C&&(p?this._onDidExpandElement.fire(Object.freeze({element:C})):this._onDidCollapseElement.fire(Object.freeze({element:C})))}setSelection(b){(0,R.equals)(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(b){const p=[];for(const C of b){const a=this.getExtensionElement(C);a&&p.push(a)}if(!(!this.dndController?.handleDrag||p.length===0))return this.dndController.handleDrag(p)}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(b,p){const C=this.getExtensionElement(p);if(!!C)return(0,P.asPromise)(()=>this.dndController?.handleDrop(b,C))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,p){if(!this.dataProvider.resolveTreeItem)return;const C=this.elements.get(b);if(C){const a=this.nodes.get(C);if(a){const M=await this.dataProvider.resolveTreeItem(a.extensionItem,C,p)??a.extensionItem;return a.item.tooltip=this.getTooltip(M.tooltip),a.item.command=this.getCommand(a.disposableStore,M.command),a.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(p=>p?this.resolveUnknownParentChain(p).then(C=>this.resolveTreeNode(p,C[C.length-1]).then(a=>(C.push(a),C))):Promise.resolve([]))}resolveParent(b){const p=this.nodes.get(b);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,P.asPromise)(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,p){const C=this.nodes.get(b);return C?Promise.resolve(C):(0,P.asPromise)(()=>this.dataProvider.getTreeItem(b)).then(a=>this.createHandle(b,a,p,!0)).then(a=>this.getChildren(p?p.item.handle:void 0).then(()=>{const M=this.getExtensionElement(a);if(M){const o=this.nodes.get(M);if(o)return Promise.resolve(o)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(b){if(b){let p;if(typeof b=="string"){const C=this.getExtensionElement(b);p=C?this.nodes.get(C):void 0}else p=b;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const p=new i.CancellationTokenSource(this._refreshCancellationSource.token);try{const C=b?this.nodes.get(b):void 0,a=await this.dataProvider.getChildren(b);if(p.token.isCancellationRequested)return;const M=await Promise.all((0,R.coalesce)(a||[]).map(async o=>{const n=await this.dataProvider.getTreeItem(o);return n&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(o,n,C):null}));return p.token.isCancellationRequested?void 0:(0,R.coalesce)(M)}finally{p.dispose()}}refresh(b){if(b.some(C=>!C))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new i.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const C=this.getHandlesToRefresh(b);if(C.length)return this.refreshHandles(C)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const p=new Set,C=b.map(M=>this.nodes.get(M));for(const M of C)if(M&&!p.has(M.item.handle)){let o=M;for(;o&&o.parent&&C.findIndex(n=>o&&o.parent&&n&&n.item.handle===o.parent.item.handle)===-1;){const n=this.elements.get(o.parent.item.handle);o=n?this.nodes.get(n):void 0}o&&!o.parent&&p.add(M.item.handle)}const a=[];return p.forEach(M=>{const o=this.elements.get(M);if(o){const n=this.nodes.get(o);n&&(!n.parent||!p.has(n.parent.item.handle))&&a.push(M)}}),a}refreshHandles(b){const p={};return Promise.all(b.map(C=>this.refreshNode(C).then(a=>{a&&(p[C]=a.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(b){const p=this.getExtensionElement(b);if(p){const C=this.nodes.get(p);if(C)return this.clearChildren(p),(0,P.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(a=>{if(a){const M=this.createTreeNode(p,a,C.parent);return this.updateNodeCache(p,M,C,C.parent),C.dispose(),M}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,p,C){const a=this.createTreeNode(b,p,C);if(p.id&&this.elements.has(a.item.handle))throw new Error((0,r.localize)(8,null,p.id));return this.addNodeToCache(b,a),this.addNodeToParentCache(a,C),a}getTooltip(b){return D.MarkdownString.isMarkdownString(b)?w.MarkdownString.from(b):b}getCommand(b,p){return p?this.commands.toInternal(p,b):void 0}createTreeNode(b,p,C){const a=new I.DisposableStore,M=this.createHandle(b,p,C),o=this.getLightIconPath(p);return{item:{handle:M,parentHandle:C?C.item.handle:void 0,label:s(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(a,p.command),contextValue:p.contextValue,icon:o,iconDark:this.getDarkIconPath(p)||o,themeIcon:this.getThemeIcon(p),collapsibleState:(0,T.isUndefinedOrNull)(p.collapsibleState)?D.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:C,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(b){return b.iconPath instanceof D.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:p,label:C,resourceUri:a},M,o){if(p)return`${F.ID_HANDLE_PREFIX}/${p}`;const n=s(C,this.extension),u=M?M.item.handle:F.LABEL_HANDLE_PREFIX;let f=n?n.label:a?(0,t.basename)(a):"";f=f.indexOf("/")!==-1?f.replace("/","//"):f;const c=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,h=this.getChildrenNodes(M)||[];let g,E=0;do{if(g=`${u}/${E}:${f}`,o||!this.elements.has(g)||c===g)break;E++}while(E<=h.length);return g}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon))return typeof b.iconPath=="string"||_.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof D.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return _.URI.isUri(b)?b:_.URI.file(b)}addNodeToCache(b,p){this.elements.set(p.item.handle,b),this.nodes.set(b,p)}updateNodeCache(b,p,C,a){this.elements.delete(p.item.handle),this.nodes.delete(b),p.item.handle!==C.item.handle&&this.elements.delete(C.item.handle),this.addNodeToCache(b,p);const M=this.getChildrenNodes(a)||[],o=M.filter(n=>n.item.handle===C.item.handle)[0];o&&M.splice(M.indexOf(o),1,p)}addNodeToParentCache(b,p){p?(p.children||(p.children=[]),p.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const p=this.nodes.get(b);if(p){if(p.children)for(const C of p.children){const a=this.elements.get(C.item.handle);a&&this.clear(a)}p.children=void 0}}else this.clearAll()}clear(b){const p=this.nodes.get(b);if(p){if(p.children)for(const C of p.children){const a=this.elements.get(C.item.handle);a&&this.clear(a)}this.nodes.delete(b),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}F.LABEL_HANDLE_PREFIX="0",F.ID_HANDLE_PREFIX="1"}),define(ye[220],_e([0,1,20,15,4,34,2,112,233,106,56,46,5,177,176,39,178,32,179,180,181,164,182,49,33,183,184,187,189,191,93,166,196,197,198,70,40,200,219,8,7,203,51,94,31,73,153,186,60,91,96,97,98,12,64,14,28,192,150,63,68,174,201,149,71,50,206,204,205,175,30,199,202,67,69,83,194,95,195,11,138,193,147,185,6,26]),function(ee,e,r,t,_,A,I,P,D,T,R,w,i,d,l,s,m,F,S,b,p,C,a,M,o,n,u,f,c,h,g,E,v,k,x,N,y,L,W,B,$,q,ie,se,X,ge,be,pe,fe,oe,Ee,Pe,Oe,je,st,et,tt,H,K,z,j,Y,ae,Se,xe,Ve,Qe,nt,rt,Je,Ze,pt,Fe,At,G,Q,de,Ue,qe,lt,ht,Ye,kt,Ae,De,ve){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function te(ne){const ue=ne.get(tt.IExtHostInitDataService),me=ne.get(Ze.IExtHostFileSystemInfo),Te=ne.get(Ve.IExtHostConsumerFileSystem),He=ne.get(o.IExtHostExtensionService),Le=ne.get(X.IExtHostWorkspace),Ge=ne.get(Q.IExtHostTelemetry),ot=ne.get(F.IExtHostConfiguration),at=ne.get(st.IURITransformerService),Ne=ne.get(et.IExtHostRpcService),ce=ne.get(N.IExtHostStorage),he=ne.get(xe.IExtensionStoragePaths),re=ne.get(je.ILoggerService),V=ne.get(je.ILogService),we=ne.get(z.IExtHostTunnelService),Re=ne.get(j.IExtHostApiDeprecationService),We=ne.get(se.IExtHostWindow),ze=ne.get(At.IExtHostSecretState),mt=ne.get(G.IExtHostEditorTabs);Ne.set(i.ExtHostContext.ExtHostFileSystemInfo,me),Ne.set(i.ExtHostContext.ExtHostLogLevelServiceShape,re),Ne.set(i.ExtHostContext.ExtHostWorkspace,Le),Ne.set(i.ExtHostContext.ExtHostConfiguration,ot),Ne.set(i.ExtHostContext.ExtHostExtensionService,He),Ne.set(i.ExtHostContext.ExtHostStorage,ce),Ne.set(i.ExtHostContext.ExtHostTunnelService,we),Ne.set(i.ExtHostContext.ExtHostWindow,We),Ne.set(i.ExtHostContext.ExtHostSecretState,ze),Ne.set(i.ExtHostContext.ExtHostTelemetry,Ge),Ne.set(i.ExtHostContext.ExtHostEditorTabs,mt);const Et=Ne.set(i.ExtHostContext.ExtHostDecorations,ne.get(oe.IExtHostDecorations)),_t=Ne.set(i.ExtHostContext.ExtHostDocumentsAndEditors,ne.get(M.IExtHostDocumentsAndEditors)),dt=Ne.set(i.ExtHostContext.ExtHostCommands,ne.get(s.IExtHostCommands)),vt=Ne.set(i.ExtHostContext.ExtHostTerminalService,ne.get(y.IExtHostTerminalService)),bt=Ne.set(i.ExtHostContext.ExtHostDebugService,ne.get(Pe.IExtHostDebugService)),xt=Ne.set(i.ExtHostContext.ExtHostSearch,ne.get(Oe.IExtHostSearch)),It=Ne.set(i.ExtHostContext.ExtHostTask,ne.get(Ee.IExtHostTask)),Mt=Ne.set(i.ExtHostContext.ExtHostOutputService,ne.get(g.IExtHostOutputService)),Dt=Ne.set(i.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Ne)),St=Ne.set(i.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ne,_t)),Qt=Ne.set(i.ExtHostContext.ExtHostDocumentContentProviders,new p.ExtHostDocumentContentProvider(Ne,_t,V)),Vt=Ne.set(i.ExtHostContext.ExtHostDocumentSaveParticipant,new C.ExtHostDocumentSaveParticipant(V,St,Ne.getProxy(i.MainContext.MainThreadBulkEdits))),wt=Ne.set(i.ExtHostContext.ExtHostNotebook,new H.ExtHostNotebookController(Ne,dt,_t,St,he)),Yt=Ne.set(i.ExtHostContext.ExtHostNotebookDocuments,new kt.ExtHostNotebookDocuments(V,wt)),qt=Ne.set(i.ExtHostContext.ExtHostNotebookEditors,new Ye.ExtHostNotebookEditors(V,Ne,wt)),Xt=Ne.set(i.ExtHostContext.ExtHostNotebookKernels,new de.ExtHostNotebookKernels(Ne,ue,wt,dt,V)),ai=Ne.set(i.ExtHostContext.ExtHostNotebookRenderers,new qe.ExtHostNotebookRenderers(Ne,wt)),Rt=Ne.set(i.ExtHostContext.ExtHostEditors,new L.ExtHostEditors(Ne,_t)),Jt=Ne.set(i.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(Ne.getProxy(i.MainContext.MainThreadTreeViews),dt,V)),li=Ne.set(i.ExtHostContext.ExtHostEditorInsets,new be.ExtHostEditorInsets(Ne.getProxy(i.MainContext.MainThreadEditorInsets),Rt,ue)),jt=Ne.set(i.ExtHostContext.ExtHostDiagnostics,new S.ExtHostDiagnostics(Ne,V,me)),Zt=Ne.set(i.ExtHostContext.ExtHostLanguages,new c.ExtHostLanguages(Ne,St,dt.converter,at)),gt=Ne.set(i.ExtHostContext.ExtHostLanguageFeatures,new f.ExtHostLanguageFeatures(Ne,at,St,dt,jt,V,Re)),ci=Ne.set(i.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Ne,gt)),Lt=Ne.set(i.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Ne,V,_t)),$t=Ne.set(i.ExtHostContext.ExtHostQuickOpen,(0,v.createExtHostQuickOpen)(Ne,Le,dt)),vi=Ne.set(i.ExtHostContext.ExtHostSCM,new k.ExtHostSCM(Ne,dt,V)),ui=Ne.set(i.ExtHostContext.ExtHostComments,(0,m.createExtHostComments)(Ne,dt,St)),ei=Ne.set(i.ExtHostContext.ExtHostProgress,new E.ExtHostProgress(Ne.getProxy(i.MainContext.MainThreadProgress))),Ci=Ne.set(i.ExtHostContext.ExtHosLabelService,new pe.ExtHostLabelService(Ne)),bi=Ne.set(i.ExtHostContext.ExtHostTheming,new K.ExtHostTheming(Ne)),ti=Ne.set(i.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Ne)),Di=Ne.set(i.ExtHostContext.ExtHostTimeline,new ae.ExtHostTimeline(Ne,dt)),di=Ne.set(i.ExtHostContext.ExtHostWebviews,new ie.ExtHostWebviews(Ne,{remote:ue.remote},Le,V,Re)),Gt=Ne.set(i.ExtHostContext.ExtHostWebviewPanels,new rt.ExtHostWebviewPanels(Ne,di,Le)),hi=Ne.set(i.ExtHostContext.ExtHostCustomEditors,new nt.ExtHostCustomEditors(Ne,St,he,di,Gt)),ki=Ne.set(i.ExtHostContext.ExtHostWebviewViews,new Qe.ExtHostWebviewViews(Ne,di)),Kt=Ne.set(i.ExtHostContext.ExtHostTesting,new pt.ExtHostTesting(Ne,dt)),Ii=Ne.set(i.ExtHostContext.ExtHostUriOpeners,new Fe.ExtHostUriOpeners(Ne));Ne.set(i.ExtHostContext.ExtHostInteractive,new Ae.ExtHostInteractive(Ne,wt,_t,dt));const Pi=(0,ge.values)(i.ExtHostContext);Ne.assertRegistered(Pi);const ii=new Je.ExtHostBulkEdits(Ne,_t),Ti=new l.ExtHostClipboard(Ne),fi=new h.ExtHostMessageService(Ne,V),wi=new b.ExtHostDialogs(Ne),ni=new x.ExtHostStatusBar(Ne,dt.converter);return d.ExtHostApiCommands.register(dt),function(Me,Ht,Ut){const yt=function(){let J=!Me.isUnderDevelopment;function le(){J||(V.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function ke(ut){if(Array.isArray(ut))ut.forEach(ke);else if(typeof ut=="string")le();else{const Ct=ut;typeof Ct.scheme=="undefined"&&le(),typeof Ct.exclusive=="boolean"&&(0,ve.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ut}}(),Ot={getSession(J,le,ke){return ti.getSession(Me,J,le,ke)},async hasSession(J,le){return(0,ve.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,J,le,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(J,le,ke,ut){return ti.registerAuthenticationProvider(J,le,ke,ut)}},ri={registerCommand(J,le,ke){return dt.registerCommand(!0,J,le,ke,void 0,Me)},registerTextEditorCommand(J,le,ke){return dt.registerCommand(!0,J,(...ut)=>{const Ct=Rt.getActiveTextEditor();if(!Ct){V.warn("Cannot execute "+J+" because there is no active text editor.");return}return Ct.edit(Tt=>{le.apply(ke,[Ct,Tt,...ut])}).then(Tt=>{Tt||V.warn("Edits from command "+J+" were not applied.")},Tt=>{V.warn("An error occurred while running command "+J,Tt)})},void 0,void 0,Me)},registerDiffInformationCommand:(J,le,ke)=>((0,ve.checkProposedApiEnabled)(Me,"diffCommand"),dt.registerCommand(!0,J,async(...ut)=>{const Ct=_t.activeEditor(!0);if(!Ct){V.warn("Cannot execute "+J+" because there is no active text editor.");return}const Tt=await Rt.getDiffInformation(Ct.id);le.apply(ke,[Tt,...ut])},void 0,void 0,Me)),executeCommand(J,...le){return dt.executeCommand(J,...le)},getCommands(J=!1){return dt.getCommands(J)}},Ei={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get appHost(){return ue.environment.appHost},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return vt.getDefaultShell(!1)},get isTelemetryEnabled(){return Ge.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Ge.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,le){return We.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:le?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return Dt.createAppUri(J);try{return await We.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(le){if((0,ht.matchesScheme)(J,lt.Schemas.http)||(0,ht.matchesScheme)(J,lt.Schemas.https))return J;throw le}},get remoteName(){return(0,fe.getRemoteName)(ue.remote.authority)},get remoteAuthority(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),ue.remote.authority},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(Ei);const yi=ue.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,Ai={createTestController(J,le,ke){return ke&&(0,ve.checkProposedApiEnabled)(Me,"testRefresh"),Kt.createTestController(J,le,ke)},createTestObserver(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.createTestObserver()},runTests(J){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.runTests(J)},get onDidChangeTestResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.onResultsChanged},get testResults(){return(0,ve.checkProposedApiEnabled)(Me,"testObserver"),Kt.results}},Ri={getExtension(J){const le=Ht.getExtensionDescription(J);if(le)return new o.Extension(He,Me.identifier,le,yi)},get all(){return Ht.getAllExtensionDescriptions().map(J=>new o.Extension(He,Me.identifier,J,yi))},get onDidChange(){return Ht.onDidChange}},Fi={createDiagnosticCollection(J){return jt.createDiagnosticCollection(Me.identifier,J)},get onDidChangeDiagnostics(){return jt.onDidChangeDiagnostics},getDiagnostics:J=>jt.getDiagnostics(J),getLanguages(){return Zt.getLanguages()},setTextDocumentLanguage(J,le){return Zt.changeLanguage(J.uri,le)},match(J,le){return(0,R.score)(B.LanguageSelector.from(J),le.uri,le.languageId,!0)},registerCodeActionsProvider(J,le,ke){return gt.registerCodeActionProvider(Me,yt(J),le,ke)},registerCodeLensProvider(J,le){return gt.registerCodeLensProvider(Me,yt(J),le)},registerDefinitionProvider(J,le){return gt.registerDefinitionProvider(Me,yt(J),le)},registerDeclarationProvider(J,le){return gt.registerDeclarationProvider(Me,yt(J),le)},registerImplementationProvider(J,le){return gt.registerImplementationProvider(Me,yt(J),le)},registerTypeDefinitionProvider(J,le){return gt.registerTypeDefinitionProvider(Me,yt(J),le)},registerHoverProvider(J,le){return gt.registerHoverProvider(Me,yt(J),le,Me.identifier)},registerEvaluatableExpressionProvider(J,le){return gt.registerEvaluatableExpressionProvider(Me,yt(J),le,Me.identifier)},registerInlineValuesProvider(J,le){return gt.registerInlineValuesProvider(Me,yt(J),le,Me.identifier)},registerDocumentHighlightProvider(J,le){return gt.registerDocumentHighlightProvider(Me,yt(J),le)},registerLinkedEditingRangeProvider(J,le){return gt.registerLinkedEditingRangeProvider(Me,yt(J),le)},registerReferenceProvider(J,le){return gt.registerReferenceProvider(Me,yt(J),le)},registerRenameProvider(J,le){return gt.registerRenameProvider(Me,yt(J),le)},registerDocumentSymbolProvider(J,le,ke){return gt.registerDocumentSymbolProvider(Me,yt(J),le,ke)},registerWorkspaceSymbolProvider(J){return gt.registerWorkspaceSymbolProvider(Me,J)},registerDocumentFormattingEditProvider(J,le){return gt.registerDocumentFormattingEditProvider(Me,yt(J),le)},registerDocumentRangeFormattingEditProvider(J,le){return gt.registerDocumentRangeFormattingEditProvider(Me,yt(J),le)},registerOnTypeFormattingEditProvider(J,le,ke,...ut){return gt.registerOnTypeFormattingEditProvider(Me,yt(J),le,[ke].concat(ut))},registerDocumentSemanticTokensProvider(J,le,ke){return gt.registerDocumentSemanticTokensProvider(Me,yt(J),le,ke)},registerDocumentRangeSemanticTokensProvider(J,le,ke){return gt.registerDocumentRangeSemanticTokensProvider(Me,yt(J),le,ke)},registerSignatureHelpProvider(J,le,ke,...ut){return typeof ke=="object"?gt.registerSignatureHelpProvider(Me,yt(J),le,ke):gt.registerSignatureHelpProvider(Me,yt(J),le,typeof ke=="undefined"?[]:[ke,...ut])},registerCompletionItemProvider(J,le,...ke){return gt.registerCompletionItemProvider(Me,yt(J),le,ke)},registerInlineCompletionItemProvider(J,le){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),gt.registerInlineCompletionsProvider(Me,yt(J),le)},registerDocumentLinkProvider(J,le){return gt.registerDocumentLinkProvider(Me,yt(J),le)},registerColorProvider(J,le){return gt.registerColorProvider(Me,yt(J),le)},registerFoldingRangeProvider(J,le){return gt.registerFoldingRangeProvider(Me,yt(J),le)},registerSelectionRangeProvider(J,le){return gt.registerSelectionRangeProvider(Me,J,le)},registerCallHierarchyProvider(J,le){return gt.registerCallHierarchyProvider(Me,J,le)},registerTypeHierarchyProvider(J,le){return gt.registerTypeHierarchyProvider(Me,J,le)},setLanguageConfiguration:(J,le)=>gt.setLanguageConfiguration(Me,J,le),getTokenInformationAtPosition(J,le){return(0,ve.checkProposedApiEnabled)(Me,"tokenInformation"),Zt.tokenAtPosition(J,le)},registerInlayHintsProvider(J,le){return(0,ve.checkProposedApiEnabled)(Me,"inlayHints"),gt.registerInlayHintsProvider(Me,J,le)},createLanguageStatusItem(J,le){return(0,ve.checkProposedApiEnabled)(Me,"languageStatus"),Zt.createLanguageStatusItem(Me,J,le)}},Mi={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return vt.activeTerminal},get terminals(){return vt.terminals},async showTextDocument(J,le,ke){const ut=await(I.URI.isUri(J)?Promise.resolve(_i.openTextDocument(J)):Promise.resolve(J));return Rt.showTextDocument(ut,le,ke)},createTextEditorDecorationType(J){return Rt.createTextEditorDecorationType(Me,J)},onDidChangeActiveTextEditor(J,le,ke){return Rt.onDidChangeActiveTextEditor(J,le,ke)},onDidChangeVisibleTextEditors(J,le,ke){return Rt.onDidChangeVisibleTextEditors(J,le,ke)},onDidChangeTextEditorSelection(J,le,ke){return Rt.onDidChangeTextEditorSelection(J,le,ke)},onDidChangeTextEditorOptions(J,le,ke){return Rt.onDidChangeTextEditorOptions(J,le,ke)},onDidChangeTextEditorVisibleRanges(J,le,ke){return Rt.onDidChangeTextEditorVisibleRanges(J,le,ke)},onDidChangeTextEditorViewColumn(J,le,ke){return Rt.onDidChangeTextEditorViewColumn(J,le,ke)},onDidCloseTerminal(J,le,ke){return vt.onDidCloseTerminal(J,le,ke)},onDidOpenTerminal(J,le,ke){return vt.onDidOpenTerminal(J,le,ke)},onDidChangeActiveTerminal(J,le,ke){return vt.onDidChangeActiveTerminal(J,le,ke)},onDidChangeTerminalDimensions(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDimensions"),vt.onDidChangeTerminalDimensions(J,le,ke)},onDidChangeTerminalState(J,le,ke){return vt.onDidChangeTerminalState(J,le,ke)},onDidWriteTerminalData(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),vt.onDidWriteTerminalData(J,le,ke)},get state(){return We.state},onDidChangeWindowState(J,le,ke){return We.onDidChangeWindowState(J,le,ke)},showInformationMessage(J,...le){return fi.showMessage(Me,A.default.Info,J,le[0],le.slice(1))},showWarningMessage(J,...le){return fi.showMessage(Me,A.default.Warning,J,le[0],le.slice(1))},showErrorMessage(J,...le){return fi.showMessage(Me,A.default.Error,J,le[0],le.slice(1))},showQuickPick(J,le,ke){return Array.isArray(J)&&J.some(ut=>ut.kind===$.QuickPickItemKind.Separator)&&(0,ve.checkProposedApiEnabled)(Me,"quickPickSeparators"),$t.showQuickPick(J,le,ke)},showWorkspaceFolderPick(J){return $t.showWorkspaceFolderPick(J)},showInputBox(J,le){return $t.showInput(J,le)},showOpenDialog(J){return wi.showOpenDialog(J)},showSaveDialog(J){return wi.showSaveDialog(J)},createStatusBarItem(J,le,ke){let ut,Ct,Tt;return typeof J=="string"?(ut=J,Ct=le,Tt=ke):(Ct=J,Tt=le),ni.createStatusBarEntry(Me,ut,Ct,Tt)},setStatusBarMessage(J,le){return ni.setStatusBarMessage(J,le)},withScmProgress(J){return Re.report("window.withScmProgress",Me,"Use 'withProgress' instead."),ei.withProgress(Me,{location:$.ProgressLocation.SourceControl},(le,ke)=>J({report(ut){}}))},withProgress(J,le){return ei.withProgress(Me,J,le)},createOutputChannel(J){return Mt.createOutputChannel(J,Me)},createWebviewPanel(J,le,ke,ut){return Gt.createWebviewPanel(Me,J,le,ke,ut)},createWebviewTextEditorInset(J,le,ke,ut){return(0,ve.checkProposedApiEnabled)(Me,"editorInsets"),li.createWebviewEditorInset(J,le,ke,ut,Me)},createTerminal(J,le,ke){return typeof J=="object"?"pty"in J?vt.createExtensionTerminal(J):vt.createTerminalFromOptions(J):vt.createTerminal(J,le,ke)},registerTerminalLinkProvider(J){return vt.registerLinkProvider(J)},registerTerminalProfileProvider(J,le){return vt.registerProfileProvider(Me,J,le)},registerTreeDataProvider(J,le){return Jt.registerTreeDataProvider(J,le,Me)},createTreeView(J,le){return Jt.createTreeView(J,le,Me)},registerWebviewPanelSerializer:(J,le)=>Gt.registerWebviewPanelSerializer(Me,J,le),registerCustomEditorProvider:(J,le,ke={})=>hi.registerCustomEditorProvider(Me,J,le,ke),registerFileDecorationProvider(J){return Et.registerFileDecorationProvider(J,Me.identifier)},registerUriHandler(J){return Dt.registerUriHandler(Me.identifier,J)},createQuickPick(){return $t.createQuickPick(Me)},createInputBox(){return $t.createInputBox(Me.identifier)},get activeColorTheme(){return bi.activeColorTheme},onDidChangeActiveColorTheme(J,le,ke){return bi.onDidChangeActiveColorTheme(J,le,ke)},registerWebviewViewProvider(J,le,ke){return ki.registerWebviewViewProvider(Me,J,le,ke?.webviewOptions)},get activeNotebookEditor(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeActiveNotebookEditor(J,le,ke)},get visibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),qt.onDidChangeNotebookEditorSelection(J,le,ke)},onDidChangeNotebookEditorVisibleRanges(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),qt.onDidChangeNotebookEditorVisibleRanges(J,le,ke)},showNotebookDocument(J,le){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.showNotebookDocument(J,le)},registerExternalUriOpener(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"externalUriOpener"),Ii.registerExternalUriOpener(Me.identifier,J,le,ke)},get tabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.tabs},get activeTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.activeTab},get onDidChangeTabs(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.onDidChangeTabs},get onDidChangeActiveTab(){return(0,ve.checkProposedApiEnabled)(Me,"tabs"),mt.onDidChangeActiveTab},getInlineCompletionItemController(J){return(0,ve.checkProposedApiEnabled)(Me,"inlineCompletions"),f.InlineCompletionController.get(J)}},_i={get rootPath(){return Re.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Le.getPath()},set rootPath(J){throw t.readonly()},getWorkspaceFolder(J){return Le.getWorkspaceFolder(J)},get workspaceFolders(){return Le.getWorkspaceFolders()},get name(){return Le.name},set name(J){throw t.readonly()},get workspaceFile(){return Le.workspaceFile},set workspaceFile(J){throw t.readonly()},updateWorkspaceFolders:(J,le,...ke)=>Le.updateWorkspaceFolders(Me,J,le||0,...ke),onDidChangeWorkspaceFolders:function(J,le,ke){return Le.onDidChangeWorkspace(J,le,ke)},asRelativePath:(J,le)=>Le.getRelativePath(J,le),findFiles:(J,le,ke,ut)=>Le.findFiles(J,le,ke,Me.identifier,ut),findTextInFiles:(J,le,ke,ut)=>{(0,ve.checkProposedApiEnabled)(Me,"findTextInFiles");let Ct,Tt;return typeof le=="object"?(Ct=le,Tt=ke):(Ct={},Tt=le,ut=ke),Le.findTextInFiles(J,Ct||{},Tt,Me.identifier,ut)},saveAll:J=>Le.saveAll(J),applyEdit(J){return ii.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,le,ke,ut)=>Lt.createFileSystemWatcher(Le,Me,J,le,ke,ut),get textDocuments(){return St.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw t.readonly()},openTextDocument(J){let le;const ke=J;if(typeof J=="string")le=Promise.resolve(I.URI.file(J));else if(I.URI.isUri(J))le=Promise.resolve(J);else if(!ke||typeof ke=="object")le=St.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return le.then(ut=>St.ensureDocumentData(ut).then(Ct=>Ct.document))},onDidOpenTextDocument:(J,le,ke)=>St.onDidAddDocument(J,le,ke),onDidCloseTextDocument:(J,le,ke)=>St.onDidRemoveDocument(J,le,ke),onDidChangeTextDocument:(J,le,ke)=>St.onDidChangeDocument(J,le,ke),onDidSaveTextDocument:(J,le,ke)=>St.onDidSaveDocument(J,le,ke),onWillSaveTextDocument:(J,le,ke)=>Vt.getOnWillSaveTextDocumentEvent(Me)(J,le,ke),get notebookDocuments(){return wt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,le){let ke;if(I.URI.isUri(J))ke=J,await wt.openNotebookDocument(J);else if(typeof J=="string")ke=I.URI.revive(await wt.createNotebookDocument({viewType:J,content:le}));else throw new Error("Invalid arguments");return wt.getNotebookDocument(ke).apiNotebook},get onDidOpenNotebookDocument(){return wt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return wt.onDidCloseNotebookDocument},registerNotebookSerializer(J,le,ke,ut){return wt.registerNotebookSerializer(Me,J,le,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ut:void 0)},registerNotebookContentProvider:(J,le,ke,ut)=>((0,ve.checkProposedApiEnabled)(Me,"notebookContentProvider"),wt.registerNotebookContentProvider(Me,J,le,ke,(0,ve.isProposedApiEnabled)(Me,"notebookLiveShare")?ut:void 0)),onDidChangeConfiguration:(J,le,ke)=>Ut.onDidChangeConfiguration(J,le,ke),getConfiguration(J,le){return le=arguments.length===1?void 0:le,Ut.getConfiguration(J,le,Me)},registerTextDocumentContentProvider(J,le){return Qt.registerTextDocumentContentProvider(J,le)},registerTaskProvider:(J,le)=>(Re.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),It.registerTaskProvider(Me,J,le)),registerFileSystemProvider(J,le,ke){return(0,De.combinedDisposable)(ci.registerFileSystemProvider(Me,J,le,ke),Te.addFileSystemProvider(J,le))},get fs(){return Te.value},registerFileSearchProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"fileSearchProvider"),xt.registerFileSearchProvider(J,le)),registerTextSearchProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"textSearchProvider"),xt.registerTextSearchProvider(J,le)),registerRemoteAuthorityResolver:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),He.registerRemoteAuthorityResolver(J,le)),registerResourceLabelFormatter:J=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),Ci.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,le,ke)=>Lt.onDidCreateFile(J,le,ke),onDidDeleteFiles:(J,le,ke)=>Lt.onDidDeleteFile(J,le,ke),onDidRenameFiles:(J,le,ke)=>Lt.onDidRenameFile(J,le,ke),onWillCreateFiles:(J,le,ke)=>Lt.getOnWillCreateFileEvent(Me)(J,le,ke),onWillDeleteFiles:(J,le,ke)=>Lt.getOnWillDeleteFileEvent(Me)(J,le,ke),onWillRenameFiles:(J,le,ke)=>Lt.getOnWillRenameFileEvent(Me)(J,le,ke),openTunnel:J=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.openTunnel(Me,J).then(le=>{if(!le)throw new Error("cannot open tunnel");return le})),get tunnels(){return(0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.getTunnels()},onDidChangeTunnels:(J,le,ke)=>((0,ve.checkProposedApiEnabled)(Me,"resolvers"),we.onDidChangeTunnels(J,le,ke)),registerPortAttributesProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"portsAttributes"),we.registerPortsAttributesProvider(J,le)),registerTimelineProvider:(J,le)=>((0,ve.checkProposedApiEnabled)(Me,"timeline"),Di.registerTimelineProvider(J,le,Me.identifier,dt.converter)),get isTrusted(){return Le.trusted},requestWorkspaceTrust:J=>((0,ve.checkProposedApiEnabled)(Me,"workspaceTrust"),Le.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,le,ke)=>Le.onDidGrantWorkspaceTrust(J,le,ke)},mi={get inputBox(){return Re.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Me)},createSourceControl(J,le,ke){return vi.createSourceControl(Me,J,le,ke)}},Oi={createCommentController(J,le){return ui.createCommentController(Me,J,le)}},Li={get activeDebugSession(){return bt.activeDebugSession},get activeDebugConsole(){return bt.activeDebugConsole},get breakpoints(){return bt.breakpoints},onDidStartDebugSession(J,le,ke){return bt.onDidStartDebugSession(J,le,ke)},onDidTerminateDebugSession(J,le,ke){return bt.onDidTerminateDebugSession(J,le,ke)},onDidChangeActiveDebugSession(J,le,ke){return bt.onDidChangeActiveDebugSession(J,le,ke)},onDidReceiveDebugSessionCustomEvent(J,le,ke){return bt.onDidReceiveDebugSessionCustomEvent(J,le,ke)},onDidChangeBreakpoints(J,le,ke){return bt.onDidChangeBreakpoints(J,le,ke)},registerDebugConfigurationProvider(J,le,ke){return bt.registerDebugConfigurationProvider(J,le,ke||$.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,le){return bt.registerDebugAdapterDescriptorFactory(Me,J,le)},registerDebugAdapterTrackerFactory(J,le){return bt.registerDebugAdapterTrackerFactory(J,le)},startDebugging(J,le,ke){return!ke||typeof ke=="object"&&"configuration"in ke?bt.startDebugging(J,le,{parentSession:ke}):bt.startDebugging(J,le,ke||{})},stopDebugging(J){return bt.stopDebugging(J)},addBreakpoints(J){return bt.addBreakpoints(J)},removeBreakpoints(J){return bt.removeBreakpoints(J)},asDebugSourceUri(J,le){return bt.asDebugSourceUri(J,le)}},Ni={registerTaskProvider:(J,le)=>It.registerTaskProvider(Me,J,le),fetchTasks:J=>It.fetchTasks(J),executeTask:J=>It.executeTask(Me,J),get taskExecutions(){return It.taskExecutions},onDidStartTask:(J,le,ke)=>It.onDidStartTask(J,le,ke),onDidEndTask:(J,le,ke)=>It.onDidEndTask(J,le,ke),onDidStartTaskProcess:(J,le,ke)=>It.onDidStartTaskProcess(J,le,ke),onDidEndTaskProcess:(J,le,ke)=>It.onDidEndTaskProcess(J,le,ke)},xi={createNotebookController(J,le,ke,ut,Ct){return Xt.createNotebookController(Me,J,le,ke,ut,(0,ve.isProposedApiEnabled)(Me,"notebookMessaging")?Ct:void 0)},registerNotebookCellStatusBarItemProvider:(J,le)=>wt.registerNotebookCellStatusBarItemProvider(Me,J,le),get onDidSaveNotebookDocument(){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditorDecorationType"),qt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ai.createRendererMessaging(Me,J)},onDidChangeNotebookDocumentMetadata(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),Yt.onDidChangeNotebookDocumentMetadata(J,le,ke)},onDidChangeNotebookCells(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeNotebookCells(J,le,ke)},onDidChangeNotebookCellExecutionState(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Xt.onDidChangeNotebookCellExecutionState(J,le,ke)},onDidChangeCellOutputs(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellOutputs(J,le,ke)},onDidChangeCellMetadata(J,le,ke){return(0,ve.checkProposedApiEnabled)(Me,"notebookEditor"),wt.onDidChangeCellMetadata(J,le,ke)},createConcatTextDocument(J,le){return(0,ve.checkProposedApiEnabled)(Me,"notebookConcatTextDocument"),new Se.ExtHostNotebookConcatDocument(wt,St,J,le)}};return{version:ue.version,authentication:Ot,commands:ri,comments:Oi,debug:Li,env:Ei,extensions:Ri,languages:Fi,notebooks:xi,scm:mi,tasks:Ni,tests:Ai,window:Mi,workspace:_i,Breakpoint:$.Breakpoint,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:t.CancellationError,CancellationTokenSource:r.CancellationTokenSource,CandidatePortSource:i.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:$.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:_.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestions,Hover:$.Hover,IndentAction:T.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:i.UIKind,Uri:I.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Ue.TextSearchCompleteMessageType,TreeDataTransfer:$.TreeDataTransfer,TreeDataTransferItem:$.TreeDataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=te}),define(ye[221],_e([0,1,220,33,213,7,13,5,11]),function(ee,e,r,t,_,A,I,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class T extends _.RequireInterceptor{_installInterceptor(){}getModule(l,s){for(let m of this._alternatives){let F=m(l);if(F){l=F;break}}if(this._factories.has(l))return this._factories.get(l).load(l,s,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends t.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(P.MainContext.MainThreadConsole);i(l,this._initData.environment.isExtensionDevelopmentDebug);const s=this._instaService.invokeFunction(r.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(T,s,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,s,m){s=s.with({path:w(s.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const F=await fetch(D.FileAccess.asBrowserUri(s).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),F.status!==200)throw new Error(F.statusText);const S=await F.text(),b=`${s.toString(!0)}#vscode-extension`,p=`${S}
//# sourceURL=${b}`;let C;try{C=new Function("module","exports","require",p)}catch(n){throw console.error(l?`Loading code for extension ${l.value} failed: ${n.message}`:`Loading code failed: ${n.message}`),console.error(`${s.toString(!0)}${typeof n.line=="number"?` line ${n.line}`:""}${typeof n.column=="number"?` column ${n.column}`:""}`),console.error(n),n}const a={},M={exports:a},o=n=>{const u=this._fakeModules.getModule(n,s);if(u===void 0)throw new Error(`Cannot load module '${n}'`);return u};try{return m.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),C(M,a,o),M.exports!==a?M.exports:a}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(l){}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const s=Date.now()+l;for(;Date.now()<s&&!("__jsDebugIsReady"in globalThis);)await(0,I.timeout)(10)}}e.ExtHostExtensionService=R;function w(d,l){return d.endsWith(l)?d:d+l}function i(d,l){s("info","log"),s("log","log"),s("warn","warn"),s("error","error");function s(S,b){const p=console[S];console[S]=function(){d.$logExtensionHostMessage({type:"__$console",severity:b,arguments:F(arguments)}),l&&p.apply(console,arguments)}}const m=1e5;function F(S){const b=[],p=[];if(S.length)for(let C=0;C<S.length;C++){if(typeof S[C]=="undefined")S[C]="undefined";else if(S[C]instanceof Error){const a=S[C];a.stack?S[C]=a.stack:S[C]=a.toString()}p.push(S[C])}try{const C=JSON.stringify(p,function(a,M){if(M&&typeof M=="object"){if(b.indexOf(M)!==-1)return"[Circular]";b.push(M)}return M});return C.length>m?"Output omitted for a large object that exceeds the limits":C}catch(C){return`Output omitted for an object that cannot be inspected ('${C.toString()}')`}}}}),define(ye[222],_e([0,1,44,33,71,221]),function(ee,e,r,t,_,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.registerSingleton)(t.IExtHostExtensionService,A.ExtHostExtensionService),(0,r.registerSingleton)(_.IExtensionStoragePaths,_.ExtensionStoragePaths)}),define(ye[234],_e([0,1,21,4,170,214,208,17,72,11,2,217,222]),function(ee,e,r,t,_,A,I,P,D,T,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const i=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");const d=fetch.bind(self);if(self.fetch=function(b,p){return b instanceof Request||/^file:/i.test(String(b))&&(b=T.FileAccess.asBrowserUri(R.URI.parse(String(b))).toString(!0)),d(b,p)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,p,C,a,M){return/^file:/i.test(p.toString())&&(p=T.FileAccess.asBrowserUri(R.URI.parse(p.toString())).toString(!0)),super.open(b,p,C??!0,a,M)}},self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=self.Worker;Worker=function(p,C){/^file:/i.test(p.toString())&&(p=T.FileAccess.asBrowserUri(R.URI.parse(p.toString())).toString(!0));const M=`(${function(f){function c(E){return typeof E=="string"||E instanceof URL?String(E).replace(/^file:\/\//i,"vscode-file://vscode-app"):E}const h=fetch.bind(self);self.fetch=function(E,v){return E instanceof Request?h(E,v):h(c(E),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(E,v,k,x,N){return super.open(E,c(v),k??!0,x,N)}};const g=importScripts.bind(self);self.importScripts=(...E)=>{g(...E.map(c))},g(f)}.toString()}('${p}'))`;C=C||{},C.name=C.name||P.basename(p.toString());const o=new Blob([M],{type:"application/javascript"}),n=URL.createObjectURL(o);return new b(n,C)}}else self.Worker=class extends I.NestedWorker{constructor(b,p){super(i,b,{name:P.basename(b.toString()),...p})}};const l=new class{constructor(){this.pid=void 0}exit(b){w()}async exists(b){return!0}async realpath(b){return b}};class s{constructor(){const p=new MessageChannel,C=new t.Emitter;let a=!1;i(p.port2,[p.port2]),p.port1.onmessage=M=>{const{data:o}=M;if(!(o instanceof ArrayBuffer)){console.warn("UNKNOWN data received",o);return}const n=r.VSBuffer.wrap(new Uint8Array(o,0,o.byteLength));if((0,_.isMessageOfType)(n,2)){a=!0,F("received terminate message from renderer");return}C.fire(n)},this.protocol={onMessage:C.event,send:M=>{if(!a){const o=M.buffer.buffer.slice(M.buffer.byteOffset,M.buffer.byteOffset+M.buffer.byteLength);p.port1.postMessage(o,[o])}}}}}function m(b){return new Promise(p=>{const C=b.onMessage(a=>{C.dispose();const M=JSON.parse(a.toString());b.send((0,_.createMessageOfType)(0)),p({protocol:b,initData:M})});b.send((0,_.createMessageOfType)(1))})}let F=b=>w();function S(){D.mark("code/extHost/willConnectToRenderer");const b=new s;return{onmessage(p){m(b.protocol).then(C=>{D.mark("code/extHost/didWaitForInitData");const a=new A.ExtensionHostMain(C.protocol,C.initData,l,null,p);F=M=>a.terminate(M)})}}}e.create=S})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a7f1b7395175418c74fe0041560eb3f0423d4d27/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
